Package: asbio
Type: Package
Title: A Collection of Statistical Tools for Biologists
Version: 1.13-1
Depends: R (>= 3.5.0), tcltk
Imports: scatterplot3d, pixmap, plotrix, mvtnorm, deSolve, lattice,
        multcompView, grDevices, graphics, stats, utils, gWidgets2,
        gWidgets2tcltk, tkrplot
Suggests: boot, R.rsp
Date: 2026-4-22
SystemRequirements: BWidget
Authors@R: person(given = "Ken",
                    family = "Aho",
                    role = c("aut", "cre"),
                    email = "kenaho1@gmail.com")
Author: Ken Aho [aut, cre]
Maintainer: Ken Aho <kenaho1@gmail.com>
URL: https://kenaho.aws.cose.isu.edu/shiny/apps/asbio_shiny.Rmd
Description: Contains functions from: Aho, K. (2014) Foundational and Applied Statistics for Biologists using R. CRC/Taylor and Francis, Boca Raton, FL, ISBN: 978-1-4398-7338-0.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-04-22 22:06:35 UTC; ahoken
Repository: CRAN
Date/Publication: 2026-04-23 05:10:13 UTC
Built: R 4.6.0; ; 2026-04-27 22:42:59 UTC; unix

Package: asbio
Type: Package
Title: A Collection of Statistical Tools for Biologists
Version: 1.11
Depends: R (>= 3.5.0), tcltk
Imports: scatterplot3d, pixmap, plotrix, mvtnorm, deSolve, lattice,
        multcompView, grDevices, graphics, stats, utils, gWidgets2,
        gWidgets2tcltk
Suggests: boot, tkrplot, R.rsp
Date: 2025-1-24
SystemRequirements: BWidget
Authors@R: person(given = "Ken",
                    family = "Aho",
                    role = c("aut", "cre"),
                    email = "kenaho1@gmail.com")
Author: Ken Aho [aut, cre]
Maintainer: Ken Aho <kenaho1@gmail.com>
Description: Contains functions from: Aho, K. (2014) Foundational and Applied Statistics for Biologists using R.  CRC/Taylor and Francis, Boca Raton, FL, ISBN: 978-1-4398-7338-0.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2025-01-14 23:02:22 UTC; ahoken
Repository: CRAN
Date/Publication: 2025-01-14 23:40:02 UTC
Built: R 4.3.3; ; 2025-01-15 01:03:25 UTC; unix

Package: asbio
Type: Package
Title: A Collection of Statistical Tools for Biologists
Version: 1.13-1
Depends: R (>= 3.5.0), tcltk
Imports: scatterplot3d, pixmap, plotrix, mvtnorm, deSolve, lattice,
        multcompView, grDevices, graphics, stats, utils, gWidgets2,
        gWidgets2tcltk, tkrplot
Suggests: boot, R.rsp
Date: 2026-4-22
SystemRequirements: BWidget
Authors@R: person(given = "Ken",
                    family = "Aho",
                    role = c("aut", "cre"),
                    email = "kenaho1@gmail.com")
Author: Ken Aho [aut, cre]
Maintainer: Ken Aho <kenaho1@gmail.com>
URL: https://kenaho.aws.cose.isu.edu/shiny/apps/asbio_shiny.Rmd
Description: Contains functions from: Aho, K. (2014) Foundational and Applied Statistics for Biologists using R. CRC/Taylor and Francis, Boca Raton, FL, ISBN: 978-1-4398-7338-0.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-04-22 22:06:35 UTC; ahoken
Repository: CRAN
Date/Publication: 2026-04-23 05:10:13 UTC
Built: R 4.6.0; ; 2026-04-26 05:42:24 UTC; unix

Package: asbio
Type: Package
Title: A Collection of Statistical Tools for Biologists
Version: 1.9-7
Depends: R (>= 3.5.0), tcltk
Imports: scatterplot3d, pixmap, plotrix, mvtnorm, deSolve, lattice,
        multcompView, grDevices, graphics, stats, utils, gWidgets2,
        gWidgets2tcltk
Suggests: boot, tkrplot, R.rsp
Date: 2024-1-17
SystemRequirements: BWidget
Author: Ken Aho
Maintainer: Ken Aho <kenaho1@gmail.com>
Description: Contains functions from: Aho, K. (2014) Foundational and Applied Statistics for Biologists using R.  CRC/Taylor and Francis, Boca Raton, FL, ISBN: 978-1-4398-7338-0.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2024-01-19 22:15:56 UTC; ahoken
Repository: CRAN
Date/Publication: 2024-01-19 23:00:02 UTC
Built: R 4.2.3; ; 2024-01-20 01:12:42 UTC; unix

# Export all names
exportPattern(.)

# Packages listed as Imports or Depends
importFrom(scatterplot3d, scatterplot3d)
importFrom(mvtnorm, dmvnorm, rmvnorm, qmvt) 
importFrom(lattice, wireframe)
importFrom(deSolve, rk4)
importFrom(plotrix, draw.circle, staxlab, thigmophobe)
importFrom(multcompView, multcompLetters)
importFrom(grDevices, hcl.colors, col2rgb, dev.capabilities, dev.cur, dev.flush, dev.hold, dev.list, dev.new, dev.off, dev.set, graphics.off, gray, heat.colors, rainbow, rgb)
importFrom(graphics, abline, arrows, axis, barplot, box, curve, grid, hist, identify, image, layout, legend, lines, locator, mtext, par, persp, plot.new, points, 
			polygon, rect, segments, symbols, text)
importFrom(stats, AIC, IQR, anova, chisq.test, coef,
             complete.cases, cor, cor.test, cov, dbeta, dbinom, dchisq, density, dexp, df, dgamma, dgeom, dhyper, dist, dlnorm, dlogis, dnbinom, dnorm,
             dpois, dt, dunif, dweibull, fitted, glm, integrate, ksmooth, lm, loess, lowess, mad, median, model.matrix, na.omit, nls, p.adjust, pbeta, pbinom, pchisq, 
			 pexp, pf, pgamma, pgeom, phyper, plnorm, plogis, pnbinom, pnorm, ppois, predict, pt, ptukey, punif, pweibull, qbeta, qbinom, qchisq, qf, qnorm, qqnorm, 
			 qsignrank, qt, qtukey, quantile, qweibull, rbinom, rchisq, resid, rexp, rnorm, rt, runif, sd, smooth.spline, t.test, terms, uniroot, var, xtabs)
importFrom(utils, compareVersion, head, write.table, stack, tail)
importFrom(stats, qqline)
importFrom(tkrplot, tkrplot)
import(
  gWidgets2,
  gWidgets2tcltk,
  tcltk,
  pixmap
)

# Method registration -print
S3method(print, addtest)
S3method(print, max_agree)
S3method(print, bci)
S3method(print, BDM)
S3method(print, blm)
S3method(print, bootstrap)
S3method(print, ci)
S3method(print, ciboot)
S3method(print, kback)
S3method(print, mltest)
S3method(print, oneSamp)
S3method(print, pairw)
S3method(print, prp.index)

# Method registration -plot
S3method(plot, pairw)

pairw.anova<-function(y,x,conf.level=0.95,method="tukey",MSE=NULL,df.err=NULL,control=NULL){
indices <- c("lsd","bonf","tukey","scheffe","dunnett")
method <- match.arg(method, indices)
if(method=="lsd"){
res <- lsdCI(y,x,conf.level=conf.level,MSE=MSE,df.err=df.err)}
if(method=="bonf"){
res <- bonfCI(y,x,conf.level=conf.level,MSE=MSE,df.err=df.err)}
if(method=="tukey"){
res <- tukeyCI(y,x,conf.level=conf.level,MSE=MSE,df.err=df.err)}
if(method=="scheffe"){
res <- scheffeCI(y,x,conf.level=conf.level,MSE=MSE,df.err=df.err)}
if(method=="dunnett"){
res <- dunnettCI(y,x,conf.level=conf.level,control=control)}
res
}


lsdCI<-function(y, x, conf.level = 0.95, MSE = NULL, df.err = NULL){
fitted<-tapply(y,factor(x),mean)
nis<-tapply(y,factor(x),length)
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)

dif.mat<-outer(fitted,fitted,"-")
diffs<-dif.mat[upper.tri(dif.mat)]

SE.diff.mat<-sqrt(MSE*outer(1/nis,1/nis,"+"))
SE.diff<-SE.diff.mat[upper.tri(SE.diff.mat)]

p.val<- 2*pt(abs(diffs/SE.diff),df.error,lower.tail=FALSE)
t<-qt(1-(1-conf.level)/2,df.error)
hwidths<-t*SE.diff
LSD<-round(qt(1-((1-conf.level)/2),df.error)*SE.diff,5)
Decision<- ifelse(abs(diffs)>LSD,"Reject H0","FTR H0")
val<-as.data.frame(cbind(LSD,round(diffs, 5),round(diffs-hwidths,5),round(diffs+hwidths,5),Decision,round(p.val,5)))
lvl<-outer(levels(x),levels(x),function(x1,x2){paste(paste("mu",x1,sep=""),paste("mu",x2,sep=""),sep="-")})
dimnames(val)<-list(lvl[upper.tri(lvl)],
c("LSD","Diff","Lower","Upper","Decision","Adj. p-value"))
head<-paste(paste(as.character(conf.level*100),"%",sep=""),c("LSD confidence intervals"))
###
res <- list()
res$head <- head
res$conf <- conf.level
comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
res$comp <- comp[upper.tri(comp)]
res$summary <- val
res$band <- cbind(diffs-hwidths, diffs+hwidths)
res$fitted <- fitted
res$x <- x
res$y <- y
res$method <- "Fisher LSD"
class(res)<-"pairw"
res
}


bonfCI<-function(y,x, conf.level=0.95,MSE=NULL,df.err=NULL){
fitted<-tapply(y,factor(x),mean)
nis<-tapply(y,factor(x),length)
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)
r<-length(fitted)
dif.mat<-outer(fitted,fitted,"-")
diffs<-dif.mat[upper.tri(dif.mat)]
SE.diff.mat<-sqrt(MSE*outer(1/nis,1/nis,"+"))
L.hat.SE<-SE.diff.mat[upper.tri(SE.diff.mat)]
p.val<- 2*pt(abs(diffs/L.hat.SE),df=df.error,lower.tail=FALSE)
p.adj<-ifelse(p.val*((r^2-r)/2)>=1,1,round(p.val*((r^2-r)/2),6))
t<-qt(1-(1-conf.level)/(r*(r-1)),df.error)
hwidths<-t*L.hat.SE
val<-round(cbind(diffs,diffs-hwidths,diffs+hwidths),5)
Decision<-ifelse((val[,2]>0&val[,3]>0)|val[,2]<0&val[,3]<0,"Reject H0","FTR H0")
val<-as.data.frame(cbind(val,Decision,p.adj))
lvl<-outer(levels(x),levels(x),function(x1,x2){paste(paste("mu",x1,sep=""),paste("mu",x2,sep=""),sep="-")})
dimnames(val)<-list(lvl[upper.tri(lvl)],
c("Diff","Lower","Upper","Decision","Adj. p-value"))
head<-paste(paste(as.character(conf.level*100),"%",sep=""),c("Bonferroni confidence intervals"))
###
res <- list()
res$head <- head
res$conf <- conf.level
comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
res$comp <- comp[upper.tri(comp)]
res$summary <- val
res$band <- cbind(diffs-hwidths, diffs+hwidths)
res$fitted <- fitted
res$x <- x
res$y <- y
res$method <- "Bonferroni"
class(res)<-"pairw"
res
}


tukeyCI<-function(y,x, conf.level=0.95,MSE=NULL,df.err=NULL){
fitted<-tapply(y,factor(x),mean)
nis<-tapply(y,factor(x),length)
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)
r<-length(fitted)

dif.mat<-outer(fitted,fitted,"-")
diffs<-dif.mat[upper.tri(dif.mat)]

SE.diff.mat<-sqrt(MSE*outer(1/nis,1/nis,"+"))
SE.diff<-SE.diff.mat[upper.tri(SE.diff.mat)]

Q.star<-abs((sqrt(2)*diffs)/ SE.diff)
p.val<-round(ptukey(Q.star,r,df=df.error,lower.tail=FALSE),6)
T<-qtukey(conf.level,r,df.error)/sqrt(2)
hwidths<-T*SE.diff
val<-round(cbind(diffs,diffs-hwidths,diffs+hwidths),5)
Decision<-ifelse((val[,2]>0&val[,3]>0)|val[,2]<0&val[,3]<0,"Reject H0","FTR H0")
val<-as.data.frame(cbind(val,Decision,p.val))
lvl<-outer(levels(x),levels(x),function(x1,x2){paste(paste("mu",x1,sep=""),paste("mu",x2,sep=""),sep="-")})
dimnames(val)<-list(lvl[upper.tri(lvl)],
c("Diff","Lower","Upper","Decision","Adj. p-value"))
head<-paste(paste(as.character(conf.level*100),"%",sep=""),c("Tukey-Kramer confidence intervals"))
###
res <- list()
res$head <- head
res$conf <- conf.level
comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
res$comp <- comp[upper.tri(comp)]
res$summary <- val
res$band <- cbind(diffs-hwidths, diffs+hwidths)
res$fitted <- fitted
res$x <- x
res$y <- y
res$method <- "Tukey HSD"
class(res)<-"pairw"
res
}


scheffeCI<-function(y,x, conf.level=0.95,MSE=NULL,df.err=NULL){
fitted<-tapply(y,factor(x),mean)
nis<-tapply(y,factor(x),length)
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)
r<-length(fitted)
dif.mat<-outer(fitted,fitted,"-")
diffs<-dif.mat[upper.tri(dif.mat)]
SE.diff.mat<-sqrt(MSE*outer(1/nis,1/nis,"+"))
SE.diff<-SE.diff.mat[upper.tri(SE.diff.mat)]
F.star<-diffs^2/((r-1)*SE.diff^2)
p.val<-round(pf(F.star,r-1,df.error,lower.tail=FALSE),6)
S<-sqrt((r-1)*qf(conf.level,r-1,df.error))
hwidths<-S*SE.diff
val<-round(cbind(diffs,diffs-hwidths,diffs+hwidths),5)
Decision<-ifelse((val[,2]>0&val[,3]>0)|val[,2]<0&val[,3]<0,"Reject H0","FTR H0")
val<-as.data.frame(cbind(val,Decision,p.val))
lvl<-outer(levels(x),levels(x),function(x1,x2){paste(paste("mu",x1,sep=""),paste("mu",x2,sep=""),sep="-")})
dimnames(val)<-list(lvl[upper.tri(lvl)],
c("Diff","Lower","Upper","Decision","Adj. P-value"))
head<-paste(paste(as.character(conf.level*100),"%",sep=""),c("Scheffe confidence intervals"))
###
res <- list()
res$head <- head
res$conf <- conf.level
comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
res$comp <- comp[upper.tri(comp)]
res$summary <- val
res$band <- cbind(diffs-hwidths, diffs+hwidths)
res$fitted <- fitted
res$x <- x
res$y <- y
res$method <- "Scheffe"
class(res)<-"pairw"
res
}

dunnettCI<-function(y, x, conf.level = 0.95, control = NULL){
x <- factor(x)
if(is.null(control)) stop(call. = FALSE, "Please specify the control")
nis <- tapply(y, x, length)
nu <- sum(nis) - nlevels(x)

    p.sd <- function(y, x){
        rs <- seq(1, nlevels(x))
        for(i in levels(x)) rs[i] <- sum((y[x == i] - mean(y[x == i]))^2)
        rs <- rs[-c(1:nlevels(x))]
        sqrt(sum(rs)/nu)
    }

s <- p.sd(y, x)
controlm <- mean(y[x == control])
fittedm <- tapply(y[x != control], factor(x)[x != control], mean)
fittedm <-fittedm[complete.cases(fittedm)]
controln <- length(y[x == control])
fittedn <- tapply(y[x != control], factor(x)[x != control], length)
fittedn <-fittedn[complete.cases(fittedn)]
diffs <- fittedm - controlm

    Dj <- seq(1, (nlevels(x) - 1))
    for(i in 1 : (nlevels(x)-1)) Dj[i] <- diffs[i]/(s*sqrt((1/fittedn[i]) + (1/controln)))

    Rij <- seq(1, (nlevels(x) - 1))
    for(i in 1 : (nlevels(x)-1)) Rij[i] <- sqrt(fittedn[i]/(fittedn[i] + controln))
    R <- outer(Rij, Rij, "*")
    diag(R) <- rep(1, (nlevels(x) - 1))

    upper <- seq(1, (nlevels(x) - 1))
    for(i in 1 : (nlevels(x)-1)) upper[i] <-  diffs[i] + s*sqrt((1/fittedn[i])+ (1/controln))*qmvt((1 - (1 - conf.level)/2), df = nu, sigma = R, tail="lower.tail")$quantile
    lower <- seq(1, (nlevels(x) - 1))
    for(i in 1 : (nlevels(x)-1)) lower[i] <- diffs[i] - s*sqrt((1/fittedn[i])+ (1/controln))*qmvt((1 - (1 - conf.level)/2), df = nu, sigma = R, tail="lower.tail")$quantile

fl <- levels(x)[levels(x)!=control]
con <- levels(x)[levels(x)==control]
decision<-ifelse((lower>0&upper>0)|lower<0&upper<0,"Reject H0","FTR H0")
lvl <- paste(paste("mu", fl, sep=""),paste("mu", con, sep=""),sep="-")
val <- as.data.frame(cbind(round(apply(cbind(lower, upper), 1, mean), 6),round(lower, 6),round(upper, 6),decision))
dimnames(val)<-list(lvl,c("Diff","Lower","Upper","Decision"))
head<-paste(paste(as.character(conf.level*100),"%",sep=""),c("Dunnett confidence intervals"))
###
res <- list()
res$head <- head
res$conf <- conf.level
comp <- paste(fl, con, sep="-")
res$comp <- comp
res$summary <- val
res$band <- cbind(lower, upper)
res$fitted <- fittedm
res$x <- x
res$y <- y
method <- "Dunnett"
class(res)<-"pairw"
res
}


scheffe.cont <- function(y, x, lvl = c("x1", "x2"), conf.level = 0.95, MSE = NULL, df.err = NULL){
alpha <- 1 - conf.level
n <- length(y); x <- factor(x)
r <- nlevels(x)
Y.new <- y[x == lvl[1]|x ==lvl[2]]
X.new <- x[x == lvl[1]|x ==lvl[2]]
means <- tapply(Y.new, X.new, mean)
means <- means[complete.cases(means)]
ni <- tapply(Y.new, X.new, length)
ni <- ni[complete.cases(ni)]
D <- means[1] - means[2]
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)
S.D <- sqrt(MSE * ((1/ni[1])+(1/ni[2])))
S <- sqrt((r - 1)*qf(1 - alpha, r - 1, n - r))
CI <- list(lower = D - S.D * S, upper = D + S.D * S)
F.star <- D^2/((r - 1)*(S.D^2))
P.val <- pf(F.star, r - 1, n - r, lower.tail = FALSE)
Dec <- ifelse(P.val <= alpha, "Reject H0", "FTR H0")
res <- data.frame(Diff = D, Lower = CI$lower, Upper = CI$upper, Decision = Dec, P = P.val)
names(res) <- c("Diff", "Lower", "Upper", "Decision", "Adj. P-value")
row.names(res) <- paste("mu",lvl[1],"-","mu",lvl[2], sep = "")
res
}


bonf.cont <- function(y, x, lvl = c("x1", "x2"), conf.level = 0.95, MSE = NULL, df.err = NULL, comps = 1){
alpha <- 1 - conf.level
n <- length(y); x <- factor(x)
Y.new <- y[x == lvl[1]|x ==lvl[2]]
X.new <- x[x == lvl[1]|x ==lvl[2]]
means <- tapply(Y.new, X.new, mean)
means <- means[complete.cases(means)]
ni <- tapply(Y.new, X.new, length)
ni <- ni[complete.cases(ni)]
D <- means[1] - means[2]
a<-anova(lm(y~factor(x)))
df.error<-ifelse(is.null(df.err),a$Df[length(a$Df)],df.err)
MSE<-ifelse(is.null(MSE),a$"Mean Sq"[length(a$"Mean Sq")],MSE)
S.D <- sqrt(MSE * ((1/ni[1])+(1/ni[2])))
t.crit <- qt(1-(alpha/(2*comps)), df.error)
CI <- list(lower = D - S.D * t.crit, upper = D + S.D * t.crit)
P.val <- 2*pt(abs(D/S.D), df.error, lower.tail = FALSE)*comps
Dec <- ifelse(P.val <= alpha, "Reject H0", "FTR H0")
res <- data.frame(Diff = D, Lower = CI$lower, Upper = CI$upper, Decision = Dec, P = ifelse(P.val>1,1,P.val))
names(res) <- c("Diff", "Lower", "Upper", "Decision", "Adj. P-value")
row.names(res) <- paste("mu",lvl[1],"-","mu",lvl[2], sep = "")
res
}

print.pairw <- function(x, ...){
cat("\n")
cat(x$head,"\n")
cat("\n")
rq<-structure(x$summary)
print(rq)
invisible(x)
}

plot.pairw <- function(x, type = 1, lcol = 1, lty = NULL, lwd = NULL, cap.length = 0.1, xlab = "", main = NULL, explanation = TRUE, ...){
if(!inherits(x, "pairw")) stop("Requires object of class pairw")
    if(type == 1){
        levels <- factor(names(x$fitted))
        levels <- gsub("-"," ", x = levels)
        cont <- outer(levels, levels, function(x1,x2)paste(x1,x2,sep="-"))
        cont1 <- cont[upper.tri(cont)]
        dec <- x$summary$Decision
        dec1 <- ifelse(dec=="FTR H0", FALSE, TRUE)
        xlvl <- x$x
        y <- x$y
        names(dec1) <- cont1
        lett <- multcompLetters(dec1)$Letters #Requires multcompView
        bplot(y, xlvl, simlett = TRUE, lett = lett, xlab = xlab, ...)
            if(explanation){
                if(x$method == "kBonferroni"){
                    cat(paste("The true effects of factor levels with the same letter are not", "\n", "significantly different at alpha = ", 1- x$conf, " using the ", strsplit(x$method, "k")[[1]][2], " method.", "\n\n", sep = ""))
                } else if (x$method == "mBonferroni"){
                    cat(paste("The true effects of factor levels in blocks with the same letter are not", "\n", "significantly different at alpha = ", 1- x$conf, " using the ", strsplit(x$method, "m")[[1]][2], " method.", "\n\n", sep = ""))
                } else{
                    cat(paste("The population means of factor levels with the same letter are not", "\n", "significantly different at alpha = ", 1- x$conf, " using the ", x$method, " method.", "\n\n", sep = ""))
                }
            }
    }
    if(type == 2){
        ci <- x$band
        w <- diff(range(min(ci[,1]),max(ci[,2])))*.05
        r <- nrow(x$summary)
        b <- barplot(rep(0, r), names.arg = x$comp, main = ifelse(is.null(main), x$head, main), xlab = xlab, horiz = TRUE, xlim = c(min(ci[,1]) - w , max(ci[,2])), border=NA, axis.lty = 1, ...)
        abline(h = b, col = "gray")
        arrows(ci[,1], b, ci[,2], b, angle = 90, col = lcol, lty = lty, lwd = lwd, length = cap.length, code = 3)
        abline(v=0, col="gray", lty=2)
        points(apply(x$band,1,mean), b, pch = 19)
        }
}

selftest.regdiag.tck1 <- function ()
{
  options(guiToolkit = "tcltk")
  w <- gwindow(title = "Regression assumptions and diagnostics")
  size(w) <- c(700, 650)
  g <- ggroup(container = w, horizontal = FALSE, use.scrollwindow = TRUE)

  #--------------- Question 1 -----------------#

  OS <- Sys.info()[['sysname']]
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For general linear regression models, we assume...",
               container = gp1.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  ans1 <- c("(a) Y\u1D62 ~ N(\u03BC, \u03C3\u00B2).", "(b) X\u1D62 ~ N(\u03BC, \u03C3\u00B2), for all predictors.",
            "(c) \u03B5\u1D62 ~ N(\u03BC, \u03C3\u00B2).", "(d) All of the above.")
  f1 <- function(h, ....) {
    if (tail(svalue(r1), 1) == ans1[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r1), 1) == ans1[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r1), 1) == ans1[3]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r1), 1) == ans1[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE,
                       where = "beginning", handler = f1)

  #--------------- Question 2 -----------------#

  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The diagnostic plot below indicates problems with...",
               container = gp2.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  Fits <- rep(1:20, 2)
  Residuals <- rnorm(40, 0, sd = Fits)
  gp2.1 <- getWidget(gp2)
  img <- tkrplot::tkrplot(gp2.1, function() {
    par(bg = "white", mar = c(4.5, 4.1, 1, 1))
    plot(Fits, Residuals, xlab = "Fitted value", ylab = "Residual",
         cex.lab = ifelse(OS == "Linux", 1, 0.9))
    abline(h = 0, lty = 2, col = 2)
  })
  add(gp2, img, horizontal = TRUE)
  ans2 <- c("(a) non-normality.", "(b) heteroscedasticy.",
            "(c) non-linearity.", "(d) non-independence.", "(e) outliers.")
  f2 <- function(h, ....) {
    if (tail(svalue(r2), 1) == ans2[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r2), 1) == ans2[2]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r2), 1) == ans2[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r2), 1) == ans2[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r2), 1) == ans2[5]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE,
                       where = "beginning", handler = f2)

  #--------------- Question 3 -----------------#

  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The diagnostic plot below most strongly indicates problems with...",
               container = gp3.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  x <- c(0.08, 0.92, 1.01, 1.1, 0.57, 0.11, 2.44, 0.88, 0.93,
         1.21, 4.01, 2.78, 0.65, 2.45, 0.9, 2.58, 0.76, 0.05,
         0.43, 0.42, 0.45, 0.56, 0.03, 0.83, 3.43, 0.06, 0.7,
         0.02, 1.97, 0.37, 2.19, 2.8, 0.55, 1.02, 0.46, 0.37,
         1.36, 1.14, 0.72, 0.01, 2.54, 1.88, 0.6, 1.12, 0.68,
         0.66, 0.16, 0.28, 0.54, 0.41, 0.04, 0.37, 0.44, 0.54,
         0.88, 0.43, 1.26, 0.86, 0.04, 2.29)
  gp3.1 <- getWidget(gp3)
  img <- tkrplot::tkrplot(gp3.1, function() {
    par(bg = "white", mar = c(4.5, 4.1, 1, 1))
    qqnorm(x, cex.lab = ifelse(OS == "Linux", 1, 0.9), main = "")
    qqline(x, col = 2, lty = 2)
  })
  add(gp3, img)
  ans3 <- c("(a) non-normality.", "(b) heteroscedasticy.",
            "(c) non-linearity.", "(d) non-independence.", "(e) outliers.")
  f3 <- function(h, ....) {
    if (tail(svalue(r3), 1) == ans3[1]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r3), 1) == ans3[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r3), 1) == ans3[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r3), 1) == ans3[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r3), 1) == ans3[5]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE,
                       where = "beginning", handler = f3)

  #--------------- Question 4 -----------------#

  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The plot below most strongly indicates problems with...",
               container = gp4.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  x <- 1:20
  y <- 3 * x + rnorm(20, sd = 2)
  y[17] <- 10
  y[19] <- 8
  gp4.1 <- getWidget(gp4)
  img <- tkrplot::tkrplot(gp4.1, function() {
    par(bg = "white", mar = c(4.5, 4.1, 1, 1))
    plot(x, y, xlab = expression(paste("Soil N", O[3], sep = "")),
         ylab = "Plant aboveground biomass (g)", pch = 19,
         cex.lab = ifelse(OS == "Linux", 1, 0.9))
  })
  add(gp4, img)
  ans4 <- c("(a) non-normality.", "(b) heteroscedasticy.",
            "(c) non-linearity.", "(d) non-independence.", "(e) outliers.")
  f4 <- function(h, ....) {
    if (tail(svalue(r4), 1) == ans4[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r4), 1) == ans4[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r4), 1) == ans4[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r4), 1) == ans4[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r4), 1) == ans4[5]) {
      gmessage(msg = "Correct")
    }
    svalue(r4) <- character(0)
  }
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE,
                       where = "beginning", handler = f4)

  #--------------- Question 5 -----------------#

  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The diagnostic plot below indicates problems with...",
               container = gp5.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  Fits <- rep(1:20, 2)
  Residuals <- rnorm(40, 0, sd = Fits)
  gp5.1 <- getWidget(gp5)
  img <- tkrplot::tkrplot(gp5.1, function() {
    par(bg = "white", mar = c(4.5, 4.1, 1, 1))
    plot(Fits, Residuals, xlab = "Order that data were collected",
         ylab = "Residual", cex.lab = ifelse(OS == "Linux", 1, 0.9))
    abline(h = 0, lty = 2, col = 2)
  })
  add(gp5, img, horizontal = TRUE)
  ans5 <- c("(a) non-normality.", "(b) heteroscedasticy.",
            "(c) non-linearity.", "(d) non-independence.", "(e) outliers.")
  f5 <- function(h, ....) {
    if (tail(svalue(r5), 1) == ans5[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r5), 1) == ans5[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r5), 1) == ans5[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r5), 1) == ans5[4]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r5), 1) == ans5[5]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE,
                       where = "beginning", handler = f5)

  #--------------- Question 6 -----------------#

  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The plot of data below indicate potential problems with...",
               container = gp6.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  substrate <- c(0.01, 2.5, 5, 10, 20, 30, 40, 60, 90, 120)
  rate <- c(0.373633, 7.0338, 12.84083, 18.355, 23.47183,
            31.42908, 28.82768, 34.36157, 38.0748, 38.1663)
  gp6.1 <- getWidget(gp6)
  img <- tkrplot::tkrplot(gp6.1, function() {
    par(bg = "white", mar = c(4.5, 4.1, 1, 1))
    plot(substrate, rate, xlab = expression(paste("Substrate (",
                                                  mu, "mols)", sep = "")),
         ylab = expression(paste("Lipid breakdown (nmol/mg enzyme)", sep = "")),
         cex.lab = ifelse(OS == "Linux", 1, 0.9))
  })
  add(gp6, img, horizontal = TRUE)
  ans6 <- c("(a) non-normality.", "(b) heteroscedasticy.",
            "(c) non-linearity.", "(d) non-independence.", "(e) outliers.")
  f6 <- function(h, ....) {
    if (tail(svalue(r6), 1) == ans6[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r6), 1) == ans6[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r6), 1) == ans6[3]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r6), 1) == ans6[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r6), 1) == ans6[5]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r6) <- character(0)
  }
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE,
                       where = "beginning", handler = f6)

  #--------------- Question 7 -----------------#

  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Cook's distance...", container = gp7.1, anchor = c(-1,
                                                                   1))
  font(qq) <- list(family = "cambria", size = 11)
  ans7 <- c("(a) quantifies how unusual a point is in predictor space.",
            "(b) quantifies the influence of a point on the regression model.",
            "(c) quantifies multicollinearity among predictors.",
            "(d) quantifies the explanatory power of linear models.")
  f7 <- function(h, ....) {
    if (tail(svalue(r7), 1) == ans7[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r7), 1) == ans7[2]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r7), 1) == ans7[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r7), 1) == ans7[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r7) <- character(0)
  }
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE,
                       where = "beginning", handler = f7)

    #--------------- Question 8 -----------------#

  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Leverage...", container = gp8.1, anchor = c(-1,
                                                            1))
  font(qq) <- list(family = "cambria", size = 11)
  ans8 <- c("(a) quantifies how unusual a point is in predictor space.",
            "(b) quantifies the influence of a point on the regression model.",
            "(c) quantifies multicollinearity among predictors.",
            "(d) quantifies the explanatory power of linear models.")
  f8 <- function(h, ....) {
    if (tail(svalue(r8), 1) == ans8[1]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r8), 1) == ans8[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r8), 1) == ans8[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r8), 1) == ans8[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r8) <- character(0)
  }
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE,
                       where = "beginning", handler = f8)

  #--------------- Question 9 -----------------#

  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A Variance Inflation Factor (VIF)...", container = gp9.1,
               anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  ans9 <- c("(a) quantifies how unusual a point is in predictor space.",
            "(b) quantifies the influence of a point on the regression model.",
            "(c) quantifies multicollinearity among predictors.",
            "(d) quantifies the explanatory power of linear models.")
  f9 <- function(h, ....) {
    if (tail(svalue(r9), 1) == ans9[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r9), 1) == ans9[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r9), 1) == ans9[3]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r9), 1) == ans9[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r9) <- character(0)
  }
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE,
                       where = "beginning", handler = f9)

  #--------------- Question 10 -----------------#

  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0,
                   horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use the Box-Tidwell procedure to obtain optimal power transformation(s)...",
               container = gp10.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  ans10 <- c("(a) of predictor variables to correct non-linearity under homoscedasticity.",
             "(b) of the response variable to correct non-linearity under heteroscedasticity.",
             "(c) of residuals to correct non-linearity under homoscedasticity.",
             "(d) of residuals to correct non-linearity under heteroscedasticity.")
  f10 <- function(h, ....) {
    if (tail(svalue(r10), 1) == ans10[1]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r10), 1) == ans10[2]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r10), 1) == ans10[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r10), 1) == ans10[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r10) <- character(0)
  }
  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE,
                        where = "beginning", handler = f10)
  gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0,
                   horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use the Box-Cox procedure to obtain optimal power transformation(s)...",
               container = gp11.1, anchor = c(-1, 1))
  font(qq) <- list(family = "cambria", size = 11)
  ans11 <- c("(a) of predictor variables to correct non-linearity under homoscedasticity.",
             "(b) of the response variable to correct non-linearity under heteroscedasticity.",
             "(c) of residuals to correct non-linearity under homoscedasticity.",
             "(d) of residuals to correct non-linearity under heteroscedasticity.")
  f11 <- function(h, ....) {
    if (tail(svalue(r11), 1) == ans11[1]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r11), 1) == ans11[2]) {
      gmessage(msg = "Correct")
    }
    if (tail(svalue(r11), 1) == ans11[3]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    if (tail(svalue(r11), 1) == ans11[4]) {
      gmessage(msg = "Incorrect", icon = "error")
    }
    svalue(r11) <- character(0)
  }
  r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE,
                        where = "beginning", handler = f11)
}

see.logic<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkframe <- ttkframe
        tklabel <- ttklabel
    }
   tclServiceMode(TRUE)
   top <- tktoplevel() 
   tkwm.geometry(top, "+500+4")
   tktitle(top) <- "Logical versus fallacious arguments"
    canvas <- tkcanvas(top, relief="raised", width=800, height=600)
    tkpack(canvas, side="top", fill="x")

    plotFont <- "Helvetica 9"
    plotFont2 <- "Calibri 11"
    
#------------------------ Message boxes ----------------------#

I.T<-function(){
 tkmessageBox(message="Correct.  This is a logical form of argument called \U0022modus ponens\U0022 or \U0022 affirming the antecedent\U0022.")}
    
I.F<-function(){
 tkmessageBox(message="Incorrect.  This is a logical form of argument called \U0022modus ponens\U0022 or \U0022 affirming the antecedent\U0022.", icon="error")}

II.T<-function(){
 tkmessageBox(message="Correct.  This is a logical form of argument called \U0022modus tollens\U0022 or \U0022 denying the consequent\U0022.")}
 
II.F<-function(){
 tkmessageBox(message="Incorrect.  This is a logical form of argument called \U0022modus tollens\U0022 or \U0022 denying the consequent.\U0022", icon="error")}

III.T<-function(){
 tkmessageBox(message="Incorrect.  This is an example of a fallacious type of argument called \U0022 affirming the consequent\U0022.", icon="error")}
 
III.F<-function(){
 tkmessageBox(message="Correct.  This is an example of a fallacious type of argument called \U0022 affirming the consequent\U0022.")}

IV.T<-function(){
 tkmessageBox(message="Correct.  This is an example of a logical type of argument called \U0022 modus ponens\U0022.")}
 
IV.F<-function(){
  tkmessageBox(message="Inorrect.  This is a logical example of \U0022modus ponens\U0022 or \U0022 affirming the antecedent\U0022.", icon="error")}
 
V.T<-function(){
 tkmessageBox(message="Incorrect.  This is an example of a fallacious type of argument called \U0022 affirming the consequent\U0022.", icon="error")}
 
V.F<-function(){
 tkmessageBox(message="Correct.  This is an example of a fallacious type of argument called \U0022 affirming the consequent\U0022.")} 
 
VI.T<-function(){
 tkmessageBox(message="Incorrect.  No causality has been established. This is an example of a fallacious type of argument called \U0022post hoc ergo propter hoc\U0022.  Translated this means: \U0022 after this; therefore, because of this\U0022.", icon="error")}
 
VI.F<-function(){
 tkmessageBox(message="Correct.  No causality has been established.  This is an example of a fallacious type of argument called \U0022post hoc ergo propter hoc\U0022.   Translated this means: \U0022 after this; therefore, because of this\U0022.")} 
 
VII.T<-function(){
 tkmessageBox(message="Incorrect.  This is a confusion of cause and effect.", icon="error")}
 
VII.F<-function(){
 tkmessageBox(message="Correct.  This is a confusion of cause and effect.")} 
 
VIII.T<-function(){
 tkmessageBox(message="Correct.  This is a logical form of an argument called \U0022reductio ad absurdum\U0022.  This is closely related to denying the consequent arguments.")}
 
VIII.F<-function(){
 tkmessageBox(message="Incorrect.  This is a logical form of an argument called \U0022reductio ad absurdum\U0022.  This is closely related to denying the consequent arguments.",icon="error")} 

#------------------------------------------------------------------------------#

    tkcreate(canvas, "polygon", 10, 10, 10, 590, 790, 590, 790, 10, width=0, fill = "white")
    tkcreate(canvas, "line", 10, 10, 790, 10, width=2)
    tkcreate(canvas, "line", 10, 590, 790, 590, width=2)
    tkcreate(canvas, "line", 10, 10, 10, 590, width=2)
    tkcreate(canvas, "line", 10, 300, 790, 300, width=2)
    tkcreate(canvas, "line", 10, 155, 790, 155, width=2)
    tkcreate(canvas, "line", 10, 445, 790, 445, width=2)
    tkcreate(canvas, "line", 400, 10, 400, 590, width=2)
    tkcreate(canvas, "line", 790, 10, 790, 590, width=2)
    
 #----------------------------- Argument 1 -------------------------#
    tkcreate(canvas, "text", 205, 20, text="Argument 1",
             font=plotFont2)
    tkcreate(canvas, "text", 20, 50, text="If Joe fails his ecology final he fails the class.   }Premise 1",
             font=plotFont,anchor="w")
    tkcreate(canvas, "text", 20, 75, text="Joe fails his ecology final.                                      }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 20, 85, 350, 85, width=1)
    tkcreate(canvas, "text", 20, 100, text="Joe fails the class.                                                   }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 125, 140, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 255, 140, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemI.T <- tkcreate(canvas, "oval", 110, 135, 120, 145,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointI.T", "withtag", itemI.T)
     itemI.F <- tkcreate(canvas, "oval", 240, 135, 250, 145,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointI.F", "withtag", itemI.F)       

#----------------------------- Argument 2 -------------------------#    

tkcreate(canvas, "text", 205, 165, text="Argument 2",
             font=plotFont2)
    tkcreate(canvas, "text", 20, 190, text="Only if Joe fails his ecology final does he fail the class.  }Premise 1",
             font=plotFont,anchor="w")
    tkcreate(canvas, "text", 20, 215, text="Joe does not fail his ecology final.                                        }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 20, 225, 350, 225, width=1)
    tkcreate(canvas, "text", 20, 240, text="Joe passes the class.                                                             }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 125, 280, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 255, 280, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemII.T <- tkcreate(canvas, "oval", 110, 275, 120, 285,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointII.T", "withtag", itemII.T)
     itemII.F <- tkcreate(canvas, "oval", 240, 275, 250, 285,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointII.F", "withtag", itemII.F)       
    
#----------------------------- Argument 3 -------------------------#    

 tkcreate(canvas, "text", 205, 310, text="Argument 3",
             font=plotFont2)
    tkcreate(canvas, "text", 20, 340, text="If A then B.   }Premise 1",
             font=plotFont,anchor="w")
    tkcreate(canvas, "text", 20, 365, text="B.                  }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 20, 375, 350, 375, width=1)
    tkcreate(canvas, "text", 20, 390, text="A.                   }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 125, 430, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 255, 430, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemIII.T <- tkcreate(canvas, "oval", 110, 425, 120, 435,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointIII.T", "withtag", itemIII.T)
     itemIII.F <- tkcreate(canvas, "oval", 240, 425, 250, 435,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointIII.F", "withtag", itemIII.F)
              
#----------------------------- Argument 4 -------------------------#    

tkcreate(canvas, "text", 205, 455, text="Argument 4",
             font=plotFont2)
    tkcreate(canvas, "text", 20, 485, text="If not A then not B.         }Premise 1",
             font=plotFont,anchor="w")                     
    tkcreate(canvas, "text", 20, 510, text="Not A.                               }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 20, 520, 350, 520, width=1)
    tkcreate(canvas, "text", 20, 535, text="Not B.                               }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 125, 575, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 255, 575, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemIV.T <- tkcreate(canvas, "oval", 110, 570, 120, 580,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointIV.T", "withtag", itemIV.T)
     itemIV.F <- tkcreate(canvas, "oval", 240, 570, 250, 580,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointIV.F", "withtag", itemIV.F)  


#----------------------------- Argument 5 -------------------------#
    tkcreate(canvas, "text", 595, 20, text="Argument 5",
             font=plotFont2)
    tkcreate(canvas, "text", 410, 50, text="If Pocatello is in ID, then it is in the Pacific NW.   }Premise 1",
             font=plotFont,anchor="w")
    tkcreate(canvas, "text", 410, 75, text="Pocatello is in the Pacific NW.                                 }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 410, 85, 740, 85, width=1)
    tkcreate(canvas, "text", 410, 100, text="Pocatello is in ID.                                                       }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 510, 140, text="Logically corect",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 640, 140, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemV.T <- tkcreate(canvas, "oval", 495, 135, 505, 145,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointV.T", "withtag", itemV.T)
     itemV.F <- tkcreate(canvas, "oval", 625, 135, 635, 145,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointV.F", "withtag", itemV.F)     

#----------------------------- Argument 6 -------------------------#    

tkcreate(canvas, "text", 595, 165, text="Argument 6",
             font=plotFont2)
    tkcreate(canvas, "text", 410, 190, text="Sarah ate vitamins during her pregnancy.   }Premise",
             font=plotFont,anchor="w")
    tkcreate(canvas, "line", 410, 200, 740, 200, width=1)
    tkcreate(canvas, "text", 410, 215, text="Sarah's baby will be a genius.                       }Conclusion",
             font=plotFont, anchor="w")
       
    tkcreate(canvas, "text", 510, 280, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 640, 280, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemVI.T <- tkcreate(canvas, "oval", 495, 275, 505, 285,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVI.T", "withtag", itemVI.T)
     itemVI.F <- tkcreate(canvas, "oval", 625, 275, 635, 285,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVI.F", "withtag", itemVI.F) 

#----------------------------- Argument 7 -------------------------#    

 tkcreate(canvas, "text", 595, 310, text="Argument 7",
             font=plotFont2)
    tkcreate(canvas, "text", 410, 340, text="Sober, industrious students own at least one cow.       }Premise",
             font=plotFont,anchor="w")
    tkcreate(canvas, "line", 410, 350, 740, 350, width=1)
    tkcreate(canvas, "text", 410, 365, text="Drunk, lazy students should be given a cow \nto make them sober and industrious.",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 705, 370, text="}Conclusion",
             font=plotFont, anchor="w")   
    tkcreate(canvas, "text", 510, 430, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 640, 430, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemVII.T <- tkcreate(canvas, "oval", 495, 425, 505, 435,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVII.T", "withtag", itemVII.T)
     itemVII.F <- tkcreate(canvas, "oval", 625, 425, 635, 435,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVII.F", "withtag", itemVII.F)

#----------------------------- Argument 8 -------------------------#    

tkcreate(canvas, "text", 595, 455, text="Argument 8",
             font=plotFont2)
    tkcreate(canvas, "text", 410, 485, text="To prove A, we assume not A.         }Premise 1",
             font=plotFont,anchor="w")                     
    tkcreate(canvas, "text", 410, 510, text="We disprove not A                              }Premise 2",
             font=plotFont, anchor="w")
    tkcreate(canvas, "line", 410, 520, 740, 520, width=1)
    tkcreate(canvas, "text", 410, 535, text="Conclude A.                                          }Conclusion",
             font=plotFont, anchor="w")
    tkcreate(canvas, "text", 510, 575, text="Logically correct",
             font=plotFont2, anchor="w")
    tkcreate(canvas, "text", 640, 575, text="Fallacious",
             font=plotFont2, anchor="w")         
     itemVIII.T <- tkcreate(canvas, "oval", 495, 570, 505, 580,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVIII.T", "withtag", itemVIII.T)
     itemVIII.F <- tkcreate(canvas, "oval", 625, 570, 635, 580,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "pointVIII.F", "withtag", itemVIII.F)  


#------------------------ Drive widgets ----------------------#             

        tkitembind(canvas, "pointI.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointI.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointI.T", "<1>", substitute(I.T()))


        tkitembind(canvas, "pointI.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointI.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointI.F", "<1>", substitute(I.F()))
        
#---------------------------------------------------------------#        
        
          tkitembind(canvas, "pointII.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointII.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointII.T", "<1>", substitute(II.T()))


        tkitembind(canvas, "pointII.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointII.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointII.F", "<1>", substitute(II.F()))
        
#---------------------------------------------------------------#         

        
          tkitembind(canvas, "pointIII.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointIII.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointIII.T", "<1>", substitute(III.T()))


        tkitembind(canvas, "pointIII.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointIII.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointIII.F", "<1>", substitute(III.F()))
        
#---------------------------------------------------------------#  
        
          tkitembind(canvas, "pointIV.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointIV.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointIV.T", "<1>", substitute(IV.T()))


        tkitembind(canvas, "pointIV.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointIV.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointIV.F", "<1>", substitute(IV.F()))
        
#---------------------------------------------------------------#  

   tkitembind(canvas, "pointV.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointV.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointV.T", "<1>", substitute(V.T()))


        tkitembind(canvas, "pointV.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointV.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointV.F", "<1>", substitute(V.F()))
        
#---------------------------------------------------------------#  


   tkitembind(canvas, "pointVI.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVI.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVI.T", "<1>", substitute(VI.T()))


        tkitembind(canvas, "pointVI.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVI.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVI.F", "<1>", substitute(VI.F()))
        
#---------------------------------------------------------------#  

 
   tkitembind(canvas, "pointVII.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVII.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVII.T", "<1>", substitute(VII.T()))


        tkitembind(canvas, "pointVII.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVII.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVII.F", "<1>", substitute(VII.F()))
        
#---------------------------------------------------------------#  

 tkitembind(canvas, "pointVIII.T", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVIII.T", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVIII.T", "<1>", substitute(VIII.T()))


        tkitembind(canvas, "pointVIII.F", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "pointVIII.F", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "pointVIII.F", "<1>", substitute(VIII.F()))
        
#---------------------------------------------------------------#  
tkpack(tkbutton(top, text = "Exit", command = function()tkdestroy(top)),side="right")
})
}


    

see.mnom.tck <- function ()
{

  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    n <- 10
    p1 <- 0.5
    assign("n", tclVar(n), envir = slider.env)
    assign("p1", tclVar(p1), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows")  {dev.new(noRStudioGD = TRUE)}

    norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        p1 <- as.numeric(evalq(tclvalue(p1), envir = slider.env))
        p2 <- 1 - p1
        x1 <- seq(0, n); x2 <- n - x1
        z <- dbinom(x1, n, p1)
        dev.hold()
        par(mar = c(5,4,0,2))
        scatterplot3d(x = x1, y = x2, z = z, type = "h", zlab = expression(paste(italic(f),"(",italic(y)[1],",",italic(y)[2],")", sep = "")), xlab = expression(italic(y)[1]), ylab = expression(italic(y)[2]), xlim = c(0,20), ylim= c(0,20), pch=19, cex.symbols=.8, box = FALSE)
        mtext(bquote(paste(italic(Y)[1],", ",italic(Y)[2], " ~ ", italic(MNOM), "(",
            .(n), ", ", .(p1), ", ", .(1-p1),")", sep = "")), line = -3, side = 3)
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "MNOM(n, \u03C0\u2081, \u03C0\u2082)")
    tkpack(tklabel(m, text = "      Visualizing the Multinomial Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C0\u2081", width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p1), envir = slider.env)

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
    on.exit(par(old.par))

}

selftest.ttest.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "t-tests")
  size(w) <- c(700, 900)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from a normal distribution with unknown mean, \u03bc, and known variance, \u03c3\u00b2.  \nWe want to conduct a null hypothesis test concerning the value of \u03bc.  We would use a...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)  pooled variance t-test.",
            "(b)  Welch t-test.",
            "(c)  paired t-test.",
            "(d)  one sample z-test.",
            "(e)  one sample t-test."
  )
  
 f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
 }
 
 r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
 
  
  
  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from a normal distribution with unknown mean, \u03bc, and unknown variance, \u03c3\u00b2.  \nWe want to conduct a null hypothesis test concerning the value of \u03bc.  We would use a...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("(a)  pooled variance t-test.",
            "(b)  Welch t-test.",
            "(c)  paired t-test.",
            "(d)  one sample z-test.",
            "(e)  one sample t-test."
  )
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[5]){
      gmessage(msg="Correct")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from two normal distributions with unknown means, \u03bc\u2081, \u03bc\u2082, and common variance, \u03c3\u00b2 \n(i.e., we assume \u03c3\u00b2\u2081 = \u03c3\u00b2\u2082 = \u03c3\u00b2). We want to conduct a null hypothesis test concerning \nthe value of \u03bc\u2081 - \u03bc\u2082.  We would use a...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)  pooled variance t-test.",
            "(b)  Welch t-test.",
            "(c)  paired t-test.",
            "(d)  one sample z-test.",
            "(e)  one sample t-test."
  )
  
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We have a blocked experimental design and in each block we have two treatments.  \nWe measure the differences of treatments in blocks and assume that these differences come from \na normal distribution with an unknown mean and an unknown variance.  We want to conduct a null \nhypothesis test concerning the value of the unknown true mean of differences.  We would use a...", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans4 <- c("(a)  pooled variance t-test.",
            "(b)  Welch t-test.",
            "(c)  paired t-test.",
            "(d)  one sample z-test.",
            "(e)  one sample t-test."
  )
  

  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1) == ans4[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from two normal distributions with unknown means, \u03bc\u2081, \u03bc\u2082, and unknown variances, \u03c3\u00b2\u2081 \nand \u03c3\u00b2\u2082. We want to conduct a null hypothesis test concerning the value of \u03bc\u2081 - \u03bc\u2082.  We would use a...", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans5 <- c("(a)  pooled variance t-test.",
            "(b)  Welch t-test.",
            "(c)  paired t-test.",
            "(d)  one sample z-test.",
            "(e)  one sample t-test."
  )
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1) == ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  #------------- Question 6 -----------#
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("To calculate the pooled variance t-test test statistic we must calculate...", container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans6 <- c("(a)  MSE.",
            "(b)  the Satterthwaite degrees of freedom.",
            "(c)  the standard deviation of differences within blocks.",
            "(d)  the mean of differences within blocks.",
            "(e)  (c) and (d)."
  )
  
  
  f6 <- function(h,....){
    if(tail(svalue(r6),1)== ans6[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1) == ans6[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r6) <- character(0)
  }
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
  
  
  #------------- Question 7 -----------#
  
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("To calculate the paired t-test test statistic we must calculate...", container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans7 <- c("(a)  MSE.",
            "(b)  the Satterthwaite degrees of freedom.",
            "(c)  the standard deviation of differences within blocks.",
            "(d)  the mean of differences within blocks.",
            "(e)  (c) and (d)."
  )
  
  
  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1) == ans7[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r7),1) == ans7[5]){
      gmessage(msg="Correct")
    }
    svalue(r7) <- character(0)
  }
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)
  
  #------------- Question 8 -----------#
  
  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("To calculate the Welch t-test p-value we must calculate...", container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans8 <- c("(a)  MSE.",
            "(b)  the Satterthwaite degrees of freedom.",
            "(c)  the standard deviation of differences within blocks.",
            "(d)  the mean of differences within blocks.",
            "(e)  (c) and (d)."
  )
  
  

  f8 <- function(h,....){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r8),1) == ans8[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r8),1) == ans8[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r8) <- character(0)
  }
  
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)
  
  
  #------------- Question 9 -----------#
  
  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null distribution for a one sample z-test is...", container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans9 <- c("(a)  t(n-1).",
            "(b)  t(n\u2081 + n\u2082 - 2).",
            "(c)  t(\u03bd), where \u03bd = the Satterthwaite degrees of freedom.",
            "(d)  N(0,1).")
  

  f9 <- function(h,....){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r9),1) == ans9[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Correct")
    }
    svalue(r9) <- character(0)
  }
  
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)
  
  
  
  #------------- Question 10 -----------#
  
  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null distribution for a pooled variance t-test is...", container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans10 <- c("(a)  t(n-1).",
             "(b)  t(n\u2081 + n\u2082 - 2).",
             "(c)  t(\u03bd), where \u03bd = the Satterthwaite degrees of freedom.",
             "(d)  N(0,1).")
  
  f10 <- function(h,....){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1) == ans10[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r10) <- character(0)
  }
  
  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)
  
  
  
  #------------- Question 11 -----------#
  
  gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null distribution for a paired t-test is...", container = gp11.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans11 <- c("(a)  t(n-1).",
             "(b)  t(n\u2081 + n\u2082 - 2).",
             "(c)  t(\u03bd), where \u03bd = the Satterthwaite degrees of freedom.",
             "(d)  N(0,1).")
  
  f11 <- function(h,....){
    if(tail(svalue(r11),1) == ans11[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r11),1)== ans11[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r11),1) == ans11[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r11) <- character(0)
  }
  
  r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)
  
  
  
  #------------- Question 12 -----------#
  
  gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null distribution for a Welch t-test is...", container = gp12.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans12 <- c("(a)  t(n-1).",
             "(b)  t(n\u2081 + n\u2082 - 2)",
             "(c)  t(\u03bd), where \u03bd = the Satterthwaite degrees of freedom",
             "(d)  N(0,1).")
  

  f12 <- function(h,....){
    if(tail(svalue(r12),1) == ans12[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r12),1) == ans12[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r12),1)== ans12[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r12) <- character(0)
  }
  
  r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)
  
  
  #------------- Question 13 -----------#
  
  gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null hypothesis for the Fligner-Killeen test is...", container = gp13.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans13 <- c("(a)  H\u2080: \u03bc = \u03bc\u2080.",
             "(b)  H\u2080: \u03bc\u2081 = \u03bc\u2082.",
             "(c)  H\u2080: The underlying population is normal.",
             "(d)  H\u2080: \u03c3\u00b2\u2081 = \u03c3\u00b2\u2082.")
  

  f13 <- function(h,....){
    if(tail(svalue(r13),1) == ans13[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1) == ans13[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[4]){
      gmessage(msg="Correct")
    }
    svalue(r13) <- character(0)
  }
  
  r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)

  
  #------------- Question 14 -----------#
  
  gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The null hypothesis for the Shapiro-Wilk test is...", container = gp14.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans14 <- c("(a)  H\u2080: \u03bc = \u03bc\u2080.",
             "(b)  H\u2080: \u03bc\u2081 = \u03bc\u2082.",
             "(c)  H\u2080: The underlying population is normal.",
             "(d)  H\u2080: \u03c3\u00b2\u2081 = \u03c3\u00b2\u2082.")
  
  f14 <- function(h,....){
    if(tail(svalue(r14),1) == ans14[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r14),1) == ans14[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r14),1)== ans14[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r14) <- character(0)
  }
  
  r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)
  
  #------------- Question 15 -----------#
  OS <- Sys.info()[['sysname']]
  gp15 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The plot below is a...", container = gp15.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  x <- rnorm(20)
  gp15.1a <- getWidget(gp15)
  img <- tkrplot::tkrplot(gp15.1a, function(){ 
    par(bg = "white", mar = c(4.5,4.1,1,1))
    qqnorm(x, cex.lab = ifelse(OS == "Linux", 1,.9), main = "")
    qqline(x, col = 2, lty = 2)
  }
  )
  add(gp15, img)
  ans15 <- c("(a) regression plot.",
             "(b) heteroscedasticy plot.",
             "(c) normal probability plot.",
             "(d) homoscedasticity plot.")

  f15 <- function(h,....){
    if(tail(svalue(r15),1) == ans15[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r15),1)== ans15[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r15) <- character(0)
  }
  
  r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)
  
  
  #------------- Question 16 -----------#
  
  gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The plot from the previous question is generally used to...", container = gp16.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans16 <- c("(a)  Check for the validity of the equal variances assumption.",
             "(b)  Check for the validity of the assumption of normality.",
             "(c)  Check for the validity of the assumption of independence.",
             "(d)  Check for outliers.")
  
  
   f16 <- function(h,....){
    if(tail(svalue(r16),1) == ans16[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r16),1) == ans16[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r16) <- character(0)
   }
   
   r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)
   
  
}

see.accPrec.tck <- function(){

#  old.par <- par(no.readonly = TRUE)

    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    accuracy <- 0.5
    assign("accuracy", tclVar(accuracy), envir = slider.env)
    precision <- 0.5
    assign("precision", tclVar(precision), envir = slider.env)
    angle <- 180
    assign("angle", tclVar(angle), envir = slider.env)

dev.new(height = 4, width = 4, noRStudioGD = TRUE)
par(mar=c(0,0,0,0))
norm.refresh <- function(...){


        dev.hold()
        accuracy <- as.numeric(evalq(tclvalue(accuracy), envir = slider.env))
        precision <- as.numeric(evalq(tclvalue(precision), envir = slider.env))
        angle <- as.numeric(evalq(tclvalue(angle), envir = slider.env))


        plot(-1:1, -1:1, type = "n", xlab= "", ylab = "", yaxt = "n", xaxt = "n")
        draw.circle(rep(0, 5), rep(0, 5), c(1, .8, .6, .4, .2), col = c("grey", "white", "grey", "white", "grey"))

        rad <- angle * pi/180

        xc <- sin(rad) * accuracy
        yc <- cos(rad) * accuracy

        x <- rnorm(10, sd = .25 * precision) + xc
        y <- rnorm(10, sd = .25 * precision) + yc

        points(x, y, pch = 19)
                dev.flush()
}


    m <- tktoplevel()
    tkwm.title(m, "")
    tkpack(tklabel(m, text = "      Accuracy and Precision      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Accuracy (low to high)", width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 0, orient = "horiz", resolution = 0.1, showvalue = FALSE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = accuracy), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Precision (low to high)", width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 0, orient = "horiz", resolution = 0.1, showvalue = FALSE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = precision), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Angle", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = angle), envir = slider.env)

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")

 #   on.exit(par(old.par))

    norm.refresh()

    }

#--------------------------- Lotka-Volterra Competition -------------------------#

anm.LVcomp<-function(n1,n2,r1,r2,K1,K2,a2.1,a1.2,time=seq(0,200),ylab="Abundance",xlab="Time",interval=0.1,...){

y<-xstart<-c(n1=n1,n2=n2)
pars<-c(r1=r1,r2=r2,K1=K1,K2=K2,a2.1=a2.1,a1.2=a1.2)
if(n1 >= K1 | n2 >= K2) stop("Initial population size cannot equal or exceed carrying capacity")

time=time; ylab=ylab; xlab=xlab; interval=interval

pr <- as.list(pars)
func<-function(time=time,xstart=xstart,pars=pars){
    n1 <- xstart[1]
    n2 <- xstart[2]
    with(as.list(pars),{
    dn1 <- r1*n1*((K1-n1-(a1.2*n2))/K1)
    dn2 <- r2*n2*((K2-n2-(a2.1*n1))/K2)
    res <- list(c(dn1,dn2))
    })}

out <- as.data.frame(deSolve::rk4(xstart, time, func, pars))

#------------------------------------------------------ exception handling ---------------------------------------------------------#
if(any(out$n1 < 0)| any(out$n1 > K1) | any(out$n2 < 0)| any(out$n2 > K2)){																#
if(any(out$n1[!is.na(out$n1)] < 0)){t <- min(which(out$n1 < 0)) ; out$n1 <- c(out$n1[1:t-1], rep(0, (length(time) - (t - 1))))}			#
if(any(out$n1[!is.na(out$n1)] > K1)){ t <- min(which(out$n1 > K1)) ; out$n1 <- c(out$n1[1:t-1], rep(K1, (length(time) - (t - 1))))}		#
if(any(out$n2[!is.na(out$n2)] < 0)){t <- min(which(out$n2 < 0)) ; out$n2 <- c(out$n2[1:t-1], rep(0, (length(time) - (t - 1))))}			#
if(any(out$n2[!is.na(out$n2)] > K2)) {t <- min(which(out$n2 > K2)) ; out$n2 <- c(out$n2[1:t-1], rep(K2, (length(time) - (t - 1))))}		#
}																																	#
#-----------------------------------------------------------------------------------------------------------------------------------#


r1.lab <- bquote(paste(r[1],"=",.(pr$r1))); r2.lab <- bquote(paste(r[2],"=",.(pr$r2)))
K1.lab <- bquote(paste(K[1],"=",.(pr$K1))); K2.lab <- bquote(paste(K[2],"=",.(pr$K2)))
a21.lab <- bquote(paste(alpha[21],"=",.(pr$a2.1))); a12.lab<-bquote(paste(alpha[12],"=",.(pr$a1.2)))

old.par <- par(no.readonly = TRUE)
if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows")
{dev.new(noRStudioGD = TRUE)}

layout(matrix(c(1,1,0,2,2,rep(3,20)),5,5,byrow=TRUE))
for(i in min(time):max(time)){
    dev.hold()
    par(mar=c(0,0,0,0))
    N1.lab<-bquote(paste(N[1],"=",.(round(out$n1[i+1],0))));N2.lab<-bquote(paste(N[2],"=",.(round(out$n2[i+1],0))));t.lab<-bquote(paste("Time = ",.(i)))
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n")
    legend("center", legend=c(as.expression(N1.lab),as.expression(N2.lab)),cex=1.75,title=as.expression(t.lab),ncol=2,bty="n")
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",cex=1.65)
    legend("center",legend=c(as.expression(r1.lab),as.expression(K1.lab),as.expression(a12.lab),as.expression(r2.lab),as.expression(K2.lab),
    as.expression(a21.lab)),cex=1.5,ncol=2,bty="n",title="Parameters")
    par(mar=c(5,4,2,2))
    plot(out$time,out$n1,type="n",xlab=xlab,ylab=ylab,ylim=c(min(out$n1,out$n2),max(out$n1,out$n2)),main="Lotka-Volterra Competition",...)
    grid()
    points(out$time[0:i+1],out$n1[0:i+1],type="l",lty=1,col=2)
    points(out$time[0:i+1],out$n2[0:i+1],type="l",lty=2,col=4)
    legend("topright",col=c(2,4),lty=c(1,2), legend=c("Sp. 1","Sp. 2"),bg="white")
 dev.flush()
 Sys.sleep(interval)
}
on.exit(par(old.par))
}





#----------------------Lotka-Volterra exploitation------------------------#

anm.LVexp<-function(nh,np,rh,con,p,d.p,time=seq(0,200),ylab="Abundance",xlab="Time",interval=0.1,circle=FALSE,...){
y=xstart=c(nh=nh,np=np);pars=c(rh=rh,con=con,p=p,d.p=d.p)

pr<-as.list(pars)
func<-function(time=time,x=xstart,pars=pars){
nh<-x[1]
np<-x[2]
with(as.list(pars),{
dnh<-rh*nh-(p*nh*np)
dnp<-con*p*nh*np-(d.p*np)
res<-list(c(dnh,dnp))
})}
out<-as.data.frame(rk4(xstart,time,func,pars))
rh.lab<-bquote(paste(r[h],"=",.(pr$rh)));c.lab<-bquote(paste(c,"=",.(pr$con)));p.lab<-bquote(paste(p,"=",.(pr$con)))
p.lab<-bquote(paste(p,"=",.(pr$p)));dp.lab<-bquote(paste(d[p],"=",.(pr$d.p)))
ccol<-rainbow(max(time)-min(time)+1)

old.par <- par(no.readonly = TRUE)
if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows")
{dev.new(noRStudioGD = TRUE)}

layout(matrix(c(1,1,0,2,2,rep(3,20)),5,5,byrow=TRUE))
for(i in min(time):max(time)){
    dev.hold()
    par(mar=c(0,0,0,0))
    Nh.lab<-bquote(paste(Prey,"=",.(round(out$nh[i+1],0))));Np.lab<-bquote(paste(Pred,"=",.(round(out$np[i+1],0))));t.lab<-bquote(paste("Time = ",.(i)))
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n")
    legend("center", legend=c(as.expression(Nh.lab),as.expression(Np.lab)),cex=1.7,title=as.expression(t.lab),ncol=2,bty="n")
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",cex=1.65)
    legend("center",legend=c(as.expression(rh.lab),as.expression(p.lab),as.expression(c.lab),as.expression(dp.lab)),
    cex=1.5,ncol=2,bty="n",title="Parameters")
    par(mar=c(5,4,2,2))
    if(circle==FALSE){
    plot(out$time,out$nh,type="n",xlab=xlab,ylab=ylab,ylim=c(min(out$nh,out$np),max(out$nh,out$np)),main="Lotka-Volterra Exploitation",...)
    grid()
    points(out$time[0:i+1],out$nh[0:i+1],type="l",lty=1,col=2)
    points(out$time[0:i+1],out$np[0:i+1],type="l",lty=2,col=4)
    legend("topright",col=c(2,4),lty=c(1,2), legend=c("Prey","Pred"),bg="white")
    }
    if(circle==TRUE){
    plot(out$nh,out$np,type="n",xlab="Prey",ylab="Predator",main="Lotka-Volterra Exploitation",...)
    grid()
    points(out$nh[0:i+1],out$np[0:i+1],type="l",lwd=1.5,col=ccol[i+1])
    points(out$nh[i+1],out$np[i+1],pch=19)
        }
    dev.flush()
    Sys.sleep(interval)
}
on.exit(par(old.par))
}

ci.sigma<-function(data,conf=.95,S.sq=NULL,n=NULL,summarized=FALSE){
if(summarized==FALSE){
  S.sq<-var(data)
  n<-nrow(as.matrix(data))}
alpha<-1-conf
lower.chi<-qchisq(1-(alpha/2),df=n-1)
upper.chi<-qchisq((alpha/2),df=n-1)
CI<-c(S.sq,S.sq*(n-1)/lower.chi,S.sq*(n-1)/upper.chi)
head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence interval for population variance"))
ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
res<-list(ci=CI,head=head,ends=ends)
class(res)<-"ci"
res
}

rinvchisq <- function (n, df, scale = 1/df) 
{
    if ((length(scale) != 1) & (length(scale) != n)) 
        stop("scale should have the same length as n")
    if (df <= 0) 
        stop("df must be greater than zero")
    if (any(scale <= 0)) 
        stop("scale must be greater than zero")
    (df * scale)/rchisq(n, df = df)
}

one.sample.t<-function (data = NULL, null.mu=0, xbar = NULL, sd = NULL, n = NULL, 
    alternative = "two.sided", conf = 0.95, na.rm = FALSE, fpc = FALSE, N = NULL) 
{
alt <- c("two.sided", "less", "greater")
if(alternative != alt[1] & alternative != alt[2] &  alternative != alt[3]) stop(c("In alternative use one of: ", paste("'", alt, "' ", sep = "")))

    if (!is.null(data)) {
        xbar <- mean(data, na.rm = na.rm)
        n <- length(na.omit(data))
        sd <- sd(data, na.rm = na.rm)
    }
    s2 <- sd^2
    Var.Xbar<-ifelse(fpc==FALSE,s2/n,(1-(n/N))*(s2/n))
    tstar <- (xbar - null.mu)/sqrt(Var.Xbar)
    if (alternative == "two.sided") {
        p.val <- 2 * pt(abs(tstar), n - 1, lower.tail = FALSE)
    }
    else if (alternative == "less") {
        p.val <- pt(tstar, n - 1, lower.tail = TRUE)
    }
    else if (alternative == "greater") {
        p.val <- pt(tstar, n - 1, lower.tail = FALSE)
    }
    res <- list()
    alt <- paste("mu is", ifelse(alternative=="two.sided","not equal", alternative), ifelse(alternative=="two.sided","to","than"), null.mu)
	tab <- data.frame(df = n - 1, t = tstar, Pval = p.val)
	rownames(tab)=""
	colnames(tab)=c("df", "t*", "P-value")
	res$head <- "One sample t-test"
	res$alternative <- alt
	res$test<-tab
	
	if (is.null(data)==TRUE){
	  data <- NULL
	} else {
	  data <- data
	}
	
	if(alternative == "less" | alternative == "greater"){
	  tail <- ifelse(alternative == "greater", "lower", "upper")
	  res$confidence <- ci.mu.oneside(data = data, summarized=ifelse(is.null(data), TRUE, FALSE), xbar = xbar, n = n, conf = conf, tail = tail, fpc = fpc, N = N)  
	}
	else{
	res$confidence <- ci.mu.t(data = data, summarized = ifelse(is.null(data), TRUE, FALSE), xbar = xbar, sd = sd, n = n, conf = conf, fpc = fpc, N = N)}    
	class(res) <- "oneSamp"
	res
	}


print.oneSamp <- function(x, digits= max(3, getOption("digits")), ...){
cat("\n")
cat(x$head ,"\n")
rq<-structure(x$test)
print(rq,digits=digits)
cat("\n")
invisible(x)
}

see.power<-function(alpha=NULL,sigma=NULL,n=NULL,effect=NULL,test="lower",xlim=c(-3,3),strict=FALSE){
#  old.par <- par(no.readonly = TRUE)

    upper.titlel<-bquote(paste("Distribution assuming ",H[0],": ",mu >= 0))
    upper.titleu<-bquote(paste("Distribution assuming ",H[0],": ",mu <= 0))
    upper.titleb<-bquote(paste("Distribution assuming ",H[0],": ",mu," = 0"))
    lower.titlel<-bquote(paste("Distribution assuming ",H[A],": ",mu," < 0"))
    lower.titleu<-bquote(paste("Distribution assuming ",H[A],": ",mu," > 0"))
    lower.titleb<-bquote(paste("Distribution assuming ",H[A],": ",mu != 0))

    effect=abs(effect)

if(test == "lower"){
    dev.hold()
    powerp<-power.z.test(alpha=alpha,sigma=sigma,effect=effect,power=NULL,n=n,test="one.tail")$power
    power1<-round(powerp,3)
    qalpha<-qnorm(alpha,mean=0,sd=sigma/sqrt(n))
    qpower<-qnorm(powerp,mean=-1*effect,sd=sigma/sqrt(n))
    plot(seq(0,1),seq(0,1),type="n",xaxt="n",yaxt="n",bty="n",xlab="",ylab="")
    text(.5,0.8,bquote(paste(alpha," = ",.(alpha),",     1 - ",beta," = ", .(power1),",    ",italic(n)," = ",.(n),",    ",sigma," = ",.(sigma))),cex=2)
    text(.5,0.14,bquote(paste("effect size = ",.(effect),",     'tail' of test = '", .(test),"'")),cex=2)


    shade.norm(x=qalpha,sigma=sigma/sqrt(n),mu=0,tail="lower",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightyellow2",main=upper.titlel,xlim=xlim)
    abline(v=qalpha,col=1)
    legend("topright",pch=22,pt.bg="lightyellow2",pt.cex=2,legend=expression(alpha))
    text(qalpha,0.5*dnorm(0,mean=0,sd=sigma/sqrt(n)),"rejection region \u2190", adj = 1)
    shade.norm(x=qpower,sigma=sigma/sqrt(n),mu=-1*effect,tail="lower",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightcoral" ,main=lower.titlel,xlim=xlim)
    abline(v=qpower,col=1)
    legend("topright",pch=22,pt.bg="lightcoral",pt.cex=2,legend=expression(paste("1-",beta)))
    text(qpower,0.5*dnorm(effect,mean=effect,sd=sigma/sqrt(n)),"rejection region \u2190", adj = 1)
    dev.flush()
    }

if(test == "upper"){
    dev.hold()
    powerp<-power.z.test(alpha=alpha,sigma=sigma,effect=effect,power=NULL,n=n,test="one.tail")$power
    power1<-round(powerp,3)
    qalpha<-qnorm(1-alpha,mean=0,sd=sigma/sqrt(n))
    qpower<-qnorm(1-powerp,mean=effect,sd=sigma/sqrt(n))
    plot(seq(0,1),seq(0,1),type="n",xaxt="n",yaxt="n",bty="n",xlab="",ylab="")
    text(.5,0.8,bquote(paste(alpha," = ",.(alpha),",     1 - ",beta," = ", .(power1),",    ",italic(n)," = ",.(n),",    ",sigma," = ",.(sigma))),cex=2)
    text(.5,0.14,bquote(paste("effect size = ",.(effect),",     'tail' of test = '", .(test),"'")),cex=2)

    shade.norm(x=qalpha,sigma=sigma/sqrt(n),mu=0,tail="upper",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightyellow2",main=upper.titleu,xlim=xlim)
    abline(v=qalpha,col=1)
    legend("topright",pch=22,pt.bg="lightyellow2",pt.cex=2,legend=expression(alpha))
    text(qalpha,0.5*dnorm(0,mean=0,sd=sigma/sqrt(n)),"\u2192 rejection region", adj = 0)

    shade.norm(x=qpower,sigma=sigma/sqrt(n),mu=effect,tail="upper",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightcoral" ,main=lower.titleu,xlim=xlim)
    abline(v=qpower,col=1)
    legend("topright",pch=22,pt.bg="lightcoral",pt.cex=2,legend=expression(paste("1-",beta)))
    text(qpower,0.5*dnorm(effect,mean=effect,sd=sigma/sqrt(n)),"\u2192 rejection region", adj = 0)
    dev.flush()
    }
if(test == "two"){
    dev.hold()
    powerp<-power.z.test(alpha=alpha,sigma=sigma,effect=effect,power=NULL,n=n,test="two.tail")$power
    if(strict == TRUE)powerp<-power.z.test(alpha=alpha,sigma=sigma,effect=effect,power=NULL,n=n,test="two.tail",strict=TRUE)$power
    power1<-round(powerp,3)
    qalpha<-qnorm(1-(alpha/2),mean=0,sd=sigma/sqrt(n))
    qpower<-qnorm(1-power.z.test(alpha=alpha,sigma=sigma,effect=effect,power=NULL,n=n,test="two.tail")$power,mean=effect,sd=sigma/sqrt(n))
    plot(seq(0,1),seq(0,1),type="n",xaxt="n",yaxt="n",bty="n",xlab="",ylab="")
    text(.5,0.8,bquote(paste(alpha," = ",.(alpha),",     1 - ",beta," = ", .(power1),",    ",italic(n)," = ",.(n),",    ",sigma," = ",.(sigma))),cex=2)
    text(.5,0.14,bquote(paste("effect size = ",.(effect),",     'tail' of test = '", .(test),"'")),cex=2)

    shade.norm(x=qalpha,sigma=sigma/sqrt(n),mu=0,tail="two",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightyellow2",main=upper.titleb,xlim=xlim)
    abline(v=qalpha,col=1)
    abline(v=-qalpha,col=1)
    legend("topright",pch=22,pt.bg="lightyellow2",pt.cex=2,legend=expression(alpha))
    text(qalpha,0.5*dnorm(0,mean=0,sd=sigma/sqrt(n)),"\u2192 rejection region", adj = 0)
    text(-qalpha,0.5*dnorm(0,mean=0,sd=sigma/sqrt(n)),"rejection region \u2190", adj = 1)

    shade.norm(x=qpower,sigma=sigma/sqrt(n),mu=effect,tail="two",show.p=FALSE,show.d=FALSE,show.dist=TRUE,shade.col="lightcoral" ,main=lower.titleb,xlim=xlim)
    abline(v=qpower,col=1)
    abline(v=-qpower,col=1)
    legend("topright",pch=22,pt.bg="lightcoral",pt.cex=2,legend=expression(paste("1-",beta)))
    text(qpower,0.5*dnorm(effect,mean=effect,sd=sigma/sqrt(n)),"\u2192 rejection region", adj = 0)
    text(-qpower,0.5*dnorm(0,mean=0,sd=sigma/sqrt(n)),"rejection region \u2190", adj = 1)
    dev.flush()
    }
#    on.exit(par(old.par))
    }



see.power.tck<-function ()
{
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    alpha <- 0.05
    sigma <- 1.5
    effect <-1
    n <- 5
    test <-tclVar("lower")
    strict <- tclVar("FALSE")

    assign("alpha", tclVar(alpha),envir= slider.env)
    assign("sigma", tclVar(sigma),envir= slider.env)
    assign("effect", tclVar(effect),envir= slider.env)
    assign("n", tclVar(n),envir= slider.env)

    xmin <- -3
    assign("xmin", tclVar(xmin),envir= slider.env)
    xmax <- 3
    assign("xmax", tclVar(xmax),envir= slider.env)

    if(Sys.info()[['sysname']] != "Linux") {dev.new(noRStudioGD = TRUE)}
    layout(matrix(c(1,rep(2,2),rep(3,2)), 5, 1, byrow = TRUE))
    par(mar=c(4, 4, 2, 1))

   norm.refresh <- function(...) {
        alpha <- as.numeric(evalq(tclvalue(alpha),envir= slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma),envir= slider.env))
        n <- as.numeric(evalq(tclvalue(n),envir= slider.env))
        effect <- as.numeric(evalq(tclvalue(effect),envir= slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin),envir= slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax),envir= slider.env))
        xixa <- c(xmin, xmax)
        test <- tclvalue(test)
        strict <- tclvalue(strict)
        see.power(alpha=alpha,sigma=sigma,n=n,effect=effect,xlim=xixa,test=test, strict=strict)
    }

    m <- tktoplevel()
    tkwm.title(m, "Visualizing Power")
    tkpack(tklabel(m,text="      Visualizing Power      "))
    tkwm.geometry(m, "+0+0")

    tkpack(tklabel(m,text="            "))

    tkpack(fr <- tkframe(m), side = "top", anchor = "w")
    tkpack(fr1 <- tkframe(fr), side = "left",anchor = "w")
    tkpack(fr2 <- tkframe(fr), side = "right", anchor = "e")

     tkpack(tklabel(fr1, text = "  Test: "), side = "left")
        for ( i in c("lower", "upper", "two")){
            tmp <- tkradiobutton(fr1, text=i, variable=test, value=i)
            tkpack(tmp,anchor="w")
            }

    tkpack(tklabel(fr2, text = "               Strict: "), side = "left")
        for ( i in c("TRUE", "FALSE")){
            tmp <- tkradiobutton(fr2, text=i, variable=strict, value=i)
            tkpack(tmp,anchor="w")
            }


    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b1',font=c("Helvetica","10","italic"), width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = alpha),envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03c3',font=c("Helvetica","10","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.5,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = sigma),envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n",font=c("Helvetica","10","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = n),envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Effect size", font=c("Helvetica","10"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 3, orient = "horiz", resolution = .1, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = effect),envir= slider.env)


    tkpack(tklabel(m,text="            "))
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmin),envir= slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmax),envir= slider.env)

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

ML.k<-function(f,x,res=0.000001){
N<-sum(f)
m<-sum(x*(f/N))
Sfx<-sum(f*x)
Sfx2<-sum(f*x^2)
s2<-(Sfx2-(Sfx^2/N))/(N-1)
khat1<-m^2/(s2-m)
rng<-s2/10

Az<-matrix(ncol=1,nrow=length(f))
Az[1]<-N-f[1]
for(i in 2:length(f)){
Az[i]<-Az[i-1]-f[i]
}

khats<-seq(khat1-rng,khat1+rng,by=res)
z<-matrix(ncol=1,nrow=length(khats))
for(i in 1:length(khats)){
S1<-sum(Az/(khats[i]+x))
S2a <- 1+(m/khats[i])
S2<-ifelse(S2a >= 0, N*log(S2a), 0)
z[i]<-abs(S1-S2)
}

result<-list()
result$k<-khats[z==min(z)]
result$m<-m
result
}

see.anova.tck <- function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    mu1 <- -1.5
    assign("mu1", tclVar(mu1), envir = slider.env)
    mu2 <- 0
    assign("mu2", tclVar(mu2), envir = slider.env)
    mu3 <- 1
    assign("mu3", tclVar(mu3), envir = slider.env)
    sigma <- 1
    assign("sigma", tclVar(sigma), envir = slider.env)
    n <- 10
    assign("n", tclVar(n), envir = slider.env)
    color<-tclVar(1)

    ylim <- c(0, dnorm(0, 0, 0.5))
    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        dev.hold()
        mu1 <- as.numeric(evalq(tclvalue(mu1), envir = slider.env))
        mu2 <- as.numeric(evalq(tclvalue(mu2), envir = slider.env))
        mu3 <- as.numeric(evalq(tclvalue(mu3), envir = slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma), envir = slider.env))
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        color <- as.logical(tclObj(color))

        mu <- (mu1+mu2+mu3)/3
        E.MSA <- sigma^2 + (n*((mu-mu1)^2)/2 + n*((mu-mu2)^2)/2 + n*((mu-mu3)^2)/2)


        y1 <- rnorm(n,mu1,sigma)
        y2 <- rnorm(n,mu2,sigma)
        y3 <- rnorm(n,mu3,sigma)
        x <- rep(c("1","2","3"),each=n)

        y <- c(y1,y2,y3)
        a <- anova(lm(y~factor(x)))
        MSA <- a$"Mean Sq"[1]
        MSE <- a$"Mean Sq"[2]
        F.star <- MSA/MSE
        P <- pf(F.star,2,n-3,lower.tail=FALSE)

        cols <- c(rgb(red=0.4,blue=0.4,green=0.5,alpha=.3), rgb(red=0.4,blue=0.8,green=0.5,alpha=.2),rgb(red=0.8,blue=0.4,green=0.5,alpha=.3))
        rcols <- c(rep(rgb(red=0.4,blue=0.4,green=0.5),n), rep(rgb(red=0.4,blue=0.8,green=0.5),n),rep(rgb(red=0.8,blue=0.4,green=0.5),n))

        curve(dnorm(x,mu1,sigma),from=-5,to=5,ylim=ylim,xlab=expression(italic(y)),ylab=expression(paste(italic(f),"(",italic(y),")", sep = "")))
        mtext(side = 3, "ANOVA from random sample of populations:", line = 2.5)
        mtext(side = 3, line = 1, bquote(paste(italic(MSTR)," = ", .(round(MSA, 2)), "  ",italic(MSE)," = ",
        .(round(MSE, 2)), "  ",italic(F),  "* = ", .(round(F.star, 2)),"   ", italic(P), "-value = ", .(round(P, 5)))))

        xx <- seq(-10, 10, length = 500)
        yy1 <- dnorm(xx, mu1, sigma)
        yy2 <- dnorm(xx, mu2, sigma)
        yy3 <- dnorm(xx, mu3, sigma)

    if(color == TRUE){
        polygon(c(xx[xx <= 10], 10), c(yy1[xx <= 10], yy1[xx ==
            -10]), col = cols[1])
        polygon(c(xx[xx <= 10], 10), c(yy2[xx <= 10], yy2[xx ==
            -10]), col = cols[2])
        polygon(c(xx[xx <= 10], 10), c(yy3[xx <= 10], yy3[xx ==
            -10]), col = cols[3])
        mtext(side = 1, at = c(y1,y2,y3), line = -1, c(rep(1,n),rep(2,n),rep(3,n)), adj = c(0.5,0), cex = .9, col = rcols)
        legend("topright", pch = 22, pt.cex = 1.7, pt.bg = cols,
            legend = c(expression(italic(X)[1]), expression(italic(X)[2]), expression(italic(X)[3])),
            bty = "n")}

    if(color == FALSE){
        polygon(c(xx[xx <= 10], 10), c(yy1[xx <= 10], yy1[xx ==
            -10]), angle = 45, density = 20)
        polygon(c(xx[xx <= 10], 10), c(yy2[xx <= 10], yy2[xx ==
            -10]), angle = 0, density = 20)
        polygon(c(xx[xx <= 10], 10), c(yy3[xx <= 10], yy3[xx ==
            -10]), angle = 135, density = 20)
        mtext(side = 1, at = c(y1,y2,y3), line = -1, c(rep(1,n),rep(2,n),rep(3,n)), adj = c(0.5,0), cex = .9, col = 1)
        legend("topright", angle = c(45, 0, 135), density = 20,
            legend = c(expression(italic(X)[1]), expression(italic(X)[2]), expression(italic(X)[3])),
            bty = "n")}

        legend("topleft", legend = c(expression(paste(italic(alpha)[1],
            "  =")), expression(paste(italic(alpha)[2], "  =")), expression(paste(italic(alpha)[3],
            "  = ")), "", expression(paste(italic(E), "(", italic(MSTR),
            ") = ")), expression(paste(italic(E), "(", italic(MSE),
            ") = "))), bty = "n")
        legend(-4.7, 0.833, legend = c(round(mu1 - mu, 2), round(mu2 -
            mu, 2), round(mu3 - mu, 2),"", paste("              ",
            round(E.MSA, 2)), paste("            ", round(sigma^2,
            2))), bty = "n")

        abline(v=mu,lty=2)
        text(mu + 0.2, max(ylim),expression(mu))
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing ANOVA")
    tkpack(tklabel(m, text = "      Visualizing ANOVA      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC\u2081", font = c("Helvetica", "11",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu1), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC\u2082", font = c("Helvetica", "11",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu2), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC\u2083", font = c("Helvetica", "11",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu3), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C3", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 2, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = sigma), envir = slider.env)

   tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 2,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)
    tkpack(tkcheckbutton(m, text="Color", variable=color))

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")

    norm.refresh()
}

book.menu <- function ()
{
    tclServiceMode(TRUE)
    tt <- tktoplevel()
    tkwm.title(tt, "Foundational and Applied Statistics for Biologists using R")
    topMenu <- tkmenu(tt)
    tkconfigure(tt, menu = topMenu, width = 800, height = 150)

#----------------------- Menu labels ---------------------#

# Book menu
	Ch1 <- tkmenu(topMenu, tearoff = FALSE)
	Ch2 <- tkmenu(topMenu, tearoff = FALSE)
	Ch3 <- tkmenu(topMenu, tearoff = FALSE)
	Ch4 <- tkmenu(topMenu, tearoff = FALSE)
	Ch5	<- tkmenu(topMenu, tearoff = FALSE)
	Ch6 <- tkmenu(topMenu, tearoff = FALSE)
	Ch7 <- tkmenu(topMenu, tearoff = FALSE)
	Ch8 <- tkmenu(topMenu, tearoff = FALSE)
	Ch9 <- tkmenu(topMenu, tearoff = FALSE)
	Ch10 <- tkmenu(topMenu, tearoff = FALSE)
	Ch11 <- tkmenu(topMenu, tearoff = FALSE)

# Biology menu
	Biology <- tkmenu(topMenu, tearoff = FALSE)

# Self test questions
  questions1 <- tkmenu(topMenu, tearoff = FALSE)
  questions2 <- tkmenu(topMenu, tearoff = FALSE)
	questions3 <- tkmenu(topMenu, tearoff = FALSE)
	questions4 <- tkmenu(topMenu, tearoff = FALSE)
	questions5 <- tkmenu(topMenu, tearoff = FALSE)
	questions6 <- tkmenu(topMenu, tearoff = FALSE)
	questions7 <- tkmenu(topMenu, tearoff = FALSE)
	questions8 <- tkmenu(topMenu, tearoff = FALSE)
	questions9 <- tkmenu(topMenu, tearoff = FALSE)
	questions10 <- tkmenu(topMenu, tearoff = FALSE)
	questions11 <- tkmenu(topMenu, tearoff = FALSE)

# Distributions
	dists1 <- tkmenu(topMenu, tearoff = FALSE) # Ch 3 (Ch 4, Ch 5, Ch 6)

#------------------- Menu contents -----------------------#

# Chapter 1
	tkadd(Ch1, "cascade", label = "Self-test questions", menu = questions1) #Names question menus
		tkadd(questions1, "command", label = "Logic", command = substitute(see.logic())) # Ch 1 questions
		tkadd(questions1, "command", label = "Scientific foundations", command = substitute(selftest.science.tck1())) # Ch 1 questions
	tkadd(Ch1, "command", label = "Accuracy and precision", command = substitute(see.accPrec.tck())) # Ch 1
	tkadd(topMenu, "cascade", label = "Chapter 1", menu = Ch1) # Names Ch 1

# Chapter 2
	tkadd(Ch2, "cascade", label = "Self-test questions", menu = questions2) #Names question menus
		tkadd(questions2, "command", label = "Probability", command = substitute(selftest.prob.tck())) # Ch 2 questions
		tkadd(questions2, "command", label = "Combinatorics", command = substitute(selftest.comb.tck())) # Ch 2 questions
	tkadd(Ch2, "command", label = "Bayesian analysis of discrete data",
        command = substitute(print(Bayes.disc.tck()))) # Ch 2
	tkadd(Ch2, "command", label = "Coin flips", command = substitute(anm.coin.tck())) # Ch 2
	tkadd(Ch2, "command", label = "Die throws", command = substitute(anm.die.tck())) # Ch 2
	tkadd(Ch2, "command", label = "Venn diagrams", command = substitute(Venn.tck())) # Ch 2
	tkadd(topMenu, "cascade", label = "Chapter 2", menu = Ch2) # Names Ch 2

# Chapter 3
	tkadd(Ch3, "cascade", label = "Self-test questions", menu = questions3) #Names question menus
		tkadd(questions3, "command", label = "Pdfs", command = substitute(selftest.pdfs.tck())) # Ch 3 questions
	tkadd(Ch3, "command", label = "Continuous pdf conceptualization", command = substitute(see.pdf.conc.tck())) # Ch 3
	tkadd(Ch3, "command", label = "Exponential power function",
		command = substitute(see.exppower.tck())) # Ch 3
      tkadd(Ch3, "command", label = "Pdf depiction", command = substitute(see.pdfdriver.tck())) # Ch 3 (also in Ch 4, 5, 6)
	tkadd(Ch3, "cascade", label = "Pdf probability", menu = dists1) # Names dist1 (also in Ch 4, 5, 6)
	tkadd(topMenu, "cascade", label = "Chapter 3", menu = Ch3) # Names Ch 3

# Chapter 4
	tkadd(Ch4, "cascade", label = "Self-test questions", menu = questions4) #Names question menus
		tkadd(questions4, "command", label = "Statistics and parameters", command = substitute(selftest.stats.tck())) # Ch 4 questions
		tkadd(questions4, "command", label = "ML and OLS estimation", command = substitute(selftest.ML_OLS.tck())) # Ch 4 questions
		tkadd(questions4, "command", label = "Transformations of random variables", command = substitute(selftest.stats.tck1())) # Ch 4 questions
		tkadd(questions4, "command", label = "Bayesian applications", command = substitute(selftest.bayes4.tck())) # Ch 4 questions
	tkadd(Ch4, "command", label = "Cognitive illusions", command = substitute(example(illusions))) # Ch 4
	tkadd(Ch4, "command", label = "Least squares", command = substitute(anm.ls.tck())) # Ch 4
	tkadd(Ch4, "command", label = "Log-likelihood", command = substitute(anm.loglik.tck())) # Ch 4
	tkadd(Ch4, "command", label = "M-estimation", command = substitute(see.M())) # Ch 4
	tkadd(topMenu, "cascade", label = "Chapter 4", menu = Ch4) # Names Ch 4

  # Shaded Distributions
	tkadd(dists1, "command", label = "Normal", command = substitute(shade.norm.tck()))
	tkadd(dists1, "command", label = "Binomial", command = substitute(shade.bin.tck()))
	tkadd(dists1, "command", label = "Chi-square", command = substitute(shade.chi.tck()))
	tkadd(dists1, "command", label = "F", command = substitute(shade.F.tck()))
	tkadd(dists1, "command", label = "Poisson", command = substitute(shade.poi.tck()))
	tkadd(dists1, "command", label = "t", command = substitute(shade.t.tck()))

# Chapter 5
	tkadd(Ch5, "cascade", label = "Self-test questions", menu = questions5) #Names question menus
		tkadd(questions5, "command", label = "Sampling distributions",
			command = substitute(selftest.sampd.tck1())) # Ch 5 questions
		tkadd(questions5, "command", label = "Confidence interval demonstration",
			command = substitute(selftest.conf.tck1())) # Ch 5 questions
		tkadd(questions5, "command", label = "Bootstrapping and jackknifing",
		      command = substitute(selftest.jack.tck())) # Ch 5 questions
		tkadd(questions5, "command", label = "Bayesian applications", command = substitute(selftest.bayes5.tck())) # Ch 5 questions
	tkadd(Ch5, "command", label = "Confidence intervals", command = substitute(anm.ci.tck())) # Ch 5
	tkadd(Ch5, "command", label = "MCMC simulation", command = substitute(anm.mc.bvn.tck())) # Ch 5
	tkadd(Ch5, "command", label = "Sampling distribution basics",
        command = substitute(samp.dist.mech.tck())) # Ch 5
	tkadd(Ch5, "command", label = "Sampling distributions",
        command = substitute(samp.dist.method.tck())) # Ch 5
	tkadd(topMenu, "cascade", label = "Chapter 5", menu = Ch5) # Names Ch 5

# Chapter 6
	tkadd(Ch6, "cascade", label = "Self-test questions", menu = questions6) #Names question menus
	tkadd(questions6, "command", label = "Null hypothesis tests",
			command = substitute(selftest.H0.tck())) # Ch 6 questions
	tkadd(questions6, "command", label = "t-tests",
	      command = substitute(selftest.ttest.tck())) # Ch 6 questions
	tkadd(questions6, "command", label = "Using t-tests in R",
	      command = substitute(selftest.codettest.tck())) # Ch 6 questions
	tkadd(questions6, "command", label = "Nonparametric alternatives to t-tests",
	      command = substitute(selftest.nonparametric6.tck())) # Ch 6 questions
	tkadd(Ch6, "command", label = "Power", command = substitute(see.power.tck())) # Ch 6
	tkadd(Ch6, "command", label = "t-test mechanics", command = substitute(see.ttest.tck())) # Ch 6
	tkadd(Ch6, "command", label = "Type I and II error", command = substitute(see.typeI_II())) # Ch 6
	tkadd(topMenu, "cascade", label = "Chapter 6", menu = Ch6) # Names Ch 6

# Chapter 7
	tkadd(Ch7, "cascade", label = "Self-test questions", menu = questions7) #Names question menus
	   tkadd(questions7, "command", label = "Experimental and sampling design fundamentals",
     command = substitute(selftest.se.tck1()))   # Ch 7 questions
	   tkadd(questions7, "command", label = "ANOVA designs",
	         command = substitute(selftest.ANVOVA_design.tck()))   # Ch 7 questions
	tkadd(Ch7, "command", label = "Experimental designs", command = substitute(anm.ExpDesign.tck())) # Ch 7
	tkadd(Ch7, "command", label = "Regression (Add/delete points)",
        command = substitute(see.adddel())) # Ch 7 (also in Ch 9)
	tkadd(Ch7, "command", label = "Regression (Move points)",
        command = substitute(see.move())) # Ch 7 (also in Ch 9)
	tkadd(Ch7, "command", label = "Sampling designs", command = substitute(anm.samp.design.tck())) # Ch 7
	tkadd(topMenu, "cascade", label = "Chapter 7", menu = Ch7) # Names Ch 7

# Chapter 8
	tkadd(Ch8, "cascade", label = "Self-test questions", menu = questions8) #Names question menus
	tkadd(questions8, "command", label = "Correlation",
			command = substitute(selftest.corr.tck1())) # Ch 8 questions
	tkadd(Ch8, "command", label = "Effect of range on correlation", command = substitute(see.cor.range.tck())) # Ch 8
	tkadd(Ch8, "command", label = "Pearson correlation sampling distribution", command = substitute(see.r.dist.tck())) # Ch 8
	tkadd(topMenu, "cascade", label = "Chapter 8", menu = Ch8) # Names Ch 8

# Chapter 9
	tkadd(Ch9, "cascade", label = "Self-test questions", menu = questions9) #Names question menus
	tkadd(questions9, "command", label = "Basic regression characteristics",
	      command = substitute(selftest.regchar.tck1())) # Ch 9 questions
	tkadd(questions9, "command", label = "Regression assumptions and diagnostics",
			command = substitute(selftest.regdiag.tck1())) # Ch 9 questions
	tkadd(questions9, "command", label = "Regression approaches",
	      command = substitute(selftest.regapproaches.tck1())) # Ch 9 questions
	tkadd(questions9, "command", label = "Generalized linear models",
	      command = substitute(selftest.regGLM.tck1())) # Ch 9 questions
	tkadd(Ch9, "command", label = "Linear models (Regression)",
		command = substitute(see.lmr.tck())) # Ch 9
	tkadd(Ch9, "command", label = "Non-linear models",
		command = substitute(see.nlm())) # Ch 9
	tkadd(Ch9, "command", label = "OLS estimation in regression",
		command = substitute(anm.ls.reg.tck())) # Ch 9
	tkadd(Ch9, "command", label = "Regression (Add/delete points)",
		command = substitute(see.adddel())) # Ch 9 (also in Ch 7)
	tkadd(Ch9, "command", label = "Regression (Move points)",
		command = substitute(see.move())) # Ch 9 (also in Ch 7)
	tkadd(Ch9, "command", label = "Regression mechanics",
		command = substitute(see.regression.tck())) # Ch 9
	tkadd(Ch9, "command", label = "ROC mechanics",
		command = substitute(see.roc.tck())) # Ch 9
	tkadd(Ch9, "command", label = "Smoothers",
		command = substitute(see.smooth.tck())) # Ch 9
	tkadd(topMenu, "cascade", label = "Chapter 9", menu = Ch9) # Names Ch 9

		# Chapter 10
	tkadd(Ch10, "cascade", label = "Self-test questions", menu = questions10) #Names question menus
	tkadd(questions10, "command", label = "ANOVA review",
	      command = substitute(selftest.ANVOVA_design_review.tck())) # Ch 10 questions
	tkadd(questions10, "command", label = "Simultaneous inference",
			command = substitute(selftest.ANOVAsiminf.tck1())) # Ch 10 questions
	tkadd(questions10, "command", label = "Mixed effect models",
			command = substitute(selftest.ANOVAmixed.tck1())) # Ch 10 questions
	tkadd(questions10, "command", label = "Type II and III SS",
			command = substitute(selftest.typeIISS.tck1())) # Ch 10 questions
	tkadd(Ch10, "command", label = "ANOVA mechanics",
		command = substitute(see.anova.tck())) # Ch 10
	tkadd(Ch10, "command", label = "ANCOVA mechanics",
		command = substitute(see.ancova.tck())) # Ch 10
	tkadd(Ch10, "command", label = "Fixed effects in mixed effect model",
		command = substitute(see.mixedII())) # Ch 10
	tkadd(Ch10, "command", label = "Linear models (ANOVA)",
		command = substitute(see.lma.tck())) # Ch 10
	tkadd(Ch10, "command", label = "Type I, II, III SS dichotomous key",
	      command = substitute(example(see.lmu.tck)))
	tkadd(Ch10, "command", label = "Type I, II, III SS and unballanced designs",
		command = substitute(see.lmu.tck())) # Ch 10
	tkadd(Ch10, "command", label = "Random effects",
		command = substitute(see.rEffect.tck())) # Ch 10
	tkadd(topMenu, "cascade", label = "Chapter 10", menu = Ch10) # Names Ch 10

# Chapter 11
	tkadd(Ch11, "cascade", label = "Self-test questions", menu = questions11) #Names question menus
	tkadd(Ch11, "command", label = "Multinomial distribution",
		command = substitute(see.mnom.tck())) # Ch 11
	tkadd(Ch11, "command", label = "Simpson's paradox",
		command = substitute(example(paik))) # Ch 11
	tkadd(topMenu, "cascade", label = "Chapter 11", menu = Ch11) # Names Ch 11

# Biology

	tkadd(Biology, "command", label = "Geometric growth",
		command = substitute(anm.geo.growth.tck()))
	tkadd(Biology, "command", label = "Exponential growth",
		command = substitute(anm.exp.growth.tck()))
	tkadd(Biology, "command", label = "Hardy Weinberg equilibrium",
		command = substitute(see.HW.tck()))
	tkadd(Biology, "command", label = "Logistic growth",
		command = substitute(anm.log.growth.tck()))
	tkadd(Biology, "command", label = "Lotka-Volterra competition",
		command = substitute(anm.LVc.tck()))
	tkadd(Biology, "command", label = "Lotka-Volterra exploitation",
		command = substitute(anm.LVe.tck()))
	tkadd(Biology, "command", label = "Matrix population models",
		command = substitute(anm.TM.tck()))
	tkadd(topMenu, "cascade", label = "Biology", menu = Biology)
}

anm.ls <- function (X, poss = NULL, parameter = "mu", est.lty = 2, est.col = 2,
    conv = diff(range(X))/50, anim = TRUE, plot.lsfunc = TRUE,
    plot.res = TRUE, interval = 0.01, xlab = expression(paste("Estimates for ",
        italic(E), "(", italic(X), ")", sep = "")), ...)
{

  if (is.null(poss))
        poss <- seq(mean(X) - 3 * sd(X), mean(X) + 3 * sd(X),
            conv)
    sq.res <- matrix(nrow = length(X), ncol = length(poss))
    for (i in 1:length(poss)) {
        sq.res[, i] <- (poss[i] - X)^2
    }
    ss.res <- sapply(poss, function(x) {
        sum((x - X)^2)
    })
    est <- poss[ss.res == min(ss.res)]
    LS.est <- mean(X)
    if (plot.lsfunc == TRUE) {
      dev.new(height = ifelse(plot.res == TRUE, 4, NULL),
              width = ifelse(plot.res == TRUE, 8, NULL), noRStudioGD = TRUE)
        nm <- which(poss == est)[1]
        if (plot.res == TRUE) {
            par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)
        }
        if (anim == FALSE) {
            plot(poss, ss.res, type = "l", ylab = "Sum of squares",
                xlab = xlab, ...)
            abline(v = mean(X), lty = est.lty, col = est.col)
            legend("bottomright", legend = bquote(paste("LS est. = ",
                .(LS.est))), cex = 0.9, bty = "n")
            points(poss, ss.res, type = "l")
            if (plot.res == TRUE) {
                plot(X, sq.res[, nm], ylab = "Squared residual",
                  type = "h", col = est.col, lty = 2, xlab = expression(italic(x)))
                points(X, sq.res[, nm], pch = 19, cex = 0.7)
                legend("topright", legend = bquote(paste("SS = ",
                  .(ss.res[nm]))), cex = 0.9, bty = "n")
            }
        }
        if (anim == TRUE) {
         # if(options("device")$device == "RStudioGD") dev.new(noRStudioGD = TRUE)
            for (i in 1:nm) {
              dev.hold()
                plot(poss, ss.res, type = "n", ylab = "Sum of squares",
                  xlab = xlab, ...)
                arrows(poss[i], ss.res[i], poss[i + 1], ss.res[i +
                  1], col = est.col, length = 0.15, lwd = 1)
                points(poss[1:i], ss.res[1:i], lty = 2, col = est.col,
                  lwd = 1, type = "l")
                if (i == nm) {
                  abline(v = mean(X), lty = est.lty, col = est.col)
                  legend("bottomright", legend = bquote(paste("LS est. = ",
                    .(LS.est))), cex = 0.9, bty = "n")
                  points(poss, ss.res, type = "l")
                }
                if (plot.res == TRUE) {
                  plot(X, sq.res[, i], ylab = "Squared residual",
                    type = "h", col = est.col, lty = 2, xlab = expression(italic(x)))
                  points(X, sq.res[, i], pch = 19, cex = 0.7)
                  legend("topright", legend = bquote(paste("SS = ",
                    .(ss.res[i]))), cex = 0.9, bty = "n")
                }
                dev.flush()
                Sys.sleep(interval)
            }
        }
    }
}

selftest.bayes5.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Bayesian applications in Ch 5")
  size(w) <- c(700, 260)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A credible interval is...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)  with a large number of repeated samples, 95% of such calculated intervals would include the \n true value of the parameter.",
            "(b)  the sampling distribution of an estimator.",
            "(c)  an interval in the domain of a posterior probability distribution.",
            "(d)  All of the above.")
  
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use Markov chains in Bayesian statistics...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("(a)  to create likelihood functions when priors are unknown.",
            "(b)  to sample from the likelihood dependent on data subsets.",
            "(c)  to describe the posterior distribution in cases when it is indescribable otherwise.",
            "(d)  All of the above.")
  

  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect",  icon = "error")
   }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)

  
    #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a Markov chain...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)  an outcome at step t +1 is only dependent on the outcome at step t.",
            "(b)  an outcome at step t +1 is only dependent on the outcome at step t - 1.",
            "(c)  an outcome at step t - 1 is dependent on the outcomes at the previous t - 2 steps.",
            "(d)  an outcome at step t is dependent on the outcomes at the previous t - 1 steps.")
  

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
} 

samp.dist.snap<-function(parent = NULL, parent2 = NULL, biv.parent = NULL, stat = mean,stat2 = NULL, stat3 = NULL, stat4 = NULL, s.size=c(1,3,6,10,20,50), s.size2 = NULL, R=1000, 
func = NULL, xlab = expression(bar(x)),show.SE = TRUE, fits = NULL, show.fits = TRUE, xlim = NULL, ylim = NULL,...){

old.par <- par(no.readonly = TRUE)  
  
if(!is.null(s.size2)&(length(s.size)!=length(s.size2))) stop("length of s.size must equal length of size2")
L <- length(s.size)
if(L>12) {stop("L must be <= 12")} else
if(L==1) {par(mfrow=c(1,1),mar=c(5,4,1,1.5))} else
if(L==2) {par(mfrow=c(2,1),mar=c(5,4,1,1.5))} else
if(L==3) {par(mfrow=c(1,3),mar=c(5,4,1.5))} else
if(L==4) {par(mfrow=c(2,2),mar=c(5,4,1,1.5))} else
if(L==5|L==6) {par(mfrow=c(3,2),mar=c(5,4,2,1.5))} else
if(L==7|L==8|L==9) {par(mfrow=c(3,3),mar=c(5,4,2,1.0))}else
if(L==10|L==11|L==12) {par(mfrow=c(4,3),mar=c(5,4,2,1.0))}
if(L>12)stop("s.size vectors must have length <= 12", call. = FALSE) 
for(i in 1:L){
if(is.null(xlim)&is.null(ylim)){                     
samp.dist(parent = parent, parent2 = parent2, biv.parent = biv.parent, stat = stat, stat2 = stat2, stat3 = stat3, stat4 = stat4, s.size = s.size[i], 
s.size2 = s.size2[i], func = func, R = R, xlab = xlab, show.SE = show.SE, anim = FALSE, ...)}
if(!is.null(xlim)&is.null(ylim)){                     
samp.dist(parent = parent, parent2 = parent2, biv.parent = biv.parent, stat = stat, stat2 = stat2, stat3 = stat3, stat4 = stat4, s.size = s.size[i], 
s.size2 = s.size2[i], func = func, R = R, xlab = xlab, show.SE = show.SE, anim = FALSE, xlim = xlim, ...)}
if(!is.null(xlim)&!is.null(ylim)){                     
samp.dist(parent = parent, parent2 = parent2, biv.parent = biv.parent, stat = stat, stat2 = stat2, stat3 = stat3, stat4 = stat4, s.size = s.size[i], 
s.size2 = s.size2[i], func = func, R = R, xlab = xlab, show.SE = show.SE, anim = FALSE, xlim = xlim, ylim = ylim,...)}
if(show.fits == TRUE){
if(!is.null(fits))fits(s.size[i], s.size2[i])}
}

on.exit(par(old.par))

}

#--------------------------------- Simple stats -------------------------------------#


samp.dist.snap.tck1<-function(statc = "mean"){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }

tclServiceMode(FALSE)              
        dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Sampling distributions")
        biv.parent.entry <- tkentry(tt, textvariable=Biv.parent, width = 16)
        parent.entry1 <- tkentry(tt, textvariable=Parent1, width = 16)
        parent.entry2 <- tkentry(tt, textvariable=Parent2, width = 16)
        s.size.entry<-tkentry(tt, textvariable=SS, width = 16)
        s.size.entry2<-tkentry(tt, textvariable=SS2, width = 16)
        stat.entry1<-tkentry(tt, textvariable=Stat1, width = 16)
        stat.entry2<-tkentry(tt, textvariable=Stat2, width = 16)
        stat.entry3<-tkentry(tt, textvariable=Stat3, width = 16)
        stat.entry4<-tkentry(tt, textvariable=Stat4, width = 16)
        func.entry<-tkentry(tt, textvariable=Func, width = 16)
        R.entry<-tkentry(tt, textvariable=Rep, width = 16)
        x.entry<-tkentry(tt, textvariable=Xlab, width = 16)
        fits.entry <- tkentry(tt, textvariable=fits, width = 16)
        x.lim.entry<-tkentry(tt, textvariable=xlim, width = 16)
        y.lim.entry<-tkentry(tt, textvariable=ylim, width = 16)
        
 
done <- tclVar(0)
show.SE<-tclVar(1)
show.fits <- tclVar(1)
        
        reset <- function()
        {
            tclvalue(Biv.parent)<-"NULL"
            tclvalue(Parent1)<-"NULL"
            tclvalue(Parent2)<-"NULL"
            tclvalue(SS)<-"0"
            tclvalue(SS2)<-"0"
            tclvalue(Stat1)<-"NULL"
            tclvalue(Stat2)<-"NULL"
            tclvalue(Stat3)<-"NULL"
            tclvalue(Stat4)<-"NULL"
            tclvalue(Func)<-"NULL"
            tclvalue(Rep)<-"NULL"
            tclvalue(Xlab)<-"NULL"
            tclvalue(xlim)<-"NULL"
            tclvalue(ylim)<-"NULL"
            tclvalue(fits)<-"NULL"
            }

        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
       
 
tw <- function(){
        tkdestroy(tt)
        samp.dist.snap.tck2(statc = statc)
        }       
               
        add.button <- tkbutton(tt, text="Add 2nd sample",command=tw)
        
        build <- function()
        {
            parent <-parse(text=tclvalue(Parent1))[[1]]
            s.size <-parse(text=tclvalue(SS))[[1]]
            stat <-parse(text=tclvalue(Stat1))[[1]]
            R <-tclvalue(Rep)
            x<-parse(text=tclvalue(Xlab))[[1]]
            R <-tclvalue(Rep)
            se <- as.logical(tclObj(show.SE))
            xlim<-parse(text=tclvalue(xlim))[[1]]
            ylim<-parse(text=tclvalue(ylim))[[1]]
            fits <- parse(text=tclvalue(fits))[[1]]
            show.fits <- as.logical(tclObj(show.fits))
            substitute(samp.dist.snap(parent = parent, s.size = s.size, stat = stat, R = as.numeric(R), xlab = x,show.SE = se, xlim = xlim, ylim = ylim, fits = fits, show.fits = show.fits))
           
             }
        


        se.cbut <- tkcheckbutton(tt, text="Show SE", variable=show.SE)
        fits.cbut <- tkcheckbutton(tt, text="Show fits", variable=show.fits)
        tkgrid(tklabel(tt,text="Sampling distribution snapshots"), columnspan = 2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="Parent",font=c("Helvetica","9","bold"), width = 12),parent.entry1) 
        tkgrid(tklabel(tt,text="Sample sizes ",font=c("Helvetica","9","bold"), width = 12),s.size.entry)
        tkgrid(tklabel(tt,text="Stat",font=c("Helvetica","9","bold"), width = 12),stat.entry1)
        tkgrid(tklabel(tt,text="Iterations", width = 12),  R.entry)
        tkgrid(tklabel(tt,text="X-axis label", width = 12), x.entry)
        tkgrid(tklabel(tt,text="Xlim", width = 12), x.lim.entry)
        tkgrid(tklabel(tt,text="Ylim", width = 12), y.lim.entry)
        tkgrid(tklabel(tt,text=""), columnspan = 2)
        tkgrid(se.cbut, sticky = "w")
        tkgrid(fits.cbut,sticky="w")
        tkgrid(tklabel(tt,text="Fit(s)"), fits.entry, sticky = "w")
        tkgrid(tklabel(tt,text=""), columnspan = 2)
        tkgrid(add.button, columnspan = 2)
        tkgrid(submit.but, reset.but)
        
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)
        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")
        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
        tclServiceMode(TRUE)        
}
     if(statc == "mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(1,3,7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("10000")
      Xlab<- tclVar("expression(bar(x))")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL") 
      }
      
      if(statc == "median"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(1,3,7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("median")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(Median)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL") 
      }

if(statc == "trimmed mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      tr.mean <- function(x)mean(x,trim = 0.2)
      Stat1<-tclVar("tr.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(Trimmed.mean)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")}
          
if(statc == "Winsorized mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      win.mean <- function(x)mean(win(x))
      Stat1<-tclVar("win.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(Winsorized.mean)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")}
          
if(statc == "Huber estimator"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("huber.mu")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(Huber.estimator)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")}
           
if(statc == "H-L estimator"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("HL.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(H-L.estimator)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")}
            
      if(statc == "sd"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(3,7,10,20)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("sd")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(S)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL") 
      }
      
      if(statc == "var"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(3,7,10,20)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("var")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(S^2)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")  
      }
      
if(statc == "MAD"){

      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("mad")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(MAD)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")  
      }
          
if(statc == "IQR"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      SS<-tclVar("c(7,10,20,50)")
      SS2<-tclVar("NULL")
      Stat1<-tclVar("IQR")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Xlab<- tclVar("expression(IQR)")
      ylim <- tclVar("NULL")
      xlim <- tclVar("NULL")
      fits <- tclVar("NULL")  
      }        
             
dialog.sd()
})
}



#-------------------------------- Complex stats -------------------------------------------#



samp.dist.snap.tck2<-function (statc = "mean") 
{
    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE)
        dialog.sd <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "Sampling distributions")
            biv.parent.entry <- tkentry(tt, textvariable = Biv.parent, 
                width = 16)
            parent.entry1 <- tkentry(tt, textvariable = Parent1, 
                width = 16)
            parent.entry2 <- tkentry(tt, textvariable = Parent2, 
                width = 16)
            s.size.entry <- tkentry(tt, textvariable = SS, width = 16)
            s.size.entry2 <- tkentry(tt, textvariable = SS2, 
                width = 16)
            stat.entry1 <- tkentry(tt, textvariable = Stat1, 
                width = 16)
            stat.entry2 <- tkentry(tt, textvariable = Stat2, 
                width = 16)
            stat.entry3 <- tkentry(tt, textvariable = Stat3, 
                width = 16)
            stat.entry4 <- tkentry(tt, textvariable = Stat4, 
                width = 16)
            func.entry <- tkentry(tt, textvariable = Func, width = 16)
            R.entry <- tkentry(tt, textvariable = Rep, width = 16)
            x.entry <- tkentry(tt, textvariable = Xlab, width = 16)
            fits.entry <- tkentry(tt, textvariable = fits, width = 16)
            x.lim.entry <- tkentry(tt, textvariable = xlim, width = 16)
            y.lim.entry <- tkentry(tt, textvariable = ylim, width = 16)
            done <- tclVar(0)
            show.SE <- tclVar(1)
            show.fits <- tclVar(1)
            reset <- function() {
                tclvalue(Biv.parent) <- "NULL"
                tclvalue(Parent1) <- "NULL"
                tclvalue(Parent2) <- "NULL"
                tclvalue(SS) <- "0"
                tclvalue(SS2) <- "0"
                tclvalue(Stat1) <- "NULL"
                tclvalue(Stat2) <- "NULL"
                tclvalue(Stat3) <- "NULL"
                tclvalue(Stat4) <- "NULL"
                tclvalue(Func) <- "NULL"
                tclvalue(Rep) <- "NULL"
                tclvalue(Xlab) <- "NULL"
                tclvalue(xlim) <- "NULL"
                tclvalue(ylim) <- "NULL"
                tclvalue(fits) <- "NULL"
            }
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)
            build <- function() {
                biv.parent <- parse(text = tclvalue(Biv.parent))[[1]]
                parent <- parse(text = tclvalue(Parent1))[[1]]
                parent2 <- parse(text = tclvalue(Parent2))[[1]]
                s.size <- parse(text = tclvalue(SS))[[1]]
                stat <- parse(text = tclvalue(Stat1))[[1]]
                s.size2 <- parse(text = tclvalue(SS2))[[1]]
                stat2 <- parse(text = tclvalue(Stat2))[[1]]
                stat3 <- parse(text = tclvalue(Stat3))[[1]]
                stat4 <- parse(text = tclvalue(Stat4))[[1]]
                R <- tclvalue(Rep)
                x <- parse(text = tclvalue(Xlab))[[1]]
                func <- parse(text = tclvalue(Func))[[1]]
                se <- as.logical(tclObj(show.SE))
                xlim <- parse(text = tclvalue(xlim))[[1]]
                ylim <- parse(text = tclvalue(ylim))[[1]]
                fits <- parse(text = tclvalue(fits))[[1]]
                show.fits <- as.logical(tclObj(show.fits))
                substitute(samp.dist.snap(parent = parent, parent2 = parent2, 
                  biv.parent = biv.parent, s.size = s.size, s.size2 = s.size2, 
                  stat = stat, func = func, stat2 = stat2, stat3 = stat3, 
                  stat4 = stat4, R = as.numeric(R), xlab = x, 
                  show.SE = se, xlim = xlim, ylim = ylim, show.fits = show.fits, 
                  fits = fits))
            }
            se.cbut <- tkcheckbutton(tt, text = "Show SE", variable = show.SE)
            fits.cbut <- tkcheckbutton(tt, text = "Show fits", 
                variable = show.fits)
            tkgrid(tklabel(tt, text = "Sampling distribution snapshots"), 
                columnspan = 4)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "Bivariate parent"), 
                biv.parent.entry)
            tkgrid(tklabel(tt, text = "Parent 1", font = c("Helvetica", 
                "9", "bold")), parent.entry1, tklabel(tt, text = "Parent 2"), 
                parent.entry2)
            tkgrid(tklabel(tt, text = "Sample sizes ", font = c("Helvetica", 
                "9", "bold")), s.size.entry, tklabel(tt, text = "Sample sizes 2"), 
                s.size.entry2)
            tkgrid(tklabel(tt, text = "Stat", font = c("Helvetica", 
                "9", "bold")), stat.entry1, tklabel(tt, text = "Stat 2"), 
                stat.entry2)
            tkgrid(tklabel(tt, text = "Stat 3"), stat.entry3, 
                tklabel(tt, text = "Stat 4"), stat.entry4)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "Iterations"), 
                R.entry)
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "Function"), 
                func.entry)
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "X-axis label"), 
                x.entry)
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "Xlim"), 
                x.lim.entry)
            tkgrid(tklabel(tt, text = ""), tklabel(tt, text = "Ylim"), 
                y.lim.entry)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(se.cbut)
            tkgrid(fits.cbut, tklabel(tt, text = "Fit(s)"), fits.entry)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = ""), submit.but, reset.but)
            tkgrid(tklabel(tt, text = ""))
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
            tclServiceMode(TRUE)
        }
        if (statc == "custom") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("NULL")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("NULL")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("NULL")
            Xlab <- tclVar("NULL")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "mean") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(1,3,7,10,20,50)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("10000")
            Xlab <- tclVar("expression(bar(x))")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "median") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(1,3,7,10,20,50)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("median")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("10000")
            Xlab <- tclVar("expression(Median)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "trimmed mean") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(7,10,20,50)")
            SS2 <- tclVar("NULL")
            tr.mean <- function(x) mean(x, trim = 0.2)
            Stat1 <- tclVar("tr.mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(Trimmed.mean)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "Winsorized mean") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar(("c(7,10,20,50)"))
            SS2 <- tclVar("NULL")
            win.mean <- function(x) mean(win(x))
            Stat1 <- tclVar("win.mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(Winsorized.mean)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "Huberestimator") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar(("c(7,10,20,50)"))
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("huber.mu")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(Huber.estimator)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "H-L estimator") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rexp(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar(("c(7,10,20,50)"))
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("HL.mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(H-L.estimator)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "sd") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,7,10,20)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("sd")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(S)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "var") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,7,10,20)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("var")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(S^2)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "MAD") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar(("c(7,10,20,50)"))
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("mad")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(MAD)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "IQR") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(7,10,20,50)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("IQR")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("NULL")
            Rep <- tclVar("1000")
            Xlab <- tclVar("expression(IQR)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "(n-1)S^2/sigma^2") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,7,10,20)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("var")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("function(s.dist, s.dist2, s.size, s.size2, sigma.sq = 1)((s.size - 1) * s.dist)/sigma.sq")
            Rep <- tclVar("10000")
            Xlab <- tclVar("expression((n - 1)*S^2/sigma^2)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("c(0,40)")
            x <- NULL
            suppressWarnings(rm(x))
            fits <- tclVar("function(s.size, s.size2)curve(dchisq(x, s.size - 1),from = 0, to = 40, add = TRUE, lwd = 2, col = gray(.3))")
        }
        if (statc == "F*") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("expression(rnorm(s.size2))")
            SS <- tclVar("c(5,7,12,20)")
            SS2 <- tclVar("c(7,5,10,15)")
            Stat1 <- tclVar("var")
            Stat2 <- tclVar("var")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("function(s.dist, s.dist2, s.size, s.size2) s.dist/s.dist2")
            Rep <- tclVar("2000")
            Xlab <- tclVar("expression(F.star)")
            ylim <- tclVar("c(0, 0.8)")
            xlim <- tclVar("c(0,20)")
            x <- NULL
            suppressWarnings(rm(x))
            fits <- tclVar("function(s.size, s.size2)curve(df(x, s.size - 1, s.size2 - 1),from = 0, to = 20, add = TRUE, col = gray(.3), lwd = 2)")
        }
        if (statc == "t* (1 sample)") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,7,10,20)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("mean")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("var")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("function(s.dist, s.dist3, s.size, s.size2)s.dist/sqrt(s.dist3/s.size)")
            Rep <- tclVar("10000")
            Xlab <- tclVar("expression(t.star)")
            ylim <- tclVar("c(0, 0.5)")
            xlim <- tclVar("c(-5, 5)")
            x <- NULL
            suppressWarnings(rm(x))
            fits <- tclVar("function(s.size, s.size2)({curve(dnorm(x),from = -10, to = 10, add = TRUE, lty = 2, lwd = 2, col = gray(.3)); curve(dt(x, s.size-1),from = -10,to = 10, add = TRUE, lty = 1, lwd = 2, col = gray(.6))})")
        }
        if (statc == "t* (2 sample)") {
            Biv.parent <- tclVar("NULL")
            Parent1 <- tclVar("expression(rnorm(s.size))")
            Parent2 <- tclVar("expression(rnorm(s.size))")
            SS <- tclVar("c(3,7,10,20)")
            SS2 <- tclVar("c(5,8,10,30)")
            Stat1 <- tclVar("mean")
            Stat2 <- tclVar("mean")
            Stat3 <- tclVar("var")
            Stat4 <- tclVar("var")
            Func <- tclVar("function(s.dist1, s.dist2, s.dist3, s.dist4, s.size = 6, s.size2 = s.size2)({MSE<-(((s.size - 1) * s.dist3) + ((s.size2 - 1) * s.dist4))/((s.size + s.size2) - 2);(s.dist1 - s.dist2)/(sqrt(MSE) * sqrt((1/s.size) + (1/s.size2)))})")
            Rep <- tclVar("10000")
            Xlab <- tclVar("expression(t.star)")
            ylim <- tclVar("c(0, 0.5)")
            xlim <- tclVar("c(-5, 5)")
            x <- NULL
            suppressWarnings(rm(x))
            fits <- tclVar("function(s.size, s.size2)({curve(dnorm(x),from = -10, to = 10, add = TRUE, lty = 2, lwd = 2, col = gray(.3)); curve(dt(x, (s.size + s.size2) - 2),from = -10,to = 10, add = TRUE, lty = 1, lwd = 2, col = gray(.6))})")
        }
        if (statc == "Pearson correlation") {

            Biv.parent <- tclVar("expression(rmvnorm(s.size, c(0,0), sigma = matrix(nrow=2,ncol=2, data =c(1,0,0,1))))")
            Parent1 <- tclVar("NULL")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,5,7,10,20,50)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("NULL")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("cor")
            Rep <- tclVar("2000")
            Xlab <- tclVar("expression(r)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        if (statc == "covariance") {

            Biv.parent <- tclVar("expression(rmvnorm(s.size, c(0,0), sigma = matrix(nrow=2,ncol=2, data =c(1,0,0,1))))")
            Parent1 <- tclVar("NULL")
            Parent2 <- tclVar("NULL")
            SS <- tclVar("c(3,5,7,10,20,50)")
            SS2 <- tclVar("NULL")
            Stat1 <- tclVar("NULL")
            Stat2 <- tclVar("NULL")
            Stat3 <- tclVar("NULL")
            Stat4 <- tclVar("NULL")
            Func <- tclVar("cov")
            Rep <- tclVar("2000")
            Xlab <- tclVar("expression(Covariance)")
            ylim <- tclVar("NULL")
            xlim <- tclVar("NULL")
            fits <- tclVar("NULL")
        }
        dialog.sd()
    })
}

samp.dist.mech <- function(rep, int=.05){
if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
  {dev.new(noRStudioGD = TRUE)} 
old.par <- par(no.readonly = TRUE)

g1 <- NULL; rm(g1)
g1 <- read.pnm(system.file("pictures/goat1.pgm", package="asbio"))

ymx <- 0.5; ymn <- 3
xback <- rnorm(1000,90.5,15); xmx <- max(xback); xmn <- min(xback)

retry <- function(){ 
xback <- rnorm(1000,90.5,15); xmx <- max(xback); xmn <- min(xback)
}

if(xmx > 110|xmn < 75)retry() 
if(xmx > 110|xmn < 75)retry()
                             

m <- (ymx - ymn)/(xmx - xmn)
b <- -m*xmx + ymx
wt1 <- matrix(nrow=10,ncol=rep,data=sample(xback, rep*10, replace=FALSE))
all.wt <- apply(wt1,2,mean)


sub <- function(wt){
layout(matrix(c(1,2,3,4,5,6,7,8,9,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11),5,5, byrow= TRUE))
fit <- b + m * wt[1]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[1],1)),"kg")))
fit <- b + m * wt[2]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[2],1)),"kg")))
fit <- b + m * wt[3]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[3],1)),"kg")))
fit <- b + m * wt[4]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[4],1)),"kg")))
fit <- b + m * wt[5]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[5],1)),"kg")))
fit <- b + m * wt[6]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[6],1)),"kg")))
fit <- b + m * wt[7]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[7],1)),"kg")))
fit <- b + m * wt[8]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[8],1)),"kg")))
fit <- b + m * wt[9]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[9],1)),"kg")))
fit <- b + m * wt[10]; par(mar=rep(fit, 4))
plot(g1); mtext(side=1,line= .8,bquote(paste(.(round(wt[10],1)),"kg")))
}



for(i in 1:rep){
dev.hold()
sub(wt1[,i])
mtext(side = 3, outer=TRUE,"", line = -26, cex = 1.3)
Sys.sleep(int*2)
mtext(side = 3, outer=TRUE,bquote(paste(italic(bar(x))[.(i)], " = ", .(round(all.wt[i],1)))), line = -24, cex = 1.3)

par(mar=c(6,5.5,5,1))
hist(all.wt[1:i], main = "", breaks = c(75,77.5,80,82.5,85,87.5,90,92.5,95,97.5,100,102.5,105,107.5,110), cex.lab=1.8, cex.axis=1.5, xlab = "", ylab = "", ylim=c(0,32))
arrows(all.wt[i], 35, all.wt[i], 28, length = 0.25, lwd = 10, col="black", angle= 30)
mtext(side=1, expression(italic(bar(x))), cex=1.3, line = 4)
mtext(side=2, "Cumulative freq.", cex = 1.3, line = 4)
dev.flush()
Sys.sleep(int)
}
on.exit(par(old.par))
}

tukey.add.test<-function(y,A,B){
dname<-paste(deparse(substitute(A)), "and",deparse(substitute(B)), "on ",deparse(substitute(y)))
A<-factor(A);B<-factor(B)
ybar..<-mean(y)
ybari.<-tapply(y,A,mean)
ybar.j<-tapply(y,B,mean)
len.means<-c(length(levels(A)),length(levels(B)))
SSAB<-sum(rep(ybari.-ybar..,len.means[2])*rep(ybar.j-ybar.., rep(len.means[1],len.means[2]))*tapply(y,interaction(A,B),mean))^2/(sum((ybari.-ybar..)^2)*sum((ybar.j-ybar..)^2))
aovm<-anova(lm(y~A+B))
SSrem<-aovm[3,2]-SSAB
dfdenom<-aovm[3,1]-1
STATISTIC<-SSAB/SSrem*dfdenom
names(STATISTIC)<- "F"
DEGREES.OF.FREEDOM<-c(1,dfdenom)
names(DEGREES.OF.FREEDOM)<-c("num.df","denom.df")
D<-sqrt(SSAB/(sum((ybari.-ybar..)^2)*sum((ybar.j-ybar..)^2)))
names(D)="D"
RVAL<-list(statistic=STATISTIC,df=DEGREES.OF.FREEDOM,p.value=1-pf(STATISTIC,1,dfdenom),head="Tukey's one df test for additivity",data.name=dname)
attr(RVAL, "class")<-"addtest"
RVAL
}

print.addtest <- function(x, digits= max(3, getOption("digits")),...){
cat("\n")
cat(x$head,"\n")
p <- paste("F =", round(x$statistic[1], digits), " ", "Denom df =", x$df[2], "  ", "p-value =", round(x$p.value[1], digits))
cat(p)
cat("\n")
invisible(x)
}

selftest.regapproaches.tck1 <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Regression approaches")
  size(w) <- c(700, 450)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  # q1 <- gexpandgroup("Question 1", container=g, anchor=c(-1,1))
  # q2 <- gexpandgroup("Question 2", container=g, anchor=c(-1,1))
  # q3 <- gexpandgroup("Question 3", container=g, anchor=c(-1,1))
  # q4 <- gexpandgroup("Question 4", container=g, anchor=c(-1,1))
  # q5 <- gexpandgroup("Question 5", container=g, anchor=c(-1,1))
  # q6 <- gexpandgroup("Question 6", container=g, anchor=c(-1,1))
  # q7 <- gexpandgroup("Question 7", container=g, anchor=c(-1,1))
  
  
  #visible(q2) <- FALSE
  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  
  qq <- glabel("We use model II regression...", container = gp1.1, horizontal = TRUE)
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp1, .5, horizontal=FALSE)
  
  ans1 <- c("(a) to address outliers in linear regression.",
            "(b) to address curvilinear associations within the context of a linear model.",
            "(c) to address heteroscedasticity in a general linear model.",
            "(d) to address cases in which levels in X are not fixed, or are measured with error.",
            "(e) to address non-quantitative, discrete, and/or strictly bounded response variables."
  )
  
 
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg ="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)  

  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use weighted least squares...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans2 <- c("(a) to address outliers in linear regression.",
            "(b) to address curvilinear associations within the context of a linear model.",
            "(c) to address heteroscedasticity in a general linear model.",
            "(d) to address cases in which levels in X are not fixed, or are measured with error.",
            "(e) to address non-quantitative, discrete, and/or strictly bounded response variables."
  )
  
 
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use polynomial regression...",
               container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    #addSpace(gp3, .5, horizontal=FALSE)
  ans3 <- c("(a) to address outliers in linear regression.",
            "(b) to address curvilinear associations within the context of a linear model.",
            "(c) to address heteroscedasticity in a general linear model.",
            "(d) to address cases in which levels in X are not fixed, or are measured with error.",
            "(e) to address non-quantitative, discrete, and/or strictly bounded response variables."
  )
 
  
  
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  #------------- Question 4 -----------#
  
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We can use the framework of GLMs...",
               container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  #addSpace(gp4, .5, horizontal=FALSE)
  ans4 <- c("(a) to address outliers in linear regression.",
            "(b) to address curvilinear associations within the context of a linear model.",
            "(c) to address heteroscedasticity in a general linear model.",
            "(d) to address cases in which levels in X are not fixed, or are measured with error.",
            "(e) to address non-quantitative, discrete, and/or strictly bounded response variables."
  )
  
  
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Correct")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
  #------------- Question 5 -----------#
  
  
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We use robust regression approaches, i.e., M-estimation, S-estimation, etc.", container = gp5.1, anchor = c(-1,1))
  
  font(qq) <- list(family = "cambria", size = 11)
  
  #addSpace(gp5, .5, horizontal=FALSE)
  ans5 <- c("(a) to address outliers in linear regression.",
            "(b) to address curvilinear associations within the context of a linear model.",
            "(c) to address heteroscedasticity in a general linear model.",
            "(d) to address cases in which levels in X are not fixed, or are measured with error.",
            "(e) to address non-quantitative, discrete, and/or strictly bounded response variables."
  )
  
 
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We would use a generalized additive model (GAM)...",
               container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  #addSpace(gp6, .5, horizontal=FALSE)
  ans6 <- c("(a)  to fit data based on local, not global, models ",
            "(b)  to fit a model using smoother algorithms without a priori assumptions of model linearity or nonlinearity",
            "(c)  to incorporate appropriate, potentially non-normal, error structures.",
            "(d)  All of the above.",
            "(e)  (a) and (b) above.")
  
  f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[5]){
      gmessage(msg="Partially correct. The answer (c) is also true.",  icon = "error")
    }
    svalue(r6) <- character(0)
  }
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
  
  
  #------------- Question 7 -----------#
  
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which of the following is a (are) nonlinear models(s), appropriate for fitting with the R function nls?",
               container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
   #addSpace(gp7, .5, horizontal=FALSE)
  ans7 <- c("(a)  Y\u1d62 = \u03b2\u2092 + \u03b2\u2081X\u2081\u1d62 + \u03b2\u2082X\u2082\u1d62 + \u03b5\u1d62 ",
            "(b)  Y\u1d62 = \u03b2\u2092 + \u03b2\u2081X\u2081\u1d62 + \u03b2\u2082X\u00b2\u2081\u1d62 + \u03b5\u1d62 ",
            "(c)  Y\u1d62 = \u03b2\u2092X\u1d62/(\u03b2\u2081 + X\u1d62) + \u03b5\u1d62",
            "(d)  All of the above.",
            "(e)  (b) and (c) above.")
  

  
  
  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r7) <- character(0)
  }
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)  
}

see.hyper.tck<-function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    n <- 1
    M <- 1
    N <- 20
    assign("n", tclVar(n), envir = slider.env)
    assign("M", tclVar(M), envir = slider.env)
    assign("N", tclVar(N), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        M <- as.numeric(evalq(tclvalue(M), envir= slider.env))
        N <- as.numeric(evalq(tclvalue(N), envir= slider.env))
        xx <- seq(0, n, length = n+1)
        yy <- dhyper(xx,M,N-M,n)
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        mtext(bquote(paste(italic(X), " ~ ", italic(HYP), "(", .(n), ", ", .(M),", ", .(N),")", sep = "")), line = 1, side = 3)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
   tkwm.title(m, "HYP(n, M, n)")
    tkpack(tklabel(m,text="      Visualizing the Hypergeometric Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = n), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "M", font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = M), envir= slider.env)

tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "N", font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 20,
        to = 40, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = N), envir= slider.env)
    norm.refresh()
}


see.hypercdf.tck<-function ()
{
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    n <- 1
    M <- 1
    N <- 20
    assign("n", tclVar(n), envir= slider.env)
    assign("M", tclVar(M), envir= slider.env)
    assign("N", tclVar(N), envir= slider.env)
    dev.new(height=4,width=8,noRStudioGD = TRUE);par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
   norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir= slider.env))
        M <- as.numeric(evalq(tclvalue(M), envir= slider.env))
        N <- as.numeric(evalq(tclvalue(N), envir= slider.env))
        xx <- seq(0, n, length = n+1)
        yy <- dhyper(xx,M,N-M,n)
        y1 <- phyper(xx,M,N-M,n)
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        plot(xx, y1, type = "n", xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        points(xx, y1, pch =19)
        segments(xx, y1,xx+1,y1)
        points(xx+1, y1, pch =1)
        mtext(bquote(paste(italic(X), " ~ ", italic(HYP), "(", .(n), ", ", .(M),", ", .(N),")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "HYP(n, M, n)")
    tkpack(tklabel(m,text="      Visualizing the Hypergeometric Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = n), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "M", font=c("Helvetica","9","italic"),width = "20"),
        side = "right")

    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = M), envir= slider.env)

tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "N", font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 20,
        to = 40, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = N), envir= slider.env)
#    on.exit(par(old.par))
    norm.refresh()
}

see.exppower.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    m <- 1
    assign("m", tclVar(m), envir = slider.env)
    xmin <- -3
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 3
    assign("xmax", tclVar(xmax), envir = slider.env)

    exppower<-function(x,m){exp(-abs(x)^m)}

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        m <- as.numeric(evalq(tclvalue(m), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 200)
        yy <- exppower(as.numeric(xx), m)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        dev.flush()
                }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing Exponential Power Distributions")
    tkwm.geometry(m, "+0+0")
    tkpack(tklabel(m,text="      Visualizing Exponential Power Distributions      "))
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "f(x) =", font=c("Helvetica","9","italic")), side = "left")
    tkpack(tklabel(fr, text = "exp(", font=c("Helvetica","9","normal")),side="left")
    tkpack(tklabel(fr, text ='-|x| \u036b', font=c("Helvetica","9","italic")), side = "left", anchor ="w")
    tkpack(tklabel(fr, text = " )  ", font=c("Helvetica","9","normal")),side="left", anchor ="w")
    tkpack(tklabel(m,text=""), side = "top")
    tkpack(fr1 <- tkframe(m), side = "top")
    tkpack(tklabel(fr1, text = "m  ", font=c("Helvetica","10","italic")),side="left", anchor = "s")
    tkpack(sc <- tkscale(fr1, command = norm.refresh, from = -10,
        to = 10, orient = "horiz", resolution = .1, showvalue = TRUE),
        side = "left", anchor="n")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = m), envir = slider.env)

    tkpack(tklabel(m,text=""), side = "top")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tklabel(m,text=""), side = "top")
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")

    norm.refresh()
 }

chi.plot<-function(Y1, Y2, ...){
###################
if(length(Y1) != length(Y2)) stop("Y1 and Y2 must have equal length")
n <- length(Y1)
o1 <- outer(Y1, Y1, "-")
o2 <- outer(Y2, Y2, "-")
diag(o1) <- NA
diag(o2) <- NA
t1 <- o1 > 0
t2 <- o2 > 0
t3 <- t1 & t2

#####################
H <- apply(t3, 1, function(x){sum(x, na.rm = TRUE)})/(n - 1)
Z <- apply(t1, 1, function(x){sum(x, na.rm = TRUE)})/(n - 1)
G <- apply(t2, 1, function(x){sum(x, na.rm = TRUE)})/(n - 1)
S <- sign((Z - 0.5)*(G - 0.5))
chi <- (H - Z * G)/sqrt(Z * (1 - Z) * G * (1 - G))
lambda <- 4 * S * pmax((Z - 0.5)^2, (G - 0.5)^2)
thresh <- 4 * (1/(n - 1) - 0.5)^2

####################### 
plot(lambda[abs(lambda)<thresh], chi[abs(lambda)<thresh], ylim = c(-1,1),
xlab = expression(lambda), ylab = expression(chi), ...)
abline(h = 1.78/sqrt(n), lty = 2)
abline(h = -1.78/sqrt(n), lty = 2)
invisible(cbind(lambda = lambda, chi = chi))
}

see.pois.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    lambda <- 5
    assign("lambda", tclVar(lambda), envir  = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir  = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir  = slider.env)

    show.norm<-tclVar(0)
      prefunc<-function(xx,yy,vy,muy,xmin,xmax,lambda,show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "h", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        x <- NULL; rm(x); # Dummy to trick R CMD check
        if(show.norm==TRUE) curve(dnorm(x,muy,vy),0,xmax, col =2,add=TRUE)
        mtext(bquote(paste(italic(X), " ~ ", italic(POI), "(", .(lambda), ")", sep = "")), line = 1, side = 3)
        dev.flush()
      }

      if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

        norm.refresh <- function(...) {
        lambda <- as.numeric(evalq(tclvalue(lambda), envir  = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir  = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir  = slider.env))
        xx <- seq(xmin, xmax, length = (xmax-xmin)+1)
        yy <- dpois(xx, lambda)
        show.norm <- as.logical(tclObj(show.norm))
        vy<-sqrt(lambda)
        muy<-lambda
        prefunc(xx,yy,vy,muy,xmin,xmax,lambda=lambda,show.norm=show.norm)
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "POI(\u03bb)")
    tkpack(tklabel(m,text="      Visualizing the Poisson Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bb', font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 10, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir  = slider.env)
    evalq(tkconfigure(sc, variable = lambda), envir  = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir  = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir  = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir  = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir  = slider.env)
    tkpack(fr,tkcheckbutton(m, text="Show normal approx.",variable=show.norm),anchor="w")
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}


see.poiscdf.tck<-function ()
{
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    lambda <- 5
    assign("lambda", tclVar(lambda), envir  = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir  = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir  = slider.env)

   show.norm<-tclVar(0)
   dev.new(height=4,width=8,noRStudioGD = TRUE);par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
   prefunc<-function(xx,yy,vy,muy,y1,xmin, xmax,lambda, show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "h", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        x <- NULL; rm(x); # Dummy to trick R CMD check
        if(show.norm==TRUE) curve(dnorm(x,muy,vy),0,xmax, col =2,add=TRUE)
        plot(xx, y1, type = "n", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        segments(xx, y1, xx+1, y1, pch=19)
        points(xx,y1,pch=19)
        points(xx+1,y1,pch=1)
        if(show.norm==TRUE) curve(pnorm(x,muy,vy),0,xmax, col =2,add=TRUE)
        mtext(bquote(paste(italic(X), " ~ ", italic(POI), "(", .(lambda), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
                  }


   norm.refresh <- function(...) {
        lambda <- as.numeric(evalq(tclvalue(lambda), envir  = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir  = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir  = slider.env))
        xx <- seq(xmin, xmax, length = (xmax-xmin)+1)
        yy <- dpois(xx, lambda)
        y1<- ppois(xx, lambda)
        show.norm <- as.logical(tclObj(show.norm))
        vy<-sqrt(lambda)
        muy<-lambda
        prefunc(xx,yy,vy,muy,y1,xmin,xmax,lambda,show.norm=show.norm)
                            }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "POI(\u03bb)")
    tkpack(tklabel(m,text="      Visualizing the Poisson Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bb', font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 10, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir  = slider.env)
    evalq(tkconfigure(sc, variable = lambda), envir  = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir  = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir  = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir  = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir  = slider.env)
    tkpack(fr,tkcheckbutton(m, text="Show normal approx.",variable=show.norm),anchor="w")
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
  #  on.exit(par(old.par))
    }

see.smooth.tck <- function(){

#old.par <- par(no.readonly = TRUE)

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)
plot_lines <- function(x, y, xlab, ylab, degree, span, kernel, bandwidth, nknots, spar){
    dev.hold()
    par(cex=1.2)
    plot(x, y, xlab=xlab, ylab=ylab)
    legend("topleft", lty = c(1,2,3), lwd = 2, legend = c("lowess", "kernel", "spline"), bty = "n")
    ##################
    o <- order(x)
    lines(x[o],fitted(loess(y[o] ~ x[o], degree = degree, span = span)[o]), lty = 1, lwd = 2)

    ##################
    lines(ksmooth(x, y, kernel = kernel, bandwidth = bandwidth), lty = 2, lwd = 2)

    ##################
    lines(smooth.spline(x, y, cv = NA, nknots = nknots, spar = spar, keep.data = FALSE), lty = 3, lwd = 2)
    dev.flush()
    }


dialog.ci <- function(){
    grDevices::devAskNewPage(FALSE)
    tclServiceMode(FALSE)
    base <- tktoplevel()
    tkwm.title(base, "Smoothers")

    spec.frm <- tkframe(base, borderwidth=2)
    left.frm <- tkframe(spec.frm)

    X.entry <- tkentry(spec.frm, textvariable = X, width = 15)
    Y.entry <- tkentry(spec.frm, textvariable = Y, width = 15)
    Xlab.entry <- tkentry(spec.frm, textvariable = Xlab, width = 15)
    Ylab.entry <- tkentry(spec.frm, textvariable = Ylab, width = 15)

    degree <- tclVar(1)
    span <- tclVar(0.5)
    kernel<- tclVar("normal")
    bw    <- tclVar(5)
    spar <- tclVar(0.5)
    knots <- tclVar(8)

    replot <- function(...) {
    X <- parse(text = tclvalue(X))[[1]];X <- eval(X)
    Y <- parse(text = tclvalue(Y))[[1]];Y <- eval(Y)
    Xlab <- tclvalue(Xlab)
    Ylab <- tclvalue(Ylab)
    degree <- as.numeric(tclvalue(degree)); degree <- as.numeric(degree)
    span <- tclvalue(span); span <- as.numeric(span)

    kernel <- tclvalue(kernel)
    bandwidth <- tclvalue(bw); bandwidth <- as.numeric(bandwidth)
    spar <- tclvalue(spar); spar <- as.numeric(spar)
    knots <- tclvalue(knots); nknots <-as.numeric(knots)
    plot_lines(x = X, y = Y, xlab = Xlab, ylab = Ylab, degree = degree, span=span, kernel=kernel, bandwidth=bandwidth, nknots = nknots, spar=spar)

}

    replot()

    ## Three left frames:
    #LOWESS
    frame1 <-tkframe(left.frm, relief="groove", borderwidth=2)
    tkpack(tklabel(frame1, text="LOWESS"))
    tkpack(tklabel(frame1, text="Degree"))
    for ( i in c(1,2) ) {
        tmp <- tkradiobutton(frame1, command=replot,
                             text=i,value=i,variable = degree)
                                     tkpack(tmp, anchor="w")
                                        }
    tkpack(tklabel (frame1, text="Span"))
    tkpack(tkscale(frame1, command = replot, from = 0.1, to = 1.0,
                   showvalue = TRUE, variable = span,
                   resolution=0.05, orient="horiz"))


    #Kernel
    frame2 <- tkframe(left.frm, relief="groove", borderwidth=2)
    tkpack(tklabel(frame2, text="Kernel smoother"))
    tkpack(tklabel(frame2, text="Kernel"))
    for (i in c("normal", "box")) {
        tmp <- tkradiobutton(frame2, command=replot,
                             text=i, value=i, variable=kernel)
        tkpack(tmp, anchor="w")
    }
    tkpack(tklabel (frame2, text="Bandwidth"))
    tkpack(tkscale(frame2, command=replot, from = 0.5, to = 500,
                   showvalue = TRUE, variable=bw,
                   resolution=0.5, orient="horiz"))


    #spline
    frame3 <-tkframe(left.frm, relief="groove", borderwidth=2)
    tkpack(tklabel(frame3, text="Spline"))

    tkpack(tklabel (frame3, text="Knots"))
    tkpack(tkscale(frame3, command = replot, from = 1, to = 28,
                   showvalue = TRUE, variable = knots,
                   resolution=1, orient="horiz"))
    tkpack(tklabel (frame3, text="Smoothing parameter"))
    tkpack(tkscale(frame3, command = replot, from = 0.01, to = 1.0,
                   showvalue = TRUE, variable = spar,
                   resolution=0.05, orient="horiz"))

#######################################################################

    tkpack(tklabel(spec.frm, text = "X"), X.entry, anchor = "w", fill = "x")
    tkpack(tklabel(spec.frm, text = "Y"), Y.entry, anchor = "w", fill = "x")
    tkpack(tklabel(spec.frm, text = "X-axis label"), Xlab.entry, anchor = "w", fill = "x")
    tkpack(tklabel(spec.frm, text = "Y-axis label"), Ylab.entry, anchor = "w", fill = "x")
    tkpack(tklabel(spec.frm, text = ""))


    tkpack(frame1, frame2, frame3)
    tkpack(left.frm, side = "left", anchor = "n")
    q.but <- tkbutton(base, text = " Exit", command=function() tkdestroy(base))


    tkpack(spec.frm, q.but)
    tclServiceMode(TRUE)
}

        X <- tclVar("c(7.1, 4.0, 5.3, 4.5, 4.1, 3.1, 9.0, 5.6, 3.7, 5.8, 9.5, 9.3, 5.7, 3.0, 4.9, 0.8, 5.9, 3.1, 8.3, 8.6, 2.7, 8.2, 5.2, 1.0, 3.8, 9.6, 5, 1.6, 3.6, 2.5)")
        Y <- tclVar("X + X^2 + X^3")
        Xlab <- tclVar("X")
        Ylab <- tclVar("Y")
        Xl <- parse(text = tclvalue(X))[[1]]; n <- length(Xl)
        dialog.ci()

})
#on.exit(par(old.par))
}

alpha.div<-function(x,index){
if(index=="simp")alpha<-Simp.index(x)
if(index=="inv.simp")alpha<-Simp.index(x,inv=TRUE)
if(index=="shan")alpha<-SW.index(x)
alpha
}

Simp.index<-function(x,inv=FALSE){
if(ncol(as.matrix(x))==1){
p.i<-x/sum(x)
D<-1-sum(p.i^2)}
if(ncol(as.matrix(x))>1){
p.i<-apply(x,1,function(x){x/sum(x)})
if(inv==FALSE)D<-1-apply(p.i^2,2,sum)
if(inv==TRUE)D<-1/apply(p.i^2,2,sum)
}
D
}

SW.index<-function(x){
if(ncol(as.matrix(x))==1){
p.i<-x/sum(x)
p.i.new<-p.i[p.i!=0]
h.prime<--1*sum(log(p.i.new)*p.i.new)}
if(ncol(as.matrix(x))>1){
p.i<-apply(x,1,function(x){x/sum(x)})
h<-apply(p.i,1,function(x){log(x)*x})
h.prime<- -1*apply(h,1,function(x){sum(x[!is.na(x)])})}
h.prime
}

anm.cont.pdf<-function(part ="norm",interval=.3){
if(part == "norm") p = rnorm(1000000)
if(part == "t") p = rt(1000000,df=10)
if(part == "exp") p = rexp(1000000)
if(part == "unif") p = runif(1000000, 0, 1)

if(part == "norm") {xlim=c(-6,6);ylim=c(0,0.5)}
if(part == "t") {xlim=c(-15,15);ylim=c(0,0.4)}
if(part =="exp") {xlim=c(0,20);ylim=c(0,0.9)}
if(part =="unif") {xlim=c(0,1);ylim=c(0,1.2)}

if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
{dev.new(noRStudioGD = TRUE)}

for(i in 1:20){
hist(p,breaks=seq(xlim[1],xlim[2],by=1/i),freq=F, ylim = ylim, xlim = xlim, main = "", xlab=expression(italic(x)), ylab="Density")
dev.flush()
Sys.sleep(interval)
}
if(part=="norm")
x <- NULL; rm(x); # Dummy to trick R CMD check
curve(if(part=="norm")dnorm(x)
else if(part=="t") dt(x, df = 10)
else if(part=="exp") dexp(x)
else if(part=="unif") dunif(x)
,xlim[1],xlim[2],ylim=ylim, xlab="",yaxt="n",bty="n",col=1,lwd=ifelse(part == "t", 3, 7), add=TRUE)
}



see.pdf.conc.tck<-function(){

see.pdf.conc<-function(pdf,show.cdf=TRUE){
if(pdf=="t")anm.cont.pdf("t")
if(pdf=="norm")anm.cont.pdf("norm")
if(pdf=="exp")anm.cont.pdf("exp")
if(pdf=="unif")anm.cont.pdf("unif")
}


tclRequire("BWidget")
local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Conceptualization of continuous pdfs")
        Pdf<-tclVar("normal")
        done <- tclVar(0)



    reset <- function()
        {
            tclvalue(Pdf)<-"normal"
        }

        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
        tkgrid(tklabel(tt,text="Conceptualize pdfs"),columnspan=2)
        tkgrid(tklabel(tt,text=""),columnspan=2)
        tkgrid(tklabel(tt, text="pdf"))
        pdfs<- c("exponential","normal","t","uniform")
            comboBox <- tkwidget(tt,"ComboBox", editable=FALSE, values=pdfs, textvariable = Pdf, width = 17)



        build<-function(){
        pdf<-tclvalue(Pdf)
        if(pdf =="exponential")dist = "exp"
        if(pdf == "normal") dist = "norm"
        if(pdf == "t") dist = "t"
        if(pdf == "uniform") dist = "unif"
        substitute(see.pdf.conc(dist))
        }


        tkgrid(comboBox,columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="w")


        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    }
      Pdf<- tclVar("normal")
      dialog.sd()
})
}

MC.test <- function (Y, X, perm = 1000, alternative = "not.equal", paired = FALSE, print = TRUE) 
{
    
    X <- factor(X)
    levelsX <- levels(X)
    if(length(levelsX) != 2) stop("Number of levels in X must = 2")
    if((paired) & (summary(X)[1] != summary(X)[2])) stop("In paired tests, no. obs. in levels must be equal")   
    
    init <- function(Y, X, random = FALSE){
        if(random){ Y <- sample(Y, replace = FALSE)}
        namesY <- paste("Y", levelsX, sep = ".")
        dat <- list(X1 = Y[X == levelsX[1]], X2 = Y[X == levelsX[2]])
        names(dat) <- namesY
        dat
    }
    
data.i <- init(X = X, Y = Y)
 
initial <- t.test(data.i[[1]], data.i[[2]], var.equal = FALSE, paired = paired)$statistic
       
perm.results <- matrix(ncol = 1, nrow = perm)
    
for (i in 1:perm) {
    data.r <- init(Y = Y, X = X, random = TRUE)
        perm.results[i] <- t.test(data.r[[1]], data.r[[2]], var.equal = FALSE, paired = paired)$statistic
}

    if (alternative == "less") {
        num <- length(perm.results[perm.results <= initial]) + 
            1
    }
    if (alternative == "greater") {
        num <- length(perm.results[perm.results >= initial]) + 
            1
    }
    if (alternative == "not.equal") {
        pos.init <- abs(initial)
        num <- length(perm.results[perm.results >= pos.init]) + length(perm.results[perm.results <= -pos.init]) +
            1
    }
    p.value <- num/perm
    num <- num - 1
    
    head <- paste("Monte Carlo t-test \n\nPaired = ", as.character(paired), ", No. perms = ", as.character(perm), "\nAlternative: ", as.character(levelsX[1]), " ", as.character(alternative), " ",  as.character(levelsX[2]), sep = "")  

    ends <- c("Obs. test stat", "  Perms > test stat", "P-val")
    res <- list(results = c(initial, num, p.value), ends = ends, 
                head = head)
 
out <-  function (x, digits = max(3, getOption("digits")), ...) {
        cat("\n")
        cat(x$head, "\n\n")
        rq <- structure(x$results, names = x$ends)
        print(rq, digits = digits)
        cat("\n")
        invisible(x)
}

if(print) out(res)
else structure(res$results, names = res$ends)      
}

see.exp.tck<-function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    theta <- 1
    beta <- 0
    assign("theta", tclVar(theta), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 6
    assign("xmax", tclVar(xmax), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        dev.hold()
        theta <- as.numeric(evalq(tclvalue(theta), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dexp(xx, theta)
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(EXP), "(", .(theta), ")", sep = "")), line = 1, side = 3)
        dev.flush()
        }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "EXP(\u03b8)")
    tkpack(tklabel(m,text="      Visualizing the Exponential Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b8', font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 2.9, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = theta), envir = slider.env)


    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

see.expcdf.tck<-function (){
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    theta <- 1
    assign("theta", tclVar(theta), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 6
    assign("xmax", tclVar(xmax), envir = slider.env)
   dev.new(height=4,width=8,noRStudioGD = TRUE)
   par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
   norm.refresh <- function(...) {
        dev.hold()
        theta <- as.numeric(evalq(tclvalue(theta), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dexp(xx, theta)
        y1 <- pexp(xx, theta)
        plot(xx, yy, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        plot(xx, y1, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(EXP), "(", .(theta), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
 }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "EXP(\u03b8)")
    tkpack(tklabel(m,text="      Visualizing the Exponential Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b8', font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 2.9, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = theta), envir = slider.env)


    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
norm.refresh()
 #   on.exit(par(old.par))
  }

ConDis.matrix<-function(Y1,Y2){
n<-length(Y1)
m<-as.data.frame(matrix(nrow=n,ncol=n,dimnames=list(seq(1,n), seq(1,n))))
for(i in 1:n){
for(j in 1:n){
m[j,i]<-ifelse((Y1[i]>Y1[j]&Y2[i]>Y2[j])|(Y1[i]<Y1[j]&Y2[i]<Y2[j]),1,
ifelse((Y1[i]<Y1[j]&Y2[i]>Y2[j])|(Y1[i]>Y1[j]&Y2[i]<Y2[j]),-1,0))
}}
m[upper.tri(m,diag=TRUE)]<-NA
m
}

ci.prat.ak <- function(y1, n1 , pi2 = NULL, method = "ac", conf = .95, bonf = FALSE, bootCI.method = "perc", R = 1000, sigma.t = NULL, r = length(y1), gamma.hyper = 1, beta.hyper = 1){

rnm <- data.frame(CImethod = c("norm", "basic", "perc", "BCa", "student"),
row = 1:5, new = c("normal","basic","percentile", "BCa","studentized"))
rn  <- rnm[,2][rnm[,1] == bootCI.method]
name <- matrix(rnm[,3])[rn]

indices <- c("ac", "bayes", "boot", "wald", "fixed-log", "noether-fixed")
    method <- match.arg(method, indices)

   if (length(y1) != length(n1)) stop("y1 and n1 must have equal length")
   if(any(n1 - y1 < 0)) stop("n1 cannot be less than y1")
   
alpha <- 1 - conf
oconf <- conf
conf <- ifelse(bonf == FALSE, conf, 1 - alpha/r)
z.star <- qnorm(1 - (1 - conf)/2)

ci.prat.ak1 <- function(y1, n1, pi2 = NULL, method = "ac", conf = .95, bonf = FALSE, sigma.t = sigma.t, bootCI.method = "perc", R = 1000){

#--------------- Bootstrap ---------------#

if(method == "boot"){
  pih1 <- y1/n1
  rat <- pih1/pi2
  if((y1 == 0 & pi2 == 0)|(y1 == 0 & pi2 != 0)|(y1 != 0 & pi2 == 0)|(y1 == n1)){
      if(y1 == 0 & pi2 == 0) {CIL <- 0;  CIU <- Inf; rat = 0; varhat = NA}
      if(y1 == 0 & pi2 != 0){
        if(pi2 == 1)stop("pi2 = 1 but y1 = 0?")    
        if(pi2 != 1){
          CIL <- 0
          yn1 <- 0.5
          pihn1 <- yn1/n1
          nrat <- (yn1/n1)/pi2
        varhat <- (pihn1 * (1 - pihn1))/(n1 * pi2^2)
        CIU <- nrat + (z.star * sqrt(varhat))
        }
      }
      if(pi2 == 0 & y1 != 0)stop("pi2 = 0 but y1 != 0?") 
      if(pi2 != 0 & y1 == n1){
        if(pi2 == 1){
          varhat <- 0
          CIL <- 1
          CIU <- 1
        }
        if(pi2 != 1){
          yn1 <- n1 - 0.5
          pihn1 <- yn1/n1
          nrat <- pihn1/pi2
          varhat <- (pihn1 * (1 - pihn1))/(n1 * pi2^2)
          CIL <- nrat - (z.star * sqrt(varhat))
          CIU <- nrat + (z.star * sqrt(varhat))
         }
       } 
    } 
  else{
    num.data <- c(rep(1, y1), rep(0, (n1 - y1)))
    brat <- function(x){(sum(x)/n1)/pi2}
    b <- bootstrap(num.data, brat, R = R)
    c <- ci.boot(b, method = bootCI.method, sigma.t = sigma.t, conf = conf)$res[rn,]
    CIU <- c[2]
    CIL <- c[1]
    varhat <- b$res[4]
  }
  CI <- c(rat, CIL, CIU)
}

#--------------- Manly/Wald ---------------#

if(method == "wald"){
  pih1 <- y1/n1
  rat <- pih1/pi2
  if((y1 == 0 & pi2 == 0)|(y1 == 0 & pi2 != 0)|(y1 != 0 & pi2 == 0)|(y1 == n1)){
    if(y1 == 0 & pi2 == 0) {CIL <- 0;  CIU <- Inf; rat = 0; varhat = NA}
    if(y1 == 0 & pi2 != 0){
      if(pi2 == 1)stop("pi2 = 1 but y1 = 0?")    
      if(pi2 != 1){
        CIL <- 0
        yn1 <- 0.5
        pihn1 <- yn1/n1
        nrat <- (yn1/n1)/pi2
      varhat <- (pihn1 * (1 - pihn1))/(n1 * pi2^2)
      CIU <- nrat + (z.star * sqrt(varhat))
      }
    }
    if(pi2 == 0 & y1 != 0)stop("pi2 = 0 but y1 != 0?") 
    if(pi2 != 0 & y1 == n1){
      if(pi2 == 1){
        varhat <- 0
        CIL <- 1
        CIU <- 1
      }
      if(pi2 != 1){
        yn1 <- n1 - 0.5
        pihn1 <- yn1/n1
        nrat <- pihn1/pi2
        varhat <- (pihn1 * (1 - pihn1))/(n1 * pi2^2)
        CIL <- nrat - (z.star * sqrt(varhat))
        CIU <- nrat + (z.star * sqrt(varhat))
       }
     } 
  }
  else{
  varhat <- (pih1 * (1 - pih1))/(n1 * pi2^2)
CIL <- rat - (z.star*sqrt(varhat))
CIU <- rat + (z.star*sqrt(varhat))
}
CIL <- ifelse(CIL < 0, 0, CIL)
CI <- c(rat, CIL, CIU)
}

#-------------------noether-fixed----------------#

if(method == "noether-fixed"){
  pih1 <- y1/n1
  rat <- pih1/pi2
  if((y1 == 0 & pi2 == 0)|(y1 == 0 & pi2 != 0)|(y1 != 0 & pi2 == 0)|(y1 == n1)){
    if(y1 == 0 & pi2 == 0) {CIL <- 0;  CIU <- Inf; rat = 0; varhat = NA}
    if(y1 == 0 & pi2 != 0){
      if(pi2 == 1)stop("pi2 = 1 but y1 = 0?")    
      if(pi2 != 1){
        CIL <- 0
        yn1 <- 0.5
        pihn1 <- yn1/n1
        nrat <- (yn1/n1)/pi2
      varhat <- (1 - pihn1)/(n1 * pihn1)
      CIU <- ((pihn1/pi2)/(1 + (z.star^2/n1))) * (1 + ((z.star^2/(2*yn1)))) + z.star * sqrt(varhat + (z.star^2/(4 * yn1^2)))
      }
    }
    if(pi2 == 0 & y1 != 0)stop("pi2 = 0 but y1 != 0?") 
    if(pi2 != 0 & y1 == n1){
      if(pi2 == 1){
        varhat <- 0
        CIL <- 1
        CIU <- 1
      }
      if(pi2 != 1){
        yn1 <- n1 - 0.5
        pihn1 <- yn1/n1
        nrat <- pihn1/pi2
        varhat <- (1 - pihn1)/(n1 * pihn1)
        CIL <- ((pihn1/pi2)/(1 + (z.star^2/n1))) * ((1 + ((z.star^2/(2*yn1)))) - z.star * sqrt(varhat + (z.star^2/(4 * yn1^2))))
        CIU <- ((pihn1/pi2)/(1 + (z.star^2/n1))) * ((1 + ((z.star^2/(2*yn1)))) + z.star * sqrt(varhat + (z.star^2/(4 * yn1^2))))
      }
    } 
  }
  else{
    varhat <- (1 - pih1)/(n1 * pih1)
    CIL <- ((pih1/pi2)/(1 + (z.star^2/n1))) * ((1 + ((z.star^2/(2*y1)))) - z.star * sqrt(varhat + (z.star^2/(4 * y1^2))))
    CIU <- ((pih1/pi2)/(1 + (z.star^2/n1))) * ((1 + ((z.star^2/(2*y1)))) + z.star * sqrt(varhat + (z.star^2/(4 * y1^2))))
    
  }
CIL <- ifelse(CIL < 0, 0, CIL)
  CI <- c(rat, CIL, CIU)
}

#------------------fixed-log--------------------#

if(method == "fixed-log"){
  pih1 <- y1/n1
  rat <- pih1/pi2
  if((y1 == 0 & pi2 == 0)|(y1 == 0 & pi2 != 0)|(y1 != 0 & pi2 == 0)|(y1 == n1)){
    if(y1 == 0 & pi2 == 0) {CIL <- 0;  CIU <- Inf; rat = 0; varhat = NA}
    if(y1 == 0 & pi2 != 0){
      if(pi2 == 1)stop("pi2 = 1 but y1 = 0?")    
      if(pi2 != 1){
        CIL <- 0
        yn1 <- 0.5
        pihn1 <- yn1/n1
        nrat <- (yn1/n1)/pi2
      varhat <- (1 - pihn1)/(n1 * pihn1)
      CIU <- nrat * exp(z.star * sqrt(varhat))
      }
    }
    if(pi2 == 0 & y1 != 0)stop("pi2 = 0 but y1 != 0?") 
    if(pi2 != 0 & y1 == n1){
      if(pi2 == 1){
        varhat <- 0
        CIL <- 1
        CIU <- 1
      }
      if(pi2 != 1){
        yn1 <- n1 - 0.5
        pihn1 <- yn1/n1
        nrat <- pihn1/pi2
        varhat <- (1 - pihn1)/(n1 * pihn1)
        CIL <- nrat * exp(-z.star * sqrt(varhat))
      CIU <- nrat * exp(z.star * sqrt(varhat))
      }
    } 
  }
  else{
    varhat <- (1 - pih1)/(n1 * pih1)
  CIL <- rat * exp(-z.star * sqrt(varhat))
  CIU <- rat * exp(z.star * sqrt(varhat))
}
CIL <- ifelse(CIL < 0, 0, CIL)
CI <- c(rat, CIL, CIU)
}

#------------------Agresti-Coull--------------------#

if(method == "ac"){
  if(pi2 == 0 & y1 != 0)stop("pi2 = 0 but y1 != 0?")
  if(pi2 == 1 & y1 == 0)stop("pi2 = 1 but y1 = 0?")
  
  y1 <- y1 + z.star^2/2; n1 <- n1 + z.star^2
  
  pih1 <- y1/n1
  rat <- pih1/pi2
  varhat <- pih1 * (1 - pih1)/((n1) * pi2^2)
  CIL <- rat - (z.star*sqrt(varhat))
  CIU <- rat + (z.star*sqrt(varhat))
  CIL <- ifelse(CIL < 0, 0, CIL)
  CI <- c(rat, CIL, CIU)
}


#------------------- Bayes ------------------------#
 
if(method == "bayes"){
  alpha <- 1 - conf
  pih1 <- y1/n1 
  rat <- pih1/pi2
  a <- gamma.hyper + y1
  b <- beta.hyper + n1 - y1
  varhat <- a * b/((a + b)^2*(a + b + 1))
  CIL <- qbeta(alpha/2, a, b)/pi2 
  CIU <- qbeta(1-alpha/2, a, b)/pi2
  CI <- c(rat, CIL, CIU)
}

#--------------------------------------------------#

  res <- list(CI = CI, varhat = varhat)
  res
}
     
  CI <- matrix(ncol = 3, nrow = length(y1))
  vh <- rep(NA, length(y1))
  for (i in 1 : length(y1)) {
  temp <- ci.prat.ak1(y1 = y1[i], n1 = n1[i], pi2 = pi2[i], conf = conf, method = method, bonf = bonf, bootCI.method = bootCI.method, sigma.t=sigma.t, R = R)
  CI[i,] <- temp$CI
  vh[i] <- temp$varhat
  }

CI <- data.frame(CI)
if (length(y1) == 1)row.names(CI) <- ""

head <- paste(paste(as.character(oconf * 100), "%", sep = ""), c("Confidence interval for ratio of binomial proportions"))
head1 <- paste(paste(as.character(oconf * 100), "%", sep = ""), c("Credible interval for ratio of binomial proportions"))

   if (method == "bayes")  head <- paste(head1, "(method=Bayes-beta)", sep ="")
   if (method == "boot")  head <- paste(head, "(method=", name, " bootstrap)", sep ="")
   if (method == "fixed-log")  head <- paste(head, "(method=fixed-log)")
   if (method == "wald") head <- paste(head, "(method=Wald-adjusted)")
   if(method == "ac") head <- paste(head, "(method=AC-adjusted)")
   if(method == "noether-fixed") head <- paste(head, "(method=Noether-fixed)")
   if(bonf == TRUE) head <- paste(head, "\n Bonferroni simultaneous intervals, r = ", bquote(.(r)), 
"\n Marginal confidence = ", bquote(.(conf)), "\n", sep = "")                                                                                                                                              


ends <- c("Estimate", paste(as.character(c((1 - oconf)/2, 1 - ((1 - oconf)/2)) * 100), "%", sep = ""))
res <- list(varhat = vh, ci = CI, ends = ends, head = head)
class(res) <- "ci"
res
}

one.sample.z<-function(data=NULL, null.mu=0, xbar=NULL, sigma, n=NULL, alternative= "two.sided", conf=.95, na.rm = FALSE, fpc = FALSE, N = NULL)
{
alt <- c("two.sided", "less", "greater")
if(alternative != alt[1] & alternative != alt[2] &  alternative != alt[3]) stop(c("In alternative use one of: ", paste("'", alt, "' ", sep = "")))
if(!is.null(data)){
xbar<-mean(data, na.rm = na.rm)
n<-nrow(as.matrix(na.omit(data)))
}
s2 <- sigma^2
Var.Xbar<-ifelse(fpc==FALSE,s2/n,(1-(n/N))*(s2/n))
z<-(xbar-null.mu)/sqrt(Var.Xbar)
if(alternative== "two.sided")
{p.val<-2*pnorm(abs(z),lower.tail=FALSE)}
else if(alternative== "less")
{p.val<-pnorm(z,lower.tail=TRUE)}
else if(alternative== "greater")
{p.val<-pnorm(z,lower.tail=FALSE)}
res<-list()
alt <- paste("mu is", ifelse(alternative=="two.sided", "not equal", alternative), ifelse(alternative=="two.sided","to","than"), null.mu)
tab <- data.frame(z = z, Pval = p.val)
rownames(tab)=""
colnames(tab)=c("z*", "P-value")
res$head <- "One sample z-test"
res$alternative <- alt
res$test<-tab

if (is.null(data)==TRUE){
  data <- NULL
} else {
  data <- data
}

if(alternative == "less" | alternative == "greater"){
  res$confidence <- NULL  
}
else{
res$confidence <- ci.mu.z(data = data, summarized=ifelse(is.null(data), TRUE, FALSE), xbar = xbar, sigma = sigma, n = n, conf = conf, na.rm = na.rm, fpc = fpc, N = N)}    
class(res) <- "oneSamp"
res
}

bvn.plot <- function (mu = c(0, 0), cv = 0, vr = c(1, 1), res = 0.3, xlab = expression(y[1]), ylab = expression(y[2]), 
        zlab = expression(paste("f(", y[1], ",", y[2], ")")),...) 
{
   # require(lattice::wireframe) || stop("function requires package lattice")
  
    mv <- max(vr)
    g <- expand.grid(x = seq(mu[1] - 3 * sqrt(mv), mu[1] + 3 * 
        sqrt(mv), res), y = seq(mu[2] - 3 * sqrt(mv), mu[2] + 
        3 * sqrt(mv), res))
    g$z <- dmvnorm(cbind(g[, 1], g[, 2]), mu, sigma = matrix(nrow = 2, 
        ncol = 2, data = c(vr[1], cv, cv, vr[2])))
    wireframe(z ~ x * y, data = g, xlab = xlab, ylab = ylab, zlab = zlab, 
        ...)
}

power.z.test<- function(sigma=1,n=NULL,power=NULL,alpha=0.05,effect=NULL,test=c("two.tail", "one.tail"),strict=FALSE){
if(is.null(n)&test=="one.tail"){
    n<-((qnorm(1-alpha)+qnorm(power))^2*sigma^2)/effect^2}

if(is.null(n)&test=="two.tail"){
    n<-((qnorm(1-(alpha/2))+qnorm(power))^2*sigma^2)/effect^2}

if(is.null(power)&test=="one.tail"){
    power<-pnorm(qnorm(1-alpha)*(sigma/sqrt(n)), mean=effect,sd=sigma/sqrt(n),lower.tail=FALSE)}

if(is.null(power)&test=="two.tail"){
    power<-pnorm(qnorm(1-(alpha/2))*(sigma/sqrt(n)), mean=effect,sd=sigma/sqrt(n),lower.tail=FALSE)
    if(strict==TRUE)power<-power+pnorm(-1*(qnorm(1-(alpha/2))*(sigma/sqrt(n))), mean=effect,sd=sigma/sqrt(n),lower.tail=TRUE)}
    
if(is.null(effect)&test=="one.tail"){
    effect<-sqrt(((qnorm(1-alpha)+qnorm(power))^2*sigma^2)/n)}

if(is.null(effect)&test=="two.tail"){
    effect<-sqrt(((qnorm(1-(alpha/2))+qnorm(power))^2*sigma^2)/n)}

res<-list(sigma=sigma,n=n,power=power,alpha=alpha,effect=effect,test=test)
res
}

selftest.science.tck1 <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Scientific foundations")
  size(w) <- c(700, 650)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A scientist measures seed weights from an experimental plot.  The scale being used can distinguish\n values of 0.0001 and 0.0002 g (probably overkill for seeds). However, she finds that her scale is\n biased (high).  The seed measures are best described as...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addSpace(gp1, .5, horizontal=FALSE)
  
  ans1 <- c("(a) accurate but not precise.",
            "(b) precise but not accurate.",
            "(c) neither accurate nor precise.",
            "(d) both accurate and precise.")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  #------------- Question 2 -----------#
  
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Scientific objectivity...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans2 <- c("(a) requires that scientists not give 'free rein' to their imaginations.",
            "(b) means that one should rely strongly on 'personal judgement' to gather and assess data.",
            "(c) means that one should always try to show that one's hypotheses are true.",
            "(d) requires that a reported outcome be reproducible by others."  )
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Correct")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Empirical evidence can be acquired through...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  # addSpace(gp3, .1, horizontal=FALSE)
  ans3 <- c("(a) careful examination of existing papers and data.",
            "(b) experimentation.",
            "(c) systematic observation.",
            "(d) All of the above.")
  
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Correct")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("All but which of the following are non-empirical sciences?",
               container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("(a)  Mathematics.",
            "(b)  Pure logic.",
            "(c)  Biology.")
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Correct")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the modern (Renaissance to present; i.e., 14th
century onward) development of the scientific method, all but which of the following have occurred?", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans5 <- c("(a)  Reliance on experimentation has increased.",
            "(b)  A greater emphasis has been placed on a form of logic called deduction.",
            "(c)  Probability has been used increasingly.")
  
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  #------------- Question 6 -----------#
  
  
  gp6 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Galileo initially demonstrated the characteristics of gravity using...", container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans6 <- c("(a) controlled experiments.",
            "(b) a thought problem.",
            "(c) careful observational data.",
            "(d) All of the above.")
  
  f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r6) <- character(0)
  }
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
  
  
  #------------- Question 7 -----------#
  
  gp7 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("If all of the premises are true, the conclusion must be true.  This is a characteristic of...", container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans7 <- c("(a) Deduction.",
            "(b) Induction",
            "(c) Reduction.",
            "(d) All of the above.")
  
  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r7) <- character(0)
  }
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)
  
  #------------- Question 8 -----------#
  
  
  gp8 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The following is an example of what?\n
If not A then not B  {Premise 1}
not A                          {Premise 2}
not B                          {Conclusion}", container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans8 <- c("(a) Reductio ad absurdum",
            "(b) Modus ponens",
            "(c) Modus tollens",
            "(d) Affirming the consequent")
  
  f8 <- function(h,....){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r8) <- character(0)
  }
  
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)
  
  
  #------------- Question 9 -----------#
  
  
  gp9 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The following is an example of what?\n 
If A then B  {Premise 1}
B                   {Premise 2}
A                   {Conclusion}", container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans9 <- c("(a) Reductio ad absurdum",
            "(b) Modus ponens",
            "(c) Modus tollens",
            "(d) Affirming the consequent")
  
  f9 <- function(h,....){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Correct")
    }
    svalue(r9) <- character(0)
  }
  
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)
  
  
  #------------- Question 9 -----------#
  
  
  gp10 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The following is an example of what?\n
If A then B      {Premise 1}
not B               {Premise 2}
not A               {Conclusion}", container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans10 <- c("(a) Reductio ad absurdum",
             "(b) Modus ponens",
             "(c) Modus tollens",
             "(d) Affirming the consequent")
  
  f10 <- function(h,....){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r10) <- character(0)
  }
  
  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)
  
}

pseudo.v <- function (data, statistic, order = 1, matrix = FALSE) 
{
    if (matrix == TRUE) 
        n <- nrow(data)
    if (matrix == FALSE) 
        n <- nrow(as.matrix(data))
    theta.star <- statistic(data)
    theta.star.i <- matrix(ncol = 1, nrow = n)
    Pseudo.v <- matrix(ncol = 1, nrow = n)
    for (i in 1:n) {
        if (matrix == TRUE) {
		if(order == 1) theta.star.i[i] <- statistic(data[-i, ])
		if(order > 1) theta.star.i[i] <- statistic(data[-c(i:(order + i - 1)),])
        }
        if (matrix == FALSE) {
            data <- as.matrix(data)
            if(order == 1) theta.star.i[i] <- statistic(data[-i])
		if(order > 1) theta.star.i[i] <- statistic(data[-c(i:(order + i - 1))])
        }
        Pseudo.v <- n * theta.star - ((n - 1) * theta.star.i)
    }
    data.frame(theta.hat.star = theta.star.i, Pseudo.val = Pseudo.v)
}

see.HW<-function(parg){
old.par <- par(no.readonly = TRUE)

p<-seq(0,1,length=1000);pp<-p^2;q<-1-p;qq<-q^2;twoqp<-2*q*p
pn<-parg;qn<-round(1-pn,3);ppn<-round(pn^2,3);qqn<-round(qn^2,3);twoqpn<-signif(2*qn*pn,3)

dev.hold()
layout(matrix(c(1,2,rep(3,8)),10,1,byrow=TRUE))
par(mar=c(0,0,0,0))
plot(seq(0,1),seq(0,1),xaxt="n",yaxt="n",xlab="",ylab="",bty="n",type="n")
legend("center",legend="Hardy-Weinberg genotypic proportions  ",cex=2,bty="n")
plot(seq(0,1),seq(0,1),xaxt="n",yaxt="n",xlab="",ylab="",bty="n",type="n")
legend("center",pch=22,pt.bg=c("coral","slateblue1","salmon4"),pt.cex=3,legend=c(paste("pp = ", ppn),paste("pq = ",twoqpn), paste("qq = ",qqn)),ncol=3,cex=1.5,bty="n",yjust=1)
par(mar=c(4.5,4,0,.6),cex=1)
fig<-plot(seq(0,1,length=1000),seq(0,1,length=1000),xlab=expression(italic(p)), ylab = "Genotype proportions",type="n")
grid(fig)
points(seq(0,1,length=1000),pp,col="coral",type="l",lwd=2)
points(seq(0,1,length=1000),twoqp,col="slateblue1","l",lwd=2)
points(seq(0,1,length=1000),qq,col="salmon4","l",lwd=2)
abline(v=parg,lwd=2)
dev.flush()
on.exit(par(old.par))
}

see.HW.tck<-function (){

if (!exists("slider.envir"))
slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
p <- 0.5
assign("p", tclVar(p), envir = slider.env)

if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)
refresh <- function(...) {
p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
see.HW(p)
}
tclServiceMode(TRUE)
m <- tktoplevel()
tkwm.title(m, "the Hardy Weinberg Equilibrium")
tkwm.geometry(m, "+0+0")
tkpack(tklabel(m,text="      Visualizing the Hardy Weinberg Equilibrium      "))
tkpack(fr <- tkframe(m), side = "top")
tkpack(tklabel(fr, text = "p  ", font=c("Helvetica","10","italic")),side="left", anchor = "s")
tkpack(sc <- tkscale(fr, command = refresh, from = 0,
    to = 1, orient = "horiz", resolution = .01, showvalue = TRUE),
    side = "left", anchor="n")
assign("sc", sc, envir = slider.env)
evalq(tkconfigure(sc, variable = p), envir = slider.env)
tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)))
refresh()
 }

anm.ci.tck<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    
    tclServiceMode(FALSE)
    dialog.ci <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Confidence intervals")
        parent.entry <- tkentry(tt, textvariable=Parent, width = 10)
        para.entry<-tkentry(tt, textvariable=True.val, width = 10)
        conf.entry <- tkentry(tt, textvariable=Conf, width = 10)
        sigma.entry <- tkentry(tt, textvariable=Sigma, width = 10)
        n.est.entry <- tkentry(tt, textvariable=N.est, width = 10)
        int.entry <- tkentry(tt, textvariable=Int, width = 10)
	done <- tclVar(0)
  Par<- tclVar("mu")

        reset <- function()
        {
            tclvalue(Parent)<-""
            tclvalue(True.val)<-"0"
            tclvalue(Par)<-"mu"
            tclvalue(Conf)<-".95"
            tclvalue(Sigma)<-"1"
            tclvalue(N.est)<-"100"
            tclvalue(Int)<-"0.1"
        }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",
                               command=function()tclvalue(done)<-0)

        build <- function()
        {
            parent  <- parse(text=tclvalue(Parent))[[1]]
            par.type  <- tclvalue(Par)
            par.val  <- tclvalue(True.val)
            sigma <- tclvalue(Sigma)
            conf <- tclvalue(Conf)
            n.est <- tclvalue(N.est)
            interval <- tclvalue(Int)
            
           substitute(anm.ci(parent, par.type=par.type, par.val=as.numeric(par.val), conf=as.numeric(conf), 
                             n.est=as.numeric(n.est), sigma=as.numeric(sigma), interval = as.numeric(interval)))
        }
        
        alt.rbuts <- tkframe(tt)

        tkpack(tklabel(alt.rbuts, text="Parameter"))
        for ( i in c("mu", "median","sigma.sq", "p")){
            tmp <- tkradiobutton(alt.rbuts, text=i, variable=Par, value=i)
            tkpack(tmp,anchor="w")
        }
        
        tkgrid(tklabel(tt,text="Confidence intervals"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="Parent"), parent.entry)
        tkgrid(tklabel(tt,text="True value"), para.entry)
        tkgrid(tklabel(tt,text="Conf"), conf.entry)
        tkgrid(tklabel(tt,text='\u03c3',font=c("Helvetica","9","italic")), sigma.entry)
        tkgrid(tklabel(tt,text="Iterations"),n.est.entry)
        tkgrid(tklabel(tt,text="Animation interval"),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(alt.rbuts)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but,reset.but, sticky="w")

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")
      
        tkdestroy(tt) 
        
        cmd <- build()
        eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
    }                            
      Parent<-tclVar("rnorm(1000)")
      True.val<-tclVar("0")
      Conf<-tclVar(".95")
      N.est<-tclVar("100")
      Sigma<-tclVar("1")
      Int<-tclVar("0.1")
      dialog.ci()
   
})
}

see.ancova.tck <- function ()
{
  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check

    sigma <- 1
    assign("sigma", tclVar(sigma), envir = slider.env)
    n <- 10
    assign("n", tclVar(n), envir = slider.env)
    con.power <- 0.4
    assign("con.power", tclVar(con.power), envir = slider.env)
    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

       see.anc <- function(mu1 = 10, mu2 = 12, mu3 = 16, sigma = 2, beta = 1, n = 10, var.exp = .4){

        Y1 <- rnorm(n, mu1, sigma)
        Y2 <- rnorm(n, mu2, sigma)
        Y3 <- rnorm(n, mu3, sigma)

        mu <- (mu1+mu2+mu3)/3
        alpha1 <- rep(mu1 - mu, n)
        alpha2 <- rep(mu2 - mu, n)
        alpha3 <- rep(mu3 - mu, n)
        alpha <- c(alpha1, alpha2, alpha3)



        dev.hold()
        layout(matrix(c(1,2,3,4,4,4),2,3, byrow = TRUE))
        par(mar = c(4,0,0,.5), oma=c(0,4.5,0.5,0.5))
        plot(1:n,Y1, xaxt = "n", ylab = "", xlab = "", ylim = c(5, 20), cex.lab = 1.3, cex.axis = 1.3, cex = 1.3); abline(h = mean(Y1), lty = 1); legend("top", legend = "Treatment 1", bty = "n", cex = 1.1)
        mtext(side=2, line = 3, expression(italic(Y)))
        axis(1,at=seq(1,n), labels=FALSE)
        plot(1:n,Y2, xaxt = "n", yaxt = "n", ylab = "", xlab = "", pch = 19, ylim = c(5, 20), cex.lab = 1.3, cex.axis = 1.3, cex = 1.3); abline(h = mean(Y2), lty = 2); legend("top", legend = "Treatment 2", bty = "n", cex = 1.1); mtext(side = 1, line = 1.8, "Experimental unit", cex = .9)
        axis(1,at=seq(1,n), labels=FALSE)
        plot(1:n,Y3, xaxt = "n", yaxt = "n", ylab = "", xlab = "", pch = 2, ylim = c(5, 20), cex.lab = 1.3, cex.axis = 1.3, cex = 1.3); abline(h = mean(Y3), lty = 3); legend("top", legend = "Treatment 3", bty = "n", cex = 1.1)
        axis(1,at=seq(1,n), labels=FALSE)

        Xij <- runif(n * 3, 0, 10)
        Yij <- mu + alpha + beta * (Xij - (mean(Xij))) + rnorm(n * 3, 0, sigma * (1 - var.exp))

        par(mar = c(4.6,0,0,0.5))
        plot(Xij - mean(Xij), Yij, pch = c(rep(1,n), rep(19, n), rep(2, n)), xlab = expression(italic(X-bar(X))), ylab = "", cex.lab = 1.4, cex.axis = 1.3, cex = 1.3)
        mtext(side=2, line = 3, expression(italic(Y)))
        abline(mu + alpha1, beta, lty = 1)
        abline(mu + alpha2, beta, lty = 2)
        abline(mu + alpha3, beta, lty = 3)
        dev.flush()
        }

norm.refresh <- function(...){
     sigma <- as.numeric(evalq(tclvalue(sigma), envir = slider.env))
     n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
     con.power <- as.numeric(evalq(tclvalue(con.power), envir = slider.env))

     see.anc(sigma = sigma, n = n, var.exp = con.power)
     }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing ANCOVA")
    tkpack(tklabel(m, text = "      Visualizing ANCOVA      "))
    tkwm.geometry(m, "+0+0")


    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C3", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "left")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 2, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = sigma), envir = slider.env)

   tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "left")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 2,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Concomitant \n Exp. power", font = c("Helvetica", "9",
        "normal"), width = "12"), side = "left")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 1, orient = "horiz", resolution = .1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = con.power), envir = slider.env)


    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")

    norm.refresh()
    on.exit(par(old.par))
}

#-------------Geometric--------------#

anm.geo.growth.tck<-function(){         

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Geometric population growth")       
        n0.entry <- tkentry(tt, textvariable=N0, width = 10)              
        lambda.entry <- tkentry(tt, textvariable=Lambda, width = 10) 
        time.entry<-tkentry(tt, textvariable=Time, width = 10)
        int.entry<-tkentry(tt, textvariable=Int, width = 10)        

	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(N0)<-""                                       
            tclvalue(Lambda)<-""
            tclvalue(Time)<-""
            tclvalue(Int)<-""
        }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
     
        build <- function()
        {
            n0 <-tclvalue(N0)
            lambda <-tclvalue(Lambda)
            time <-parse(text=tclvalue(Time))[[1]]
            interval <-tclvalue(Int) 
            
           substitute(anm.geo.growth(n0=as.numeric(n0),lambda=as.numeric(lambda),time=time, interval=as.numeric(interval)))
        }
        
        tkgrid(tklabel(tt,text="Geometric growth"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="N\u2080"), n0.entry)
        tkgrid(tklabel(tt,text="\u03bb"), lambda.entry)
        tkgrid(tklabel(tt,text="Time seq."), time.entry)
        tkgrid(tklabel(tt,text="Anim. int. "),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="e")

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
    }                            
      N0<-tclVar("10")                          
      Lambda<-tclVar("1.3")
      Int<-tclVar("0.1")
      Time<-tclVar("seq(0,20)")
      dialog.sd()

})
}

#-------------Exponential--------------#

anm.exp.growth.tck<-function(){         

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Exponential population growth")       
        n.entry <- tkentry(tt, textvariable=N, width = 10)              
        rmax.entry <- tkentry(tt, textvariable=Rmax, width = 10) 
        time.entry<-tkentry(tt, textvariable=Time, width = 10)
        int.entry<-tkentry(tt, textvariable=Int, width = 10)        

	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(N)<-""                                       
            tclvalue(Rmax)<-""
            tclvalue(Time)<-""
            tclvalue(Int)<-""
        }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
     
        build <- function()
        {
            n <-tclvalue(N)
            rmax <-tclvalue(Rmax)
            time <-parse(text=tclvalue(Time))[[1]]
            interval <-tclvalue(Int) 
            
           substitute(anm.exp.growth(n=as.numeric(n),rmax=as.numeric(rmax),time=time, interval=as.numeric(interval)))
        }
        
        tkgrid(tklabel(tt,text="Exponential growth"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="N"), n.entry)
        tkgrid(tklabel(tt,text="r.max"), rmax.entry)
        tkgrid(tklabel(tt,text="Time seq."), time.entry)
        tkgrid(tklabel(tt,text="Anim. int. "),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="w")
  
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
    }                            
      N<-tclVar("10")                          
      Rmax<-tclVar("0.6")
      Int<-tclVar("0.1")
      Time<-tclVar("seq(0,20)")
      dialog.sd()
      
})
}


#-------------Logistic--------------#

anm.log.growth.tck<-function(){         

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Logistic population growth")       
        n.entry <- tkentry(tt, textvariable=N, width = 10)              
        rmax.entry <- tkentry(tt, textvariable=Rmax, width = 10) 
        K.entry<-tkentry(tt, textvariable=Ke, width = 10)
        time.entry<-tkentry(tt, textvariable=Time, width = 10)
        int.entry<-tkentry(tt, textvariable=Int, width = 10)        

	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(N)<-""                                       
            tclvalue(Rmax)<-""
            tclvalue(Ke)<-""
            tclvalue(Time)<-""
            tclvalue(Int)<-""
        }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
     
        build <- function()
        {
            n <-tclvalue(N)
            rmax <-tclvalue(Rmax)
            time <-parse(text=tclvalue(Time))[[1]]
            K <-tclvalue(Ke)
            interval <-tclvalue(Int) 
            
           substitute(anm.log.growth(n=as.numeric(n),rmax=as.numeric(rmax), K=as.numeric(K), time=time, interval=as.numeric(interval)))
        }
        
        tkgrid(tklabel(tt,text="Logisitic growth"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="N"), n.entry)
        tkgrid(tklabel(tt,text="r.max"), rmax.entry)
        tkgrid(tklabel(tt,text="K"), K.entry)
        tkgrid(tklabel(tt,text="Time seq."), time.entry)
        tkgrid(tklabel(tt,text="Anim. int."),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="w")
             

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
    }                            
      N<-tclVar("10")                          
      Rmax<-tclVar("0.6")
      Ke<-tclVar("1000")
      Int<-tclVar("0.1")
      Time<-tclVar("seq(0,50)")
      dialog.sd()
      
})
}

huber.NR<-function(x,c=1.28,iter=20){

mu.k<-matrix(nrow=iter,ncol=1)
mu.k[1]<-median(x)
for(i in 1:iter){
if(mad(x) == 0)mu.k=NA
if(mad(x) != 0){
A1<-(x-mu.k[i])/mad(x)
A<-sum(sapply(A1,function(x){max(-c,min(c,x))}))
B1<-(A1>=c|A1<=-c)
B<-length(B1[B1==FALSE])
mu.k[i+1]<-mu.k[i]+((mad(x)*A)/B)
}}
mu.k
}

dec2bin <- function(num, max.bits = 10, max.rep0 = 6){
  if(num < 0) stop("num must be >= 0. You can obtain binary expressions for negative decimal numbers with two's complement formatting using dec2bin.twos().")
  frac <- NULL
  numc <- as.character(num)

  if(grepl("\\.", numc)){
    ss <- unlist(strsplit(numc, "\\."))
    whole <- ss[1]; frac <- paste0("0.",ss[2])
  }

  fnd2c <- function(num){
    if(num/2 < 1) out <- as.character(num %% 2)
    else {
      m <- 1; iq <- num; out <- ""
      repeat{
        temp <- iq
        iq <- iq %/% 2
        m <- temp %% 2
        out <- paste0(out, m)
        if(iq == 1) break
      }
    out.1 <- rev(unlist(strsplit(out,"")))
    out <- paste0("1", paste0(out.1, collapse = ""))
    }
    out
  }

  fnd2cf <- function(num, max.bit = max.bits){
    i <- 0; iq <- num; out <- "0."
      for(i in 1:max.bits){
        iq <- iq * 2
        m <- ifelse(iq < 1, 0, 1)
        iq <- (iq) %% 1
        out <- paste0(out,m)
        if(max.bits <= i) break
      }
    out
    }

if(!is.null(frac)) {
  if(whole == "0"){out <- fnd2cf(as.numeric(frac))}
  else {
    wn <- fnd2c(as.numeric(whole))
    fn <- fnd2cf(as.numeric(frac))
    ss <- unlist(strsplit(fn, "\\."))
    out <- paste(wn, ".", ss[2], sep = "")
  }
} else{out <- fnd2c(num)}
  if(!is.null(max.rep0)){
      u <- unlist(strsplit(out, NULL))
      runs <- rle(u)
      ss <- subset(u, u %in% runs$values[runs$lengths >= max.rep0])
      if(length(ss > 0) && all(tail(u) == tail(ss))){
        w <- which(runs$values == "0" & runs$length >= max.rep0)
        id <- paste(rep("0", runs$length[w]), collapse="")
        out <- unlist(strsplit(x = out, id))
        }
  }
noquote(out)
}

anm.LVc.tck<-function(){         

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Lotka Volterra competition")
        n1.entry <- tkentry(tt, textvariable=N1, width = 10)              
        n2.entry <- tkentry(tt, textvariable=N2, width = 10) 
        r1.entry <- tkentry(tt, textvariable=R1, width = 10) 
        r2.entry <- tkentry(tt, textvariable=R2, width = 10) 
        K1.entry <- tkentry(tt, textvariable=K1, width = 10)
        K2.entry<-tkentry(tt, textvariable=K2, width = 10)
        a2.1entry <- tkentry(tt, textvariable=A2.1, width = 10)
        a1.2entry <- tkentry(tt, textvariable=A1.2, width = 10)
        int.entry<-tkentry(tt, textvariable=Int, width = 10)
        Ts.entry<-tkentry(tt, textvariable=Ts, width = 10)
                
	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(N1)<-"150"                                       
            tclvalue(N2)<-"50"
            tclvalue(R1)<-"0.7"
            tclvalue(R2)<-"0.8"
            tclvalue(K1)<-"750"
            tclvalue(K2)<-"1000"
            tclvalue(A2.1)<-"0.5"
            tclvalue(A1.2)<-"0.7"
            tclvalue(Int)<-"0.1"
            tclvalue(Ts)<-"seq(0,200)"
          }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)

        build <- function()
        {
            n1 <-tclvalue(N1)
            n2 <-tclvalue(N2)
            r1 <-tclvalue(R1)
            r2 <-tclvalue(R2)
            K1 <-tclvalue(K1)
            K2 <-tclvalue(K2)
            a2.1<-tclvalue(A2.1)
            a1.2<-tclvalue(A1.2)
            interval <-tclvalue(Int) 
            time<-parse(text=tclvalue(Ts))[[1]]    
           substitute(anm.LVcomp(n1=as.numeric(n1),n2=as.numeric(n2),r1=as.numeric(r1),r2=as.numeric(r2),K1=as.numeric(K1),K2=as.numeric(K2),a1.2=as.numeric(a1.2),a2.1=as.numeric(a2.1),interval=as.numeric(interval),time=time))
        }
        f0<-c("Calibri","10")
        f1<-c("Calibri","11")
        tkgrid(tklabel(tt,text="Lotka Volterra competition",font=f0),columnspan=4)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="n\u2081",font=f1), n1.entry,tklabel(tt,text="n\u2082",font=f1), n2.entry)
        tkgrid(tklabel(tt,text="r\u2081",font=f1), r1.entry,tklabel(tt,text="r\u2082",font=f1), r2.entry)
        tkgrid(tklabel(tt,text="K\u2081",font=f1), K1.entry,tklabel(tt,text="K\u2082",font=f1), K2.entry)
        tkgrid(tklabel(tt,text="\u03b1\u2081\u2082",font=f1), a1.2entry,tklabel(tt,text="\u03b1\u2082\u2081",font=f1), a2.1entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Time seq.",font=f0), Ts.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Anim. int. ",font=f0),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but,tklabel(tt,text=""),tklabel(tt,text=""), reset.but, sticky = "w")
 
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)
        tkwait.variable(done)
        if(tclvalue(done)=="2") stop("aborted")
        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    invisible(tclServiceMode(TRUE))
    }                            
      N1<-tclVar("150")   
      N2<-tclVar("50")
      R1<-tclVar("0.7")
      R2<-tclVar("0.8")
      K1<-tclVar("750")
      K2<-tclVar("1000")
      A2.1<-tclVar("0.5")
      A1.2<-tclVar("0.7")
      Int<-tclVar("0.1")
      Ts<-tclVar("seq(0,200)")
      dialog.sd()
})
}

selftest.conf.tck1 <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Confidence intervals")
  size(w) <- c(700, 400)
  
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  # q1 <- gexpandgroup("Question 1", container=g, anchor=c(-1,1))
  # q2 <- gexpandgroup("Question 2", container=g, anchor=c(-1,1))
  # q3 <- gexpandgroup("Question 3", container=g, anchor=c(-1,1))
  # q4 <- gexpandgroup("Question 4", container=g, anchor=c(-1,1))
  # 
  # # visible(q1) <- TRUE
  # visible(q2) <- FALSE
  # visible(q3) <- FALSE
  # visible(q4) <- FALSE
 
  
  #------------- Question 1 -----------#
  
  f1 <- function(h,....){
    if(svalue(r1) == ans1[1]){
      gmessage(msg="Incorrect. The interval has been calculated.  The interval will either contain mu, or it will not, i.e. the probability that the interval contains mu is either 0 or 1.",  icon = "error", parent = gp1)
    }
    if(svalue(r1)== ans1[2]){
      gmessage(msg="Correct", parent = gp1)
    }
    if(svalue(r1)== ans1[3]){
      gmessage(msg="Incorrect. The confidence interval for mu is calculated using the sample mean, and as a result the sample mean will always be in the confidence interval interval for mu", icon = "error", parent = gp1)
    }
    if(svalue(r1)== ans1[4]){
      gmessage(msg="Incorrect. This answer is incorrect for several reasons.  For one thing the confidence interval for mu is calculated using the sample mean, and as a result the sample mean will always be in the confidence interval interval for mu", icon = "error", parent = gp1)
    }
    svalue(r1) <- character(0)
  }
  
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A 95% confidence interval for \u03bc is calculated with the confidence limits (24, 28).  \nWhat is the correct interpretation of this result?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp1, .5)
  
  ans1 <- c("(a)  There is a probability of 0.95 that \u03bc will be between 24 and 28.",
            "(b)  We have 95% confidence that \u03bc will be between 24 and 28.",
            "(c)  We have 95% confidence that the sample mean will be between 24 and 28.",
            "(d)  There is a probability of 0.95 that the sample mean will be between 24 and 28.")
  
  r1 <- gcheckboxgroup(ans1, container = gp1, where = "beginning", handler = f1)


  

  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) If confidence intervals for \u03bc are repeatedly calculated then, \non average, a proportion of 1 - \u03b1 of these will contain \u03bc.", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  #addSpace(gp2, .5)
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct.  The definition given is correct, and is often used to help conceptualize confidence intervals.")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    
    svalue(r2) <- character(0)
  }
  
  ans2 <- c("True",
            "False")
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  
  
  
  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  
  qq <- glabel("The standard error of the mean statistic is calculated using...", container = gp3.1, anchor = c(-1,1))
  #addSpace(gp3, .5)
  font(qq) <- list(family = "cambria", size = 11)
   ans3 <- c("(a)  S/\u221an",
            "(b)  S/n",
            "(c)  S\u00b2/n",
            "(d)  S\u00b2/\u221an")
  
 
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect.  This is an estimator for the sampling distribution variance", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  
   r3 <- gcheckboxgroup(ans3, container = gp3, where = "beginning", handler = f3)
  
  

  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In general, a standard error is...", container = gp4.1, anchor = c(-1,1))
  #addSpace(gp4, .5)
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("(a) The variance of a sampling distribution.",
            "(b) The median of a sampling distribution.",
            "(c) The standard deviation of a sampling distribution.",
            "(d) The mean of a sampling distribution.")
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r4) <- character(0)
  }
  
    r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
}

print.prp.index<-function(x,digits= max(3, getOption("digits") - 3), ...){
cat("Perpendicularity index","\n\n")
cs<-x$crossing.summary
cat("Binomial estimates for crossing probability","\n")
if(!is.na(cs[1])){
rq<-structure(x$crossing.summary)
print(rq)
cat("\n")
}
ps<-x$P.summary
rq<-structure(x$P.summary)
cat("Perpendicularity summary","\n")
print(rq)
cat("\n")
invisible(x)
}

see.M <- function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    cval <- 0
    assign("cval", tclVar(cval), envir = slider.env)
    xmin <- -5
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 5
    assign("xmax", tclVar(xmax), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        cval <- as.numeric(evalq(tclvalue(cval), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- sapply(xx, function(x) {
            min(1, cval/abs(x))
        })
        dev.hold()
        p <- plot(xx, yy, type = "l", xlim = c(xmin, xmax), ylab = "Weight",
            xlab = expression(paste(italic(x), " - ", hat(mu))),
            lwd = 2, bty = "l")
        grid(p)
        legend("topright", legend = bquote(paste(italic(c)," = ", .(cval), sep = "")), box.col = "white",
            bg = "white")
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing M-estimation of location")
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "c", width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 5, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = cval), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
}

panel.cor.res <- function(x, y, digits=2, meth="pearson", cex.cor=1)
     {
         usr <- par("usr"); on.exit(par("usr"))
         par(usr = c(0, 1, 0, 1))
         r <- round(cor(x, y,method=meth),digits)
         cr<-round(cor.test(x,y,method=meth,alternative="t")$p.value,digits)
         
         text(0.5, 0.65,paste("r =",r), cex = cex.cor)
         
         if(!cr==0){
         text(0.5, 0.35,paste("p =",cr), cex = cex.cor)}
         else text(0.5, 0.35,paste("p < 0.01"), cex = cex.cor) 
         
     }

#############################################################################

panel.lm<-function(x, y, col = par("col"), bg = NA, pch = par("pch"), cex = 1,col.line = 2,lty = par("lty")) 
{
    points(x, y, pch = pch, col = col, bg = bg, cex = cex)
    ok <- is.finite(x) & is.finite(y)
    if (any(ok)) 
    beta.hat <- as.numeric(lm(y~x)$"coefficients")
    abline(beta.hat[1],beta.hat[2],col=col.line,lty=lty)	
    }

R.hat <-  function (M, burn.in = 0.5) {
        alpha = .05                     # 95% intervals
        m = ncol(M)
        x = M [round(((burn.in * nrow(M)) + 1), 0):nrow(M),]  # second half of simulated sequences  h <- round(((burn.in * n) + 1), 0)
        n = nrow(x)
        xdot = as.vector(apply(x, 2, mean))
        s2 = as.vector(apply(x, 2, var))
        W = mean(s2)
        B = n*var(xdot)
        muhat = mean(xdot)
        varW = var(s2)/m
        varB = B^2 * 2/(m-1)
        covWB = (n/m)*(cov(s2,xdot^2) - 2*muhat*cov(s2,xdot))
        sig2hat = ((n-1)*W + B)/n
        quantiles = quantile (as.vector(x), probs=c(.025,.25,.5,.75,.975))

    if (W > 1.e-8) {            # non-degenerate case
        postvar = sig2hat + B/(m*n)
        varpostvar =
                (((n-1)^2)*varW + (1+1/m)^2*varB + 2*(n-1)*(1+1/m)*covWB)/n^2

        chisqdf <- function(A, varA) 2 * (A^2/varA)

        post.df = chisqdf (postvar, varpostvar)
        post.range = muhat + sqrt(postvar) * qt(1-alpha/2, post.df)*c(-1,0,1)
        varlo.df = chisqdf (W, varW)
        confshrink = sqrt(postvar/W*(post.df+3)/(post.df+1))
        confshrink
    }
    else {      # degenerate case:  all entries in "data matrix" are identical
        1
    }
}

ci.mu.oneside<-function(data,conf=.95,n=NULL,Var=NULL,xbar=NULL,summarized=FALSE,N=NULL,fpc = FALSE,tail="upper",na.rm = FALSE){
  if(summarized==TRUE)Var.xbar<-Var/n
  if(summarized==FALSE){
    xbar<-mean(data, na.rm = na.rm)
    n<-nrow(as.matrix(na.omit(data)))
    Var.xbar<-var(data, na.rm = na.rm)/n}
S.xbar<-ifelse(fpc==FALSE,sqrt(Var.xbar),sqrt((1-(n/N))*Var.xbar))
tstar<-qt(conf,df=n-1)
  if(tail=="upper")CI<-c(xbar,-Inf,xbar+tstar*S.xbar)
  if(tail=="lower")CI<-c(xbar,xbar-tstar*S.xbar,Inf)
res<-list()
res$head<-paste(paste(as.character(conf*100),"%",sep=""),c("One-sided t confidence interval for population mean"))
res$ci<-CI
res$ends<-c("Estimate",paste(as.character(c((1-conf),1-((1-conf)))*100),"%",sep=""))
class(res)<-"ci"
res
}

r.eff <- function(){
old.par <- par(no.readonly = TRUE)
varA = 1
dev.hold()
layout(matrix(c(1,1,1,1,2,3,3,3,3,4,5,5,5,5,6),3,5,byrow=TRUE))
par(mar=c(2.8,2,1,1),oma=c(0.5,0,0,0))
plot(seq(-6,6,.001),dnorm(seq(-6,6,.001),mean=0,sd=sqrt(varA)),ylab="",cex=.1,xaxt="n",yaxt="n")
abline(v=0,lty=2)
mtext("Density", side = 2, line =.6,cex=.9)
mtext(expression(paste(italic(E),"(",italic(Y),"|",italic(A[i]),")")), side = 1, line = 1.2,cex=.9)
A1 <- rnorm(1,0,sqrt(varA))
A2 <- rnorm(1,0,sqrt(varA))
abline(v=A1,lty=2,col="gray")
abline(v=A2,lty=2,col="gray")
text(-.25,.5*dnorm(0,0,sd=sqrt(varA)), expression(mu))


plot(seq(1,20),xaxt="n",yaxt="n",col="white",bty="n")
text(8,12.5, expression(paste("Mean = ",mu)),cex=1.5)
text(8,8.5, expression(paste("Var = ",sigma[A]^2)) ,cex=1.5)


plot(seq(-6,6,.001),dnorm(seq(-6,6,.001),mean=A1,sd=sqrt(varA*4)),ylab="",cex=.1,xaxt="n",yaxt="n")
abline(v=A1,lty=2,col="gray")
mtext("Density", side = 2, line = .6,cex=.9)
mtext(expression(paste("Yield given fertilizer 1; i.e.", italic(Y),"|",italic(A)[1])), side = 1, line = 1.2,cex=.9)
text(A1-.25,.5*dnorm(A1,A1,sd=sqrt(varA*4)), expression(mu[1]))
s<-rnorm(3,A1, sd=sqrt(varA*2))
points(s[1],.001)
text(s[1],.02, expression(Y[11]))
points(s[2],.001)
text(s[2],.02, expression(Y[12]))
points(s[3],.001)
text(s[3],.02, expression(Y[13]))

plot(seq(1,20),xaxt="n",yaxt="n",col="white",bty="n")
text(8-.25,12.5, expression(paste("Mean = ",mu[1])),cex=1.5)
text(8,8.5, expression(paste("Var = ",sigma^2)),cex=1.5)


plot(seq(-6,6,.001),dnorm(seq(-6,6,.001),mean=A2,sd=sqrt(varA*4)),ylab="",cex=.1,xaxt="n",yaxt="n")
text(A2-.25,.5*dnorm(A2,A2,sd=sqrt(varA*4)), expression(mu[2]))
abline(v=A2,lty=2,col="gray")
mtext("Density", side = 2, line = .6,cex=.9)
mtext(expression(paste("Yield given fertilizer 2; i.e.", italic(Y),"|",italic(A)[2])), side = 1,  line = 1.2,cex=.9)
s<-rnorm(3,A2, sd=sqrt(varA*2))
points(s[1],.001)
text(s[1],.02, expression(Y[11]))
points(s[2],.001)
text(s[2],.02, expression(Y[12]))
points(s[3],.001)
text(s[3],.02, expression(Y[13]))

plot(seq(1,20),xaxt="n",yaxt="n",col="white",bty="n")
text(8,12.5, expression(paste("Mean = ",mu[2])),cex=1.5)
text(8,8.5, expression(paste("Var = ",sigma^2)),cex=1.5)
dev.flush()
on.exit(par(old.par))
}



see.rEffect.tck <- function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    sigmaA <- 1
    assign("sigmaA", tclVar(sigmaA), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
          r.eff()
    }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing random effects")
    tkpack(tklabel(m, text = " Visualizing random effects "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tkbutton(fr, text = "Sample", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

near.bound<-function(X,Y,bX,bY){
  euc<-function(x1,x2,y1,y2)sqrt((x1-x2)^2+(y1-y2)^2)##euclidean distance
n<-length(X)
nb<-length(bX)
e<-matrix(ncol=n,nrow=nb)
  for(i in 1:n){
  e[,i]<-euc(X[i],bX,bY,Y[i])
  }
mn<-apply(e,2,function(x){which(x==min(x))})
xy.bound<-data.frame(near.X.coord=bX[mn],near.Y.coord=bY[mn])
xy.bound
}

joint.ci.bonf<-function(model,conf=.95){
bk<-model$coefficients
p<-length(bk)
n<-length(model$residuals)
SE<-summary(model)$coefficients[,2]
B<-qt(1-((1-conf)/(2*p)),n-p)
margin<-B*SE
CI<-data.frame(lower=bk-margin,upper=bk+margin)
ends<-c((1-conf)/2,1-((1-conf)/2))*100
names(CI)<-c(paste(ends[1],"%"),paste(ends[2],"%"))
CI
}

see.bin.tck<-function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
        slider.env <<- new.env()
    n <- 10
    p <- 0.5
    assign("n", tclVar(n), envir = slider.env)
    assign("p", tclVar(p), envir = slider.env)

   show.norm <- tclVar(0)
   if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

      prefunc<-function(xx,yy,vy,muy,n,p,show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        x <- NULL; rm(x); # Dummy to trick R CMD check
        if(show.norm==TRUE) curve(dnorm(x,muy,vy),0,n, col =2,add=TRUE)
        mtext(bquote(paste(italic(X), " ~ ", italic(BIN), "(", .(n), ", ", .(p),")", sep = "")), line = 1, side = 3)
        dev.flush()
                  }
   norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xx <- seq(0, n, length = n+1)
        yy <- dbinom(xx,n,p)
        show.norm <- as.logical(tclObj(show.norm))
        vy<-sqrt(p*n*(1-p))
        muy<-n*p
        prefunc(xx,yy,vy,muy,n,p=p,show.norm=show.norm)
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "BIN(n, \u03C0)")
    tkpack(tklabel(m,text="      Visualizing the Binomial Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")

    tkpack(tklabel(fr, text = "n", font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03C0', font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)
    tkpack(fr,tkcheckbutton(m, text="Show normal approx.",variable=show.norm),anchor="w")
     tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}


see.bincdf.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    n <- 10
    p <- 0.5
    assign("n", tclVar(n), envir = slider.env)
    assign("p", tclVar(p), envir = slider.env)

    show.norm<-tclVar(0)

 #   old.par <- par(no.readonly = TRUE)

    dev.new(height=4,width=8,noRStudioGD = TRUE)
    par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0))
    layout(matrix(c(1,2), 1, 2, byrow = TRUE))

    prefunc<-function(xx,yy,y1,vy,muy,n,p,show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        x <- NULL; rm(x); # Dummy to trick R CMD check
        if(show.norm==TRUE) curve(dnorm(x,muy,vy),0,n, col =2, add = TRUE)
        plot(xx, y1, type = "n", xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        points(xx, y1, pch =19)
        segments(xx, y1,xx+1,y1)
        points(xx+1, y1, pch =1)
        if(show.norm==TRUE) curve(pnorm(x,muy,vy),0,n, col =2, add=TRUE)
        mtext(bquote(paste(italic(X), " ~ ", italic(BIN), "(", .(n), ", ", .(p),")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
                  }

   norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xx <- seq(0, n, length = n+1)
        yy <- dbinom(xx,n,p)
        y1 <- pbinom(xx,n,p)
        show.norm <- as.logical(tclObj(show.norm))
        vy<-sqrt(p*n*(1-p))
        muy<-n*p
        prefunc(xx, yy, y1, vy, muy, n, p, show.norm = show.norm)
                   }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "BIN(n, \u03C0)")
    tkpack(tklabel(m,text="      Visualizing the Binomial Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03C0', font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)
    tkpack(fr,tkcheckbutton(m, text="Show normal approx.",variable=show.norm),anchor="w")
     tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
#    on.exit(par(old.par))

    }

se.jack <- function(x){
n <- length(x)
x <- as.matrix(x)
sqrt(((n - 1)/n) * sum((x - mean(x))^2))
}

se.jack1 <- function(x){
n <- length(x)
x <- as.matrix(x)
sqrt(sum((x - mean(x))^2)/(n*(n - 1)))
}

selftest.ANVOVA_design_review.tck <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "ANOVA review")
  size(w) <- c(700, 670)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  gp16_1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1_1 <- ggroup(container = gp16_1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp16.1_1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, a factor is...", container = gp16.1_1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans16_1 <- c("(a)     a categorical explanatory variable.",
             "(b)     a category from a categorical explanatory variable.",
             "(c)     a response variable.",
             "(d)     a tabular analysis.")
  
  f16_1 <- function(h,....){
    if(tail(svalue(r16_1),1) == ans16_1[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r16_1),1)== ans16_1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r16_1),1)== ans16_1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r16_1),1)== ans16_1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r16_1) <- character(0)
  }
  
  r16_1 <- gcheckboxgroup(ans16_1, container = gp16_1, checked = FALSE, where = "beginning", handler = f16_1)
  
  #------------- Question 2 -----------#
  gp17_1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp17.1_1 <- ggroup(container = gp17_1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp17.1_1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, fixed factor levels are...", container = gp17.1_1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans17_1 <- c("(a)     a subset from a population of potential factor levels.",
             "(b)     are not informative.",
             "(c)     not an obvious subset from a population of potential factor levels.",
             "(d)     are informative.",
             "(e)     (a) and (b)",
             "(f)     (c) and (d)")
  
  f17_1 <- function(h,....){
    if(tail(svalue(r17_1),1) == ans17_1[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17_1),1)== ans17_1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17_1),1)== ans17_1[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r17_1),1)== ans17_1[4]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r17_1),1)== ans17_1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17_1),1)== ans17_1[6]){
      gmessage(msg="Correct")
    }
    svalue(r17_1) <- character(0)
  }
  
  r17_1 <- gcheckboxgroup(ans17_1, container = gp17_1, checked = FALSE, where = "beginning", handler = f17_1)
  
  
  #------------- Question 3 -----------#
  gp18_1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp18.1_1 <- ggroup(container = gp18_1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp18.1_1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, random factor levels are...", container = gp18.1_1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans18_1 <- c("(a)     a subset from a population of potential factor levels.",
             "(b)     are not informative.",
             "(c)     not an obvious subset from a population of potential factor levels.",
             "(d)     are informative.",
             "(e)     (a) and (b)",
             "(f)     (c) and (d)")
  
  f18_1 <- function(h,....){
    if(tail(svalue(r18_1),1) == ans18_1[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r18_1),1)== ans18_1[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r18_1),1)== ans18_1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r18_1),1)== ans18_1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r18_1),1)== ans18_1[5]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r18_1),1)== ans18_1[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r18_1) <- character(0)
  }
  
  r18_1 <- gcheckboxgroup(ans18_1, container = gp18_1, checked = FALSE, where = "beginning", handler = f18_1)
  

  #------------- Question 4 -----------# 
  
  
  gp1_1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1_1 <- ggroup(container = gp1_1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp1.1_1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) ANOVA is a type of generalized linear model, and thus a type of general linear model.", container = gp1.1_1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1_1 <- c("(a)     TRUE.",
               "(b)     FALSE."
           )
  
  f1_1 <- function(h,....){
    if(tail(svalue(r1_1),1) == ans1_1[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1_1),1)== ans1_1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
      svalue(r1_1) <- character(0)
  }
  
  r1_1 <- gcheckboxgroup(ans1_1, container = gp1_1, checked = FALSE, where = "beginning", handler = f1_1)
  
  
  
  #------------- Question 5 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have six experimental units (EUs) randomly assigned to two treatments \n(A\u2081 and A\u2082).  What is the experimental design?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  gp1.1a <- getWidget(gp1)
  img <- tkrplot::tkrplot(gp1.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("CRD",n = 6, cex.text = .85,titles = FALSE)
  }
  )
  add(gp1, img, horizontal=TRUE)

  ans1 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct.  The CRD is the simplest experimental design.  \nNote that no blocking, splitting or nesting occurs.")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  
  
  #------------- Question 6 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two factors A and B, each with two factor levels, randomly assigned \nwithin four blocks. What is the experimental design?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  gp2.1a <- getToolkitWidget(gp2)
  img <- tkrplot::tkrplot(gp2.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("SPRB",cex.text = .85,titles = FALSE)
  }
  )
  add(gp2, img, horizontal=TRUE)
  ans2 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",,  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Correct.  Specifically, this is a split-plot design in randomized blocks (RBSP). Note that the blocks comprise a replicate for the whole plot (factor A) factor levels. The RBSP design is the most common split plot design.")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  
  #------------- Question 7 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two factors A and B, each with two factor levels, randomly assigned to \nfour experimental units. What is the experimental design?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp3.1a <- getToolkitWidget(gp3)
  img <- tkrplot::tkrplot(gp3.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("factorial2by2",cex.text = .95,titles = FALSE)
  }
  )
  add(gp3, img, horizontal=TRUE)
  ans3 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Correct.  Note that the design here is balanced but unreplicated (each of the four factor level combinations has only one replicate).  ")
    }
    if(tail(svalue(r3),1)== ans3[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  #------------- Question 8 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two treatments (A\u2081 and A\u2082), randomly assigned within two blocks. \nWhat is the experimental design?", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp4.1a <- getToolkitWidget(gp4)
  img <- tkrplot::tkrplot(gp4.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("RCBD",cex.text = .85,titles = FALSE)
  }
  )
  add(gp4, img, horizontal=TRUE)

    ans4 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  
 f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Correct.  Note that treatments are assigned exactly once within each block.")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r4) <- character(0)
 }
 
 r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
 
  
  
  #------------- Question 9 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have three experimental units randomly assigned to each of two treatments \n(A\u2081 and A\u2082). What is the experimental design?", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp5.1a <- getToolkitWidget(gp5)
  img <- tkrplot::tkrplot(gp5.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("pairs",cex.text = .95,titles = FALSE)
  }
  )
  add(gp5, img, horizontal=TRUE)

    ans5 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[6]){
      gmessage(msg="Correct.  Note that each EU receives both treatments, but that the order in which the EUs receive treatments is randomized.")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  
}

partial.R2<-function(nested.lm, ref.lm){
a <- anova(nested.lm)
b <- anova(ref.lm)
length.ref <- length(attributes(ref.lm$terms)$"dataClasses")
length.nested <- length(attributes(nested.lm$terms)$"dataClasses")
if(length.nested > length.ref) stop("Specify nested model first in arguements")
if(length.ref - length.nested > 1) stop("Reference and nested model should only differ with repsect to the presence/absence of one predictor")
SSE.wo <- tail(a$"Sum Sq", 1)
SSE.with <- tail(b$"Sum Sq", 1)
P.R2<-(SSE.wo-SSE.with)/SSE.wo
P.R2
}

see.Fcdf.tck<-function ()
{
  # old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu1 <- 5
    assign("nu1", tclVar(nu1), envir = slider.env)
    nu2 <- 5
    assign("nu2", tclVar(nu2), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir = slider.env)

    dev.new(height=4,width=8,noRStudioGD = TRUE)
    par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
    norm.refresh <- function(...) {
        nu1 <- as.numeric(evalq(tclvalue(nu1), envir = slider.env))
        nu2 <- as.numeric(evalq(tclvalue(nu2), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(0, 10, length = 200)
        yy <- df(xx, nu1, nu2)
        y1 <- pf(xx, nu1, nu2)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        plot(xx, y1, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(F), "(", .(nu1), ", ", .(nu2),")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
            }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "F(\u03bd\u2081, \u03bd\u2082)")
    tkpack(tklabel(m,text="      Visualizing the F Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd\u2081',width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu1), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd\u2082',width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    evalq(tkconfigure(sc, variable = nu2), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
     tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
norm.refresh()
 #   on.exit(par(old.par))
    }


see.F.tck<-function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu1 <- 5
    assign("nu1", tclVar(nu1), envir = slider.env)
    nu2 <- 5
    assign("nu2", tclVar(nu2), envir = slider.env)
        xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir = slider.env)
    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        nu1 <- as.numeric(evalq(tclvalue(nu1), envir = slider.env))
        nu2 <- as.numeric(evalq(tclvalue(nu2), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(0, 10, length = 200)
        yy <- df(xx, nu1, nu2)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(F), "(", .(nu1), ", ", .(nu2),")", sep = "")), line = 1, side = 3)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "F(\u03bd\u2081, \u03bd\u2082)")
    tkpack(tklabel(m,text="      Visualizing the F Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd\u2081', width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu1), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd\u2082', width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu2), envir = slider.env)
        tkpack(fr <- tkframe(m), side = "top")
    evalq(tkconfigure(sc, variable = nu2), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
     tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
   }

anm.samp.design.tck<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Sampling designs")
        n.entry <- tkentry(tt, textvariable=N, width = 10)
        int.entry <- tkentry(tt, textvariable=Int, width = 10)
        iter.entry<-tkentry(tt, textvariable=Iter, width = 10)
       
                
	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(N)<-"20"
            tclvalue(Int)<-"0.5"
            tclvalue(Iter)<-"30"
          }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)

        build <- function()
        {
            n <-tclvalue(N)
            interval <-tclvalue(Int) 
            iter <-tclvalue(Iter)
     
           substitute(anm.samp.design(n=as.numeric(n),interval=as.numeric(interval),iter=as.numeric(iter)))
        }
        
        tkgrid(tklabel(tt,text="Sampling designs"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="Sample size"), n.entry)
        tkgrid(tklabel(tt,text="Anim. int."),int.entry)
        tkgrid(tklabel(tt,text="Iterations "), iter.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="w")
     
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    invisible(tclServiceMode(TRUE))
    }                            
      N<-tclVar("20")
      Iter<-tclVar("30")
      Int<-tclVar("0.5")
      dialog.sd()
})
}

bin2dec <- function(digits, sign.bit = FALSE){
  digits <- as.numeric(digits)
  if(digits < 0) stop("digits must be >= 0")
  x <- as.character(digits)
  h <- unlist(strsplit(x, ""))
  if(!all(h == "1" | h == "0" | h == ".")) stop("digits must be binary")

  if(any(h == ".")){
    w <- which(h == ".")
    len <- length(h)
    mkappa <- w - len; Mkappa <- w - 2
    kappa <- seq(Mkappa, mkappa)
    noradix <- paste(gsub(x = h,".","", fixed = TRUE), collapse = "")
    mantissa <- as.numeric(unlist(strsplit(noradix, "")))
  } else {
    mkappa <- 0; Mkappa <- length(h) - 1
    kappa <- seq(Mkappa, mkappa)
    mantissa <- as.numeric(h)
  }
  if(sign.bit){
    mantissa[1] <- -mantissa[1]
  }
  sum(mantissa * 2^kappa)
}

see.typeI_II<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkframe <- ttkframe
        tklabel <- ttklabel
    }
tclServiceMode(FALSE)
   top <- tktoplevel() 
   tkwm.geometry(top, "+500+4")
   tktitle(top) <- "Demonstration of type I and type II error"
    canvas <- tkcanvas(top, relief="raised", width=550, height=550)
    tkpack(canvas, side="top", fill="x")

    plotFont <- "Helvetica 9"
    plotFont2 <- "Calibri 11"
    
#------------------------ Message boxes ----------------------#

I<-function(){
 tkmessageBox(message="This constitutes a type I error, i.e. the null hypothesis is rejected, but it is actually true.  Type I error will occur with a probability equivelent to the significance level (alpha) of the hypothesis test.  Type I error is generally considered to be more serious than type II error, and as a result it is emphasized more in hypothesis testing.\n
 
The significance level is often set at 0.05, based on an early reccomendation by R.A. Fisher.  Fisher later argued against using set significance levels")}

II<-function(){
 tkmessageBox(message="This constitutes a correct decision, i.e. the null hypothesis is rejected, and it is false.  The scenario is referred to as power.  Power will occur with a probability equivelent to 1 - the probability of type II error.  A conventional level of power used by working statisticians is 0.8.")}
    
III<-function(){
 tkmessageBox(message="This constitutes a correct decision, i.e. we fail to reject the null hypothesis, and it is true.  The scenario will occur with a probability equivelent to 1 - the probability of type I error.")}
 
IV<-function(){
 tkmessageBox(message="This constitutes a type II error, i.e. we fail to reject the null hypothesis, but it is actually false.  Just as a level of 0.05 is often used for an acceptable level of type I error, a level of 0.2 is often used as a cutoff for type II error.")}
 

    tkcreate(canvas, "polygon", 100, 100, 100, 500, 500, 500, 500, 100, width=0, fill = "white")
    tkcreate(canvas, "line", 100, 100, 500, 100, width=2)
    tkcreate(canvas, "line", 100, 500, 500, 500, width=2)
    tkcreate(canvas, "line", 500, 100, 500, 500, width=2)
    tkcreate(canvas, "line", 100, 500, 100, 100, width=2)
    tkcreate(canvas, "line", 300, 100, 300, 500, width=2)
    tkcreate(canvas, "line", 100, 300, 500, 300, width=2)
    tkcreate(canvas, "text", 300, 20, text="Type I and type II error",
             font=plotFont2)
    tkcreate(canvas, "text", 50, 200, text="Reject H\u2080",
             font=plotFont2)
    tkcreate(canvas, "text", 50, 400, text="FTR H\u2080",
             font=plotFont2)
    tkcreate(canvas, "text", 200, 80, text="H\u2080 True",
             font=plotFont2)
    tkcreate(canvas, "text", 400, 80, text="H\u2080 False",
             font=plotFont2)

#------------------------ alpha ----------------------#
    tkcreate(canvas, "text", 200, 150, text="Type I error\n          \u03b1",
             font=plotFont2)
             
            item1 <- tkcreate(canvas, "polygon", 160, 235, 160, 265, 240, 265, 240, 235,
                                 width=1, outline="black",
                                 fill="SkyBlue2")        
            tkaddtag(canvas, "point1", "withtag", item1)
         
            tkcreate(canvas, "text", 200, 250, text="More info",
                     font=plotFont2)
                     
#------------------------ 1-beta ----------------------#    
    tkcreate(canvas, "text", 400, 160, text="Correct decision\n         Power\n           1 - \u03b2",
             font=plotFont2)
             
             item2 <- tkcreate(canvas, "polygon", 360, 235, 360, 265, 440, 265, 440, 235,
                           width=1, outline="black",
                           fill="SkyBlue2")        
            tkaddtag(canvas, "point2", "withtag", item2)
            tkcreate(canvas, "text", 400, 250, text="More info",
                     font=plotFont2)

#------------------------ 1-alpha ----------------------#                 
    tkcreate(canvas, "text", 200, 350, text="Correct decision\n            1 - \u03b1",
             font=plotFont2)
    
            item3 <- tkcreate(canvas, "polygon", 160, 435, 160, 465, 240, 465, 240, 435,
                           width=1, outline="black",
                           fill="SkyBlue2")        
            tkaddtag(canvas, "point3", "withtag", item3)
            tkcreate(canvas, "text", 200, 450, text="More info",
                     font=plotFont2)

#------------------------ beta ----------------------#    
    tkcreate(canvas, "text", 400, 350, text="Type II error\n          \u03b2",
             font=plotFont2)
             
            item4 <- tkcreate(canvas, "polygon", 360, 435, 360, 465, 440, 465, 440, 435,
                           width=1, outline="black",
                           fill="SkyBlue2")        
            tkaddtag(canvas, "point4", "withtag", item4)
            tkcreate(canvas, "text", 400, 450, text="More info",
                     font=plotFont2)         

#------------------------ Drive widgets ----------------------#             

        tkitembind(canvas, "point1", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "point1", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "point1", "<1>", substitute(I()))


        tkitembind(canvas, "point2", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "point2", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
                                             
        tkitembind(canvas, "point2", "<1>", substitute(II()))
        
        tkitembind(canvas, "point3", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "point3", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "point3", "<1>", substitute(III()))
        
        tkitembind(canvas, "point4", "<Any-Enter>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="red"))
        tkitembind(canvas, "point4", "<Any-Leave>",
                   function() tkitemconfigure(canvas, "current",
                                              fill="SkyBlue2"))
        tkitembind(canvas, "point4", "<1>", substitute(IV()))
        

tkpack(tkbutton(top, text = "Exit", command = function()tkdestroy(top)),side="right")
tclServiceMode(TRUE)
})
}


    

boot.ci.M<-function(X1, X2, alpha = 0.05, est = huber.one.step, R = 1000){
X1 <- X1[complete.cases(X1)]; X2 <- X2[complete.cases(X2)]

X1b <- bootstrap(X1, R = R, statistic = est)$dist
X2b <- bootstrap(X2, R = R, statistic = est)$dist
bvec <- sort(X1b - X2b)
test <- sum(bvec < 0)/R + 0.5 * sum(bvec == 0)/R
pv = 2 * min(c(test, 1 - test))
low <- round((alpha/2) * R)
up <- round((1 - alpha/2) * R)
se <- sqrt(var(bvec))

head <- paste(paste(as.character((1-alpha)*100),"%",sep=""),c("Confidence interval for true difference of location measures :"))
head2 <- "Test results :"
ends <- c(paste(as.character(c((alpha)/2,1-((alpha)/2))*100),"%",sep=""))
ends2 <- c("SE","P.value")
CI <- c(lower=bvec[low],upper=bvec[up])
tr <- c(se, pv) 
res <- list(ci=CI,head=head, head2 =head2, ends2 =ends2, ends=ends, test.res = tr)
class(res)<-"bci"
res
}

print.bci <- function(x,digits= max(3, getOption("digits")), ...){
cat("\n")
cat(x$head,"\n")
rq<-structure(x$ci,names=x$ends)
print(rq,digits=digits)
cat("\n")
cat(x$head2,"\n")
rq2<-structure(x$test.res,names=x$ends2)
print(rq2,digits=digits)
cat("\n")
invisible(x)
}

ci.boot <- function(x, method = "all", sigma.t = NULL, conf = 0.95){

indices <- c("all", "norm", "basic", "perc", "BCa", "student")
method <- match.arg(method, indices)

mes <- NULL
B <- x$dist 
se <- x$res[4]
est <- x$res[1]
alpha <- 1 - conf
R <- length(B)
uZ <- round((1 - (alpha/2))*R, 0)
lZ <- round((alpha/2)*R, 0)
sB <- sort(B)


if(method == "all" | method == "norm")
{z <- qnorm(1 - (alpha/2))
nciL <- est - z * se
nciU <- est + z * se  
nci <- c(nciL, nciU)
}

else nci <- c(NA, NA)

if(method == "all" | method == "basic")
{
bciL <- 2*est-sB[uZ]
bciU <- 2*est-sB[lZ]
bci <- c(bciL, bciU)
}

else bci <- c(NA, NA)

if(method == "all" | method == "perc")
{
pciL <- sB[lZ]
pciU <- sB[uZ]
pci <- c(pciL, pciU)
}

else pci <- c(NA, NA)

if(method == "all" | method == "BCa")
{
pv <- pseudo.v(x$data, statistic = x$statistic)
jk <- mean(pv[,1])
a <- sum((jk - pv[,1])^3)/(6*((sum((jk - pv[,1])^2))^1.5))# Eq. 3.11 Manly 
p <- length(sB[sB > est])/R
z0 <- qnorm(1 - p)
zU <- (z0 - qnorm(alpha/2))/(1 - a*(z0 - qnorm(alpha/2)))+z0
zL <- (z0 + qnorm(alpha/2))/(1 - a*(z0 + qnorm(alpha/2)))+z0
pL <- pnorm(zL)
pU <- pnorm(zU)
uZ <- round(pL*R, 0)
lZ <- round(pU*R, 0); uZ <- ifelse(uZ == 0, 1, uZ) 
bcciU <- sB[lZ]
bcciL <- sB[uZ]
bcci <- c(bcciL, bcciU)
}

else bcci <- c(NA, NA)

if(method == "all" | method == "student")
{
if(is.null(sigma.t)){
mes <- "Bootstrap SEs req'd for studentized intervals"
sci <- c(NA, NA)
}
else{
t <- (B - est)/sigma.t
sciL <- est - qt(1-(alpha/2))*se
sciU <- est + qt(1-(alpha/2))*se
sci <- c(sciL, sciU)
}
}

else sci = c(NA, NA)

head <- paste(conf*100,"%", " Bootstrap confidence interval(s)", sep = "")
ends <-  c(paste(as.character(c((1 - conf)/2, 1 - ((1 - conf)/2)) * 100), "%", sep = ""))
res <- matrix(nrow = 5, data=rbind(nci, bci, pci, bcci, sci), dimnames = list(c("Normal","Basic","Percentile", "BCa","Studentized"), ends))
out <- list(head = head, res = res, mes = mes, a = ifelse(method == "BCa"|method == "all", a, 0))
class(out) <- "ciboot"
out
} 

print.ciboot <- function(x, digits = max(3, getOption("digits")), ...) 
{
    cat("\n")
    cat(x$head, "\n\n")
    print(x$res, digits = digits, justify = "center")
    cat("\n")
    if(!is.null(x$mes))cat(x$mes,"\n")
    invisible(x)
}
 


 

anm.loglik <- function (X, dist = c("norm", "poi", "bin", "exp", "custom"),
    plot.likfunc = TRUE, parameter = NULL, func = NULL, poss = NULL,
    plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL,
    conv = diff(range(X))/70, anim = TRUE, est.col = 2, density.leg = TRUE, cex.leg = 0.9, interval = 0.01, ...)
{

    if (dist == "norm")
        loglik.norm.plot(X = X, parameter = parameter, poss = poss,
            plot.likfunc = plot.likfunc, plot.density = plot.density,
            plot.calc = plot.calc, xlab = xlab, ylab = ylab,
            conv = conv, anim = anim, est.col = est.col,
            density.leg = density.leg, cex.leg = cex.leg,
            interval = interval, ... = ...)
    if (dist == "poi")
        loglik.pois.plot(X = X, poss = poss, plot.likfunc = plot.likfunc,
            plot.density = plot.density, plot.calc = plot.calc,
            xlab = xlab, ylab = ylab, conv = conv, anim = anim,
            interval = interval, ... = ...)
    if (dist == "bin")
        loglik.binom.plot(X = X, poss = poss, plot.likfunc = plot.likfunc,
            plot.density = plot.density, xlab = xlab, ylab = ylab,
            conv = conv, anim = anim, interval = interval, ... = ...)
    if (dist == "exp")
        loglik.exp.plot(X = X, poss = poss, plot.likfunc = plot.likfunc,
            plot.density = plot.density, plot.calc = plot.calc,
            xlab = xlab, ylab = ylab, conv = conv, anim = anim,
            interval = interval, density.leg = density.leg,
            cex.leg = cex.leg, est.col = est.col, ... = ...)
    if (dist == "custom")
        loglik.custom.plot(X = X, func = func, poss = poss, anim = anim,
            interval = interval, xlab = xlab, ylab = ylab, ... = ...)

}

##################################################
############%%%%%% POISSON %%%%%%#################
##################################################


loglik.pois.plot<-function(X, poss = NULL, plot.likfunc = TRUE, plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL, conv = 0.01, anim = TRUE, interval = 0.01,...){
possibilities<-poss
  if(is.null(poss)){
    possibilities <- seq(max(0,mean(X) - sd(X)), (mean(X) + 2 * sd(X)), conv)
    logl <- seq(min(possibilities), max(possibilities),conv)}
  if(!is.null(poss))logl <- poss
    for(i in 1:length(possibilities)){
    {
    logl[i]<-log(prod(dpois(X,possibilities[i])))}
    }
max.p <- ifelse(is.null(poss), mean(X), possibilities[logl == max(logl)][1])
MLE <- mean(X)
Max.lik <- log(prod(dpois(X,mean(X))))

##No Animation
  if(anim == FALSE){
      if(plot.likfunc == TRUE & plot.density == TRUE){
      dev.new(height=4, width=8); par(mfrow = c(1,2), mar=c(4.4,4.5,1,0.5),cex=.9); layout(matrix(c(1,2), 1, 2, byrow = TRUE))}
      if(plot.likfunc == TRUE){
          plot(possibilities,logl,type="l",ylab=ifelse(is.null(ylab),"Poisson Log-likelihood function",ylab),
          xlab=ifelse(is.null(xlab),expression(paste("Estimates for ", lambda)),xlab),...)
          legend("topright",legend=bquote(paste("ML est. = ",.(MLE))),cex=.9,bty="n")
          abline(v=mean(X),lty=2,col=2)
          }
      if(plot.density == TRUE){
          plot(X,dpois(X,mean(X)),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")),type="n")
          legend("topright",legend=c(paste("X~POI(",bquote(.(round(mean(X),3))),")",sep=""),
          paste("Loglik = ",bquote(.(round(Max.lik,2))))),bty="n",cex=.9)
          legend("topleft",col=2,lty=2,legend="Obs. density",bty="n",cex=.9)
          segments(X,rep(0,length(X)),X,dpois(X,mean(X)),lty=2,col=2)}
          points(X,dpois(X,mean(X)),pch=16,cex=.9)
      }
  ##Animation
      if(anim == TRUE){
        nm <- which(logl == max(logl))[1]
          if(plot.likfunc == TRUE & plot.density == TRUE){
            dev.new(height = 4,width = 8)
            par(mfrow=c(1, 2),mar=c(4.4, 4.5, 1, 0.5), cex=.9)}
            for(i in 1:(nm - 1)){
                dev.hold()
                if(plot.likfunc == TRUE){
                    plot(possibilities, logl, type="n", ylab = ifelse(is.null(ylab), "Poisson Log-likelihood function", ylab),
                    xlab = ifelse(is.null(xlab), expression(paste("Estimates for ", lambda)), xlab) ,...)
                    arrows(possibilities[i], logl[i], possibilities[i+1], logl[i+1], col = 2, length = .15, lwd = 1)
                    points(possibilities[1:i], logl[1:i], lty = 2, col = 2, lwd = 1, type = "l")
                        if(i == (nm-1)){points(possibilities, logl, type="l")
                            abline(v=mean(X), lty=2, col=2)
                            legend("topright", legend = bquote(paste("ML est. = ",.(MLE))), cex = .9, bty = "n")

                }
            }
            if(plot.density == TRUE){
            plot(X, dpois(X, possibilities[i]), xlab = expression(italic(x)), ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")),type="n")
                      segments(x0=X,y0=rep(0,length(X)),x1=X,y1=dpois(X,possibilities[i]),col=2,lty=2)
                      points(X,dpois(X,possibilities[i]),pch=16)
                          if(i != (nm-1)){legend("topright",legend=c(as.expression(bquote(paste(lambda, " = ",.(round(possibilities[i],2))))),
                          as.expression(bquote(paste("Loglik = ", .(round(logl[i],2)))))),bty="n",cex=.9)
                          }
                          if(i == (nm-1)){legend("topright",legend=c(as.expression(bquote(paste(lambda, " = ",.(MLE)))),as.expression(bquote(paste("Loglik = ",
                          .(round(Max.lik,2)))))),bty="n",cex=.9)
                          }
                }
            dev.flush()
            Sys.sleep(interval)
            }
        if(plot.calc == TRUE){
            dev.new(width=4, height=4, ypos=225); par(mar=c(4.4,4.5,1,0.5), cex=.9)
            X <- sort(X)
            c <- ifelse(length(X)<200,round(200/length(X), 0), 1)
            x0 = rep(X, each = c); y0 = rep(rep(0,length(X)), each = c); y1 = rep(dpois(X, mean(X)), each = c)
            loglik <- log(dpois(X,mean(X)))
            cumlik <- rep(cumsum(loglik),each=c)
            for(i in 1:(length(X)*c)){
              dev.hold()
              plot(X, dpois(X, mean(X)), xlab = expression(italic(x)), ylab = expression(paste(italic(f),"(",italic(x),")", sep = "")), pch = 16, type = "n")
              dev.hold()
              legend("topleft",col = 2,lty = 2,legend = "Obs. density", bty = "n",cex = .9)
              legend("topright",legend=c(paste("X~POI(",bquote(.(round(MLE,2))),")"),
              paste("Loglik = ", bquote(.(round(cumlik[i],2))))), bty = "n", cex=.9)
              segments(x0[1:i],y0[1:i],x0[1:i],y1[1:i],col=2,lty=2)
              points(x0[1:i],y1[1:i],pch=16)
              dev.flush()
              Sys.sleep(interval)
              }
         }
    }
}

##################################################
############%%%%%% BINOMIAL %%%%%%################
##################################################

loglik.binom.plot<-function(X,poss=NULL,xlab=NULL,ylab=NULL,plot.likfunc=TRUE,plot.density=TRUE,conv=0.01,anim=TRUE,interval=0.01,...){
possibilities<-poss
if(is.null(poss)) {possibilities<-seq(max(0,mean(X)-2*sd(X)),min(1,mean(X)+sd(X)*2),conv)
logl<-seq(min(possibilities),max(possibilities),conv)}
  if(!is.null(poss)) if(!is.null(poss))logl<-poss
    for(i in 1:length(possibilities)){
    {
    logl[i]<-log(prod(dbinom(sum(X),size=length(X),prob=possibilities[i])))}
    }
max.p<-ifelse(is.null(poss),mean(X),possibilities[logl==max(logl)][1])
MLE<-mean(X)
Max.lik<-log(prod(dbinom(sum(X),length(X),mean(X))))

##No Animation
      if(anim==FALSE){
          if(plot.likfunc==TRUE&plot.density==TRUE)dev.new(height=4,width=8);par(mfrow=c(1,2),mar=c(4.4,4.5,1,0.5),cex=.9)
          if(plot.likfunc==TRUE){
              plot(possibilities,logl,type="l",ylab=ifelse(is.null(ylab), "Binomial Log-likelihood function", ylab),
              xlab=ifelse(is.null(xlab),expression(paste("Estimates for ", italic(pi))),xlab),...)
              legend("topright",legend=bquote(paste("ML est. = ",.(MLE))),cex=.9,bty="n")
              abline(v=mean(X),lty=2,col=2)
          }
          if(plot.density==TRUE){
              plot(sum(X),dbinom(sum(X),length(X),mean(X)),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")),type="l")
              legend("topright",legend=c(paste("X~BIN(",length(X),bquote(.(round(mean(X),3))),")",sep=""),
              paste("Loglik = ",bquote(.(round(Max.lik,2))))),bty="n",cex=.9)
              legend("topleft",col=2,lty=2,legend="Obs. density",bty="n",cex=.9)
              segments(sum(X),0,sum(X),dbinom(sum(X),length(X),mean(X)),lty=2,col=2)
              points(sum(X),dbinom(sum(X),length(X),mean(X)),pch=16,cex=.9)
          }
      }
  ##Animation
      if(anim==TRUE){
        nm<-which(logl==max(logl))[1]
      if(plot.likfunc==TRUE&plot.density==TRUE)dev.new(height=4,width=8);par(mfrow=c(1,2),mar=c(4.4,4.5,1,0.5),cex=.9)
           for(i in 1:(nm-1)){
           dev.hold()
               if(plot.likfunc==TRUE){
                    plot(possibilities,logl,type="n",ylab=ifelse(is.null(ylab),"Binomial Log-likelihood function",ylab),
                    xlab=ifelse(is.null(xlab),expression(paste("Estimates for ", italic(pi))),xlab),...)
                    arrows(possibilities[i],logl[i],possibilities[i+1],logl[i+1],col=2,length=.15,lwd=1)
                    points(possibilities[1:i],logl[1:i],lty=2,col=2,lwd=1,type="l")
                        if(i == (nm-1)){points(possibilities,logl,type="l")
                            abline(v=mean(X),lty=2,col=2)
                            legend("topright",legend=bquote(paste("ML est. = ",.(MLE))),cex=.9,bty="n")}
              }
              if(plot.density==TRUE){
                    plot(sum(X),dbinom(sum(X),length(X),possibilities[i]),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")),type="n",ylim=c(0,exp(Max.lik)))
                    segments(x0=sum(X),y0=0,x1=sum(X),y1=dbinom(sum(X),length(X),possibilities[i]),col=2,lty=2)
                    points(sum(X),dbinom(sum(X),length(X),possibilities[i]),pch=16)
                        if(i != (nm-1)){legend("topright",legend=c(as.expression(bquote(paste(italic(pi), " = ",.(round(possibilities[i],2))))),
                        as.expression(bquote(paste("Loglik = ", .(round(logl[i],2)))))),bty="n",cex=.9)
                        }
                        if(i == (nm-1)){legend("topright",legend=c(as.expression(bquote(paste(italic(pi), " = ",.(MLE)))),as.expression(bquote(paste("Loglik = ",
                        .(round(Max.lik,2)))))),bty="n",cex=.9)}
              }
           dev.flush()
           Sys.sleep(interval)
          }
      }
  }

##################################################
###############%%%% CUSTOM %%%%###################
##################################################

loglik.custom.plot<-function(X=NULL,func,poss,anim=TRUE,interval=0.01,xlab,ylab,...){
logl<-poss
for(i in 1:length(poss)){
  logl[i]<-log(prod(func(X,poss[i])))}
max.p<-poss[logl==max(logl)][1]
if(anim==FALSE){
plot(poss,logl,type="l",xlab=xlab,ylab=ylab,...)
}
if(anim==TRUE){
nm<-which(logl==max(logl))[1]
        for(i in 1:(nm-1)){
          dev.hold()
          plot(poss,logl,type="n",xlab=xlab,ylab=ylab,...)
          arrows(poss[i],logl[i],poss[i+1],logl[i+1],col=2,length=.15,lwd=1)
          points(poss[1:i],logl[1:i],lty=2,col=2,lwd=1,type="l")
          dev.flush()
          Sys.sleep(interval)
      }
      points(poss,logl,type="l")
      }
abline(v=max.p,lty=2,col=2)
legend("topright",legend=bquote(paste("ML est. = ",.(max.p))),cex=.9,bty="n")
}

anm.samp.design<-function(n=20, interval = 0.5 ,iter = 30, main = "", lwd = 2, lcol = 2){
r<-rep(n,iter)
if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows")
{dev.new(noRStudioGD = TRUE)}
for(i in 1:iter){
samp.design(r[i], lwd = lwd, lcol = lcol)
dev.flush()
Sys.sleep(interval)
}
}

samp.design<-function(n=20, main = "", lwd = 2, lcol = 2){
old.par <- par(no.readonly = TRUE)
plotSamp<-function(n=n,type=type, main=main, lwd = lwd, lcol = lcol){
  plot(seq(1,19),seq(1,19),xaxt="n",yaxt="n",xlab="",ylab="",type="n",xlim=c(0.5,19.5),ylim=c(0.5,19.5),main=main)

#--------------------------- SRS -----------------------------#

if(type=="SRS"){
pop<-seq(1,400,1)
pop.mat<-matrix(seq(1,400,1),ncol=20,nrow=20)
x<-sample(pop,n,replace=FALSE)
y<-sample(pop,n,replace=FALSE)
x.1<-matrix(ncol=1,nrow=n)
y.1<-matrix(ncol=1,nrow=n)
for(i in 1:n){
x.1[i]<-col(pop.mat)[pop.mat==x[i]]-.5
y.1[i]<-row(pop.mat)[pop.mat==y[i]]-.5}
for(i in 1:n){
symbols(x.1[i],y.1[i],squares=.9,inches=FALSE,add=TRUE,bg=1)
segments(seq(0,20),rep(0,20),seq(0,20),rep(20,10),col="gray")
segments(rep(0,20),seq(0,20),rep(20,20),seq(0,20),col="gray")
}
}

#----------------- STATIFIED -------------------#

if(type=="strat"){
pop<-seq(1,100,1)
pop.mat<-matrix(seq(1,100,1),ncol=10,nrow=10)

strat.samp<-function(n){
x.1<-matrix(ncol=1,nrow=n)
y.1<-matrix(ncol=1,nrow=n)
x.2<-sample(pop,n,replace=FALSE)
y.2<-sample(pop,n,replace=FALSE)
for(i in 1:n){
x.1[i]<-col(pop.mat)[pop.mat==x.2[i]]-.5
y.1[i]<-row(pop.mat)[pop.mat==y.2[i]]-.5
}
res<-list(x.1=x.1,y.1=y.1)
res
}

x<-matrix(ncol=4,nrow=n/4)
y<-matrix(ncol=4,nrow=n/4)
for(i in 1:4){
x[,i]<-strat.samp(n/4)$x.1
y[,i]<-strat.samp(n/4)$y.1
}
x<-x+matrix(nrow=n/4,ncol=4,c(rep(0,n/4),rep(0,n/4),rep(10,n/4),rep(10,n/4)))
y<-y+matrix(nrow=n/4,ncol=4,c(rep(0,n/4),rep(10,n/4),rep(0,n/4),rep(10,n/4)))

for(i in 1:n){
symbols(x[i],y[i],squares=.9,inches=FALSE,add=TRUE,bg=1)}

segments(seq(0,20),rep(0,20),seq(0,20),rep(20,10),col="gray")
segments(rep(0,20),seq(0,20),rep(20,20),seq(0,20),col="gray")
segments(10,0,10,20,col=lcol,lwd=lwd)
segments(0,10,20,10,col=lcol,lwd=lwd)
}

#----------------- CLUSTER ---------------------#

if(type=="clust"){
x<-sample(c(5,5,15,15),size=2,replace=FALSE)
y<-sample(c(5,5,15,15),size=2,replace=FALSE)
y[2]<-ifelse(x[1]==x[2]&y[1]==y[2]&y[1]==5,15,y[2])
y[2]<-ifelse(x[1]==x[2]&y[1]==y[2]&y[1]==15,5,y[2])
for(i in 1:2){
symbols(x[i],y[i],squares=9.85,inches=FALSE,add=TRUE,bg=1)}
segments(seq(0,20),rep(0,20),seq(0,20),rep(20,10),col="gray")
segments(rep(0,20),seq(0,20),rep(20,20),seq(0,20),col="gray")
segments(10,0,10,20,col=lcol,lwd=lwd)
segments(0,10,20,10,col=lcol,lwd=lwd)
}
}

##random sampling using all three designs

par(mfrow=c(2,2),mar=c(0.5,1.5,2,0.5))
plot(seq(1,19),seq(1,19),xaxt="n",yaxt="n",xlab="",ylab="",type="n",xlim=c(0.5,19.5),ylim=c(0.5,19.5),main="Sample population")
segments(seq(0,20),rep(0,20),seq(0,20),rep(20,10),col="gray")
segments(rep(0,20),seq(0,20),rep(20,20),seq(0,20),col="gray")
plotSamp(n,"SRS",main="Simple random sampling", lwd = lwd, lcol = lcol)
plotSamp(n,"strat",main="Stratified random sampling", lwd = lwd, lcol = lcol)
plotSamp(n,"clust",main="Cluster sampling", lwd = lwd, lcol = lcol)
on.exit(par(old.par))
}

selftest.bayes4.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Bayesian applications in Ch 4")
  size(w) <- c(700, 600)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  

  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The unnormalized posterior distribution is expressed as...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)  P(\u03B8|data) = P(data|\u03B8)P(\u03B8)/P(data).",
            "(b)  P(\u03B8|data) \u221D P(\u03B8|data)P(\u03B8)/P(data).",
            "(c)  f(\u03B8|data) =  f(data|\u03B8)f(\u03B8).",
            "(d)  f(\u03B8|data) \u221D f(data|\u03B8)f(\u03B8).")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect.  This is the normalized posterior for discrete or categorical outcomes.",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  

  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Under conjugacy ...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("(a)  the posterior and prior distributions will belong to the same distributional family, 
            e.g., normal, beta, etc.",
            "(b)  the posterior and likelihood distributions will belong to the same distributional family, 
            e.g., normal, beta, etc.",
            "(c)  the posterior, likelihood and prior distributions will all belong to the same distributional family, 
            e.g., normal, beta, etc.",
            "(d)  the likelihood and prior distributions will belong to the same distributional family,
            e.g., normal, beta, etc..")

  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)

  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A beta prior and binomial likelihood will produce a ...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)  normal posterior.",
            "(b)  beta posterior.",
            "(c)  binomial posterior.",
            "(d)  negative binomial posterior.")

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
 
 
  

#------------- Question 4 -----------#
gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("The posterior distribution will be ________ affected by the priors as n increases.",  container = gp4.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans4 <- c("(a)  more",
          "(b)  less",
          "(c)  variably",
          "(d)  None of the above.  The posterior will be unchanged as sample size increases.")

f4 <- function(h,....){
  if(tail(svalue(r4),1) == ans4[1]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r4),1)== ans4[2]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r4),1)== ans4[3]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r4),1)== ans4[4]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  svalue(r4) <- character(0)
}

r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)



#------------- Question 5 -----------#
gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("A gamma prior and Poisson likelihood will produce a ...", container = gp5.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans5 <- c("(a)  normal posterior.",
          "(b)  Poisson posterior.",
          "(c)  gamma posterior.",
          "(d)  negative binomial posterior.")

f5 <- function(h,....){
  if(tail(svalue(r5),1) == ans5[1]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r5),1)== ans5[2]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r5),1)== ans5[3]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r5),1)== ans5[4]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  svalue(r5) <- character(0)
}

r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)

} 

#-------------------------- normal distribution--------------------------------#

shade.norm <- function(x = NULL, from = NULL, to = NULL, sigma = 1, mu = 0, tail = "lower", show.p = TRUE, show.d = FALSE, show.dist = TRUE, digits = 5, legend.cex = .9, shade.col = "gray", ...){

m <- 4 * sigma
xv <- seq(mu - m, mu + m, sigma/1000)
yv <- dnorm(xv, mean = mu, sd = sigma)

curve(dnorm(x, mu, sigma), from = mu - m,to = mu + m, 
      ylab = expression(paste(italic(f),"(",italic(x),")", sep = "")), 
      xlab = expression(italic(x)), ...)

if(tail == "lower"){
    polygon(c(xv[xv <= x], x), c(yv[xv <= x], yv[xv == mu - m]), col = shade.col)
    p <- round(pnorm(x, mu, sigma, lower.tail = TRUE), digits)
    d <- round(dnorm(x, mean = mu, sd = sigma), digits)
if(show.p & show.d == FALSE) 
    {legend("topright", legend = bquote(paste(italic(P),"(", italic(X) <= .(x),") = ", .(p), sep = "")), bty = "n",cex = legend.cex)}
if(show.d & show.p == FALSE) 
    {legend("topright",legend = bquote(paste("", italic(f),"(", .(x),") = ", .(d), sep = "")), bty="n", cex = legend.cex)}
if(show.d & show.p) 
    {legend("topright",legend = bquote(paste(italic(P),"(", italic(X) <= .(x),") = ", .(p),",  ", italic(f),"(", .(x),") = ", .(d), sep = "")), bty = "n", cex = legend.cex)}
if(show.dist) 
    {legend("topleft",legend = bquote(paste(italic(X)," ~ ",italic(N),"(", .(mu)," , ", .(sigma^2),")" , sep = "")), bty = "n", cex = legend.cex)}
}

if(tail=="upper"){
    polygon(c(x,xv[xv >= x]), c(yv[xv == mu + m], yv[xv >= x]), col = shade.col)
    p <- round(pnorm(x, mu, sigma, lower.tail = FALSE), digits)
    d <- round(dnorm(x,mean = mu,sd=sigma),digits)
if(show.p & show.d == FALSE)
    {legend("topright",legend=bquote(paste(italic(P),"(", italic(X) >= .(x),") = ", .(p), sep = "")),bty="n",cex = legend.cex)}
if(show.d & show.p == FALSE)
    {legend("topright",legend=bquote(paste("",italic(f),"(", (x),") = ", .(d), sep = "")), bty = "n",cex = legend.cex)}
if(show.d & show.p)
    {legend("topright",legend=bquote(paste(italic(P),"(",italic(X) >= .(x),") = ",.(p),",  ",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)}
if(show.dist)
    {legend("topleft",legend=bquote(paste(italic(X)," ~ ", italic(N),"(", .(mu)," , ", .(sigma^2), ")", sep = "")),bty = "n",cex = legend.cex)}
}

if(tail == "two"){
    polygon(c(xv[xv <= -abs(x)], -abs(x)), c(yv[xv <= -abs(x)], yv[xv == mu - m]), col = shade.col)
    polygon(c(abs(x),xv[xv >= abs(x)]), c(yv[xv == mu + m], yv[xv >= abs(x)]), col = shade.col)
    p <- round(2 * pnorm(abs(x), mu, sigma, lower.tail = FALSE), digits)
if(show.p){
    legend("topright",bty="n",cex=legend.cex,legend=bquote(paste(2%*%italic(P),"(", italic(X)>="|",.(x),"|) = ",.(p), sep = "")))}
if(show.dist)
    {legend("topleft",legend=bquote(paste(italic(X)," ~ ",italic(N),"(",.(mu)," , ",.(sigma^2),")", sep = "")),bty="n",cex=legend.cex)}
}

if(tail=="two.custom"){
    polygon(c(xv[xv <= x[1]], x[1]), c(yv[xv <= x[1]], yv[xv == mu - m]), col = shade.col)
    polygon(c(x[2], xv[xv >= x[2]]), c(yv[xv == mu + m], yv[xv >= x[2]]), col=shade.col)
    p <- round(pnorm(x[1], mu, sigma), digits) + round(pnorm(x[2], mu, sigma, lower.tail = FALSE), digits)
if(show.p)
    {legend("topright", bty = "n", cex = legend.cex, legend = bquote(paste(italic(P),"(", .(x[1]) >= "", italic(X) >= .(x[2]),") = ", .(p), sep = "")))}
if(show.dist)
    {legend("topleft", legend = bquote(paste(italic(X), " ~ " ,italic(N), "(", .(mu)," , ", .(sigma^2),")", sep = "")), bty = "n",cex = legend.cex)}
}

if(tail == "middle"){
    polygon(c(xv[xv <= mu + m], mu + m), c(yv[xv <= mu + m], yv[xv == mu - m]), col = shade.col)
    polygon(c(xv[xv <= from], from), c(yv[xv <= from], yv[xv == mu - m]), col="white")
    len <- length(xv[xv >= to])
    polygon(c(xv[xv >= to], xv[xv >= to][len:1]), c(rep(0, len), yv[xv >= to][len:1]), col = "white")
    p <- round(pnorm(to, mu, sigma) - pnorm(from, mu, sigma), digits)
if(show.p)
    {legend("topright", legend = bquote(paste(italic(P), "(", .(from)<="", italic(X) <= .(to),") = ", .(p), sep = "")),bty = "n",cex = legend.cex)}
if(show.dist==TRUE)
    {legend("topleft", legend = bquote(paste(italic(X), " ~ ", italic(N), "(",.(mu)," , ", .(sigma^2),")", sep = "")),bty = "n",cex = legend.cex)}
}
}

#-------------------------- t-distribution --------------------------------#


shade.t <- function(x = NULL, from = NULL, to = NULL, nu = 3, tail = "lower", show.p = TRUE, show.d = FALSE, show.dist = TRUE, digits = 5, legend.cex = .9, shade.col = "gray", ...){
sigma <- qt(.975, nu)
m <- 4 * sigma
xv <- seq(-m, m * sigma, sigma/1000)
yv <- dt(xv, df = nu)
curve(dt(x, nu), from = -m, to = m, xlab = expression(italic(x)), ylab = expression(paste(italic(f), "(", italic(x),")", sep = "")), ...)

if(tail=="lower"){
  polygon(c(xv[xv <= x], x), c(yv[xv <= x], yv[xv == -m]), col = shade.col)
  p <- round(pt(x, nu, lower.tail = TRUE), digits)
  d <- round(dt(x,nu), digits)
if(show.p & show.d == FALSE){
  legend("topright", legend = bquote(paste(italic(P), "(", italic(X) <= .(x),") = ", .(p), sep = "")), bty = "n", cex = legend.cex)}
if(show.d & show.p == FALSE){ 
  legend("topright", legend = bquote(paste("", italic(f), "(", .(x), ") = ", .(d), sep = "")), bty = "n", cex = legend.cex)}
if(show.d & show.p){ 
  legend("topright", legend = bquote(paste(italic(P), "(", italic(X) <= .(x),") = ", .(p), ",  ", italic(f), "(", .(x),") = ", .(d), sep = "")), bty = "n", cex = legend.cex)}
if(show.dist){
  legend("topleft", legend = bquote(paste(italic(X), " ~ ", italic(t), "(", .(nu),")", sep = "")), bty = "n", cex = legend.cex)}
}

if(tail=="upper"){
  polygon(c(x, xv[xv >= x]), c(yv[xv == m], yv[xv >= x]),col = shade.col)
  p<-round(pt(x, nu, lower.tail = FALSE), digits)
  d<-round(dt(x, nu), digits)
if(show.p & show.d == FALSE){
  legend("topright", legend = bquote(paste(italic(P), "(", italic(X) >= .(x),") = ", .(p), sep = "")), bty = "n", cex = legend.cex)}
if(show.d & show.p==FALSE){
  legend("topright", legend = bquote(paste("", italic(f), "(", .(x), ") = ", .(d), sep = "")), bty = "n", cex = legend.cex)}
if(show.d & show.p){
  legend("topright", legend = bquote(paste(italic(P),"(", italic(X) >= .(x), ") = ", .(p),",  ", italic(f), "(", .(x), ") = ", .(d), sep = "")), bty = "n",cex = legend.cex)}
if(show.dist){
  legend("topleft", legend = bquote(paste(italic(X)," ~ ",italic(t),"(", .(nu),")", sep = "")), bty = "n", cex = legend.cex)}
}

if(tail == "two"){
  polygon(c(xv[xv <= -abs(x)], -abs(x)), c(yv[xv <= -abs(x)], yv[xv == m]),col = shade.col)
  polygon(c(abs(x), xv[xv >= abs(x)]), c(yv[xv == m], yv[xv >= abs(x)]),col=shade.col)
  p <- round(2 * pt(abs(x), nu, lower.tail = FALSE), digits)
if(show.p){
  legend("topright", bty = "n", cex = legend.cex, legend = bquote(paste(2 %*% italic(P), "(", italic(X) >= "|", .(x), "|) = ", .(p), sep = "")))}
if(show.dist){
  legend("topleft", legend = bquote(paste(italic(X)," ~ ", italic(t), "(", .(nu), ")", sep = "")), bty = "n", cex = legend.cex)}
}

if(tail=="two.custom"){
  polygon(c(xv[xv <= x[1]], x[1]), c(yv[xv <= x[1]], yv[xv == - m]), col = shade.col)
  polygon(c(x[2], xv[xv >= x[2]]), c(yv[xv == m], yv[xv >= x[2]]), col = shade.col)
  p <- round(pt(x[1], nu), digits) + round(pt(x[2], nu, lower.tail = FALSE), digits)
  if(show.p)
  {legend("topright", bty = "n", cex = legend.cex, legend = bquote(paste(italic(P),"(", .(x[1]) >= "", italic(X) >= .(x[2]),") = ", .(p), sep = "")))}
  if(show.dist) {
    legend("topleft", legend = bquote(paste(italic(X)," ~ ", italic(t), "(", .(nu), ")", sep = "")), bty = "n", cex = legend.cex)}
}

if(tail == "middle"){
  polygon(c(xv[xv <= m], m), c(yv[xv <= m], yv[xv == -m]),col = shade.col)
  polygon(c(xv[xv <= from], from), c(yv[xv <= from], yv[xv == -m]),col="white")
  polygon(c(to, xv[xv >= to]), c(yv[xv == m], yv[xv >= to]), col = "white")
  p <- round(pt(to, nu) - pt(from, nu), digits)
if(show.p){
  legend("topright", legend = bquote(paste(italic(P), "(", .(from) <= "", italic(X) <= .(to), ") = ", .(p), sep = "")), bty = "n", cex = legend.cex)}
if(show.dist==TRUE)legend("topleft",legend=bquote(paste(italic(X)," ~ ",italic(t),"(",.(nu),")", sep = "")), bty = "n", cex = legend.cex)
}
}

#------------------------F distribution---------------------------#

shade.F <- function(x = NULL, from = NULL, to = NULL, nu1 = 1, nu2 = 5, tail = "lower", show.p = TRUE, show.d = FALSE, show.dist = TRUE, prob.to.each.tail = 0.025, digits = 5, legend.cex=.9, shade.col = "gray", ...){
sigma<-qf(.999,nu1,nu1)
xv<-seq(0,sigma,sigma/1000)
yv<-df(xv,nu1,nu2)
curve(df(x,nu1,nu2),from=0,to=sigma,xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")), ...)

if(tail=="lower"){
polygon(c(xv[xv<=x],x),c(yv[xv<=x],yv[xv==0]),col=shade.col)
p<-round(pf(x,nu1,nu2,lower.tail=TRUE),digits)
d<-round(df(x,nu1,nu2),digits)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==FALSE)legend("topright",legend=bquote(paste("",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(p),",  ",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",italic(F),"(",.(nu1),",",.(nu2),")", sep = "")),bty="n",cex=legend.cex,adj=0.5)
}
if(tail=="upper"){
polygon(c(x,xv[xv>=x]),c(yv[xv==sigma],yv[xv>=x]),col=shade.col)
p<-round(pf(x,nu1,nu2,lower.tail=FALSE),digits)
d<-round(df(x,nu1,nu2),digits)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==FALSE)legend("topright",legend=bquote(paste("",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(p),",  ",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",italic(F),"(",.(nu1),",",.(nu2),")", sep = "")),bty="n",cex=legend.cex,adj=0.5)
}
if(tail=="two"){
qs<-round(qf(c(prob.to.each.tail,1-prob.to.each.tail),nu1,nu2),1) 
polygon(c(xv[xv<=qs[1]],qs[1]),c(yv[xv<=qs[1]],yv[xv==sigma]),col=shade.col)
polygon(c(qs[2],xv[xv>=qs[2]]),c(yv[xv==sigma],yv[xv>=qs[2]]),col=shade.col)
p<-round(prob.to.each.tail*2,digits)
if(show.p==TRUE)legend("topright",bty="n",cex=legend.cex,legend=bquote(paste(italic(P),"(",.(qs[1])<=italic(X), " and ", italic(X)>=.(qs[2]),") = ",.(p))))
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",italic(F),"(",.(nu1),",",.(nu2),")", sep = "")),bty="n",cex=legend.cex,adj=0.5)
}
if(tail=="middle"){
polygon(c(xv[xv<=sigma],sigma),c(yv[xv<=sigma],yv[xv==0]),col=shade.col)
polygon(c(xv[xv<=from],from),c(yv[xv<=from],yv[xv==0]),col="white")
polygon(c(to,xv[xv>=to]),c(yv[xv==sigma],yv[xv>=to]),col="white")
p<-round(pf(to,nu1,nu2)-pf(from,nu1,nu2),digits)
if(show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",.(from)<="", italic(X)<=.(to),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",italic(F),"(",.(nu1),",",.(nu2),")", sep = "")),bty="n",cex=legend.cex,adj=0.5)
}
}

#-------------------------Chi-square distribution------------------------------#

shade.chi<-function(x=NULL,from=NULL,to=NULL,nu=1,tail="lower",show.p=TRUE,show.d=FALSE,show.dist=TRUE,prob.to.each.tail=0.025,digits=5,legend.cex=.9,shade.col="gray",...){
sigma<-qchisq(.9999,nu)
xv<-seq(0,sigma,sigma/10000)
yv<-dchisq(xv,nu)
curve(dchisq(x,nu),from=0,to=sigma,xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep ="")), ...)

if(tail=="lower"){
    if(nu<3){
        ax <- abs(xv-x)
        xn <- ax==min(ax)
       polygon(c(0, x, x, sort(xv[xv <= x], decreasing = T)), c(0, 0, yv[xn], sort(yv[xv <= x])), col = shade.col) 
     }
    if(nu>=3)polygon(c(xv[xv <= x], x), c(yv[xv <= x], yv[xv == 0]), col = shade.col)

d<-round(dchisq(x,nu),digits)
p<-round(pchisq(x,nu,lower.tail=TRUE), digits)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==FALSE)legend("topright",legend=bquote(paste("",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(p),",  ",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",chi^2,"(",.(nu),")")),bty="n",cex=legend.cex,adj=0.5)
}

if(tail=="upper"){
polygon(c(x,xv[xv>=x]),c(yv[xv==sigma],yv[xv>=x]),col=shade.col)
p<-round(pchisq(x,nu,lower.tail=FALSE),digits)
d<-round(dchisq(x,nu),digits)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==FALSE)legend("topright",legend=bquote(paste("",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.d==TRUE&show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(p),",  ",italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",chi^2,"(",.(nu),")")),bty="n",cex=legend.cex,adj=0.5)
}
if(tail=="two"){
qs<-round(qchisq(c(prob.to.each.tail,1-prob.to.each.tail),nu),1) 
if(nu >=3){
polygon(c(xv[xv<=qs[1]],qs[1]),c(yv[xv<=qs[1]],yv[xv==sigma]),col=shade.col)
polygon(c(qs[2],xv[xv>=qs[2]]),c(yv[xv==sigma],yv[xv>=qs[2]]),col=shade.col)
}
p<-round(prob.to.each.tail*2,digits)
if(show.p==TRUE)legend("topright",bty="n",cex=legend.cex,legend=bquote(paste(italic(P),"(",.(qs[1])<=italic(X), " and ", italic(X)>=.(qs[2]),") = ",.(p))))
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",chi^2,"(",.(nu),")")),bty="n",cex=legend.cex,adj=0.5)
}
if(tail=="middle"){
if(nu >= 3){
polygon(c(xv[xv<=sigma],sigma),c(yv[xv<=sigma],yv[xv==0]),col=shade.col)
polygon(c(xv[xv<=from],from),c(yv[xv<=from],yv[xv==0]),col="white")
polygon(c(to,xv[xv>=to]),c(yv[xv==sigma],yv[xv>=to]),col="white")
}
p<-round(pchisq(to,nu)-pchisq(from,nu),digits)
if(show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",.(from)<="",italic(X)<=.(to),") = ",.(p), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("top",legend=bquote(paste(italic(X)," ~ ",chi^2,"(",.(nu),")")),bty="n",cex=legend.cex,adj=0.5)
}
}

#------------------------------ Weibull distribution ----------------------------#

shade.wei <- function (x = NULL, from = NULL, to = NULL, theta = 1, beta = 1, tail = "lower", 
    show.p = TRUE, show.d = FALSE, show.dist = TRUE, prob.to.each.tail = 0.025, 
    digits = 5, legend.cex = 0.9, shade.col = "gray", ...) 
{
    sigma <- qweibull(0.9999, theta, beta)
    xv <- seq(0, sigma, sigma/10000)
    yv <- dweibull(xv, theta, beta)
    curve(dweibull(x, theta, beta), from = 0, to = sigma, xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")), ...)
    if (tail == "lower") {
         if(theta<=1){
            ax <- abs(xv-x)
            xn <- ax==min(ax)
           polygon(c(0, x, x, sort(xv[xv <= x], decreasing = T)), c(0, 0, yv[xn], sort(yv[xv <= x])), col = shade.col) 
         }
        if(theta > 1)polygon(c(xv[xv <= x], x), c(yv[xv <= x], yv[xv == 0]), col = shade.col)
        d <- round(dweibull(x, theta, beta), digits)
        p <- round(pweibull(x, theta, beta, lower.tail = TRUE), digits)
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(" ", italic(f),"(", .(x),") = ", .(d), sep = "")), bty = "n", cex = legend.cex)
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), "(", italic(X)<=.(x), ") = ", .(p), sep = "")), bty = "n", cex = legend.cex)
        if(show.p == TRUE & show.d == TRUE)
            legend("topright", legend = bquote(paste(italic(P), "(", italic(X)<=.(x), ") = ", .(p), ",  ", italic(f),"(", .(x), 
                ") = ", .(d), sep = "")), bty = "n", cex = legend.cex)  
            if (show.dist == TRUE) 
            legend("top", legend = bquote(paste(italic(X)," ~ ", italic(WEI),"(", .(theta),",", .(beta), ")", sep = "")), bty = "n", cex = legend.cex, adj = 0.5)
    }
    if (tail == "upper"){
        polygon(c(x, xv[xv >= x]), c(yv[xv == sigma], yv[xv >= 
            x]), col = shade.col)
        p <- round(pweibull(x, theta, beta, lower.tail = FALSE), digits)
        d <- round(dweibull(x, theta, beta), digits)
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(" ", italic(f),"(", .(x), 
                ") = ", .(d), sep = "")), bty = "n", cex = legend.cex)
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), "(", italic(X)>=.(x), ") = ", .(p), sep = "")), bty = "n", cex = legend.cex)
        if(show.p == TRUE & show.d == TRUE)
            legend("topright", legend = bquote(paste(italic(P), "(", italic(X)>=.(x), ") = ", .(p), ",  ",italic(f),"(", .(x), 
                ") = ", .(d), sep = "")), bty = "n", cex = legend.cex)  
                
        if (show.dist == TRUE) 
            if (show.dist == TRUE) 
           legend("top", legend = bquote(paste(italic(X)," ~ ", italic(WEI),"(", .(theta),",", .(beta), ")", sep = "")), bty = "n", cex = legend.cex, adj = 0.5)
    }
    if (tail == "two"){
        qs <- round(qweibull(c(prob.to.each.tail, 1 - prob.to.each.tail), 
            theta, beta), 1)
        polygon(c(xv[xv <= qs[1]], qs[1]), c(yv[xv <= qs[1]], 
            yv[xv == sigma]), col = shade.col)
        polygon(c(qs[2], xv[xv >= qs[2]]), c(yv[xv == sigma], 
            yv[xv >= qs[2]]), col = shade.col)
        p <- round(prob.to.each.tail * 2, digits)
        if (show.p == TRUE) 
            legend("topright", bty = "n", cex = legend.cex, legend = bquote(paste(italic(P),"(",.(qs[1])<=italic(X), " and ", italic(X)>=.(qs[2]), ") = ", .(p), sep = "")))
        if (show.dist == TRUE) 
            if (show.dist == TRUE) 
            legend("top", legend = bquote(paste(italic(X)," ~ ", italic(WEI),"(", .(theta),",", .(beta), ")", sep = "")), bty = "n", cex = legend.cex, adj = 0.5)
    }
    if (tail == "middle") {
        if(theta > 1){
        polygon(c(xv[xv <= sigma], sigma), c(yv[xv <= sigma], 
            yv[xv == 0]), col = shade.col)
        polygon(c(xv[xv <= from], from), c(yv[xv <= from], yv[xv == 
            0]), col = "white")
        polygon(c(to, xv[xv >= to]), c(yv[xv == sigma], yv[xv >= 
            to]), col = "white")}
        p <- round(pweibull(to, theta) - pweibull(from, beta), digits)
        if (show.p == TRUE) 
            legend("topright", legend = bquote(paste(italic(P),"(", .(from)<="",italic(X)<=.(to), ") = ", .(p), sep = "")), bty = "n", cex = legend.cex)
        if (show.dist == TRUE) 
            legend("top", legend = bquote(paste(italic(X)," ~ ", italic(WEI),"(", .(theta),",", .(beta), ")", sep = "")), bty = "n", cex = legend.cex, adj = 0.5)
    }
}



#-------------------------Binomial distribution------------------------------#

shade.bin <- function (x = NULL, from = NULL, to = NULL, n = 1, p = 0.5, tail = "X=x", 
    show.p = TRUE, show.dist = TRUE, show.d = FALSE, legend.cex = 0.9, 
    digits = 5, ...) 
{
    xv <- seq(0, n, length = n + 1)
    yv <- dbinom(xv, n, p)
    plot(xv, yv, type = "h", xlab = expression(italic(x)), ylab = expression(paste(italic(f), 
        "(", italic(x), ")", sep = "")), col = gray(0.4), lty = 2, 
        ...)
    points(xv, yv, col = gray(0.4), pch = 19)
    if (tail == "X=x") {
        d <- round(dbinom(x, n, p), digits)
        segments(x, 0, x, d, lwd = 2)
        points(x, d, pch = 19)
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(italic(f), 
                "(", .(x), ") = ", .(d), sep = "")), bty = "n", 
                cex = legend.cex)
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X), " = ", .(x), ") = ", .(d), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.p == TRUE & show.d == TRUE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X), " = ", .(x), ") = ", .(d), ",  ", 
                italic(f), "(", .(x), ") = ", .(d), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.dist == TRUE) 
            legend("topleft", legend = bquote(paste(italic(X), 
                "  ~ ", italic(BIN), "(", .(n), ", ", .(p), ")", sep = "")), 
                bty = "n", cex = legend.cex)
    }
    if (tail == "lower") {
        xvnew <- xv[xv <= x]
        yvnew <- dbinom(xvnew, n, p)
        segments(xvnew, rep(0, length(xvnew)), xvnew, yvnew, 
            lwd = 2)
        points(xvnew, yvnew, pch = 19)
        d <- round(dbinom(x, n, p), digits)
        pv <- round(pbinom(x, n, p, lower.tail = TRUE), digits)
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(italic(f), 
                "(", .(x), ") = ", .(d), sep = "")), bty = "n", 
                cex = legend.cex)
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X) <= .(x), ") = ", .(pv), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.p == TRUE & show.d == TRUE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X) <= .(x), ") = ", .(pv), ",  ", 
                italic(f), "(", .(x), ") = ", .(d), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.dist == TRUE) 
            legend("topleft", legend = bquote(paste(italic(X), 
                "  ~ ", italic(BIN), "(", .(n), ", ", .(p), ")", sep = "")), 
                bty = "n", cex = legend.cex)
    }
    if (tail == "upper") {
        xvnew <- xv[xv >= x]
        yvnew <- dbinom(xvnew, n, p)
        segments(xvnew, rep(0, length(xvnew)), xvnew, yvnew, 
            lwd = 2)
        points(xvnew, yvnew, pch = 19)
        d <- round(dbinom(x, n, p), digits)
        pv <- round(pbinom(x, n, p, lower.tail = FALSE), digits)
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(italic(f), 
                "(", .(x), ") = ", .(d), sep = "")), bty = "n", 
                cex = legend.cex)
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X) >= .(x), ") = ", .(pv), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.p == TRUE & show.d == TRUE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X) >= .(x), ") = ", .(pv), ",  ", 
                italic(f), "(", .(x), ") = ", .(d), sep = "")), 
                bty = "n", cex = legend.cex)
        if (show.dist == TRUE) 
            legend("topleft", legend = bquote(paste(italic(X), 
                "  ~ ", italic(BIN), "(", .(n), ", ", .(p), ")", sep = "")), 
                bty = "n", cex = legend.cex)
    }
    if (tail == "two") {
        qs <- sort(c(x, n - x))
        xvnew <- c(xv[xv <= qs[1]], xv[xv >= qs[2]])
        yvnew <- dbinom(xvnew, n, p)
        segments(xvnew, rep(0, length(xvnew)), xvnew, yvnew, 
            lwd = 2)
        points(xvnew, yvnew, pch = 19)
        d <- round(dbinom(x, n, p), digits)
        qs <- sort(c(x, n - x))
        if (show.d == TRUE & show.p == FALSE) 
            legend("topright", legend = bquote(paste(italic(f), 
                "(", .(x), ") = ", .(d), sep = "")), bty = "n", 
                cex = legend.cex)
        pv <- round(pbinom(x, n, p, lower.tail = TRUE), digits) * 
            2
        if (show.p == TRUE & show.d == FALSE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", italic(X) <= .(qs[1]), " and ", italic(X) >= 
                  .(qs[2]), ")=", .(pv), sep = "")), bty = "n", 
                cex = legend.cex)
        if (show.dist == TRUE) 
            legend("topleft", legend = bquote(paste(italic(X), 
                "  ~ ", italic(BIN), "(", .(n), ", ", .(p), ")", sep = "")), 
                bty = "n", cex = legend.cex)
    }
    if (tail == "middle") {
        xvnew <- c(xv[xv >= from & xv <= to])
        yvnew <- dbinom(xvnew, n, p)
        segments(xvnew, rep(0, length(xvnew)), xvnew, yvnew, 
            lwd = 2)
        points(xvnew, yvnew, pch = 19)
        pv <- round(pbinom(to, n, p) - pbinom(from, n, p), digits)
        if (show.p == TRUE) 
            legend("topright", legend = bquote(paste(italic(P), 
                "(", .(from) <= "", italic(X) <= .(to), ") = ", 
                .(pv), sep = "")), bty = "n", cex = legend.cex)
        if (show.dist == TRUE) 
            legend("topleft", legend = bquote(paste(italic(X), 
                "  ~ ", italic(BIN), "(", .(n), ", ", .(p), ")", sep = "")), 
                bty = "n", cex = legend.cex)
    }
}


#-------------------------Poisson distribution------------------------------#

shade.poi<-function(x=NULL,from=NULL,to=NULL,lambda=5,tail="X=x",show.p=TRUE,show.dist=TRUE,show.d=FALSE,legend.cex=.9,digits=5,...){
xv<-seq(0,round(lambda+2*lambda,0),length=round(lambda+2*lambda+1,0))
yv<-dpois(xv,lambda)
plot(xv,yv,type="h",xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")), col=gray(.4),lty=2,...)
points(xv,yv,col=gray(.4),pch=19)

if(tail=="X=x"){
d<-round(dpois(x,lambda),digits)
segments(x,0,x,d,lwd=2)
points(x,d,pch=19)
if(show.d==TRUE&show.p ==FALSE)legend("topright",legend=bquote(paste(italic(f),"(",.(x),") = ",.(d), sep ="")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)," = ",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)," = ",.(x),") = ",.(d), ",  ", italic(f), "(",.(x),") = ", .(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("topleft",legend=bquote(paste(italic(X), " ~ ", italic(POI),"(",.(lambda),")")),bty="n",cex=legend.cex)
}

if(tail=="lower"){
xvnew<-xv[xv<=x];yvnew<-dpois(xvnew,lambda)
segments(xvnew,rep(0,length(xvnew)),xvnew,yvnew,lwd=2)
points(xvnew,yvnew,pch=19)
d<-round(dpois(x,lambda),digits)
pv<-round(ppois(x,lambda,lower.tail=TRUE),digits)
if(show.d==TRUE&show.p ==FALSE)legend("topright",legend=bquote(paste(italic(f),"(",.(x),") = ",.(d), sep ="")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(pv), sep = "")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)<=.(x),") = ",.(pv), ",  ", italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("topleft",legend=bquote(paste(italic(X), " ~ ", italic(POI),"(",.(lambda),")")),bty="n",cex=legend.cex)
}

if(tail=="upper"){
xvnew<-xv[xv>=x];yvnew<-dpois(xvnew,lambda)
segments(xvnew,rep(0,length(xvnew)),xvnew,yvnew,lwd=2)
points(xvnew,yvnew,pch=19)
d<-round(dpois(x,lambda),digits)
pv<-round(ppois(x,lambda,lower.tail=FALSE),digits)
if(show.d==TRUE&show.p ==FALSE)legend("topright",legend=bquote(paste(italic(f),"(",.(x),") = ",.(d), sep ="")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==FALSE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(pv), sep = "")),bty="n",cex=legend.cex)
if(show.p==TRUE&show.d==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",italic(X)>=.(x),") = ",.(pv), ",  ", italic(f),"(",.(x),") = ",.(d), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("topleft",legend=bquote(paste(italic(X), " ~ ", italic(POI),"(",.(lambda),")")),bty="n",cex=legend.cex)
}

if(tail=="two")stop("two-tailed probability not implemented in 'shade.poi'")

if(tail=="middle"){
xvnew<-c(xv[xv>=from&xv<=to]);  yvnew<-dpois(xvnew,lambda)
segments(xvnew,rep(0,length(xvnew)),xvnew,yvnew,lwd=2)
points(xvnew,yvnew,pch=19)
pv<-round(ppois(to,lambda)-ppois(from,lambda),digits)
if(show.p==TRUE)legend("topright",legend=bquote(paste(italic(P),"(",.(from)<="",italic(X)<=.(to),") = ",.(pv), sep = "")),bty="n",cex=legend.cex)
if(show.dist==TRUE)legend("topleft",legend=bquote(paste(italic(X), " ~ ", italic(POI),"(",.(lambda),")")),bty="n",cex=legend.cex)
}
}

ci.median<-function(x,conf=.95){
n<-nrow(as.matrix(x))
if(qbinom((1-conf)/2,n,0.5)==0)stop("CI not calculable")
L<- qbinom((1-conf)/2,n,0.5)
U<-n-L+1
if(L>=U)stop("CI not calculable")
order.x<-sort(x)
res<-list()
res$head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence interval for population median"))
res$ci<-c(median=median(x),lower=order.x[L],upper=order.x[n-L+1])
res$ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
res$coverage<-1-(2*pbinom(q=L-1,n,0.5))
class(res)<-"ci"
res
}

see.nlm<-function(){
old.par <- par(no.readonly = TRUE)
if(any(dev.list()>1)) graphics.off()
#options()$device(xpos=20)
par(mar=c(.1,.1,.1,.1))
dev.new(noRStudioGD = TRUE)
plot(seq(1,10),seq(1,10.5,length.out=10),type="n",xaxt="n",yaxt="n",xlab="",ylab="")
text(5.8,10.2,"Important non-linear models",cex=1.5)
rect(2.25, 1.15, 9.75, 9.75,lwd=1.5)
segments(2.25,9.1,9.75,9.1,lwd=1.5)
segments(5,9.75,5,1.15,lwd=1.5)
segments(8,9.75,8,1.15,lwd=1.5)
segments(2.25,8.45,9.75,8.45, col="gray")
segments(2.25,7.45,9.75,7.45, col="gray")
segments(2.25,6.45,9.75,6.45, col="gray")
segments(2.25,5.8,9.75,5.8, col="gray")
segments(2.25,4.8,9.75,4.8, col="gray")
segments(2.25,3.8,9.75,3.8, col="gray")
segments(2.25,2.8,9.75,2.8, col="gray")
segments(2.25,2.15,9.75,2.15, col="gray")
segments(2.25,1.15,9.75,1.15)
text(3.1,8.6,"Asymptotic",font=2)
text(3.05,5.95,"Sigmoidal",font=2)
text(3.25,2.3,"Hump-shaped",font=2)
text(3.5,9.25,"Name",font=2)
text(6.5,9.25,"Equation",font=2)
text(8.9,9.25,"Parameters",font=2)
text(3.31,7.6,"Michaelis-Menten",cex=.9)
text(3.65,6.6,"2-parameter exponential",cex=.9)
text(3.4,4.95,"2-parameter logistic",cex=.9)
text(3.4,3.95,"3-parameter logistic",cex=.9)
text(2.85,2.95,"Gompertz",cex=.9)
text(2.71,1.3,"Ricker",cex=.9)
text(8.8,7.6,"a, b",font=3, cex=.9)
text(8.8,6.6,"a, b",font=3, cex=.9)
text(8.8,4.95,"a, b",font=3,cex=.9)
text(8.85,3.95,"a, b, c",font=3,cex=.9)
text(8.85,2.95,"a, b, c",font=3,cex=.9)
text(8.8,1.3,"a, b",font=3,cex=.9)
text(6.3,7.9,expression(paste(italic("f(x) = "),italic(frac(ax,b+x)))),font=3)
text(6.3,6.9,expression(paste(italic("f(x) = a","(1-"),italic(e^(-bx)))),font=3)
text(6.3,5.25,expression(paste(italic("f(x) = "),italic(frac(e^(a+bx),1+e^(a+bx))))),font=3)
text(6.3,4.25,expression(paste(italic("f(x) = "),italic(frac(a,1+be^(-cx))))),font=3)
text(6.3,3.25,expression(paste(italic("f(x) = a"),italic(e^(-be)^(-cx)))),font=3)
text(6.3,1.6,expression(paste(italic("f(x) = ax"),italic(e^(-bx)))),font=3)
x<-rep(1.5,5,6)
y<-c(7.95,6.95,5.3,4.3,3.3,1.65)
points(x,y,cex=1.5)

fp<-function(){
ans <- identify(x, y, n = 1, plot = FALSE)
yw <- y[ans]
if(yw==7.95)
{points(1.5,7.95,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.MM"}
if(yw==6.95)
{points(1.5,6.95,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.2PE"}
if(yw==5.3)
{points(1.5,5.3,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.2PL"}
if(yw==4.3)
{points(1.5,4.3,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.3PL"}
if(yw==3.3)
{points(1.5,3.3,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.G"}
if(yw==1.65)
{points(1.5,1.65,pch=21,bg="red",cex=1.5);dev.new(noRStudioGD = TRUE);com="see.R"}
com
}

com <- fp()

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    a <- 1
    b <- 1
    c <- 1
    assign("a", tclVar(a), envir= slider.env)
    assign("b", tclVar(b), envir= slider.env)
    assign("c", tclVar(c), envir= slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir= slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir= slider.env)



    norm.refresh <- function(...) {
        a <- as.numeric(evalq(tclvalue(a), envir= slider.env))
        b <- as.numeric(evalq(tclvalue(b), envir= slider.env))
        c <- as.numeric(evalq(tclvalue(c), envir= slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir= slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir= slider.env))
        xx <- seq(xmin, xmax, length = 500)
        par(mar=c(5, 4.3, 4, 2), cex=1.2)

        if(com=="see.MM"){yy<-a*xx/(b+xx);main=bquote(paste("Michaelis-Menten Model   ",italic(f),"(",italic(x),") = ",.(a),italic(x),"/(",.(b)," + ",italic(x),")"))}
        if(com=="see.2PE"){yy<-a*exp(-b*xx);main="2 Parameter Exponential"}
        if(com=="see.2PL"){yy<-exp(a+b*xx)/(1+exp(a+b*xx));main="2 Parameter Logistic"}
        if(com=="see.3PL"){yy<-a/(1+b*exp(-c*xx));main="3 Parameter Logistic"}
        if(com=="see.G"){yy<-a*exp(-b*exp(-c*xx));main="Gompertz"}
        if(com=="see.R"){yy<-a*xx*exp(-b*xx);main="Ricker"}
        dev.hold()
        par(cex=1.3)
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")),main=main, cex.main=1.1)
        dev.flush()
    }

    tw <- function(){
    tkdestroy(m)
    see.nlm()
    }


    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.geometry(m, "+600+4")
    tkwm.title(m, "Visualizing Non-linear Models")
    tkpack(tklabel(m, text = "      Visualizing Non-linear Models      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "a", font = c("Helvetica",
        "9", "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 50, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = a), envir= slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "b", font = c("Helvetica",
        "9", "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 20, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = b), envir= slider.env)
     tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "c", font = c("Helvetica",
        "9", "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 10, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = c), envir= slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir= slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir= slider.env)
    tkpack(tkbutton(m, text = "New model", command = function() tw()))
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
on.exit(par(old.par))
}

ci.impt <- function(y1, n1, y2 = NULL, n2 = NULL, avail.known = FALSE, pi.2 = NULL, conf = .95, x100 = TRUE, alternative = "two.sided", bonf = TRUE, wald = FALSE){
pi.1 <- y1/n1
alpha <- 1 - conf
if(bonf == TRUE) alpha <- alpha/length(pi.1)
z.star <- ifelse(alternative == "two.sided", qnorm(1 - (alpha/2)), qnorm(1 - alpha))

if(avail.known == FALSE){
pi.2 <- y2/n2
sigma.hat.I <- sqrt((1 - pi.1)/(n1 * pi.1) + (1 - pi.2)/(n2 * pi.2))
}

if(avail.known == TRUE){
if(any(pi.2 < 0) | any(pi.2 > 1)) stop("pi.2 must be in the interval (0, 1)")
sigma.hat.I <- sqrt((1 - pi.1)/(n1 * pi.1))
if (wald == TRUE) {
sigma.hat.W <- sqrt(pi.2^2 * (pi.1 * (1 - pi.1))/n1)
if(x100 == TRUE){
sigma.hat.W <- sqrt(100^2 * pi.2^2 * (pi.1 * (1 - pi.1))/n1)
}
}
}

if(x100 == TRUE) theta.hat <- (pi.1*100) * pi.2  else  theta.hat <- pi.1 * pi.2

CI.L <- theta.hat * exp(-1 * z.star * sigma.hat.I)
CI.U <- theta.hat * exp(z.star * sigma.hat.I)
if(avail.known==TRUE & wald == TRUE){
CI.L <- theta.hat - z.star * sigma.hat.W
CI.U <- theta.hat + z.star * sigma.hat.W
}

CI.L <- ifelse(CI.L < 0, 0, CI.L)
CI.U <- ifelse(x100 == TRUE & CI.U > 100, 100, CI.U)
CI.U <- ifelse(x100 == FALSE & CI.U > 1, 1, CI.U)
if(alternative =="less") CI.U <- NA
if(alternative == "greater") CI.L <- NA
CI <- data.frame(theta.hat = theta.hat, CI.L = CI.L, CI.U = CI.U)

head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence interval for product of proportions"))
if(length(pi.1) > 1) head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence intervals for product of proportions"))
if(bonf == TRUE & length(pi.1) > 1) head <- paste(head, "\nBonferroni-adjusted intervals")
ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
res<-list(SE=ifelse(avail.known ==TRUE & wald==TRUE, sigma.hat.W, sigma.hat.I), ci=CI, ends=ends, head=head)
class(res)<-"ci"
res
}

see.cor.range.tck <-function(sd = .5){

old.par <- par(no.readonly = TRUE)
 if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") {dev.new(noRStudioGD = TRUE)}
draw.cor.range <- function(y1, y2, a = 0, b = 2, col.arg = TRUE){
dev.hold()
plot(y1, y2, xlab=expression(italic(Y)[1]),ylab=expression(italic(Y)[2]), type = "n")
if(col.arg==TRUE) col = rgb(red=0.4,blue=0.4,green=0.5,alpha=.9)
if(col.arg==FALSE) col = rgb(red=0.5,blue=0.5,green=0.5)

ny1 <- c(y1[y1 >= a & y1 <= b])
ny2 <- c(y2[y1 >= a & y1 <= b])
rect(a,-10, b, 10, col=col)
points(y1, y2)
points(ny1, ny2, pch = 19)

legend("topleft", bty = "n", title = expression(paste("     ",italic(r),"        ",italic(r[k]), "       ",italic(r[s]))), legend = c(paste(round(cor(y1, y2), 2),round(cor(y1, y2, method = "k"), 2), round(cor(y1, y2, method = "s"), 2)),
paste(round(cor(ny1, ny2), 2),round(cor(ny1, ny2, method = "k"),2), round(cor(ny1, ny2, method = "s"),2))), pch = c(1, 19))
dev.flush()
}

y1 <- runif(50,-3,3)
y2 <- y1
for(i in 1 : length(y1)){
y2[i] <- y1[i] + rnorm(1,sd = sd)}


    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    a <- 0
    b <- 1
    assign("a", tclVar(a), envir= slider.env)
    assign("b", tclVar(b), envir= slider.env)
    color<-tclVar(1)
    norm.refresh <- function(...) {
        a <- as.numeric(evalq(tclvalue(a), envir= slider.env))
        b <- as.numeric(evalq(tclvalue(b), envir= slider.env))
        color <- as.logical(tclObj(color))
        draw.cor.range(y1 = y1, y2 = y2, as.numeric(a), as.numeric(b), col.arg = color)
        }

        tclServiceMode(TRUE)
    m <- tktoplevel()
    col.cbut <- tkcheckbutton(m, text="Color", variable=color)
    tkwm.title(m, "The effect of range on correlation")
    tkpack(tklabel(m, text = "      Effect of range on correlation      "))

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "lower range", font = c("Helvetica",
        "9"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 0, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = a), envir= slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "upper range", font = c("Helvetica",
        "9"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = b), envir= slider.env)


    tkpack(col.cbut)
    norm.refresh()
    on.exit(par(old.par))
    invisible()
        }

selftest.typeIISS.tck1 <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Type II and III SS")
  size(w) <- c(700, 950)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  #------------- Question 1 -----------#

  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We would use type II or III sums of squares whenever...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  

  ans1 <- c("(a)  We have an unbalanced one way ANOVA format.",
            "(b)  We have a quantitative predictor.",
            "(c)  We have a balanced multiway ANOVA format.",
            "(d)  We have either an unbalanced multiway ANOVA format, or some other multiple X format with at least one \n       quantitative X variable.")
  
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
}

anm.ci <- function (parent=expression(rnorm(n)), par.val, conf = 0.95, sigma = NULL, par.type = c("mu",
    "median", "sigma.sq", "p"), n.est = 100, n = 50, err.col = 2, par.col = 4, interval = 0.1,
    ...)
{

  if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
    {dev.new(noRStudioGD = TRUE)}

  ci <- matrix(ncol = 3, nrow = n.est)
    names <- c(expression(mu), "Pop. Median", expression(sigma^2),
       expression(pi))
    for (i in 1:n.est) {
        x <- sample(eval(parent), size = n, replace = FALSE)
        if (par.type == "mu") {
            if (!is.null(sigma)) {
                cint <- ci.mu.z(x, conf, sigma)
                ci[i, ] <- c(cint$ci[1], cint$ci[2], cint$ci[3])
            }
            if (is.null(sigma)) {
                cint <- ci.mu.t(x, conf)
                ci[i, ] <- c(cint$ci[1], cint$ci[2], cint$ci[3])
            }
        }
        if (par.type == "median") {
            cint <- ci.median(x, conf)
            ci[i, ] <- c(cint$ci[1], cint$ci[2], cint$ci[3])
        }
        if (par.type == "sigma.sq") {
            cint <- ci.sigma(x, conf)
            ci[i, ] <- c(cint$ci[1], cint$ci[2], cint$ci[3])
        }
        if (par.type == "p") {
            cint <- ci.p(x, conf)
            ci[i, ] <- c(cint$ci[1], cint$ci[2], cint$ci[3])
        }
    }
    lcol <- matrix(nrow = n.est, ncol = 1)
    for (i in 1:n.est) {
        lcol[i] <- ifelse(ci[, 2][i] < par.val & ci[, 3][i] >
            par.val, 1, err.col)
    }

    dev.hold()
    plot(ci[, 1], seq(1, n.est), xlim = c(min(ci[, 2]), max(ci[,
        3])), type = "n", xlab = "Point and interval estimates",
        ylab = "Estimate number", ...)
    abline(v = par.val, lty = 2, col = par.col)
    if (par.type == "mu")
        mtext(names[1], 3, at = par.val, font = 3, line = 0.1)
    if (par.type == "median")
        mtext(names[2], 3, at = par.val, font = 3, line = 0.1)
    if (par.type == "sigma.sq")
        mtext(names[3], 3, at = par.val, font = 3, line = 0.1)
    if (par.type == "p")
        mtext(names[4], 3, at = par.val, font = 3, line = 0.1)
    for (i in 1:n.est) {
        points(ci[, 1][i], i, pch = 19, cex = 0.6, col = lcol[i])
        segments(x0 = ci[, 2][i], x1 = ci[, 3][i], y0 = i, y1 = i,
            col = lcol[i])
        dev.flush()
        Sys.sleep(interval)
    }
    mtext(bquote(paste("Obs. cvg. = ", .(round(sum(sapply(lcol ==
        1, sum))/n.est, 2)))), 3, at = max(ci[, 3]), adj = 1,
        line = 1)
    mtext(bquote(paste("Conf. = ", .(conf))), 3, at = min(ci[,
        2]), adj = 0, line = 1)
}

trim.test<-function(Y,X,tr=.2){
n.i<-tapply(Y,X,length)
r<-nlevels(X)
Xn<-as.numeric(X)
h<-matrix(nrow=r,ncol=1)
d<-matrix(nrow=r,ncol=1)
for(i in 1:r){
h[i]<-length(trim.me(Y[Xn==i],trim=tr))
h}
for(i in 1:r){
d[i]<-((n.i[i]-1)*var(win(Y[Xn==i])))/(h[i]*(h[i]-1))
d
}
w<-1/d
U<-sum(w)
X.tilda<-(1/U)*sum(w*as.matrix(tapply(Y,X,function(x){mean(x,tr)})))
A<-(1/(r-1))*sum(w*as.matrix((tapply(Y,X,function(x){mean(x,tr)})-X.tilda)^2))
B<-(2*(r-2)/(r^2-1))*sum(((1-w/U)^2)/h)
F.star<-A/(1+B)
nu1<-r-1
nu2<-1/((3/(r^2-1))*sum(((1-(w/U))^2)/(h-1)))
res<-list()
res$Results<-data.frame(nu1=nu1,nu2=nu2,F=F.star,P.val=pf(F.star,nu1,nu2,lower.tail=FALSE))
colnames(res$Results)<-c("df1","df2","F*","P(>F)")
res
}

modlevene.test<-function(y, x){
medians<-sapply(split(y,x),median,na.rm=TRUE)
resid.y<-abs(y-medians[x])
res<-list()
res<-anova(lm(resid.y~x))
class(res) <- "mltest"
res}

print.mltest <- function(x, ...){
df1 <- paste("df1 =", x$"Df"[1])
df2 <- paste("df2 =", x$"Df"[2])
F <-  paste("F =", round(x$"F value"[1], 5))
P <- paste("p-value =", round(x$"Pr(>F)"[1], 5))  
out <- paste(df1, df2, F, P, sep = ",  ")
cat("\n")
cat("Modified Levene's test of homogeneity of variances","\n")
cat("\n")
cat(out)
invisible(x)
}

bound.angle<-function(X,Y,nX,nY){
rX<-nX-X
rY<-nY-Y
theta<-atan(rY/rX)*180/pi
  qrat<-function(rX,rY){
  if(rX==0&rY==0){q=NA} 
  if(rX>0&rY>0){q=1} else
  if(rX<0&rY>0){q=2} else
  if(rX<0&rY<0){q=3} else
  if(rX>0&rY<0){q=4} else
  if(rX==0&rY>0){q=1} else
  if(rX==0&rY<0){q=4} else
  if(rX>0&rY==0){q=3} else
  if(rX<0&rY==0){q=3} 
  q
  }
qm<-matrix(ncol=1,nrow=length(rX))
  for(i in 1: length(rX)){
  qm[i]<-qrat(rX[i],rY[i])
  if(is.na(qm[i])){theta[i]=NA} else
  if(qm[i]==1){theta[i]=theta[i]} else
  if(qm[i]==2){theta[i]=abs(theta[i])+90} else
  if(qm[i]==3&theta[i]!=0){theta[i]=-180+abs(theta[i])} else
  if(qm[i]==3&theta[i]==0){theta[i]=180}
  if(qm[i]==4){theta[i]=theta[i]}
  }
theta<-data.frame(near.angle=theta)
theta
}

Bayes.disc<-function(Likelihood,Prior,data.name="data",plot=TRUE,c.data=seq(1,length(Prior)),...){
Posterior<-(Likelihood*Prior)/sum(Likelihood*Prior)
if(plot==TRUE){
x<-seq(1,length(Prior))
old.par <- par(no.readonly = TRUE)
dev.new(height=6,width=4);par(mfrow=c(3,1),mar=c(2,4,0.5,2),cex=.9)
f1<-plot(x,Likelihood,type="h",col=gray(.5),lwd=6,xaxt="n",xlab="",...);grid(f1)
mtext(paste(data.name,c.data,sep="|"),side=1,at=x,cex=.9)
f2<-plot(x,Prior,type="h",col=gray(.5),xaxt="n",lwd=6,xlab="",...);grid(f2)
mtext(c.data,side=1,at=x,cex=.9)
f3<-plot(x,Posterior,type="h",col=1,lwd=6,xaxt="n",xlab="",...);grid(f3)
mtext(paste(c.data,data.name,sep="|"),side=1,at=x,cex=.9)
on.exit(par(old.par))
}
res<-rbind(Likelihood,Prior,Posterior)
colnames(res)<-c.data
res
}

bv.boxplot<-function(X, Y, robust=TRUE, D = 7, xlab="X", ylab="Y", pch = 21, 
pch.out = NULL, bg = "gray", bg.out = NULL, hinge.col = 1, fence.col = 1, 
hinge.lty = 2, fence.lty = 3, xlim = NULL, ylim = NULL, names = 1:length(X), 
ID.out = FALSE, cex.ID.out = 0.7, uni.CI = FALSE, uni.conf = 0.95, 
uni.CI.col = 1, uni.CI.lty = 1, uni.CI.lwd = 2, show.points = TRUE, ...){
if(length(X) != length(Y)) stop("X and Y must have equal length")
biweight<-function(a,const1=9,const2=36,err=0.0001){ ###From Everitt (2004)
              x<-a[,1]
              y<-a[,2]
              n<-length(x)
              mx<-median(x)
              my<-median(y)
              madx<-median(abs(x-mx))
              mady<-median(abs(y-my))
              if(madx != 0) { ux<-(x-mx)/(const1*madx)
                              ux1<-ux[abs(ux)<1]
                              tx<-mx+(sum((x[abs(ux)<1]-mx)*(1-ux1*ux1)^2)/
                                     sum((1-ux1^2)^2))
                              sx<- sqrt(n)*sqrt(sum((x[abs(ux)<1]-mx)^2*
                                   (1-ux1*ux1)^4))/abs(sum((1-ux1*ux1)*
                                    (1-5*ux1*ux1)))
                             }
                  else { tx<-mx
                         sx<-sum(abs(x-mx))/n
                       }
              if(mady != 0) { uy<-(y-my)/(const1*mady)
                              uy1<-uy[abs(uy)<1]
                              ty<-my+(sum((y[abs(uy)<1]-my)*(1-uy1*uy1)^2)/
                                     sum((1-uy1^2)^2))
                              sy<- sqrt(n)*sqrt(sum((y[abs(uy)<1]-my)^2*
                                   (1-uy1*uy1)^4))/abs(sum((1-uy1*uy1)*
                                    (1-5*uy1*uy1)))
                             }
                  else { ty<-my
                         sy<-sum(abs(y-my))/n
                       }
               z1<-(y-ty)/sy+(x-tx)/sx
               z2<-(y-ty)/sy-(x-tx)/sx
              mz1<-median(z1)
              mz2<-median(z2)
              madz1<-median(abs(z1-mz1))
              madz2<-median(abs(z2-mz2))
              if(madz1 != 0) { uz1<-(z1-mz1)/(const1*madz1)
                              uz11<-uz1[abs(uz1)<1]
                           tz1<-mz1+(sum((z1[abs(uz1)<1]-mz1)*(1-uz11*uz11)^2)/
                                     sum((1-uz11^2)^2))
                              sz1<- sqrt(n)*sqrt(sum((z1[abs(uz1)<1]-mz1)^2*
                                   (1-uz11*uz11)^4))/abs(sum((1-uz11*uz11)*
                                    (1-5*uz11*uz11)))
                             }
                  else { tz1<-mz1
                         sz1<-sum(abs(z1-mz1))/n
                       }
              if(mady != 0) { uz2<-(z2-mz2)/(const1*madz2)
                              uz21<-uz2[abs(uz2)<1]
                          tz2<-mz2+(sum((z2[abs(uz2)<1]-mz2)*(1-uz21*uz21)^2)/
                                     sum((1-uz21^2)^2))
                              sz2<- sqrt(n)*sqrt(sum((z2[abs(uz2)<1]-mz2)^2*
                                   (1-uz21*uz21)^4))/abs(sum((1-uz21*uz21)*
                                    (1-5*uz21*uz21)))
                             }
                  else { tz2<-mz2
                         sz2<-sum(abs(z2-mz2))/n
                       }
              esq<-((z1-tz1)/sz1)^2+((z2-tz2)/sz2)^2
              w<-numeric(length=n)
              c2<-const2
              for(i in 1:10) {
              w[esq<const2]<-(1-esq[esq<const2]/const2)^2
              w[esq>=const2]<-0
              l<-length(w[w==0])
              if(l<0.5*n) break
                  else const2<-2*const2
                            }
               tx<-sum(w*x)/sum(w)
               sx<-sqrt(sum(w*(x-tx)^2)/sum(w))
               ty<-sum(w*y)/sum(w)
               sy<-sqrt(sum(w*(y-ty)^2)/sum(w))
               r<-sum(w*(x-tx)*(y-ty))/(sx*sy*sum(w))
               const2<-c2
               wold<-w
            for(i in 1:100) {
                     z1<-((y-ty)/sy+(x-tx)/sx)/sqrt(2*(1+r))
                     z2<-((y-ty)/sy-(x-tx)/sx)/sqrt(2*(1+r))
                     esq<-z1*z1+z2*z2
                     for(j in 1:10) {
                                    w[esq<const2]<-(1-esq[esq<const2]/const2)^2
                                    w[esq>=const2]<-0
                                    l<-length(w[w==0])
                                    if(l<0.5*n) break
                                         else const2<-2*const2
                                     }
               tx<-sum(w*x)/sum(w)
               sx<-sqrt(sum(w*(x-tx)^2)/sum(w))
               ty<-sum(w*y)/sum(w)
               sy<-sqrt(sum(w*(y-ty)^2)/sum(w))
               r<-sum(w*(x-tx)*(y-ty))/(sx*sy*sum(w))
               term<-sum((w-wold)^2)/(sum(w)/n)^2
               if(term<-err) break
                    else {wold<-w
                          const2<-c2
                         }
                             }
            param<-c(tx,ty,sx,sy,r)
            param
}

if(robust == TRUE){
bw <- biweight(cbind(X,Y))
R <- bw[5]
S.X <- bw[3]
S.Y <- bw[4]
X.loc <- bw[1]
Y.loc <- bw[2]
}
if(robust == FALSE){
R <- cor(X, Y)
S.X <- sd(X)
S.Y <- sd(Y)
X.loc <- mean(X)
Y.loc <- mean(Y)
}
X.stan <-(X - X.loc)/S.X
Y.stan <-(Y - Y.loc)/S.Y

E.i <- sqrt((X.stan^2 + Y.stan^2 - 2 * R * X.stan * Y.stan)/(1 - R^2))
E.m <- median(E.i)
E.max <- max(E.i[E.i^2 < D * E.m^2])

#Fence
R1f <- E.max * sqrt((1 + R)/2)
R2f <- E.max * sqrt((1 - R)/2)
theta <- seq(2, 360, by = 2)
theta.rad <-(theta * pi)/180
Theta1 <- R1f * cos(theta.rad)
Theta2 <- R2f * sin(theta.rad)
X.pf <- X.loc + (Theta1 + Theta2) * S.X
Y.pf <- Y.loc + (Theta1 - Theta2) * S.Y

#Hinge
R1 <- E.m * sqrt((1 + R)/2)
R2 <- E.m * sqrt((1 - R)/2)
Theta1 <- R1 * cos(theta.rad)
Theta2 <- R2 * sin(theta.rad)
X.p <- X.loc + (Theta1 + Theta2) * S.X
Y.p <- Y.loc + (Theta1 - Theta2) * S.Y


fmmx <- c(min(X.pf), max(X.pf))
fmmy <- c(min(Y.pf), max(Y.pf))

b1 <- (R * S.Y)/S.X
a1 <- Y.loc - b1 * X.loc
Y1 <- a1 + b1 * min(fmmx)
Y2 <- a1 + b1 * max(fmmx)
b2 <- (R * S.X)/S.Y
a2 <- X.loc - b2 * Y.loc
X1 <- a2 + b2 * min(fmmy)
X2 <- a2 + b2 * max(fmmy)
maxx <- max(c(max(X), max(fmmx), X1, X2))
minx <- min(c(min(X), min(fmmx), X1, X2))
maxy <- max(c(max(Y), max(fmmy), Y1, Y2))
miny <- min(c(min(Y), min(fmmy), Y1, Y2))
if(is.null(xlim)) xlim <- c(minx, maxx) 
if(is.null(ylim)) ylim <- c(miny, maxy)
plot(X, Y,  xlab = xlab, ylab = ylab, type = "n", xlim = xlim, ylim = ylim)
lines(X.pf, Y.pf, lty = fence.lty, col = fence.col)
lines(X.p, Y.p, lty = hinge.lty, col = hinge.col)
segments(min(fmmx), Y1, max(fmmx), Y2, lty = 1)
segments(X1, min(fmmy), X2, max(fmmy), lty = 1)

#------- Outlier ID ---------------#
bool <- ifelse(E.i > E.max, "out", "in")

if(is.null(pch.out)) pch.out <- pch
if(is.null(bg.out)) bg.out <- bg
pch <- ifelse(bool == "in", pch, pch.out)
bg <- ifelse(bool == "in", bg, bg.out)

if(show.points == TRUE) points(X, Y, pch = pch, bg = bg, ...)

outl <- data.frame(X = X, Y = Y)[bool == "out",] 
if(ID.out == TRUE){pos <- 2; if(nrow(outl) > 2) pos <-  thigmophobe(outl$X,outl$Y)
text(outl$X, outl$Y, row.names(outl), pos = pos, cex = cex.ID.out)}

if(uni.CI == TRUE){
cX <- ci.median(X, conf = uni.conf)$ci
cY <- ci.median(Y, conf = uni.conf)$ci
yjust <- abs(par("usr")[1]-par("usr")[2])*.02
xjust <- abs(par("usr")[3]-par("usr")[4])*.02
segments(par("usr")[1]+yjust,cY[2], par("usr")[1]+yjust,cY[3],lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
segments(cX[2],par("usr")[3]+xjust,cX[3], par("usr")[3]+xjust,lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
segments(par("usr")[1]+(.5*yjust),cY[2],par("usr")[1]+(yjust+.5*yjust),cY[2],lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
segments(par("usr")[1]+(.5*yjust),cY[3],par("usr")[1]+(yjust+.5*yjust),cY[3],lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
segments(cX[2],par("usr")[3]+(.5*xjust), cX[2],par("usr")[3]+(xjust+.5*xjust), lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
segments(cX[3],par("usr")[3]+(.5*xjust), cX[3],par("usr")[3]+(xjust+.5*xjust), lwd=uni.CI.lwd, lty = uni.CI.lty, col = uni.CI.col)
}
invisible(list(centroid = c(X.loc, Y.loc), scale = c(S.X, S.Y), correlation = R, E.median = E.m, E.max = E.max, outliers = outl))
}

 

see.regression.tck <- function ()
{
  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    beta0 <- 0
    assign("beta0", tclVar(beta0), envir = slider.env)
    beta1 <- 0.6
    assign("beta1", tclVar(beta1), envir = slider.env)
    sigma <- 2
    assign("sigma", tclVar(sigma), envir = slider.env)
    n <- 5
    assign("n", tclVar(n), envir = slider.env)


xpts<- c(5,15)

dev.new(height = 5, width = 10, noRStudioGD = TRUE)

plot_it<-function(...){

dev.hold()
        beta0 <- as.numeric(evalq(tclvalue(beta0), envir = slider.env))
        beta1 <- as.numeric(evalq(tclvalue(beta1), envir = slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma), envir = slider.env))
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))

X<-Y<-0:20; Z<-seq(0,.6,.03)
pts <- runif(n, 0, 20)


layout(matrix(c(1,1,1,1,1,1,2,2,2,2), 1, 10, byrow = TRUE))
e<-scatterplot3d(X,Y,Z,scale.y=1.75,type="n",angle=50,xlab=expression(italic(x)),ylab=expression(italic(y)),
zlab=expression(paste(italic(f),"(",italic(y),")", sep = "")),lty.hide=0,box=FALSE, mar = c(3, 3, 0, 2))
e$points3d(seq(0,20),(beta1*seq(0,20))+beta0, rep(0,21),type="l",lwd=2) #true reg. line

for(i in 1:length(xpts)){
R1 <- seq(max(((beta1*xpts[i])+beta0)-3*sigma, -5),min(((beta1*xpts[i])+beta0)+3*sigma, 25), .1)
L1 <- length(R1)
e$points3d(rep(xpts[i],L1),R1,dnorm(R1,beta1*xpts[i]+beta0,sigma),type="l")
e$points3d(rep(xpts[i],L1),R1,rep(0,L1),type="l")
e$points3d(rep(xpts[i],L1),rep(beta1*xpts[i]+beta0,L1),seq(0,round(dnorm(beta1*xpts[i]+beta0,beta1*xpts[i]+beta0,sigma),3),length=L1),type="l")
}

epsilon <- matrix(nrow = n, ncol = 1)
loc <- matrix(nrow = n, ncol = 1)

for(i in 1:n){
loc[i] <- rnorm(1, beta1*pts[i]+beta0, sigma)
epsilon[i] <- (loc[i] - beta1*pts[i]+beta0)^2
e$points3d(pts[i],loc[i],0, pch=16)
e$points3d(rep(pts[i], 20), seq(loc[i], beta1*pts[i]+beta0, length = 20), rep(0,20),type="l",col="red",lty=2)
}

text(3, 10.75, "Population regression line", cex=1.6)
text(3, 9.5, bquote(paste(italic(E),"(",italic(Y[i]),") = ", .(beta0), " + ", .(beta1),italic(X[i]),sep="")), cex=1.5)
text(3, 8.75, bquote(paste(italic(epsilon[i]), " ~ ", italic(N), "(0, ", .(sigma^2),")", sep = "")), cex=1.5)
text(3, 8, bquote(paste(italic(E), "(", italic(MSR), ") = ", .(sigma^2 + beta1^2 * sum((pts-mean(pts))^2)), ",   ", italic(E), "(", italic(MSE), ") = ", .(sigma^2),sep = "")), cex=1.5)

reg <- lm(loc ~ pts)
par(mar = c(5,4,8,3))
p <- plotCI.reg(pts, loc, CI = FALSE, PI = FALSE, resid = TRUE, resid.col=2, resid.lty=2, pch = 16, cex=1.2, cex.lab=1.4, cex.axis=1.4, xlab = expression(italic(x)), ylab = expression(italic(y)))
b <- round(coef(p), 2)
MS <- round(anova(p)$"Mean Sq", 2)
P <- round(anova(p)$"Pr(>F)"[1], 3)

mtext(side = 3, "Sample regression line", cex=1, line = 6)
mtext(side = 3, bquote(paste(italic(Y[i])," = ", .(b[1]), " + ", .(b[2]),italic(X[i]),sep="")), cex=.9, line = 3)
mtext(side = 3, bquote(paste(italic(MSR), " = ", .(MS[1]), ",   ", italic(MSE), " = ", .(MS[2]),",   ", italic(P),"-value = ", .(P), sep = "")), cex=.9, line = 1)
dev.flush()
}


tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing regression")
    tkpack(tklabel(m, text = "      Visualizing regression      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03B2\u2080", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = plot_it, from = -3,
        to = 14, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = beta0), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03B2\u2081", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = plot_it, from = -0.5,
        to = 1, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = beta1), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C3", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = plot_it, from = 0.1,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = sigma), envir = slider.env)

   tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = plot_it, from = 2,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)


    tkpack(tkbutton(m, text = "Refresh", command = plot_it),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    on.exit(par(old.par))
    plot_it()
}

r.pb<-function(X,Y,beta=0.2){
    n<-nrow(as.matrix(X))
  prc<-function(V){
    W.i<-abs(V-median(V))
    W.pi<-sort(W.i)
    m<-floor((1-beta)*n)
    w.hat<-W.pi[m]
    i<-(V-median(V))/w.hat
    i.1<-length(i[i<(-1)])
    i.2<-length(i[i>1])
    S.i<-ifelse(i>1|i<(-1),0,V)
    theta.hat<-(w.hat*(i.2-i.1)+sum(S.i))/(n-i.1-i.2)
    U.i<-(V-theta.hat)/w.hat
    U.i
    }
  U<-prc(X)
  V<-prc(Y)
  A<-sapply(U,function(x){max(-1,min(1,x))})
  B<-sapply(V,function(x){max(-1,min(1,x))})
  R<-sum(A*B)/sqrt(sum(A^2)*sum(B^2))
  TS<-R*sqrt((n-2)/(1-R^2))
  P<-pt(abs(TS),df=n-2,lower.tail=FALSE)*2
  res<-data.frame(r.bp=R,TS=TS,P=P)
  names(res)<-c("r.bp","t*","P(T>t*)")
  res
}

selftest.H0.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Null hypotheses")
  size(w) <- c(700, 1000)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  # q1 <- gexpandgroup("Question 1", container=g)
  # q2 <- gexpandgroup("Question 2", container=g, anchor=c(-1,1))
  # q3 <- gexpandgroup("Question 3", container=g, anchor=c(-1,1))
  # q4 <- gexpandgroup("Question 4", container=g, anchor=c(-1,1))
  # q5 <- gexpandgroup("Question 5", container=g, anchor=c(-1,1))
  # q6 <- gexpandgroup("Question 6", container=g, anchor=c(-1,1))

  # visible(q1) <- FALSE
  # visible(q2) <- FALSE
  # visible(q3) <- FALSE
  # visible(q4) <- FALSE
  # visible(q5) <- FALSE
  # visible(q6) <- FALSE
  # 
  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("I reject H\u2080 but H\u2080 is true.  This is a...", container = gp1.1, horizontal = TRUE)
  font(qq) <- list(family = "cambria", size = 11)
#  addSpace(gp1, .5)
  ans1 <- c("(a)  Type I error.",
            "(b)  Type II error.",
            "(c)  Type III error.",
            "(d)  None of the above.")

  f1 = function(h,....){
    if(svalue(r1) == ans1[1]){
      gmessage(msg="Correct")
    }
    if(svalue(r1) == ans1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r1) == ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r1) == ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
    r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  

  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We suspect that a soil N treatment will increase mean plant biomass compared to a control.  \nWhat would our alternative hypothesis be?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
   # addSpace(gp2, .5, horizontal=FALSE)
  ans2 <- c("(a) \u03BCN < \u03BCControl.",
            "(b) \u03BCN > \u03BCControl.",
            "(c) \u03BCN = \u03BCControl.",
            "(d) \u03BCN \u2260 \u03BCControl.")
  
  
  f2 <- function(h,....){
    if(svalue(r2) == ans2[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r2) == ans2[2]){
      gmessage(msg="Correct")
    }
    if(svalue(r2)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r2)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Statistical power is...",
         container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
 # addSpace(gp3, .5, horizontal=FALSE)
  ans3 <- c("(a)  1 - the probability of type I error",
            "(b)  1 - \u03B1\u00B2",
            "(c)  1 - the probability of type II error",
            "(d)  1/\u03B1")
  
  
  
  f3 <- function(h,....){
    if(svalue(r3) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(svalue(r3) == ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(svalue(r3) == ans3[3]){
      gmessage(msg="Correct")
    }
    if(svalue(r3) == ans3[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) A P-value requires a null hypothesis.",
         container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
#  addSpace(gp4, .5, horizontal=FALSE)
  ans4 <- c("T",
            "F")
  
  
  
  f4 <- function(h,....){
    if(svalue(r4) == ans4[1]){
      gmessage(msg="Correct")
    }
    if(svalue(r4) == ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }

r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)

  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A P-value is...",
         container = gp5.1, anchor = c(-1,1))
  
  font(qq) <- list(family = "cambria", size = 11)
  
#  addSpace(gp5, .5, horizontal=FALSE)
  ans5 <- c("(a)  The probability that the null hypothesis is true.",
            "(b)  The probability that the null hypothesis is false.",
            "(c)  The probability that the alternative hypothesis is false.",
            "(d)  P(data|H\u2080)")
  

  f5 <- function(h,....){
    if(svalue(r5) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(svalue(r5) == ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(svalue(r5) == ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(svalue(r5) == ans5[4]){
      gmessage(msg="Correct")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which of the following constitute a criticism of H\u2080 hypothesis testing?",
         container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
#  addSpace(gp6, .5, horizontal=FALSE)
  ans6 <- c("(a)  The sample space for the H\u2080 distribution may exceed what can be sampled.",
            "(b)  P-values represent P(data|H\u2080) not P(H\u2080|data).",
            "(c)  Evidence against H\u2080 may not imply evidence for the alternative.",
            "(d)  Significance levels (in significance testing) are arbitrary",
            "(e)  P-values are partially a function of sample size.",
            "(f)  All of the above.")

  f6 <- function(h,....){
    if(svalue(r6) == ans6[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(svalue(r6) == ans6[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(svalue(r6) == ans6[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(svalue(r6) == ans6[4]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(svalue(r6) == ans6[5]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(svalue(r6) == ans6[6]){
      gmessage(msg="Correct")
    }
    svalue(r6) <- character(0)
  }            
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)

}

pairw.kw <- function (y, x, conf = 0.95)
{
    comp <- !is.na(y)
    y <- y[comp]; x <- x[comp]
    ranks <- rank(y)
    fitted <- tapply(y, x, median)
    ni <- tapply(ranks, x, length)
    N <- length(ranks)
    r <- length(ni)

    z <- sort(match(ranks,ranks))
      t <- 0
      for (i in 1:(N - 1)) {
          tie.ranks <- sum(match(z, i),na.rm=T)
          if (tie.ranks > 1) t <- t + tie.ranks^3 - tie.ranks
          }

    mean.ranks <- tapply(ranks, x, mean)
    dif.mat <- outer(mean.ranks, mean.ranks, "-")
    diffs <- dif.mat[upper.tri(dif.mat)]
    
    ni.mat <- outer(1/ni, 1/ni, "+")
    ni.den <- ni.mat[upper.tri(ni.mat)]
    
    SE.diff <- sqrt(((N * (N + 1))/12 - t/(12 * (N - 1))) * ni.den)
    B <- qnorm(1 - ((1 - conf)/(r^2 - r)))
    p.val <- 2 * pnorm(abs(diffs)/SE.diff, lower.tail = FALSE)
    p.adj <- ifelse(p.val * ((r^2 - r)/2) >= 1, 1, round(p.val *
        ((r^2 - r)/2), 6))
    hwidths <- B * SE.diff
    val <- round(cbind(diffs, diffs - hwidths, diffs + hwidths),
        5)
    Decision <- ifelse((val[, 2] > 0 & val[, 3] > 0) | val[,
        2] < 0 & val[, 3] < 0, "Reject H0", "FTR H0")
    val <- as.data.frame(cbind(val, Decision, p.adj))
    lvl <- outer(levels(x), levels(x), function(x1, x2) {
        paste(x1, x2, sep = "-")
      })
    dimnames(val) <- list(lvl[upper.tri(lvl)], c("Diff", "Lower",
        "Upper", "Decision", "Adj. P-value"))
   head <- paste(paste(as.character(conf*100),"%",sep=""),c("Confidence intervals for Kruskal-Wallis comparisons"))
   ###
   res <- list()
   res$head <- head
   res$conf <- conf
   comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
   res$comp <- comp[upper.tri(comp)]
   res$summary <- val
   res$band <- cbind(diffs-hwidths, diffs+hwidths)
   res$fitted <- fitted
   res$x <- x
   res$y <- y
   res$method <- "kBonferroni"
   class(res)<-"pairw"
   res
    }

MS.test<-function(Y,X,reps){
orderm<-matrix(nrow=nrow(Y),ncol=ncol(Y))
for(i in 1:ncol(Y)){
orderm[,i]<-rank(Y[,i]) 
}
S<-matrix(ncol=1,nrow=max(X))
for(i in 1 :max(X)){
S[i]<-sum(orderm[X==i])/reps
}
N<-dim(Y)[1]*dim(Y)[2]
MS<-(12/(max(X)*(N+ncol(Y)))*sum(S^2))-3*(N+ncol(Y))
p.val<-pchisq(MS,max(X)-1,lower.tail = FALSE)
res<-data.frame(df=max(X)-1,MS=MS,Chi.sq_p.val=p.val)
colnames(res)<-c("df","MS.test.stat","P(Chi.sq>MS)")
res
}

press <- function(lm, as.R2 = FALSE){
X <- model.matrix(lm)
H <- X%*%(solve((t(X)) %*% (X))) %*% t(X)
e.i <- resid(lm)
if(as.R2 == FALSE) out <- sum((e.i/(1-diag(H)))^2)
if(as.R2 == TRUE) out <- 1 - (sum((e.i/(1-diag(H)))^2)/sum(anova(lm)$"Sum Sq"))
out
}

selftest.regchar.tck1 <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Basic regression characteristics")
  size(w) <- c(700, 650)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  #------------- Question 1 -----------#
 
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which of the following is a (are) linear model(s)?",
         container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans1 <- c("(a)  Y\u1d62 = \u03b2\u2092 + \u03b2\u2081X\u2081\u1d62 + \u03b2\u2082X\u2082\u1d62 + \u03b5\u1d62 ",
            "(b)  Y\u1d62 = \u03b2\u2092 + \u03b2\u2081X\u2081\u1d62 + \u03b2\u2082X\u00b2\u2081\u1d62 + \u03b5\u1d62 ",
            "(c)  Y\u1d62 = \u03b2\u2092X\u1d62/(\u03b2\u2081 + X\u1d62) + \u03b5\u1d62",
            "(d)  All of the above.",
            "(e)  (a) and (b) above.")

  f1 <- function(h,....){ 
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Correct")
    }
    svalue(r1) <- character(0)
  }
  
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
   
  
  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In simple linear regression, \u03b2\u2092 represents...",
               container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans2 <- c("(a)  The sample Y-intercept, i.e., the estimated mean value of Y when X = 0.",
            "(b)  The true (population) Y-intercept, i.e., the true mean value of Y when X = 0.",
            "(c)  The sample slope, i.e., the estimated change in Y given a one unit increase in X.",
            "(d)  The true (population) slope, i.e., the true change in Y given a one unit increase in X.")
  
  f2 <- function(h,....){ 
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    
    svalue(r2) <- character(0)
  }
  
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In simple linear regression, \u03b2\u2081 represents...",
               container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans3 <- c("(a)  The sample Y-intercept, i.e., the estimated mean value of Y when X = 0.",
            "(b)  The true (population) Y-intercept, i.e., the true mean value of Y when X = 0.",
            "(c)  The sample slope, i.e., the estimated change in Y given a one unit increase in X.",
            "(d)  The true (population) slope, i.e., the true change in Y given a one unit increase in X.")
  
  f3 <- function(h,....){ 
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Correct")
    }
    
    svalue(r3) <- character(0)
  }
  
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a multiple regression with two predictors, \u03b2\u2081 represents...",
               container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans4 <- c("(a)  The true change in X\u2081 given a one unit increase in Y.",
            "(b)  The true change in Y, given a one unit increase in X\u2081, holding X\u2082 constant.",
            "(c)  The true change in Y, given a one unit increase in X\u2081.",
            "(d)  The true change in Y, given a one unit increase in X\u2082, holding X\u2081 constant.")
  
  f4 <- function(h,....){ 
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    
    svalue(r4) <- character(0)
  }
  
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)  
  
 
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a regression model, I calculate a 95% confidence interval for E(Y\u2095).\n Which of the following is a correct interpretation?",
               container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans5 <- c("(a)  There is a probability of 0.95 that the true mean of Y, given the hth value of the predictors, is in the interval.",
            "(b)  I am 95% confident that a future value of Y, given the hth value of the predictors, is in the interval.",
            "(c)  I am 95% confident that the true slope is in the interval.",
            "(d)  I am 95% confident that the true mean value of Y, given the hth value of the predictors, is in the interval.")
  
  f5 <- function(h,....){ 
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Correct")
    }
    
    svalue(r5) <- character(0)
  }
  
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)  
  
 
 #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a regression model, I calculate a 95% prediction interval for Y\u2095.\n Which of the following is a correct interpretation?",
               container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans6 <- c("(a)  There is a probability of 0.95 that the true mean of Y, given the hth value of the predictors, is in the interval.",
            "(b)  I am 95% confident that a future value of Y, given the hth value of the predictors, is in the interval.",
            "(c)  I am 95% confident that the true slope is in the interval.",
            "(d)  I am 95% confident that the true mean value of Y, given the hth value of the predictors, is in the interval.")
  
  f6 <- function(h,....){ 
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    
    svalue(r6) <- character(0)
  }
  
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)  
  
  
  
  #------------- Question 7 -----------#
  
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The sum of squared error (SSE) of a regression model is...",
               container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans7 <- c("(a)  The sum of squared differences of the fitted Y and the mean Y, i.e., \u03A3(\u0176 - \u0232)\u00B2.",
            "(b)  The sum of squared differences of the observed Y and fitted Y, i.e., \u03A3(Y - \u0176)\u00B2.",
            "(c)  The sum of squared differences of the observed Y and the mean Y, i.e., \u03A3(Y - \u0232)\u00B2.",
            "(d)  The sum of squared differences of the mean Y and the observed Y, i.e., \u03A3(\u0232 - Y)\u00B2.")
  
  f7 <- function(h,....){ 
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect,  this is the regression sum of squares, SSR.",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Correct, this denotes the sum of the squared residuals.")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect,  this is the total sum of squares, SSTO.",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect, this is equilent to answer c, it is the SSTO.",  icon = "error")
    }
    
    svalue(r7) <- character(0)
  }
  
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)  
  
  
  
  #------------- Question 8 -----------#
  
  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Let n be the number of observations, and p be the number of estimated parameters in\n a regression model. The equation for MSE is...",
               container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans8 <- c("(a)  SSE/(n - 1).",
            "(b)  SSE/(p - 1).",
            "(c)  SSE/(n - p).",
            "(d)  SSE/(p - n).")
  
  f8 <- function(h,....){ 
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Correct,  the degrees of freedom for SSE is n - p.")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    
    svalue(r8) <- character(0)
  }
  
  
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)  
  
  
 
  #------------- Question 9 -----------#
  
  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("MSE is an estimator for...",
               container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans9 <- c("(a)  The true mean of X given Y",
            "(b)  E(Y), the true mean of Y given X.",
            "(c)  The true variance of X.",
            "(d)  The true variance of the error term in the model.")
  
  f9 <- function(h,....){ 
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Correct.")
    }
    
    svalue(r9) <- character(0)
  }
  
  
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)  


  
  #------------- Question 10 -----------#
  
  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Consider the matrix expression of a general linear model:",
               container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  qq1 <- glabel("Y = \u03b2X + \u03b5.",
               container = gp10.1, anchor = c(-1,1))
  font(qq1) <- list(family = "cambria", size = 11, weight = "bold")
  qq2 <- glabel("\u03b2",
                container = gp10.1, anchor = c(-1,1))
  font(qq2) <- list(family = "cambria", size = 11, weight = "bold")
  qq3 <- glabel("has dimension...",
                container = gp10.1, anchor = c(-1,1))
  font(qq3) <- list(family = "cambria", size = 11)
  
  ans10 <- c("(a)  (n x p).",
            "(b)  (n x 1).",
            "(c)  (p x 1).",
            "(d)  (p x n).")
  
  f10 <- function(h,....){ 
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r10) <- character(0)
  }
  
  
  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)  
  

  
  
  #------------- Question 11 -----------#
  
  gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Consider the matrix expression of a general linear model:",
               container = gp11.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  qq1 <- glabel("Y = \u03b2X + \u03b5.",
                container = gp11.1, anchor = c(-1,1))
  font(qq1) <- list(family = "cambria", size = 11, weight = "bold")
  qq2 <- glabel("X",
                container = gp11.1, anchor = c(-1,1))
  font(qq2) <- list(family = "cambria", size = 11, weight = "bold")
  qq3 <- glabel("has dimension...",
                container = gp11.1, anchor = c(-1,1))
  font(qq3) <- list(family = "cambria", size = 11)
  
  ans11 <- c("(a)  (n x p).",
             "(b)  (n x 1).",
             "(c)  (p x 1).",
             "(d)  (p x n).")
  
  f11 <- function(h,....){ 
    if(tail(svalue(r11),1) == ans11[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r11),1)== ans11[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[3]){
      gmessage(msg="Inorrect",  icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r11) <- character(0)
  }
  
  
  r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)  

  
  
  #------------- Question 12 -----------#
  
  gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The coefficient of determinination, R\u00B2...",
               container = gp12.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans12 <- c("(a)  will be in the range [0, 1].",
             "(b)  is calculated as 1 - SSE/SSTO.",
             "(c)  represents the proportion of variability in Y explained by the model.",
             "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
             "(e)  (a) and (c) above.",
             "(f)  All of the above.")
  
  f12 <- function(h,....){ 
    if(tail(svalue(r12),1) == ans12[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[4]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[5]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[6]){
      gmessage(msg="Correct")
    }
    svalue(r12) <- character(0)
  }
  
  
  r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)  

  
  #------------- Question 13 -----------#
  
  gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The adjusted R\u00B2...",
               container = gp13.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans13 <- c("(a)  will be identical to R\u00B2 in most situations.",
             "(b)  will occasionally be larger than R\u00B2.",
             "(c)  adjusts for the number of parameters in the model.",
             "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
             "(e)  (a) and (c) above.",
             "(f)  All of the above.")
  
  f13 <- function(h,....){ 
    if(tail(svalue(r13),1) == ans13[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r13),1)== ans13[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[6]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r13) <- character(0)
  }
  
  
  r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)  
  

  #------------- Question 14 -----------#
  
  gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The partial R\u00B2...",
               container = gp14.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans14 <- c("(a)  measures the reduction in SSE after a variable of interest is added to model.",
             "(b)  will occasionally be larger than R\u00B2.",
             "(c)  requires the specification of a nested model (that lacks a variable of interest) and a reference (full) model.",
             "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
             "(e)  (a) and (c) above.",
             "(f)  All of the above.")
  
  f14 <- function(h,....){ 
    if(tail(svalue(r14),1) == ans14[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[5]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r14),1)== ans14[6]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r14) <- character(0)
  }
  
  
  r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)  
  

  
  
  #------------- Question 15 -----------#
  
  gp15 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An ANOVA approach for assessing the affect of individual predictors in multiple regression\n is problematic because...",
               container = gp15.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans15 <- c("(a)  Sums of squares and p-values will vary depending on the order predictors are specified in the linear model.",
             "(b)  Linear model algorithms typically use type I sums of squares which will be untrustworthy for assessing\n the affect of individual predictors.",
             "(c)  Type II sums of squares, which will provide consistent results, require the specification of a nested model\n (that lacks a variable of interest) and a reference (full) model.",
             "(d)  All of the above.")
  
  f15 <- function(h,....){ 
    if(tail(svalue(r15),1) == ans15[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[4]){
      gmessage(msg="Correct")
    }
      svalue(r15) <- character(0)
  }
  
  
  r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)  
  
  

  #------------- Question 16 -----------#
  
  gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In multiple regression we can assess the null hypothesis: H\u2080: \u03B2\u2081 = \u03B2\u2082 = , ... , = \u03B2\u209A\u02CD\u2081.  \nWhat is the null distribution for this test?",
               container = gp16.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans16 <- c("(a)  N(0, 1).",
             "(b)  t(n - p).",
             "(c)  t(p - n).",
             "(d)  F(p-1, n-p).",
             "(e)  F(n-p, p-1).")
  
  f16 <- function(h,....){ 
    if(tail(svalue(r16),1) == ans16[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[2]){
      gmessage(msg="Incorrect.  This is the null distribution for considering the effect of individual predictors.",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r16),1)== ans16[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r16) <- character(0)
  }
  
  
  r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)  
  

  
  #------------- Question 17 -----------#
  
  gp17 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp17.1 <- ggroup(container = gp17, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("17) ", container = gp17.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Why are predicted values a concern in multiple regression?",
               container = gp17.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans17 <- c("(a)  It is difficult to determine if new X outcomes from multiple predictors constitute extrapolated values.",
             "(b)  It is difficult to predict Y from multiple X variables.",
             "(c)  It is difficult to predict multiple Ys from a single X variable.",
             "(d)  The null distribution will not exist.")
  
  f17 <- function(h,....){ 
    if(tail(svalue(r17),1) == ans17[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r17),1)== ans17[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r17) <- character(0)
  }
  
  
  r17 <- gcheckboxgroup(ans17, container = gp17, checked = FALSE, where = "beginning", handler = f17)  
  
  
  
  
  
  
  
  
  
   
}  
  
  
  
  
  
  
  
   

anm.ls.reg<-function (X, Y, parameter = "slope",
    nmax=50, interval = 0.1, col = "red",...)
{

  old.par <- par(no.readonly = TRUE)

    lin.mod <- lm(Y ~ X)
    b0 <- summary(lin.mod)$coefficients[1]
    b1 <- summary(lin.mod)$coefficients[2]
    stb0 <- summary(lin.mod)$coefficients[3]
    stb1 <- summary(lin.mod)$coefficients[4]

    if(parameter == "intercept") {poss <- seq(b0 - (2 * stb0), b0 + (2 * stb0), length.out=nmax)}
    if(parameter == "slope"){poss <- seq(b1 - (2 * stb1), b1 + (2 * stb1), length.out=nmax)}

    fitted <- matrix(ncol = length(poss), nrow = length(X))
    if(parameter == "intercept") {for(i in 1:ncol(fitted)) fitted[,i] <- poss[i] + X * b1}
    if(parameter == "slope"){for(i in 1:ncol(fitted)) fitted[,i] <- b0 + poss[i] * X}

    sq.res <- matrix(nrow = length(X), ncol = length(poss))
    for (i in 1:length(poss)) {
        sq.res[, i] <- (fitted[,i] - Y)^2
    }
        ss.res <- apply(sq.res, 2, sum)

            dev.new(height = 4, width = 8, noRStudioGD = TRUE)
            par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)

               for (i in 1:length(poss)) {
                dev.hold()
                if(i < length(poss)){
                plot(X, Y)
                abline(b0, b1, lwd = 1.4)
                if(parameter == "intercept") abline(poss[i],b1, col="gray")
                if(parameter == "slope") abline(b0,poss[i], col="gray")
                segments(X, Y, X, fitted[,i],lty = 2, col = col)
                }

                if(i == length(poss)){
                plot(X, Y, xlab = expression(italic(X)), ylab=expression(italic(Y)))
                abline(b0, b1, lwd = 1.4)
                segments(X, Y, X, fitted(lin.mod),lty = 2, col = col)
                }

                plot(poss, ss.res, ylab = "Residual sum of squares", xlab =
                ifelse(parameter == "intercept","Intercept estimate","Slope estimate"), type = "n")
                arrows(poss[i], ss.res[i], poss[i + 1], ss.res[i + 1], col = col, length = 0.15, lwd = 1)
                points(poss[1:i], ss.res[1:i], lty = 2, col = col, lwd = 1, type = "l")

                if(i < length(poss)){
                legend("topright", legend = bquote(paste("SS = ", .(ss.res[i]))), cex = 0.9, bty = "n")
                }

                 if(i == length(poss)){
                legend("topright", legend = bquote(paste("SS = ", .(sum(resid(lin.mod)^2)))), cex = 0.9, bty = "n")
                }

                dev.flush()
                Sys.sleep(interval)
                }

           abline(v=ifelse(parameter=="intercept",b0,b1),lty=2)
           if(parameter=="intercept") legend("center",legend = bquote(paste(hat(beta[0])," = ",.(b0))),box.col="white", bg = "white",)
           if(parameter=="slope") legend("center",legend = bquote(paste(hat(beta[1])," = ",.(b1))),box.col="white", bg = "white")
           on.exit(par(old.par))
}

see.adddel<-function(){
message("Click on plot to add or delete points.  To stop function, click stop, then click on a point in the plot.")
action<-tclVar("add")
pts <- matrix(c(12, 56,
                20, 94,
                33, 98,
                32, 120,
                61, 180,
                75, 160,
                98, 223), ncol=2, byrow=TRUE)
x<-pts[,1]
y<-pts[,2]

old.par <- par(no.readonly = TRUE)

dev.new(height = 5, width= 5*1.4, noRStudioGD = TRUE)
par(mar=c(5,4,1,9),xpd=FALSE,bg="gray90")
plot(x,y,xlab=expression(italic(x)),ylab=expression(italic(y)),type="n")
pu<-par("usr")
rect(pu[1],pu[3],pu[2],pu[4],col="white")
points(x,y,pch=21,cex=1.2,bg="skyblue2")
l<-lm(y~x);co<-coef(l);c1<-summary(l)$coefficients;p<-c1[2,4]
abline(co[1],co[2])
par(xpd=TRUE)
legend(pu[2]+.5,pu[4],legend=c(paste(" Y int = ",round(co[1],4)),paste(" Slope = ",round(co[2],4)),"",paste(" r = ",round(cor(y,x),4)),paste(" r\u00b2 = ",round(cor(y,x)^2,4)),"",paste(" P-value = ",round(p,4))),box.col="gray90",cex=.8,bg="white")
box()

add.points<-function(){
if(action=="delete")m<-delete.points()
else{
loc<-locator(1)
x<-c(x,loc$x)
y<-c(y,loc$y)
cbind(x,y) }
}

delete.points<-function(){
ans<-identify(x,y, n=1, plot=FALSE)
x<-x[-ans]
y<-y[-ans]
cbind(x,y)
}

repeat{
    refresh<-function(){

        action<-tclvalue(action)
	   if(action=="stop") {stop()}
        else if(action=="add")m<-add.points()
        else if(action=="delete")m<-delete.points()
        tkdestroy(tt)
        x<<-m[,1];y<<-m[,2]
        dev.hold()
        par(xpd=FALSE)
        plot(x,y,xlab=expression(italic(x)),ylab=expression(italic(y)),type="n")
        pu<-par("usr")
        rect(pu[1],pu[3],pu[2],pu[4],col="white")
        points(x,y,pch=21,cex=1.2,bg="skyblue2")
        l<-lm(y~x);co<-coef(l);c1<-summary(l)$coefficients;p<-c1[2,4]
        abline(co[1],co[2])
        par(xpd=TRUE)
        legend(pu[2]+.5,pu[4],legend=c(paste(" Y int = ",round(co[1],4)),paste(" Slope = ",round(co[2],4)),"",paste(" r = ",round(cor(y,x),4)),paste(" r\u00b2 = ",round(cor(y,x)^2,4)),"",paste(" P-value = ",round(p,4))),box.col="gray90",cex=.8,bg="white")
        box()
        dev.flush()
        }

tclServiceMode(TRUE)
tt <- tktoplevel()
tkwm.geometry(tt, "+50+4")
tkwm.title(tt, "Demonstration of least squares regression -- Add/delete points")
tkpack(tklabel(tt,text="Adding/deleting points in\nsimple linear regression"))
tkpack(tklabel(tt,text=""))
tkpack(tklabel(tt, text = "  Action: "), side = "top")
        for ( i in c("add", "delete", "stop")){
            tmp <- tkradiobutton(tt, text=i, variable=action, value=i)
            tkpack(tmp, anchor = "w")}
tkpack(tkbutton(tt, text = "Exit", command = function()tkdestroy(tt)))
refresh()
}
on.exit(par(old.par))
}

anm.transM<-function(A,init,inter=100,stage.names =c("All grps",1:(ncol(A))),leg.room = 1.5,anim.interval=0.1,...){
A<-as.matrix(A)
m<-matrix(nrow=ncol(A),ncol=inter)
for (i in 2:inter){
m[,1]<-init
m[,i]<-A%*%m[,i-1]
}
n<-apply(m,2,sum)

if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
{dev.new(noRStudioGD = TRUE)}

for(i in 1:inter){
dev.hold()
fig<-plot(seq(1,inter),n,type="n",ylim=c(0,max(n)*leg.room),...);grid(fig)
lines(seq(1,i),n[1:i],col=1,lwd=3)
for(j in 1:ncol(A)){
points(seq(1:i),m[j,][1:i],col=1+j,type="l")
}
legend("topright",legend=stage.names,lwd=c(3,rep(1,ncol(A))),col=seq(1,(ncol(A)+1)),bg="white")
dev.flush()
Sys.sleep(anim.interval)
}
}

g.test <- function(y, correct = FALSE, pi.null = NULL){
  c <- chisq.test(y, correct = correct)
  E <- ifelse(is.null(pi.null), c$expected, pi.null * sum(y)) 
  temp <- log(y/E)
  temp <- ifelse(temp==-Inf,0, temp)

  G <- sum(y * temp) * 2
  Df <- c$parameter
  p.val <- pchisq(G, df = Df, lower.tail=FALSE)
  res <- list()
  res$head <- "Contingency table likelihood ratio test"
  res$summary <- data.frame(G = G, P = p.val)
  names(res$summary) <- c("G.statistic", "P-value")
  row.names(res$summary) <- ""
  class(res) <- "gtest"

  #---------------------------------#

cat("\n")
cat(res$head,"\n")
cat("\n")
rq<-structure(res$summary)
print(rq, digits = max(3, getOption("digits")))
cat("\n")
invisible(res)
}

see.lma.tck<-function (){

local({
have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
if (have_ttk) {
    tkbutton <- ttkbutton
    tkcheckbutton <- ttkcheckbutton
    tkentry <- ttkentry
    tkframe <- ttkframe
    tklabel <- ttklabel
    tkradiobutton <- ttkradiobutton
}
tclServiceMode(FALSE) 
dialog.sd <- function() {
  tt <- tktoplevel()
  tkwm.title(tt,"Linear models")
  y.entry <- tkentry(tt, textvariable=Y, width =45)
  x0.entry <- tkentry(tt, textvariable=X0, width =45) 
  x1.entry <- tkentry(tt, textvariable=X1, width =45) 
  x2.entry <- tkentry(tt, textvariable=X2, width =45) 
  x3.entry <- tkentry(tt, textvariable=X3, width =45) 
 
  nvars <- tkentry(tt, textvariable=NV, width =5) 
showXY<-tclVar(1)  
  done <- tclVar(0)
 
reset<-function(){
Y<-"c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)"
X0<-"c(rep(1,5),rep(14,1))"
X1<-"c(rep(0,5),rep(1,5),rep(0,9))"
X2<-"c(rep(0,10),rep(1,4),rep(0,5))"
X3<-"c(rep(0,14),rep(1,5))"

NV<-"4"
  tclvalue(showXY)<-"1"
}

reset.but <- tkbutton(tt, text = "Reset", command = reset)
submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)



build <- function() {
  showXY <- as.logical(tclObj(showXY))
  Y <-parse(text=tclvalue(Y))[[1]]
  NV<-parse(text=tclvalue(NV))[[1]]
  
if(NV == "2"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1)))}  
if(NV == "3"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X2 <- parse(text=tclvalue(X2))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1),as.numeric(X2)))}
if(NV =="4"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X2 <- parse(text=tclvalue(X2))[[1]]
X3 <- parse(text=tclvalue(X3))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1),as.numeric(X2),as.numeric(X3)))}

substitute(pm1(as.numeric(Y),as.numeric(X),as.numeric(.8),showXY=showXY))
}                

nc.cbut <- tkcheckbutton(tt, text="Show XY", variable=showXY)
  tkgrid(tklabel(tt, text = "Linear model (ANOVA)"), 
      columnspan = 2)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(tklabel(tt, text = 'Y'), y.entry)
  tkgrid(tklabel(tt, text = 'X1'), x0.entry)
  tkgrid(tklabel(tt, text = 'X2'), x1.entry)
  tkgrid(tklabel(tt, text = "X3"), x2.entry)
  tkgrid(tklabel(tt, text = "X4"), x3.entry)
  
  tkgrid(tklabel(tt, text = "Number of factor levels"), nvars)
  tkgrid(tklabel(tt, text = ""))
    tkgrid(nc.cbut)  
  tkgrid(tklabel(tt, text = ""))
  tkgrid(submit.but, reset.but, sticky ="e")
 
  tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
  tkwait.variable(done)
  if (tclvalue(done) == "2") 
      stop("aborted")
  tkdestroy(tt)
  cmd <- build()
  eval.parent(cmd)
}
Y<-tclVar("c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)")
X0<-tclVar("c(rep(1,5),rep(0,14))")
X1<-tclVar("c(rep(0,5),rep(1,5),rep(0,9))")
X2<-tclVar("c(rep(0,10),rep(1,4),rep(0,5))")
X3<-tclVar("c(rep(0,14),rep(1,5))")

NV<-tclVar("4")
dialog.sd()
})
}    
                                                            

pm1<-function(Y,X,sz=1,showXY=TRUE){
old.par <- par(no.readonly = TRUE)
  
X<-matrix(nrow=length(Y),data=X)
Y<-as.matrix(Y)
n<-length(Y)
p<-ncol(X)
b<-solve(t(X)%*%X)%*%t(X)%*%Y
b1<-round(b,8)
MSR<-round(((t(b)%*%t(X)%*%Y)-(1/n)*t(Y)%*%matrix(1,nrow=n,ncol=n)%*%Y)/(p-1),10)
MSE<-round((t(Y)%*%(Y)-t(b)%*%t(X)%*%Y)/(n-p),10)
Yhat<-round(X%*%b,8)

par(mar=c(0,0,0,0))
layout(matrix(c(rep(1,1),rep(2,2),rep(3,1),rep(4,1),rep(5,1)),2,3, byrow = TRUE))
plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
if(showXY==TRUE){
legend("center",ncol=1,legend=Y,bty="n",title="Y",cex=1.3*sz)}
plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
if(showXY==TRUE)
legend("center",ncol=ncol(X),legend=c(as.vector(X)),bty="n",title="X",cex=1.3*sz)

plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n")
text(5,9.5,"Coefficients",cex=1.6*sz)
text(1.8,8.1,expression(paste(hat(beta)," = ")),cex=1.4*sz)
text(4.1,8,paste("(X'X","\u0029","\u02c9","\u00b9","X'Y = ",sep=""),cex=1.4*sz)
legend(5,9,b1,cex=1.3*sz,bty="n")
     
plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n")
text(5,9.5,"Mean squares",cex=1.6*sz)
text(1.8,8.1,expression(paste("MSR = ", hat(beta),"'","X'Y - ",frac(1,n)," Y'1Y/(p - 1)")),cex=1.4*sz,adj=0)
text(1.8,6.8,bquote(paste("       = ",.(MSR))),cex=1.4*sz,adj=0)
text(1.8,5.5,expression(paste("MSE = Y'",hat(beta),"'X'Y/(n - p)")),cex=1.4*sz,adj=0)
text(1.8,4.1,paste("       = ",bquote(.(MSE))),cex=1.4*sz,adj = 0)

plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n")
text(5,9.5,"Fitted values",cex=1.6*sz)
text(1.8,8.1,expression(paste(hat(Y)," = X", hat(beta)," = ")),cex=1.4*sz,adj=0)
legend(5,9,Yhat,cex=1.3*sz,bty="n")
on.exit(par(old.par))
}

see.lmr.tck<-function (){

local({
have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
if (have_ttk) {
    tkbutton <- ttkbutton
    tkcheckbutton <- ttkcheckbutton
    tkentry <- ttkentry
    tkframe <- ttkframe
    tklabel <- ttklabel
    tkradiobutton <- ttkradiobutton
}
tclServiceMode(FALSE) 
dialog.sd <- function() {
  tt <- tktoplevel()
  tkwm.title(tt,"Linear models")
  y.entry <- tkentry(tt, textvariable=Y, width =45)
  x0.entry <- tkentry(tt, textvariable=X0, width =45) 
  x1.entry <- tkentry(tt, textvariable=X1, width =45) 
  x2.entry <- tkentry(tt, textvariable=X2, width =45) 
  x3.entry <- tkentry(tt, textvariable=X3, width =45) 
  x4.entry <- tkentry(tt, textvariable=X4, width =45) 
  nvars <- tkentry(tt, textvariable=NV, width =5) 
showXY<-tclVar(1) 
  done <- tclVar(0)
 
reset<-function(){
Y<-"c(20,30,10,15,5,45,60,55,45)"
X0<-"c(rep(1,9))"
X1<-"c(13,20,10,11,2,25,30,25,23)"
X2<-"c(1.2,2,1.5,1,0.3,2,3,2.7,2.5)"
X3<-"c(15,14,16,12,10,18,25,24,20)"
X4<-"(45,120,100,56,5,20,5,15,15)"
NV<-"4"
  tclvalue(showXY)<-"1"
}

reset.but <- tkbutton(tt, text = "Reset", command = reset)
submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)



build <- function() {
  showXY <- as.logical(tclObj(showXY))
  Y <-parse(text=tclvalue(Y))[[1]]
  NV<-parse(text=tclvalue(NV))[[1]]
  
if(NV == "2"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1)))}  
if(NV == "3"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X2 <- parse(text=tclvalue(X2))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1),as.numeric(X2)))}
if(NV =="4"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X2 <- parse(text=tclvalue(X2))[[1]]
X3 <- parse(text=tclvalue(X3))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1),as.numeric(X2),as.numeric(X3)))}
if(NV=="5"){
X0 <- parse(text=tclvalue(X0))[[1]]
X1 <- parse(text=tclvalue(X1))[[1]]
X2 <- parse(text=tclvalue(X2))[[1]]
X3 <- parse(text=tclvalue(X3))[[1]]
X4 <- parse(text=tclvalue(X4))[[1]]
X<-substitute(cbind(as.numeric(X0),as.numeric(X1),as.numeric(X2),as.numeric(X3),as.numeric(X4)))}
substitute(pm1(as.numeric(Y),as.numeric(X),showXY=showXY))
}                

nc.cbut <- tkcheckbutton(tt, text="Show XY", variable=showXY)
  tkgrid(tklabel(tt, text = "Linear model (Regression)"), 
      columnspan = 2)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(tklabel(tt, text = 'Y'), y.entry)
  tkgrid(tklabel(tt, text = 'X0'), x0.entry)
  tkgrid(tklabel(tt, text = 'X1'), x1.entry)
  tkgrid(tklabel(tt, text = "X2"), x2.entry)
  tkgrid(tklabel(tt, text = "X3"), x3.entry)
  tkgrid(tklabel(tt, text = "X4"), x4.entry)
  tkgrid(tklabel(tt, text = "Number of X vars."), nvars)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(nc.cbut)  
  tkgrid(tklabel(tt, text = ""))
  tkgrid(submit.but, reset.but, sticky ="e")
  
  tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
  tkwait.variable(done)
  if (tclvalue(done) == "2") 
      stop("aborted")
  tkdestroy(tt)
  cmd <- build()
  eval.parent(cmd)
}
Y<-tclVar("c(20,30,10,15,5,45,60,55,45)")
X0<-tclVar("c(rep(1,9))")
X1<-tclVar("c(13,20,10,11,2,25,30,25,23)")
X2<-tclVar("c(1.2,2,1.5,1,0.3,2,3,2.7,2.5)")
X3<-tclVar("c(15,14,16,12,10,18,25,24,20)")
X4<-tclVar("c(45,120,100,56,5,20,5,15,15)")
NV<-tclVar("5")
dialog.sd()
})
}    
                                                            

r.dist <- function(rho, r, n){

rd <- function(rho, r, n){
((n-2)*gamma(n-1)*((1-rho^2)^((n-1)/2))*((1-r^2)^((n-4)/2)))/
(sqrt(2*pi)*gamma(n-0.5)*((1-rho*r)^(n-(3/2)))) *
(1 + 1/4 * (((rho * r) + 1)/((2 * n) - 1))  + 9/16 * ((((rho * r) + 1)^2)/((2 * n) - 1)* (2 * n + 1)))
}
r.unst <- rd(rho, r, n)
integrand <-function(x)rd(rho = rho, n = n, r = x)
den <- integrate(integrand, -1, 1)
std.r <- r.unst/den$value
std.r
}


#----------------------------- tcltk implementation ---------------------------------#


see.r.dist.tck <-function(){
  if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows")
  {dev.new(noRStudioGD = TRUE)}

plot_r <- function(rho, r, n, ...){
vals <- r.dist(rho = rho, r = seq(-1, 1, .001) , n = n)
dev.hold()
plot(seq(-1, 1, .001), vals, type = "l", ylab = expression(paste(italic(f),"(",italic(r),")", sep = "")), xlab = expression(italic(r)), ...)
dev.flush()
}


    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    n <- 5
    rho <- 0
    assign("n", tclVar(n), envir = slider.env)
    assign("rho", tclVar(rho), envir = slider.env)
    xmin <- -1
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 1
    assign("xmax", tclVar(xmax), envir = slider.env)

    norm.refresh <- function(...) {
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        rho <- as.numeric(evalq(tclvalue(rho), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))

        plot_r(n = n, rho = rho, xlim = c(xmin, xmax))
    }


    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.geometry(m, "+600+4")
    tkwm.title(m, "Pearson product moment correlation distribution")
    tkpack(tklabel(m, text = "Sampling distribution of r"))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 5,
        to = 50, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C1", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -.99,
        to = .99, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = rho), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")

    norm.refresh()

}

ci.p<-function(data,conf=.95, summarized=FALSE, phat=NULL, fpc=FALSE, n=NULL, N=NULL, method="agresti.coull", plot=TRUE){
indices <- c("agresti.coull","asymptotic","exact","LR","score")
method <- match.arg(method, indices)
alpha <-1-conf 
z.star<-qnorm(1-(alpha/2)) 

if (summarized == FALSE) {
   n <- length(as.matrix(data))
   phat <- ifelse(method == "agresti.coull", (sum(data) + (z.star^2/2))/(n + (z.star^2)), sum(data)/n)
   Var.phat <- ifelse(method == "agresti.coull", (phat * (1 - phat))/(n + (z.star^2)), (phat * (1 - phat))/n)
   S.phat <- ifelse(fpc == FALSE, sqrt(Var.phat), sqrt((1 - (n/N)) * Var.phat))
   x <- n * phat
       }


if(summarized==TRUE){
  x <- n * phat
  phat <- ifelse(method == "agresti.coull", (x + (z.star^2/2))/(n + (z.star^2)), x/n)
  Var.phat <- ifelse(method == "agresti.coull", (phat * (1 - phat))/(n + (z.star^2)), (phat * (1 - phat))/n)
  S.phat<-ifelse(fpc == FALSE, sqrt(Var.phat), sqrt((1-(n/N)) * Var.phat))}

  m <- S.phat * z.star
    
if(method == "agresti.coull"| method == "asymptotic") CI <- c(phat, phat - m, phat + m)
  
  

if(method == "exact") {
   cl <- qbeta(alpha/2, x, n - x + 1)
	 cu <- qbeta(1 - (alpha/2), x + 1, n - x)	
	 CI <- c(phat, cl, cu)
   }

if(method=="score"){ 
  a <- 1 + (z.star^2/n)
  b <- -2*phat - (z.star^2/n)
  c <- phat^2 
  CI<-c(phat,(-b-sqrt(b^2-(4*a*c)))/(2*a),(-b+sqrt(b^2-(4*a*c)))/(2*a)) # quadratic eqn. 
  }

if(method=="LR"){ 
  x2 <- qchisq(conf, 1)/2
  p.0 <- seq(0.00001, 0.99999, by = 0.00001)
  LR <- rep(NA, length=length(p.0))
  ML <- log(dbinom(x,n,phat))
  LL <- log(dbinom(x,n,p.0))
  int<-p.0[LL > ML - x2]
  CI <- c(phat, min(int), max(int))
  if(plot == TRUE){
  plot(p.0, LL, type="l", xlab = expression(pi[0]), ylab = "Binomial log-likelihood") 
  abline(h = ML-x2, lty=2); abline(v=CI,lwd=2, col="gray"); abline(v=phat, lwd = 2)
  #legend("bottomleft",lty=2,legend=expression(paste("logLik(",hat(pi),") - ",italic(f),"(",pi[0],") = ",chi^2,"(1 - ",alpha,")/2", sep = "")), box.col = "white", cex = .9, bg = "white", inset = .01)
  } 
  } 
  

head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence interval for binomial parameter pi"))
if(method=="agresti.coull")head<-paste(head,"(method=Agresti-Coull)")
if(method=="exact")head<-paste(head,"(method=Clopper-Pearson)")
if(method=="asymptotic")head<-paste(head,"(method= asymptotic (Wald) normal approximation)")
if(method=="score")head<-paste(head,"(method=score)")
if(method=="LR")head<-paste(head,"(method=likelihood ratio)")


ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
if(method=="agresti.coull"|method=="asymptotic"|method =="score"|method=="LR")res<-list(SE=S.phat,margin=m,ci=CI,ends=ends,head=head)
if(method=="exact")res<-list(ci=CI,ends=ends,head=head)
class(res)<-"ci"
res
}

anm.loglik.tck<-function(){

    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE)
        dialog.ll <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "Log-likelihood")
            custom.ent <- tkentry(tt, textvariable = Cust)
            X.entry <- tkentry(tt, textvariable = Xe)
            Norm.par <- tclVar("mu")
            done <- tclVar(0)
            Dist <- tclVar("norm")
            
            reset <- function() {
                tclvalue(Cust) <- "NULL"
                tclvalue(X) <- ""
                tclvalue(Dist) <- "norm"
                tclvalue(Norm.Par) <- "mu"
            }
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)
            build <- function() {
                func <- parse(text = tclvalue(Cust))[[1]]
                X <- n.seq <- parse(text = tclvalue(Xe))[[1]]
                dist <- tclvalue(Dist)
                parameter <- tclvalue(Norm.Par)
                substitute(anm.loglik(X = as.numeric(X), dist = dist, parameter = parameter, 
                  func = func))
            }
            alt.rbuts <- tkframe(tt)
            alt.rbuts1 <- tkframe(tt)
            tkpack(tklabel(alt.rbuts, text = "pdf"))
            for (i in c("norm", "exp", "poi", "bin", "custom")) {
                tmp <- tkradiobutton(alt.rbuts, text = i, variable = Dist, 
                  value = i)
                tkpack(tmp, anchor = "w")
            }
            tkpack(tklabel(alt.rbuts1, text = "Norm parameter"))
            for (i in c("mu", "sigma.sq")) {
                tmp <- tkradiobutton(alt.rbuts1, text = i, variable = Norm.Par, 
                  value = i)
                tkpack(tmp, anchor = "w")
            }
            tkgrid(tklabel(tt, text = "Log-likelihood"), columnspan = 2)
            tkgrid(tklabel(tt, text = "Data"), X.entry)
            tkgrid(tklabel(tt, text = "Custom func."), custom.ent)
            tkgrid(alt.rbuts, alt.rbuts1)
            tkgrid(submit.but, reset.but, sticky = "e")
            if (tclvalue(Cust) == "") 
                tclvalue(Cust) <- "NULL"
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
            invisible(tclServiceMode(TRUE))
        }
        Xe <- tclVar("rnorm(20)")
        Dist <- tclVar("norm")
        Norm.Par <- tclVar("mu")
        Cust <- tclVar("NULL")
        dialog.ll()
    })
}

selftest.ANOVAsiminf.tck1 <-function(){

  options(guiToolkit="tcltk")
  w <- gwindow(title = "Simultaneous inference")
  size(w) <- c(700, 400)
  
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  
  f1 <- function(h,....){
    if(svalue(r1) == ans1[1]){
      gmessage(msg="Correct")
    }
    if(svalue(r1)== ans1[2]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r1)== ans1[4]){
      gmessage(msg="Inorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the family of tests for which Scheff\u00E9's procedure will control family-wise type I error?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp1, .5)
  
  ans1 <- c("(a)  All possible comparisons.",
            "(b)  All possible pairwise comparisons.",
            "(c)  All possible comparisons to a control.",
            "(d)  None of the above.")
  
  r1 <- gcheckboxgroup(ans1, container = gp1, where = "beginning", handler = f1)
  

  
  #------------- Question 2 -----------#
  
 
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the family of tests for which Tukey's procedure will control family-wise type I error?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp2, .5)
 
  
  ans2 <- c("(a)  All possible comparisons.",
            "(b)  All possible pairwise comparisons.",
            "(c)  All possible comparisons to a control.",
            "(d)  None of the above.")
  
  f2 <- function(h,....){
    if(svalue(r2) == ans2[1]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r2)== ans2[2]){
      gmessage(msg="Correct")
    }
    if(svalue(r2)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(svalue(r2)== ans2[4]){
      gmessage(msg="Inorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, where = "beginning", handler = f2)
  

  
  #------------- Question 3 -----------#
  
  
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the family of tests for which Dunnett's procedure will control family-wise type I error?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp3, .5)
  
  
  ans3 <- c("(a)  All possible comparisons.",
            "(b)  All possible pairwise comparisons.",
            "(c)  All possible comparisons to a control.",
            "(d)  None of the above.")
  
  f3 <- function(h,....){
    if(svalue(r3) == ans3[1]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r3)== ans3[2]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r3)== ans3[3]){
      gmessage(msg="Correct")
    }
    if(svalue(r3)== ans3[4]){
      gmessage(msg="Inorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, where = "beginning", handler = f3)
  

  
  #------------- Question 4 -----------#
  
  
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Family-wise type I error rate (FWER) is...", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp4, .5)
  
  
  ans4 <- c("(a)  the probability that any one test in a family of tests rejects H\u2080.",
            "(b)  the probability that any one test in a family of tests incorrectly rejects H\u2080.",
            "(c)  the probability that all tests in a family of tests incorrectly rejects H\u2080.",
            "(d)  the probability that no test in a family of tests correctly rejects H\u2080.",
            "(e)  the number of true H\u2080 rejections
divided by the total number of H\u2080 rejections.")
  
  f4 <- function(h,....){
    if(svalue(r4) == ans4[1]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r4)== ans4[2]){
      gmessage(msg="Correct")
    }
    if(svalue(r4)== ans4[3]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r4)== ans4[4]){
      gmessage(msg="Inorrect", icon = "error")
    }  
    if(svalue(r4)== ans4[5]){
      gmessage(msg="Inorrect", icon = "error")  
    }
  
      svalue(r4) <- character(0)
    }
    
    r4 <- gcheckboxgroup(ans4, container = gp4, where = "beginning", handler = f4)
    
    
  #------------- Question 5 -----------#
  
  
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("False discovery rate (FDR) is...", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp5, .5)
  
  
  ans5 <- c("(a)  the probability that any one test in a family of tests rejects H\u2080.",
            "(b)  the probability that any one test in a family of tests incorrectly rejects H\u2080.",
            "(c)  the probability that all tests in a family of tests incorrectly rejects H\u2080.",
            "(d)  the probability that no test in a family of tests correctly rejects H\u2080.",
            "(e)  the number of true H\u2080 rejections
divided by the total number of H\u2080 rejections.")
  
  f5 <- function(h,....){
    if(svalue(r5) == ans5[1]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r5)== ans5[2]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r5)== ans5[3]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r5)== ans5[4]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r5)== ans5[5]){
      gmessage(msg="Correct")  
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, where = "beginning", handler = f5)
  

  
  #------------- Question 5 -----------#
  
  
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) FDR tends to me more conservative than FWER with respect to false null rejections.", container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp6, .5)
  
  
  ans6 <- c("(a)  TRUE",
            "(b)  FALSE"
)
  
  f6 <- function(h,....){
    if(svalue(r6) == ans6[1]){
      gmessage(msg="Inorrect", icon = "error")
    }
    if(svalue(r6)== ans6[2]){
      gmessage(msg="Correct", icon = "error")
    }
    svalue(r6) <- character(0)
    }
    
    r6 <- gcheckboxgroup(ans6, container = gp6, where = "beginning", handler = f6)
    
    
      
}

see.tcdf.tck<-function ()
{
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu <- 5
    assign("nu", tclVar(nu), envir = slider.env)
    xmin <- -7
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 7
    assign("xmax", tclVar(xmax), envir = slider.env)

    show.norm<-tclVar(0)

    dev.new(height=4,width=8,noRStudioGD = TRUE);par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))

    prefunc<-function(xx,yy,sny,y1,sncy,xlim,nu,show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        if(show.norm==TRUE) points(xx,sny,type = "l", col =2)
        plot(xx, y1, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        if(show.norm==TRUE) points(xx,sncy,type = "l", col =2)
        mtext(bquote(paste(italic(X), " ~ ", italic(t), "(", .(nu), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
        }


    norm.refresh <- function(...) {
        nu <- as.numeric(evalq(tclvalue(nu), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dt(xx, df=nu)
        y1 <- pt(xx, df=nu)
        sny <- dnorm(xx)
        sncy <- pnorm(xx)
        show.norm <- as.logical(tclObj(show.norm))
        prefunc(xx,yy,sny,y1,sncy,nu=nu,show.norm=show.norm)
              }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "t(\u03bd)")
    tkpack(tklabel(m,text="      Visualizing the t Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd',font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 15, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr,text="      "))
    tkpack(fr,tkcheckbutton(m, text="Show standard normal pdf",variable=show.norm),anchor="w")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr,text="      "))
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
#    on.exit(par(old.par))
    norm.refresh()
    }


see.t.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu <- 5
    assign("nu", tclVar(nu), envir = slider.env)
    xmin <- -7
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 7
    assign("xmax", tclVar(xmax), envir = slider.env)

     show.norm<-tclVar(0)

    prefunc<-function(xx,yy,sny,y1,sncy,xlim,nu,show.norm=FALSE){
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        if(show.norm==TRUE) points(xx,sny,type = "l", col =2)
        mtext(bquote(paste(italic(X), " ~ ", italic(t), "(", .(nu), ")", sep = "")), line = 1, side = 3)
        dev.flush()
                 }

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        nu <- as.numeric(evalq(tclvalue(nu), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dt(xx, nu)
        sny <- dnorm(xx)
        show.norm <- as.logical(tclObj(show.norm))
        prefunc(xx,yy,sny,nu=nu,show.norm=show.norm)
              }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "t(\u03bd)")
    tkpack(tklabel(m,text="      Visualizing the t Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd',font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 15, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr,text="      "))
    tkpack(fr,tkcheckbutton(m, text="Show standard normal pdf",variable=show.norm),anchor="w")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr,text="      "))

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

shade.F.tck<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Depiction of F probability")
        x.entry <- tkentry(tt, textvariable=X, width = 10)
        nu1.entry<-tkentry(tt, textvariable=Nu1, width = 10)
        nu2.entry<-tkentry(tt, textvariable=Nu2, width = 10)
        from.entry<-tkentry(tt, textvariable=From, width = 10)
        to.entry<-tkentry(tt, textvariable=To, width = 10)
       
  Tail.par<-tclVar("lower")
  done <- tclVar(0)
 	show.p<-tclVar(1)
  show.d<-tclVar(0)
  show.dist<-tclVar(1)
        reset <- function()
        {
            tclvalue(X)<-"-.2"
            tclvalue(Nu1)<-"5"
            tclvalue(Nu2)<-"5"
            tclvalue(From)<-""
            tclvalue(To)<-""
            tclvalue(show.p)<-"1"
            tclvalue(show.d)<-"0"
            tclvalue(show.dist)<-"1"
         }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)

        build <- function()
        {
            x <- tclvalue(X)
            nu1 <-tclvalue(Nu1)
            nu2 <-tclvalue(Nu2)
            from <-tclvalue(From)
            to<-tclvalue(To)
            tail<-tclvalue(Tail.par)
            show.p <- as.logical(tclObj(show.p))
            show.d <- as.logical(tclObj(show.d))
            show.dist <- as.logical(tclObj(show.dist))
                      
         substitute(shade.F(x=as.numeric(x),nu1=as.numeric(nu1), nu2=as.numeric(nu2),from = as.numeric(from), to=as.numeric(to),tail=tail,show.p=show.p,show.d=show.d,show.dist=show.dist))
        }
        
        p.cbut <- tkcheckbutton(tt, text="Show probability", variable=show.p)
        d.cbut <- tkcheckbutton(tt, text="Show density", variable=show.d)
        dist.cbut <- tkcheckbutton(tt, text="Show distribution", variable=show.dist)
        
               
        tkgrid(tklabel(tt,text="F probability"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="x",font=c("Helvetica","9","italic")), x.entry)
        tkgrid(tklabel(tt,text='\u03bd\u2081'), nu1.entry)
        tkgrid(tklabel(tt,text='\u03bd\u2082'), nu2.entry)
        tkgrid(tklabel(tt,text=""))
        alt.rbuts <- tkframe(tt)

        tkpack(tklabel(alt.rbuts, text="Tail"))
        for ( i in c("lower","upper","two","middle")){
            tmp <- tkradiobutton(alt.rbuts, text=i, variable=Tail.par, value=i)
            tkpack(tmp,anchor="w")
            }
        tkgrid(alt.rbuts)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="Middle 'tail' span"))
        tkgrid(tklabel(tt,text="From"),from.entry)
        tkgrid(tklabel(tt,text="To"),to.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(p.cbut,sticky="w", columnspan = 2)
        tkgrid(d.cbut,sticky="w", columnspan = 2)
        tkgrid(dist.cbut,sticky="w", columnspan = 2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but,reset.but, sticky = "w")

       
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
        tclServiceMode(TRUE)
    }                            
      X<-tclVar("2")
      Nu1<-tclVar("5")
      Nu2<-tclVar("5")
      Tail<-tclVar("lower")
      From<-tclVar("")
      To<-tclVar("")
      dialog.sd()
})
}

see.nbin.tck <-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    r <- 1
    p <- 0.5
    assign("r", tclVar(r), envir = slider.env)
    assign("p", tclVar(p), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        r <- as.numeric(evalq(tclvalue(r), envir = slider.env))
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax)
        yy <- dnbinom(xx, r, p)
        plot(xx, yy, type = "h", xlab = expression(italic(x)),
            ylab = expression(paste(italic(f), "(", italic(x),
                ")", sep = "")))
        points(xx, yy, pch = 19)
        mtext(bquote(paste(italic(X), " ~ ", italic(NB), "(",
            .(r), ", ", .(p), ")", sep = "")), line = 1, side = 3)
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "NB(r, \u03C0)")
    tkpack(tklabel(m, text = "      Visualizing the Negative Binomial Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "r", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = r), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C0", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}








see.nbincdf.tck <- function ()
{
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    r <- 1
    p <- 0.5
    assign("r", tclVar(r), envir = slider.env)
    assign("p", tclVar(p), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir = slider.env)
    dev.new(height = 4, width = 8,noRStudioGD = TRUE)
    par(mar = c(4.4, 4.5, 1, 0.5), cex = 0.85, oma = c(0, 0,
        1.5, 0))
    layout(matrix(c(1, 2), 1, 2, byrow = TRUE))
    norm.refresh <- function(...) {
        r <- as.numeric(evalq(tclvalue(r), envir = slider.env))
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax)
        yy <- dnbinom(xx, r, p)
        y1 <- pnbinom(xx, r, p)
        plot(xx, yy, type = "h", xlab = expression(italic(x)),
            ylab = expression(paste(italic(f), "(", italic(x),
                ")", sep = "")))
        points(xx, yy, pch = 19)
        plot(xx, y1, type = "n", xlab = expression(italic(x)),
            ylab = expression(paste(italic(F), "(", italic(x),
                ")", sep = "")))
        points(xx, y1, pch = 19)
        segments(xx, y1, xx + 1, y1)
        points(xx + 1, y1, pch = 1)
        mtext(bquote(paste(italic(X), " ~ ", italic(NB), "(",
            .(r), ", ", .(p), ")", sep = "")), outer = TRUE,
            side = 3, cex = 0.9)
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "NB(r, \u03C0)")
    tkpack(tklabel(m, text = "      Visualizing the Negative Binomial Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "r", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = r), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C0", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
#    on.exit(par(old.par))
}

BDM.test <- function (Y, X) 
{
    if(any(is.na(Y))==TRUE) stop("Please remove missing values")
    n <- length(Y)
    n.s <- tapply(Y, X, length)
    Q <- matrix((1/n) * (tapply(rank(Y), X, function(x) {
        mean(x) - (1/2)
    })))
    r <- nlevels(X)
    S.sq <- matrix(ncol = 1, nrow = r)
    ranks <- rank(Y)
    for (i in 1:r) {
        Xn <- as.numeric(X)
        S.sq[i] <- 1/(n^2 * (length(Y[Xn == i]) - 1)) * sum((ranks[Xn == 
            i] - mean(ranks[Xn == i]))^2)
    }
    V <- n * diag(as.vector(S.sq) * (1/n.s))
    M <- diag(1, r, r) - ((1/r) * matrix(1, r, r))
    F.star <- n/sum(diag(M[1] * V)) * (t(Q) %*% M %*% Q)
    nu1 <- M[1]^2 * sum(diag(V))^2/sum(diag(M %*% V %*% M %*% 
        V))
    nu2 <- sum(diag(V))^2/sum(diag(V %*% V %*% diag(1/(n.s - 
        1))))
    res <- list()
    res$head <- "One way Brunner-Dette-Munk test" 	
    res$Q <- data.frame(Levels = levels(X), Rel.effects = Q)
    res$BDM.Table <- data.frame(df1 = nu1, df2 = nu2, F = F.star, 
        p.val = pf(F.star, nu1, nu2, lower.tail = FALSE), row.names = "X")
    colnames(res$BDM.Table) <- c("df1", "df2", "F*", "P(F > F*)")
    if(nrow(res$BDM.Table) == 1) rownames(res$BDM.Table) <- ""	
    class(res) <- "BDM"
    res
}

print.BDM<-function(x,digits= max(3, getOption("digits")), ...){
cat("\n")
cat(x$head,"\n\n")
print(x$BDM.Table,digits=digits)
cat("\n")
invisible(x)
}


BDM.2way<-function(Y,X1,X2){
n<-length(Y)
n.s<-tapply(Y,interaction(X1,X2,lex.order=TRUE),length)
Q<-matrix((1/n)*(tapply(rank(Y),interaction(X1,X2,lex.order=TRUE),function(x){mean(x)-(1/2)})))
ranks<-rank(Y)
J<-nlevels(X1)
K<-nlevels(X2)
L<-J*K
S.sq<-matrix(ncol=1,nrow=L)

for(i in 1:L){
Xn<-as.numeric(interaction(X1,X2))
S.sq[i]<-1/(n^2*(length(Y[Xn==i])-1))*sum((ranks[Xn==i]-mean(ranks[Xn==i]))^2)
}

V<-n*diag(as.vector(S.sq)*(1/n.s))

P.J<-diag(1,J)-(matrix(1,J,J)/J)
P.K<-diag(1,K)-(matrix(1,K,K)/K)
M.A<-kronecker(P.J,matrix(1,K,K)/K)
M.B<-kronecker(matrix(1,J,J)/J,P.K)
M.AB<-kronecker(P.J,P.K)
F.A<-n/sum(diag(M.A[1]*V))*(t(Q)%*%M.A%*%Q)
F.B<-n/sum(diag(M.B[1]*V))*(t(Q)%*%M.B%*%Q)
F.AB<-n/sum(diag(M.AB[1]*V))*(t(Q)%*%M.AB%*%Q)

nu1.A<-M.A[1]^2*sum(diag(V))^2/sum(diag(M.A%*%V%*%M.A%*%V))
nu1.B<-M.B[1]^2*sum(diag(V))^2/sum(diag(M.B%*%V%*%M.B%*%V))
nu1.AB<-M.AB[1]^2*sum(diag(V))^2/sum(diag(M.AB%*%V%*%M.AB%*%V))

nu2<-sum(diag(V))^2/sum(diag(V%*%V%*%diag(1/(n.s-1))))
res<-list()
res$head <- "Two way Brunner-Dette-Munk test" 
res$Q<-data.frame(Levels=levels(interaction(X1,X2,lex.order=TRUE)),Rel.effects=Q)

res$BDM.Table<-data.frame(nu1=c(nu1.A,nu1.B, nu1.AB),nu2=c(nu2,nu2,nu2),F.star=c(F.A,F.B,F.AB),P.val=c(pf(F.A,nu1.A,nu2,lower.tail=FALSE),pf(F.B,nu1.B,nu2,lower.tail=FALSE),
pf(F.AB,nu1.AB,nu2,lower.tail=FALSE)),row.names=c("X1","X2","X1:X2"))
colnames(res$BDM.Table)<-c("df1","df2","F*","P(F > F*)")
class(res) <- "BDM"
res
}

#############################################################################################################
################################################ prp ########################################################
#############################################################################################################

prp<-function(Time,S.X,S.Y,N.X,N.Y,habitat=NULL,near.angle=NULL, F.0.NA=TRUE){


pairw<-length(S.X)-1
  
  Euc<-function(x,y)sqrt((x[1]-y[1])^2+(x[2]-y[2])^2) ##Euclidean distance

if(!is.null(near.angle))
  {Find.quad<-function(x) 
    {for(i in 1:length(S.X))
      {if(x[i]>=0&x[i]<=90){x[i]=1}
      if(x[i]<=180&x[i]>90){x[i]=2}
      if(x[i]<(-90)&x[i]>=(-180)){x[i]=3}
      if(x[i]<0&x[i]>=(-90)){x[i]=4}
      }
    x
    }
  near.angle<-Find.quad(near.angle)
  }

######################################## Lines ###########################################

Deer<-cbind(S.X,S.Y)
Near<-cbind(N.X,N.Y)

A<-matrix(ncol=1,nrow=pairw)
B<-matrix(ncol=1,nrow=pairw)
C<-matrix(ncol=1,nrow=pairw)
D<-matrix(ncol=1,nrow=pairw)
F<-matrix(ncol=1,nrow=pairw)

for(i in 1:(pairw))
  {A[i]<-Euc(Deer[i,],Near[i,])
  B[i]<-Euc(Deer[i+1,],Near[i+1,])
  C[i]<-Euc(Deer[i,],Deer[i+1,])
  D[i]<-Euc(Deer[i+1,],Near[i,])
  F[i]<-Euc(Near[i,],Near[i+1,])
  }


######################################## Angles ##########################################

kappa<-acos((C^2+A^2-D^2)/(2*C*A))*180/pi
gamma<-acos((B^2+F^2-D^2)/(2*B*F))*180/pi

######################################## Index ##########################################

m.C<-matrix(ncol=1,nrow=pairw)
m.F<-matrix(ncol=1,nrow=pairw)
b.C<-matrix(ncol=1,nrow=pairw)
b.F<-matrix(ncol=1,nrow=pairw)
int.x.coord<-matrix(ncol=1,nrow=pairw)
int.y.coord<-matrix(ncol=1,nrow=pairw)

for(i in 1:pairw)
  {if(F[i]!=0&C[i]!=0){
  m.C[i]<-(S.Y[i+1]-S.Y[i])/(S.X[i+1]-S.X[i])
  m.F[i]<-(N.Y[i+1]-N.Y[i])/(N.X[i+1]-N.X[i])}
  if(C[i]==0&F[i]==0){ ## No movement
  m.C[i]=-9999
  m.F[i]=-9999}
  if(F[i]==0&C[i]!=0){
  m.C[i]=-9998
  m.F[i]=-9998}
  if(F[i]!=0&C[i]==0)stop("F!=0 but C=0")
  }

for(i in 1:pairw)#### Infinite slopes??  No problem
  {if(m.C[i]!=-9999&m.C[i]!=-9998)
    {if(m.C[i]==m.F[i]){##Parallel
    m.C[i]= -9997
    m.F[i]= -9997}
    if(m.C[i]!=m.F[i]){##Not Parallel
      {if((m.C[i]==Inf|m.C[i]==-Inf)&(m.F[i]!=Inf|m.F[i]!=-Inf)){
      int.x.coord[i]<-S.X[i]
      b.F[i]<-N.Y[i]-N.X[i]*m.F[i]
      int.y.coord[i]<-int.x.coord[i]*m.F[i]+b.F[i]}
      if((m.C[i]!=Inf|m.C[i]!=-Inf)&(m.F[i]==Inf|m.F[i]==-Inf)){
      int.x.coord[i]<-N.X[i]
      b.C[i]<-S.Y[i]-S.X[i]*m.C[i]
      int.y.coord[i]<-int.x.coord[i]*m.C[i]+b.C[i]}
      if((m.C[i]!=Inf&m.C[i]!=-Inf)&(m.F[i]!=Inf&m.C[i]!=-Inf)){##No infinite slopes
      b.C[i]<-S.Y[i]-S.X[i]*m.C[i]
      b.F[i]<-N.Y[i]-N.X[i]*m.F[i]
      int.x.coord[i]<-(b.C[i]-b.F[i])/(m.F[i]-m.C[i])
      int.y.coord[i]<-int.x.coord[i]*m.F[i]+b.F[i]
        }
      }
    }
  }
  if(m.C[i]==-9999){## No movement
  int.x.coord[i]=-9999
  int.y.coord[i]=-9999
  }
  if(m.C[i]==-9998){## Same nearest neighbor
  int.x.coord[i]=-9998
  int.y.coord[i]=-9998
  }
}
  
C.ext<-matrix(ncol=1,nrow=pairw)
F.ext<-matrix(ncol=1,nrow=pairw)
last<-matrix(ncol=1,nrow=pairw)

for(i in 1:pairw)
  {if(m.C[i]!=-9999&m.F[i]!=-9999){##Find which side delta is on and calculte S and T
  C.ext[i]<-max(c(Euc(c(int.x.coord[i],int.y.coord[i]),c(S.X[i],S.Y[i])),Euc(c(int.x.coord[i],int.y.coord[i]),
  c(S.X[i+1],S.Y[i+1]))))
  F.ext[i]<-max(c(Euc(c(int.x.coord[i],int.y.coord[i]),c(N.X[i],N.Y[i])),Euc(c(int.x.coord[i],int.y.coord[i]),
  c(N.X[i+1],N.Y[i+1]))))
  last[i]<-max(A[i],B[i])}##opposite side of delta
  if(m.C[i]==-9999|m.F[i]==-9999){
  C.ext[i]=-9999
  F.ext[i]=-9999
  last[i]=-9999}
  }



delta<-matrix(ncol=1,nrow=pairw)
for(i in 1:pairw)
  {if(F[i]==0&is.null(habitat)){
    if(F[i]==0&C[i]!=0&F.0.NA==FALSE)delta[i]=90 ## F = 0; let delta = 90
    if(F[i]==0&C[i]!=0&F.0.NA==TRUE)delta[i]=NA   ## F = 0; let delta = NA
  }
  if(F[i]!=0|(F[i]==0&!is.null(habitat))){
    if(F[i]==0&!is.null(habitat)){
      if(habitat[i]!=habitat[i+1])delta[i]=90
      if(habitat[i]==habitat[i+1]){
        if(C[i]!=0&F.0.NA==FALSE)delta[i]=90
        if(C[i]!=0&F.0.NA==TRUE)delta[i]=NA}
        }
    if(m.C[i]!=-9999&m.F[i]!=-9999&m.C[i]!=-9998){
    delta[i]<-acos((C.ext[i]^2+F.ext[i]^2-last[i]^2)/(2*C.ext[i]*F.ext[i]))*180/pi}
    if(m.C[i]==-9999|m.F[i]==-9999)delta[i]=NA
    if(m.C[i]==-9997|m.F[i]==-9997)delta[i]=0
    }
  }
  
perp<-matrix(ncol=1,nrow=pairw)

for(i in 1:pairw)
  {if(is.na(delta[i])){delta[i]=NA}
  if(!is.na(delta[i])){
  if(delta[i]<=90){perp[i]=delta[i]/90}
  if(delta[i]>90&delta[i]<=135){perp[i]=(90-(delta[i]-90))/90}
  if(delta[i]>135&delta[i]<=180){perp[i]=(delta[i]-90)/90}}
  }

##################################################################################################

if(!is.null(near.angle)|!is.null(habitat)){ 
  
  for(i in 1:pairw)## Adjustments for potential problems with switching boundaries in a patch
    {if(!is.na(perp[i])){
    perp[i]<-ifelse(near.angle[i]!=near.angle[i+1]&habitat[i]==habitat[i+1],NA,perp[i])
    delta[i]<-ifelse(near.angle[i]!=near.angle[i+1]&habitat[i]==habitat[i+1],NA,delta[i])}
    }
    
  crossing<-matrix(ncol=1,nrow=pairw)
  for(i in 1:pairw){
  crossing[i]<-ifelse(habitat[i]!=habitat[i+1],1,0)}
  
  hab.type<-matrix(ncol=1,nrow=pairw)
  for(i in 1:pairw){
  if(habitat[i]==habitat[i+1]){hab.type[i]=habitat[i]}
  if(habitat[i]!=habitat[i+1]){hab.type[i]="Crossing"}
  }
  

  border.change<-matrix(ncol=1,nrow=pairw)
  for(i in 1:pairw){
  border.change[i]<-ifelse(near.angle[i]!=near.angle[i+1],"Y","N")}
  }

############################################ Results ################################################

  end.time<-matrix(ncol=1,nrow=pairw)
  for(i in 1:pairw){
  end.time[i]<-round(Time[i+1],0)}
  
res<-list()

  angles<-round(cbind(kappa,gamma,delta),3)
  colnames(angles)<-c("Kappa","Gamma","Delta")
  rownames(angles)<-end.time
  res$angles<-angles
  
  lines<-round(cbind(A,B,C,D,F),3)
  colnames(lines)<-c("A","B","C","D","F")
  rownames(lines)<-end.time
  res$lines<-lines
  
  n.perp<-length(!is.na(perp))
  SD.perp<-sapply(perp,function(x)sd(x,na.rm=TRUE))
  SE.perp<-SD.perp/sqrt(n.perp)
  
if(!is.null(habitat))
  {res$moment.by.moment<-data.frame(matrix(nrow=pairw,ncol=5,data=c(end.time,round(perp,4),round(delta,4),hab.type,border.change),dimnames=list(seq(1,pairw),c("End.time","Eta Index","Delta","Habitat","Brdr chng"))))
  }
if(is.null(habitat))
  {res$moment.by.moment<-data.frame(matrix(nrow=pairw,ncol=3,data=c(end.time,round(perp,4),round(delta,4)),dimnames=list(seq(1,pairw),c("End.time","Eta Index","Delta"))))
  }
res$P.summary<-matrix(nrow=1,ncol=3,data=c(mean(perp,na.rm=TRUE),SE.perp,n.perp),dimnames=list(c(""),c("Mean.Eta","SE.Eta","n")))
if(!is.null(near.angle)|!is.null(habitat))
  {
  x<-length(crossing[crossing==1]) 
  p.wilson<-(x+2)/(pairw+4)
  res$crossing.summary<-matrix(nrow=2,ncol=2,data=c(mean(crossing),sqrt((mean(crossing)*(1-mean(crossing)))/pairw),p.wilson,sqrt((p.wilson*(1-p.wilson))/(pairw+4))),dimnames=list(c("p.hat","S.p.hat"),c("Binomial estimates","Wilson estimates")))#estimators for binomial dist
  }
if(is.null(near.angle)|is.null(habitat))res$crossing.summary<-NA
class(res)<-"prp.index"
res
}
                               

anm.mc.bvn.tck <- function(){

    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE)
        dialog.ci <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "MCMC random walk")
            mu.entry <- tkentry(tt, textvariable = Mu, 
                width = 10)
            sigma.entry <- tkentry(tt, textvariable = Sigma, 
                width = 10)
            start.entry <- tkentry(tt, textvariable = Start, 
                width = 10)
            jump.entry <- tkentry(tt, textvariable = Jump, width = 10)
            xlim.entry <- tkentry(tt, textvariable = Xlim, 
                width = 10)
            ylim.entry <- tkentry(tt, textvariable = Ylim, 
                width = 10)
            length.entry <- tkentry(tt, textvariable = Length, 
                width = 10)
            int.entry <- tkentry(tt, textvariable = Int, width = 10)
            done <- tclVar(0)
            Par <- tclVar("Gibbs")
            reset <- function() {
                tclvalue(Mu) <- "c(0, 0)"
                tclvalue(Sigma) <- "matrix(2, 2, data = c(1, 0, 0, 1))"
                tclvalue(Start) <- "c(-4, 4)"
                tclvalue(Jump) <- "0.2"
                tclvalue(Xlim) <- "c(-4, 4)"
                tclvalue(Ylim) <- "c(-4, 4)"
                tclvalue(Length) <- "1000"
                tclvalue(Int) <- "0.01"
                tclvalue(Par) <- "Gibbs"
            }
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 0)
            build <- function() {
                mu <- parse(text = tclvalue(Mu))[[1]]
                sigma <- parse(text = tclvalue(Sigma))[[1]]
                start <- parse(text = tclvalue(Start))[[1]] 
                jump <- tclvalue(Jump)
                part <- tclvalue(Par)
                if(part == "Gibbs") par.type <- "G"
                if(part == "Metropolis") par.type <- "M"
                if(part == "Metropolis-Hastings") par.type <- "MH"
                xlim <- parse(text = tclvalue(Xlim))[[1]]
                ylim <- parse(text = tclvalue(Ylim))[[1]]
                interval <- tclvalue(Int)
                length <- tclvalue(Length)
                substitute(anm.mc.bvn(mu = mu, sigma = sigma, jump.kernel = as.numeric(jump), 
                  sim = par.type, interval = as.numeric(interval), length = as.numeric(length), xlim = xlim, ylim = ylim))
            }
            alt.rbuts <- tkframe(tt)
            tkpack(tklabel(alt.rbuts, text = "Simulation"))
            for (i in c("Gibbs", "Metropolis", "Metropolis-Hastings")) {
                tmp <- tkradiobutton(alt.rbuts, text = i, variable = Par, 
                  value = i)
                tkpack(tmp, anchor = "w")
            }
            tkgrid(tklabel(tt, text = "MCMC random walk"), 
                columnspan = 2)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = "\u03BC", font=c("Helvetica","9","bold")), mu.entry)
            tkgrid(tklabel(tt, text = "\u03C3\u00b2", font=c("Helvetica","9","bold")), sigma.entry)
            tkgrid(tklabel(tt, text = "Start"), start.entry)
            tkgrid(tklabel(tt, text = "Jump kernel"), jump.entry)
            tkgrid(tklabel(tt, text = "Length"), length.entry)
            tkgrid(tklabel(tt, text = "Xlim"), xlim.entry)
            tkgrid(tklabel(tt, text = "Ylim"), ylim.entry)
            tkgrid(tklabel(tt, text = "Anim. interval"), 
                int.entry)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(alt.rbuts, columnspan = 2)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(submit.but, reset.but, sticky = "w")
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
            invisible(tclServiceMode(TRUE))
        }
        Mu <- tclVar("c(0, 0)")
        Sigma <- tclVar("matrix(2, 2, data = c(1, 0, 0, 1))")
        Start <- tclVar("c(-4, 4)")
        Jump <- tclVar("0.2")
        Length <- tclVar("1000")
        Xlim <- tclVar("c(-4, 4)")
        Ylim <- tclVar("c(-4, 4)")
        Int <- tclVar("0.01")
        dialog.ci()
    })
}

Venn <- function (A, B, AandB = 0, labA = "A", labB = "B", cex.text = .95, ...) 
{
    if(A > 1) stop("Violation of probability rules! \nP(A) cannot be greater than 1")
    if(B > 1) stop("Violation of probability rules! \nP(B) cannot be greater than 1")   
    if(AandB > 1) stop("Violation of probability rules! \nP(AandB) cannot be greater than 1") 
    if(A + B - AandB > 1)stop("Violation of probability rules! \nP(A) + P(B) -P(AandB) cannot be greater than 1")  
    # if(A + B + AandB > 1) stop("Violation of probability rules! \nP(A) + P(B) + P(AandB) cannot be greater than 1")   
    if(A < 0) stop("Violation of probability rules! \nP(A) cannot be less than 0")  
    if(B < 0) stop("Violation of probability rules! \nP(B) cannot be less than 0")
    if(AandB < 0) stop("Violation of probability rules! \nP(AandB) cannot be less than 0")    
    if(AandB > A | AandB > B) stop("Violation of probability rules! \nP(AandB) cannot be greater than P(A) or P(B)")

    if (A == 0 & B == 0) {
        S <- plot(seq(0, 1), seq(0, 1), type = "n", xaxt = "n", 
            yaxt = "n", xlab = "", ylab = "",...)
        text(0.5, 0.6, bquote(paste(italic(P), "(", italic(.(labA)), 
            ") = 0", sep = "")), cex = cex.text)
        text(0.5, 0.4, bquote(paste(italic(P), "(", italic(.(labB)), 
            ") = 0", sep = "")), cex = cex.text)
    }
    if (A + B == 1 & AandB == 0) {
        S <- plot(seq(0, 1), seq(0, 1), type = "n", xaxt = "n", 
            yaxt = "n", xlab = "", ylab = "", bty = "n",...)
        rect(c(0, A), c(0, 0), c(A, 1), c(1, 1), col = c(rgb(0.7, 
            0.7, 0.7, 0.8), rgb(0.3, 0.3, 0.3, 0.8)))
        text(A/2, 0.5, bquote(paste(italic(P), "(", italic(.(labA)), 
            ") = ", .(A), sep = "")), cex = cex.text)
        text(A + ((1 - A)/2), 0.5, bquote(paste(italic(P), "(", 
            italic(.(labB)), ") = ", .(B), sep = "")), cex = cex.text)
    }
    if (A + B == 1 & AandB > 0) {
        S <- plot(seq(0, 1), seq(0, 1), type = "n", xaxt = "n", 
            yaxt = "n", xlab = "", ylab = "", bty = "n",...)
        rect(c(0, 0.5, A-(AandB/2)), c(0, 0, 0), c(A, 1, A+(AandB/2)), c(1, 1, 1), col = c(rgb(0.7, 
            0.7, 0.7, 0.8), rgb(0.3, 0.3, 0.3, 0.8), rgb(0.3, 0.3, 0.3, 0.8)))
        text(A/2, 0.5, bquote(paste(italic(P), "(", italic(.(labA)), 
            ") = ", .(A), sep = "")), cex = cex.text)
        text(A + ((1 - A)/2), 0.5, bquote(paste(italic(P), "(", 
            italic(.(labB)), ") = ", .(B), sep = "")), cex = cex.text)
        mtext(bquote(paste(italic(P), "(", italic(.(labA)), intersect(""), 
            italic(.(labB)), ") = ", .(AandB), sep = "")), side = 3, 
            at = (A - (AandB/2) + A + (AandB/2))/2, cex = cex.text)
        arrows((A - (AandB/2) + A + (AandB/2))/2, 1.01, (A - (AandB/2) + A + (AandB/2))/2, 0.75, length = 0.05)
    }
    if ((AandB == A | AandB == B) & (A != 0 | B != 0)) {
        S <- plot(seq(-0.55, 0.55, length = 3), seq(-0.55, 0.55, 
            length = 3), type = "n", xaxt = "n", yaxt = "n", 
            xlab = "", ylab = "",...)
        r.A <- sqrt(A/pi)
        r.B <- sqrt(B/pi)
        draw.circle(0, 0, radius = r.A, col = rgb(blue = 0.7, 
            red = 0.7, green = 0.7, alpha = 0.8))
        draw.circle(0, 0, radius = r.B, col = rgb(blue = 0.3, 
            red = 0.3, green = 0.3, alpha = 0.8))
        if (A >= B) {
            text(-0.5, 0.5, bquote(paste(italic(P), "(", italic(.(labA)), 
                ") = ", .(A), sep = "")), cex = cex.text)
            text(0, 0, bquote(paste(italic(P), "(", italic(.(labB)), 
                ") = ", italic(P), "(", italic(A), intersect(""), 
                italic(B), ") = ", .(B), sep = "")), cex = cex.text)
        }
        if (B > A) {
            text(-0.5, 0.5, bquote(paste(italic(P), "(", italic(.(labB)), 
                ") = ", .(B), sep = "")), cex = cex.text)
            text(0, 0, bquote(paste(italic(P), "(", italic(.(labA)), 
                ") = ", italic(P), "(", italic(A), intersect(""), 
                italic(B), ") = ", .(A), sep = "")), cex = cex.text)
        }
        arrows(-0.5, 0.46, -mean(c(r.A, r.B)), 0, length = 0.05)
    }
    if (A + B != 1 & AandB == 0 & (A != 0 | B != 0)) {
        S <- plot(seq(0, 2), seq(0, 2), type = "n", xaxt = "n", 
            yaxt = "n", xlab = "", ylab = "", bty = "n",...)
        r.A <- sqrt(A/pi)
        r.B <- sqrt(B/pi)
        draw.circle(0.5, 1, radius = r.A, col = rgb(blue = 0.7, 
            red = 0.7, green = 0.7, alpha = 0.8))
        draw.circle(1.25, 1, radius = r.B, col = rgb(blue = 0.3, 
            red = 0.3, green = 0.3, alpha = 0.8))
        text(0.5, 1, bquote(paste(italic(P), "(", italic(.(labA)), 
            ") = ", .(A), sep = "")), cex = cex.text)
        text(1.25, 1, bquote(paste(italic(P), "(", italic(.(labB)), 
            ") = ", .(B), sep = "")), cex = cex.text)
        rect(0.5 - sqrt(1/pi), 1 - sqrt(1/pi), 1.25 + sqrt(1/pi), 
            1 + sqrt(1/pi))
    }
    if ((A + B != 1 & AandB != 0) & (A != AandB) & (B != AandB)) {
        S <- plot(seq(-1, 1), seq(-1, 1), type = "n", xaxt = "n", 
            yaxt = "n", xlab = "", ylab = "", bty = "n",...)
        r.A <- sqrt(A/pi)
        r.B <- sqrt(B/pi)
        r.diff <- r.A - r.B
        d <- 2 * ((1 - AandB) * r.A) - r.diff
        draw.circle(-0.5, 0, radius = r.A, col = rgb(blue = 0.7, 
            red = 0.7, green = 0.7, alpha = 0.8))
        draw.circle(d - 0.5, 0, radius = r.B, col = rgb(blue = 0.3, 
            red = 0.3, green = 0.3, alpha = 0.8))
        text(-0.5, 0, bquote(paste(italic(P), "(", italic(.(labA)), 
            ") = ", .(A), sep = "")), cex = cex.text)
        text(d - 0.5, 0, bquote(paste(italic(P), "(", italic(.(labB)), 
            ") = ", .(B), sep = "")), cex = cex.text)
        x <- ((d + r.diff)/2) - 0.5
        arrows(x, 0.6, x, 0, length = 0.05)
        text(x, 0.65, bquote(paste(italic(P), "(", italic(.(labA)), 
            intersect(""), italic(.(labB)), ") = ", .(AandB), 
            sep = "")), cex = 0.8)
        rect(-0.5 - sqrt(1/pi), sqrt(1/pi), (d - 0.5) + sqrt(1/pi), 
            -sqrt(1/pi))
    }
}

Venn.tck<-function()
{

    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE) 
        dialog.sd <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "Venn diagrams")
            A.entry <- tkentry(tt, textvariable = Ae, width =10)
            B.entry <- tkentry(tt, textvariable = Be, width =10)
            AandB.entry <- tkentry(tt, textvariable = AandBe, width =10)
            A.label.entry <- tkentry(tt, textvariable = Alabel, width =10)
            B.label.entry <- tkentry(tt, textvariable = Blabel, width =10)
            
            done <- tclVar(0)
 
            reset <- function() {
                tclvalue(Ae) <- ""
                tclvalue(Be) <- ""
                tclvalue(AandBe) <- ""
                tclvalue(Alabel)<-"A"
                tclvalue(Blabel)<-"B"
            }
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)
            build <- function() {
                A <-tclvalue(Ae)
                B <- tclvalue(Be)
                AandB <- tclvalue(AandBe)
                labA <- tclvalue(Alabel)
                labB <- tclvalue(Blabel)
                substitute(Venn(A=as.numeric(A),B=as.numeric(B),AandB=as.numeric(AandB),labA=labA,labB=labB))
            }
            
            tkgrid(tklabel(tt, text = "Venn probability diagrams"), 
                columnspan = 2)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = "    P(A)"), A.entry, sticky = "w")
            tkgrid(tklabel(tt, text = "    P(B)"), B.entry, sticky = "w")
            tkgrid(tklabel(tt, text = "    P(A\u2229B)"), AandB.entry, sticky = "w")
            tkgrid(tklabel(tt, text = "    A label"), A.label.entry,  sticky = "w")
            tkgrid(tklabel(tt, text = "    B label"), B.label.entry, sticky = "w")
            tkgrid(tklabel(tt, text = ""))
            tkgrid(submit.but, reset.but,sticky="w")
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
        }
        Ae <- tclVar("0.4")
        Be <- tclVar("0.3")
        AandBe <- tclVar("0.1")
        Alabel <- tclVar("A")
        Blabel <-tclVar("B")
        dialog.sd()
    })
    }

selftest.stats.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Parameters and Statistics")
  size(w) <- c(700, 900)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which describes the expected value of a discrete random variable X?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans1 <- c("(a)     E(X) = \u2211\u2093 xf(x).",
            "(b)     The arithmetic mean given all possible outcomes from X.",
            "(c)     E(X) = \u2211\u2093 f(x).",
            "(d)     (a) and (b) only.",
            "(e)     (b) and (c) only.")

  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }

  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)



  #------------- Question 2 -----------#

  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The variance of a random variable X is computed as:", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans2 <- c("(a) Var(X) =  E(X\u00B2) - E(X)\u00B2.",
            "(b) Var(X) =  E(X)\u00B2 - E(X\u00B2).",
            "(c) Var(X) =  E(X\u00B2) + E(X)\u00B2.",
            "(d) Var(X) =  E(X)\u00B2 + E(X\u00B2).")

  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }

   r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)


  #------------- Question 3 -----------#

  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a random variable X, assume that f(x) = 0.5(x/4) for x = 1, 3, and 4, and that f(x) = 0 for all \n other x outcomes. What is E(X)?",
         container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)


  ans3 <- c("(a)  1",
            "(b)  3.25",
            "(c)  2.5",
            "(d)  0")

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    svalue(r3) <- character(0)
  }

  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)



  #------------- Question 4 -----------#

  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For the pdf in question 3, what is E(X\u00B2)?",
         container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans4 <- c("(a)  1",
            "(b)  3.25",
            "(c)  11.5",
            "(d)  42.25")

  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect.  This is E(X)", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }

  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)


  #------------- Question 5 -----------#

  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For the pdf in question 3, what is Var(X)?",
         container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)


  ans5 <- c("(a)  0.9375",
            "(b)  1",
            "(c)  20.75",
            "(d)  \u221E")

  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r5) <- character(0)
  }

  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)


  #------------- Question 6 -----------#

  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The efficacy of a statistical estimator can be quantified using its...", container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans6 <- c("(a)  stress.",
            "(b)  bias.",
            "(c)  consistency.",
            "(d)  efficiency.",
            "(e)  all but (a) are correct")

  f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect",icon="error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Partially correct.  Bias is an important characteristic to consider in estimators.",icon="error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Partially correct.  Consistency is an important characteristic to consider in estimators.",icon="error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Partially correct.  Efficiency is an important characteristic to consider in estimators.", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[5]){
      gmessage(msg="Correct")
    }
    svalue(r6) <- character(0)
  }

  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)


  #------------- Question 7 -----------#

  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("From a random variable Y we observe the outcomes: y\u2081, y\u2082,...,y\u2099. Then, \u0233 =  7 is a(n)", container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans7 <- c("(a)  parameter.",
            "(b)  statistic.",
            "(c)  estimator.",
            "(d)  estimate.",
            "(e)  (b) and (d) above.",
            "(f)  (b) and (c) above.")

  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[5]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r7) <- character(0)
  }

  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)


  #------------- Question 8 -----------#

  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <-glabel("\u0232 represents a(n)", container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

    ans8 <- c("(a)  parameter.",
            "(b)  statistic.",
            "(c)  estimator.",
            "(d)  estimate.",
            "(e)  (b) and (d) above.",
            "(f)  (b) and (c) above.")

  f8 <- function(h,....){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r8) <- character(0)
  }

  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)

  #------------- Question 9 -----------#

  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Var(Y) represents a(n)", container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans9 <- c("(a)  parameter.",
            "(b)  statistic.",
            "(c)  estimator.",
            "(d)  estimate.",
            "(e)  (b) and (d) above.",
            "(f)  (b) and (c) above.")

  f9 <- function(h,....){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r9) <- character(0)
  }

  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)


  #------------- Question 10 -----------#

  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("I want to find the mean growth rates given a series of rates. I would use the:", container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans10 <- c("(a) arithmetic mean.",
             "(b) geometric mean",
             "(c) harmonic mean",
             "(d) sample median")

  f10 <- function(h,....){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r10) <- character(0)
  }

  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)


  #------------- Question 11 -----------#

  gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")

  qq <- glabel("I want a location estimator that is robust to outliers. A widely used option is the:", container = gp11.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans11 <- c("(a) arithmetic mean.",
             "(b) geometric mean",
             "(c) harmonic mean",
             "(d) sample median")

  f11 <- function(h,....){
    if(tail(svalue(r11),1) == ans11[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[4]){
      gmessage(msg="Correct")
    }
    svalue(r11) <- character(0)
  }

    r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)


  #------------- Question 12 -----------#

  gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("I obtain a random sample of four male ISU students and measure their height.  \nThe measures (in meters) are: 2, 1.85, 1.85, and 1.7. \nWhat is arithmetic mean of these data?", container = gp12.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans12 <- c("1.5m",
             "1.75m",
             "1.85m",
             "1.95m")

  f12 <- function(h,....){
    if(tail(svalue(r12),1) == ans12[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r12),1)== ans12[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r12) <- character(0)
  }

  r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)




  #------------- Question 13 -----------#
  gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the sample median of the data in Question 12?", container = gp13.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans13 <- c("1.5m",
             "1.75m",
             "1.85m",
             "1.95m")

  f13 <- function(h,....){
    if(tail(svalue(r13),1) == ans13[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r13),1)== ans13[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r13) <- character(0)
  }

  r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)




  #------------- Question 14 -----------#
  gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the sample variance of the data in Question 12?", container = gp14.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans14 <- c("0.015m",
             "0.015m\u00B2",
             "0.122m",
             "0.122m\u00B2")


  f14 <- function(h,....){
    if(tail(svalue(r14),1) == ans14[1]){
      gmessage(msg="Incorrect.  The units are wrong.", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r14),1)== ans14[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r14) <- character(0)
  }

  r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)



  #------------- Question 15 -----------#
  gp15 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the sample standard deviation of the data in Question 12?", container = gp15.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans15 <- c("0.015m",
             "0.015m\u00B2",
             "0.122m",
             "0.122m\u00B2")

  f15 <- function(h,....){
    if(tail(svalue(r15),1) == ans15[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r15),1)== ans15[4]){
      gmessage(msg="Incorrect.  The units are wrong.", icon = "error")
    }
    svalue(r15) <- character(0)
  }

  r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)



  #------------- Question 16 -----------#
  gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) If a sample includes the entire population, \nthen statistics serve a descriptive instead of an inferential purpose. ", container = gp16.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans16 <- c("True",
             "False")

  f16 <- function(h,....){
    if(tail(svalue(r16),1) == ans16[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r16),1)== ans16[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r16) <- character(0)
  }

  r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)



}


#############################################################################
#############################################################################

selftest.stats.tck1 <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Transformations of random variables")
  size(w) <- c(700, 600)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)


  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Assume that a random variable X has the expected value, E(X) = 2.  \nTo X, I add 3, then multiply by 2.  The new expected value is...",
         container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans1 <- c("(a)  7",
            "(b)  12",
            "(c)  10",
            "(d)  8")

  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect. From the text in the question, we have the transform: X' = 2(3 + X). Based on this order of operations, we have: E(X') = 2(3 + 2) = 10.", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Correct. From the text in the question, we have the transform: X' = 2(3 + X). Based on this order of operations, we have: E(X') = 2(3 + 2) = 10.")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }

  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)



  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Assume that a random variable X has the variance, Var(X) = 2.  \nTo X, I add 3, then multiply by 2.  The new population variance is...",
         container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans2 <- c("(a)  7",
            "(b)  12",
            "(c)  10",
            "(d)  8")

  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Correct")
    }
    svalue(r2) <- character(0)
  }

  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)



  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) The sum of two normal random variables is an exponential distribution.", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans3 <- c("True",
            "False")


  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect.  The sum of two normal random variables will also be normal.", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Correct.  The sum of two normal random variables will also be normal.")
    }
    svalue(r3) <- character(0)
  }

  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)


  #------------- Question 4 -----------#
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Assume that X ~ N(0, 2), Y ~ N(2, 4), and Z = X - Y.  What is E(Z)?",
         container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans4 <- c("(a)  -2",
            "(b)  0",
            "(c)  2",
            "(d)  6")

  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r4) <- character(0)
  }

  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)



  #------------- Question 5 -----------#
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Assume that X ~ N(0, 2), Y ~ N(2, 4), and Z = X - Y.  What is Var(Z)?  \nAssume that X and Y are independent",
         container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans5 <- c("(a)  -2",
            "(b)  0",
            "(c)  2",
            "(d)  6")

  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Correct")
    }
    svalue(r5) <- character(0)
  }

  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)




  #------------- Question 6 -----------#
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Let X ~ N(0, 2), Y ~ N(2, 4), Z = X - Y, and assume X and Y are independent.  Then,",
         container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans6 <- c("(a)  Cov(X,Y) = 0",
            "(b)  Cov(X,Y) < 0",
            "(c)  Cov(X,Y) > 0",
            "(d)  Cov(X,Y) is undefined")

  f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Correct.  If X and Y are independent, their covariance will equal 0.")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r6) <- character(0)
  }

  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)


  #------------- Question 7 -----------#
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Let X ~ N(0, 2), Y ~ N(2, 4), Z = X - Y, and assume Cov(X,Y) = 1. What is Var(Z)?",
         container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans7 <- c("(a)  -2",
            "(b)  0",
            "(c)  4",
            "(d)  6")

  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r7) <- character(0)
  }

  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)


}

eff.rbd <- function(lm){
alm<-anova(lm)
block <- alm[rownames(alm)=="block",]
trt <- alm[rownames(alm)!="block"&rownames(alm)!="Residuals",] 
error <- alm[rownames(alm)=="Residuals",] 
nb <- as.numeric(block[1])+1
r <- as.numeric(trt[1])+1
MSB <- as.numeric(block[3])+1
MSE <- as.numeric(error[3])+1

(((nb - 1)* MSB)+(nb * (r - 1) * MSE))/((nb * r) - 1 * MSE)
}

Kullback <- function(Y,X)
{
X <- factor(X)
n <- length(X)
# n.j <- as.matrix(summary(X))
n.j <- summary(X)
p <- ncol(Y)
g <- nlevels(X)
lev.X <- levels(X)
#
# Vj will contain the within-group dispersion matrices of individual groups
Vj <- vector("list", g)
log.ratios <- NA
det.V.j <- NA
# Compute |V|
V <- matrix(0,p,p)
for(k in 1:g)  V <- V + cov(Y[X==lev.X[k],])*(n.j[k]-1)
V <- V/(n-g)
det.V <- det(V)
# Compute Kulback chi-square
Chi <- 0
for(k in 1:g) {
	V.group <- cov(Y[X==lev.X[k],])
	det.V.gr <- det(V.group)
	log.rat <- log(det.V/det.V.gr)
	Chi <- Chi + log.rat*((n.j[k]-1)/2)
	Vj[k] <- list(V.group)
	log.ratios <- c(log.ratios, log.rat)
	det.V.gr <- c(det.V.j, det.V.gr)
	}
#
p.val <- pchisq(Chi,(g-1)*p*(p+1)/2,lower.tail=FALSE)
res <- data.frame(Chi=Chi,df=(g-1)*p*(p+1)/2,p.val=p.val)
names(res) <- c("Chi*","df","P(Chi>Chi*)")
head<-"Kullback test for equal covariance matrices"
out <- list(Kullback=res, V=V, Vj=Vj, log.ratios=log.ratios[-1], det.V=det.V, det.V.j=det.V.j[-1], head=head)
class(out)<-"kback"
out
}


print.kback<-function(x,digits= max(3, getOption("digits")), ...){
cat("\n")
cat(x$head,"\n")
rq<-x$Kullback
print(rq,digits=digits)
cat("\n")
invisible(x)
}

HL.mean <- function (x, conf = NULL, method = "exact") 
{
    d <- outer(x, x, "+")/2
    sus <- d[lower.tri(d, diag = TRUE)]
    pm <- median(sus)

if(!is.null(conf)){
    alpha <- 1 - conf
    if(method == "normal"){
        n <- length(x)
        c.alpha <- floor((n*(n+1))/4-qnorm(1-(alpha/2))*sqrt((n*(n+1)*(2*n+1))/24))
        M <- (n^2+n)/2 
        soso <- sort(sus)
        ci.L <- soso[c.alpha]
        ci.U <- soso[M + 1 - c.alpha]
    }
    
    if(method == "exact"){
        n <- length(x)
        M <- (n^2+n)/2 
        c.alpha <- M + 1 - (qsignrank(1-(alpha/2), n = n)+1)
        soso <- sort(sus)
        ci.L <- soso[c.alpha]
        ci.U <- soso[M + 1 - c.alpha]
        }
}

if(is.null(conf)) res <- pm
if(!is.null(conf)){ 
res <- list()
res$head<-paste(paste(as.character(conf*100),"%",sep=""),c("Confidence interval for population pseudomedian"))
res$ci<-c(pseudomedian=pm,lower=ci.L,upper=ci.U)
res$ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
class(res)<-"ci"
}
res
}

anm.coin.tck<-function () 
{

    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE)
        dialog.sd <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "Frequentist probability and coin flips")
            p.entry <- tkentry(tt, textvariable = P, width = 10)
            int.entry <- tkentry(tt, textvariable = Int, width = 10)
            flip.entry <- tkentry(tt, textvariable = Flip, width = 10)
            done <- tclVar(0)
            show.coin<-tclVar(1)
            reset <- function() {
                tclvalue(P) <- "0.5"
                tclvalue(Int) <- "0.01"
                tclvalue(Flip) <- "1000"
                tclvalue(show.coin)<-"0"
            }
            tclServiceMode(FALSE)
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)
            build <- function() {
                p.head <- tclvalue(P)
                interval <- tclvalue(Int)
                flips <- tclvalue(Flip)
                show.coin <- as.logical(tclObj(show.coin))
                substitute(anm.coin(p.head = as.numeric(p.head), 
                  interval = as.numeric(interval), flips = as.numeric(flips),show.coin=show.coin))
            }
            nc.cbut <- tkcheckbutton(tt, text="Show coin", variable=show.coin)
            tkgrid(tklabel(tt, text = "Frequentist probability\nand coin flips", justify = "center"), columnspan = 2)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = "P(Head)"), p.entry)
            tkgrid(tklabel(tt, text = "Flips"), flip.entry)
            tkgrid(tklabel(tt, text = "Anim. int."), int.entry)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(nc.cbut)
            tkgrid(submit.but, reset.but, sticky ="w")
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
        }
        P <- tclVar("0.5")
        Flip <- tclVar("1000")
        Int <- tclVar("0.01")
        dialog.sd()
    })
    }

partial.resid.plot <- function (x, smooth.span = 0.8, lf.col = 2, sm.col = 4,...) 
{
    p <- ncol(x$model)
    X <- as.matrix(x$model[,2:p])
    Y <- x$model[,1]
    resid <- matrix(ncol = ncol(X), nrow = nrow(X))
    other.resid <- matrix(ncol = ncol(X), nrow = nrow(X))
    for (i in 1:ncol(X)) {
        resid[, i] <- lm(Y ~ X[, -i])$residuals
        other.resid[, i] <- lm(X[, i] ~ X[, -i])$residuals
    }
    for (i in 1:ncol(X)) {
        plot(other.resid[, i], resid[, i], xlab = bquote(paste(hat(epsilon), 
            "(", .(colnames(X)[i]), " | model without ", .(colnames(X)[i]), 
            ")")), ylab = bquote(paste(hat(epsilon), "(Y | model without ", 
            .(colnames(X)[i]), ")")),...)
        l1 <- lm(resid[, i] ~ other.resid[, i])
        abline(as.numeric(l1$coefficients[1]), as.numeric(l1$coefficients[2]), 
            col = lf.col, lty = 1)
        lines(lowess(other.resid[, i], resid[, i], f = smooth.span), 
            lty = 2, col = sm.col)
        readline("Press return for next plot")
    }
}

pairw.fried<-function(y, x, blocks, nblocks, conf = 0.95)
{block.ranks<-matrix(ncol=nlevels(x),nrow=nblocks)
for(i in 1:nblocks){
block.ranks[i,]<-rank(y[blocks==i])
}	
mean.ranks<-apply(block.ranks,2,mean)

R1<-tapply(y,x,length)
r<-length(R1)
fitted<- tapply(y, x, median)
dif.mat<-outer(mean.ranks,mean.ranks,"-")
diffs<-dif.mat[upper.tri(dif.mat)]

SE.diff<-sqrt((r*(r+1))/(6*nblocks))
B<-qnorm(1-((1-conf)/(2*(r^2-r)/2)))
p.val<-2*pnorm(abs(diffs)/SE.diff,lower.tail=FALSE)
p.adj<-ifelse(p.val*((r^2-r)/2)>=1,1,round(p.val*((r^2-r)/2),6))
hwidths<-B*SE.diff
val<-round(cbind(diffs,diffs-hwidths,diffs+hwidths),5)
Decision<-ifelse((val[,2]>0&val[,3]>0)|val[,2]<0&val[,3]<0,"Reject H0","FTR H0")
mr<-as.matrix(mean.ranks)
row.names(mr)<-levels(x)
val<-as.data.frame(cbind(val,Decision,p.adj))
lvl<-outer(levels(x),levels(x),function(x1,x2){paste(paste("Avg.rank",x1,sep=""),paste("Avg.rank",x2,sep=""),sep="-")})
dimnames(val)<-list(lvl[upper.tri(lvl)],
c("Diff","Lower","Upper","Decision","Adj. P-value"))
head<-paste(paste(as.character(conf*100),"%",sep=""),c("confidence intervals for Friedman's comparisons"))
###
res <- list()
res$head <- head
res$conf <- conf
comp <- outer(levels(x),levels(x),function(x1,x2){paste(x1, x2, sep="-")})
res$comp <- comp[upper.tri(comp)]
res$summary <- val
res$band <- cbind(diffs-hwidths, diffs+hwidths)
res$fitted <- fitted
res$mean.rank.in.blocks<-mr
res$method <- "mBonferroni"
res$x <- x
res$y <- y
class(res)<-"pairw"
res
}

dirty.dist <- function(s.size, parent = expression(rnorm(1)), cont = expression(rnorm(1, mean = 10)), prop.cont = 0.1){
vec <- seq(1,s.size)
for(i in 1 : s.size){
pure <- eval(parent)
dirty <- eval(cont)
vec[i]<- sample(c(pure, dirty), size = 1, prob = c(1 - prop.cont, prop.cont))
}
vec
} 

samp.dist<- function (parent = NULL, parent2 = NULL, biv.parent = NULL, s.size = 1, s.size2 = NULL, R = 1000, nbreaks = 50, stat = mean, stat2 = NULL, 
stat3 = NULL, stat4 = NULL, xlab = expression(bar(x)), func = NULL, show.n = TRUE, show.SE = FALSE, anim = TRUE, interval = 0.01, col.anim = "rainbow", digits = 3, ...) 
{
 
    if (is.null(col.anim)) 
        clr = NULL
    if (!is.null(col.anim)) {
        if (col.anim == "rainbow") 
            clr <- rainbow(R)
        if (col.anim == "heat.colors") {
            c1 <- heat.colors(R, 1)
            clr <- c1[length(c1):1]
        }
        if (col.anim == "gray") 
            clr <- gray(1 - (1:R)/R)
        if (col.anim != "rainbow" & col.anim != "gray" & col.anim != 
            "heat.colors") 
            clr <- rep(col.anim, R)
    }

if(!is.null(biv.parent)){
     
        func.res <- seq(1:R)
        for (i in 1:R) {
            if(is.expression(biv.parent)) part <- eval(biv.parent)
            if(!is.expression(biv.parent)){ 
                part <- sample(1:nrow(biv.parent), s.size, replace = FALSE)
                samp <- sample(1:nrow(biv.parent), s.size, replace = FALSE)
                part <- biv.parent[samp,]}
            
            func.res[i] <- func(part[,1],part[,2])
}
}
    
if(is.null(biv.parent)){    
    if (is.null(stat2) & is.null(stat3)) {
        func.res <- matrix(ncol = 1, nrow = R)
            for (i in 1:R) {
                if(is.expression(parent))func.res[i] <- stat(eval(parent))
                if(!is.expression(parent)){
                    part <- sample(parent, size = s.size, replace = FALSE)
                    func.res[i] <- stat(part)}
           }
        if (!is.null(func)) 
            func.res <- func(func.res, s.dist2 = NULL, s.size, s.size2 = NULL)
    }

    if (!is.null(stat2) | !is.null(stat3)){
        s.dist1 <- matrix(ncol = 1, nrow = R)
        s.dist2 <- matrix(ncol = 1, nrow = R)
        s.dist3 <- matrix(ncol = 1, nrow = R)
        s.dist4 <- matrix(ncol = 1, nrow = R)
         for(i in 1 : R){
             if(is.expression(parent)){
                sample1 <- eval(parent)
                if(!is.null(parent2)) sample2 <- eval(parent2)
                }
             if(!is.expression(parent)){
                sample1 <- sample(parent, size = s.size, replace = FALSE)
                if(!is.null(parent2)) sample2 <- sample(parent2, size = s.size, replace = FALSE)
                }
                        
                    s.dist1[i] <- stat(sample1)
                if (!is.null(stat2)) 
                    s.dist2[i] <- stat2(sample2)
                if (!is.null(stat3)) 
                    s.dist3[i] <- stat3(sample1)
                if (!is.null(stat4)) 
                    s.dist4[i] <- stat4(sample2)
              } 
        
        if (!is.null(stat2) & (is.null(stat3) | is.null(stat4))) {
            func.res <- func(s.dist1, s.dist2, s.size, s.size2)
        }
        if (!is.null(stat3) & (is.null(stat2) | is.null(stat4))) {
            func.res <- func(s.dist1, s.dist3, s.size, s.size2)
        }                                                               
        if (!is.null(stat2) & !is.null(stat3) & !is.null(stat4)) {
            func.res <- func(s.dist1, s.dist2, s.dist3, s.dist4, s.size, s.size2)
        }
        }
        }
        SE <- round(ifelse(is.matrix(func.res),apply(func.res, 2, sd),sd(func.res)),digits)
        brks <- seq(min(func.res),max(func.res),length.out=nbreaks)
        
        if (anim == TRUE) {
          if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
          {dev.new(noRStudioGD = TRUE)}
            for (i in 1:R) {
                dev.hold()
                hist(func.res, xlab = xlab,  
                  main = "", freq = FALSE, breaks = brks, border = "white",...)
                points(suppressWarnings(hist(func.res[1:i], plot = FALSE, 
                  breaks = brks, freq = FALSE)$mids), suppressWarnings(hist(func.res[1:i], 
                  plot = FALSE, breaks = brks, freq = FALSE)$density), 
                  type = "h", col = clr[i], lwd = 5)
                if(i < R) legend("topright",legend=i, bty="n", title="Sample")
                dev.flush()
                Sys.sleep(interval)
            }
        }
        if (anim == FALSE) {
            hist(func.res, xlab = xlab,  
                main = "", freq = FALSE, breaks = brks, ...)
        }
    
    if (show.SE == FALSE & show.n == TRUE) {
       if(is.null(s.size2))legend("topright", legend = paste("n = ", s.size), bty = "n")
       if(!is.null(s.size2))legend("topright", legend = c(paste("n1 = ", s.size), paste("n2 = ", s.size2)), bty = "n")
    }
    if (show.SE == TRUE & show.n == FALSE) {
       legend("topright", legend = paste("SE = ", SE), bty = "n")
    }
    if (show.SE == TRUE & show.n == TRUE) {
       if(is.null(s.size2)){
       legend("topright", legend = c(paste("n = ", s.size), 
            paste("SE = ", SE)), bty = "n")}
       if(!is.null(s.size2)){
       legend("topright", legend = c(paste("n1 = ", s.size), paste("n2 = ", s.size2), 
            paste("SE = ", SE)), bty = "n")}     
    }
}

#----------------------------- changing n ------------------------------------#

samp.dist.n<-function (parent, R = 500, n.seq = seq(1, 30), stat = mean, xlab = expression(bar(x)), 
    nbreaks = 50, func = NULL, show.n = TRUE, 
    show.SE = FALSE, est.density = TRUE, col.density = 4, lwd.density = 2, 
    est.ylim = TRUE, ylim = NULL, anim = TRUE, interval = 0.5, 
    col.anim = NULL, digits = 3, ...) 
{
    n.max <- max(n.seq)
    n.min <- min(n.seq)
    max.col <- length(n.seq)
    if (n.min == 1 & is.na(stat(1))) 
        stop("Statistic in stat cannot be computed with n = 1, revise n.seq.")
    if (anim == FALSE) {
        s.dist <- matrix(ncol = 1, nrow = R)
        for (i in 1:R) {
            if(is.expression(parent)) s.dist[i] <- stat(eval(parent))
            if(!is.expression(parent)) s.dist[i] <- stat(sample(parent, size = n.max, replace = FALSE))
        }
        if (!is.null(func)) 
            s.dist <- func(s.dist)
        SE <- round(apply(s.dist,2,sd), digits)
        hist(s.dist, xlab = xlab, main = "", freq = FALSE, 
            breaks = nbreaks, ...)
        if (est.density == TRUE) {
            lines(density(s.dist), col = col.density, lwd = lwd.density)
        }
        if (show.n == TRUE & show.SE == FALSE) {
            legend("topright", legend = paste("n = ", n.max), 
                bty = "n")
        }
        if (show.SE == TRUE & show.n == FALSE) {
            legend("topright", legend = paste("SE = ", SE), bty = "n")
        }
        if (show.SE == TRUE & show.n == TRUE) {
            legend("topright", legend = c(paste("n = ", n.max), 
                paste("SE = ", SE)), bty = "n")
        }
    }
    if (anim == TRUE) {
        if (is.null(col.anim)) 
            clr = NULL
        if (!is.null(col.anim)) {
            if (col.anim == "heat.colors") {
                c1 <- heat.colors(max.col)
                clr <- c1[length(c1):1]
            }
            if (col.anim == "rainbow") 
                clr <- rainbow(max.col)
            if (col.anim == "gray") 
                clr <- gray(1 - (1:max.col/max.col))
            if (col.anim != "rainbow" & col.anim != "gray" & 
                col.anim != "heat.colors") 
                clr <- rep(col.anim, max.col)
        }
        s.dist <- matrix(nrow = R, ncol = max.col)
        for (i in n.min:max.col) {
            if(is.expression(parent)) s.dist[,i] <- stat(eval(parent))
            if(!is.expression(parent)){
            s.dist[,i] <- apply(matrix(replicate(R, sample(parent, 
                i)), i), 2, stat)}
        }
        if (!is.null(func)) 
            s.dist <- func(s.dist)
        SE <- round(apply(s.dist, 2, sd), digits)
        if (est.ylim == TRUE & !is.numeric(ylim)) {
            ylim <- c(0, max(c(max(density(s.dist[, 1])$y), max(density(s.dist[, 
                max.col])$y))))
        }
        brks <- seq(min(s.dist), max(s.dist), length.out = nbreaks)
        for (i in 1:length(n.seq)) {
            dev.hold()
            hist(s.dist[, i], xlab = xlab, ylim = ylim, 
                main = "", breaks = brks, freq = FALSE, col = clr[i],...)
            if (show.n == TRUE & show.SE == FALSE) {
                legend("topright", legend = paste("n = ", n.seq[i]), 
                  bty = "n")
            }
            if (show.SE == TRUE & show.n == FALSE) {
                legend("topright", legend = paste("SE = ", SE[i]), 
                  bty = "n")
            }
            if (show.SE == TRUE & show.n == TRUE) {
                legend("topright", legend = c(paste("n = ", n.seq[i]), 
                  paste("SE = ", SE[i])), bty = "n")
            }
            if (est.density == TRUE) {
                lines(density(s.dist[, i]), col = col.density, 
                  lwd = lwd.density)
            }
            dev.flush()
            Sys.sleep(interval)
        }
    }
}

dec2bin.twos <- function(num, ...) {
  abs <- abs(num)
  temp <- dec2bin(abs, ...)

    #1#
    out <- paste(0, temp, sep = "")
    if (num < 0) {
    #2#
    h <- unlist(strsplit(out, ""))
    step2.1 <- gsub("1", "0.1", x = h)
    step2.2 <- gsub("0", "1", x = step2.1)
    step2.3 <- gsub("1.1", "0", x = step2.2)
    #3#
    one <- 1 # if no fractional component
    if (any(step2.3 == ".")) {
    # find last fractional bit
      w <- which(step2.3 == ".")
      len <- length(step2.3)
      one <- bin2dec(10^(w - len))
    }
    step3.1 <- paste(step2.3, collapse = "")
    # add one to last bit
    step3.2 <- bin2dec(step3.1) + one
    out <- dec2bin(step3.2, ...)
  }
  out
}

anm.LVe.tck<-function(){         

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Lotka Volterra exploitation")       
        nh.entry <- tkentry(tt, textvariable=Nh, width = 10)              
        np.entry <- tkentry(tt, textvariable=Np, width = 10) 
        rh.entry <- tkentry(tt, textvariable=Rh, width= 10) 
        con.entry <- tkentry(tt, textvariable=Con, width = 10 ) 
        p.entry <- tkentry(tt, textvariable=P, width = 10)
        dp.entry<-tkentry(tt, textvariable=Dp, width = 10)
        int.entry<-tkentry(tt, textvariable=Int, width = 10)
        Ts.entry<-tkentry(tt, textvariable=Ts, width = 10)
                
	done <- tclVar(0)
  show.circle<-tclVar(0)
        reset <- function()
        {
            tclvalue(Nh)<-"300"                                       
            tclvalue(Np)<-"50"
            tclvalue(Rh)<-"0.7"
            tclvalue(Con)<-"0.4"
            tclvalue(P)<-"0.006"
            tclvalue(Dp)<-"0.2"
            tclvalue(Int)<-"0.1"
            tclvalue(Ts)<-"seq(0,200)"
            tclvalue(show.circle)<-"0"
          }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
        c.cbut <- tkcheckbutton(tt, text="Circle", variable=show.circle)
        build <- function()
        {
            nh <-tclvalue(Nh)
            np <-tclvalue(Np)
            rh <-tclvalue(Rh)
            con <-tclvalue(Con)
            p <-tclvalue(P)
            d.p <-tclvalue(Dp)
            interval <-tclvalue(Int) 
            time<-parse(text=tclvalue(Ts))[[1]]
            circle<-as.logical(tclObj(show.circle))    
           substitute(anm.LVexp(nh=as.numeric(nh),np=as.numeric(np),rh=as.numeric(rh),con=as.numeric(con),p=as.numeric(p),d.p=as.numeric(d.p),interval=as.numeric(interval),time=time,circle=circle))
        }
        
        tkgrid(tklabel(tt,text="Lotka Volterra exploitation"),columnspan=4)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""), tklabel(tt,text="Prey"),tklabel(tt,text=""),tklabel(tt,text="Predator"))
        tkgrid(tklabel(tt,text="    n.h", width = 5), nh.entry,tklabel(tt,text="n.p"), np.entry)
        tkgrid(tklabel(tt,text="    r.h", width = 5), rh.entry,tklabel(tt,text="c"), con.entry)
        tkgrid(tklabel(tt,text="    p", width = 5), p.entry,tklabel(tt,text="d.p"), dp.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Time seq."), Ts.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Anim. int."),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(c.cbut)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, tklabel(tt,text=""),tklabel(tt,text=""),reset.but, sticky="e")
      
        

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    invisible(tclServiceMode(TRUE))
    }                            
      Nh<-tclVar("300")                          
      Np<-tclVar("50")
      Rh<-tclVar("0.7")
      Con<-tclVar("0.4")
      P<-tclVar("0.006")
      Dp<-tclVar("0.2")
      Int<-tclVar("0.1")
      Ts<-tclVar("seq(0,200)")
      dialog.sd()
})
}

bayes.lm <- function(Y, X, model = "anova", length = 1000, cred = .95)
{
n <- length(Y); p <- ncol(X)
beta.hat <- solve(qr(X, LAPACK=TRUE), Y)
V.beta <- solve(t(X)%*%X)
MSE<-(t(Y)%*%(Y)-t(beta.hat)%*%t(X)%*%Y)/(n - p)
sigma.sq <- rinvchisq(length, n - p, MSE)

beta.f.x <- matrix(ncol = length(beta.hat), nrow = length)
for(i in 1 : length){
    beta.f.x[i,] <- rmvnorm(1, beta.hat, V.beta *sigma.sq[i])
    }

alpha <- 1 - cred
hi <- 1 - (alpha/2)
low <- 1 - hi
 
posterior <- data.frame(cbind(sigma.sq, beta.f.x))
lower <- apply(posterior, 2, function(x) quantile(x, low))
upper <- apply(posterior, 2, function(x) quantile(x, hi))
med <- apply(posterior, 2, median)

if(model == "reg") rnames <- c("sigma.sq", paste("beta", seq(0, (ncol(X) -1)), sep = ""))
if(model == "anova") rnames <- c("sigma.sq", "mu", paste("alpha", seq(1, (ncol(X) -1)), sep = ""))
cnames <- c(paste(low * 100, "%", sep =""), "Median", paste(hi * 100, "%", sep =""))
head <- c("Bayesian linear model with standard uniform priors")

summary <- data.frame(cbind(lower, med, upper)) 
names(summary) <- cnames
rownames(summary) <- rnames

res <- list(summary = summary, head = head, posterior = posterior)
class(res) <- "blm"
res
}  

print.blm <- function(x, ...){
cat("\n")
cat(x$head, "\n\n")
print(x$summary)
cat("\n")
invisible(x)
}   

selftest.jack.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Jackknifing and Bootstrapping")
  size(w) <- c(700, 400)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We often use jackknifing and bootstrapping in cases when...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)  the sample dataset is small.",
            "(b)  the sampling distribution of an estimator is unknown.",
            "(c)  the sample data contain errors.",
            "(d)  the sample dataset is extremely large.")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  

  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("With bootstrapping...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("(a)  we sample with replacement from an existing dataset.",
            "(b)  we sample without replacement from an existing dataset.",
            "(c)  we create pseudovalues based statistical summaries of particular data subsets: the dataset with the 1st \nobservation removed, the dataset with the 2nd observation removed, etc.",
            "(d)  we create pseudovalues based statistical summaries of particular data subsets: the 1st \nobservation, the 2nd observation, etc.",
            "(e)  we create a Bayesian posterior distribution.")
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[5]){
      gmessage(msg="Incorrect.  Bootstrapping is not an explicitly Bayesian method.",  icon = "error")
    }
      svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  
  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("With jackknifing...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)  we sample with replacement from an existing dataset.",
            "(b)  we sample without replacement from an existing dataset.",
            "(c)  we create pseudovalues based statistical summaries of particular data subsets: the dataset with the 1st \nobservation removed, the dataset with the 2nd observation removed, etc.",
            "(d)  we create pseudovalues based statistical summaries of particular data subsets: the 1st \nobservation, the 2nd observation, etc.",
            "(e)  we create a Bayesian posterior distribution.")
  
  
  
 f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[5]){
      gmessage(msg="Incorrect.  Jackknifing is not an explicitly Bayesian method.",  icon = "error")
    }
    svalue(r3) <- character(0)
 }
 
 r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
 
  
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Scientists often use jackknifing to...", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("(a) create normal distributions for bacteria.",
            "(b) run bioinformatics sequences.",
            "(c) check the bias of estimators.",
            "(d) generate species area curves.",
            "(e) All of the above.",
            "(f)   (a) and (b) only.",
            "(g)  (c) and (d) only.")
  
  
  f4 <-  function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[7]){
      gmessage(msg="Correct")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
}

mcmc.norm.hier <- function(data, length = 1000, n.chains = 5){
# require(geoR) 

n.j <- apply(data, 2, function(x) length(x[!is.na(x)]))
ybar.j <- apply(data, 2, function(x) mean(x, na.rm = TRUE))
n <- sum(n.j)
J <- ncol(data)

#--------------- Statistics -----------------#

s.sq.hat <- function(t.j){
sm <- seq(1, J)
for(i in 1 : J){
sm[i] <- sum(sapply(data[,i],function(x)(x - t.j[i])^2),na.rm=TRUE)
}
1/n*sum(sm)
}

tau.sq.hat <- function(t.j, mu) 1/(J-1) * sum((t.j-mu)^2, na.rm = TRUE)
theta.j.hat <- function(tau.sq, s.sq, mu, ybar.j, n.j) ((1/tau.sq) * mu + (n.j/s.sq) * ybar.j)/((1/tau.sq) + (n.j/s.sq))
V.theta.j <- function(tau.sq, s.sq, n.j) 1/((1/tau.sq) + (n.j/s.sq))


#############################################################
#---------------------------Gibbs---------------------------#
#############################################################

dimnames <- list(seq(1 : length), c(paste("theta", seq(1 : J), sep = ""), "mu", "s.sq", "tau.sq"), paste("Chain#", seq(1 : n.chains)))
chains <- array(NA, c(length, J + 3 , n.chains), dimnames = dimnames)
    
    for(m in 1 : n.chains){

#------------------ Start for each chain -------------------#

    theta.j <- matrix(ncol = J, nrow = length)
    mu <- matrix(ncol = 1, nrow = length)
    s.sq <- matrix(ncol = 1, nrow = length)
    tau.sq <- matrix(ncol = 1, nrow = length) 
    
    theta.j[1,] <- apply(data, 2, function(x) sample(x[!is.na(x)], 1, replace = TRUE))
    mu[1] <- mean(theta.j, na.rm = TRUE)
    s.sq1 <- s.sq.hat(theta.j[1,]) 
    s.sq[1] <- rinvchisq(1, n, s.sq1)
    tau.sq1 <- tau.sq.hat(theta.j[1,], mu[1])
    tau.sq[1] <- rinvchisq(1, J - 1, tau.sq1)

#-------------------------- Sampling ------------------------#

    for(i in 2 : length){
        k = i
        for(j in 1 : J){
            theta1 <- theta.j.hat(tau.sq[k - 1], s.sq[k - 1], mu[k - 1],  ybar.j[j], n.j[j])
            vtheta1 <- V.theta.j(tau.sq[k - 1], s.sq[k - 1], n.j[j]) 
            theta.j[k,][j] <- rnorm(1, theta1, sqrt(vtheta1))
            }
    
        mu.hat <- mean(theta.j[i,])
        mu[i] <- rnorm(1, mu.hat, sqrt(tau.sq[i - 1]/(J)))
        
        s.sq1 <- s.sq.hat(theta.j[i,]) 
        s.sq[i] <- rinvchisq(1, n, s.sq1)
        
        tau.sq1 <- tau.sq.hat(theta.j[i,], mu[i])
        tau.sq[i] <- rinvchisq(1, J - 1, tau.sq1)
        } 
    chains[1 : length, 1 : (ncol(data) + 3), m] <- cbind(theta.j, mu, s.sq, tau.sq)
    }

#############################################################
#-----------------------------------------------------------#
#############################################################

class(chains) <- "norm.hier"
chains
}

norm.hier.summary <- function(M, burn.in = 0.5, cred = 0.95, conv.log = TRUE){
  if(!inherits(m, "norm.hier")) stop("Input must be output from function 'mcmc.norm.hier'")
        n <- dim(M)[1]
        m <- M[(n * burn.in) : n, ,]
        vars <- dim(m)[2]
        n.chains <- dim(m)[3]
        
        upper <- 1 - (1 - cred)/2; lower <- 1 - upper 
        res <- matrix(nrow = vars, ncol = 4, dimnames = list(c(paste("theta", seq(1 : (vars - 3)), sep = ""), "mu", "s.sq", "tau.sq"), c(paste(lower * 100, "%", sep = ""), "Median", paste(upper * 100, "%", sep =""), "R.hat")))
            for(i in 1 : vars){
            res[,1][i] <- quantile(m[, i, 1 : n.chains], lower)
            res[,2][i] <- median(m[, i, 1 : n.chains])
            res[,3][i] <- quantile(m[, i, 1 : n.chains], upper)
            }
            if(conv.log == TRUE) M[, (vars - 1) : vars,]  <- log(M[,(vars-1):vars,])
            for(i in 1 : vars){
            res[,4][i] <- R.hat(M[, i, 1 : n.chains])
            }
    res
}

auc <- function(obs, fit, plot=FALSE){
compf <- outer(fit[obs == 0], fit[obs == 1], function(x, y)paste(x, y, sep = ","))
cf <- as.data.frame(matrix(ncol = 2, unlist(strsplit(compf, ",")), byrow = TRUE))
names(cf) <- c("pi.hat.0", "pi.hat.1")

n <- prod(summary(factor(obs)))
U <- ifelse(cf[,1] < cf[,2], 1, 0)
AUC <- sum(U)/n

if(plot==TRUE){
        
        int <- seq(0.01, 0.99, by = 0.01)
        sens <- rep(NA, length(int))
        omspec <- rep(NA, length(int))
       
        for(i in 1:length(int)){
        t <- table(ifelse(fit > int[i], 1, 0), obs)
                    
        sens[i] <- t[,2][2]/sum(t[,2])
        omspec[i] <- 1 - t[,1][1]/sum(t[,1])
        }
        
        plot(c(1, omspec, 0), c(1, sens, 0), xlab = "False positive rate", ylab = "True positive rate", type = "l", xlim=c(0,1), ylim=c(0,1), lwd = 2.5, main = "ROC curve",cex.lab=1.3,cex.main=1.3)
        abline(0, 1, lty = 2)
        }
AUC
}

see.logis.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    theta <- 1
    beta<-0
    assign("theta", tclVar(theta), envir= slider.env)
    assign("beta", tclVar(beta), envir= slider.env)
    xmin <- -10
    assign("xmin", tclVar(xmin), envir= slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir= slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

   norm.refresh <- function(...) {
        theta <- as.numeric(evalq(tclvalue(theta), envir= slider.env))
        beta <- as.numeric(evalq(tclvalue(beta), envir= slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir= slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir= slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dlogis(xx, beta, theta)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(LOGIS), "(", .(beta),", ",.(theta), ")",sep="")), line = 1, side = 3)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "LOGIS(\u03b2, \u03b8)")
    tkpack(tklabel(m,text="      Visualizing the Logistic Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b2',font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = beta), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b8', font=c("Helvetica","9","italic"), width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = theta), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir= slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir= slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}



see.logiscdf.tck<-function (){
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    theta <- 1
    beta<-0
    assign("theta", tclVar(theta), envir= slider.env)
    assign("beta", tclVar(beta), envir= slider.env)
    xmin <- -10
    assign("xmin", tclVar(xmin), envir= slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir= slider.env)

    dev.new(height=4,width=8,noRStudioGD = TRUE);par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
   norm.refresh <- function(...) {
        theta <- as.numeric(evalq(tclvalue(theta), envir= slider.env))
        beta <- as.numeric(evalq(tclvalue(beta), envir= slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir= slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir= slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dlogis(xx, beta, theta)
        y1<- plogis(xx, beta, theta)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        plot(xx, y1, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(LOGIS), "(", .(beta),", ",.(theta), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
  tkwm.title(m, "LOGIS(\u03b2, \u03b8)")
    tkpack(tklabel(m,text="      Visualizing the Logistic Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b2', font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = beta), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03b8', font=c("Helvetica","9","italic"), width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir= slider.env)
    evalq(tkconfigure(sc, variable = theta), envir= slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir= slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir= slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
 #   on.exit(par(old.par))
    norm.refresh()
  }

see.chicdf.tck<-function ()
{

 # old.par <- par(no.readonly = TRUE)

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu <- 5
    assign("nu", tclVar(nu), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir = slider.env)

    dev.new(height=4,width=8,noRStudioGD = TRUE)
    par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.75,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
    norm.refresh <- function(...) {
        nu <- as.numeric(evalq(tclvalue(nu), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(0, xmax, length = 500)
        yy <- dchisq(xx, nu)
        y1 <- pchisq(xx, nu)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        plot(xx, y1, type = "l", xlim = c(xmin, xmax), xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", chi^2, "(", .(nu), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
            }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "\u03A7\u00B2(\u03bd)")
     tkpack(tklabel(m,text="      Visualizing the Chi-square Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd',font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
#    on.exit(par(old.par))
    norm.refresh()
        }


see.chi.tck<-function ()
{

    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    nu <- 5
    assign("nu", tclVar(nu), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 20
    assign("xmax", tclVar(xmax), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        nu <- as.numeric(evalq(tclvalue(nu), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(0, xmax, length = 500)
        yy <- dchisq(xx, nu)
        y1 <- pchisq(xx, nu)
        dev.hold()
        plot(xx, yy, type = "l", xlim = c(xmin, xmax),xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", chi^2, "(", .(nu), ")", sep = "")), line = 1, side = 3)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "\u03A7\u00B2(\u03bd)")
    tkpack(tklabel(m,text="      Visualizing the Chi-square Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bd',font=c("Helvetica","9","italic"),width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 1,
        to = 30, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = nu), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

trim.ranef.test<-function(Y,X,tr=.2){
a<-nlevels(as.factor(X))
Xn<-as.numeric(X)

X.bar.Wi<-matrix(ncol=1,nrow=a)
S.sq.W.i<-matrix(ncol=1,nrow=a)
for(i in 1:a){
Y.ij<-win(Y[Xn==i])
X.bar.Wi[i]<-mean(Y.ij)
S.sq.W.i[i]<-var(Y.ij)
}

h<-matrix(nrow=a,ncol=1)
for(i in 1:a){
h[i]<-length(trim.me(Y[Xn==i],trim=tr))
h}

X.bar.ti<-tapply(Y,X,function(x){mean(x,trim=tr)})
X.bar.t<-mean(X.bar.ti)
BSST<-(1/(a-1))*sum((as.matrix(X.bar.ti)-X.bar.t)^2)

inner.WSSW<-matrix(nrow=a,ncol=1)
for(i in 1:a){
inner.WSSW[i]<-sum((win(Y[Xn==i]-X.bar.Wi[i])^2)/(h[i]*(h[i]-1)))
}

WSSW<-(1/a)*sum(inner.WSSW)
F.star<-BSST/WSSW

n.i<-tapply(Y,X,length)

d<-matrix(nrow=a,ncol=1)
for(i in 1:a){
d[i]<-((n.i[i]-1)*S.sq.W.i[i])/(h[i]*(h[i]-1))

}
nu1<-(((a-1)*sum(d))^2)/((sum(d))^2+(a-2)*a*sum(d^2))
nu2<-(sum(d))^2/(sum((d^2)/(h-1)))
res<-list()
res$Table<-data.frame(nu1=nu1,nu2=nu2,F=F.star,P.val=pf(F.star,nu1,nu2,lower.tail=FALSE))
colnames(res$Table)<-c("df1","df2","F*","P(>F)")
res
}

anm.ls.reg.tck<-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,'OLS estimation of regression parameters')
        X.entry <- tkentry(tt, textvariable=X, width = 10)
        Y.entry <- tkentry(tt, textvariable=Y, width = 10)
        Par.entry <- tkentry(tt, textvariable=Par, width = 10)
        int.entry <- tkentry(tt, textvariable=Int, width = 10)
              
                
	done <- tclVar(0)
  
        reset <- function()
        {
            tclvalue(X)<-"rnorm(30)"
            tclvalue(Y)<-"rnorm(30)"
            tclvalue(Y)<-"Par"
            tclvalue(Int)<-"0.1"
           
          }
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)

        build <- function()
        {
            X <-n.seq<-parse(text=tclvalue(X))[[1]]
            Y <-n.seq<-parse(text=tclvalue(Y))[[1]]
            interval <-tclvalue(Int) 
            par<-tclvalue(Par)
     
           substitute(anm.ls.reg(X=as.numeric(X),Y=as.numeric(Y),parameter=par,interval=as.numeric(interval)))
        }
        
        tkgrid(tklabel(tt,text='OLS estimation of regression'),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="X"), X.entry)
        tkgrid(tklabel(tt,text="Y"), Y.entry)
        tkgrid(tklabel(tt,text="Parameter"), Par.entry)
        tkgrid(tklabel(tt,text="Anim. int."),int.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky = "w")
         

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    invisible(tclServiceMode(TRUE))
    }                            
      X<-tclVar("rnorm(30)")
      Y<-tclVar("rnorm(30)")
      Int<-tclVar("0.1")
      Par<-tclVar("slope")
      dialog.sd()
})
}

plotAncova <- function(model, pch = NULL, lty = NULL, col = NULL, leg.loc = "topright", leg.cex = 1, leg.bty = "o", leg.bg = par("bg"), legend.title = NULL, ...) {
  if(model$contrasts!="contr.treatment") stop("Please use treatment contrasts")
  if(ncol(model$model)>3) stop("function can only be used one with one-way ANCOVAs")
    
    x.name <- names(attr(model$terms,"dataClasses"))[attr(model$terms,"dataClasses")=="character"|attr(model$terms,"dataClasses")=="factor"]
    x1 <- model$model[,names(model$model)==x.name]
      cats <- unique(x1); r <- length(cats); n <- dim(model$model)[1]
    
    preds.vec <- names(attr(model$terms,"dataClasses"))[2:3]
    con.name <- preds.vec[preds.vec!=x.name] 
    con <- model$model[,names(model$model)==con.name]
    y <- model$model[,1]
  
  if(is.null(pch))  pch <- as.numeric(as.factor(x1))
  if(is.null(col))  col <- as.numeric(as.factor(x1))
  if(is.null(lty))  lty <- as.numeric(as.factor(x1))
  
  if(length(pch)==1) pch <- rep(pch, n)
  if(length(col)==1) col <- rep(col, n)
  if(length(lty)==1) lty <- rep(lty, n)
   
  mat <- data.frame(y = y, con = con, x = x1, pch, col, lty)
  o <- order(mat$x)
  mat <- mat[o,]
  names <- unique(mat$x)  
  
  leg.pch <- unique(mat$pch)
    if(length(leg.pch)==1) leg.pch <- rep(leg.pch, r) 
  leg.col <- unique(mat$col)
    if(length(leg.col)==1) leg.col <- rep(leg.col, r)
  leg.lty <- unique(mat$lty)
    if(length(leg.lty)==1) leg.lty <- rep(leg.lty, r)
  
      
      if(length(attr(model$terms,"term.labels"))==2){
          cof <- t(coef(model))
          slope <- cof[,colnames(cof)==con.name]
          subcof <- as.matrix(cof[,colnames(cof)!=con.name])
          int <- c(subcof[1],subcof[1]+subcof[2:r])
          out <- c(Intercept = int, Slope = slope)
          
          plot(con, y, pch = pch, col = col,...)
          for(i in 1:r){
          abline(int[i],slope,lty=leg.lty[i],col=leg.col[i])
          }
      }

      if(length(attr(model$terms,"term.labels"))==3){
      
          new.model <- lm(mat$y ~ -1 + mat$x + mat$x:mat$con)
          
          cof <- coef(new.model)
          
          int <- cof[1:r]
          slope <- cof[(r + 1) : (2 * r)]
          out <- data.frame(Intercept = int, Slope = slope)
          plot(con, y, pch = pch, col = col,...)
          for(i in 1:r){
          abline(int[i],slope[i],lty=leg.lty[i],col=leg.col[i])
          }
      }

  if(leg.loc!="n"){
  legend(leg.loc, legend = names, pch = leg.pch, col = leg.col, lty = leg.lty, cex = leg.cex, bty = leg.bty, bg = leg.bg, title=legend.title) 
  }
  print(model)
  invisible(out)
}

best.agreement <- function(class1, class2, test = FALSE, rperm = 100){
  
  permutations <- function(x, prefix = c()){
    if(length(x) == 1) # was zero before
      return(list(c(prefix, x)))
    out <- do.call(c, lapply(1:length(x), function(idx) 
      permutations(x[-idx], c(prefix, x[idx]))))
    if(length(prefix) > 0L)
      return(out)
    do.call(rbind, out) # Thanks to Benjamin Christoffersen
  }
  
  lvls1 <- as.factor(class1); nlvl1 <- nlevels(lvls1)
  lvls2 <- as.factor(class2); nlvl2 <- nlevels(lvls2)
  
  if(nlvl1 > nlvl2){
    lvls3 <- lvls2; lvls2 <- lvls1; lvls1 <- lvls3
    nlvl1 <- nlevels(lvls1); nlvl2 <- nlevels(lvls2)
  }
  
  outcomes <- permutations(1:nlvl2)
  
  
  #-------------------------------------------------------------#
  
  agree.f <-  function(x, in1 = lvls1, in2 = lvls2){
    out <- factor(in2, levels = x)
    ta <- table(out, in1)
    tt <- t(ta)
    max(sum(diag(ta))/sum(ta),sum(diag(tt))/sum(tt))
  }
  
  #-------------------------------------------------------------#
  
  agree <- apply(outcomes, 1, function(x) agree.f(x, lvls1, lvls2))
  
  #-------------------------------------------------------------#
  
  perm.test <- function(producer, user, maxa, rperm){
    outH0 <- replicate(rperm, sample(user))
    perm.agree <- apply(outH0, 2, function(x){
      ta <- table(producer, x)
      tt <- t(ta)
      max(sum(diag(ta))/sum(ta),sum(diag(tt))/sum(tt))
    })
    p.val <- (1 + length(which(perm.agree >= maxa)))/rperm
    p.val
  }
  
  #-------------------------------------------------------------#
  
  all.max <- which(agree == max(agree))
  n.max <- length(all.max)
  w <- all.max[1]
  max.agree <- agree[w]
  
  max.class.names2 = factor(lvls2, levels = unlist(outcomes[w,]))
  
  result <- list(n.possible.perms = nrow(outcomes), n.max.solutions = n.max,
                 max.agree = max.agree, max.tab = table(lvls1, max.class.names2),
                 max.class.names1 = lvls1, test = test,
                 max.class.names2 = max.class.names2)
  
  if (test) result$pval = perm.test(lvls1, lvls2, max.agree, rperm = rperm)
  else result$pval = "no.test"
  class(result) <- "max_agree"
  invisible(result)
}

print.max_agree <- function(x, digits = 4, ...){
  cat(paste("Max agreement = ", round(x$max.agree, digits), sep = ""), if(x$test)paste("\np-value = ", round(x$pval, digits)))
  invisible(x)
}


  

ES.May<-function(mat,digs=3){
	Nk<-apply(mat,1,sum)
        i.names<-paste("i=",1:nrow(mat),sep="")
##calculate Pki matrix        
	Pk<-apply(mat,2,function(x){x/Nk})
	rownames(Pk)<-rownames(mat)
        colnames(Pk)<-i.names
##calculate N matrix            
	N.mat<-matrix(nrow=nrow(mat),ncol=nrow(mat))	
	     for(i in 1:nrow(mat)){
	N.mat[,i]<-rep((1/i),nrow(mat))*(Pk[,i]*Nk)}
	rownames(N.mat)<-rownames(mat)
        colnames(N.mat)<-i.names
##calculate fk vector
	fk.mat<-matrix(nrow=nrow(mat),ncol=nrow(mat))	
	     for(i in 1:nrow(mat)){
	fk.mat[,i]<-rep((1/i),nrow(mat))*Pk[,i]}
        fk.vec<-apply(fk.mat,1,sum)
	names(fk.vec)<-rownames(mat)
	rownames(fk.mat)<-rownames(mat)
        colnames(fk.mat)<-i.names
 
##Nf
	Nk.vec<-fk.vec*Nk
        names(Nk.vec)<-rownames(mat)


	res<-list()
        res$E.S_coefficents<-cbind(N=sum(N.mat),F=sum(N.mat)/sum(Nk))
	res$Nk<-Nk
	res$Pki.matrix<-round(Pk,digs)
        res$N.matrix<-round(N.mat,digs)
        res$fk.matrix<-round(fk.mat, digs)
        res$fk.vector<-round(fk.vec,digs)
        res$Nk.vector<-round(Nk.vec,digs)
        
        res
}

bootstrap <- function (data, statistic, R = 1000, prob = NULL, matrix = FALSE) 
{
    
    theta.hat <- statistic(data)
    if (matrix == TRUE)  n <- nrow(data)
    if (matrix == FALSE) n <- nrow(as.matrix(data))
    
    
    
    if (matrix == TRUE) {
	boot.stat <- matrix(ncol = 1, nrow = R)
     samples <- matrix(ncol = n, nrow = R)
        for (i in 1:R) {
            samp <- data[sample(seq(1, n), replace = TRUE, prob = prob),]
            samples[i,] <- samp
            boot.stat[i] <- statistic(samples[i,])
        }
    }
    if (matrix == FALSE) {
            samp <- sample(data, R, replace = TRUE, prob = prob)
            samples <- matrix(nrow = R, ncol = n, data = samp, byrow = TRUE)
            boot.stat <- apply(samples, 1, statistic)
    }
    
    theta.hat.B <- mean(as.vector(boot.stat))
    bias <- theta.hat.B - theta.hat
    se <- sd(as.vector(boot.stat))
    res <- t(as.matrix(c(theta.hat, theta.hat.B, bias, se)))
    ends <- c("original", "theta.hat.B", "bias", "SE") 
    out <- list(dist = boot.stat, samples = samples , res = res, head = "Bootstrap summary :", ends = ends, data = data, statistic = statistic)
    class(out) <- "bootstrap"
    out
}


print.bootstrap <- function(x, digits = max(3, getOption("digits")), ...) 
{
    cat("\n")
    cat(x$head, "\n\n")
    rq <- structure(x$res, dimnames = list("",x$ends))
    print(rq, digits = digits, justify = "center")
    cat("\n")
    invisible(x)
}
 

Preston.dist<-function(counts, start=.2, cex.octave = 1, cex.legend = 1, cex.pt = 1,...){

	log2.counts<-logb(counts,2)
	hm<-hist(round(log2.counts,0),breaks=seq(0,round(max(log2.counts),0)),plot=FALSE)
	n<-hm$counts
	n.0<-max(hm$counts)
	octave.mode<-which(n==max(n))
	R<-(seq(0:(length(hm$counts)-1))-octave.mode)+.5
	no.spp<-nls(n~n.0*(exp(-1*(a*R)^2)),start=list(a=start))
	a<-summary(no.spp)$parameters[1]
	x<-seq(-1+-1*max(abs(c(min(R),max(R)))),1+max(abs(c(min(R),max(R)))))
	plot(x,c(rep(0,length(x)-1),n.0),type="n",xaxt="n",xlab=expression(paste(Log[2]," abundance (octaves)")),ylab="Number of species", ...)
	
	func<-function(x){n.0*exp(-1*(a*x)^2)}
	curve(func,from=min(x),to=max(x),add=TRUE,lwd=1)
	points(R,n,cex=cex.pt)
	staxlab(1,seq(min(R)-.5,max(R)+.5),hm$breaks,line.spacing=0, cex = cex.octave)
	abline(v=min(R)-0.5,lty=2,col=1)
	legend("topright",lty=2,col=1,legend=c("Veil line"),bty="n", cex = cex.legend)
	eq<-paste("n = ",bquote(.(n.0)),"*exp(",bquote(.(-1*round(a,3))),"*R)^2")
	Est.no.of.spp<-(n.0*sqrt(pi))/abs(a)
	res<-list(Equation=eq,Est.no.of.spp=Est.no.of.spp,Pct.sampling.completed=length(counts)/Est.no.of.spp*100)
	res
	}

qq.Plot <- function (y, x = NULL, col = NULL, pch = NULL, main = "", R = 5000, 
                     fit.lty = 1, env.lty = 2, conf = 0.95, type = "point", ylim = NULL, 
                     xlim = NULL, xlab = NULL, ylab = NULL, plot.CI = FALSE, standy = TRUE, ...) 
{
  boot <- NA
  rm(boot)
  envelope <- NA
  rm(envelope)
  qqline1 <- function(y, datax = FALSE, distribution = qnorm, 
                      probs = c(0.25, 0.75), qtype = 7, ...) {
    stopifnot(length(probs) == 2, is.function(distribution))
    y <- quantile(y, probs, names = FALSE, type = qtype, 
                  na.rm = TRUE)
    x <- distribution(probs)
    if (datax) {
      slope <- diff(x)/diff(y)
      int <- x[1L] - slope * y[1L]
    }
    else {
      slope <- diff(y)/diff(x)
      int <- y[1L] - slope * x[1L]
    }
    res <- list(int = int, slope = slope)
    res
  }
  
  boot.envel <- function(y) {
    z <- (y - mean(y))/sd(y)
    gen <- function(dat, mle) rnorm(length(dat))
    qqboot <- boot::boot(z, sort, R = 999, sim = "parametric", 
                         ran.gen = gen)
    qq <- qqnorm(z, plot.it = FALSE)
    qq <- lapply(qq, sort)
    env <- boot::envelope(qqboot, level = conf)
    res <- list()
    res$x <- qq$x
    res$y <- qq$y
    if (type == "overall") {
      res$ub <- env$overall[1, ]
      res$lb <- env$overall[2, ]
    }
    if (type == "point") {
      res$ub <- env$point[1, ]
      res$lb <- env$point[2, ]
    }
    res
  }
  if (is.null(x)) {
    if (plot.CI == TRUE) {
      br <- boot.envel(y)
      l <- lm(br$y ~ br$x)
      if (!is.null(ylim)) 
        ylim <- c(min(br$lb), max(br$ub))
      plot(br$x, br$y, ylim = , ylab = ylab, col = ifelse(is.null(col), 
                                                          1, col), pch = ifelse(is.null(pch), 1, pch), 
           xlab = ifelse(is.null(xlab), "Normal quantiles", 
                         xlab), ylab = ifelse(is.null(ylab), "Studentized observed quantiles", 
                                              ylab), main = main, ...)
      abline(coef(l)[1], coef(l)[2], lty = fit.lty, col = ifelse(is.null(col), 
                                                                 1, col))
      lines(br$x, br$lb, col = ifelse(is.null(col), 1, 
                                      col), lty = env.lty)
      lines(br$x, br$ub, col = ifelse(is.null(col), 1, 
                                      col), lty = env.lty)
    }
    else {
      qqnorm(y, col = ifelse(is.null(col), 1, col), pch = ifelse(is.null(pch), 
                                                                 1, pch), xlab = ifelse(is.null(xlab), "Theoretical quantiles", 
                                                                                        xlab), ylab = ifelse(is.null(ylab), "Sample quantiles", 
                                                                                                             ylab), main = main, ...)
      qqline(y, col = ifelse(is.null(col), 1, col), lty = fit.lty)
    }
  }
  else {
    x <- factor(x)
    nlev <- nlevels(x)
    levels <- levels(x)
    if (is.null(col)) 
      col <- 1:nlev
    else {
      if (!is.null(col) & length(col) == 1) 
        col <- rep(col, nlev)
      else col <- col
    }
    if (is.null(pch)) 
      pch <- 1:nlev
    else {
      if (!is.null(pch) & length(pch) == 1) 
        pch <- rep(pch, nlev)
      else pch <- pch
    }
    if (plot.CI == TRUE) {
      y1 <- y[x == levels[1]]
      br <- boot.envel(y1)
      l <- lm(br$y ~ br$x)
      if (is.null(ylim)) 
        ylim <- c(min(br$lb), max(br$ub))
      plot(br$x, br$y, ylim = ylim, xlab = ifelse(is.null(xlab), 
                                                  "Normal quantiles", xlab), ylab = ifelse(is.null(ylab), 
                                                                                           "Studentized observed quantiles"), col = col[1], 
           pch = pch[1], main = "", ...)
      abline(coef(l)[1], coef(l)[2], lty = fit.lty, col = col[1])
      lines(br$x, br$lb, col = col[1], lty = env.lty)
      lines(br$x, br$ub, col = col[1], lty = env.lty)
      for (i in 2:nlev) {
        y.temp <- y[x == levels[i]]
        br <- boot.envel(y.temp)
        l <- lm(br$y ~ br$x)
        abline(coef(l)[1], coef(l)[2], lty = fit.lty, 
               col = col[i])
        points(br$x, br$y, col = col[i], pch = pch[i])
        lines(br$x, br$lb, col = col[i], lty = env.lty)
        lines(br$x, br$ub, col = col[i], lty = env.lty)
      }
    }
    else {
      n <- tapply(y,x,length)
      nmax <- max(n)
      ynew <- matrix(ncol = nlev, nrow = nmax)
      xnew <- matrix(ncol = nlev, nrow = nmax)
      for (i in 1:nlev) {
        z <- y[x == levels[i]]
        if(standy) z <- (z - mean(z))/sd(z)
        a <- qqnorm(z, plot.it = FALSE)
        ynew[, i][1:n[i]] <- a$y
        if(n[i] < nmax) ynew[, i][(n[i]+1):nmax] <- NA
        xnew[, i][1:n[i]] <- a$x
        if(n[i] < nmax) xnew[, i][(n[i]+1):nmax] <- NA
      }
      

      if (is.null(ylim)) 
        ylim <- c(min(ynew, na.rm = TRUE), max(ynew, na.rm = TRUE))
      if (is.null(xlim)) 
        xlim <- c(min(xnew, na.rm = TRUE), max(xnew, na.rm = TRUE))
      
      plot(xnew[, 1], ynew[, 1], ylim = ylim, xlim = xlim, 
           xlab = ifelse(is.null(xlab), "Theoretical quantiles", 
                         xlab), ylab = ifelse(is.null(ylab), "Sample quantiles", 
                                              ylab), col = col[1], pch = pch[1], main = main, 
           ...)
      qqline(na.omit(ynew[, 1]), col = col[1], lty = fit.lty)
      for (i in 2:nlev) {
        suppressWarnings(qqline(na.omit(ynew[, i]), col = col[i], lty = fit.lty))
        points(xnew[, i], ynew[, i], col = col[i], pch = pch[i])
       # a <- qqline1(y[x == levels[i]])
       # abline(a$int, a$slope, col = col[i], lty = fit.lty)
      }
    }
    legend("topleft", pch = pch, col = col, legend = levels, 
           bg = "white")
  }
}

selftest.prob.tck <- function(){
options(guiToolkit="tcltk")
w <- gwindow(title = "Probability")
size(w) <- c(600, 700)
g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)



#------------- Question 1 -----------#

gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) = 0.2, P(B) = 0.4, and P(A \u2229 B) = 0.08, then A and B are disjoint.", container = gp1.1, anchor=c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans1 <- c("True",
          "False")


f1 <- function(h,....){
  if(tail(svalue(r1),1) == ans1[1]){
    gmessage(msg = "Incorrect. The probability of the intersection of A and B does not = 0.", icon = "error")
  }
  if(tail(svalue(r1),1)== ans1[2]){gmessage(msg="Correct")
  }
  svalue(r1) <- character(0)
}

r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)

#------------- Question 2 -----------#


gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) = 0.2, P(B) = 0.4, and P(A \u2229 B) = 0.08, then A and B are independent.", container = gp2.1, anchor=c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans2 <- c("True",
          "False")


f2 <- function(h,....){
  if(tail(svalue(r2),1) == ans2[1]){
    gmessage(msg="Correct. The probability of the intersection of A and B = P(A)P(B).")
  }
  if(tail(svalue(r2),1)== ans2[2]){ gmessage(msg="Incorrect.  A and B are independent because the probability of the union of A and B  = P(A)P(B).", icon = "error")
  }
  svalue(r2) <- character(0)
}

r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)

#------------- Question 3 -----------#

gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) = 0.2, P(B) = 0.4, and P(A|B) = 0.2, then A and B are independent.", container = gp3.1, anchor=c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans3 <- c("True",
          "False")

f3 <- function(h,....){
  if(tail(svalue(r3),1) == ans3[1]){
    gmessage(msg="Correct. P(A|B) = P(A).")
  }
  if(tail(svalue(r3),1)== ans3[2]){
    gmessage(msg="Incorrect.  A and B are independent because P(A|B) = P(A)", icon = "error")
  }
  svalue(r3) <- character(0)
}

r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)


#------------- Question 4 -----------#

gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) = 0.3, P(B) = 0.4, and P(A \u222A B) = 0.5, then P(A \u2229 B) = ", container = gp4.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans4 <- c("(a)    0.0",
          "(b)    0.1",
          "(c)    0.2",
          "(d)    1.0")


f4 <- function(h,....){
  if(tail(svalue(r4),1) == ans4[1]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r4),1)== ans4[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r4),1)== ans4[3]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r4),1)== ans4[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r4) <- character(0)
}

r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)



#------------- Question 5 -----------#

gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A|B) = 0.8, P(B|A) = 0.4, and P(A) = 0.5, then P(A \u2229 B) =", container = gp5.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans5 <- c("(a)  0.1",
          "(b)  0.2",
          "(c)  0.25",
          "(d)  0.9")


f5 <- function(h,....){
  if(tail(svalue(r5),1) == ans5[1]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r5),1)== ans5[2]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r5),1)== ans5[3]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r5),1)== ans5[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r5) <- character(0)
}

r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)



#------------- Question 6 -----------#

gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A|B) = 0.8, P(B|A) = 0.4, and P(A) = 0.5, then P(B) =", container = gp6.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans6 <- c("(a)  0.1",
          "(b)  0.2",
          "(c)  0.25",
          "(d)  0.9")


f6 <- function(h,....){
  if(tail(svalue(r6),1) == ans6[1]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r6),1)== ans6[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r6),1)== ans6[3]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r6),1)== ans6[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r6) <- character(0)
}

r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)


#------------- Question 7 -----------#

gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) = 0.4, then P(A') =", container = gp7.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans7 <- c("(a)    0.6",
          "(b)    0.8",
          "(c)    -0.8",
          "(d)    0.2")


f7 <- function(h,....){
  if(tail(svalue(r7),1) == ans7[1]){
    gmessage(msg="Correct", icon = "error")
  }
  if(tail(svalue(r7),1)== ans7[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r7),1)== ans7[3]){
    gmessage(msg="Incorrect.  Probabilities must be (0, 1).", icon = "error")
  }
  if(tail(svalue(r7),1)== ans7[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r7) <- character(0)
}

r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)



#------------- Question 8 -----------#

gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("If P(A) > 0.5, then", container = gp8.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans8 <- c("(a)    -1 \u2264 \u2126(A) < 0",
          "(b)    1 < \u2126(A) < \u221E",
          "(c)    0 > \u2126(A) > 1",
          "(d)    0 \u2264 \u2126(A) < \u221E")


f8 <- function(h,....){
  if(tail(svalue(r8),1) == ans8[1]){
    gmessage(msg="Incorrect.  Odds must be greater than 0.", icon = "error")
  }
  if(tail(svalue(r8),1)== ans8[2]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r8),1)== ans8[3]){
    gmessage(msg="Incorrect.  These are discontinuous intervals.", icon = "error")
  }
  if(tail(svalue(r8),1)== ans8[4]){
    gmessage(msg="Incorrect.  This encompasses the full support for odds, not the odds of A given P(A) > 0.5.", icon = "error")
  }
  svalue(r8) <- character(0)
}

r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)


#------------- Question 9 -----------#

gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("You would use the Bonferroni inequality to:", container = gp9.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans9 <- c("(a)  Establish the upper bound to the probability of a union of events.",
          "(b)  Establish the lower bound to the probability of a union of events.",
          "(c)  Establish the lower bound to the probability of an intersection of events.",
          "(d)  Establish the average probability of events.")


f9 <- function(h,....){
  if(tail(svalue(r9),1) == ans9[1]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r9),1)== ans9[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r9),1)== ans9[3]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r9),1)== ans9[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r9) <- character(0)
}

r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)


#------------- Question 10 -----------#

gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("You would use Boole's inequality to:", container = gp10.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans10 <- c("(a)  Establish the upper bound to the probability of a union of events.",
          "(b)  Establish the lower bound to the probability of a union of events.",
          "(c)  Establish the lower bound to the probability of an intersection of events.",
          "(d)  Establish the average probability of events.")


f10 <- function(h,....){
  if(tail(svalue(r10),1) == ans10[1]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r10),1)== ans10[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r10),1)== ans10[3]){
    gmessage(msg="Inorrect", icon = "error")
  }
  if(tail(svalue(r10),1)== ans10[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r10) <- character(0)
}

r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)


#------------- Question  11 -----------#

gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("Which equation defines Bayes rule?", container = gp11.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans11 <- c("(a)     P(data|\u03B8) = P(\u03B8|data)P(\u03B8)/P(data).",
           "(b)     P(\u03B8|data) = P(data|\u03B8)P(\u03B8)/P(data).",
           "(c)     P(\u03B8) = P(data|\u03B8)P(\u03B8|data)/P(data).",
           "(d)     P(data) = P(data|\u03B8)P(\u03B8|data)/P(\u03B8).")


f11 <- function(h,....){
  if(tail(svalue(r11),1) == ans11[1]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r11),1)== ans11[2]){
    gmessage(msg="Correct")
  }
  if(tail(svalue(r11),1)== ans11[3]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r11),1)== ans11[4]){
    gmessage(msg="Incorrect", icon = "error")
  }
  svalue(r11) <- character(0)
}

r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)


#------------- Question  12 -----------#

gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
font(q) <- list(weight = "bold")
qq <- glabel("In Bayes rule, P(\u03B8) denotes the", container = gp12.1, anchor = c(-1,1))
font(qq) <- list(family = "cambria", size = 11)

ans12 <- c("(a)     posterior",
           "(b)     total probability",
           "(c)     likelihood",
           "(d)     priors")


f12 <- function(h,....){
  if(tail(svalue(r12),1) == ans12[1]){
    gmessage(msg="Incorrect",  icon = "error")
  }
  if(tail(svalue(r12),1)== ans12[2]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r12),1)== ans12[3]){
    gmessage(msg="Incorrect", icon = "error")
  }
  if(tail(svalue(r12),1)== ans12[4]){
    gmessage(msg="Correct")
  }
  svalue(r12) <- character(0)
}

r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)



}

samp.dist.method.tck<-function(){

tclRequire("BWidget")
local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }

tclServiceMode(FALSE)
dialog.ci <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Sampling distributions")
        Par1<- tclVar("snapshot")
        Stats<-tclVar("mean") 
        done <- tclVar(0)
    
reset <- function()
        {
        tclvalue(Par)<-"sanpshot"
        tclvalue(Stats)<-"mean"
        } 

distrib<-function(Par,Stats){
        if(Par=="animation") samp.dist.tck(Stats)
        if(Par=="snapshot"){
            if(Stats == "mean"|Stats == "median"|Stats == "trimmed mean"| Stats == "Winsorized mean"| Stats == "sd"| Stats == "var"| Stats == "Huber estimator" | Stats == "H-L estimator" | Stats == "IQR" | Stats == "MAD") samp.dist.snap.tck1(Stats)
            if(Stats != "mean"  & Stats != "median" & Stats != "trimmed mean" & Stats != "Winsorized mean" & Stats != "sd" & Stats != "var" & Stats != "Huber estimator" & Stats != "H-L estimator" & Stats != "IQR" & Stats != "MAD") samp.dist.snap.tck2(Stats)
        }
        }
  
build <- function()
        {
            Par <-tclvalue(Par1)
            Stats <-tclvalue(Stats)
            distrib(Par, Stats)
        }
               
        
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",
                               command=function()tclvalue(done)<-0)

        
        alt.rbuts <- tkframe(tt)
        tkpack(tklabel(alt.rbuts, text="Depiction method"))
        for ( i in c("animation", "snapshot")){
            tmp <- tkradiobutton(alt.rbuts, text=i, variable=Par1, value=i)
            tkpack(tmp,anchor="w")
        }

        tkgrid(tklabel(tt, text="Statistic"),columnspan=2)
        stats<- c("custom", "mean","median", "trimmed mean", "Winsorized mean", "Huber estimator", "H-L estimator", "sd", "var", "IQR", "MAD","(n-1)S^2/sigma^2", "F*", "t* (1 sample)", "t* (2 sample)", "Pearson correlation", "covariance")
            comboBox <- tkwidget(tt,"ComboBox", editable=FALSE, values=stats, textvariable = Stats, width = 20)
        tkgrid(comboBox,columnspan=2)
        tkgrid(tklabel(tt,text=""),columnspan=2)
        tkgrid(alt.rbuts,columnspan=2)
        tkgrid(tklabel(tt,text=""),columnspan=2)
        tkgrid(submit.but,reset.but)
            
tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)
tkwait.variable(done)
if(tclvalue(done)=="2") stop("aborted")
tkdestroy(tt) 
cmd <- build()
eval.parent(cmd)
tclServiceMode(TRUE)
    }                            
Par1 <-tclVar("snapshot")
Stats <- tclVar("mean")
dialog.ci()

})
}

 



samp.dist.tck<-function(statc = "mean"){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Sampling distributions")
        biv.parent.entry <- tkentry(tt, textvariable=Biv.parent)
        parent.entry1 <- tkentry(tt, textvariable=Parent1)
        parent.entry2 <- tkentry(tt, textvariable=Parent2)
        s.size1.entry<-tkentry(tt, textvariable=S.size1)
        s.size2.entry<-tkentry(tt, textvariable=S.size2)
        stat.entry1<-tkentry(tt, textvariable=Stat1)
        stat.entry2<-tkentry(tt, textvariable=Stat2)
        stat.entry3<-tkentry(tt, textvariable=Stat3)
        stat.entry4<-tkentry(tt, textvariable=Stat4)
        func.entry<-tkentry(tt, textvariable=Func)
        R.entry<-tkentry(tt, textvariable=Rep)
        x.entry<-tkentry(tt, textvariable=Xlab)
        int.entry<-tkentry(tt, textvariable=Int)
        col.entry<-tkentry(tt, textvariable=Col)
        
           
    done <- tclVar(0)
    show.SE<-tclVar(1)
        
        reset <- function(){
            tclvalue(Biv.parent)<-"NULL"
            tclvalue(Parent1)<-"rexp(100)"
            tclvalue(Parent2)<-"NULL"
            tclvalue(S.size1)<-""
            tclvalue(S.size2)<-"NULL"
            tclvalue(Stat1)<-"mean"
            tclvalue(Stat2)<-"NULL"
            tclvalue(Stat3)<-"NULL"
            tclvalue(Stat4)<-"NULL"
            tclvalue(Func)<-"NULL"
            tclvalue(Rep)<-""
            tclvalue(Xlab)<-"expression(Mean)"
            tclvalue(Int)<-"0.1"
            tclvalue(show.SE)<-"0"
            tclvalue(Col)<-"rainbow"
        }

        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)

        build <- function()
        {
            biv.parent <- parse(text=tclvalue(Biv.parent))[[1]]
            parent <-parse(text=tclvalue(Parent1))[[1]]
            parent2 <-parse(text=tclvalue(Parent2))[[1]]
            s.size <-tclvalue(S.size1)
            s.size2 <-parse(text=tclvalue(S.size2))[[1]]
            stat <-parse(text=tclvalue(Stat1))[[1]]
            stat2 <-parse(text=tclvalue(Stat2))[[1]]
            stat3 <-parse(text=tclvalue(Stat3))[[1]]
            stat4 <-parse(text=tclvalue(Stat4))[[1]]
            R <-tclvalue(Rep)
            x<-parse(text=tclvalue(Xlab))[[1]]
            func<-parse(text=tclvalue(Func))[[1]]
            se <- as.logical(tclObj(show.SE))
            interval<-tclvalue(Int)
            col.anim <-tclvalue(Col)
            substitute(samp.dist(biv.parent=biv.parent,parent=parent,parent2=parent2,s.size=as.numeric(s.size),s.size2=s.size2,stat=stat,stat2=stat2,stat3=stat3,stat4=stat4, func=func,R=as.numeric(R),xlab=x,interval=as.numeric(interval),show.SE=se,col.anim=col.anim))
        }
       
        se.cbut <- tkcheckbutton(tt, text="Show SE", variable=show.SE)
        tkgrid(tklabel(tt,text="Sampling distribution animations"),columnspan=4)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Bivariate parent"), biv.parent.entry)
        tkgrid(tklabel(tt,text="Parent 1",font=c("Helvetica","9","bold")), parent.entry1,tklabel(tt,text="Parent 2"), parent.entry2)
        tkgrid(tklabel(tt,text="Sample size 1",font=c("Helvetica","9","bold")), s.size1.entry,tklabel(tt,text="Sample size 2"), s.size2.entry)
        tkgrid(tklabel(tt,text="Stat",font=c("Helvetica","9","bold")), stat.entry1,tklabel(tt,text="Stat 2"), stat.entry2)
        tkgrid(tklabel(tt,text="Stat 3"), stat.entry3, tklabel(tt,text="Stat 4"), stat.entry4)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Iterations"), R.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Function"), func.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Anim. color"), col.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="Anim. interval"), int.entry)
        tkgrid(tklabel(tt,text=""),tklabel(tt,text="X-axis label"), x.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),se.cbut,sticky="w")
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text=""),submit.but, reset.but)
        tkgrid(tklabel(tt,text=""))
       
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    tclServiceMode(TRUE)
    }                            
if(statc == "custom"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("NULL")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("NULL")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("NULL")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("NULL")
      Ne<-tclVar("NULL")
      Xlab<- tclVar("NULL")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}
if(statc == "mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(bar(x))")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}
if(statc == "median"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("median")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(Median)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}
if(statc == "trimmed mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      tr.mean <- function(x)mean(x,trim = 0.2)
      Stat1<-tclVar("tr.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(Trimmed.mean)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}      
if(statc == "Winsorized mean"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      win.mean <- function(x)mean(win(x))
      Stat1<-tclVar("win.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(Winsorized.mean)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}      
if(statc == "Huber estimator"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("huber.mu")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(Huber.estimator)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}      
if(statc == "H-L estimator"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rexp(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("HL.mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(H-L.estimator)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}  
if(statc == "sd"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("sd")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(S)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}   
if(statc == "var"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("var")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(S^2)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}   
if(statc == "MAD"){

      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("mad")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(MAD))")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}           
if(statc == "IQR"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("10")
      S.size2<-tclVar("10")
      Stat1<-tclVar("IQR")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("NULL")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(IQR)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}    
if(statc == "(n-1)S^2/sigma^2"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("8")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("var")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      xlabel <- expression(paste("(n - 1)", s^2, "/", sigma^2))
      Func<-tclVar("function(s.dist, s.dist2, s.size, s.size2, sigma.sq = 1)((s.size - 1) * s.dist)/sigma.sq")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("xlabel")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}    
if(statc == "F*"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("expression(rnorm(s.size2))")
      S.size1<-tclVar("10")
      S.size2<-tclVar("8")
      Stat1<-tclVar("var")
      Stat2<-tclVar("var")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("function(s.dist,s.dist2,s.size, s.size2) s.dist/s.dist2")
      Rep<-tclVar("2000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(F.star)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}  
if(statc == "t* (1 sample)"){
      Biv.parent<-tclVar("NULL")
      Parent1<-tclVar("expression(rnorm(s.size))")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("8")
      S.size2<-tclVar("NULL")
      Stat1<-tclVar("mean")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("var")
      Stat4<-tclVar("NULL")
      Func<-tclVar("function(s.dist, s.dist3, s.size, s.size2)s.dist/(sqrt(s.dist3/s.size))")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(t.star)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}    
if(statc == "t* (2 sample)"){      
      Biv.parent<-tclVar("NULL")
      Parent1 <- tclVar("expression(rnorm(s.size))")
      Parent2 <- tclVar("expression(rnorm(s.size))")
      SS <- tclVar("10")
      SS2<-tclVar("12")
      Stat1<-tclVar("mean")
      Stat2<-tclVar("mean")
      Stat3<-tclVar("var")
      Stat4<-tclVar("var")
      Func<-tclVar("function(s.dist1, s.dist2, s.dist3, s.dist4, s.size = 6, s.size2 = s.size2)({MSE<-(((s.size - 1) * s.dist3) + ((s.size2 - 1) * s.dist4))/((s.size + s.size2) - 2);(s.dist1 - s.dist2)/(sqrt(MSE) * sqrt((1/s.size) + (1/s.size2)))})")
      Rep<-tclVar("10000")
      Xlab<- tclVar("expression(t.star)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}    
if(statc == "Pearson correlation"){
  
      Biv.parent<-tclVar("expression(rmvnorm(s.size, c(0,0), sigma = matrix(nrow=2,ncol=2, data =c(1,0,0,1))))")
      Parent1<-tclVar("NULL")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("8")
      S.size2<-tclVar("8")
      Stat1<-tclVar("NULL")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("cor")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(r)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")} 
if(statc == "covariance"){
      
      Biv.parent<-tclVar("expression(rmvnorm(s.size, c(0,0), sigma = matrix(nrow=2,ncol=2, data =c(1,0,0,1))))")
      Parent1<-tclVar("NULL")
      Parent2<-tclVar("NULL")
      S.size1<-tclVar("8")
      S.size2<-tclVar("8")
      Stat1<-tclVar("NULL")
      Stat2<-tclVar("NULL")
      Stat3<-tclVar("NULL")
      Stat4<-tclVar("NULL")
      Func<-tclVar("cor")
      Rep<-tclVar("1000")
      Ne<-tclVar("seq(1,30)")
      Xlab<- tclVar("expression(Covariance)")
      Col<- tclVar("gray")
      Int<-tclVar("0.01")}      
dialog.sd()
})
}

Bayes.disc.tck<-function (){

local({
have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
if (have_ttk) {
    tkbutton <- ttkbutton
    tkcheckbutton <- ttkcheckbutton
    tkentry <- ttkentry
    tkframe <- ttkframe
    tklabel <- ttklabel
    tkradiobutton <- ttkradiobutton
}
tclServiceMode(FALSE)
dialog.sd <- function() {
  tt <- tktoplevel()
  tkwm.title(tt,"Bayesian analysis -- discrete data and priors")
  prior.entry <- tkentry(tt, textvariable=Prior, width =15)
  data.entry <- tkentry(tt, textvariable=Data1, width =15) 
  data.name.entry <- tkentry(tt, textvariable=Data.name, width = 15) 
  c.data.entry <- tkentry(tt, textvariable=C.data, width = 15) 
  
  done <- tclVar(0)
  show.plot<-tclVar(1)

reset<-function(){
  tclvalue(Prior) <- ""
  tclvalue(Data1) <- ""
  tclvalue(Data.name) <- "Data"
  tclvalue(C.data) <- "seq(1,length(Prior))"
  tclvalue(show.plot)<-"1"
}

reset.but <- tkbutton(tt, text = "Reset", command = reset)
submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)


build <- function() {
  Prior <-parse(text=tclvalue(Prior))[[1]]
  Data <- parse(text=tclvalue(Data1))[[1]]
  data.name <- tclvalue(Data.name)
  show.plot <- as.logical(tclObj(show.plot))
  c.data <-parse(text=tclvalue(C.data))[[1]]

substitute(Bayes.disc(Likelihood=Data,Prior=Prior, 
data.name=data.name,c.data=c.data,plot=show.plot))
}

nc.cbut <- tkcheckbutton(tt, text="Show plot", variable=show.plot)
  tkgrid(tklabel(tt, text = " Bayesian analysis of discrete data "), 
      columnspan = 2)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(tklabel(tt, text = 'Data|\u03b8 '), data.entry)
  tkgrid(tklabel(tt, text = 'Priors; \u03b8 '), prior.entry)
  tkgrid(tklabel(tt, text = "Data name"), data.name.entry)
  tkgrid(tklabel(tt, text = "Prior names"), c.data.entry)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(nc.cbut)
  tkgrid(submit.but, reset.but, sticky ="e")
  
  tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
  tkwait.variable(done)
  if (tclvalue(done) == "2") 
      stop("aborted")
  tkdestroy(tt)
  cmd <- build()
  eval.parent(cmd)
invisible(tclServiceMode(TRUE))
}
Prior <- tclVar("c(1/3, 1/3, 1/3)")
Data1<-tclVar("c(1, 1/2, 0)")
Data.name <- tclVar("data")
C.data <- tclVar("c(1, 2, 3)")
dialog.sd()
})
}

selftest.nonparametric6.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Nonparametric alternatives to t-tests")
  size(w) <- c(700, 500)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  
  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The Wilcoxon rank sum test is a nonparametric analogue of the...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
    ans1 <- c("(a)     paired t-test.",
            "(b)     Welch's t-test.",
            "(c)     Pooled variance t-test.",
            "(d)     One sample t-test.")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The Wilcoxon sign rank test is a nonparamteric analogue of the...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans2 <- c("(a)     paired t-test.",
            "(b)     Welch's t-test.",
            "(c)     Pooled variance t-test.",
            "(d)     One sample t-test.")
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Nonparametric tests tend to...",
         container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans3 <- c("(a)  have more power than their parametric analogues.",
            "(b)  have less power than their parametric analogues.",
            "(c)  have the same power as their parametric analogues.",
            "(d)  relative power of parametric and nonparametric tests cannot be determined")
  

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Rank-based permutation tests tend not to be...",
         container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans4 <- c("(a)  robust to outliers.",
            "(b)  robust to non-normality.",
            "(c)  robust to heteroscedasticity.",
            "(d)  robust to outliers and non-normality.")
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) Ties in data simplify the implementation of rank-based permutation tests.",
         container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans5 <- c("T",
            "F")
  
  
  f5 <-  function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Correct")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  
}

samp.dist.mech.tck <-function(){

local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.ci <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Sampling distribution basics")
        ns.entry <- tkentry(tt, textvariable=ns, width =6) 
        int.entry <- tkentry(tt, textvariable=int, width =6) 
        done <- tclVar(0)
       

   build <- function()
        {
            ns  <- tclvalue(ns)
            int  <- tclvalue(int)
                        
           substitute(samp.dist.mech(as.numeric(ns),as.numeric(int)))
        }

#desc <- tklabel(tt,text="A population of mountain goats are \r
#randomly sampled with sample size 10.\rThe goats are weighed, 
#and a mean is computed from the 10 weights. \r 
#This is repeated a user-specified number of times \r 
#to create a distribution of mean weights.")  
desc1 <- tklabel(tt, text = "Goat weight ~ N(90.5, 225)", font=c("Helvetica","12","normal"))
desc2 <- tklabel(tt, text = "", font=c("Helvetica","1","normal"))
desc3 <- tklabel(tt, text = "n = 10", font=c("Helvetica","12","normal"))

g1 <- read.pnm(system.file("pictures/goat3.pgm", package="asbio"))
f <- function(){
old.par <- par(no.readonly = TRUE)
par(mar = c(0,2,0,2))
plot(g1)
old.par <- par(no.readonly = TRUE)
}

submit.but <- tkbutton(tt, text="Submit", command=function()tclvalue(done)<-0)


#img <-tkrplot(tt, f, hscale=.8, vscale=.8)
tkpack(desc1, desc2, desc3)
tkpack(tklabel(tt,text="Iterations"), ns.entry)
tkpack(tklabel(tt,text="Animation interval"), int.entry)
tkpack(tklabel(tt,text="",font=c("Helvetica","2","normal")))
tkpack(submit.but)
tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")
      
        tkdestroy(tt) 
        
cmd <- build()
eval.parent(cmd)
invisible(tclServiceMode(TRUE))
}
ns<-tclVar("100")
int<-tclVar(".03")
dialog.ci()
})
}

selftest.se.tck1 <- function (){ 
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Experimental and Sampling design")
  size(w) <- c(700, 950)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Random assignment of experimental units to treatments will help provide...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)     absolute proof regarding the effect of the treatment.",
            "(b)     causal evidence regarding the effect of the treatment.",
            "(c)     inference to the sampled population.",
            "(d)     inference to the sample.")
  
  
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect. Absolute proof of causality is not possible with empirical data.", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect. The method of sampling (not the method of treatment assignment) will determine inference to the population.", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect. The method of sampling (not the method of treatment assignment) will determine inference to the population.", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Random sampling from the population will help provide...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  

    ans2 <- c("(a)     absolute proof regarding the effect of the treatment.",
            "(b)     causal evidence regarding the effect of the treatment.",
            "(c)     inference to the sampled population.",
            "(d)     inference to the sample.")
  

  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect. Absolute proof of causality is not possible with empirical data.", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect. The experimental design (not the method of sampling) will determine causal inference.", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  
  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A lurking variable...", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)     is an unmeasured explanatory variable that may be important in explaining the response variable(s).",
            "(b)     will often result in false claims about the causality of X on Y.",
            "(c)     is generally not an explanatory variable central to a research hypothesis.",
            "(d)     All of the above.")
  

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Correct")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  
  #------------- Question 4 -----------#
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Confounded variables...", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("(a)     are explanatory variables that are indistinguishable with respect to their effect on Y.",
            "(b)     obscure straightforward interpretations about the effect of X on Y.",
            "(c)     will result in multicollinearity problems in linear models.",
            "(d)     All of the above.")
  
  
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Correct")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
  
  
  #------------- Question 5 -----------#
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a multivariate analysis we have...", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans5 <- c("(a)     multiple response variables and one or more explanatory variables.",
            "(b)     a single response variable and more than one explanatory variable.",
            "(c)     multiple observations from both Y and X variables.",
            "(d)     None of the above.")
  

  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  
  #------------- Question 6 -----------#
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("If a population size is definitively finite, then the conventional formula for the standard error of the \nmean will be...", 
         container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans6 <- c("(a)     unbiased.",
            "(b)     biased high.",
            "(c)     biased low.",
            "(d)     biased high or low, depending on N.")
  
 f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r6) <- character(0)
 }
 
 r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
 
  
  
  #------------- Question 7 -----------#
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("If a population size is definitively finite, with size N, then the conventional formula for the sample \nstandard error of the mean should be multiplied by the square root of...", 
               container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans7 <- c("(a)     1-(n/N).",
            "(b)     n/(N-1).",
            "(c)     n/N.",
            "(d)     1-(N/n).")
  
  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r7) <- character(0)
  }
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)
  
  
  
  #------------- Question 8 -----------#
  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Pseudoreplication...", container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans8 <- c("(a)     indicates a lack of replication in sample entities assumed to be samples.",
            "(b)     can result in a situation in which treatments are not replicated (although samples may be).",
            "(c)     results in testing for treatment effects with an error term inappropriate for the hypothesis \n         being considered.",
            "(d)     All of the above.")

  f8 <- function(h,....){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Partially correct",, icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Correct")
    }
    svalue(r8) <- character(0)
  }
  
  
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)
  
  
  
  
  #------------- Question 9 -----------#
  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE, anchor = c(1,1))
  font(q) <- list(weight = "bold")
  qq <- glabel("In an experiment to consider the effect of nutrient additions to plant growth we have two groups and \n40 plants. In group A we randomly assign 20 plants to a supplemental nutrient treatment.  Group B \nplants receive no additional nutrients, but are otherwise handled in exactly the same way as group A.  \nGroup B can be called...", 
               container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  ans9 <- c("(a)     a pseudocontrol.",
            "(b)     a non-control.",
            "(c)     a negative control.",
            "(d)     a positive control.")
  
  f9 <- function(h,....){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r9) <- character(0)
  }
  
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)
  
  
  
  #------------- Question 10 -----------#
  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Controls are used to...", container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans10 <- c("(a)     quantify the effect of a treatment by accounting for background conditions.",
             "(b)     control for lurking variables.",
             "(c)     strengthen causal evidence.",
             "(d)     all of the above.")
  
  f10 <- function(h,....){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Correct")
    }
    svalue(r10) <- character(0)
  }
  
  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)
  
  
  #------------- Question 11 -----------#
  gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An analytical approach appropriate when X and Y variables are both quantitative is...", container = gp11.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans11 <- c("(a)     Conventional regression.",
             "(b)     ANOVA-type analysis.",
             "(c)     a GLM regression approach.",
             "(d)     tabular analysis.",
             "(e)     ANCOVA-type analysis.")
  
  f11 <- function(h,....){
    if(tail(svalue(r11),1) == ans11[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r11),1)== ans11[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r11) <- character(0)
  }
  
  r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)
  
  
  #------------- Question 12 -----------#
  gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An analytical approach appropriate when X and Y variables are both categorical is...", container = gp12.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans12 <- c("(a)     Conventional regression.",
             "(b)     ANOVA-type analysis.",
             "(c)     a GLM regression approach.",
             "(d)     tabular analysis.",
             "(e)     ANCOVA-type analysis.")
  
  f12 <- function(h,....){
    if(tail(svalue(r12),1) == ans12[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r12),1)== ans12[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r12),1)== ans12[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r12) <- character(0)
  }
  
  r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)
  
  
  #------------- Question 13 -----------#
  gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An analytical approach appropriate when the X variable(s) is (are) categorical and the Y variable \nis quantitative is...", 
               container = gp13.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans13 <- c("(a)     Conventional regression.",
             "(b)     ANOVA-type analysis.",
             "(c)     a GLM regression approach.",
             "(d)     tabular analysis.",
             "(e)     ANCOVA-type analysis.")
  
    f13 <- function(h,....){
    if(tail(svalue(r13),1) == ans13[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r13),1)== ans13[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r13) <- character(0)
    }
    
    r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)
    
  
  #------------- Question 14 -----------#
  gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An analytical approach appropriate when the X variable(s) is (are) quantitative and the Y variable \nis categorical is...", 
               container = gp14.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans14 <- c("(a)     Conventional regression.",
             "(b)     ANOVA-type analysis.",
             "(c)     a GLM regression approach.",
             "(d)     tabular analysis.",
             "(e)     ANCOVA-type analysis.")
  
  f14 <- function(h,....){
    if(tail(svalue(r14),1) == ans14[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r14),1)== ans14[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r14) <- character(0)
  }
  
  r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)
  
  
  #------------- Question 15 -----------#
  gp15 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An analytical approach appropriate when one X variable is quantitative, one X variable is \ncategorical, and the Y variable is quantitative is...", 
               container = gp15.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans15 <- c("(a)     Conventional regression.",
             "(b)     ANOVA-type analysis.",
             "(c)     a GLM regression approach.",
             "(d)     tabular analysis.",
             "(e)     ANCOVA-type analysis.")

  f15 <- function(h,....){
    if(tail(svalue(r15),1) == ans15[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[5]){
      gmessage(msg="Correct")
    }
    svalue(r15) <- character(0)
  }
  
  r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)
  
  
  #------------- Question 16 -----------#
  gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, a factor is...", container = gp16.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans16 <- c("(a)     a categorical explanatory variable.",
             "(b)     a category from a categorical explanatory variable.",
             "(c)     a response variable.",
             "(d)     a tabular analysis.")
  
  f16 <- function(h,....){
    if(tail(svalue(r16),1) == ans16[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r16),1)== ans16[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r16) <- character(0)
  }
  
  r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)
  
  #------------- Question 17 -----------#
  gp17 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp17.1 <- ggroup(container = gp17, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("17) ", container = gp17.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, fixed factor levels are...", container = gp17.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans17 <- c("(a)     a subset from a population of potential factor levels.",
             "(b)     are not informative.",
             "(c)     not an obvious subset from a population of potential factor levels.",
             "(d)     are informative.",
             "(e)     (a) and (b)",
             "(f)     (c) and (d)")
  
  f17 <- function(h,....){
    if(tail(svalue(r17),1) == ans17[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[4]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r17),1)== ans17[6]){
      gmessage(msg="Correct")
    }
    svalue(r17) <- character(0)
  }
  
  r17 <- gcheckboxgroup(ans17, container = gp17, checked = FALSE, where = "beginning", handler = f17)
  
  
  #------------- Question 18 -----------#
  gp18 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp18.1 <- ggroup(container = gp18, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("18) ", container = gp18.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In ANOVA, random factor levels are...", container = gp18.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans18 <- c("(a)     a subset from a population of potential factor levels.",
             "(b)     are not informative.",
             "(c)     not an obvious subset from a population of potential factor levels.",
             "(d)     are informative.",
             "(e)     (a) and (b)",
             "(f)     (c) and (d)")
  
  f18 <- function(h,....){
    if(tail(svalue(r18),1) == ans18[1]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r18),1)== ans18[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r18),1)== ans18[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r18),1)== ans18[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r18),1)== ans18[5]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r18),1)== ans18[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r18) <- character(0)
  }
  
  r18 <- gcheckboxgroup(ans18, container = gp18, checked = FALSE, where = "beginning", handler = f18)
  
}

huber.mu<-function(x,c=1.28,iter=20,conv=.1e-06){
mu.hat <- huber.NR(x, c, iter)
if(c < 0) stop("c must be >= 0")
if(c == 0 | is.nan(mu.hat[2])) mu.est <- median(x)
if(c > 0 & !is.nan(mu.hat[2]))
for(i in 1:iter){
if(abs(mu.hat[i] - mu.hat[i+1]) <=conv) mu.est=mu.hat[i+1]
}
mu.est
}

anm.coin <- function (flips = 1000, p.head = 0.5, interval = 0.01, show.coin = TRUE, ...)
{
  if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
  {dev.new(noRStudioGD = TRUE)}
  if (p.head > 1 | p.head < 0)
    stop("p.head must be in the interval [0,1]")
  res <- rbinom(n = flips, size = 1, prob = p.head)
  n.trials <- seq(1, flips)
  cum.s <- cumsum(res)
  cum.p <- cum.s/n.trials
  if (show.coin == FALSE) {
    for (i in 1:flips) {
      plot(seq(0, flips), seq(0, 1, 1/flips), type = "n",
           ylab = "Cumulative proportion", xlab = "Trial",
           cex.axis = 1.2, cex.lab = 1.2, ...)
      abline(h = p.head, lty = 2, col = "gray", lwd = 1.2)
      lines(n.trials[1:i], cum.p[1:i], type = "l", col = 1,
            lwd = 1.2)
    }
  }
  if (show.coin == TRUE) {
    old.par <- par(no.readonly = TRUE)
    layout(matrix(c(rep(1, 6), 0, 2, 0), 3, 3, byrow = TRUE))
    par(mar = c(5.5, 4.5, 2, 2))
    for (i in 1:flips) {
      dev.hold()
      plot(seq(0, flips), seq(0, 1, 1/flips), type = "n",
           ylab = "Cumulative proportion", xlab = "Trial",
           cex.lab = 1.4, cex.axis = 1.4, ...)
      abline(h = p.head, lty = 2, col = "gray", lwd = 1.3)
      lines(n.trials[1:i], cum.p[1:i], type = "l", col = 1,
            lwd = 1.3)
      plot(seq(0, 1), seq(0, 1), type = "n", xaxt = "n",
           yaxt = "n", xlab = "", ylab = "", bty = "n")
      draw.circle(x = 0.5, y = 0.5, radius = 0.35, col = rgb(blue = 0.7,
                                                             red = 0.7, green = 0.7, alpha = 0.8))
      text(0.5, 0.5, ifelse(res[i] == 0, "TAIL", "HEAD"),
           cex = 2.1)
      dev.flush()
      Sys.sleep(interval)
    }
    on.exit(par(old.par))
    invisible()
  }
}

#---------------------------- Geometric Growth --------------------------#

anm.geo.growth<-function(n0,lambda,time=seq(0,20),ylab="Abundance",xlab="Time",interval=0.1,...){
n<-n0*lambda^time

if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") {dev.new(noRStudioGD = TRUE)}
layout(matrix(c(1,1,0,2,2,rep(3,20)),5,5,byrow=TRUE))
lambda.lab<-bquote(paste(lambda,"=",.(lambda)))
old.par <- par(no.readonly = TRUE)

for(i in min(time):max(time)){
    dev.hold()
    par(mar=c(0,0,0,0))
    N.lab<-bquote(paste(N,"=",.(round(n[i+1],0))));t.lab<-bquote(paste("Time = ",.(i)))
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n")
    legend("center", legend=c(as.expression(N.lab),as.expression(t.lab)),cex=1.75,bty="n")
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",cex=1.65)
    legend("center",legend=as.expression(lambda.lab),cex=1.5,ncol=2,bty="n")
    par(mar=c(5,4,2,2))
    plot(time,n,type="n",xlab=xlab,ylab=ylab,main="Geometric Population Growth",...)
    grid()
    points(time[0:i+1],n[0:i+1],type="l",lty=1,col=2)
 dev.flush()
 Sys.sleep(interval)
}
on.exit(par(old.par))
}

#--------------------------- Exponential Growth -------------------------#

anm.exp.growth<-function(n,rmax,time=seq(0,20),ylab="Abundance",xlab="Time",interval=0.1,...){
y<-xstart<-c(n=n)
pars<-c(rmax=rmax)

pr<-as.list(pars)
func<-function(time=time,xstart=xstart,pars=pars){
    n<-xstart
    with(as.list(pars),{
    dn1<-rmax*n
    res<-list(dn1)
    })}

out<-as.data.frame(rk4(xstart,time,func,pars))
rmax.lab<-bquote(paste(r[max],"=",.(pr$rmax)))

if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") {dev.new(noRStudioGD = TRUE)}
layout(matrix(c(1,1,0,2,2,rep(3,20)),5,5,byrow=TRUE))
old.par <- par(no.readonly = TRUE)

for(i in min(time):max(time)){
    dev.hold()
    par(mar=c(0,0,0,0))
    N.lab<-bquote(paste(N,"=",.(round(out$n[i+1],0))));t.lab<-bquote(paste("Time = ",.(i)))
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n")
    legend("center", legend=c(as.expression(N.lab),as.expression(t.lab)),cex=1.75,bty="n")
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",cex=1.65)
    legend("center",legend=as.expression(rmax.lab),cex=1.5,ncol=2,bty="n")
    par(mar=c(5,4,2,2))
    plot(out$time,out$n,type="n",xlab=xlab,ylab=ylab,main="Exponential Population Growth",...)
    grid()
    points(out$time[0:i+1],out$n[0:i+1],type="l",lty=1,col=2)
 dev.flush()
 Sys.sleep(interval)
}
on.exit(par(old.par))
}

#--------------------------- Logistic Growth -------------------------#

anm.log.growth<-function(n,rmax,K,time=seq(0,60),ylab="Abundance",xlab="Time",interval=0.1,...){
y<-xstart<-c(n=n)
pars<-c(rmax=rmax,K=K)

pr<-as.list(pars)
func<-function(time=time,xstart=xstart,pars=pars){
    n<-xstart
    with(as.list(pars),{
    dn1<-rmax*n*(1-(n/K))
    res<-list(dn1)
    })}

out<-as.data.frame(rk4(xstart,time,func,pars))
rmax.lab<-bquote(paste(r[max],"=",.(pr$rmax)))
K.lab<-bquote(paste(K,"=",.(pr$K)))

if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
{dev.new(noRStudioGD = TRUE)}
layout(matrix(c(1,1,0,2,2,rep(3,20)),5,5,byrow=TRUE))
old.par <- par(no.readonly = TRUE)

for(i in min(time):max(time)){
    dev.hold()
    par(mar=c(0,0,0,0))
    N.lab<-bquote(paste(N,"=",.(round(out$n[i+1],0))));t.lab<-bquote(paste("Time = ",.(i)))
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n")
    legend("center", legend=c(as.expression(N.lab),as.expression(t.lab)),cex=1.75,bty="n")
    plot(seq(0,1),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",cex=1.65)
    legend("center",legend=c(as.expression(rmax.lab),as.expression(K.lab)),cex=1.5,ncol=2,bty="n",title="Parameters")
    par(mar=c(5,4,2,2))
    plot(out$time,out$n,type="n",xlab=xlab,ylab=ylab,main="Logistic Population Growth",...)
    grid()
    points(out$time[0:i+1],out$n[0:i+1],type="l",lty=1,col=2)
 dev.flush()
 Sys.sleep(interval)
}
on.exit(par(old.par))
}

selftest.pdfs.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Probability Density Functions")
  size(w) <- c(900, 950)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
 
  #------------- Question 1 -----------#
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("All but which of the following are requirements for f(x) to be a valid pdf for a random variable X.", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)   \u2211\u2093 f(x) = 1, if X is discrete.",
            "(b)   \u222B\u2093 f(x) = 1, if X is continuous.",
            "(c)   f(x) \u2265 0 for any x.",
            "(d)   x \u2265 0 for any x.")

  f1 <- function(h,...){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect.  This is a characteristic of a valid discrete pdf, i.e., a probability mass function.",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect.  This is a characteristic of a valid continuous pdf.",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect.  This is a characteristic of all valid pdfs", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct.  This is not a requirement for a valid pdf.  In some cases, random variable outcomes, x, may be less than 0")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a discrete random variable, X, which of the following describes the pdf, f(x)?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("(a)  P(X < x).  ",
            "(b)  P(X = x).  ",
            "(c)  P(X \u2264 x).  ",
            "(d)  P(X \u2265 z).   ")
  

  f2 <- function(h,...){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect.  This describes the cdf.", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }

  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a discrete or continuous random variable, X, which of the following describes the cdf, F(x)?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("(a)  P(X < x).  ",
            "(b)  P(X = x).  ",
            "(c)  P(X \u2264 x).  ",
            "(d)  P(X \u2265 z).   ")
  
  
  f3 <- function(h,...){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect.  This describes density for a discrete random variable.", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Correct.  This probability represents the cdf for both discrete and continuous random variables.  Note that for a continuous pdf, answers (a) and (c) are equivalent.")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }

  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a discrete or continuous random variable, X, what does the inverse cdf, F\u02c9\u00b9, provide?",
         container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("(a)  The outcome x, given a upper-tailed probability.",
            "(b)  The lower-tailed probability of an outcome x.",
            "(c)  The upper-tailed probability of an outcome x.",
            "(d)  The outcome x, given a lower-tailed probability.")
  
  f4 <- function(h,...){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect. This describes the cdf", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Correct")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
 
    #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a discrete random variable X, assume that f(x) = 0.5(x/4) for x = 1, 3, and 4, and that f(x) = 0 \nfor all other x outcomes. What is P(X = 4)?",
         container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans5 <- c("(a)  1/8",
            "(b)  1/4",
            "(c)  3/8",
            "(d)  1/2")
  
  f5 <- function(h,...){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Correct")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  

  #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a discrete random variable X, assume that f(x) = 0.5(x/4) for x = 1, 3, and 4, and that f(x) = 0 \nfor all other x outcomes. What is P(X < 4)?",
         container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans6 <- c("(a)  1/8",
            "(b)  1/4",
            "(c)  3/8",
            "(d)  1/2")
  
  f6 <- function(h,...){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect.  Make a table of probabilities for x outcomes and try again.",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Correct")
    }
    svalue(r6) <- character(0)
  }
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
  

  
  #------------- Question 7 -----------#
  
  gp7 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a continuous distribution, X, with pdf f(x)...", container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans7 <- c("(a)  f(x) = P(X = x).",
            "(b)  P(X = x) = 0.",
            "(c)  P(X \u2264 x) = P(X < x).",
            "(d)  P(X \u2265 x) = P(X > x).",
            "(e)  All of the above",
            "(f)  All of the above but (a).")
  
  
  f7 <- function(h,...){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",icon="error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Partially correct",icon="error")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r7),1) == ans7[5]){
      gmessage(msg="Incorrect",icon="error")
    }
    if(tail(svalue(r7),1) == ans7[6]){
      gmessage(msg="Correct")
    }
    svalue(r7) <- character(0)
  }
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)
  

  #------------- Question 8 -----------#
  
  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What does the normal pdf describe?", container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans8 <- c("(a)  A continuous random variable, e.g., height or weight.",
            "(b)  The number of successes, with a lower limit of 0, and an unbounded upper limit.",
            "(c)  The number of successes, with a lower limit of 0, and an upper bound of n.",
            "(d)  A discrete random variable, e.g. height or weight.")
  
  f8 <- function(h,...){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Incorrect.  The normal distribution describes continuous random variables.", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Incorrect.  The normal distribution describes continuous random variables.", icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect.  Height and weight are continuous.", icon = "error")
    }
    svalue(r8) <- character(0)
  }
  
  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)
  

  #------------- Question 9 -----------#
  
  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What does the binomial pdf describe?", container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans9 <- c("(a)  A continuous random variable, e.g., height or weight.",
            "(b)  The number of successes, with a lower limit of 0, and an unbounded upper limit.",
            "(c)  The number of successes, with a lower limit of 0, and an upper bound of n.",
            "(d)  A discrete random variable, e.g. height or weight.")
  
  f9 <- function(h,...){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Incorrect.  The binomial pdf describes discrete random variables.",icon="error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Incorrect.  The upper bound will equal the number of trials, n",icon="error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Incorrect.  The binomial pdf describes discrete random variables.  Height and weight are not discrete.", icon = "error")
    }
    svalue(r9) <- character(0)
  }
  
  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)
  
  #------------- Question 10 -----------#
  
  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What does the Poisson pdf describe?", container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans10 <- c("(a)  A continuous random variable, e.g., height or weight.",
             "(b)  The number of successes, with a lower limit of 0, and an unbounded upper limit.",
             "(c)  The number of successes, with a lower limit of 0, and an upper bound of n.",
             "(d)  A discrete random variable, e.g. height or weight.")
  
  f10 <- function(h,...){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect.  The Poisson pdf describes discrete random variables.",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Incorrect.  There is no upper bound to x in a Poisson distribution", icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect.  The Poisson pdf describes discrete random variables.  Height and weight are not discrete.", icon = "error")
    }
    svalue(r10) <- character(0)
  }
  
   r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)
 
  #------------- Question 11 -----------#
  gp11 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What are the parameters for a normal distribution?", container = gp11.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans11 <- c("(a)  \u03bc and \u03c3, repressing the mean and the variance, respectively.",
             "(b)   \u03bc and \u03c3\u00b2, repressing the mean and the variance, respectively",
             "(c)  \u03bc and \u03c3, repressing the variance and mean, respectively.",
             "(d)  \u03bc and \u03c3\u00b2, repressing the variance and the mean, respectively")
  
  
  f11 <- function(h,...){
    if(tail(svalue(r11),1) == ans11[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r11),1)== ans11[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r11),1)== ans11[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r11) <- character(0)
  }
  
  r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)
  


  #------------- Question 12 -----------#
  gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Approximately what percentage of a normal distribution is \u00b1 2\u03c3 from \u03bc?", container = gp12.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans12 <- c("(a)  100%",
             "(b)  99.7%",
             "(c)  95%",
             "(d)  68%")
  
    
    f12 <- function(h,...){
      if(tail(svalue(r12),1) == ans12[1]){
        gmessage(msg="Incorrect",  icon = "error")
      }
      if(tail(svalue(r12),1)== ans12[2]){
        gmessage(msg="Incorrect", icon = "error")
      }
      if(tail(svalue(r12),1)== ans12[3]){
        gmessage(msg="Correct")
      }
      if(tail(svalue(r12),1)== ans12[4]){
        gmessage(msg="Incorrect", icon = "error")
      }
      svalue(r12) <- character(0)
    }
    
    
     r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)
  
 
  #------------- Question 13 -----------#
  gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the binomial distribution, the parameter \u03c0 represents...", container = gp13.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans13 <- c("(a)  The probability of success.",
             "(b)  The mean and the variance of the distribution.",
             "(c)  The rate of success.",
             "(d)  The standard deviation of the distribution.",
             "(e)  (a) and (d).",
             "(f)  (b) and (c).")
  
  f13 <- function(h,...){
    if(tail(svalue(r13),1) == ans13[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r13),1)== ans13[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r13),1)== ans13[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r13) <- character(0)
  }
  
  r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)
  
  
  #------------- Question 14 -----------#
  gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The Bernoulli is a special case of binomial distribution, when...", container = gp14.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans14 <- c("(a)  \u03c0 = 0.5.",
             "(b)  \u03c0 = 1.",
             "(c)  \u03c0 = 1 and n = 0.",
             "(d)  n = 1.")
  f14 <-  function(h,...){
    if(tail(svalue(r14),1) == ans14[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r14),1)== ans14[4]){
      gmessage(msg="Correct")
    }
    svalue(r14) <- character(0)
  } 
  
  r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)
  
  #------------- Question 15 -----------#
  gp15 <- ggroup(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the Poisson distribution, the parameter \u03bb represents...", container = gp15.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans15 <- c("(a)  The probability of success.",
             "(b)  The mean and the variance of the distribution.",
             "(c)  The rate of success.",
             "(d)  The standard deviation of the distribution.",
             "(e)  (a) and (d).",
             "(f)  (b) and (c).")
  f15 <- function(h,...){
    if(tail(svalue(r15),1) == ans15[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r15),1)== ans15[6]){
      gmessage(msg="Correct")
    }
    svalue(r15) <- character(0)
  }
  
  r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)
  
  #------------- Question 16 -----------#
  gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The hypergeometric distribution differs from the binomial distribution, in that...", container = gp16.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans16 <- c("(a)  It does not consider the number of successes.",
             "(b)  It has only one parameter.",
             "(c)  It assumes sampling without replacement.",
             "(d)  It allows consideration of non-biological phenomena.")
  
  f16 <- function(h,...){
    if(tail(svalue(r16),1) == ans16[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r16),1)== ans16[3]){
      gmessage(msg="Correct.  Conversely, the binomial assumes sampling with replacement")
    }
    if(tail(svalue(r16),1)== ans16[4]){
      gmessage(msg="Incorrect.  Both the binomial and hypergeometric distribution allow consideration of non-biological (and biological) phenomena", icon = "error")
    }
    svalue(r16) <- character(0)
  }
 
   r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)
 
  #------------- Question 17 -----------#
  gp17 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp17.1 <- ggroup(container = gp17, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("17) ", container = gp17.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("All but which of the following are continuous distributions?", container = gp17.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
    ans17 <- c("(a)  t",
             "(b)  F",
             "(c)  exponential",
             "(d)  geometric",
             "(e)  gamma",
             "(f)  beta"
  )
    
    f17 <- function(h,...){
      if(tail(svalue(r17),1) == ans17[1]){
        gmessage(msg="Incorrect",  icon = "error")
      }
      if(tail(svalue(r17),1)== ans17[2]){
        gmessage(msg="Incorrect", icon = "error")
      }
      if(tail(svalue(r17),1)== ans17[3]){
        gmessage(msg="Incorrect", icon = "error")
      }
      if(tail(svalue(r17),1)== ans17[4]){
        gmessage(msg="Correct")
      }
      if(tail(svalue(r17),1)== ans17[5]){
        gmessage(msg="Incorrect", icon = "error")
      }
      if(tail(svalue(r17),1)== ans17[6]){
        gmessage(msg="Incorrect", icon = "error")
      }
      svalue(r17) <- character(0)
    } 
 
  r17 <- gcheckboxgroup(ans17, container = gp17, checked = FALSE, where = "beginning", handler = f17)
  
  
  #------------- Question 19 -----------#
  gp19 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp19.1 <- ggroup(container = gp19, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("19) ", container = gp19.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The geometric distribution...", container = gp19.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans19 <- c("(a)  gives the probability that x independent failures occur before the first success.",
             "(b)  gives the probability that x independent failures occur before the rth success.",
             "(c)  gives the probability that one failure occurs before the xth independent success.",
             "(d)  gives the probability that r successes occurs before the xth independent failure."  )
  
 
  f19 <- function(h,...){
    if(tail(svalue(r19),1) == ans19[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r19),1)== ans19[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r19),1)== ans19[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r19),1)== ans19[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r19) <- character(0)
  }
  
  r19 <- gcheckboxgroup(ans19, container = gp19, checked = FALSE, where = "beginning", handler = f19)
  
    
  
  #------------- Question 20 -----------#
  gp20 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp20.1 <- ggroup(container = gp20, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("20) ", container = gp20.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The negative binomial distribution...", container = gp20.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans20 <- c("(a)  gives the probability that x independent failures occur before the first success.",
             "(b)  gives the probability that x independent failures occur before the rth success.",
             "(c)  gives the probability that one failure occurs before the xth independent success.",
             "(d)  gives the probability that r successes occurs before the xth independent failure."
  )
  
  
  f20 <- function(h,...){
    if(tail(svalue(r20),1) == ans20[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r20),1)== ans20[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r20),1)== ans20[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r20),1)== ans20[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r20) <- character(0)
  }
  
  r20 <- gcheckboxgroup(ans20, container = gp20, checked = FALSE, where = "beginning", handler = f20)


  #------------- Question 21 -----------#
  gp21 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp21.1 <- ggroup(container = gp21, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("21) ", container = gp21.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The chi-squared distribution can be obtained by...", container = gp21.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans21 <- c("(a)  taking the log of a standard normal distribution.",
             "(b)  squaring an exponential distribution.",
             "(c)  taking the sum of one or more squared standard normal distributions.",
             "(d)  taking the sum of one or more standard normal distributions."
  )
  
  
  f21 <- function(h,...){
    if(tail(svalue(r21),1) == ans21[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r21),1)== ans21[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r21),1)== ans21[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r21),1)== ans21[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r21) <- character(0)
  }
  
  r21 <- gcheckboxgroup(ans21, container = gp21, checked = FALSE, where = "beginning", handler = f21)
  
  
}  
    

see.normcdf.tck <- function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL
    suppressWarnings(rm(slider.env))
    slider.env <<- new.env()
    mu <- 0
    assign("mu", tclVar(mu), envir = slider.env)
    sigma <- 1
    assign("sigma", tclVar(sigma), envir = slider.env)
    xmin <- -5
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 5
    assign("xmax", tclVar(xmax), envir = slider.env)
    ymin <- 0
    assign("ymin", tclVar(ymin), envir = slider.env)
    ymax <- round(dnorm(0, 0, 0.5), 2)
    assign("ymax", tclVar(ymax), envir = slider.env)

#    old.par <- par(no.readonly = TRUE)

    dev.new(height = 4, width = 8, noRStudioGD = TRUE)
    par(mar = c(4.4, 4.5, 1, 0.5), cex = 0.85, oma = c(0, 0,
        1.5, 0))
    layout(matrix(c(1, 2), 1, 2, byrow = TRUE))
    norm.refresh <- function(...) {
        dev.hold()
        mu <- as.numeric(evalq(tclvalue(mu), envir = slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        ymin <- as.numeric(evalq(tclvalue(ymin), envir = slider.env))
        ymax <- as.numeric(evalq(tclvalue(ymax), envir = slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dnorm(xx, mu, sigma)
        y1 <- pnorm(xx, mu, sigma)
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), ylim = c(ymin,
            ymax), xlab = expression(italic(x)), ylab = expression(paste(italic(f),
            "(", italic(x), ")", sep = "")))
        lines(c(mu, mu), c(par("usr")[3], dnorm(0, 0, sigma)),
            lty = 3)
        segments(mu, dnorm(sigma, 0, sigma),mu + sigma, dnorm(sigma, 0, sigma), lty = 2)
        legend("topright", lty = c(3, 2),
            legend = c(expression(mu), expression(paste("+1",
                sigma))), bty = "n")
        plot(xx, y1, type = "l", xlim = c(xmin, xmax), xlab = expression(italic(x)),
            ylab = expression(paste(italic(F), "(", italic(x),
                ")", sep = "")))
        mtext(bquote(paste(italic(X), " ~ ", italic(N), "(",
            .(mu), ", ", .(sigma^2), ")", sep = "")), outer = TRUE,
            side = 3, cex = 0.9)
        dev.flush()
    }

    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "N(\u03bc, \u03c3\u00B2)")
    tkpack(tklabel(m, text = "      Visualizing the Normal Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -3,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03c3", font = c("Helvetica", "9",
        "italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.5,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = sigma), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Ymin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = ymin), envir = slider.env)
    tkpack(tklabel(fr, text = "Ymax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = ymax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
norm.refresh()
#    on.exit(par(old.par))
    }


see.norm.tck<-function ()
{

    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    mu <- 0
    assign("mu", tclVar(mu),envir= slider.env)
    sigma <- 1
    assign("sigma", tclVar(sigma),envir= slider.env)
    xmin <- -5
    assign("xmin", tclVar(xmin),envir= slider.env)
    xmax <- 5
    assign("xmax", tclVar(xmax),envir= slider.env)
    ymin <- 0
    assign("ymin", tclVar(ymin),envir= slider.env)
    ymax <- round(dnorm(0, 0, 0.5), 2)
    assign("ymax", tclVar(ymax),envir= slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    norm.refresh <- function(...) {
        dev.hold()
        mu <- as.numeric(evalq(tclvalue(mu),envir= slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma),envir= slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin),envir= slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax),envir= slider.env))
        ymin <- as.numeric(evalq(tclvalue(ymin),envir= slider.env))
        ymax <- as.numeric(evalq(tclvalue(ymax),envir= slider.env))
        xx <- seq(xmin, xmax, length = 500)
        yy <- dnorm(xx, mu, sigma)
        plot(xx, yy, type = "l", xlim = c(xmin, xmax), ylim = c(ymin,
            ymax), xlab = expression(italic(x)), ylab = expression(paste(italic(f),
            "(", italic(x), ")", sep = "")))
        lines(c(mu, mu), c(par("usr")[3], dnorm(0, 0, sigma)),
            lty = 3)
        segments(mu, dnorm(sigma, 0, sigma),mu + sigma, dnorm(sigma, 0, sigma), lty = 2)

        mtext(bquote(paste(italic(X), " ~ ", italic(N), "(", .(mu), ", ", .(sigma^2),")", sep = "")), line = 1, side = 3)
        legend("topright", lty = c(3, 2),
            legend = c(expression(mu), expression(paste("+1",
                sigma))), bty = "n")
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "N(\u03bc, \u03c3\u00B2)")
    tkpack(tklabel(m,text="      Visualizing the Normal Distribution      "))
    tkwm.geometry(m, "+0+0")
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03bc',font=c("Helvetica","9","italic"), width = "20"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -3,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = mu),envir= slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03c3',font=c("Helvetica","9","italic"), width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.5,
        to = 3, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc,envir= slider.env)
    evalq(tkconfigure(sc, variable = sigma),envir= slider.env)


    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmin),envir= slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = xmax),envir= slider.env)
    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Ymin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = ymin),envir= slider.env)
    tkpack(tklabel(fr, text = "Ymax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e,envir= slider.env)
    evalq(tkconfigure(e, textvariable = ymax),envir= slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}

ci.mu.t<-function(data, conf=.95, summarized=FALSE, xbar=NULL, sd=NULL, fpc=FALSE, N=NULL, n=NULL, na.rm = FALSE){

if(summarized==FALSE){
n<-nrow(as.matrix(na.omit(data)))
t.star<-qt((1-((1-conf)/2)),n-1)
s2 <- var(data, na.rm = na.rm)
Var.Xbar<-ifelse(fpc==FALSE,s2/n,(1-(n/N))*(s2/n))
xbar <- mean(data, na.rm = na.rm)
}

if(summarized==TRUE){
t.star<-qt((1-((1-conf)/2)),n-1)
Var.Xbar<-ifelse(fpc==FALSE,sd^2/n,(1-(n/N))*(sd^2/n))
}

m<-sqrt(Var.Xbar)*t.star
CI<-c(xbar,xbar-m,xbar+m)
  
head<-paste(paste(as.character(conf*100),"%",sep=""),c("t Confidence interval for population mean"))
ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
res<-list(SE=sqrt(Var.Xbar),margin=m,ci=CI,ends=ends,head=head)
class(res)<-"ci"
res
}

ci.mu.z<-function(data,conf=.95,sigma=1,summarized=FALSE,xbar=NULL,fpc=FALSE,N=NULL,n=NULL, na.rm = FALSE){
z.star<-qnorm(1-((1-conf)/2)) 

if(summarized==FALSE){
n<-length(as.matrix(na.omit(data)))
xbar <- mean(data, na.rm = na.rm)
Var.xbar<-sigma^2/nrow(as.matrix(data))
SD.xbar<-ifelse(fpc==FALSE,sqrt(Var.xbar),sqrt((1-(n/N))* Var.xbar))
}

if(summarized==TRUE){
SD.xbar<-ifelse(fpc==FALSE,sigma/sqrt(n),sqrt((1-(n/N))* (sigma^2/n)))
}

m<-SD.xbar*z.star
CI<-c(xbar,xbar-m,xbar+m)

head<-paste(paste(as.character(conf*100),"%",sep=""),c("z Confidence interval for population mean"))
ends<-c("Estimate",paste(as.character(c((1-conf)/2,1-((1-conf)/2))*100),"%",sep=""))
res<-list(margin=m,ci=CI,head=head,ends=ends)
class(res)<-"ci"
res
}

selftest.ANOVAmixed.tck1 <-function(){

  options(guiToolkit="tcltk")
  w <- gwindow(title = "Mixed effect models")
  size(w) <- c(700, 400)
  
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
 
 
  

  
   
  #------------- Question 1 -----------#
  
  f1 <- function(h,....){
    if(svalue(r1) == ans1[1]){
      gmessage(msg="Partially correct",  icon = "error", parent = gp1)
    }
    if(svalue(r1)== ans1[2]){
      gmessage(msg="Partially correct", icon = "error", parent = gp1)
    }
    if(svalue(r1)== ans1[3]){
      gmessage(msg="Partially correct", icon = "error", parent = gp1)
    }
    if(svalue(r1)== ans1[4]){
      gmessage(msg="Correct", parent = gp1)
    }
    svalue(r1) <- character(0)
  }
  
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Why do we use REML to estimate variances in random and mixed effect models?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp1, .5)
  
  ans1 <- c("(a)  ML estimates are biased low.",
            "(b)  MOM estimates can be negative.",
            "(c)  Lack of balance in multifactor designs prevents MOM estimates.",
            "(d)  All of the above.")
  
  r1 <- gcheckboxgroup(ans1, container = gp1, where = "beginning", handler = f1)
  

  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("For a random factor A with three stipulated factor levels, we would use a random effect model to test\n the null hypothesis...", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  #addSpace(gp1, .5)
  
  ans2 <- c("(a)  \u03bc\u2081 = \u03bc\u2082 = \u03bc\u2083.",
            "(b)  The true variance of the population of factor level means in A equals zero.",
            "(c)  The true variance of the observed factor level means in A equals zero.",
            "(d)  None of the above.")

  
  f2 <- function(h,....){
    if(svalue(r2) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error", parent = gp2)
    }
    if(svalue(r2)== ans2[2]){
      gmessage(msg="Correct", parent = gp2)
    }
    if(svalue(r2)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error", parent = gp2)
    }
    if(svalue(r2)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error", parent = gp2)
    }
    svalue(r2) <- character(0)
  }
  
    
  r2 <- gcheckboxgroup(ans2, container = gp2, where = "beginning", handler = f2)
  
    

}

see.pdfdriver<-function(pdf,show.cdf=TRUE){
if(pdf=="beta"&show.cdf==TRUE)see.betacdf.tck()
if(pdf=="beta"&show.cdf==FALSE)see.beta.tck()
if(pdf=="binomial"&show.cdf==TRUE)see.bincdf.tck()
if(pdf=="binomial"&show.cdf==FALSE)see.bin.tck()
if(pdf=="chisq"&show.cdf==TRUE)see.chicdf.tck()
if(pdf=="chisq"&show.cdf==FALSE)see.chi.tck()
if(pdf=="F"&show.cdf==TRUE)see.Fcdf.tck()
if(pdf=="F"&show.cdf==FALSE)see.F.tck()
if(pdf=="gamma"&show.cdf==TRUE)see.gamcdf.tck()
if(pdf=="gamma"&show.cdf==FALSE)see.gam.tck()
if(pdf=="geometric"&show.cdf==TRUE)see.geocdf.tck()
if(pdf=="geometric"&show.cdf==FALSE)see.geo.tck()
if(pdf=="hypergeometric"&show.cdf==TRUE)see.hypercdf.tck()
if(pdf=="hypergeometric"&show.cdf==FALSE)see.hyper.tck()
if(pdf=="exponential"&show.cdf==TRUE)see.expcdf.tck()
if(pdf=="exponential"&show.cdf==FALSE)see.exp.tck()
if(pdf=="logistic"&show.cdf==TRUE)see.logiscdf.tck()
if(pdf=="logistic"&show.cdf==FALSE)see.logis.tck()
if(pdf=="lognormal"&show.cdf==TRUE)see.lnormcdf.tck()
if(pdf=="lognormal"&show.cdf==FALSE)see.lnorm.tck()
if(pdf=="negative binomial"&show.cdf==TRUE)see.nbincdf.tck()
if(pdf=="negative binomial"&show.cdf==FALSE)see.nbin.tck()
if(pdf=="normal"&show.cdf==TRUE)see.normcdf.tck()
if(pdf=="normal"&show.cdf==FALSE)see.norm.tck()
if(pdf=="poisson"&show.cdf==TRUE)see.poiscdf.tck()
if(pdf=="poisson"&show.cdf==FALSE)see.pois.tck()
if(pdf=="t"&show.cdf==TRUE)see.tcdf.tck()
if(pdf=="t"&show.cdf==FALSE)see.t.tck()
if(pdf=="uniform"&show.cdf==TRUE)see.unifcdf.tck()
if(pdf=="uniform"&show.cdf==FALSE)see.unif.tck()
if(pdf=="discrete uniform"&show.cdf==TRUE)see.disc.unifcdf.tck()
if(pdf=="discrete uniform"&show.cdf==FALSE)see.disc.unif.tck()  
if(pdf=="weibull"&show.cdf==TRUE)see.weibcdf.tck()
if(pdf=="weibull"&show.cdf==FALSE)see.weib.tck()
}



see.pdfdriver.tck<-function(){

tclRequire("BWidget")
local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog.sd <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Depiction of pdfs")
        Pdf<-tclVar("normal")  
        done <- tclVar(0)
        show.cdf<-tclVar(1)
    
    
    reset <- function()
        {
            tclvalue(Pdf)<-"normal"
            tclvalue(show.cdf)<-"1"
        }
        
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",command=function()tclvalue(done)<-1)
        tkgrid(tklabel(tt,text="Choose pdf"),columnspan=2)  
        tkgrid(tklabel(tt,text=""),columnspan=2)
        cdf.cbut <- tkcheckbutton(tt, text="Show cdf", variable=show.cdf)
        tkgrid(tklabel(tt, text="pdf"))
        pdfs<- c("beta","binomial","chisq","exponential","F","gamma","geometric", "hypergeometric","logistic","lognormal","negative binomial","normal","poisson","t", "uniform","discrete uniform", "weibull")
            comboBox <- tkwidget(tt,"ComboBox", editable=FALSE, values=pdfs, textvariable = Pdf, width = 17)
        
        
        
        build<-function(){
        f<-as.logical(tclObj(show.cdf))
        pdf<-tclvalue(Pdf)
        substitute(see.pdfdriver(pdf,f))
        }
          
        
        tkgrid(comboBox,columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(cdf.cbut)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but, reset.but, sticky="w")
        
        
        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    }                            
      Pdf<- tclVar("normal")
      dialog.sd()
})
}
 

anm.die.tck<-function () 
{

    local({
        have_ttk <- as.character(tcl("info", "tclversion")) >= 
            "8.5"
        if (have_ttk) {
            tkbutton <- ttkbutton
            tkcheckbutton <- ttkcheckbutton
            tkentry <- ttkentry
            tkframe <- ttkframe
            tklabel <- ttklabel
            tkradiobutton <- ttkradiobutton
        }
        tclServiceMode(FALSE)
        dialog.sd <- function() {
            tt <- tktoplevel()
            tkwm.title(tt, "Frequentist probability and die throws")
            p.entry <- tkentry(tt, textvariable = P, width = 10)
            int.entry <- tkentry(tt, textvariable = Int, width = 10)
            throw.entry <- tkentry(tt, textvariable = Throws, width = 10)
            done <- tclVar(0)
            show.die<-tclVar(1)
            color<-tclVar(1)
            reset <- function() {
                tclvalue(P) <- "c(1/6,1/6,1/6,1/6,1/6,1/6)"
                tclvalue(Int) <- "0.01"
                tclvalue(Throw) <- "1000"
                tclvalue(show.die)<-"0"
                tclvalue(color)<- "0"
            }
            reset.but <- tkbutton(tt, text = "Reset", command = reset)
            submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)
            build <- function() {
                p <-parse(text=tclvalue(P))[[1]]
                interval <- tclvalue(Int)
                reps <- tclvalue(Throws)
                show.die <- as.logical(tclObj(show.die))
                color <- as.logical(tclObj(color))
                substitute(anm.die(rep=as.numeric(reps),p=p, 
                  interval = as.numeric(interval), show.die=show.die, cl = color))
            }
            nc.cbut <- tkcheckbutton(tt, text="Show die", variable=show.die)
            col.cbut <- tkcheckbutton(tt, text="Color", variable=color)
            tkgrid(tklabel(tt, text = "Frequentist probability\nand die throws", justify = "center"), 
                columnspan = 2)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(tklabel(tt, text = "P(Throw)"), p.entry)
            tkgrid(tklabel(tt, text = "Throws"), throw.entry)
            tkgrid(tklabel(tt, text = "Anim. int."), 
                int.entry)
            tkgrid(tklabel(tt, text = ""))
            tkgrid(nc.cbut, col.cbut)
            tkgrid(submit.but, reset.but,sticky="w")
            tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
            tkwait.variable(done)
            if (tclvalue(done) == "2") 
                stop("aborted")
            tkdestroy(tt)
            cmd <- build()
            eval.parent(cmd)
        invisible(tclServiceMode(TRUE))
        }
        P <- tclVar("rep(1/6,6)")
        Throws <- tclVar("1000")
        Int <- tclVar("0.01")
        dialog.sd()
    })
    }

see.roc.tck <- function ()
{
  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    mu1 <- 0.4
    assign("mu1", tclVar(mu1), envir = slider.env)
    mu2 <- 0.6
    assign("mu2", tclVar(mu2), envir = slider.env)
    c <- 0.5
    assign("c", tclVar(c), envir = slider.env)

    dev.new(width=10,height=5,noRStudioGD = TRUE)

    xlim <- c(0, 1.8)
    ylim <- c(0, dnorm(0, 0, 0.07))

    norm.refresh <- function(...) {
        dev.hold()

        mu1 <- as.numeric(evalq(tclvalue(mu1), envir = slider.env))
        mu2 <- as.numeric(evalq(tclvalue(mu2), envir = slider.env))
        c <- as.numeric(evalq(tclvalue(c), envir = slider.env))
        sigma = 0.08
        layout(matrix(c(1,1,1,1,1,2,2), 1, 7))
        par(mar=c(5,4.1,3,1))


        x<-NULL; rm(x)

        cols <- c(rgb(red=1,blue=1,green=1,alpha=.6), rgb(red=0,blue=0,green=0,alpha=.6), rgb(red=.5,blue=.5,green=0.5,alpha=.6))
        curve(dnorm(x,mu1,sigma),from=0,to=1,ylab = "",ylim=ylim,xlab = "",xlim=xlim, main = "Dichotomous populations",cex.lab=1.4,cex.axis=1.3, cex.main=1.4,xaxt="n",yaxt="n")
        axis(side = 1, at = c(0, .2, .4, .6, .8,1))
        mtext(side = 1, at = 0.5, line = 3, expression(italic(c)))
        mtext(side = 2, line = 1.7, "Density")
        legend("topleft", pch=22, pt.cex=1.7, pt.bg=c(cols[1],cols[2]), legend = c(expression(paste(italic(Y)," = 0")), expression(paste(italic(Y)," = 1"))), bty = "n")

        xx <- seq(-0.5, 1.5, length = 500)
        yy1 <- dnorm(xx, mu1, sigma)
        yy2 <- dnorm(xx, mu2, sigma)

        polygon(c(xx[xx<=1.5],1.5),c(yy2[xx<=1.5],yy2[xx==-0.5]),col=cols[2])
        polygon(c(xx[xx<=1.5],1.5),c(yy1[xx<=1.5],yy1[xx==-0.5]),col=cols[1])


        ys <- c(ylim[2]*.6, ylim[2]*.8, ylim[2])
        xs <- c(.6*xlim[2], .8*xlim[2], xlim[2])

        rect(xs[1],ys[2],xs[2],ys[3], col=cols[1])   #topleft
        rect(xs[2],ys[2],xs[3],ys[3], col=cols[3])   #topright
        rect(xs[1],ys[1],xs[2],ys[2], col=cols[3])   #bottomleft
        rect(xs[2],ys[1],xs[3],ys[2], col=cols[2])   #bottomright

        xv <- c(rnorm(200, mu1, sigma), rnorm(200, mu2, sigma))
        yv <- c(rep(0, 200), rep(1, 200))

        glmm <- suppressWarnings(glm(yv ~ xv, family = "binomial"))
        abline(v = c, lwd = 2)

        t <- table(ifelse(fitted(glmm) > c, 1, 0), yv)
        TP <- round(t[,2][2]/sum(t[,2]),2)
        FN <- round(1 - t[,1][1]/sum(t[,1]),2)
        TN <- round(t[,1][1]/sum(t[,1]),2)
        FP <- round(1 - t[,2][2]/sum(t[,2]),2)

        text(mean(c(xs[1],xs[2])), .97*ys[3], "True negative rate")
        text(mean(c(xs[2],xs[3])), .97*ys[3], "False positive rate")
        text(mean(c(xs[1],xs[2])), .97*ys[2], "False negative rate")
        text(mean(c(xs[2],xs[3])), .97*ys[2], "True positive rate")

        text(mean(c(xs[1],xs[2])), .9*ys[3], bquote(.(TN)))
        text(mean(c(xs[2],xs[3])), .9*ys[3], bquote(.(FP)))
        text(mean(c(xs[1],xs[2])), .86*ys[2], bquote(.(FN)))
        text(mean(c(xs[2],xs[3])), .86*ys[2], bquote(.(TP)))

        int <- seq(0.01, 0.99, by =.01)
        sens <- rep(NA, length(int))
        omspec <- rep(NA, length(int))



        for(i in 1:length(int)){
        t <- table(ifelse(fitted(glmm) > int[i], 1, 0), yv)
        if(ncol(t)==1){
            if(colnames(t)=="0") t <- cbind(t, c(0,0))
            if(colnames(t)=="1") t <- cbind(c(0,0), t)
                      }
        if(nrow(t)==1){
            if(rownames(t)=="0") t <- rbind(t, c(0,0))
            if(rownames(t)=="1") t <- rbind(c(0,0), t)
                      }

        sens[i] <- t[,2][2]/sum(t[,2])
        omspec[i] <- 1 - t[,1][1]/sum(t[,1])
        }

        plot(c(1,omspec,0), c(1,sens,0), xlab = "False positive rate", ylab = "True positive rate", type = "l", xlim=c(0,1), ylim=c(0,1), lwd = 2.5, main = "ROC curve",cex.lab=1.4,cex.main=1.4,cex.axis=1.3)
        abline(0, 1, lty = 2)

        dev.flush()
    }


    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing ROC curves")
    tkpack(tklabel(m, text = "      Visualizing ROC curves      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Y = 0", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.3,
        to = 0.48, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu1), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Y = 1", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.54,
        to = 0.7, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu2), envir = slider.env)

 tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "c", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.2,
        to = 0.95, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = c), envir = slider.env)

    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
    on.exit(par(old.par))
    }

see.ttest.tck <- function ()
{
  old.par <- par(no.readonly = TRUE)
        tclRequire("BWidget")
    if (!exists("slider.env"))
        slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check
    mu1 <- -1
    assign("mu1", tclVar(mu1), envir = slider.env)
    mu2 <- 0
    assign("mu2", tclVar(mu2), envir = slider.env)
    sigma <- 1
    assign("sigma", tclVar(sigma), envir = slider.env)
    n <- 10
    assign("n", tclVar(n), envir = slider.env)

alt <-tclVar("two.sided")
var.equal<-tclVar(0)

if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

    ylim <- c(0, dnorm(0, 0, 0.5))
    norm.refresh <- function(...) {
        dev.hold()
        par(mfrow=c(2, 1))
        mu1 <- as.numeric(evalq(tclvalue(mu1), envir = slider.env))
        mu2 <- as.numeric(evalq(tclvalue(mu2), envir = slider.env))
        sigma <- as.numeric(evalq(tclvalue(sigma), envir = slider.env))
        n <- as.numeric(evalq(tclvalue(n), envir = slider.env))
        alt <- tclvalue(alt)
        ve <- as.logical(tclObj(var.equal))
        y1 <- rnorm(n,mu1,sigma)
        y2 <- rnorm(n,mu2,sigma)

        if(alt == "two.sided")test <- "two"
        if(alt == "less")test <- "lower"
        if(alt == "greater")test <- "upper"
        x <- rep(c("1","2","3"),each=n)


        a <- t.test(y1, y2, alternative = alt, var.equal = ve)
        t <- a$statistic
        P <- a$p.value
        nu <- as.numeric(a$parameter)

        cols <- c(rgb(red=0.5,blue=0.6,green=0.5,alpha=.3), rgb(red=0.5,blue=0.5,green=0.6,alpha=.3))
        rcols <- c(rep(rgb(red=0.5,blue=0.6,green=0.5),n), rep(rgb(red=0.5,blue=0.5,green=0.6),n))

        curve(dnorm(x,mu1,sigma),from=-5,to=5,ylim=ylim,xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))


        mtext(side = 3, expression(paste(italic(t), "-test from random sample of populations:", sep = "")), line = -1.5)
        mtext(side = 3, line = -2.5, bquote(paste("alternative = ", .(alt), "  ", italic(t)," = ", .(round(t, 2)), "  ",italic(P)," = ",.(round(P, 5)))))


        xx <- seq(-10, 10, length = 500)
        yy1 <- dnorm(xx, mu1, sigma)
        yy2 <- dnorm(xx, mu2, sigma)

        polygon(c(xx[xx <= 10], 10), c(yy1[xx <= 10], yy1[xx ==
            -10]), col = cols[1])
        polygon(c(xx[xx <= 10], 10), c(yy2[xx <= 10], yy2[xx ==
            -10]), col = cols[2])
        text(c(y1,y2),rep(0.008,n*2), c(rep(1,n),rep(2,n)), adj = c(0.5,0), cex = .9, col = rcols)
        legend("topright", pch = 22, pt.cex = 1.7, pt.bg = cols,
            legend = c(expression(italic(X)[1]), expression(italic(X)[2])),
            bty = "n")
        par(mar=c(4,4,0.5,2))
        shade.t(t, nu=nu, tail= test)
        dev.flush()
    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "Visualizing t-tests")
    tkpack(tklabel(m, text = "      Visualizing t-tests      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC\u2081", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu1), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03BC\u2082", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = -4,
        to = 4, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = mu2), envir = slider.env)

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "\u03C3", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.1,
        to = 2, orient = "horiz", resolution = 0.1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = sigma), envir = slider.env)

   tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "n", font = c("Helvetica", "10",
        "normal"), width = "10"), side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 2,
        to = 20, orient = "horiz", resolution = 1, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = n), envir = slider.env)

    alternative <- c("two.sided", "less", "greater")
    comboBox1 <- tkwidget(m,"ComboBox", editable=FALSE, values=alternative, textvariable = alt, width = 10)
      tkpack(tklabel(m, text = "Alternative"))
      tkpack(comboBox1)
    v.but <- tkcheckbutton(m, text="Variance equal", variable=var.equal)
      tkpack(v.but)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
    on.exit(par(old.par))
    }

bplot<-function (y, x, bar.col = "gray", loc.meas = mean, sort = FALSE, order = NULL, int = "SE", conf = 0.95, 
    uiw = NULL, liw = NULL, sfrac = 0.1, slty = 1, scol = 1, slwd = 1, exp.fact = 1.5, simlett = FALSE, lett.side = 3,  
    lett = NULL, cex.lett = 1, names.arg = NULL, ylim = NULL, horiz = FALSE, xpd = FALSE, print.summary = TRUE,...) 
{

#------ error estimators -------#
  
    SE <- tapply(y, x, function(x) {
    ci.mu.t(x[!is.na(x)])$SE
    })
    CI <- tapply(y, x, function(x) {
    ci.mu.t(x[!is.na(x)], conf = conf)$margin
    })
    iqr <- tapply(y, x, IQR)
    n <- as.numeric(summary(as.factor(x)))
    iqr.ci <- 1.58 * iqr/sqrt(n)
    MAD <- tapply(y, x, function(x) {
    mad(x[!is.na(x)])})
    
	if(int == "bootSE"){
    	     lvl <- levels(factor(x))
		bootSE <- 1:length(lvl)
		for(i in 1: length(lvl)){
		bootSE[i] <- bootstrap(y[x==lvl[i]], loc.meas)$res[4]
		}
	}	

# scale.estimates <- data.frame(SD = SE * sqrt(n), SE = SE, CI.margin = CI, IQR = IQR, IQR.CI.margin = iqr.ci, MAD = MAD)    
      
#-----------------#
       	
    loc.vec <- tapply(y, x, function(x) {
        loc.meas(x[!is.na(x)])})
    
      if (sort == TRUE) {
      o <- order(loc.vec)
      loc.vec <- loc.vec[o]
      SE <- SE[o]
      CI <- CI[o]
      iqr <- iqr[o]
      iqr.ci <- iqr.ci[o]
      MAD <- MAD[o]
      names.arg <- names.arg[o]
	if(!is.null(lett))lett <- lett[o]	
	}
    
      if(!is.null(order)){
	 if(length(order) != nlevels(factor(x))) stop("order must be a vector whose length is equal to the number of factor levels")   
	 loc.vec <- loc.vec[order] 
	 SE <- SE[order]
      CI <- CI[order]
      iqr <- iqr[order]
      iqr.ci <- iqr.ci[order]
      MAD <- MAD[order]
      names.arg <- names.arg[order]
	  if(!is.null(lett))lett <- lett[order]	
	}
	
    if(int == "CI") margin <- CI
    if(int == "SE") margin <- SE
    if(int == "IQR") margin <- iqr
    if(int == "IQR.CI") margin <- iqr.ci
    if(int == "MAD") margin <- MAD
    if(int == "bootSE") margin <- bootSE 
    if(is.null(uiw)) uiw <- loc.vec + margin; liw <- loc.vec - margin
    
                if (simlett == TRUE & is.null(ylim)){ 
                  ylim = c(min(c(0, loc.vec - (margin * exp.fact))), 
                  max(c(0, loc.vec + (margin * exp.fact))))}
                if(simlett == FALSE & is.null(ylim)){
                  ylim <- c(min(0, loc.vec - (margin)), max(0, loc.vec + (margin)))}
                                     
                if(horiz == FALSE) b <- barplot(loc.vec, ylim = ylim , col = bar.col, names.arg = names.arg, xpd = xpd, ...)
                if(horiz == TRUE) b <- barplot(loc.vec, xlim = ylim , col = bar.col, horiz = TRUE, names.arg = names.arg, xpd = xpd, ...)
                if(horiz == FALSE){
                    arrows(b, liw, b, uiw, angle = 90, col = scol, lty = slty, lwd = slwd, length = sfrac)
                    arrows(b, liw, b, uiw, code = 1, angle = 90, col = scol, lty = slty, lwd = slwd, length = sfrac)}
                if(horiz == TRUE){
                    arrows(liw, b, uiw, b, angle = 90, col = scol, lty = slty, lwd = slwd, length = sfrac)
                    arrows(liw, b, uiw, b, code = 1, angle = 90, col = scol, lty = slty, lwd = slwd, length = sfrac)}
			if(simlett == TRUE){
                    mtext(lett, side = lett.side, cex = cex.lett, at = b, line = ifelse(lett.side == 3, 0.5, -0.5), las = ifelse(horiz == TRUE, 2, 1))}
			if(print.summary == TRUE){
				if(int != "CI"){
					cat(paste("\n","Bars are ", deparse(substitute(loc.meas)), "s.  Errors are ", int, "s.", "\n\n", sep = ""))}
				if(int == "CI"){
					cat(paste("\n", "Bars are ", deparse(substitute(loc.meas)), "s.  Errors are ", conf * 100, "% confidence intervals for the true mean.", "\n\n", sep = ""))}
			}
invisible(b)    
}				

selftest.ML_OLS.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "OLS and ML estimation")
  size(w) <- c(700, 400)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
 
  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What is the likelihood of a value for a parameter \u03B8, given data?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans1 <- c("(a)  The absolute value of data densities resulting from a specified value of \u03B8, \nthat parameterizes an assumed probability distribution.",
            "(b)  P(\u03B8|data).",
            "(c)  The sum of probabilities of data resulting from a specified value of \u03B8, \nthat parameterizes an assumed probability distribution.",
            "(d)  The product of data densities resulting from a specified value of \u03B8, \nthat parameterizes an assumed probability distribution.")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Correct")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) Likelihood can be interpreted as a probability.", container = gp2, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans2 <- c("True",
            "False")
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect.  Densities cannot always be interpreted as probabilities.  For instance, it is possible for a likelihood to be greater than 1.",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Correct.  Densities cannot always be interpreted as probabilities.  For instance, it is possible for a likelihood to be greater than 1.")
    }
    svalue(r2) <- character(0)
  } 
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) The arithmetic mean is the OLS estimator for the true mean of any distribution.", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans3 <- c("True",
            "False")
  
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r3) <- character(0)
  } 

r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)

  
  
  #------------- Question 4 -----------#
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("An OLS estimator for \u03B8...", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans4 <- c("minimizes: \u2211\u2093(x\u1D62 - f\u1D62(\u03B8))\u00B2",
            "maximizes: \u2211\u2093(x\u1D62 - f\u1D62(\u03B8))\u00B2",
            "minimizes: \u220F\u2093 f(x\u1D62|\u03B8)",
            "maximizes: \u220F\u2093 f(x\u1D62|\u03B8)"
  )
  
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1) == ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }

   r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
   
  
  #------------- Question 5 -----------#
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A ML estimator for \u03B8...", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans5 <- c("minimizes: \u2211\u2093(x\u1D62 - f\u1D62(\u03B8))\u00B2",
            "maximizes: \u2211\u2093(x\u1D62 - f\u1D62(\u03B8))\u00B2",
            "minimizes: \u220F\u2093 f(x\u1D62|\u03B8)",
            "maximizes: \u220F\u2093 f(x\u1D62|\u03B8)")

  f5 <-  function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1) == ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Correct")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
}

AP.test<-function(Y){
ranks<-matrix(nrow=nrow(Y),ncol=ncol(Y),data=rank(Y))
R<-apply(ranks,2,mean)
a<-ncol(Y)
b<-nrow(Y)
S<-(b-1)*cov(ranks)/(b-a+1)
C<-diag(1,nrow=a-1,ncol=a)
for(i in 1:a-1){
C[i,i+1]<--1}
F.star<-b/(a-1)*t(C%*%R)%*%(solve(C%*%S%*%t(C)))%*%C%*%R
nu1<-a-1
nu2<-(a-1)*(b-1)
AP.Table<-data.frame(df1=nu1,df2=nu2,F=F.star,p.val=pf(F.star,nu1,nu2,lower.tail=FALSE),row.names="X")
colnames(AP.Table)<-c("df1","df2","F*","P(F>F*)")
AP.Table
}

lm.select <- function(lms, deltaAIC = FALSE){
      models <- matrix(ncol = 1, nrow = length(lms))
      res <- matrix(ncol = 5, nrow = length(lms))
      for(i in 1 : length(lms)){
      res[,1][i] <- AIC(lms[[i]])
          p <- length(coef(lms[[i]])) + 1
          n <- length(fitted(lms[[i]]))
      res[,2][i] <- AIC(lms[[i]]) + (2 * p * (p + 1))/(n - p - 1)
      res[,3][i] <- AIC(lms[[i]], k = log(n))
          MSE <- tail(anova(lms[[1]])$"Mean Sq", 1)
          SSEk <- tail(anova(lms[[i]])$"Sum Sq", 1)
      res[,4][i] <- SSEk/MSE - (n - 2 * p)
      res[,5][i] <- press(lms[[i]])
          tm1 <- attributes(lms[[1]]$terms)$term.labels
          tmi <- attributes(lms[[i]]$terms)$term.labels
          if(deltaAIC == FALSE & any(is.na(match(tmi,tm1)))){
          message("Warning: subsequent models not a subset of first model, Cp values invlaid") }
	models[i] <- as.matrix(format(lms[[i]]$call$formula))
      }
res1 <- data.frame(Model = models, AIC = res[,1], AICc = res[,2], BIC = res[,3], Cp = res[,4], PRESS = res[,5])
if(deltaAIC == TRUE){
deltaAIC <- res[,1] - min(res[,1])
rel.likelihood <- exp(-0.5*deltaAIC) 
res1 <- data.frame(Model = models, deltaAIC = deltaAIC, Rel.likelihood = rel.likelihood, Akaike.weight = rel.likelihood/sum(rel.likelihood)) 
}
res1
}

D.sq<-function(g1,g2){
dbar<-as.vector(colMeans(g1)-colMeans(g2))
S1<-cov(g1)
S2<-cov(g2)
n1<-nrow(g1)
n2<-nrow(g2)
V<-as.matrix((1/(n1+n2-2))*(((n1-1)*S1)+((n2-1)*S2)))
D.sq<-t(dbar)%*%solve(V)%*%dbar
res<-list()
res$D.sq<-D.sq
res$V<-V
res
}

selftest.sampd.tck1 <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Sampling distributions")
  size(w) <- c(700, 450)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
 
  
  #------------- Question 1 -----------#
  
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("A sampling distribution can be best described as a...", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp1, .5, horizontal=FALSE)
  ans1 <- c("(a) A sample of individuals from a parent population one wishes to make inference to.  ",
            "(b) An idealization, describing an infinite number of independent statistical estimates (e.g., arithmetic means) \ntaken from the same parent distribution, using the same sample size.",
            "(c) A collection of statistics describing outcomes from a particular experiment.  ",
            "(d) A collection of random samples from a normal distribution.   ")
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
    r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  

  
  
  #------------- Question 2 -----------#
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("If the parent distribution is \u0059 ~ N(\u03bc, \u03c3\u00b2), then the sampling distribution of \u0232 will be: ", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp2, .5, horizontal=FALSE)
  
  
  ans2 <- c("(a)    \u0232 ~ N(\u0232, \u03c3\u00b2).",
            "(b)    \u0232 ~ N(\u03bc, \u03c3/n).",
            "(c)    \u0232 ~ N(\u03bc/n, \u03c3\u00b2).",
            "(d)    \u0232 ~ N(\u03bc, \u03c3\u00b2/n).")
  
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Correct")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  

  
  
  #------------- Question 3 -----------#
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which of the following describes the Central Limit Theorem?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp3, .5, horizontal=FALSE)
  ans3 <- c("(a)  If Y ~ N(\u03bc, \u03c3\u00b2), then \u0232 ~ N(\u03bc/n, \u03c3\u00b2/n).",
            "(b)  If the sample size from Y is large, then the variance for the sampling distribution of \u0232 will be small.",
            "(c)  Even if Y is not normal, if the sample size from Y is large, then \u0232 will be approximately normal.",
            "(d)  None of the above.")
  
  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="This does occur, but it is due to the Law of Large Numbers, not the Central Limit Theorem.",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Which of the following statistics have sampling distributions?", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp4, .5, horizontal=FALSE)
  ans4 <- c("(a) The sample mean",
            "(b) The sample median",
            "(c) The sample standard deviation.",
            "(d) All of the above.")
  
  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Partially correct", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Correct.  Any statistical estimator can have a sampling distribution.")
    }
    svalue(r4) <- character(0)
  }
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
  
 
  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from a normal parent distribution to make inference to Y, with sample size n.  \nAssume that \u03bc\u2080 is equal to the mean of Y, \u03bc. That is, assume \u03bc = \u03bc\u2080.  \nWhat is the sampling distribution of \u221an(\u0232 - \u03bc\u2080)/S,  where S is the sample standard deviation. 
         ",  container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp5, .5, horizontal=FALSE)
  ans5 <- c("(a)  N(0,1)",
            "(b)  F(n\u2082 - 1, n\u2082 - 1)",
            "(c)  t(n - 1)",
            "(d)  t(n)")
  
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  
  #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Given the assumptions in Question 5, what is the sampling distribution of \u221an(\u0232 - \u03bc\u2080)/\u03c3",
         container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp6, .5, horizontal=FALSE)
  ans6 <- c("(a)  N(0,1)",
            "(b)  F(n\u2082 - 1, n\u2082 - 1)",
            "(c)  t(n - 1)",
            "(d)  t(n)")
  
  f6 <- function(h,....){
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r6) <- character(0)
  }
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)
 
  
  #------------- Question 7 -----------#
  
  
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We sample from two normal distributions, Y\u2081 and Y\u2082, with sample sizes n\u2081 and n\u2082, respectively.  \nWe assume that the variances of Y\u2081 and Y\u2082 are equal.  \nWhat is the sampling distribution of the ratio of sample variances: S\u2081\u00b2/S\u2082\u00b2",
         container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  # addspace(gp7, .5, horizontal=FALSE)
  ans7 <- c("(a)  N(0,1)",
            "(b)  F(n\u2081 - 1, n\u2082 - 1)",
            "(c)  t(n - 1)",
            "(d)  t(n)")
  
  f7 <- function(h,....){
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r7) <- character(0)
  }
  
   r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)
  
  

}

perm.fact.test<-function(Y,X1,X2,X3=NA, perm=100, method = "a"){

if(all(is.na(X3))){init.model<-anova(lm(Y~X1*X2))}
if(all(!is.na(X3))){init.model<-anova(lm(Y~X1*X2*X3))}


r<-length((init.model)$"F value")-1
F.init<-init.model$"F value"[1:r]
MS <- init.model$"Mean Sq"


# (a)
if(method == "a"){
F.perm<-matrix(nrow=r,ncol=perm)
if(all(is.na(X3))){
for(i in 1:perm){
Y.new<-sample(Y,replace=FALSE)
F.perm[,i]<-anova(lm(Y.new~X1*X2))$"F value"[1:r]}}

if(all(!is.na(X3))){
for(i in 1:perm){
Y.new<-sample(Y,replace=FALSE)
F.perm[,i]<-anova(lm(Y.new~X1*X2*X3))$"F value"[1:r]}}
}


# (b)
if(method == "b"){
MS.perm<-matrix(nrow=r + 1,ncol=perm)
if(all(is.na(X3))){
for(i in 1:perm){
Y.new<-sample(Y,replace=FALSE)
MS.perm[,i]<-anova(lm(Y.new~X1*X2))$"Mean Sq"}}

if(all(!is.na(X3))){
for(i in 1:perm){
Y.new<-sample(Y,replace=FALSE)
MS.perm[,i]<-anova(lm(Y.new~X1*X2*X3))$"Mean Sq"}}

F.perm <- matrix(nrow = r, ncol = perm)
for(i in 1:perm){
F.perm[,i] <- MS.perm[,i][1:r]/MS.perm[,i][r+1]
}
}

p1<-matrix(nrow=r,ncol=perm)
for(i in 1:r){
p1[i,]<-F.perm[i,]>=F.init[i]}

p2<-apply(p1,1,function(x){length(x[x==TRUE])})

p.val<-(p2+1)/perm
p.val<-ifelse(p.val>1,1,p.val)

if(all(is.na(X3))){
Table<-data.frame(Initial.F=init.model$"F value",Df = init.model$"Df",row.names=c("X1","X2","X1:X2","Residual"),pval=c(p.val,NA))}
if(all(!is.na(X3))){
Table<-data.frame(Initial.F=init.model$"F value",Df = init.model$"Df",row.names=c("X1","X2","X3","X1:X2","X1:X3","X2:X3","X1:X2:X3","Residual"),pval=c(p.val,NA))}
res<-list()
res$Table<-Table
res
}

selftest.corr.tck1 <-function(){
    options(guiToolkit="tcltk")
    w <- gwindow(title = "Correlation")
    size(w) <- c(700, 450)
    g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
 
    
    #------------- Question 1 -----------#
    
    gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
    gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
    q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
    font(q) <- list(weight = "bold")
    qq <- glabel("The value of a correlation coefficient ranges between ...", container = gp1.1, anchor = c(-1,1))
   # addSpace(gp1, 0)
    font(qq) <- list(family = "cambria", size = 11)
    
    
    ans1 <- c("(a)  0 and 1.",
              "(b)  -1 and 1.",
              "(c)  0 and \u221E.",
              "(d)  -\u221E and \u221E.")
    
    f1 <- function(h,....){
      if(tail(svalue(r1),1) == ans1[1]){
        gmessage(msg="Incorrect",  icon = "error")
      }
      if(tail(svalue(r1),1)== ans1[2]){
        gmessage(msg="Correct")
      }
      if(tail(svalue(r1),1)== ans1[3]){
        gmessage(msg="Incorrect", icon = "error")
      }
      if(tail(svalue(r1),1)== ans1[4]){
        gmessage(msg="Incorrect", icon = "error")
      }
      svalue(r1) <- character(0)
    }
    
    r1 <- gcheckboxgroup(ans1, container = gp1, where = "beginning", handler = f1)
    
   
    
    
    #------------- Question 2 -----------#
    
    gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
    gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
    q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
    font(q) <- list(weight = "bold")
    qq <- glabel("Anscombe's quartet demonstrates...", container = gp2.1, anchor = c(-1,1))
   # addSpace(gp2, .1)
    font(qq) <- list(family = "cambria", size = 11)
    
    ans2 <- c("(a)  that variances tend to increase with mean values.",
              "(b)  four ways to reject H\u2080 in correlation analysis.",
              "(c)  that dramatically different patterns of correlation can produce the same correlation estimate.",
              "(d)  the beauty of four part musical harmony.")

    f2 = function(h,....){
        if(tail(svalue(r2),1) == ans2[1]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r2),1)== ans2[2]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r2),1)== ans2[3]){
            gmessage(msg="Correct")
        }
        if(tail(svalue(r2),1)== ans2[4]){
            gmessage(msg="Incorrect.  Although four part harmonies can in fact be beautiful.", icon = "error")
        }
        svalue(r2) <- character(0)
    }
    
    r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
    
    
    
    #------------- Question 3 -----------#
    gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
    gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
    q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
    font(q) <- list(weight = "bold")
    qq <- glabel("If Cor(X,Y) = 0,...", container = gp3.1, anchor = c(-1,1))
  #  addSpace(gp3, .1)
    font(qq) <- list(family = "cambria", size = 11)
    
    
    ans3 <- c("(a)  then X and Y are independent.",
              "(b)  then X are Y dependent.",
              "(c)  then X and Y are independent only if X and Y have a biexponential distribution.",
              "(d)  then X and Y are independent only if X and Y have a bivariate normal distribution.")
    

    f3 = function(h,....){
        if(tail(svalue(r3),1) == ans3[1]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r3),1)== ans3[2]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r3),1)== ans3[3]){
            gmessage(msg="Correct",  icon = "error")
        }
        if(tail(svalue(r3),1)== ans3[4]){
            gmessage(msg="Correct")
        }
        svalue(r3) <- character(0)
    }
    
    r3 <- gcheckboxgroup(ans3, container = gp3, where = "beginning", handler = f3)
    
    
    #------------- Question 4 -----------#
    gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
    gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
    q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
    font(q) <- list(weight = "bold")
    qq <- glabel("If X and Y are independent, then...", container = gp4.1, anchor = c(-1,1))
  #  addSpace(gp4, .5)
    font(qq) <- list(family = "cambria", size = 11)
    
    
    ans4 <- c("(a)  Cor(X,Y) = 0.",
              "(b)  Cov(X,Y) = 0.",
              "(c)  f(x,y) = f(x)f(y).",
              "(d)  All of the above are true.",
              "(e)  It is impossible to determine Cor(X,Y), Cov(X,Y) or f(x)f(y) from the given information.")
    

    f4 = function(h,....){
        if(tail(svalue(r4),1) == ans4[1]){
            gmessage(msg="Partially correct",  icon = "error")
        }
        if(tail(svalue(r4),1)== ans4[2]){
            gmessage(msg="Partially correct",  icon = "error")
        }
        if(tail(svalue(r4),1)== ans4[3]){
            gmessage(msg="Partially correct",  icon = "error")
        }
        if(tail(svalue(r4),1)== ans4[4]){
            gmessage(msg="Correct")
        }
        if(tail(svalue(r4),1)== ans4[5]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        svalue(r4) <- character(0)
    }
    
    r4 <- gcheckboxgroup(ans4, container = gp4, where = "beginning", handler = f4)
    
    
    
    #------------- Question 5 -----------#
    gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
    gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
    q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
    font(q) <- list(weight = "bold")
    qq <- glabel("Let |r\u2096| be the absolute value of Kendall's tau, and let |r\u209B| be the absolute value of Spearman's \nrank correlation coefficient.  Then, for correlation measures of the same dataset...", container = gp5.1, anchor = c(-1,1))
    #addSpace(gp5, .1)
    font(qq) <- list(family = "cambria", size = 11)
    
    ans5 <- c("(a)  |r\u2096| = |r\u209B|.",
              "(b)  |r\u2096| > |r\u209B|, except in the case of perfect monotonicity.",
              "(c)  |r\u2096| < |r\u209B|, except in the case of perfect monotonicity.",
              "(d)  None of the above.")
    
    
    
   f5 = function(h,....){
        if(tail(svalue(r5),1) == ans5[1]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r5),1)== ans5[2]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        if(tail(svalue(r5),1)== ans5[3]){
            gmessage(msg="Correct")
        }
        if(tail(svalue(r5),1)== ans5[4]){
            gmessage(msg="Incorrect",  icon = "error")
        }
        svalue(r5) <- character(0)
   }
   
   r5 <- gcheckboxgroup(ans5, container = gp5, where = "beginning", handler = f5)
   
} 

anm.TM.tck<-function(){   



local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkcheckbutton <- ttkcheckbutton
        tkentry <- ttkentry
        tkframe <- ttkframe
        tklabel <- ttklabel
        tkradiobutton <- ttkradiobutton
    }
    tclServiceMode(FALSE)
    dialog <- function(){
        tt <- tktoplevel()
        tkwm.title(tt,"Matrix population models")
        a.entry <- tkentry(tt, textvariable=Av, width = 20)
        n.entry <- tkentry(tt, textvariable=nv, width = 20)
        int.entry <- tkentry(tt, textvariable=Int, width = 10) 
	      aint.entry <- tkentry(tt, textvariable=Aint, width = 10) 
    done <- tclVar(0)
	
        reset <- function()
          {
            tclvalue(Av)<-""
            tclvalue(nv)<-""
            tclvalue(Int)<-""
            tclvalue(Aint)<-"0.1"
          }
        
        reset.but <- tkbutton(tt, text="Reset", command=reset)
        submit.but <- tkbutton(tt, text="Submit",
                               command=function()tclvalue(done)<-1)

        build <- function()
        {
            a  <- parse(text=tclvalue(Av))[[1]]
            n  <- parse(text=tclvalue(nv))[[1]]
            inter <- tclvalue(Int)
            anim.interval <- tclvalue(Aint)
            substitute(anm.transM(a,n,inter=as.numeric(inter),anim.interval=as.numeric(anim.interval),xlab="Time intervals from present"))
        }
               
        tkgrid(tklabel(tt,text="Matrix population models"),columnspan=2)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="A",font=c("Helvetica","9","bold"),width=3), a.entry)
        tkgrid(tklabel(tt,text="n",font=c("Helvetica","9","bold"),width=3), n.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(tklabel(tt,text="Time ints. "), int.entry)
        tkgrid(tklabel(tt,text="Anim. int. "),aint.entry)
        tkgrid(tklabel(tt,text=""))
        tkgrid(submit.but,reset.but, sticky ="e")

        tkbind(tt, "<Destroy>", function()tclvalue(done)<-2)

        tkwait.variable(done)

        if(tclvalue(done)=="2") stop("aborted")

        tkdestroy(tt)
        cmd <- build()
        eval.parent(cmd)
    invisible(tclServiceMode(TRUE))
    }

    Av <- tclVar("matrix(nrow=3,ncol=3,data=c(.672,0,.561,0.018,0.849,0,0,0.138,0.969),byrow=TRUE)")
    nv <- tclVar("c(10,2,1)")
    Int <-tclVar("100")
    Aint <-tclVar("0.1") 
    dialog()
    })
    }

plotCI.reg<-function(x,y,conf=.95, CI = TRUE, PI = TRUE, resid = FALSE, reg.col = 1, CI.col=2, PI.col=4, reg.lty=1, CI.lty=2, PI.lty=3, reg.lwd=1, CI.lwd=1, resid.lty = 3, resid.col = 4, ...){
  lm.temp<-lm(y~x)
  CIm<-predict(lm.temp,level=conf,interval="conf")
  PIm<-suppressWarnings(predict(lm.temp,level=conf,interval="prediction"))
  min.max.Y<-c(min(y,PIm[,2]),max(y,PIm[,3]))
  plot(x,y,ylim = min.max.Y,...)
  abline(lm(y~x),lty=reg.lty,lwd=reg.lwd,col=reg.col)
  o<-order(x)
if(CI == TRUE){  
    lines(x[o],CIm[,2][o],col=CI.col,lty=CI.lty,lwd=CI.lwd)
    lines(x[o],CIm[,3][o],col=CI.col,lty=CI.lty,lwd=CI.lwd)}
if(PI == TRUE){
    lines(x[o],PIm[,2][o],col=PI.col,lty=PI.lty,lwd=CI.lwd)
    lines(x[o],PIm[,3][o],col=PI.col,lty=PI.lty,lwd=CI.lwd)}
    summary(lm.temp)
if(resid == TRUE){
    f <- fitted(lm.temp) 
    for(i in 1:length(y)){
    segments(x[i], y[i], x[i], f[i], lty = resid.lty, col = resid.col)
    }
    }
    res <- invisible(lm.temp)
    res
}

see.geo.tck<-function ()
{

    if (!exists("slider.env"))
  slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check

    p <- 0.5
    assign("p", tclVar(p), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir = slider.env)

    if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

     norm.refresh <- function(...) {
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax)
        yy <- dgeom(xx,p)
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        mtext(bquote(paste(italic(X), " ~ ", italic(GEO), "(", .(p), ")", sep = "")), line = 1, side = 3)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "GEO(\u03C0)")
    tkpack(tklabel(m,text="      Visualizing the Geometric Distribution      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03C0', font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)

 tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
    norm.refresh()
}


see.geocdf.tck<-function ()
{
#  old.par <- par(no.readonly = TRUE)
    if (!exists("slider.env"))
    slider.env <- NULL; suppressWarnings(rm(slider.env)); slider.env <<- new.env()# Dummy to trick R CMD check

    p <- 0.5
    assign("p", tclVar(p), envir = slider.env)
    xmin <- 0
    assign("xmin", tclVar(xmin), envir = slider.env)
    xmax <- 10
    assign("xmax", tclVar(xmax), envir = slider.env)


   dev.new(height=4,width=8,noRStudioGD = TRUE);par(mar=c(4.4,4.5,1,0.5),cex=.85, oma = c(0,0,1.5,0)); layout(matrix(c(1,2), 1, 2, byrow = TRUE))
   norm.refresh <- function(...) {
        p <- as.numeric(evalq(tclvalue(p), envir = slider.env))
        xmin <- as.numeric(evalq(tclvalue(xmin), envir = slider.env))
        xmax <- as.numeric(evalq(tclvalue(xmax), envir = slider.env))
        xx <- seq(xmin, xmax)
        yy <- dgeom(xx,p)
        y1 <- pgeom(xx,p)
        dev.hold()
        plot(xx, yy, type = "h", xlab=expression(italic(x)),ylab=expression(paste(italic(f),"(",italic(x),")", sep = "")))
        points(xx, yy, pch =19)
        plot(xx, y1, type = "n", xlab=expression(italic(x)),ylab=expression(paste(italic(F),"(",italic(x),")", sep = "")))
        points(xx, y1, pch =19)
        segments(xx, y1,xx+1,y1)
        points(xx+1, y1, pch =1)
        mtext(bquote(paste(italic(X), " ~ ", italic(GEO), "(", .(p), ")", sep = "")), outer = TRUE, side = 3, cex = .9)
        dev.flush()
                    }
    tclServiceMode(TRUE)
    m <- tktoplevel()
    tkwm.title(m, "GEO(\u03C0)")
    tkpack(tklabel(m,text="      Visualizing the Geometric Distribution      "))
    tkwm.geometry(m, "+0+0")

    tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = '\u03C0', font=c("Helvetica","9","italic"),width = "20"),
        side = "right")
    tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0.01,
        to = 1, orient = "horiz", resolution = 0.01, showvalue = TRUE),
        side = "left")
    assign("sc", sc, envir = slider.env)
    evalq(tkconfigure(sc, variable = p), envir = slider.env)

 tkpack(fr <- tkframe(m), side = "top")
    tkpack(tklabel(fr, text = "Xmin:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmin), envir = slider.env)
    tkpack(tklabel(fr, text = "Xmax:", width = 6), side = "left")
    tkpack(e <- tkentry(fr, width = 8), side = "left")
    assign("e", e, envir = slider.env)
    evalq(tkconfigure(e, textvariable = xmax), envir = slider.env)
    tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
        side = "left")
    tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
        side = "right")
#    on.exit(par(old.par))
    norm.refresh()
}

Kappa<-function(class1,reference){
t<-table(class1,reference)

##################################
##assymetric matrix?

##if necessary, create more columns
tc<-match(colnames(t),rownames(t))
mtc<-matrix(ncol=ncol(t),nrow=length(tc[tc=="NA"]),0)
nrn<-colnames(t)[is.na(tc)==TRUE]
rownames(mtc)<-nrn
t1<-rbind(t,mtc)

##if necessary, create more rows
tr<-match(rownames(t1),colnames(t1))
mtr<-matrix(nrow=nrow(t1),ncol=length(tr[tr=="NA"]),0)
ncn<-rownames(t1)[is.na(tr)==TRUE]
colnames(mtr)<-ncn
t2<-cbind(t1,mtr)

##line up classes
sr<-sort(rownames(t2))
mr<-match(sr,rownames(t2))
t3<-t(t2[mr,])
sc<-sort(rownames(t3))
mc<-match(sc,rownames(t3))
t4<-t(t3[mc,])

###################################
agree<-diag(t4)
prod1<-apply(t4,1,sum)
prod2<-agree/prod1
user1<-apply(t4,2,sum)
user2<-agree/user1
N<-sum(t4)
k1<-sum(agree)
k2<-sum(prod1*user1)
khat<-((N*k1)-k2)/(N^2-k2)
result<-list()
result$ttl_agreement<-(sum(diag(t4))/sum(t4))*100
result$user_accuracy<-round(user2*100,1)
result$producer_accuracy<-round(prod2*100,1)
result$khat<-round(khat*100,1)
result$table<-t
result
}

illusions<-function(ill.no=1) {
old.par <- par(no.readonly = TRUE)
if(ill.no==1){
#Illusion#1
par(mar = c(5,0,4,0))
plot(seq(1,10),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",main="Which line is longer?")
arrows(2.5,4,8.5,4,lwd=4)
arrows(8.5,4,2.5,4,lwd=4)
arrows(8.5,6,2.5,6,angle=140,lwd=4)
arrows(2.5,6,8.5,6,angle=140,lwd=4)
readline("Press return for next plot")
rect(1,1,2.5,10, col = "white", border = "white")
rect(8.5,1,10,10, col = "white", border = "white")
rect(2.5,1,8.5,5, col = "white", border = "white")
segments(2.5,4,8.5,4,lwd=4)
abline(v=c(2.5,8.5), col = "gray", lty = 2)
}
if(ill.no==2){
#Illusion#2
plot(seq(1,10),type="n",xaxt="n",yaxt="n",xlab="",ylab="",bty="n",main="Are the red lines straight?")
points(5,5,pch=8,cex=47,lwd=8)
segments(5,5,3,0,lwd=8)
segments(5,5,7,0,lwd=8)
segments(5,5,0,3,lwd=8)
segments(5,5,0,7,lwd=8)
segments(5,5,3,10,lwd=8)
segments(5,5,7,10,lwd=8)
segments(5,5,10,3,lwd=8)
segments(5,5,10,7,lwd=8)
segments(c(2,4,6,8),c(1,1,1,1),c(2,4,6,8),c(10,10,10,10),lwd=8,col="red")
}
if(ill.no==3){
#Illusion#3
op<-par(mar = c(0,0,0,0), bg = "black")
pn<-plot.new()
x = seq(0, 1, length = 10)
y = seq(0, 1, length = 10)
abline(v = x, h = y, col = "gray", lwd = 6)
points(rep(x, each=10), rep(y, 10), col = "white", 
cex = 3, pch = 20)
par(op)
print("Code for this illusion follow from Yihui Xie's package animation")
}
on.exit(par(old.par))
}

see.move<-function(){
local({
    have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
    if(have_ttk) {
        tkbutton <- ttkbutton
        tkframe <- ttkframe
        tklabel <- ttklabel
    }
    
    tclServiceMode(FALSE) 
    top <- tktoplevel()
    tktitle(top) <- "Demonstration of Least Squares Regression -- Move points"
 

    buttons <- tkframe(top)
    tkpack(buttons, side="bottom", fill="x", pady="2m")
    dismiss <- tkbutton(buttons, text="Exit",
                        command=function()tkdestroy(top))
    tkpack(dismiss, side="right", expand=TRUE)
    
    canvas <- tkcanvas(top, relief="raised", width=550, height=350)
    tkpack(canvas, side="top", fill="x")

    plotFont <- "Helvetica 9"
    plotFont2 <- "Helvetica 11"
    

    tkcreate(canvas, "polygon", 100, 50, 100, 250, 400, 250, 400, 50, width=0, fill = "white")
    tkcreate(canvas, "line", 100, 250, 400, 250, width=2)
    tkcreate(canvas, "line", 100, 250, 100, 50, width=2)
    tkcreate(canvas, "text", 275, 20, text="Moving points in simple linear regression",
             font=plotFont2)
    tkcreate(canvas, "text", 250, 290, text="x",
             font=c("Helvetica", "11","italic"))
    tkcreate(canvas, "text", 30, 150, text="y",
             font=c("Helvetica", "11","italic"))
             
     tkcreate(canvas, "polygon", 430, 60, 430, 180, 530, 180, 530, 60, width=2, fill = "white")

    # X tickmarks & labels; from x = 100 to 400 
        for (i in 0:10) {
        x <- 100 + i * 30
        tkcreate(canvas, "line", x, 250, x, 245, width=2)
        tkcreate(canvas, "text", x, 254,
                 text=10*i, anchor="n", font=plotFont)
    }
    # Y tickmarks & labels; from y = 50 to 250
    for (i in 0:5) {
        y <- 250 - i * 40
        tkcreate(canvas, "line", 100, y, 105, y, width=2)
        tkcreate(canvas, "text", 96, y,
                 text=formatC(50*i,format="f",digits=1),
                 anchor="e", font=plotFont)
    }

    # The (original) data
    points <- matrix(c(12, 56,
                       20, 94,
                       33, 98,
                       32, 120,
                       61, 180,
                       75, 160,
                       98, 223), ncol=2, byrow=TRUE)

    ## `self-drawing' point object
    point.items <- apply(points, 1, function(row) {
        x <- 100 + 3 * row[1]
        y <- 250 - 4/5 * row[2]
        item <- tkcreate(canvas, "oval", x - 5, y - 5, x + 5, y + 5,
                         width=1, outline="black",
                         fill="SkyBlue2")
        tkaddtag(canvas, "point", "withtag", item)
        item
    })

    plotDown <- function(x, y) {
      ## Arguments:
      ## x, y -	The coordinates of the mouse press.
      x <- as.numeric(x)
      y <- as.numeric(y)
      tkdtag(canvas, "selected")
      tkaddtag(canvas, "selected", "withtag", "current")
      tkitemraise(canvas,"current")
      lastX <<- x
      lastY <<- y
    }

    plotMove <- function(x, y) {
        ## Arguments:
        ## x, y -	The coordinates of the mouse.
        x <- as.numeric(x)
        y <- as.numeric(y)
        tkmove(canvas, "selected", x - lastX, y - lastY)
        lastX <<- x
        lastY <<- y
    }

    step1 <- function(){lapply(point.items,
                         function(item)
                         as.double(tkcoords(canvas,item)))}
    
    plotLine <- function(){
        coords <-step1()
        x <- sapply(coords, function(z) (z[1]+z[3])/2)
        y <- sapply(coords, function(z) (z[2]+z[4])/2)
        lm.out <- lm(y~x)
        x0 <- range(x)
        y0 <- predict(lm.out, data.frame(x=x0))
        tkcreate(canvas, "line", x0[1], y0[1], x0[2], y0[2], width=3)
        
    }

    line <- plotLine()

    slope.func<-function(){
    coords <-step1()
        x <- sapply(coords, function(z) (z[1]+z[3])/2)
        x <- (x-100)/3
        y <- sapply(coords, function(z) (z[2]+z[4])/2)
        y <- -1*(y-250)*5/4
        lm.out<-lm(y~x)
        slope<-lm.out$coefficients[2]
        tkcreate(canvas, "text", 500, 80, text=formatC(slope,format="f",digits=2),
             font=plotFont)      
        }
    
    slope<-slope.func()    
    
    pre.func0 <- function(){
     tkcreate(canvas, "text", 460, 80, text= "Slope = ",
             font=plotFont)}
             
    pre0 <-pre.func0()
    
    yint.func<-function(){
    coords <-step1()
        x <- sapply(coords, function(z) (z[1]+z[3])/2)
        x <- (x-100)/3
        y <- sapply(coords, function(z) (z[2]+z[4])/2)
        y <- -1*(y-250)*5/4
        lm.out<-lm(y~x)
        yint<-lm.out$coefficients[1]
        tkcreate(canvas, "text", 505, 105, text=formatC(yint,format="f",digits=2),
             font=plotFont)      
        }
    
    yint<-yint.func()    
    
    pre.func01 <- function(){
     tkcreate(canvas, "text", 460, 105, text= "Y int. = ",
             font=plotFont)}
             
    pre01 <-pre.func01()
    
    
    r.func <-function(){
        coords <-step1()
        x <- sapply(coords, function(z) (z[1]+z[3])/2)
        y <- sapply(coords, function(z) (z[2]+z[4])/2)
        r<-round(cor(y,x),2)
        tkcreate(canvas, "text", 485, 140, text=formatC(-1*r,format="f",digits=2),
             font=plotFont)
               }
    
    r <-r.func()
     
    pre.func1 <- function(){
     tkcreate(canvas, "text", 460, 140, text= "r = ",
             font=plotFont)}
     
    pre1 <-pre.func1() 
        
    r2.func <-function(){
        coords <-step1()
        x <- sapply(coords, function(z) (z[1]+z[3])/2)
        y <- sapply(coords, function(z) (z[2]+z[4])/2)
        r<-round(cor(y,x),2)
        tkcreate(canvas, "text", 485, 165, text=formatC(r*r,format="f",digits=2),
             font=plotFont)
              }
    
     r2 <-r2.func()
    
     pre.func2 <- function(){
     tkcreate(canvas, "text", 460, 165, text= 'r\u00b2 = ',
             font=plotFont)}
     
    pre2 <-pre.func2() 
    
    lastX <- 0
    lastY <- 0

    tkitembind(canvas, "point", "<Any-Enter>",
               function() tkitemconfigure(canvas, "current",
                                          fill="red"))
    tkitembind(canvas, "point", "<Any-Leave>",
               function() tkitemconfigure(canvas, "current",
                                          fill="SkyBlue2"))
    tkitembind(canvas, "point", "<1>", plotDown)
    tkitembind(canvas, "point", "<ButtonRelease-1>",
               function(x){
                   tkdtag(canvas, "selected")
                   tkdelete(canvas, "withtag", line)
                   tkdelete(canvas, "withtag", slope)
                   tkdelete(canvas, "withtag", yint)
                   tkdelete(canvas, "withtag", r)
                   tkdelete(canvas, "withtag", r2)
                   tkdelete(canvas, "withtag", pre0)
                   tkdelete(canvas, "withtag", pre01)
                   tkdelete(canvas, "withtag", pre1)
                   tkdelete(canvas, "withtag", pre2)
                   
                   line <<- plotLine()
                   slope <<- slope.func()
                   yint <<- yint.func()
                   pre0 <<- pre.func0()
                   pre01 <<- pre.func01()
                   r <<- r.func()
                   r2 <<- r2.func()
                   pre1 <<- pre.func1()
                   pre2 <<- pre.func2()
                      })
    tkbind(canvas, "<B1-Motion>", plotMove)
    tclServiceMode(TRUE)
})
}


    

transM<-function(A,init,inter=100,stage.names =c("All grps",1:(ncol(A))),leg.room = 1.5,...){
m<-matrix(nrow=ncol(A),ncol=inter)
m[,1]<-init

for (i in 2:inter){
m[,i]<-A%*%m[,i-1]
}

n<-apply(m,2,sum)
plot(seq(1,inter),n,type="n",ylim=c(0,max(n)*leg.room),...)
lines(seq(1,inter),n,col=1,lwd=3)
for(i in 1:ncol(A))
lines(seq(1,inter),m[i,],col=i+1)
res<-matrix(nrow=3,ncol=inter,data=apply(m,2,function(x){x/sum (x)}),dimnames=list(stage.names[-1],seq(1,inter)))
legend("topright",legend=stage.names,lwd=c(3,rep(1,ncol(A))),col=seq(1,(ncol(A)+1)))
res
}

km <- function (r, d, var = "O", conf = 0.95, age.seq = seq(1, length(r)), 
  ylab = "Survivorship", xlab = "Age class", type = "b", plot.km = TRUE, plot.CI = TRUE, ...) 
{
  step <- (1 - (d/r))
  s.hat <- matrix(nrow = length(r), ncol = 1)
  s.hat[1] <- step[1]
  for (i in 2:length(r)) {
    s.hat[i] <- s.hat[i - 1] * step[i]
  }
  Green.Sum <- matrix(nrow = length(r), ncol = 1)
  Green.Var <- matrix(nrow = length(r), ncol = 1)
  for (i in 1:length(r)) {
    Green.Var[1] <- 0
    Green.Sum[1] <- d[1]/(r[1] * (r[1] - d[1]))
    Green.Sum[i + 1] <- d[i + 1]/(r[i + 1] * (r[i + 1] - 
      d[i + 1])) + Green.Sum[i]
    Green.Var[i + 1] <- s.hat[i + 1]^2 * Green.Sum[i + 1]
    Green.Var <- Green.Var[-(length(r) + 1)]
  }
  Oakes.Var <- (s.hat^2 * (1 - s.hat)/r)
  if (var == "O") {
    C.L <- s.hat - qnorm(1 - ((1 - conf)/2)) * ((Oakes.Var)^0.5)
    C.U <- s.hat + qnorm(1 - ((1 - conf)/2)) * ((Oakes.Var)^0.5)
  }
  if (var == "G") {
    C.L <- s.hat - qnorm(1 - ((1 - conf)/2)) * ((Green.Var)^0.5)
    C.U <- s.hat + qnorm(1 - ((1 - conf)/2)) * ((Green.Var)^0.5)
  }
  if(plot.km){
  plot(age.seq, s.hat, type = type, xlab = xlab, ylab = ylab, 
    ...)
  if(plot.CI){
  lines(age.seq, C.L, lty = 2)
  lines(age.seq, C.U, lty = 2)
  }
  }      
  res <- list()
  res$s.hat <- s.hat
  res$Greenwood.Var <- Green.Var
  res$Oakes.Var <- Oakes.Var
  res$CI <- cbind(C.L, C.U)
  res
}

pairw.oneway<-function(y,x,conf=.95,digits = 5, method = "holm"){
  fitted <- tapply(y, factor(x), mean)#calculates factor level means
  nis <- tapply(y, factor(x), length)#calculates number of observations
  var <- tapply(y, factor(x), var)#calculates variance
  r <- length(fitted) #number of levels
  se.mat<- outer(var/nis, var/nis,"+")
  ses <- sqrt(se.mat[upper.tri(se.mat)]) #eliminates redundant standard errors
  dif.mat <- outer(fitted, fitted, "-") #all possible differences of means
  diffs <- dif.mat[upper.tri(dif.mat)] #eliminates redundant differences
  t.star <- diffs/ses #calculates test statistics 
  num.mat <- outer(var/nis, var/nis,"+")^2
  den.mat <- outer((var/nis)^2/(nis-1), (var/nis)^2/(nis-1),"+")
  nums <- num.mat[upper.tri(num.mat)]
  dens <- den.mat[upper.tri(den.mat)]
  nu <- nums/dens
  pvals <- pt(abs(t.star),nu,lower.tail = FALSE)*2
  getlvl <- levels(x)
  lvl <- outer(getlvl, getlvl, function(x,y)paste(x,y,sep = "-"))
  
  holm<-p.adjust(pvals, method = method)
  
  
  Decision <- ifelse(holm < 1-conf, "Reject H0", "FTR H0")
  hwidths <- qt(1-(1-conf)/2,nu) * ses
  if(method == "bonferroni") hwidths <- qt(1-(1-conf)/(2 * r),nu) * ses
  val <- round(cbind(diffs, diffs - hwidths, diffs + hwidths), 
               digits)
  val <- as.data.frame(cbind(val, Decision, signif(holm,digits)))
  lvl <- outer(levels(x), levels(x), function(x1, x2) {
    paste(paste("mu", x1, sep = ""), paste("mu", x2, sep = ""), 
          sep = "-")
  })
  dimnames(val) <- list(lvl[upper.tri(lvl)], c("Diff", "Lower", 
                                               "Upper", "Decision", "Adj. p-value"))
  head <- paste(paste(as.character(conf * 100), "%", 
                      sep = ""), c("Welch adjusted confidence intervals"))
  res <- list()
  res$head <- head
  res$conf <- conf
  comp <- outer(levels(x), levels(x), function(x1, x2) {
    paste(x1, x2, sep = "-")
  })
  res$comp <- comp[upper.tri(comp)]
  res$summary <- val
  res$band <- cbind(diffs - hwidths, diffs + hwidths)
  res$fitted <- fitted
  res$x <- x
  res$y <- y
  res$method <- paste("Welch","/",method)
  class(res) <- "pairw"
  res
}

selftest.ANVOVA_design.tck <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "ANOVA experimental designs")
  size(w) <- c(700, 670)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)
  
  
  #------------- Question 1 -----------#
  OS <- Sys.info()[['sysname']]
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have six experimental units (EUs) randomly assigned to two treatments \n(A\u2081 and A\u2082).  What is the experimental design?", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  gp1.1a <- getWidget(gp1)
  img <- tkrplot::tkrplot(gp1.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("CRD",n = 6, cex.text = ifelse(OS == "Linux",1,.85),titles = FALSE)
  }
  )
  add(gp1, img, horizontal=TRUE)

  ans1 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  
  
  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Correct.  The CRD is the simplest experimental design.  \nNote that no blocking, splitting or nesting occurs.")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
  
  
  
  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two factors A and B, each with two factor levels, randomly assigned \nwithin four blocks. What is the experimental design?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  gp2.1a <- getToolkitWidget(gp2)
  img <- tkrplot::tkrplot(gp2.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("SPRB",cex.text = ifelse(OS == "Linux",1,.85),titles = FALSE)
  }
  )
  add(gp2, img, horizontal=TRUE)
  ans2 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect",,  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Correct.  Specifically, this is a split-plot design in randomized blocks (RBSP). Note that the blocks comprise a replicate for the whole plot (factor A) factor levels. The RBSP design is the most common split plot design.")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two factors A and B, each with two factor levels, randomly assigned to \nfour experimental units. What is the experimental design?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp3.1a <- getToolkitWidget(gp3)
  img <- tkrplot::tkrplot(gp3.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("factorial2by2",cex.text = ifelse(OS == "Linux",1,.95),titles = FALSE)
  }
  )
  add(gp3, img, horizontal=TRUE)
  ans3 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  

  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Correct.  Note that the design here is balanced but unreplicated (each of the four factor level combinations has only one replicate).  ")
    }
    if(tail(svalue(r3),1)== ans3[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have two treatments (A\u2081 and A\u2082), randomly assigned within two blocks. \nWhat is the experimental design?", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp4.1a <- getToolkitWidget(gp4)
  img <- tkrplot::tkrplot(gp4.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("RCBD",cex.text = ifelse(OS == "Linux",1,.85),titles = FALSE)
  }
  )
  add(gp4, img, horizontal=TRUE)

    ans4 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  
 f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Correct.  Note that treatments are assigned exactly once within each block.")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[6]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r4) <- character(0)
 }
 
 r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)
 
  
  
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the design below we have three experimental units randomly assigned to each of two treatments \n(A\u2081 and A\u2082). What is the experimental design?", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  gp5.1a <- getToolkitWidget(gp5)
  img <- tkrplot::tkrplot(gp5.1a, function(){ 
    par(bg = "white", mar = c(1,1,1,1))
    ExpDesign("pairs",cex.text = ifelse(OS == "Linux",1,.95),titles = FALSE)
  }
  )
  add(gp5, img, horizontal=TRUE)

    ans5 <- c("(a) randomized complete block design (RCBD).",
            "(b) completely randomized design (CRD).",
            "(c) split-plot design.",
            "(d) 2 x 2 factorial.",
            "(e) nested design.",
            "(f) matched pairs design (repeated measures)."
  )
  
  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[5]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[6]){
      gmessage(msg="Correct.  Note that each EU receives both treatments, but that the order in which the EUs receive treatments is randomized.")
    }
    svalue(r5) <- character(0)
  }
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)
  
  
  
}

selftest.comb.tck <- function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Combinatorics")
  size(w) <- c(700, 600)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)



  #------------- Question 1 -----------#

  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The binomial coefficeint, i.e., n choose r, is equivelent to:", container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans1 <- c("(a)     n!/(n-r)!",
            "(b)     r!/[n!(n-r)]!",
            "(c)     n!/[r!(n-r)]!",
            "(d)     n!/r!")


  f1 <- function(h,....){
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Incorrect.  This describes Boole's inequality.", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r1),1)== ans1[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r1),1)== ans1[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r1) <- character(0)
  }

  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)


  #------------- Question 2 -----------#

  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("How many ''permutations'' are possible for five distinguishible objects?", container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans2 <- c("(a)     120",
            "(b)     150",
            "(c)     10",
            "(d)     5")


  f2 <- function(h,....){
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Correct.  This is is equivelent to 5!.")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r2) <- character(0)
  }

  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)


  #------------- Question 3 -----------#

  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a plant growth experiment, I have three watering treatments and two nutrient treatments.\nHow many total treatment combinations do I have?", container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans3 <- c("(a)     5",
            "(b)     2",
            "(c)     6",
            "(d)     Impossible to say.")


  f3 <- function(h,....){
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r3) <- character(0)
  }

  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)

  #------------- Question 4 -----------#

  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("5 choose 3 = ", container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans4 <- c("(a)     10",
             "(b)     5",
             "(c)     3",
             "(d)     1")


  f4 <- function(h,....){
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r4) <- character(0)
  }

  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)




  #------------- Question 5 -----------#

  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("0! = ", container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)

  ans5 <- c("(a)     0",
             "(b)     1",
             "(c)     2",
             "(d)     3")


  f5 <- function(h,....){
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect", icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    svalue(r5) <- character(0)
  }

  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)

}

loglik.exp.plot <- function (X, poss = NULL, plot.likfunc = TRUE, plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL, conv = 0.01,
    anim = TRUE, est.col = 2, density.leg = TRUE, cex.leg = 0.9, interval = 0.01, ...)
{
    old.par <- par(no.readonly = TRUE)
    possibilities <- poss
    if (is.null(poss)) {
        possibilities <- seq(conv, mean(X) + (sd(X) * 2), min(conv,
            0.01))
        logl <- possibilities
    }
    if (!is.null(poss))
        possibilities <- poss[poss != 0]
    logl <- possibilities
    for (i in 1:length(possibilities)) {
        logl[i] <- log(prod(dexp(X, 1/possibilities[i])))
    }
    max.p <- ifelse(is.null(poss), mean(X), possibilities[logl ==
        max(logl)][1])
    MLE <- mean(X)
    Max.lik <- log(prod(dexp(X, 1/mean(X))))
    if (anim == FALSE) {
        if (plot.likfunc == TRUE & plot.density == TRUE) {
            dev.new(height = 4, width = 8)
            par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)
            layout(matrix(c(1, 2), 1, 2, byrow = TRUE))
        }
        if (plot.likfunc == TRUE) {
            plot(possibilities, logl, type = "l", ylab = ifelse(is.null(ylab),
                "Exponential Log-likelihood function", ylab),
                xlab = ifelse(is.null(xlab), expression(paste("Estimates for ",
                  theta)), xlab), ...)
            legend("topright", legend = bquote(paste("ML est. = ",
                .(MLE))), cex = cex.leg, bty = "n")
            abline(v = mean(X), lty = 2, col = est.col)
        }
        if (plot.density == TRUE) {
            x <- NULL
            rm(x)
            curve(dexp(x, 1/mean(X)), from = min(X), to = max(X),
                xlab = expression(italic(x)), ylab = expression(paste(italic(f),
                  "(", italic(x), ")", sep = "")))
            legend("topright", legend = c(paste("X~EXP(1/", bquote(.(round(mean(X),
                3))), ")", sep = ""), paste("Loglik = ", bquote(.(round(Max.lik,
                2))))), bty = "n", cex = cex.leg)
            if(density.leg == TRUE)
            {legend("topleft", col = est.col, lty = 2, legend = "Obs. density",
                bty = "n", cex = cex.leg)}
            segments(X, rep(0, length(X)), X, dexp(X, 1/mean(X)),
                lty = 2, col = est.col)
        }
    }
    if (anim == TRUE) {
        nm <- which(logl == max(logl))[1]
        if (plot.likfunc == TRUE & plot.density == TRUE){
        dev.new(height = 4, width = 8, noRStudioGD = TRUE)
        par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)}
        if ((plot.likfunc == TRUE & plot.density == FALSE)||
        (plot.likfunc == FALSE & plot.density == TRUE)){dev.new(noRStudioGD = TRUE)}

        for (i in 1:(nm - 1)) {
            dev.hold()
            if (plot.likfunc == TRUE) {
                plot(possibilities, logl, type = "n", ylab = ifelse(is.null(ylab),
                  "Exponential Log-likelihood function", ylab),
                  xlab = ifelse(is.null(xlab), expression(paste("Estimates for ",
                    theta)), xlab), ...)
                arrows(possibilities[i], logl[i], possibilities[i +
                  1], logl[i + 1], col = est.col, length = 0.15, lwd = 1)
                points(possibilities[1:i], logl[1:i], lty = 2,
                  col = est.col, lwd = 1, type = "l")
                if (i == (nm - 1)) {
                  points(possibilities, logl, type = "l")
                  abline(v = mean(X), lty = 2, col = est.col)
                  legend("topright", legend = bquote(paste("ML est. = ",
                    .(MLE))), cex = cex.leg, bty = "n")
                }
            }
            if (plot.density == TRUE) {
                x <- NULL
                rm(x)
                curve(dexp(x, 1/possibilities[i]), from = min(X),
                  to = max(X), xlab = expression(italic(x)),
                  ylab = expression(paste(italic(f), "(", italic(x),
                    ")", sep = "")))
                segments(x0 = X, y0 = rep(0, length(X)), x1 = X,
                  y1 = dexp(X, 1/possibilities[i]), col = est.col,
                  lty = 2)
                if (i != (nm - 1)) {
                  legend("topright", legend = c(as.expression(bquote(paste(theta,
                    " = ", .(round(possibilities[i], 2))))),
                    as.expression(bquote(paste("Loglik = ", .(round(logl[i],
                      2)))))), bty = "n", cex = cex.leg)
                }
                if (i == (nm - 1)) {
                  legend("topright", legend = c(as.expression(bquote(paste(theta,
                    " = ", .(MLE)))), as.expression(bquote(paste("Loglik = ",
                    .(round(Max.lik, 2)))))), bty = "n", cex = cex.leg)
                }
            }
            dev.flush()
            Sys.sleep(interval)
        }
        if (plot.calc == TRUE) {
            dev.new(width = 4, height = 4, ypos = 225)
            par(mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)
            X <- sort(X)
            c <- ifelse(length(X) < 200, round(200/length(X),
                0), 1)
            x0 = rep(X, each = c)
            y0 = rep(rep(0, length(X)), each = c)
            y1 = rep(dexp(X, 1/mean(X)), each = c)
            loglik <- log(dexp(X, 1/mean(X)))
            cumlik <- rep(cumsum(loglik), each = c)
            for (i in 1:(length(X) * c)) {
                dev.hold()
                x <- NULL
                rm(x)
                curve(dexp(x, 1/mean(X)), from = min(X), to = max(X),
                  xlab = "x", ylab = "f(x)")
                if(density.leg == TRUE){
                legend("topleft", col = 2, lty = 2, legend = "Obs. density",
                  bty = "n", cex = cex.leg)}
                legend("topright", legend = c(paste("X~EXP(1/",
                  bquote(.(round(mean(X), 4))), ")"), paste("Loglik = ",
                  bquote(.(round(cumlik[i], 2))))), bty = "n",
                  cex = cex.leg)
                segments(x0[1:i], y0[1:i], x0[1:i], y1[1:i],
                  col = est.col, lty = 2)
                dev.flush()
                Sys.sleep(interval)
            }
        }
    }
on.exit(par(old.par))
}

anm.mc.norm <- function(start = -4, mu = 0, sigma = 1, length = 2000, sim = "M", jump.kernel = 0.2, xlim = c(-4, 4), ylim = c(0, 0.4), interval = 0.01, show.leg = TRUE, ...)
{
x<-seq(-4, 4, .05)
dev.new(xpos = -750, noRStudioGD = TRUE)
curve(dnorm(x, mu, sigma), xlim = xlim, xlab = "x", ylab = "f(x)", main = "Underlying distribution")
dev.new(noRStudioGD = TRUE)

if(sim == "M") method = "Metropolis"; if(sim == "MH") method = "Metropolis-Hastings"

q.x <- matrix(ncol = 1, nrow = length)
q.x[1] <- start

if(sim == "M")
{
    for( i in 2 : length)
        {
        new <- rnorm(1, q.x[i - 1], sigma * (jump.kernel^2))
        dold <- dnorm(q.x[i - 1], mu, sigma)
        dnew <- dnorm(new, mu, sigma)
        r <- dnew/dold
        p <- min(r, 1)
        s <- sample(c(1, 2), 1, prob = c(p, 1 - p))
        if(s == 1)q.x[i] = new
        if(s == 2)q.x[i] = q.x[i - 1]
        }
}

if(sim == "MH")
{

    for( i in 2 : length)
        {
        new <- rnorm(1, q.x[i - 1], sigma * (jump.kernel^2))
        dold <- dnorm(q.x[i - 1], mu, sigma)
        djump.old <- dnorm(q.x[i - 1], q.x[i - 1], sigma)
        dnew <- dnorm(new, mu, sigma)
        djump.new <- dnorm(new, new, sigma)
        r <- (dnew/djump.new)/(dold/djump.old)
        p <- min(r, 1)
        s <- sample(c(1, 2), 1, prob = c(p, 1 - p))
        if(s == 1)q.x[i] = new
        if(s == 2)q.x[i] = q.x[i - 1]
        }
}

dens <- dnorm(q.x, mu, sigma)

    for( i in 1 : length)
        {
        dev.hold()
        plot(q.x[seq(1 : i)], dens[seq(1 : i)], xlim = xlim, ylim = ylim, xlab = "x", ylab = "f(x)", type = "l", col = "gray", main = paste("MCMC walk, method = ", method))
        points(q.x[seq(1 : i)], dens[seq(1 : i)], pch = 19, cex = .5)
        points(q.x[i], dens[i], pch = 19, cex = 1.5)
        legend("topleft", bty = "n", legend = c("Length = ", i))
        dev.flush()
        Sys.sleep(interval)
        }
}




anm.mc.bvn <- function(start = c(-4, -4), mu = c(0, 0), sigma = matrix(2, 2, data = c(1, 0, 0, 1)), length = 1000, sim = "M", jump.kernel = 0.2, xlim = c(-4, 4), ylim = c(-4, 4), interval = 0.01, show.leg = TRUE, cex.leg = 1,...)
{


x<-seq(-4, 4, .05)
g<-expand.grid(x, x)
p<-dmvnorm(g, mu, sigma)
dev.new(xpos = -750)
old.par <- par(no.readonly = TRUE)
par(mar=c(5,4.5,3,2))

plot(g, type = "p", col = gray(1-(p/max(p))), xlab = expression(italic(X)[1]), ylab = expression(italic(X)[2]), main = "Underlying BVN distribution",...)
dev.new()
par(mar=c(5,4.5,3,2))

if(sim == "M") method = "Metropolis"; if(sim == "MH") method = "Metropolis-Hastings"; if(sim == "G") method = "Gibbs"

q.x <- matrix(ncol = 2, nrow = length)
q.x[1,] <- start

if(sim == "G")
{
x <- y <- matrix(ncol = 1, nrow = length)
x[1] <- start[1]
y[1] <- start[2]
rho <- sigma[3]
    for( i in 2 : length)
        {
        x[i] <- rnorm(1, mu[1] + rho * y[i - 1], sd = 1 - rho^2)
        y[i] <- rnorm(1, mu[2] + rho * x[i], sd = 1 - rho^2)
        }
        q.x <- cbind(x, y)
}


if(sim == "M")
{
    for( i in 2 : length)
        {
        x <- rmvnorm(1, q.x[i - 1,], sigma * (jump.kernel^2))
        dold <- dmvnorm(q.x[i - 1,], mu, sigma)
        dnew <- dmvnorm(x, mu, sigma)
        r <- dnew/dold
        p <- min(1, r)
        s <- sample(c(1, 2), 1, prob = c(p, 1 - p))
        if(s == 1)q.x[i,] = x
        if(s == 2)q.x[i,] = q.x[i - 1,]
        }
}


if(sim == "MH")
{
    for( i in 2 : length)
        {
        x <- rmvnorm(1, q.x[i - 1,], sigma * (jump.kernel^2))
        dold <- dmvnorm(q.x[i - 1,], mu, sigma)
        djump.old <- dmvnorm(q.x[i - 1,], q.x[i - 1,], sigma)
        dnew <- dmvnorm(x, mu, sigma)
        djump.new <- dmvnorm(x, x, sigma)
        r <- (dnew/djump.new)/(dold/djump.old)
        p <- min(r, 1)
        s <- sample(c(1, 2), 1, prob = c(p, 1 - p))
        if(s == 1)q.x[i,] = x
        if(s == 2)q.x[i,] = q.x[i - 1,]
        }
}

    for( i in 1 : length)
        {
        dev.hold()
        plot(q.x[seq(1 : i),], xlim = xlim, ylim = ylim, xlab = expression(italic(X)[1]), ylab = expression(italic(X)[2]), type = "l", col = "gray", main = paste("MCMC walk, method = ", method),...)
        points(q.x[,1][seq(1 : i)], q.x[,2][seq(1 : i)], pch = 19, cex = .5)
        points(q.x[i,][1], q.x[i,][2], pch = 19, cex = 1.5)
        density <- dmvnorm(q.x[i,], mu, sigma)
        #legend("topright", bty = "n", inset = 0.1, legend = c("f(x1,x2) = ", density))
        if(show.leg) legend("topleft", bty = "n", legend = c("Length = ", i), cex = cex.leg)
        dev.flush()
        Sys.sleep(interval)
        }
on.exit(par(old.par))
}

ci.strat<-function(data,strat,N.h,conf=.95,summarized=FALSE,use.t=FALSE,n.h=NULL,x.bar.h=NULL,var.h=NULL){
N<-sum(N.h)
k<-nrow(as.matrix(N.h))
  if(summarized==FALSE){
    var.h<-tapply(data,strat,function(x){var(x,na.rm=TRUE)})
    x.bar.h<-tapply(data,strat, function(x){mean(x,na.rm=TRUE)})
    n.h<-summary(as.factor(strat))
  }
S.xbar.str<-sqrt(sum((1-(n.h/N.h))*((N.h/N)^2)*(var.h/n.h)))
S.T.hat<-sqrt(sum((1-(n.h/N.h))*N.h^2*(var.h/n.h)))
T.hat<-sum(N.h*x.bar.h)
x.bar.str<-T.hat/N
  if(use.t==FALSE){
    z.star<-qnorm(1-((1-conf)/2))
    CI.mu<-as.matrix(c(x.bar.str,x.bar.str-z.star*S.xbar.str, x.bar.str+z.star* S.xbar.str))
    CI.T<-as.matrix(c(T.hat,T.hat-z.star* S.T.hat, T.hat+z.star* S.T.hat))
  }
  if(use.t==TRUE){
    t.star<-qt(1-((1-conf)/2),df=(sum(n.h)-k))
    CI.mu<-as.matrix(c(x.bar.str,x.bar.str-t.star*S.xbar.str, x.bar.str+t.star* S.xbar.str))
    CI.T<-as.matrix(c(T.hat,T.hat-t.star* S.T.hat, T.hat+t.star* S.T.hat))
  }
  
result<-list()
ends<-c((1-conf)/2,1-((1-conf)/2))*100
rownames(CI.mu)<-c("estimate",paste(ends[1],"%"),paste(ends[2],"%"))
rownames(CI.T)<-c("estimate",paste(ends[1],"%"),paste(ends[2],"%"))
CI<-cbind(CI.mu,CI.T)
colnames(CI)<-c("CI.mu","CI.T")
strat.summary=as.matrix(cbind(N.h,n.h,x.bar.h,var.h))
rownames(strat.summary)<-levels(strat)
result<-list(strat.summary=strat.summary,CI=t(CI))
result
}

see.disc.unif.tck <-function ()
{

  if (!exists("slider.env"))
    slider.env <- NULL
  suppressWarnings(rm(slider.env))
  slider.env <<- new.env()
  a <- 0
  b <- 10

  assign("a", tclVar(a), envir = slider.env)
  assign("b", tclVar(b), envir = slider.env)

  if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

  if(names(dev.cur()) == "RStudioGD") dev.new(noRStudioGD = TRUE)

  norm.refresh <- function(...) {
    a <- as.numeric(evalq(tclvalue(a), envir = slider.env))
    b <- as.numeric(evalq(tclvalue(b), envir = slider.env))
    xx <- seq(a,b,1)
    n <- length(xx)
    ddunif <- function(n){rep(1/n, n)}
    yy <- ddunif(n)
    plot(xx, yy, type = "h", xlab = expression(italic(x)),
         ylab = expression(paste(italic(f), "(", italic(x),
                                 ")", sep = "")))
    points(xx, yy, pch = 19)
    mtext(bquote(paste(italic(X), " ~ ", italic(DUNIF), "(",
                       .(a), ", ", .(b), ")", sep = "")), line = 1, side = 3)
    dev.flush()
  }
  tclServiceMode(TRUE)
  m <- tktoplevel()
  tkwm.title(m, "DUNIF(a, b)")
  tkpack(tklabel(m, text = "      Visualizing the Discrete Uniform Distribution      "))
  tkwm.geometry(m, "+0+0")
  tkpack(fr <- tkframe(m), side = "top")
  tkpack(tklabel(fr, text = "a", font = c("Helvetica", "9",
                                          "italic"), width = "20"), side = "right")
  tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
                       to = 5, orient = "horiz", resolution = 1, showvalue = TRUE),
         side = "left")
  assign("sc", sc, envir = slider.env)
  evalq(tkconfigure(sc, variable = a), envir = slider.env)

  tkpack(fr <- tkframe(m), side = "top")
  tkpack(tklabel(fr, text = "b", font = c("Helvetica", "9",
                                          "italic"), width = "20"), side = "right")
  tkpack(sc <- tkscale(fr, command = norm.refresh, from = 5,
                       to = 20, orient = "horiz", resolution = 0.01, showvalue = TRUE),
         side = "left")
  assign("sc", sc, envir = slider.env)
  evalq(tkconfigure(sc, variable = b), envir = slider.env)
  tkpack(fr <- tkframe(m), side = "top")

  tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
         side = "left")
  tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
         side = "right")
  norm.refresh()
}








see.disc.unifcdf.tck <- function ()
{
  #  old.par <- par(no.readonly = TRUE)
  if (!exists("slider.env"))
    slider.env <- NULL
  suppressWarnings(rm(slider.env))
  slider.env <<- new.env()
  a <- 0
  b <- 10
  assign("a", tclVar(a), envir = slider.env)
  assign("b", tclVar(b), envir = slider.env)
  dev.new(height = 4, width = 8, noRStudioGD = TRUE)
  par(mar = c(4.4, 4.5, 1, 0.5), cex = 0.85, oma = c(0, 0,
                                                     1.5, 0))
  layout(matrix(c(1, 2), 1, 2, byrow = TRUE))
   norm.refresh <- function(...) {
    a <- as.numeric(evalq(tclvalue(a), envir = slider.env))
    b <- as.numeric(evalq(tclvalue(b), envir = slider.env))
    xx <- seq(a,b,1)
    n <- length(xx)
    ddunif <- function(n){rep(1/n, n)}
    yy <- ddunif(n)
    y1 <- cumsum(yy)
    plot(xx, yy, type = "h", xlab = expression(italic(x)),
         ylab = expression(paste(italic(f), "(", italic(x),
                                 ")", sep = "")))
    points(xx, yy, pch = 19)
    plot(xx, y1, type = "n", xlab = expression(italic(x)),
         ylab = expression(paste(italic(F), "(", italic(x),
                                 ")", sep = "")))
    points(xx, y1, pch = 19)
    segments(xx, y1, xx + 1, y1)
    points(xx + 1, y1, pch = 1)
    mtext(bquote(paste(italic(X), " ~ ", italic(DUNIF), "(",
                       .(a), ", ", .(b), ")", sep = "")), outer = TRUE,
          side = 3, cex = 0.9)
    dev.flush()
  }
  tclServiceMode(TRUE)
  m <- tktoplevel()
  tkwm.title(m, "DUNIF(a, b)")
  tkpack(tklabel(m, text = "      Visualizing the Discrete Uniform Distribution      "))
  tkwm.geometry(m, "+0+0")
  tkpack(fr <- tkframe(m), side = "top")
  tkpack(tklabel(fr, text = "a", font = c("Helvetica", "9",
                                          "italic"), width = "20"), side = "right")
  tkpack(sc <- tkscale(fr, command = norm.refresh, from = 0,
                       to = 5, orient = "horiz", resolution = 1, showvalue = TRUE),
         side = "left")
  assign("sc", sc, envir = slider.env)
  evalq(tkconfigure(sc, variable = a), envir = slider.env)

  tkpack(fr <- tkframe(m), side = "top")
  tkpack(tklabel(fr, text = "b", font = c("Helvetica", "9",
                                          "italic"), width = "20"), side = "right")
  tkpack(sc <- tkscale(fr, command = norm.refresh, from = 5,
                       to = 20, orient = "horiz", resolution = 0.01, showvalue = TRUE),
         side = "left")
  assign("sc", sc, envir = slider.env)
  evalq(tkconfigure(sc, variable = b), envir = slider.env)
  tkpack(fr <- tkframe(m), side = "top")

  tkpack(tkbutton(m, text = "Refresh", command = norm.refresh),
         side = "left")
  tkpack(tkbutton(m, text = "Exit", command = function() tkdestroy(m)),
         side = "right")
  #    on.exit(par(old.par))
  norm.refresh()
}

pm<-function(Y, X1, X2, X1X2, change.order=FALSE, delete = 0){
old.par <- par(no.readonly = TRUE)  
if(delete != 0){
Y <- Y[-delete]
X1 <- X1[-delete]
X2 <- X2[-delete]
X1X2 <- X1X2[-delete]
}

n <- tapply(Y,X1,length)
status <- as.character(ifelse(n[1]==n[2], "Ballanced", "Unballanced"))

par(mar=c(0,0,0,0))
layout(matrix(c(rep(1,1),rep(2,2),rep(3,1),rep(4,1),rep(5,1)),2,3, byrow = TRUE))
plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
text(2.5,5,"Y = ",font=2,cex=2)
segments(c(4.5,7),c(2,2),c(4.5,7),c(9,9),lwd=2)
segments(c(4.5,7),c(2,9),c(4.7,6.8),c(2,9),lwd=2)
segments(c(4.5,7),c(9,2),c(4.7,6.8),c(9,2),lwd=2)

legend("center",ncol=1,legend=Y,bty="n",cex=.9)
plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
text(4,5, "X = ", font=2,cex=2)
segments(c(4.5,6.6),c(2,2),c(4.5,6.6),c(9,9),lwd=2)
segments(c(4.5,6.6),c(2,9),c(4.6,6.5),c(2,9),lwd=2)
segments(c(4.5,6.6),c(9,2),c(4.6,6.5),c(9,2),lwd=2)
legend("center",ncol=3,legend=c(X1,X2,X1X2),bty="n",cex=.9)
if(status == "Unballanced") legend("center", yjust = 3, legend = status, text.col = 2, bty="n", cex = 1.2)
if(delete != 0 & change.order == FALSE) legend("topright", legend = paste("Obs. no. ", delete, " deleted"), bty="n", cex = .9)
if(delete != 0 & change.order == TRUE) legend("topright", legend = c(paste("Obs. no. ", delete, " deleted"), "Predictor order reversed"), bty="n", cex = .9)
if(delete == 0 & change.order == TRUE) legend("topright", legend = "Predictor order reversed", bty="n", cex = .9)
#SS

 
 SSE.mu<-anova(lm(Y~1))$"Sum Sq"[1]
 SSE.X1<-anova(lm(Y~X1))$"Sum Sq"[2]
 SSE.X2<-anova(lm(Y~X2))$"Sum Sq"[2]
 SSE.noX1<-anova(lm(Y~X2+X1X2))$"Sum Sq"[3]
 SSE.noX2<-anova(lm(Y~X1+X1X2))$"Sum Sq"[3]
 SSE.X1pX2<-anova(lm(Y~X1+X2))$"Sum Sq"[3]
 SSE.X1iX2<-anova(lm(Y~X1+X2+X1X2))$"Sum Sq"[4]

 if(change.order==FALSE)anovaI<-anova(lm(Y~X1+X2+X1X2))
 if(change.order==TRUE)anovaI<-anova(lm(Y~X2+X1+X1X2))
 Dfs <- anovaI$Df
 Dfi <- Dfs[3]
 Dfe <- Dfs[4]
 MSE <- tail(anovaI$"Mean Sq", 1)

 ##type I
 
 plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
 rect(1,1,10,10,col="wheat")
legend("top",inset=.2,title=ifelse(change.order==FALSE,"Type I Sum of Squares\n\nModel: Y = X1 + X2 + X1:X2","Type I Sum of Squares\n\nModel: Y = X2 + X1 + X1:X2"),legend=c(
 ifelse(change.order==FALSE,paste("SSE.X1 = ",round(SSE.mu-SSE.X1,3)),paste("SSE.X2 = ",round(SSE.mu-SSE.X2,3))), ifelse(change.order==FALSE,paste("SSE.X2 = ",round(SSE.X1-SSE.X1pX2,3)),paste("SSE.X1 = ",round(SSE.X2-SSE.X1pX2,3))),paste("SSE.X1:X2 = ",round(SSE.X1pX2-SSE.X1iX2,3)),paste("SSE = ",round(SSE.X1iX2,3))),bty="n")

legend("bottom",title="P-value",legend=c(ifelse(change.order==FALSE,paste("X1 = ",round(anovaI$"Pr(>F)"[1],6)),paste("X2 = ",round(anovaI$"Pr(>F)"[1],6))),ifelse(change.order==FALSE,(paste("X2 = ",round(anovaI$"Pr(>F)"[2],6))),paste("X1 = ",round(anovaI$"Pr(>F)"[2],6))),paste("X1:X2 = ",round(anovaI$"Pr(>F)"[3],6))),bty="n",inset=.2)

 
#type II 
SSE.Xn1 <- SSE.X2 - SSE.X1pX2
SSE.Xn2 <- SSE.X1  -SSE.X1pX2
SSE.X1X2 <- SSE.X1pX2-SSE.X1iX2
SSE <- SSE.X1iX2

plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
rect(1,1,10,10,col="wheat3") 

legend("top",inset=.2,title=ifelse(change.order==FALSE,"Type II Sum of Squares\n\nModel: Y = X1 + X2 + X1:X2","Type II Sum of Squares\n\nModel: Y = X2 + X1 + X1:X2"),legend=c(
ifelse(change.order==FALSE,paste("SSE.X1 = ",round(SSE.Xn1,3)),paste("SSE.X2 = ",round(SSE.Xn2, 3))), ifelse(change.order==FALSE,paste("SSE.X2 = ",round(SSE.Xn2,3)),
paste("SSE.X1 = ",round(SSE.Xn1,3))),paste("SSE.X1:X2 = ",round(SSE.X1X2,3)),paste("SSE = ",round(SSE.X1iX2,3))),bty="n")

if(change.order==FALSE)P.val <- c(pf(SSE.Xn1/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.Xn2/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X1X2/MSE, Dfi, Dfe, lower.tail = FALSE))   
if(change.order== TRUE)P.val <- c(pf(SSE.Xn2/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.Xn1/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X1X2/MSE, Dfi, Dfe, lower.tail = FALSE))   

legend("bottom", title="P-value", legend=c(ifelse(change.order == FALSE, paste("X1 = ",round(P.val[1],6)), paste("X2 = ",round(P.val[1],6))), 
ifelse(change.order == FALSE, paste("X2 = ",round(P.val[2],6)), paste("X1 = ",round(P.val[2],6))),
paste("X1:X2 = ",round(P.val[3],6))),bty="n",inset=.2)

#type III
SSE.X1 <- SSE.noX1-SSE.X1iX2
SSE.X2 <- SSE.noX2-SSE.X1iX2
SSE.X1X2 <- SSE.X1pX2-SSE.X1iX2
SSE <- SSE.X1iX2

plot(seq(1,10),seq(1,10),type="n",xlab="",ylab="",xaxt="n",yaxt="n",bty="n")
rect(1,1,10,10,col="wheat4") 
legend("top",inset=.2,title=ifelse(change.order==FALSE,"Type III Sum of Squares\n\nModel: Y = X1 + X2 + X1:X2","Type III Sum of Squares\n\nModel: Y = X2 + X1 + X1:X2"),legend=c(
 ifelse(change.order==FALSE,paste("SSE.X1 = ",round(SSE.X1,3)),paste("SSE.X2 = ",round(SSE.X2,3))), ifelse(change.order==FALSE,paste("SSE.X2 = ",round(SSE.X2,3)),paste("SSE.X1 = ",round(SSE.X1,3))),paste("SSE.X1:X2 = ",round(SSE.X1pX2-SSE.X1iX2,3)),paste("SSE = ",round(SSE.X1iX2,3))),bty="n")

if(change.order==FALSE)P.val <- c(pf(SSE.X1/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X2/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X1X2/MSE, Dfi, Dfe, lower.tail = FALSE))   
if(change.order== TRUE)P.val <- c(pf(SSE.X2/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X1/MSE, 1, Dfe, lower.tail = FALSE), pf(SSE.X1X2/MSE, Dfi, Dfe, lower.tail = FALSE))   

legend("bottom", title="P-value", legend=c(ifelse(change.order == FALSE, paste("X1 = ",round(P.val[1],6)), paste("X2 = ",round(P.val[1],6))), ifelse(change.order == FALSE, paste("X2 = ",round(P.val[2],6)), paste("X1 = ",round(P.val[2],6))),
paste("X1:X2 = ",round(P.val[3],6))),bty="n",inset=.2)
on.exit(par(old.par))

}






see.lmu.tck<-function (){

tclRequire("BWidget")
local({
have_ttk <- as.character(tcl("info", "tclversion")) >= "8.5"
if (have_ttk) {
    tkbutton <- ttkbutton
    tkcheckbutton <- ttkcheckbutton
    tkentry <- ttkentry
    tkframe <- ttkframe
    tklabel <- ttklabel
    tkradiobutton <- ttkradiobutton
}
tclServiceMode(FALSE)
dialog.sd <- function() {
  tt <- tktoplevel()
  tkwm.title(tt,"Type I, II, and III SS")
  y.entry <- tkentry(tt, textvariable=Y, width =45)
  x1.entry <- tkentry(tt, textvariable=X1, width =45) 
  x2.entry <- tkentry(tt, textvariable=X2, width =45) 
  x1x2.entry <- tkentry(tt, textvariable=X1X2, width =45) 

Delete <-tclVar("0")
 
  
 
  r.order<-tclVar(0)
  done <- tclVar(0)

submit.but <- tkbutton(tt, text = "Submit", command = function() tclvalue(done) <- 1)

build <- function() {
  Y <-parse(text=tclvalue(Y))[[1]]
  X1 <- parse(text=tclvalue(X1))[[1]]
  X2 <- parse(text=tclvalue(X2))[[1]]
  X1X2 <- parse(text=tclvalue(X1X2))[[1]]
  r.order <- as.logical(tclObj(r.order))
  delete <- tclvalue(Delete)
X<-substitute(cbind(as.numeric(X1),as.numeric(X2),as.numeric(X1X2)))
substitute(pm(as.numeric(Y),as.numeric(X1),as.numeric(X2),as.numeric(X1X2),change.order = r.order, delete = as.numeric(delete)))
}                

 
  tkgrid(tklabel(tt, text = " ANOVA linear model "), 
      columnspan = 2)
  tkgrid(tklabel(tt, text = ""))
  tkgrid(tklabel(tt, text = 'Y'), y.entry)
  tkgrid(tklabel(tt, text = 'X1'), x1.entry)
  tkgrid(tklabel(tt, text = "X2"), x2.entry)
  tkgrid(tklabel(tt, text = "X1X2"), x1x2.entry)
  tkgrid(tklabel(tt, text = ""))

  val <- seq(0, length(eval(parse(text=tclvalue(Y))[[1]])))
  val <- as.character(val)
  comboBox <- tkwidget(tt,"ComboBox", editable=FALSE, values=val,textvariable = Delete, width = 3)
  nc.cbut <- tkcheckbutton(tt, text="Reverse X1 X2 order", variable=r.order)
  tkgrid(nc.cbut)
  tkgrid(tklabel(tt, text = "Delete obs.")) 
  tkgrid(comboBox) 
  tkgrid(tklabel(tt, text = ""), submit.but)
  
  tkbind(tt, "<Destroy>", function() tclvalue(done) <- 2)
  tkwait.variable(done)
  if (tclvalue(done) == "2") 
      stop("aborted")
  tkdestroy(tt)
  cmd <- build()
  eval.parent(cmd)
}
Y<-tclVar("c(16.5,18.4,12.7,14.0,12.8,14.5,11.0,10.8,14.3,10.0,39.1,26.2,21.3,35.8,40.2,32.0,23.8,28.8,25.0,29.3)")
X1<-tclVar("c(1,1,1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,-1,-1)")
X2<-tclVar("c(1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1)")
X1X2<-tclVar("c(1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1)")
dialog.sd()
})
}                         

loglik.norm.plot <- function (X, parameter = c("mu", "sigma.sq"), poss = NULL, plot.likfunc = TRUE,
    plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL,
    conv = 0.01, anim = TRUE, est.col = 2, density.leg = TRUE, cex.leg = 0.9, interval = 0.01, ...)
{
    possibilities <- poss
    Var.MLE <- function(e.i) sum((e.i - mean(e.i))^2)/length(e.i)
    if (is.null(poss)) {
        if (parameter == "mu")
            possibilities <- seq(mean(X) - 2 * sd(X), mean(X) +
                2 * sd(X), conv)
        if (parameter == "sigma.sq")
            possibilities <- seq(0.5 * Var.MLE(X), 2 * Var.MLE(X),
                conv)
        logl <- seq(min(possibilities), max(possibilities), conv)
    }
    if (!is.null(poss))
        logl <- poss
    for (i in 1:length(possibilities)) {
        if (parameter == "mu") {
            sdM <- sqrt(Var.MLE(X))
            logl[i] <- log(prod(dnorm(X, mean = possibilities[i],
                sd = sdM)))
        }
        if (parameter == "sigma.sq") {
            mu <- mean(X)
            logl[i] <- log(prod(dnorm(X, mean = mu, sd = sqrt(possibilities[i]))))
        }
    }
    max.p <- ifelse(is.null(poss), ifelse(parameter == "mu",
        mean(X), Var.MLE(X)), possibilities[logl == max(logl)][1])
    MLE <- ifelse(parameter == "mu", mean(X), Var.MLE(X))
    Max.lik <- log(prod(dnorm(X, mean = mean(X), sd = sqrt(Var.MLE(X)))))
    if (anim == FALSE) {
        if (plot.likfunc == TRUE & plot.density == TRUE) {
            dev.new(height = 4, width = 8)
            par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)
            layout(matrix(c(1, 2), 1, 2, byrow = TRUE))
        }
        if (plot.likfunc == TRUE) {
            plot(possibilities, logl, type = "l", ylab = ifelse(is.null(ylab),
                "Normal log-likelihood function", ylab), xlab = ifelse(is.null(xlab),
                ifelse(parameter == "mu", expression(paste("Estimates for ",
                  mu)), expression(paste("Estimates for ", sigma^2))),
                xlab), ...)
            legend("topright", legend = bquote(paste("ML est. = ",
                .(MLE))), cex = cex.leg, bty = "n")
            abline(v = MLE, lty = 2, col = est.col)
        }
        if (plot.density == TRUE) {
            x <- NULL
            rm(x)
            curve(dnorm(x, mean = mean(X), sd = sqrt(Var.MLE(X))),
                from = min(X), to = max(X), xlab = expression(italic(x)),
                ylab = expression(paste(italic(f), "(", italic(x),
                  ")", sep = "")))
              legend("topright",legend=c(paste("X~N(",bquote(.(round(mean(X),1))),", ",bquote(.(round(Var.MLE(X),1))),")",sep=""),
              paste("Loglik = ",bquote(.(round(Max.lik,2))))),bty="n",cex=cex.leg)


            if(density.leg == TRUE){legend("topleft", col = 2, lty = 2, legend = "Obs. density",
                bty = "n", cex = cex.leg)}
            segments(x0 = X, y0 = rep(0, length(X)), x1 = X,
                y1 = dnorm(X, mean = mean(X), sd = sqrt(Var.MLE(X))),
                col = est.col, lty = 2)
        }
    }
    if (anim == TRUE) {
        nm <- which(logl == max(logl))[1]
        if (plot.likfunc == TRUE & plot.density == TRUE){
          dev.new(height = 4, width = 8, noRStudioGD = TRUE)
          par(mfrow = c(1, 2), mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)}

        if ((plot.likfunc == TRUE & plot.density == FALSE)||
            (plot.likfunc == FALSE & plot.density == TRUE)){dev.new(noRStudioGD = TRUE)}

        for (i in 1:(nm - 1)) {
            dev.hold()
            if (plot.likfunc == TRUE) {
                plot(possibilities, logl, type = "n", ylab = ifelse(is.null(ylab),
                  "Normal log-likelihood function", ylab), xlab = ifelse(is.null(xlab),
                  ifelse(parameter == "mu", expression(paste("Estimates for ",
                    mu)), expression(paste("Estimates for ",
                    sigma^2))), xlab), ...)
                arrows(possibilities[i], logl[i], possibilities[i +
                  1], logl[i + 1], col = est.col, length = 0.15, lwd = 1)
                points(possibilities[1:i], logl[1:i], lty = 2,
                  col = est.col, lwd = 1, type = "l")
                if (i == (nm - 1)) {
                  points(possibilities, logl, type = "l")
                  abline(v = MLE, lty = 2, col = est.col)
                  legend("topright", legend = bquote(paste("ML est. = ",
                    .(MLE))), cex = cex.leg, bty = "n")
                }
            }
            if (plot.density == TRUE) {
                x <- NULL
                rm(x)
                curve(dnorm(x, mean = ifelse(parameter == "mu",
                  possibilities[i], mu), sd = ifelse(parameter ==
                  "mu", sdM, possibilities[i])), from = min(X),
                  to = max(X), xlab = expression(italic(x)),
                  ylab = expression(paste(italic(f), "(", italic(x),
                    ")", sep = "")))
                segments(x0 = X, y0 = rep(0, length(X)), x1 = X,
                  y1 = dnorm(X, mean = ifelse(parameter == "mu",
                    possibilities[i], mu), sd = ifelse(parameter ==
                    "mu", sdM, possibilities[i])), col = est.col, lty = 2)
                if (i != (nm - 1)) {
                  legend("topright", legend = c(ifelse(parameter ==
                    "mu", as.expression(bquote(paste(mu, " = ",
                    .(round(possibilities[i], 2))))), as.expression(bquote(paste(sigma^2,
                    " = ", .(round(possibilities[i], 2)))))),
                    as.expression(bquote(paste("Loglik = ", .(round(logl[i],
                      2)))))), bty = "n", cex = cex.leg)
                }
                if (i == (nm - 1)) {
                  legend("topright", legend = c(ifelse(parameter ==
                    "mu", as.expression(bquote(paste(mu, " = ",
                    .(MLE)))), as.expression(bquote(paste(sigma^2,
                    " = ", .(MLE))))), as.expression(bquote(paste("Loglik = ",
                    .(round(Max.lik, 2)))))), bty = "n", cex = cex.leg)
                }
            }
            dev.flush()
            Sys.sleep(interval)
        }
        if (plot.calc == TRUE) {
            dev.new(width = 4, height = 4, ypos = 225)
            par(mar = c(4.4, 4.5, 1, 0.5), cex = 0.9)
            X <- sort(X)
            c <- ifelse(length(X) < 200, round(200/length(X),
                0), 1)
            x0 = rep(X, each = c)
            y0 = rep(rep(0, length(X)), each = c)
            y1 = rep(dnorm(X, mean = ifelse(parameter == "mu",
                max.p, mu), sd = ifelse(parameter == "mu", sdM,
                max.p)), each = c)
            loglik <- log(dnorm(X, mean = ifelse(parameter ==
                "mu", max.p, mu), sd = ifelse(parameter == "mu",
                sdM, max.p)))
            cumlik <- rep(cumsum(loglik), each = c)
            for (i in 1:(length(X) * c)) {
                dev.hold()
                x <- NULL
                rm(x)
                curve(dnorm(x, mean = ifelse(parameter == "mu",
                  max.p, mu), sd = ifelse(parameter == "mu",
                  sdM, max.p)), from = min(X), to = max(X), xlab = expression(italic(x)),
                  ylab = expression(paste(italic(f), "(", italic(x),
                    ")", sep = "")))
                if(density.leg == TRUE){legend("topleft", col = 2, lty = 2, legend = "Obs. density",
                  bty = "n", cex = 0.9)}
                legend("topright", legend = c(paste("X~N(", bquote(.(round(mean(X),
                  1))), ", ", bquote(.(round(Var.MLE(X), 1))),
                  ")", sep = ""), paste("Loglik = ", bquote(.(round(cumlik[i],
                  2))))), bty = "n", cex = cex.leg)
                segments(x0[1:i], y0[1:i], x0[1:i], y1[1:i],
                  col = 2, lty = 2)
                dev.flush()
                Sys.sleep(interval)
            }
        }
    }
}

paik <- function(formula, counts, resp.lvl = 2, data, circle.mult = .4, xlab = NULL, ylab = NULL, leg.title = NULL, leg.loc = NULL, show.mname = FALSE,...){

vars <- as.character(attr(terms(formula), "variables")[-1])
cond.var = vars[3]
rv <- data[,names(data)==vars[1]]
cv <- data[,names(data)==cond.var]
ov <- vars[vars!=vars[1]&vars!=cond.var]
or <- data[,names(data)==ov]

new.formula <- formula(counts ~ rv + ov + cv)
cl <- levels(data[,names(data) == cond.var])
ol <- levels(data[,names(data) == ov])
rl <- levels(data[,names(data) == vars[1]])

x <- xtabs(count ~ rv + or + cv, data = data)
xm <- xtabs(count ~ rv + or, data = data)
m.prop <- apply(xm, 2, function(x)x[resp.lvl]/sum(x))


r.prop <- matrix(nrow=length(cl), ncol=length(ol), dimnames=list(paste(cond.var,cl,sep="."),paste(ov,ol,sep=".")))
r.sum <- matrix(nrow=length(cl), ncol=length(ol), dimnames=list(paste(cond.var,cl,sep="."),paste(ov,ol,sep=".")))

for(i in 1:length(cl)){
tab <- x[,,cl = cl[i]]
r.prop[i,] <- apply(tab, 2, function(x)x[resp.lvl]/sum(x))
r.sum[i,] <- apply(tab, 2, sum)
}

b<-barplot(1:(length(ol)+2), plot = FALSE)
pts <- b[-c(1,(length(ol)+2))]
y.loc <- stack(as.data.frame(r.prop))[,1]
x.loc <- rep(pts,each=length(cl))
temp.ylab <- bquote(paste("Proportion  ", .(vars[1]), "  =  ", .(rl[resp.lvl])))

p <- plot(x.loc, y.loc, xlim = c(1.5,(length(ol)+1.5)), type = "n", xaxt = "n", xlab = ifelse(is.null(xlab), ov, xlab), ylab = ifelse(is.null(ylab), eval(temp.ylab), ylab))
grid(p)
axis(1, at = pts , labels = ol)

tprop <- stack(as.data.frame(t(r.prop)))[,1]
tx <- rep(pts,length(cl))
tpropm <- matrix(ncol = length(pts), nrow = length(cl), data = tprop, byrow = TRUE)
txm <- matrix(ncol = length(pts), nrow = length(cl), data = tx, byrow = TRUE)

col <- gray(seq(1:length(cl))/length(cl))
circle.col <- rep(col, length(cl))
radii <- r.sum/sum(r.sum)
radii <- stack(as.data.frame(radii))[,1]*circle.mult
for(i in 1: length(radii))draw.circle(x.loc[i], y.loc[i], radii[i], col = circle.col[i])


if(length(pts)==2){
for(i in 1:length(cl)){
segments(txm[i,][1], tpropm[i,][1], txm[i,][2], tpropm[i,][2])
}
segments(pts[1], m.prop[1], pts[2], m.prop[2], lty = 2, lwd = 2)
}

if(length(pts)==3){
for(i in 1:length(cl)){
segments(txm[i,][1], tpropm[i,][1], txm[i,][2], tpropm[i,][2]);segments(txm[i,][2], tpropm[i,][2], txm[i,][3], tpropm[i,][3])
}
segments(pts[1], m.prop[1], pts[2], m.prop[2], lty = 2, lwd = 2); segments(pts[2], m.prop[2], pts[3], m.prop[3], lty = 2, lwd = 2)
}

if(length(pts)==4){
for(i in 1:length(cl)){
segments(txm[i,][1], tpropm[i,][1], txm[i,][2], tpropm[i,][2]);segments(txm[i,][2], tpropm[i,][2], txm[i,][3], tpropm[i,][3]);segments(txm[i,][3], tpropm[i,][3], txm[i,][4], tpropm[i,][4]) 
}
segments(pts[1], m.prop[1], pts[2], m.prop[2], lty = 2, lwd = 2); segments(pts[2], m.prop[2], pts[3], m.prop[3], lty = 2, lwd = 2); segments(pts[3], m.prop[3], pts[4], m.prop[4], lty = 2, lwd = 2)
}

if(length(pts)==5)stop("Number of rows in table must be less than 5")


points(x.loc, y.loc, pch = 19, cex=.6)
legend(ifelse(is.null(leg.loc),"topright",leg.loc),pch=rep(21,length(cl)),pt.bg = col, bg = "white", pt.cex = 1.5, title = ifelse(is.null(leg.title), cond.var, leg.title), legend = cl) 


degree <- diff(m.prop)/diff(pts)*360

if(show.mname==TRUE)text(mean(pts),mean(m.prop) + 0.03*max(y.loc),srt=degree, "Marginal prop.")
res <- invisible(list(marginal.prop = r.prop, group.prop = r.sum/sum(r.sum))) 
invisible(res)
}

selftest.regGLM.tck1 <-function(){
  options(guiToolkit="tcltk")
  w <- gwindow(title = "Generalized linear models")
  size(w) <- c(700, 650)
  g <- ggroup(container=w, horizontal=FALSE, use.scrollwindow = TRUE)

  #------------- Question 1 -----------#
 
  gp1 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp1.1 <- ggroup(container = gp1, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("1) ", container = gp1.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("(T or F) Generalized linear models (GLMs) can be used to analyze data from all four basic types of 
experimental designs.",
         container = gp1.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans1 <- c("(a)  TRUE ",
            "(b)  FALSE")

  f1 <- function(h,....){ 
    if(tail(svalue(r1),1) == ans1[1]){
      gmessage(msg="Correct.  GLMs can be used to analyze cases when Y is quantitative or categorical and X(s) is (are) quantitative or categorical (or both).")
    }
    if(tail(svalue(r1),1)== ans1[2]){
      gmessage(msg="Incorrect")
    }
   svalue(r1) <- character(0)
  }
  
  
  r1 <- gcheckboxgroup(ans1, container = gp1, checked = FALSE, where = "beginning", handler = f1)
  
   
  
  #------------- Question 2 -----------#
  
  gp2 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp2.1 <- ggroup(container = gp2, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("2) ", container = gp2.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("General linear models are not a type of GLM.",
               container = gp2.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans2 <- c("(a)  TRUE.",
            "(b)  FALSE.")
  
  f2 <- function(h,....){ 
    if(tail(svalue(r2),1) == ans2[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r2),1)== ans2[2]){
      gmessage(msg="Correct")
    }
   
    svalue(r2) <- character(0)
  }
  
  
  r2 <- gcheckboxgroup(ans2, container = gp2, checked = FALSE, where = "beginning", handler = f2)
  
  
  #------------- Question 3 -----------#
  
  gp3 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp3.1 <- ggroup(container = gp3, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("3) ", container = gp3.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("What distinguishes a GLM?",
               container = gp3.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans3 <- c("(a)  Simultaneous consideration of BIC and AIC in the model.",
            "(b)  Incorporation of model II regression procedures.",
            "(c)  A user-defined link function that allows the expression of the Y mean function in linear terms,\n and a user-defined error term distribution.",
            "(d)  All of the above.")
  
  f3 <- function(h,....){ 
    if(tail(svalue(r3),1) == ans3[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r3),1)== ans3[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r3),1)== ans3[4]){
      gmessage(msg="Incorrect", icon = "error")
    }
    
    svalue(r3) <- character(0)
  }
  
  
  r3 <- gcheckboxgroup(ans3, container = gp3, checked = FALSE, where = "beginning", handler = f3)
  
  
  
  #------------- Question 4 -----------#
  
  gp4 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp4.1 <- ggroup(container = gp4, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("4) ", container = gp4.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("We would use a logistic GLM...",
               container = gp4.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans4 <- c("(a)  to account for inequality of BIC and AIC in a model.",
            "(b)  to model bivariate forms of Y.",
            "(c)  to find the optimal power transformation of X, to account for nonconstant variance in residuals.",
            "(d)  to model a dichotomous Y as a function of X(s). ",
            "(e)  to find the optimal power transformation of X, to account for nonlinearity in the relationship of Y and X.")
  
  f4 <- function(h,....){ 
    if(tail(svalue(r4),1) == ans4[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r4),1)== ans4[4]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r4),1)== ans4[5]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r4) <- character(0)
  }
  
  
  r4 <- gcheckboxgroup(ans4, container = gp4, checked = FALSE, where = "beginning", handler = f4)  
  
 
  #------------- Question 5 -----------#
  
  gp5 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp5.1 <- ggroup(container = gp5, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("5) ", container = gp5.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The logit of an outcome A is defined as...",
               container = gp5.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans5 <- c("(a)  P(A) - (1 - P(A)).",
            "(b)  1 - P(A).",
            "(c)  P(A)/(1 - P((A)).",
            "(d)  ln(P(A)/(1 - P((A))).")
  
  f5 <- function(h,....){ 
    if(tail(svalue(r5),1) == ans5[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r5),1)== ans5[4]){
      gmessage(msg="Correct")
    }
    
    svalue(r5) <- character(0)
  }
  
  
  r5 <- gcheckboxgroup(ans5, container = gp5, checked = FALSE, where = "beginning", handler = f5)  
  
 
 #------------- Question 6 -----------#
  
  gp6 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp6.1 <- ggroup(container = gp6, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("6) ", container = gp6.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In the context of GLMs, deviance is...",
               container = gp6.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans6 <- c("(a)  a maladjusted human behaviour.",
            "(b)  a generalized form of model error.",
            "(c)  equivelent to SSE for general linear models.",
            "(d)  b) and c) above.")
  
  f6 <- function(h,....){ 
    if(tail(svalue(r6),1) == ans6[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r6),1)== ans6[4]){
      gmessage(msg="Correct")
    }
    
    svalue(r6) <- character(0)
  }
  
  
  r6 <- gcheckboxgroup(ans6, container = gp6, checked = FALSE, where = "beginning", handler = f6)  
  
  
  
  #------------- Question 7 -----------#
  
  gp7 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp7.1 <- ggroup(container = gp7, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("7) ", container = gp7.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a logistic GLM, units for coefficients from the fitted model will be...",
               container = gp7.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  
  ans7 <- c("(a)  odds.",
            "(b)  log odds.",
            "(c)  probability.",
            "(d)  inverse probability.")
  
  f7 <- function(h,....){ 
    if(tail(svalue(r7),1) == ans7[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[2]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r7),1)== ans7[3]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r7),1)== ans7[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    
    svalue(r7) <- character(0)
  }
  
  
  r7 <- gcheckboxgroup(ans7, container = gp7, checked = FALSE, where = "beginning", handler = f7)  
  
  
  
  #------------- Question 8 -----------#

  gp8 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp8.1 <- ggroup(container = gp8, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("8) ", container = gp8.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("In a Poisson GLM, units for coefficients from the fitted model will be...",
               container = gp8.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)


  ans8 <- c("(a)  odds.",
            "(b)  log counts.",
            "(c)  counts.",
            "(d)  inverse counts.")

  f8 <- function(h,....){
    if(tail(svalue(r8),1) == ans8[1]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[2]){
      gmessage(msg="Correct.")
    }
    if(tail(svalue(r8),1)== ans8[3]){
      gmessage(msg="Incorrect.",  icon = "error")
    }
    if(tail(svalue(r8),1)== ans8[4]){
      gmessage(msg="Incorrect.",  icon = "error")
    }

    svalue(r8) <- character(0)
  }


  r8 <- gcheckboxgroup(ans8, container = gp8, checked = FALSE, where = "beginning", handler = f8)



  #------------- Question 9 -----------#

  gp9 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp9.1 <- ggroup(container = gp9, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("9) ", container = gp9.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("Overdispersion in GLMs...",
               container = gp9.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)


  ans9 <- c("(a)  occurs when the observed error variance exceeds the model (theoretical) variance.",
            "(b)  can be estimated as the residual deviance divided by the degrees of freedom error for the model.",
            "(c)  indicates the GLM model is inappropriate.",
            "(d)  a) and b) above.",
            "(e)  All of the above.")

  f9 <- function(h,....){
    if(tail(svalue(r9),1) == ans9[1]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[2]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[3]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[4]){
      gmessage(msg="Partially correct",  icon = "error")
    }
    if(tail(svalue(r9),1)== ans9[5]){
      gmessage(msg="Correct")
    }

    svalue(r9) <- character(0)
  }


  r9 <- gcheckboxgroup(ans9, container = gp9, checked = FALSE, where = "beginning", handler = f9)



  #------------- Question 10 -----------#

  gp10 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  gp10.1 <- ggroup(container = gp10, spacing = 2, pos = 0, horizontal = TRUE)
  q <- glabel("10) ", container = gp10.1, horizontal = TRUE)
  font(q) <- list(weight = "bold")
  qq <- glabel("The area under the curve (AUC) from from a receiver operating characteristic (ROC) curve...",
               container = gp10.1, anchor = c(-1,1))
  font(qq) <- list(family = "cambria", size = 11)
  
  ans10 <- c("(a)  provides a measure of parsimony for Poisson GLMs.",
            "(b)  measures deviance in logistic GLMs.",
            "(c)  provides a general measure of the predictive effectiveness of a logistic GLM.",
            "(d)  All of the above.")

  f10 <- function(h,....){
    if(tail(svalue(r10),1) == ans10[1]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[2]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    if(tail(svalue(r10),1)== ans10[3]){
      gmessage(msg="Correct")
    }
    if(tail(svalue(r10),1)== ans10[4]){
      gmessage(msg="Incorrect",  icon = "error")
    }
    svalue(r10) <- character(0)
  }


  r10 <- gcheckboxgroup(ans10, container = gp10, checked = FALSE, where = "beginning", handler = f10)




  # #------------- Question 11 -----------#
  # 
  # gp11 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp11.1 <- ggroup(container = gp11, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("11) ", container = gp11.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("Consider the matrix expression of a general linear model:",
  #              container = gp11.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # qq1 <- glabel("Y = \u03b2X + \u03b5.",
  #               container = gp11.1, anchor = c(-1,1))
  # font(qq1) <- list(family = "cambria", size = 11, weight = "bold")
  # qq2 <- glabel("X",
  #               container = gp11.1, anchor = c(-1,1))
  # font(qq2) <- list(family = "cambria", size = 11, weight = "bold")
  # qq3 <- glabel("has dimension...",
  #               container = gp11.1, anchor = c(-1,1))
  # font(qq3) <- list(family = "cambria", size = 11)
  # 
  # ans11 <- c("(a)  (n x p).",
  #            "(b)  (n x 1).",
  #            "(c)  (p x 1).",
  #            "(d)  (p x n).")
  # 
  # f11 <- function(h,....){ 
  #   if(tail(svalue(r11),1) == ans11[1]){
  #     gmessage(msg="Correct")
  #   }
  #   if(tail(svalue(r11),1)== ans11[2]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r11),1)== ans11[3]){
  #     gmessage(msg="Inorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r11),1)== ans11[4]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   svalue(r11) <- character(0)
  # }
  # 
  # 
  # r11 <- gcheckboxgroup(ans11, container = gp11, checked = FALSE, where = "beginning", handler = f11)  
  # 
  # 
  # 
  # #------------- Question 12 -----------#
  # 
  # gp12 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp12.1 <- ggroup(container = gp12, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("12) ", container = gp12.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("The coefficient of determinination, R\u00B2...",
  #              container = gp12.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans12 <- c("(a)  will be in the range [0, 1].",
  #            "(b)  is calculated as 1 - SSE/SSTO.",
  #            "(c)  represents the proportion of variability in Y explained by the model.",
  #            "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
  #            "(e)  (a) and (c) above.",
  #            "(f)  All of the above.")
  # 
  # f12 <- function(h,....){ 
  #   if(tail(svalue(r12),1) == ans12[1]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r12),1)== ans12[2]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r12),1)== ans12[3]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r12),1)== ans12[4]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r12),1)== ans12[5]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r12),1)== ans12[6]){
  #     gmessage(msg="Correct")
  #   }
  #   svalue(r12) <- character(0)
  # }
  # 
  # 
  # r12 <- gcheckboxgroup(ans12, container = gp12, checked = FALSE, where = "beginning", handler = f12)  
  # 
  # 
  # #------------- Question 13 -----------#
  # 
  # gp13 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp13.1 <- ggroup(container = gp13, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("13) ", container = gp13.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("The adjusted R\u00B2...",
  #              container = gp13.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans13 <- c("(a)  will be identical to R\u00B2 in most situations.",
  #            "(b)  will occasionally be larger than R\u00B2.",
  #            "(c)  adjusts for the number of parameters in the model.",
  #            "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
  #            "(e)  (a) and (c) above.",
  #            "(f)  All of the above.")
  # 
  # f13 <- function(h,....){ 
  #   if(tail(svalue(r13),1) == ans13[1]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r13),1)== ans13[2]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r13),1)== ans13[3]){
  #     gmessage(msg="Correct")
  #   }
  #   if(tail(svalue(r13),1)== ans13[4]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r13),1)== ans13[5]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r13),1)== ans13[6]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   svalue(r13) <- character(0)
  # }
  # 
  # 
  # r13 <- gcheckboxgroup(ans13, container = gp13, checked = FALSE, where = "beginning", handler = f13)  
  # 
  # 
  # #------------- Question 14 -----------#
  # 
  # gp14 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp14.1 <- ggroup(container = gp14, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("14) ", container = gp14.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("The partial R\u00B2...",
  #              container = gp14.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans14 <- c("(a)  measures the reduction in SSE after a variable of interest is added to model.",
  #            "(b)  will occasionally be larger than R\u00B2.",
  #            "(c)  requires the specification of a nested model (that lacks a variable of interest) and a reference (full) model.",
  #            "(d)  is equivalent to r\u00B2 for a simple linear regression model.",
  #            "(e)  (a) and (c) above.",
  #            "(f)  All of the above.")
  # 
  # f14 <- function(h,....){ 
  #   if(tail(svalue(r14),1) == ans14[1]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r14),1)== ans14[2]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r14),1)== ans14[3]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r14),1)== ans14[4]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r14),1)== ans14[5]){
  #     gmessage(msg="Correct")
  #   }
  #   if(tail(svalue(r14),1)== ans14[6]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   svalue(r14) <- character(0)
  # }
  # 
  # 
  # r14 <- gcheckboxgroup(ans14, container = gp14, checked = FALSE, where = "beginning", handler = f14)  
  # 
  # 
  # 
  # 
  # #------------- Question 15 -----------#
  # 
  # gp15 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp15.1 <- ggroup(container = gp15, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("15) ", container = gp15.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("An ANOVA approach for assessing the affect of individual predictors in multiple regression\n is problematic because...",
  #              container = gp15.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans15 <- c("(a)  Sums of squares and p-values will vary depending on the order predictors are specified in the linear model.",
  #            "(b)  Linear model algorithms typically use type I sums of squares which will be untrustworthy for assessing\n the affect of individual predictors.",
  #            "(c)  Type II sums of squares, which will provide consistent results, require the specification of a nested model\n (that lacks a variable of interest) and a reference (full) model.",
  #            "(d)  All of the above.")
  # 
  # f15 <- function(h,....){ 
  #   if(tail(svalue(r15),1) == ans15[1]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r15),1)== ans15[2]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r15),1)== ans15[3]){
  #     gmessage(msg="Partially correct",  icon = "error")
  #   }
  #   if(tail(svalue(r15),1)== ans15[4]){
  #     gmessage(msg="Correct")
  #   }
  #     svalue(r15) <- character(0)
  # }
  # 
  # 
  # r15 <- gcheckboxgroup(ans15, container = gp15, checked = FALSE, where = "beginning", handler = f15)  
  # 
  # 
  # 
  # #------------- Question 16 -----------#
  # 
  # gp16 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp16.1 <- ggroup(container = gp16, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("16) ", container = gp16.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("In multiple regression we can assess the null hypothesis: H\u2080: \u03B2\u2081 = \u03B2\u2082 = , ... , = \u03B2\u209A\u02CD\u2081.  \nWhat is the null distribution for this test?",
  #              container = gp16.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans16 <- c("(a)  N(0, 1).",
  #            "(b)  t(n - p).",
  #            "(c)  t(p - n).",
  #            "(d)  F(p-1, n-p).",
  #            "(e)  F(n-p, p-1).")
  # 
  # f16 <- function(h,....){ 
  #   if(tail(svalue(r16),1) == ans16[1]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r16),1)== ans16[2]){
  #     gmessage(msg="Incorrect.  This is the null distribution for considering the effect of individual predictors.",  icon = "error")
  #   }
  #   if(tail(svalue(r16),1)== ans16[3]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r16),1)== ans16[4]){
  #     gmessage(msg="Correct")
  #   }
  #   if(tail(svalue(r16),1)== ans16[5]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   svalue(r16) <- character(0)
  # }
  # 
  # 
  # r16 <- gcheckboxgroup(ans16, container = gp16, checked = FALSE, where = "beginning", handler = f16)  
  # 
  # 
  # 
  # #------------- Question 17 -----------#
  # 
  # gp17 <- gframe(container = g, spacing = 2, pos = 0, horizontal = FALSE)
  # gp17.1 <- ggroup(container = gp17, spacing = 2, pos = 0, horizontal = TRUE)
  # q <- glabel("17) ", container = gp17.1, horizontal = TRUE)
  # font(q) <- list(weight = "bold")
  # qq <- glabel("Why are predicted values a concern in multiple regression?",
  #              container = gp17.1, anchor = c(-1,1))
  # font(qq) <- list(family = "cambria", size = 11)
  # 
  # 
  # ans17 <- c("(a)  It is difficult to determine if new X outcomes from multiple predictors constitute extrapolated values.",
  #            "(b)  It is difficult to predict Y from multiple X variables.",
  #            "(c)  It is difficult to predict multiple Ys from a single X variable.",
  #            "(d)  The null distribution will not exist.")
  # 
  # f17 <- function(h,....){ 
  #   if(tail(svalue(r17),1) == ans17[1]){
  #     gmessage(msg="Correct")
  #   }
  #   if(tail(svalue(r17),1)== ans17[2]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r17),1)== ans17[3]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   if(tail(svalue(r17),1)== ans17[4]){
  #     gmessage(msg="Incorrect",  icon = "error")
  #   }
  #   svalue(r17) <- character(0)
  # }
  # 
  # 
  # r17 <- gcheckboxgroup(ans17, container = gp17, checked = FALSE, where = "beginning", handler = f17)  
  # 
  # 
  # 
  # 
  # 
  # 
  # 
  # 
  # 
   
}  
  
  
  
  
  
  
  
   

anm.die<-function(reps=300,interval=0.1,show.die=TRUE,p=c(1/6,1/6,1/6,1/6,1/6,1/6),cl=TRUE){

old.par <- par(no.readonly = TRUE)
if(names(dev.cur()) == "RStudioGD" | Sys.info()[['sysname']] == "Darwin" | Sys.info()[['sysname']] == "Windows") 
{dev.new(noRStudioGD = TRUE)}

if(sum(p)!=1)stop("sum of die probabilities must = 1")
p<-p*100
die<-sample(c(rep(1,p[1]),rep(2,p[2]),rep(3,p[3]),rep(4,p[4]),rep(5,p[5]),rep(6,p[6])),reps,replace=TRUE)
p1<-seq(1:reps);p2<-seq(1:reps);p3<-seq(1:reps);p4<-seq(1:reps);p5<-seq(1:reps);p6<-seq(1:reps)
for(i in 1:reps){
p1[i]<-length(die[0:i][die[0:i]==1])/i;p2[i]<-length(die[0:i][die[0:i]==2])/i
p3[i]<-length(die[0:i][die[0:i]==3])/i;p4[i]<-length(die[0:i][die[0:i]==4])/i
p5[i]<-length(die[0:i][die[0:i]==5])/i;p6[i]<-length(die[0:i][die[0:i]==6])/i}

for(i in 1:reps){
dev.hold()
if(show.die==TRUE){
layout(matrix(c(rep(1,6),0,2,0), 3, 3, byrow = TRUE))
par(mar=c(5.5,4.5,2,2.1))
exp = 1.3
}

else exp <- 1.2

plot(seq(1,reps),seq(0,reps-1)/(reps-1),type="n",xlab="Trials",ylab="Cumulative proportion", cex.lab = exp + .1, cex.axis = exp + .1)
points(seq(1:i),p1[1:i],lty=ifelse(cl==TRUE,1, 1),col=ifelse(cl==TRUE,1, 1),type="l", lwd=1.3)
points(seq(1:i),p2[1:i],lty=ifelse(cl==TRUE,1, 2),col=ifelse(cl==TRUE,2, gray(.2)),type="l",lwd=exp)
points(seq(1:i),p3[1:i],lty=ifelse(cl==TRUE,1, 3),col=ifelse(cl==TRUE,3, gray(.4)),type="l",lwd=exp)
points(seq(1:i),p4[1:i],lty=ifelse(cl==TRUE,1, 4),col=ifelse(cl==TRUE,4, gray(.6)),type="l",lwd=exp)
points(seq(1:i),p5[1:i],lty=ifelse(cl==TRUE,1, 1),col=ifelse(cl==TRUE,5, gray(.8)),type="l",lwd=exp)
points(seq(1:i),p6[1:i],lty=ifelse(cl==TRUE,1, 2),col=ifelse(cl==TRUE,4, gray(.6)),type="l",lwd=exp)

if(cl == TRUE){
lcol <- 1:6
llty <- rep(1, 6)
}
else{
llty <- c(1,2,3,4,1,2)
lcol <- gray(c(0,.2,.4,.6,.8,.6))
}

legend("topright",col=lcol, lty=llty, lwd=exp, legend=c("1","2","3","4","5","6"), title="Die result", bg="white", cex = exp-.1)
if(show.die==TRUE){
par(mar=c(0.2,0,0,0))
if(die[i]==1)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(0.5,0.5,pch=19,cex=8)}
if(die[i]==2)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(c(0.1,0.9),c(0.1,0.9),pch=19,cex=8)}
if(die[i]==3)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(c(0.1,0.5,0.9),c(0.1,0.5,0.9),pch=19,cex=8)}
if(die[i]==4)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(c(0.1,0.1,0.9,0.9),c(0.1,0.9,0.1,0.9),pch=19,cex=8)}
if(die[i]==5)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(c(0.1,0.1,0.5,0.9,0.9),c(0.1,0.9,0.5,0.1,0.9),pch=19,cex=8)}
if(die[i]==6)
{plot(seq(0,1),seq(0,1),xlab="",ylab="",xaxt="n",yaxt="n",type="n");points(c(0.1,0.5,0.9,0.1,0.5,0.9),c(0.1,0.1,0.1,0.9,0.9,0.9),pch=19,cex=8)}}
dev.flush()
Sys.sleep(interval)
}
on.exit(par(old.par))
invisible()
}

\name{fruit}
\alias{fruit}
\docType{data}
\title{
Fruit weight data from Littell et al. (2002)
}
\description{
Valencia orange tree fruit weights are measured at harvest with respect to five irrigation treatment applied in eight blocks in a RCBD.  
}
\usage{data(fruit)}
\format{
  A data frame with 40 observations on the following 3 variables.
  \describe{
    \item{\code{block}}{a factor describing eight blocks}
    \item{\code{irrig}}{a factor with levels \code{basin} \code{flood} \code{spray} \code{sprinkler} \code{trickle}}
    \item{\code{fruitwt}}{a numeric vector}
  }
}
\source{
Littell, R. C., Stroup, W. W., and R. J. Freund (2002)  \emph{SAS for linear models}.  John 
Wiley and Associates.
}
\keyword{datasets}

\name{huber.one.step}
\alias{huber.one.step}
\title{Huber one step M-estimator}
\description{
Returns the first Raphson-Newton iteration of the function \code{Huber.NR}.
}
\usage{
huber.one.step(x, c = 1.28)
}
\arguments{

  \item{x}{Vector of quantitative data}
  \item{c}{Bend criterion.  The value \code{c = 1.28} gives 95\% efficiency of the mean given normality.}
}
\details{The Huber \emph{M}-estimator function usually converges fairly quickly, hence the justification of the Huber one step estimator.  The function uses the Median Absolute Deviation function, \code{\link{mad}}.  If MAD = 0, then \code{NA} is returned.
}
\value{Returns the Huber one step estimator.}
\seealso{\code{\link{huber.mu}}, \code{\link{huber.NR}}, \code{\link{mad}}}
\references{
Huber, P. J.  (2004)  \emph{Robust Statistics}. Wiley.

Wilcox, R. R.   (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\examples{
x<-rnorm(100)
huber.one.step(x)
}

\name{shad}
\alias{shad}
\docType{data}
\title{
American gizzard shad data
}
\description{
Hollander and Wolfe (1999) describe young of year lengths at four sites for American gizzard shad, \emph{Dorosoma cepedianum}, a fish of the herring family. 
}
\usage{data(shad)}
\format{
  A data frame with 40 observations on the following 2 variables.
  \describe{
    \item{\code{length}}{Fish length in cm}
    \item{\code{site}}{a factor with levels \code{I} \code{II} \code{III} \code{IV}}
  }
}

\source{
Hollander, M., and  D. A. Wolfe  (1999) \emph{Nonparametric Statistical Methods}. New York: John Wiley & Sons. 
}
\keyword{datasets}

\name{world.co2}
\alias{world.co2}
\docType{data}
\title{World CO2 levels, by country, from 1980 to 2006}
\description{
The Carbon Dioxide Information Analysis Center (CDIAC) has compiled extensive data, detailing total carbon dioxide emissions from the consumption and flaring of fossil fuels (in millions of metric tons of carbon dioxide).  Data can be broken down by country.  More up-to-date data can be found in this package at \code{\link{world.emissions}}.
}
\usage{data(world.co2)}
\format{
The dataframe contains 16 columns
\describe{
\item{\code{Year}}{The year of CO\eqn{_2} measure (1980-2006)}.   
\item{\code{Afghanistan}}{CO\eqn{_2} emissions in Afghanistan from 1980-2006 (1x\eqn{10^6} metric tons).}         
\item{\code{Belgium}}{CO\eqn{_2} emissions in Belgium...}        
\item{\code{Brazil}}{CO\eqn{_2} emissions in Brazil...}
\item{\code{Canada}}{CO\eqn{_2} emissions in Canada...}
\item{\code{China}}{CO\eqn{_2} emissions in China...}
\item{\code{Finland}}{CO\eqn{_2} emissions in Finland...}
\item{\code{Ghana}}{CO\eqn{_2} emissions in Ghana...}
\item{\code{Italy}}{CO\eqn{_2} emissions in Italy...}        
\item{\code{Japan}}{CO\eqn{_2} emissions in Japan...}
\item{\code{Kenya}}{CO\eqn{_2} emissions in Kenya...}
\item{\code{Mexico}}{CO\eqn{_2} emissions in Mexico...}        
\item{\code{Saudi.Arabia}}{CO\eqn{_2} emissions in Saudi Arabia...}
\item{\code{United.Arab.Emirates}}{CO\eqn{_2} emissions in the United Arab Emirates..}
\item{\code{United.States}}{CO\eqn{_2} emissions in United States...}
\item{\code{World.Total}}{CO\eqn{_2} emissions totals for the world...}
  }
}
\source{The U.S. Carbon Dioxide Information Analysis Center (CDIAC).}
\keyword{datasets}

\name{enzyme}
\alias{enzyme}
\docType{data}
\title{
Enzymatic rate data for the phospholipase protein ExoU 
}
\description{
The bacterium \emph{Pseudomonas aeruginosa} causes disease in human hosts leading to 
sepsis and even death in part by secreting lipases (proteins that break down lipids) 
into cellular environments.  The protein ExoU is a phospholipase produce by particularly 
virulent strains of \emph{P. aeruginosa}.  Benson et al. (2009) measured of ExoU enzymatic 
activity under varying levels of the fluorescent phospholipase substrate PED6.  
}
\usage{data(enzyme)}
\format{
  A data frame with 10 observations on the following 3 variables.
  \describe{
    \item{\code{substrate}}{PED6 concentration (in micromoles).}
    \item{\code{rate}}{enzymatic rate (nmol of cleaved of PED6 per mg ExoU).}
    \item{\code{sd}}{standard deviation of rate for each level of substrate.}
  }
}
\source{
Benson, M. A., Schmalzer, K. M., and D. W. Frank (2009) A sensitive fluorescence-based assay for the detection of ExoU mediated PLA2 activity.  \emph{Clin Chim Acta} 411(3-4): 190-197.
}

\keyword{datasets}

\name{Kullback}
\alias{Kullback}
\alias{print.kback}

\title{Kullback test for equal covariance matrices.}
\description{
Provides Kullback's (1959) test for multivariate homoscedasticity.
}
\usage{
Kullback(Y, X)

}
\arguments{
  \item{Y}{An \emph{n} x \emph{p} matrix of quantitative variables}
  \item{X}{An \emph{n} x 1 vector of categorical assignments (e.g. factor levels)}
}
\details{
Multivariate general linear models assume equal covariance matrices for all 
factor levels or factor level combinations. Legendre and Legendre (1998) recommend 
this test for verifying homoscedasticity.  \emph{P}-values concern a null hypothesis of 
equal population covariance matrices.  \emph{P}-values from the test are conservative with respect to type I error. 
}
\value{
Returns a dataframe with the test statistic (which follows a chi-square distribution if H\eqn{_0} is true), 
the chi-square degrees of freedom, and the calculated \emph{p}-value.  Invisible objects include the within group dispersion matrix.
}
\references{
Kullback, S. (1959)  \emph{Information Theory and Statistics}.  John Wiley and Sons.

Legendre, P, and Legendre, L.  (1998) \emph{Numerical Ecology, 2nd English edition}.  Elsevier, 
Amsterdam, The Netherlands. 
}
\author{Pierre Legendre is the author of the most recent version of this function asbio ver >= 1.0. Stephen Ousley discovered an error in the original code. Ken Aho was the author of the original function}

\examples{
Y1<-rnorm(100,10,2)
Y2<-rnorm(100,15,2)
Y3<-rnorm(100,20,2)
Y<-cbind(Y1,Y2,Y3)
X<-factor(c(rep(1,50),rep(2,50)))
Kullback(Y,X)
}

\keyword{multivariate}
\keyword{htest}

\name{see.ttest.tck}
\alias{see.ttest.tck}

\title{
Visualize t-tests
}
\description{
Interactive GUI for demonstrating \emph{t}-tests
}
\usage{

see.ttest.tck()
}
\author{
Ken Aho
}
\keyword{graphs}

\name{shade.norm}
\alias{shade}
\alias{shade.norm}
\alias{shade.t}
\alias{shade.F}
\alias{shade.chi}
\alias{shade.bin}
\alias{shade.poi}
\alias{shade.wei}

\title{Shading functions for interpretation of pdf probabilities.
}
\description{
Creates plots with lower, upper, two-tailed, and middle of the distribution shading for popular pdfs. 
}
\usage{

shade.norm(x = NULL, from = NULL, to = NULL, sigma = 1, mu = 0,
tail = "lower", show.p = TRUE, show.d = FALSE, show.dist = TRUE, digits = 5,
legend.cex = .9, shade.col="gray",...)

shade.t(x = NULL, from = NULL, to = NULL, nu = 3, tail = "lower", 
show.p = TRUE, show.d = FALSE, show.dist = TRUE, digits = 5,legend.cex = .9, 
shade.col="gray",...)

shade.F(x = NULL, from = NULL, to = NULL, nu1 = 1, nu2 = 5, 
tail = "lower", show.p = TRUE, show.d = FALSE, show.dist = TRUE, 
prob.to.each.tail = 0.025, digits = 5, legend.cex = .9,shade.col="gray",...)

shade.chi(x = NULL, from = NULL, to = NULL, nu = 1, tail = "lower", 
show.p = TRUE, show.d = FALSE, show.dist = TRUE, prob.to.each.tail = 0.025, 
digits = 5,legend.cex = .9,shade.col="gray",...)

shade.bin(x=NULL,from=NULL,to=NULL,n=1,p=0.5,tail="X=x",show.p=TRUE,
show.dist=TRUE, show.d=FALSE,legend.cex = .9,digits=5, ...)

shade.poi(x=NULL,from=NULL,to=NULL,lambda=5,tail="X=x",show.p=TRUE,
show.dist=TRUE, show.d=FALSE,legend.cex = .9,digits=5, ...)

shade.wei(x = NULL, from = NULL, to = NULL, theta = 1, beta = 1, tail = "lower", 
show.p = TRUE, show.d = FALSE, show.dist = TRUE, prob.to.each.tail = 0.025, 
digits = 5, legend.cex = 0.9, shade.col = "gray", ...)
}

\arguments{
  \item{x}{
A quantile, i.e. \eqn{X = x}, or if \code{tail = "two.custom"} ins \code{shade.norm}, a two element vector specifying the upper bound of the lower tail and the lower bound of the upper tail. 
}
  \item{from}{
To be used with \code{tail = "middle"}; the value \emph{a} in \eqn{P(a < X < b)}. 
}
  \item{to}{
To be used with \code{tail = "middle"}; the value \emph{b} in \eqn{P(a < X < b)}. 
}
  \item{sigma}{
Standard deviation for the nomral distribution.
}
  \item{mu}{
Mean of the normal distribution.
}
  \item{tail}{
One of four possibilities: \code{"lower"} provides lower tail shading, \code{"upper"} provides upper tail shading, \code{"two"} provides two tail shading, and \code{"middle"} provide shading in the middle of the pdf, between \code{"from"} and \code{"to"}.  The additional option \code{"two.custom"} is allowed for \code{shade.norm} and \code{shade.t}. This allows calculation of asymmetric two tailed probabilities.  It requires that the argument \code{x} is a two element vector with elements denoting the upper bound of the lower tail and the lower bound of the upper tail.  For discrete pdfs (binomial and Poisson) the possibility \code{"X=x"} is also allowed, and will be equivalent to the density. Two tailed probability is not implemented for \code{shade.poi}.  
}
  \item{show.p}{
Logical; indicating whether probabilities are to be shown.
}
  \item{show.d}{
Logical; indicating whether densities are to be shown.
}
  \item{show.dist}{
Logical; indicating whether parameters for the distribution are to be shown.
}
  \item{nu}{
Degrees of freedom.
}
  \item{nu1}{
Numerator degrees of freedom for the \emph{F}-distribution.
}
  \item{nu2}{
Denominator degrees of freedom for the \emph{F}-distribution.
}
  \item{prob.to.each.tail}{
Probability to be apportioned to each tail in the \emph{F} and Chi-square distributions if \code{tail = "two"}.
}
  \item{digits}{
Number of digits to be reported in probsabilities and densities.
}
  \item{n}{
The number of trials for the binomial pdf.
}
\item{p}{
The binomial probability of success.
}
\item{lambda}{
The Poisson parameter (i.e. rate).
}
\item{legend.cex}{
Character expansion for legends in plots.
}
\item{shade.col}{
Color of probability shading.
}
\item{theta}{
Pdf parameter.
}
\item{beta}{
Pdf parameter.
}

\item{\dots}{
Additional arguments to \code{\link{plot}}.}
}
\value{
Returns a plot with the requested pdf and probability shading.
}
\author{
Ken Aho
}
\note{
Lower-tailed chi-squared probabilities are not plotted correctly for df < 3.  
}
\examples{
\dontrun{
##normal
shade.norm(x=1.2,sigma=1,mu=0,tail="lower")
shade.norm(x=1.2,sigma=1,mu=0,tail="upper")
shade.norm(x=1.2,sigma=1,mu=0,tail="two")
shade.norm(from=-.4,to=0,sigma=1,mu=0,tail="middle")
shade.norm(from=0,to=0,sigma=1,mu=0,tail="middle")
shade.norm(x=c(-0.2, 2),sigma=1,mu=0,tail="two.custom")

##t
shade.t(x=-1,nu=5,tail="lower")
shade.t(x=-1,nu=5,tail="upper")
shade.t(x=-1,nu=5,tail="two")
shade.t(from=.5,to=.7,nu=5,tail="middle")
                                                                                        
##F
shade.F(x=2,nu1=15,nu2=8,tail="lower")
shade.F(x=2,nu1=15,nu2=8,tail="upper")
shade.F(nu1=15,nu2=8,tail="two",prob.to.each.tail=0.025)
shade.F(from=.5,to=.7,nu1=15,nu2=10,tail="middle")

##Chi.sq
shade.chi(x=2,nu=5,tail="lower")
shade.chi(x=2,nu=5,tail="upper")
shade.chi(nu=7,tail="two",prob.to.each.tail=0.025)
shade.chi(from=.5,to=.7,nu=5,tail="middle")

##binomial
shade.bin(x=5,n=20,tail="X=x",show.d=TRUE)
shade.bin(x=5,n=20,tail="lower")
shade.bin(x=5,n=20,tail="two")
shade.bin(from=8,to=12,n=20,tail="middle")

##Poisson
shade.poi(x=5,lambda=6,tail="X=x",show.d=TRUE)
shade.poi(x=5,lambda=7,tail="lower")
shade.poi(x=5,lambda=8,tail="upper")
shade.poi(from=8,to=12,lambda=7,tail="middle")
}
}
\keyword{graphs}
\keyword{univar}

\name{Venn}
\alias{Venn}
\alias{Venn.tck}

\title{Venn probability diagrams for an event with two outcomes}
\description{
The user specifies the probabilities of two outcomes, and if applicable, their intersection.  A Venn diagram is returned. The universe, S, will generally not have unit area, but in many applications will be a good approximation.  The area of the intersection will also be an approximation.   
}
\usage{
Venn(A, B, AandB = 0, labA = "A", labB = "B", cex.text = .95, ...)

Venn.tck()
}
\arguments{
  \item{A}{Probability of event A}
  \item{B}{Probability of event B}
  \item{AandB}{Probability of the intersection of A and B}
  \item{labA}{Label assigned to event A in the diagram}
  \item{labB}{Label assigned to event B in the diagram}
  \item{cex.text}{Character expansion for text.}
  \item{\dots}{Additional arguments from \code{\link{plot}}}
}
\value{
A Venn diagram is returned.  
}
\references{Bain, L. J., and M. Engelhardt (1992)  \emph{Introduction to Probability and Mathematical 
Statistics}.  Duxbury press.  Belmont, CA, USA.
}
\author{K. Aho}
\examples{
Venn(A=.3,B=.2,AandB=.06)
}
\keyword{graphs}

\name{death.penalty}
\alias{death.penalty}
\docType{data}
\title{
Florida state death penalty data
}
\description{
Dataset detailing death penalty 674 homicide trials in the state of Florida from 1976-1987 with respect to verdict, and victim and defendant race.  The data were previously used (Agresti 2012) to demonstrate Simpson's Paradox.
}
\usage{data(death.penalty)}
\format{
  A data frame with 8 observations on the following 4 variables.
  \describe{
    \item{\code{count}}{Counts from cross classifications.}
    \item{\code{verdict}}{Death penalty verdict \code{No} \code{Yes}.}
    \item{\code{d.race}}{Defendant's race \code{Black} \code{White}.}
    \item{\code{v.race}}{Victims' race \code{Black} \code{White}.}
  }
}
\details{
A reversal of associations or comparisons may occur as a result of lurking variables or aggregating groups.  This is called Simpson's Paradox.  
}
\source{
Agresti, A.  (2012)  \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley. 

Radelet, M. L., and G. L. Pierce  (1991) Choosing those who will die: race and the death 
penalty in Florida.  \emph{Florida Law Review}  43(1):1-34.

Simpson, E. H. (1951) The Interpretation of interaction in contingency tables. \emph{Journal of the Royal Statistical Society} Ser. B 13: 238-241.
}

\keyword{datasets}

\name{se.jack}
\alias{se.jack}
\alias{se.jack1}

\title{
Jackknife standard error from a set of pseudovalues
}
\description{
Calculates the conventional jackknife standard error from a set of pseudovalues. The function \code{se.jack} provides Tukey's jackknife estimator.  The function \code{se.jack} provides a measure associated with first order jackknife estimates of species richness (Heltsche and Forester 1983).
}
\usage{

se.jack(x)


se.jack1(x)
}

\arguments{

  \item{x}{
A numeric vector of pseudovalue, for instance from function \code{\link{pseudo.v}}.
}
}
\references{
Heltshe, J. F., and N. E. Forrester  (1983)  Estimating species richness using the jackknife procedure.  \emph{Biometrics} 39: 1-12. 
}


\author{
Ken Aho
}
\seealso{
\code{\link{pseudo.v}}}
\examples{
trag <- c(59, 49, 75, 43, 94, 68, 77, 78, 63, 71, 31, 59, 53, 48, 65, 73, 50, 59, 50, 57)
p <- pseudo.v(trag, statistic = mean)
se.jack(p[,2])
}

\name{bayes.lm}
\alias{bayes.lm}
\alias{print.blm}
\title{
Bayesian linear models with uniform priors 
}
\description{
Gelman et al. (2002) describe general methods for Bayesian implementation of simple linear models (e.g. simple and multiple regression and fixed effect one way ANOVA) with standard non-informative priors uniform on \eqn{\alpha, \sigma^2}. The function is not yet suited for multifactor or multivariance (random effect) ANOVAs. 
}
\usage{

bayes.lm(Y, X, model = "anova", length = 1000, cred = 0.95)
}

\arguments{

  \item{Y}{
An \emph{n} x \emph{1} column vector (a matrix with one column) containing the response variable.
}
  \item{X}{
The \emph{n} x \emph{p} design matrix
}
  \item{model}{
One of \code{"anova"} or \code{"reg"}.  Parameter output labels are changed depending on choice. 
}
  \item{length}{
Number of draws for posterior. 
}
  \item{cred}{
Level for credible interval. 
}
}
\value{
Provides the median and central credible intervals for model parameters.
}
\references{
Gelman, A., Carlin, J. B., Stern, H. S., and D. B. Rubin  (2003)  \emph{Bayesian Data Analysis, 2nd edition}.  Chapman and Hall/CRC. 
}
\author{
Ken Aho
}
\seealso{
\code{\link{mcmc.norm.hier}}
}
\examples{
\dontrun{
data(Fbird)
X <- with(Fbird, cbind(rep(1, 18), vol))
Y <- Fbird$freq
bayes.lm(Y, X, model = "reg")
}
}

\name{see.exppower.tck}
\alias{see.exppower.tck}

\title{
Visualize exponential power functions
}
\description{
Visualize exponential power functions, including a Gaussian distribution.
}
\usage{

see.exppower.tck()
}

\details{
The normal distribution and Gaussian distribution are based on an exponential power function:
\deqn{f(x)=exp(-|x|^{m})}
Letting \eqn{m = 2} results in a Gaussian distribution.  Standardizing this so that the area under the curve = 1 results in the standard normal distribution. 
}

\author{
Ken Aho
}
\seealso{
\code{\link{book.menu}}
}

\keyword{graphs}

\name{prostate}
\alias{prostate}
\docType{data}
\title{
Prostate cancer data
}
\description{Hastie et al. (2001) describe a cancer research study that attempted to associate prostate specific antigens and and a number of prognostic measures in the context of advanced prostate cancer.

Data in the experiment were collected from 97 men who were about to undergo radial prostectomies. 
}
\usage{data(prostate)}
\format{
 A data frame with 97 observations on the following 4 variables.
  \describe{
    \item{\code{PSA}}{Serum prostate-specific albumin level (mg/ml).}
    \item{\code{vol}}{Tumor volume (cc).}
    \item{\code{weight}}{Prostate weight (g).}
    \item{\code{Gleason}}{Pathologically determined grade of disease.  Summed scores were either 6, 7, or 8 with higher scores indicating worse prognosis.}
  }
}
\source{
Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li  (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston. 
}
\references{
Hastie, T., R. Tibshirani, and J. Friedman (2009) \emph{The Elements of Statistical Learning: Data Mining, Inference, and Prediction, Second Edition}. Springer.
}
\keyword{datasets}

\name{PM2.5}
\alias{PM2.5}
\docType{data}
\title{
PM 2.5 pollutant data from Pocatello Idaho
}
\description{
PM 2.5 pollutants (those less than 2.5 microns in diameter) can be directly emitted from sources such as forest fires, or can form when gases discharged from power plants, industries and automobiles react in the air. Once inhaled, these particles can affect the heart and lungs and cause serious health problems. The DEQ began monitoring PM 2.5 pollutants in Pocatello Idaho in November 1998. 
}
\usage{data(PM2.5)}
\format{
  A data frame with 65 observations on the following 2 variables.
  \describe{
    \item{\code{Yr.mos}}{Year and month.  A factor with levels \code{1998 11} \code{1998 12} \code{1999 1} \code{1999 10} \code{1999 11} \code{1999 12} \code{1999 2} \code{1999 3} \code{1999 4} \code{1999 5} \code{1999 6} \code{1999 7} \code{1999 8} \code{1999 9} \code{2000 1} \code{2000 10} \code{2000 11} \code{2000 12} \code{2000 2} \code{2000 3} \code{2000 4} \code{2000 5} \code{2000 6} \code{2000 7} \code{2000 8} \code{2000 9} \code{2001 1} \code{2001 10} \code{2001 11} \code{2001 12} \code{2001 2} \code{2001 3} \code{2001 4} \code{2001 5} \code{2001 6} \code{2001 7} \code{2001 8} \code{2001 9} \code{2002 1} \code{2002 10} \code{2002 11} \code{2002 12} \code{2002 2} \code{2002 3} \code{2002 4} \code{2002 5} \code{2002 6} \code{2002 7} \code{2002 8} \code{2002 9} \code{2003 1} \code{2003 10} \code{2003 11} \code{2003 12} \code{2003 2} \code{2003 3} \code{2003 4} \code{2003 5} \code{2003 6} \code{2003 7} \code{2003 8} \code{2003 9} \code{2004 1} \code{2004 2} \code{2004 3}}
    \item{\code{PM2.5}}{A numeric vector describing PM 2.5 pollutant levels in \eqn{mu}g/\eqn{m^2}.}
  }
}
\source{
Idaho department of Environmental Quality
}
\keyword{datasets}

\name{perm.fact.test}
\alias{perm.fact.test}
\title{Permutation test for two and three way factorial designs}
\description{
Provides permutation tests for two and three way designs, using permutations of of the response vector with respect to factor levels.  One way permutation tests are provided by \code{\link{MC.test}}, and the function \code{oneway_test} in \code{coin}.
}
\usage{
perm.fact.test(Y, X1, X2, X3 = NA, perm = 100, method = "a")
}
\arguments{

  \item{Y}{A vector of response data.  A quantitative vector.}
  \item{X1}{A vector of factor levels describing factor one.}
  \item{X2}{A vector of factor levels describing factor two.}
  \item{X3}{If necessary, a vector of factor levels describing factor three.}
  \item{perm}{Number of permutations.}
  \item{method}{Either \code{"a"} or \code{"b"}, see below.}
}
\details{
Manly (1997) describes five factorial permutation methods which allow testing of interactions.  None of these should be considered to be extensively tested or strongly supported by the statistical literature.
(a) In the first method observations are randomly allocated to factorial treatments preserving the sample size for each treatment.  
Permutation distributions of the \emph{F} statistics for A, B, and AB are used for statistical tests.
(b) In the second method observations are randomized as above but permutation distributions of MSA, MSB and MSAB are obtained. 
(c) Edgington (1995) recommended a restricted randomization procedure where observations within a main effect are randomized while holding other effects constant.  
Either mean squares or \emph{F} statistics can be used to create permutation distributions.  
Edgington emphasized that testing interactions with this method are not possible, but that by randomizing over all AB combinations (as in alternative "a" above) provides a test statistic sensitive to interactions.       
(d) Still and White (1981) recommended a restricted testing procedure (as in (c) above) but recommended testing interactions after "subtracting" main effects.  
(e) Ter Braak (1992) recommended replacing observations by their residuals from the initial linear model.  These are then permuted, assuming that sample sizes were equal to original sample sizes across interactions of treatments.  Permutation distributions of the \emph{F} statistics for A, B, and AB are then used for statistical tests.
Manly (1997) recommends methods a, b, d, or e. Methods a and b are currently implemented.

}
\value{
A dataframe is returned describing initial \emph{F} test statistics for main effects and interactions, degrees of freedom, and permutation \emph{P}-values.
}
\references{
Edgington, E. S. (1995)  \emph{Randomization Tests, 3rd edition}.  Marcel Dekker, New York.  

Manly, B. F. J. (1997)  \emph{Randomization and Monte Carlo Methods in Biology, 2nd edition}.  
Chapman and Hall, London.

Still, A. W., and A. P. White  (1981)  The approximate randomization test as an 
alternative to the \emph{F} test in analysis of variance.  \emph{British Journal of Mathematics and Statistical Psychology}.  34: 243-252.

Ter Braak, C. F. J.  (1992)  Permutation versus bootstrap significance tests in multiple 
regression and ANOVA.  In Jockel, K. J. (ed). \emph{Bootstrapping and Related Techniques}.  Springer-Verlag, Berlin.
}

\author{Ken Aho}
\seealso{\code{\link{MC.test}}}
\examples{
lizard<-data.frame(ants=c(13,242,105,8,59,20,515,488,88,18,44,21,182,21,7,24,312,68,
460,1223,990,140,40,27),size=factor(c(rep(1,12),rep(2,12))),
month=factor(rep(rep(c(1,2,3,4),each=3),2)))
attach(lizard)
perm.fact.test(ants,month,size,perm=100, method = "b")
}
\keyword{univar}
\keyword{htest}

\name{anm.ExpDesign}
\alias{anm.ExpDesign}
\alias{anm.ExpDesign.tck}
\alias{ExpDesign}
\title{Animated depiction of experimental designs}
\description{
Describes random treatment allocation for fifteen experimental designs.}
\usage{

anm.ExpDesign(method="all", titles =  TRUE, cex.text = 1, mp.col = NULL, lwda = 1, 
n = 10, EUcol = hcl.colors(n, palette = "Dark 3"), interval = 0.5, iter = 30)


ExpDesign(method="all", titles = TRUE, cex.text = 1, mp.col = NULL, lwda = 1, n = 10, 
EUcol = hcl.colors(n, palette = "Dark 3"),...)

anm.ExpDesign.tck()
}
\arguments{
  \item{method}{A character vector listing the experimental methods to be demonstrated (see \bold{Details} below).}  
  \item{titles}{A logical argument specifying whether or not plots should have \code{main} titles.}
  \item{interval}{Time length spent on each frame in animation (in seconds).}
  \item{iter}{Number of random iterations in animation.}
  \item{cex.text}{Text character expansion plots.}
  \item{mp.col}{Arrow colors in \code{"matched"} plot.  Either a vector of length 3 or a single color.}
  \item{lwda}{Arrow line widths.}
  \item{n}{Sample size (number of experimental units).  Currently only implemented for \code{method = "CRD"}}
  \item{EUcol}{Color of text identifying experimental units (or in some designs, treatments).  Currently only implemented for \code{method = "CRD"},  \code{method = "factorial2by2"}, \code{method = "RCBD"},  and \code{method = "nested"}}
  \item{\dots}{Additional arguments from \code{\link{plot}}.}
}
\details{
The function returns a plot or series of plots illustrating the workings of experimental designs. Random apportionment of treatments of experimental units (EUs) is illustrated for each of twelve experimental designs.  A character string can be specified in the \code{method} argument using a subset of any of the following: \cr
 \code{"CRD"}: a one-way completely randomized design,\cr
 \code{"factorial2by2"}: a 2 x 2 design with four EUs,\cr
 \code{"factorial2by2by2"}: a 2 x 2 x 2 factorial designs with 8 EUs,\cr 
 \code{"nested"}: a nested design with two levels of nesting,\cr
 \code{"RCBD"} a randomized complete block design with two blocks, two treatments and four EUs,\cr
 \code{"RIBD"}: a randomized incomplete block design with three blocks, three treatments, and six EUs,\cr
 \code{"split"}: a split plot design with a whole plot (factor A) and a split plot (factor B),\cr
 \code{"split.split"}: a split split-split plot design, \cr
 \code{"SPRB"}: split plots in randomized blocks,\cr
 \code{"strip.split"}: strip-split plot design,\cr
 \code{"latin"}: a Latin squares design with \emph{r} = 3, and \cr 
 \code{"pairs"}: a matched pairs design.\cr  
 The function \code{anm.ExpDesign.tck} provides an interactive GUI. Details on these designs are given below. 
}

 \section{Completely randomized design (CRD)}{
 In a \bold{completely randomized design} experimental units are each randomly assigned to factor levels without constraints like blocking.  This approach can (and should) be implemented in one way ANOVAs, and in more complex formats like factorial and hierarchical designs.  
 }
 \section{Factorial design}{
 Treatments can be derived by combining factor levels from the multiple factors.  This is called a \bold{factorial design}.  In a fully crossed factorial design with two factors, A and B, every level in factor A is contained in every level of factor B.
 }
 \section{Randomized block design (RBD)}{
 In a \bold{randomized block design} a researcher randomly assigns experimental units to treatments separately within units called blocks.  If all treatments are assigned exactly once within each block this is known as a \bold{randomized complete block design (RCBD)} 
 }
 \section{Latin squares}{
 \bold{Latin squares designs} are useful when there are two potential blocking variables.  These can figuratively or literally be represented by rows and columns.  All treatments are assigned to each row and to each column, and for each row and column treatment assignments differ.  Of course this stipulation limits the number of ways one can allocate treatments.  
 }                             
 \section{Nested design}{
 In a \bold{nested design} factor levels from one factor will be contained entirely in one factor level from another factor.  Consider a design with two factors A and B.  When every level of factor A appears with every level of factor B, and vice versa, then we have a fully crossed factorial design (see above).  Conversely, when levels of B only occur within a single level of A, then B is nested in A.
 }  
 \section{Split plot design}{
 A \bold{split plot} design contains two nested levels of randomization.  At the highest level are whole plots which are randomly assigned factor levels from one factor.  At a second nested level whole plots are split to form split plots.  The split plots are randomly assigned factor levels from a second factor.  Split plot designs are replicated in units called blocks. \bold{Split-split plot} design will have two levels of split plot nesting: C (split-split plots) are split plots within B (split plots), and B are split plots within A (whole plots).  We can see obvious and confusing similarities here to nested designs. A \bold{split plot randomized block} (\bold{SPRB}) design will have whole plots randomly assigned within blocks, and split plots randomly assigned within the whole plots.  Thus, levels of A (whole plot) are assigned randomly to a block, and split plots containing levels of B (split plot) are assigned within a level of A. 
 }
 \section{Strip plot design}{
 Closely related to split plot designs are strip plots. \bold{Strip plots} can be used address situations when relatively large experimental units are required for each of two factors in an experiment. A strip plot will have a row and column structure.  Let the number of columns equal to the number of levels in factor A, and let the number of rows be equal to the number of levels in factor B.  Levels in A are randomly assigned to columns only (across all rows) in a RBD format, and levels in B are assigned to rows only (across all columns). Interestingly, the levels in A serve as split plots in B and vice versa.  However, unlike a split plot design assignment of treatments at this level is not entirely random since rows are assigned single levels in A, while columns are assigned single levels in B.  Compared to a factorial design strip plots allow for greater precision in the measurement of interaction effects while sacrificing precision in the measurement of main effects.  Split-block design discussed by Littell et al. (2006), are indistinguishable from strip plots, described earlier, except that they are placed in the context of blocks.  They are also indistinguishable from SPRBs except that the design has an explicit row/column structure (one level of A for each column, one level of B for each row), resulting in larger experimental units for A and B. Conversely, in a SPRB, different levels of A and B can be assigned within columns and rows respectively.  A final type of split/strip plot design is known as a \bold{strip-split plot}.  Strip-split plots are three way designs (cf. Hoshmand 2006, Milliken and Johnson 2009).  In these models a conventional two factor strip plot is created (factors A and B) and split plots are placed in the resulting cells (levels in factor C). The design is indistinguishable from a split-split plot design except for the fact that "columns" always constitute the same levels in A, while "rows" always constitute the same levels in B, allowing larger experimental units for A and B, and reflecting the strip plot relationship of A and B.  Other, even more complex variants of split and strip plots are possible are possible.  For instance, Littell et al. (2006) discuss a case study they describe as strip-split-split plot design!  
}
\section{Matched pairs}{
In a \bold{matched pairs} design treatments are compared by using the same (or highly similar) experimental units.  If treatments are assigned at particular time segments it is assumed that outcomes within an experimental unit are independent, i.e., there is no "carryover" effect from the previous treatment.  Violation of this assumption may result in ashpericity and prevent conventional approaches.
}
\references{
Hoshmand, A. R. (2006) \emph{Design of Experiments for Agriculture and the Natural Sciences 2nd Edition}. CRC Press. 

Littell, R. C., Stroup, W. W., and R. J. Fruend  (2002)  \emph{SAS for linear models}. Wiley, New York.  

Milliken, G. A., and D. E. Johnson  (2009) \emph{Analysis of messy data: Vol. I. Designed 	experiments, 2nd edition}. CRC. 
}
\author{Ken Aho}
\seealso{
\code{\link{samp.design}}
}
\examples{
ExpDesign()
\dontrun{anm.ExpDesign()}
}
\keyword{design}
\keyword{graphs}

\name{ci.strat}
\alias{ci.strat}
\title{Confidence intervals for stratified random samples.
}
\description{
A statistical estimate along with its associated confidence interval can be considered to be an inferential statement about the sampled population.  However this statement will only be correct if the method of sampling is considered in the computations of standard errors.  The function \code{ci.strat} provides appropriate computations given stratified random sampling.
}
\usage{

ci.strat(data, strat, N.h, conf = 0.95, summarized = FALSE, use.t = FALSE, 
n.h = NULL, x.bar.h = NULL, var.h = NULL)
}
\arguments{
  \item{data}{A vector of quantitative data.  Required if \code{summarized=FALSE}.}
  \item{strat}{A vector describing strata.}
  \item{N.h}{
A vector describing the number of experimental units for each of the \emph{k} strata.}
  \item{conf}{Level of confidence; 1 - \emph{P}(type I error).}
  \item{summarized}{Logical.  Indicates whether summarized data are to be used.}
  \item{use.t}{Logical.  Indicates whether \emph{t} or \emph{z} confidence intervals should be built.}
  \item{n.h}{A vector indicating the number of experimental units sampled in each of the \emph{k} strata. Required if \code{summarized=TRUE}.}
  \item{x.bar.h}{A vector containing the sample means for each of the \emph{k} strata. Required if \code{summarized=TRUE}
.}
  \item{var.h}{A vector containing the sample variances for each of the \emph{k} strata. Required if \code{summarized=TRUE}.}
}
\details{
the conventional formula for the sample standard error assumes simple random sampling.  There are two other general types of sampling designs: stratified random sampling and cluster sampling.  Since cluster sampling is generally used for surveys involving human demographics we will only describe corrections for stratified random sampling here.  For more information on sample standard error adjustments for cluster sampling see Lohr (1999).   

For a stratified random sampling design let \emph{N} be the known total number of units in the defined population of interest, and assume that the population can be logically divided into \emph{k} strata; \eqn{N=N_1+N_2+N_3+\dots+N_k}  (i.e. we are assuming that we know both the total population size, and the population size of each stratum).  We sample each of the \emph{k} strata with \eqn{n_h} observations; \eqn{h=1,2,\dots,k}.  

We estimate the variance in the \emph{h}th stratum as:
\deqn{S^{2}_{h}=\frac{1}{n_h-1}\sum_{i=1}^{n_k}(X_{hi}-\bar{X}_h)^2}

where \eqn{X_{hi}} is the \emph{i}th observation from the \emph{h}th strata and \eqn{\bar{X}_h} is the \emph{h}th sample mean.  We estimate the true population total, \emph{T}, with:
\deqn{\hat{T}=\sum_{h=i}^{k}N_h\bar{X}_h}

We estimate the population mean, \eqn{\mu}, with:
\deqn{\bar{X}_{str}=\frac{\hat{T}}{N}}

An unbiased estimator for the standard error of \eqn{\bar{X}_{str}} is:
\deqn{S_{\bar{X}_{str}}=\sqrt{\sum_{h=1}^{k}\left(1-\frac{n_h}{N_h}\right)\left(\frac{N_h}{N}\right)^2\left(\frac{S_h^2}{n_h}\right)}}

The standard error of \eqn{\hat{T}} is also of interest.  Here is an unbiased estimator:
\deqn{S_{\hat{T}}=\sqrt{\sum_{h=1}^{k}\left(1-\frac{n_h}{N_h}\right)N_h^2\left(\frac{S_h^2}{n_h}\right)}}

Note that these standard errors have both a finite population correction and adjustments for stratification built into them.  Assuming that sample sizes within each stratum are large or that the sampling design has a large number of strata, a 100(1 - \eqn{\alpha})percent confidence interval for \eqn{\mu}  and \emph{T} can be constructed using:

\deqn{\bar{X}_{str}\pm z_{1-\alpha/2}S_{\bar{X}_{str}}}
\deqn{\hat{T}\pm z_{1-\alpha/2}S_{\hat{T}}}

In situations where sample sizes or the number of strata are small, a \eqn{t(n - k)} distribution can (and should) be used for calculation of confidence intervals,  where \eqn{n=n_1+n_2+\dots+n_k}.
}
\value{
Returns a list with two items:
\item{strat.summary}{A matrix with columns: \code{N.h,n.h,x.bar.h} and \code{var.h}}
\item{CI}{Confidence intervals for \eqn{\mu} and \emph{T}}

}
\references{
Lohr, S. L. (1999) \emph{Sampling: Design and Analysis}.  Duxbury Press.  Pacific Grove, USA.

Siniff, D. B., and Skoog, R. O. (1964)  Aerial censusing of caribou using stratified 
random sampling.  \emph{Journal of Wildlife Management} 28: 391-401.
}
\author{Ken Aho}
\seealso{\code{\link{ci.mu.z}}}
\examples{
#Data from Siniff and Skoog (1964)
Caribou<-data.frame(Stratum=c("A","B","C","D","E","F"),N.h=c(400,30,61,18,70,120),
n.h=c(98,10,37,6,39,21),x.bar.h=c(24.1,25.6,267.6,179,293.7,33.2),
var.h=c(5575,4064,347556,22798,123578,9795))
attach(Caribou)
ci.strat(data,strat=Stratum,N.h=N.h,conf=.95,summarized=TRUE,use.t=FALSE,n.h=n.h,
x.bar.h=x.bar.h,var.h=var.h)
}

\keyword{univar}
\keyword{htest}

\name{e.cancer}
\alias{e.cancer}
\docType{data}
\title{Esophageal cancer data modified slightly to create a balanced three-way 
factorial design}
\description{Breslow and Day (1980) studied the effect of age, tobacco, and 
alcohol on esophageal cancer rates at Ile-et-Vilaine, France.  Data 
are altered slightly to make the design balanced, and to allow enough degrees 
of freedom to perform a fully factorial three way ANOVA.
}
\usage{data(e.cancer)}
\format{
The dataset contains four variables:
  \describe{
     \item{age grp.}{age group, a factor with four levels: \code{"25-34", "35-44", "45-54", "55-64"}, and \code{"65-74"}.}
     \item{alcohol}{alcohol consumed (g/day).}	
     \item{tobacco}{tobacco consumed (g/day).}	
     \item{cases}{number of esophageal cancer cases.}
  }
}
\source{
Breslow, N. E. and N. E. Day (1980) \emph{Statistical Methods in Cancer Research. 1: The 
Analysis of Case-Control Studies}. IARC Lyon / Oxford University Press. 
}

\keyword{datasets}

\name{book.menu}
\alias{book.menu}
\title{Pulldown menus for 'asbio' interactive graphical functions
}
\description{
Provides a pulldown GUI menus to allow access to \pkg{asbio} statistical and biological graphical demos, e.g. \code{\link{anm.ci}}, \code{\link{samp.dist}}, \code{\link{anm.loglik}}, etc.  The function \code{demos} is deprecated.  The function \code{book.menu} currently provides links to over 100 distinct GUIs (many of these are slaves to other GUIs), which in turn provide distinct graphical demonstrations. The GUIs work best with an SDI R interface.   
}
\usage{
book.menu()
}


\author{Ken Aho and Roy Hill (Roy created the \code{book.menu} GUI)}

\seealso{
\code{\link{anm.coin}},  \code{\link{anm.ci}},  \code{\link{anm.die}},  \code{\link{anm.exp.growth}},  \code{\link{anm.geo.growth}},  \code{\link{anm.log.growth}}, \code{\link{anm.loglik}},  \code{\link{anm.LVcomp}},  \code{\link{anm.LVexp}},  \code{\link{anm.ls}},  \code{\link{anm.ls.reg}},  \code{\link{anm.transM}}, \code{\link{see.lmu.tck}}, \code{\link{samp.dist}}, \code{\link{see.HW}},  \code{\link{see.logic}},  \code{\link{see.M}},   \code{\link{see.move}}, \code{\link{see.nlm}}, \code{\link{see.norm.tck}},  \code{\link{see.power}},  \code{\link{see.regression.tck}},   \code{\link{see.typeI_II}}, \code{\link{selftest.se.tck1}},  \code{\link{shade.norm}}, \code{\link{Venn}}} 
\examples{
\dontrun{
book.menu()
}
}
\keyword{graphs}

\name{see.typeI_II}
\alias{see.typeI_II}

\title{
Interactive depiction of type I and II error
}
\description{
The function provides a \pkg{tcltk} GUI illustrating type I, type II error, and power.
}
\usage{
see.typeI_II()
}
\author{Ken Aho
}
\seealso{
\code{\link{see.power}},\code{\link{power.z.test}}
}
\keyword{graphs}

\name{pairw.anova}
\alias{pairw.anova}
\alias{lsdCI}
\alias{bonfCI}
\alias{tukeyCI}
\alias{scheffeCI}
\alias{dunnettCI}
\alias{scheffe.cont}
\alias{bonf.cont}
\alias{print.pairw}

\title{Conducts pairwise post hoc and planned comparisons associated with an ANOVA}
\description{
The function \code{pairw.anova} replaces the defunct \code{Pairw.test}. Conducts all possible pairwise tests with adjustments to \emph{P}-values using one of five methods: Least Significant difference (LSD), Bonferroni, Tukey-Kramer honest significantly difference (HSD), Scheffe's method, or Dunnett's method. 
Dunnett's method requires specification of a control group, and does not return adjusted \emph{P}-values.  The functions \code{scheffe.cont} and \code{bonf.cont} allow Bonferroni and Scheffe's family-wise adjustment of individual planned pairwise contrasts.    
}
\usage{

pairw.anova(y, x, conf.level = 0.95, method = "tukey", 
MSE = NULL, df.err = NULL, control = NULL)

lsdCI(y, x, conf.level = 0.95, MSE = NULL, df.err = NULL)

bonfCI(y, x, conf.level = 0.95, MSE = NULL, df.err = NULL)

tukeyCI(y, x, conf.level = 0.95, MSE = NULL, df.err = NULL)

scheffeCI(y, x, conf.level = 0.95, MSE = NULL, df.err = NULL)

dunnettCI(y, x, conf.level = 0.95, control = NULL)

scheffe.cont(y, x, lvl = c("x1", "x2"), conf.level = 0.95, 
MSE = NULL, df.err = NULL)

bonf.cont(y, x, lvl = c("x1", "x2"), conf.level = 0.95, 
MSE = NULL, df.err = NULL, comps = 1)

}
\arguments{
  \item{y}{A quantitative vector containing the response variable}
  \item{x}{A categorical vector containing the groups (e.g. factor levels or treatments)}
  \item{conf.level}{1 - \emph{P}(type I error)}
  \item{method}{One of five possible choices: \code{"lsd", "bonf", "tukey", "scheffe", "dunnett"}}
  \item{MSE}{Value of MSE from the ANOVA model.  Default = \code{NULL}}
  \item{df.err}{Degrees of freedom error from the omnibus ANOVA.  Default = \code{NULL}}
  \item{control}{Control group for Dunnett's test.}
  \item{lvl}{A two element vector defining two factor levels to be compared using Scheffe's and the Bonferroni method.}
  \item{comps}{The number of comparisons to be made in the Bonferroni method.}
}  
\details{Adjustment of comparison type I error for simultaneous inference is a contentious subject and will not be discussed here.  For description of methods go to Kutner et al. (2005). For models where the number of factors is \eqn{\ge 2}, MSE and the residual degrees of freedom (used in the computation of confidence intervals for all pairwise methods used here) will vary depending on the experimental design and the number of factors.  
Thus, for multifactor designs the user should specify the residual degrees of freedom and MSE from the overall ANOVA.  This will be unnecessary for one-way ANOVAs.}
\value{
The function \code{pairw.anova} and the confidence interval functions it calls return a list of \code{class = "pairw"}.  For all but the LSD test (which also returns LSD) and Dunnett's test (which does not return adjusted \emph{P}-values), the utility function \code{print.pairw} returns a descriptive head and a six column summary dataframe containing: 

1) the type of contrast (names are taken from levels in \code{x}),

2) the mean difference, 

3) the lower confidence bound of the true mean difference, 

4) the upper confidence bound of the true mean difference, 

5) the hypothesis decision, given the prescribed significance level, and 

6) the adjusted \emph{P}-value.

Other \code{invisible} objects include:
  \item{cont}{a vector of contrasts.}
  \item{conf}{The confidence level.}
  \item{band}{A two column matrix containing the lower and upper confidence bounds.}

The \code{pairw} class also has a utility function \code{\link{plot.pairw}} which provides either a barplot of location measures with errors and letters indicating whether true effects are significant and the defined significance level (argument \code{type = 1}) or confidence intervals for the true difference of each comparison (argument \code{type = 2}).  See code below and and \code{\link{plot.pairw}} for examples.    
}
\references{Kutner, M. H., Nachtsheim, C. J., Neter, J., and Li., W  (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.
}
\author{Ken Aho}
\note{Different forms of these functions have existed for years without implementation into libraries.  My version here, based on the function \code{\link{outer}} is unique.}
\seealso{\code{\link{plot.pairw}}.  Functions from library \pkg{mult.comp} provide more sophisticated comparisons including customized contrasts and one tailed tests.}
\examples{
eggs<-c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)
trt<-as.factor(c(1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,4,4,4))

pairw.anova(y = eggs, x = trt, method = "lsd")##LSD method
pairw.anova(y = eggs, x = trt, method = "bonf")##Bonferroni
pairw.anova(y = eggs, x = trt, method = "scheffe")##Sheffe
tukey <- pairw.anova(y = eggs, x = trt, method = "tukey")##Tukey HSD

plot(tukey)
# you can also try plot(tukey, type = 2)

blood.count <- data.frame(bc=c(7.4,8.5,7.2,8.24,9.84,8.32,9.76,8.8,
7.68,9.36,12.8,9.68,12.16,9.2,10.55), trt=c(rep("C",6),rep("A",4),rep("B",5)))
with(blood.count,pairw.anova(y=bc,x=trt,control="C",method="dunnett"))## Dunnett

scheffe.cont(y = eggs, x = trt, lvl = c(1, 3)) 
scheffe.cont(y = eggs, x = trt, lvl = c(1,2))

bonf.cont(y = eggs, x = trt, lvl = c(1,3), comps = 2) 
bonf.cont(y = eggs, x=trt, lvl = c(1,2), comps = 2) 
}

\keyword{univar}
\keyword{htest}

\name{anm.ci}
\alias{anm.ci}
\alias{anm.ci.tck}
\title{
Animation demonstrations of confidence intervals.
}
\description{
Provides animated depictions of confidence intervals for \eqn{\mu}, \eqn{\sigma^{2}}, the population median, and the binomial parameter \eqn{\pi}.
}
\usage{

anm.ci(parent=expression(rnorm(n)), par.val, conf = 0.95, sigma = NULL,
  par.type = c("mu", "median", "sigma.sq", "p"), n.est = 100,
  n = 50, err.col = 2, par.col = 4, interval = 0.1, ...)

anm.ci.tck()

}

\arguments{
  \item{parent}{A parental distribution; ideally a distribution with known parameters.}
  \item{par.val}{True parameter value which is being estimated.}
  \item{conf}{Confidence level: 1-\emph{P}(type I error).}
  \item{sigma}{\eqn{\sigma} from the normal pdf, if known.}
  \item{par.type}{The parameter whose confidence intervals to be estimated.  There are
  currently four choices \code{c("mu", "median", "sigma.sq", "p")}.  These are the normal pdf
  parameters \eqn{\mu} and \eqn{\sigma^{2}}, the population median, and the binomial
  parameter, \eqn{\pi}.}
  \item{n.est}{The number of confidence intervals to be created.}
  \item{n}{The sample size used for each confidence interval.}
  \item{err.col}{The line color of the intervals which do not include the true value.}
  \item{par.col}{The line color denoting the parameter value.}
  \item{interval}{The time interval for animation (in seconds).  Smaller intervals speed up animation}
  \item{\dots}{Additional arguments to \code{\link{plot}}.}
}
\details{
Provides an animated plot showing confidence intervals with respect to a known parameter.  Intervals which do not contain the parameter are emphasized with different colors. The function can be run with a \pkg{tcltk} GUI function, \code{anm.ci.tck()}.
}
\value{
Returns an animated plot.
}
\author{Ken Aho}
\seealso{Additional documentation for methods provided in: \code{\link{ci.mu.t}}, \code{\link{ci.mu.z}}, \code{\link{ci.median}}, \code{\link{ci.sigma}}, and \code{\link{ci.p}}.
}
\examples{
\dontrun{
parent<-rnorm(100000)
anm.ci(parent, par.val=0, conf =.95, sigma =1, par.type="mu")
anm.ci(parent, par.val=1, conf =.95, par.type="sigma.sq")
anm.ci(parent, par.val=0, conf =.95, par.type="median")
parent<-rbinom(100000,1,p=.65)
anm.ci(parent, par.val=0.65, conf =.95, par.type="p")
##Interactive GUI, requires package 'tcltk'
anm.ci.tck()
}
}
\keyword{graphs}

\name{selftest.se.tck1}
\alias{selftest.ANVOVA_design.tck}
\alias{selftest.ANOVAsiminf.tck1}
\alias{selftest.ANOVAmixed.tck1}
\alias{selftest.ANVOVA_design_review.tck}
\alias{selftest.corr.tck1}
\alias{selftest.conf.tck1}
\alias{selftest.comb.tck}
\alias{selftest.bayes4.tck}
\alias{selftest.bayes5.tck}
\alias{selftest.H0.tck}
\alias{selftest.jack.tck}
\alias{selftest.ML_OLS.tck}
\alias{selftest.nonparametric6.tck}
\alias{selftest.pdfs.tck}
\alias{selftest.prob.tck}
\alias{selftest.regGLM.tck1}
\alias{selftest.regchar.tck1}
\alias{selftest.regdiag.tck1}
\alias{selftest.regdiag.tck2}
\alias{selftest.regdiag.tck3}
\alias{selftest.regapproaches.tck1}
\alias{selftest.regapproaches.tck2}
\alias{selftest.regapproaches.tck3}
\alias{selftest.regapproaches.tck4}
\alias{selftest.sampd.tck1}
\alias{selftest.science.tck1}
\alias{selftest.se.tck1}
\alias{selftest.stats.tck}
\alias{selftest.stats.tck1}
\alias{selftest.ttest.tck}
\alias{selftest.codettest.tck}
\alias{selftest.typeIISS.tck1}

\title{
Interactive self-testing questions
}
\description{
These functions provide interactive multiple-choice questions.
}
\usage{
selftest.se.tck1()
}
\author{
Ken Aho
}

\name{anscombe}
\alias{anscombe}
\docType{data}
\title{
Anscombe's quartet
}
\description{
A set of four bivariate datasets with the same conditional means, conditional variances, linear regressions, and correlations, but with dramatically different forms of association. 
}
\usage{data(anscombe)}
\format{
  A data frame with 11 observations on the following 8 variables.
  \describe{
    \item{\code{x1}}{The first conditional variable in the first bivariate dataset.}
    \item{\code{y1}}{The second conditional variable in the first bivariate dataset.}
    \item{\code{x2}}{The first conditional variable in the second bivariate dataset.}
    \item{\code{y2}}{The second conditional variable in the second bivariate dataset.}
    \item{\code{x3}}{The first conditional variable in the third bivariate dataset.}
    \item{\code{y3}}{The second conditional variable in the third bivariate dataset.}
    \item{\code{x4}}{The first conditional variable in the fourth bivariate dataset.}
    \item{\code{y4}}{The second conditional variable in the fourth bivariate dataset.}
  }
}
\details{
Anscombe (1973) used these datasets to demonstrate that summary statistics are inadequate for describing association.
}
\source{
Anscombe, F. J.  (1973)  Graphs in statistical analysis. \emph{American Statistician} 27 (1): 17-21.
}
\references{
Anscombe, F. J.  (1973)  Graphs in statistical analysis. \emph{American Statistician} 27 (1): 17-21.
}
\examples{
# dev.new(height=3.5)
op <- par(mfrow=c(1,4),mar=c (0,0,2,3), oma = c(5, 4.2, 0, 0))
with(anscombe, plot(x1, y1, xlab = "", ylab = "", main = bquote(paste(italic(r),
" = ",.(round(cor(x1, y1),2)))))); abline(3,0.5) 
with(anscombe, plot(x2, y2, xlab = "", ylab = "",, main = bquote(paste(italic(r),
" = ",.(round(cor(x2, y2),2)))))); abline(3,0.5) 
with(anscombe, plot(x3, y3, xlab = "", ylab = "",, main = bquote(paste(italic(r),
" = ",.(round(cor(x3, y3),2)))))); abline(3,0.5) 
with(anscombe, plot(x4, y4, xlab = "", ylab = "",, main = bquote(paste(italic(r),
" = ",.(round(cor(x4, y4),2)))))); abline(3,0.5) 
mtext(expression(italic(y[1])),side=1, outer = TRUE, line = 3)
mtext(expression(italic(y[2])),side=2, outer = TRUE, line = 2.6)
mtext("(a)",side=3, at = -42, line = .5)
mtext("(b)",side=3, at = -26, line = .5)
mtext("(c)",side=3, at = -10.3, line = .5)
mtext("(d)",side=3, at = 5.5, line = .5)
par(op)
}
\keyword{datasets}

\name{ConDis.matrix}
\alias{ConDis.matrix}
\title{Calculation and display of concordant and discordant pairs}
\description{
Calculates whether pairs of observations from two vectors are concordant discordant or neither.  
These are displayed in the lower diagonal of a symmetric output matrix as 1, -1 or 0.
}
\usage{

ConDis.matrix(Y1, Y2)
}
\arguments{

  \item{Y1}{A vector of quantitative data.}
  \item{Y2}{A vector of quantitative data.  Observations are assumed to be paired
   with respective observations from \code{Y1}.}
}
\details{
Consider all possible combinations of \eqn{(Y_{1i}, Y_{ij})} and \eqn{(Y_{2i}, Y_{ij})} where \eqn{1<=i<j<=n}.  A pair is concordant if \eqn{Y_{1i} > Y_{1j}} and \eqn{Y_{2i} > Y_{2j}} or if \eqn{Y_{1i} < Y_{1j}} and  \eqn{Y_{2i} < Y_{2j}}.  Conversely, a pair is discordant if \eqn{Y_{1i} < Y_{1j}} and \eqn{Y_{2i} > Y_{2j}} or if \eqn{Y_{1i} > Y_{1j}} and \eqn{Y_2i < Y_2j}.  This information has a number of important uses including calculation of Kendall's \eqn{\tau}.}
\value{
A matrix is returned.  Elements in the lower triangle indicate whether observations are concordant (element = \code{1}), discordant (element = \code{-1}) or neither (element = \code{0}).
}
\references{
Hollander, M., and  Wolfe, D. A. (1999) \emph{Nonparametric statistical methods}. New York: John Wiley & Sons. 

Liebetrau, A. M. (1983) \emph{Measures of association}. Sage Publications, Newbury Park, CA.

Sokal, R. R., and Rohlf, F. J. (1995)  \emph{Biometry}.  W. H. Freeman and Co., New York. }
\seealso{\code{\link{cor}}}
\author{Ken Aho}
\examples{
#Crab data from Sokal and Rohlf (1998)
crab<-data.frame(gill.wt=c(159,179,100,45,384,230,100,320,80,220,320,210),
body.wt=c(14.4,15.2,11.3,2.5,22.7,14.9,1.41,15.81,4.19,15.39,17.25,9.52))
attach(crab)
crabm<-ConDis.matrix(gill.wt,body.wt)
crabm
}

\name{r.bw}
\alias{r.bw}
\title{Biweight midvariance, and biweight midcorrelation. 
}
\description{
Calculates biweight midvariance if one variable is given and biweight midvariances, midcovariance and midcorrelation if two variables are given. Biweight midcorrelation is a robust alternative to Pearson's \emph{r}.
}
\usage{
r.bw(X, Y=NULL)
}
\arguments{
  \item{X}{A numeric vector
}
  \item{Y}{An optional second numeric variable.
}
}
\details{
Biweight statistics are robust to violations of normality.   Like the sample median the sample midvariance has a breakdown point of approximately 0.5.  The triefficiency of the biweight midvariance was the highest for any of the 150 measures of scale compared by Lax (1985). 
}
\value{
Returns the biweight variance if one variable is given, and the biweight midvariances, midcovariance and midcorrelation if two variables are given. 
}
\references{
Lax, D. A.  (1985)  Robust estimators of scale: finite sample performance in long-tailed symmetric distributions.  \emph{Journal of the American Statistical Association}, 80 736-741.

Wilcox, R. R.  (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho
}
\seealso{\code{\link{cor}}, \code{\link{r.pb}}}

\examples{
x<-rnorm(100)
y<-rnorm(100)
r.bw(x,y)
}
\keyword{univar}

\name{anm.die}
\alias{anm.die}
\alias{anm.die.tck}

\title{
Animated depiction of six-sided die throws.
}
\description{
Convergence in probability for fair (or loaded) six-sided die.
}
\usage{

anm.die(reps = 300, interval = 0.1, show.die = TRUE, p = c(1/6, 1/6, 1/6, 
1/6, 1/6, 1/6), cl = TRUE)

anm.die.tck()
}
\arguments{
  \item{reps}{Number of die throws.
}
  \item{interval}{
Animation interval in frames per second.
}
  \item{show.die}{
Logical, indicating whether die outcomes should be shown.
}
  \item{p}{
A vector of length six which sums to one indicating the probability of die outcomes.
}
  \item{cl}{
Logical,  Indicating whether or not color should be used.
}
}
\author{
Ken Aho
}
\seealso{
\code{\link{anm.coin}}}
\examples{
\dontrun{
anm.die()
}
}
\keyword{graphs}

\name{bplot}
\alias{bplot}
\title{
Barplots with error bars (including interval plots)
}
\description{
Creates barplots for displaying statistical summaries by treatment (e.g. means, medians, \emph{M}-estimates of location, standard deviation, variance, etc.) and 
their error estimates by treatment (i.e. standard errors, confidence intervals, \emph{IQR}s, \emph{IQR} confidence intervals, and \emph{MAD} intervals). Custom intervals can also be created.  
The function can also be used to display letters indicating if comparisons of locations are significant after adjustment for simultaneous inference (see \code{\link{pairw.anova}}, \code{\link{pairw.kw}}, and/or \code{\link{pairw.fried}}).
}
\usage{
bplot(y, x, bar.col = "gray", loc.meas = mean, sort = FALSE, order = NULL, int = "SE",
 conf = 0.95, uiw = NULL, liw = NULL, sfrac = 0.1, slty = 1, scol = 1,
 slwd = 1, exp.fact = 1.5, simlett = FALSE, lett.side = 3, lett = NULL,
 cex.lett = 1, names.arg = NULL, ylim = NULL, horiz = FALSE, xpd = FALSE, 
 print.summary = TRUE, ...)
}

\arguments{
  \item{y}{A quantitative vector representing the response variable.}
  \item{x}{A categorical vector representing treatments (e.g. factor levels).}
  \item{bar.col}{Color of bar.}
  \item{loc.meas}{Measure of location or other summary statistic, e.g. mean, median, etc.}
  \item{sort}{Logical, if \code{TRUE}, then treatments are ordered by their location statistics.}
  \item{order}{A vector of length equal to the number of factor levels, specifying the order of bars with respect to the alphanumeric order of their names.}
  \item{int}{Type of error bar to be drawn, must be one of \code{"SE"}, \code{"CI"}, \code{\link{IQR}}, \code{"MAD"}, \code{"IQR.CI"} or \code{"bootSE"}.  IQR-derived confidence intervals are based on \eqn{\pm-1.58 IQR/\sqrt{n}} and provide an approximate 95\% confidence interval for the difference in two medians.  The measure can be attributed to Chambers et al. (1983, p. 62), given McGill et al. (1978, p. 16). It is based on asymptotic normality of the median and assumes roughly equal sample sizes for the two medians being compared.  The interval is apparently insensitive to the underlying distributions of the samples. The specification \code{"bootSE"} gives bootstrap SEs for the location measure using the function \code{\link{bootstrap}}}
  \item{conf}{Level of confidence, 1 - \emph{P}(type I error).}
  \item{uiw}{Upper \emph{y}-coordinate for the error bar, if \code{NULL} then this will be computed from \code{int}.} 
  \item{liw}{Lower \emph{y}-coordinate for the error bar, if \code{NULL} then this will be computed from \code{int}.}  
  \item{sfrac}{Scaling factor for the size of the "serifs" (end bars) on the confidence bars, in \emph{x}-axis units.}
  \item{slty}{Line type for error bars.}
  \item{scol}{Line color for error bars.}
  \item{slwd}{Line width for error bars.}
  \item{exp.fact}{A multiplication factor indicating how much extra room is made for drawing letters in top of graph.  Only used if \code{simlett = TRUE}.}
  \item{simlett}{A logical statement indicating whether or not letters should be shown above bars indicating that populations means have been determined to be significantly different. }
  \item{lett.side}{Side that letters will be drawn on, 1 = bottom, 2 = left, 3 = top, 4 = right.}
  \item{lett}{A vector of letters or some other code to display multiple comparison results.}
  \item{cex.lett}{Character expansion for multiple comparison result letters.}
  \item{names.arg}{A vector of names to be plotted below each bar or error bar. If this argument is omitted, then the names are taken from the names attribute of \code{y}.}
  \item{ylim}{Upper and lower limits of the \emph{Y}-axis}
  \item{horiz}{Logical value. If \code{FALSE}, then bars are drawn vertically with the first bar to the left. If \code{TRUE}, then bars are drawn horizontally with the first at the bottom.}
  \item{xpd}{Logical value. If \code{FALSE}, this overrides \code{\link{barplot}} designation \code{xpd = TRUE}, which may cause bars to extend off the plot if \code{ylim} is modified.}
  \item{print.summary}{Logical value.  If \code{TRUE} a summary of the location and dispersion measures used in the plot is printed.}
  \item{\dots}{Additional arguments from \code{\link{barplot}}.}
}
\details{
It is often desirable to display the results of a pairwise comparison procedure using sample measures of location and error bars.  This functions allows these sorts of plots to be made. The function is essentially a wrapper for the function \code{\link{barplot}}.
}
\value{
A plot is returned.  Bar centers (ala \code{\link{barplot}}) are returned invisibly. 
}
\author{Ken Aho}
\seealso{\code{\link{mad}}, \code{\link{barplot}}, \code{\link{pairw.anova}}, \code{\link{pairw.kw}}, \code{\link{pairw.fried}}}
\references{
Chambers, J. M., Cleveland, W. S., Kleiner, B. and Tukey, P. A. (1983) \emph{Graphical Methods for Data Analysis}. Wadsworth & Brooks/Cole.

McGill, R., Tukey, J. W. and Larsen, W. A. (1978) Variations of box plots. \emph{The American Statistician} 32, 12-16.}  
\examples{
eggs<-c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)
trt<-c(1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,4,4,4)
bplot(y=eggs, x=factor(trt),int="SE",xlab="Treatment",ylab="Mean number of eggs",
simlett=TRUE, lett=c("b","b","b","a"))
}
\keyword{graphs}

\name{caribou}
\alias{caribou}
\docType{data}
\title{
Caribou count data
}
\description{Stratified random sampling was used to estimate the size of the Nelchina herd of Alaskan caribou (\emph{Rangifer tarandus}) in February 1962 (Siniff and Skoog 1964).  
The total population of sample units (for which responses would be counts of caribou) consisted of 699 four mile\eqn{^2} areas.  This population was divided into six strata, and each of these was randomly sampled.
}

\usage{data(caribou)}
\format{
  A data frame with 6 observations on the following 5 variables.
  \describe{
    \item{\code{stratum}}{Strata; a factor with levels \code{A} \code{B} \code{C} \code{D} \code{E} \code{F}}
    \item{\code{N.h}}{Strata population size}
    \item{\code{n.h}}{Strata sample size}
    \item{\code{x.bar.h}}{Strata means}
    \item{\code{var.h}}{Strata variances}
  }
}

\source{
Siniff, D. B., and R. O. Skoog (1964)  Aerial censusing of caribou using stratified random sampling.  
\emph{Journal of Wildlife Management} 28: 391-401. 

}

\keyword{datasets}

\name{auc}
\alias{auc}

\title{
Area under a receiver operating characteristic (ROC) curve
}
\description{
A simple algorithm for calculating \emph{AUC}.
}
\usage{

auc(obs, fit, plot = FALSE)
}

\arguments{

  \item{obs}{
Dichotomous \code{0, 1} outcomes (i.e., response values for binomial GLM).
}
  \item{fit}{
Fitted probabilities from some model.
}
  \item{plot}{
Logical, indicating whether or not ROC curve plot should be created.}
}
\references{
Agresti, A.  (2012) \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley. 
}
\author{
Ken Aho
}
\examples{
\dontrun{
obs <-rbinom(30, 1, 0.5)
fit <- rbeta(30, 1, 2)
auc(obs, fit)}
}

\name{G.mean}
\alias{G.mean}
\title{Geometric mean}
\description{Calculates the geometric mean.}
\usage{G.mean(x)}
\arguments{
  \item{x}{A vector of quantitative data.}
}
\value{Returns the geometric mean.}
\author{Ken Aho}
\seealso{\code{\link{H.mean}}, \code{\link{HL.mean}}}
\examples{
x<-c(2,1,4,5,6,2.4,7,2.2,.002,15,17,.001)
G.mean(x)
}

\name{anm.ls}
\alias{anm.ls}
\alias{anm.ls.tck}
\title{
Animated plot of least squares function.
}
\description{Depicts the process of least squares estimation by plotting the least squares function with respect to a vector of estimate possibilities.
}
\usage{

anm.ls(X, poss=NULL, parameter = "mu", est.lty = 2, est.col = 2,
conv=diff(range(X))/50, anim=TRUE, plot.lsfunc = TRUE, plot.res = TRUE, 
interval=0.01, xlab=expression(paste("Estimates for ", italic(E),
"(",italic(X),")", sep = "")),...)

anm.ls.tck()
}
\arguments{

  \item{X}{
A numeric vector containing sample data.
}
  \item{poss}{
An ordered numeric sequence of possible parameter estimates.  Inclusion of the least squares estimate in the vector (e.g. \eqn{\bar{X}} for \eqn{\mu} will cause the least squares function be minimized at this value.
}
  \item{parameter}{
Parameter to be estimated.  Only estimation for \emph{E}(\emph{X}) is currently implemented.  Note that if  \emph{X} ~ \emph{N}(\eqn{\mu},\eqn{\sigma^2}) then \emph{E}(\emph{X}) =  \eqn{\mu}.}
  \item{est.lty}{
Line type to be used to indicate the least squares estimate.
}
  \item{est.col}{
Line color to be used to indicate the least squares estimate.
}
  \item{conv}{Precision of LS function.  Decreasing \code{conv} increases the smoothness and precision of the function.}
  \item{anim}{A logical command indicating whether animation should be used in plots.}  
  \item{plot.lsfunc}{A logical command indicating whether the least-squares function should be plotted.}
  \item{plot.res}{A logical command indicating whether a plot of residuals should be created.}
  \item{interval}{Speed of animation (in frames per second).  A smaller interval decreases speed.  May not work in all systems; see \code{\link{Sys.sleep}}.} 
  \item{xlab}{\emph{X}-axis label.}
  \item{\dots}{
Additional arguments to \code{\link{plot}}
}
}

\value{
A plot of the least squares function is returned along with the least squares estimate for E(\emph{X}) given a set of possibilities.  The function \code{anm.ls.tck} provides a GUI to run the function.
}
\author{
Ken Aho
}
\seealso{
\code{\link{loglik.plot}}
}
\examples{
\dontrun{X<-c(11.2,10.8,9.0,12.4,12.1,10.3,10.4,10.6,9.3,11.8)
anm.ls(X)}
}
\keyword{graphs}

\name{trim.ranef.test}
\alias{trim.ranef.test}
\title{Robust test for random factors using trimmed means.}
\description{Provides a robust hypothesis test for the null: \emph{Var}(\emph{X}) = 0, for a population of random factor levels. 
}
\usage{
trim.ranef.test(Y, X, tr = 0.2)
}
\arguments{
  \item{Y}{Vector of response data. A quantitative vector.}
  \item{X}{Vector of factor levels}
  \item{tr}{Amount of trimming.  A number from 0-0.5.}
}
\details{
Robust analyses for random effect designs are particularly important since standard random effects models provide poor control over type I error when assumptions of normality and homoscedasticity are violated.   Specifically, Wilcox (1994) showed that even with equal sample sizes, and moderately large samples, actual probability of type I error can exceed 0.3 if normality and homoscedasticity are violated.  
}
\value{
Returns a list with three components dataframe describing numerator and denominator degrees of freedom, the \emph{F} test statistic and the \emph{p}-value.
}
\references{Wilcox, R. R. (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\note{code based on Wilcox (2005)}
\examples{
rye<-c(50,49.8,52.3,44.5,62.3,74.8,72.5,80.2,47.6,39.5,47.7,50.7)
nutrient<-factor(c(rep(1,4),rep(2,4),rep(3,4)))
trim.ranef.test(rye,nutrient,tr=.2)
}

\keyword{htest}
\keyword{univar}

\name{boot.ci.M}
\alias{boot.ci.M}
\alias{print.bci}
\title{Bootstrap CI of M-estimators differences of two samples}
\description{
Creates a bootstrap confidence interval for location differences for two samples.  The default location
estimator is the Huber one-step estimator, although any estimator can be used.  The function is based on 
a function written by Wilcox (2005).  Note, importantly, that \emph{P}-values may be in conflict with the confidence interval bounds.
}
\usage{
boot.ci.M(X1, X2, alpha = 0.05, est = huber.one.step, R = 1000)
}
\arguments{
  \item{X1}{Sample from population one.}
  \item{X2}{Sample from population two.}
  \item{alpha}{Significance level.}
  \item{est}{Location estimator; default is the Huber one step estimator.}
  \item{R}{Number of bootstrap samples.}

}
\value{
  Returns a list with one component, a dataframe containing summary information from the analysis:  
    \item{R.used}{The number of bootstrap samples used.  This may not = \code{R} if \code{NAs} occur because \emph{MAD} = 0.} 
    \item{ci.type}{The method used to construct the confidence interval.}
    \item{conf}{The level of confidence used.}
    \item{se}{The bootstrap distribution of differences standard error.}
    \item{original}{The original, observed difference.}
    \item{lower}{Lower confidence bound.}
    \item{upper}{Upper confidence bound.}
   
  }
\references{
Manly, B. F. J.  (1997)  \emph{Randomization and Monte Carlo methods in Biology, 2nd edition}.  
Chapman and Hall, London.

Wilcox, R. R. (2005) \emph{Introduction to Robust Estimation and Hypothesis Testing, 2nd edition}.  Elsevier, 
Burlington, MA.

}
\author{Ken Aho and R. R. Wilcox from whom I stole liberally from code in the function \code{m2ci} on R-forge}
\seealso{\code{\link{bootstrap}}, \code{\link{ci.boot}}}
\examples{
\dontrun{
X1<-rnorm(100,2,2.5)
X2<-rnorm(100,3,3)
boot.ci.M(X1,X2)
}
}
\keyword{manip}
\keyword{htest}
\keyword{univar}

\name{tukey.add.test}
\alias{tukey.add.test}
\alias{print.addtest} 
\title{Tukey's test of additivity.}
\description{With an RBD we are testing the null hypothesis that there is no treatment effect in any block.  As a result randomized block designs including RBDs, Latin Squares, and spherical repeated measures assume that there is no interaction effect between blocks and main factors (i.e. main effects and block are additive).  We can test this assumption with the Tukey's test for additivity.  We address the following hypotheses:

H\eqn{_0}: Main effects and blocks are additive, versus H\eqn{_A}: Main effects and blocks are non-additive.}
\usage{

tukey.add.test(y, A, B)
}
\arguments{

  \item{y}{Response variable. Vector of quantitative data.}
  \item{A}{Main effects.  Generally a vector of categorical data.}
  \item{B}{Blocking variable.  A vector of categories (blocks).}
}
\details{
Tukey's test for additivity is best for detecting simple block x treatment interactions; for instance, when lines in an interaction plot cross.  As a result interaction plots should be used for diagnosis of other types of interactions.  A high probability of type II error results from the inability Tukey's additivity test to detect complex interactions (Kirk 1995).  As a result a conservative value of  should be used, i.e. 0.1 - 0.25. 
}
\value{
Returns a table with test results.
}
\references{
Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li. (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.

Kirk, R. E.  1995.  \emph{Experimental Design}.  Brooks/Cole.  Pacific Grove, CA.
}
\author{Orginal author unknown.  Modified by K. Aho}
\examples{
treatment<-as.factor(c(36,54,72,108,144,36,54,72,108,144,36,54,72,108,144))
block<-as.factor(c(rep(1,5),rep(2,5),rep(3,5)))
strength<-c(7.62,8.14,7.76,7.17,7.46,8,8.15,7.73,7.57,7.68, 7.93,7.87,7.74, 7.8,7.21)
tukey.add.test(strength,treatment,block)
}

\keyword{univar}
\keyword{htest}

\name{wildebeest}
\alias{wildebeest}
\docType{data}
\title{
Wildebeest carcass categorical data
}
\description{
To test the "predation-sensitive food" hypothesis, which predicts that both food and predation limit prey populations, 
Sinclair and Arcese (1995) examined wildebeest (\emph{Connochaetes taurinus}) carcasses in the Serengeti.  
The degree of malnutrition in animals was measured by marrow content since marrow will contain the last fat reserves in ungulates.  
Carcasses were cross-classified with respect to three categorical variables: sex (M, F), cause of death (predation, non-predation), 
and marrow type (SWF = Solid White Fatty, indicating healthy animals, OG = Opaque Gelatinous, indicating malnourishment, and TG = Translucent Gelatinous, the latter indicating severe malnourishment).   
}
\usage{data(wildebeest)}
\format{
  A data frame with 12 observations on the following 4 variables.
  \describe{
    \item{\code{marrow}}{A factor with levels \code{OG} \code{SWF} \code{TG}.}
    \item{\code{sex}}{A factor with levels \code{F} \code{M}.}
    \item{\code{predation}}{A factor with levels \code{N} \code{P}.}
    \item{\code{count}}{Count in each cell}
  }
}
\source{
Sinclair, A. R. E., and P. Arcese (1995)  Population consequences of predation-sensitive foraging: the Serengeti wildebeest.  \emph{Ecology}  76(3):  882-891.
}
\keyword{datasets}

\name{illusions}
\alias{illusions}
\title{
Visual illusions illustrating human perception errors.
}
\description{
In development, currently displays three illusions.  Illusion 3 is from Yihui Xie's package \pkg{animation}.
}
\usage{

illusions(ill.no = 1)
}

\arguments{

  \item{ill.no}{Integer in 1:3 describing which illusion number to view.

}
}

\author{
Ken Aho.  Illusion 3 uses code from Yihui Xie's package animation.
}
\examples{
illusions(1)
illusions(2)
illusions(3)
}
\keyword{graphs}

\name{AP.test}
\alias{AP.test}
\title{Agresti-Pendergrast test}
\description{
Provides a more powerful alternative to Friedman's test for blocked (dependent) data with a single replicate.
}
\usage{
AP.test(Y)
}
\arguments{

  \item{Y}{A matrix with treatments in columns and blocks (e.g. subjects) in rows.}
}
\details{
The Agresti-Pendergrast test is more powerful than Friedman's test, given normality, and remains powerful in heavier tailed distributions (Wilcox 2005).  
}
\value{
Returns a dataframe showing the numerator and denominator degrees of freedom, \emph{F} test statistic, and \emph{p}-value.
}
\references{
Wilcox, R. R.  (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\note{code based on Wilcox (2005).} 

\seealso{\code{\link{friedman.test}}, \code{\link{MS.test}}}
\examples{
temp<-c(2.58,2.63,2.62,2.85,3.01,2.7,2.83,3.15,3.43,3.47,2.78,2.71,3.02,3.14,3.35,
2.36,2.49,2.58,2.86,3.1,2.67,2.96,3.08,3.32,3.41,2.43,2.5,2.85,3.06,3.07)
Y<- matrix(nrow=6,ncol=5,data=temp,byrow=TRUE)
AP.test(Y)}
\keyword{htest}
\keyword{univar}

\name{see.logic}
\alias{see.logic}
\title{
Interactive worksheet for logical and fallacious arguments
}
\description{
It is vital that scientists understand what logical and fallacious arguments are.  This worksheet provides a pedagogical tool for considering logic.
}
\usage{
see.logic()
}
\references{
Salmon, W (1963) \emph{Logic}.  Prentice-Hall
}
\author{
Ken Aho
}
\seealso{
\code{\link{book.menu}}
}
\examples{
\dontrun{
see.logic()
}
}
\keyword{graphs}

\name{BDM.test}
\alias{BDM.test}
\alias{BDM.2way}
\alias{print.BDM}
\title{Brunner-Dette-Munk test}
\description{One and two way heteroscedastic rank-based permutation tests.  Two way designs are assumed to be factorial, i.e., interactions are tested.
}
\usage{

BDM.test(Y, X)

BDM.2way(Y, X1, X2)
}
\arguments{
  \item{Y}{Vector of response data.  A quantitative vector}
  \item{X}{A vector of factor levels for a one-way analysis.  To be used with \code{BDM.test}}
  \item{X1}{A vector of factor levels for the first factor in a two-way factorial design.  To be used with \code{BDM.2way}.}
  \item{X2}{A vector of factor levels for the second factor in a two-way factorial design.  To be used with \code{BDM.2way}.}
}
\details{
A problem with the Kruskal-Wallis test is that, while it does not assume normality for groups, it still assumes homoscedasticity 
(i.e. the groups have the same distributional shape).  As a solution Brunner et al. (1997) proposed a heteroscedastic version of 
the Kruskal-Wallis test which utilizes the \emph{F}-distribution.  Along with being robust to non-normality and heteroscedasticity, 
calculations of exact \emph{P}-values using the Brunner-Dette-Munk method are not made more complex by tied values.  
This is another obvious advantage over the traditional Kruskal-Wallis approach.    
}
\value{
 Returns a list with two components
  \item{Q}{The "relative effects" for each group.}
  \item{Table}{An ANOVA type table with hypothesis test results.}
}
\references{
Brunner, E., Dette, H., and A. Munk (1997)  Box-type approximations in nonparametric 
factorial designs.  \emph{Journal of the American Statistical Association}.  92: 1494-1502.

Wilcox, R. R.  (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.

}
\author{Ken Aho}
\note{Code based on Wilcox (2005)
}
\seealso{\code{\link{kruskal.test}}, \code{\link{trim.test}}}
\examples{
rye<-c(50,49.8,52.3,44.5,62.3,74.8,72.5,80.2,47.6,39.5,47.7,50.7)
nutrient<-factor(c(rep(1,4),rep(2,4),rep(3,4)))
BDM.test(Y=rye,X=nutrient)
}
\keyword{htest}
\keyword{univar}

\name{MC}
\alias{MC}
\alias{Rf}
\alias{mat.pow}

\title{
Simple functions for MCMC demonstrations
}
\description{
Function \code{MC} creates random Markov Chain from a transitions matrix.  Function \code{Rf} presents proportional summaries of discrete states from \code{MC}.  Function \code{mat.pow} finds the exponential expansion of a matrix.  Required for finding the expectations of a transition matrix. 
}
\usage{
MC(T, start, length)
Rf(res)
mat.pow(mat, pow)
}

\arguments{

  \item{T}{
A symmetric transition matrix.
}
  \item{start}{
Starting state
}
  \item{length}{
Length of the chain to be created
}

  \item{res}{
Results from \code{MC}.
}

  \item{mat}{
A symmetric matrix.
}
  \item{pow}{
Power the matrix is to be raised to.
}
}


\author{
Ken Aho
}

\examples{
A <- matrix(nrow = 4, ncol = 4, c(0.5, 0.5, 0, 0, 0.25, 0.5, 0.25,0, 0, 0.25, 0.5, 0.25, 
0, 0, 0.5, 0.5), byrow = TRUE)
pi.0 <- c(1, 0, 0, 0)
Tp10 <- mat.pow(A, 10)
chain <- MC(A, 1, 100)
Rf(chain)
}

\keyword{manip}

\encoding{UTF-8}
\name{BCI.count}
\alias{BCI.count}
\docType{data}
\title{Barro Colorado Island Tree Counts}
\description{
  This dataset, lifted from \pkg{vegan}, contains tree counts in 1-hectare plots in Barro Colorado Island, Panama.
}
\usage{data(BCI.count)}
\format{
  A data frame with 50 plots (rows) of 1 hectare with counts of trees on each
  plot with total of 225 species (columns). Full Latin names are used
  for tree species.
 }
\details{
  Data give the numbers of trees at least 10 cm in
  diameter at breast height (1.3 m above the ground) in each one hectare
  square of forest. Within each one hectare square, all individuals of
  all species were tallied and are recorded in this table.

  The data frame contains only the Barro Colorado Island subset of the
  original data.

  The quadrats are located in a regular grid. See \code{examples} for the
  coordinates. 

}
\source{
  Condit et al. (2002). Data documentation here follows directly from \pkg{vegan}.
}
\references{
  Condit, R, Pitman, N, Leigh, E.G., Chave, J., Terborgh, J., Foster,
  R.B., \enc{Nuñez}{Nunez}, P., Aguilar, S., Valencia, R., Villa, G., Muller-Landau,
  H.C., Losos, E. & Hubbell, S.P. (2002). Beta-diversity in tropical
  forest trees. \emph{Science} 295, 666--669.
}

\keyword{datasets}

\name{PCB}
\alias{PCB}
\docType{data}
\title{
PCBs and herring egg thickness
}
\description{
Thirteen sites in the Great Lakes were selected for a study to quantify PCB 
concentrations in 1982 and 1996 (Hughes et al. 1998).  At each site 9-13 American 
herring gull (\emph{Larus smithsonianus}) eggs were randomly collected and tested for PCB content.
}
\usage{data(PCB)}
\format{
  A data frame with 26 observations on the following 3 variables.
  \describe{
    \item{\code{nest}}{Nest number}
    \item{\code{level}}{PCB levels microgram/gram of dry weight}
    \item{\code{year}}{a numeric vector}
}
}
\source{
Ott, R. L., and M. T. Longnecker  (2004)  \emph{A First Course in Statistical Methods}.  Thompson. 
}
\references{
Hughes, K. D., Weselogh, D. V., and B. M. Braune (1998) The ratio of DDE to PCB 
concentrations in Great Lakes herring gull eggs and its use in interpreting contaminants data. \emph{Journal of Great Lakes Research} 24(1): 12-31. 
}
\keyword{datasets}

\name{see.nlm}
\alias{see.nlm}

\title{
Visualize important non-linear functions
}
\description{
A number of important equation forms require that their parameters be estimated using the non-linear least squares.  Here are six.
}
\usage{
see.nlm()
}

\references{Crawley, M. J.  (2007)  \emph{The R Book}.  Wiley.
}
\author{
Ken Aho
}
\keyword{graphs}

\name{cliff.sp}
\alias{cliff.sp}
\docType{data}
\title{Yellowstone NP cliff community data}
\description{
A subset of a dataset collected by Aho (2006) which describes  the distribution of communities of lichens and vascular and avascular plant species on montane cliffs in Northeast Yellowstone National Park.  Of particular interest was whether substrate (limestone or andesitic conglomerate) or water supply influenced community composition. 
}
\usage{data(cliff.sp)}
\details{
Responses are average counts from two 10 x 10 point frames at 54 sites. Abundance data are for eleven species, 9 lichens, 3 mosses, and 2 vascular plants. Data were gathered in the summer of 2004 on two andesitic/volcanic peaks (Barronette and Abiathar) with sedimentary layers at lower elevations.  
}
\source{Aho, K.(2006)  \emph{Alpine Ecology and Subalpine Cliff Ecology in the Northern Rocky 
Mountains}.  Doctoral dissertation, Montana State University, 458 pgs.}
\keyword{datasets}

\name{case0902}
\alias{case0902}
\docType{data}
\title{
Dataset of mammal traits from Ramsey and Schaefer (1997)
}
\description{
These data were used by Ramsey and Schaefer (1997) to demonstrate multiple regression.  The dataset was originally collected by Sacher and Stafeldt (1974) and provided (for varying sample sizes) average values of brain weight, body weight, gestation period and litter size for 96 placental mammal species. 
}

\usage{data("case0902")}
\format{
  A data frame with 96 observations on the following 5 variables.
  \describe{
    \item{\code{Xs}}{A factor defining common names for mammal species under examination.}
    \item{\code{Y}}{Brain weight (in grams).}
    \item{\code{Xb}}{Body weight (in kilograms).}
    \item{\code{Xg}}{Gestation period length (in days).}
    \item{\code{Xl}}{Litter size.}
  }
}

\source{
Ramsey, F., and Schafer, D. (1997). \emph{The statistical sleuth: a course in methods of data analysis}. Cengage Learning.
}
\references{
Sacher, G. A., and Staffeldt, E. F. (1974). Relation of gestation time to brain weight for placental mammals: implications for the theory of vertebrate growth.  \emph{The American Naturalist}, 108(963), 593-615.
}
\examples{
data(case0902)
}
\keyword{datasets}

\name{simberloff}
\alias{simberloff}
\docType{data}
\title{
Compilations of genus and species counts from Simberloff (1970)
}
\description{
A compilation of taxonomic (species and genus) counts for a wide array of organism groups for island and associated mainland locations.  Taken from Simberloff (1970).
}
\usage{data("simberloff")}
\format{
  A data frame with 204 observations on the following 12 variables.
  \describe{
    \item{\code{Location}}{Island and mainland location.}
    \item{\code{Designation}}{A factor with levels \code{Island} \code{Mainland}.}
    \item{\code{Hypothesized.source}}{Hypothesized mainland location for particular island location.}
    \item{\code{No.spp.}}{The number of species}
    \item{\code{Obs.S.G}}{Observed species/genus (S/G) ratio}
    \item{\code{E.S.G.}}{Expected S/G ratio, based on random sampling from mainland pool of species.}
    \item{\code{prop..obs..cogeners}}{The proportion of observed cogeners, only reported for bird species.}
    \item{\code{prop..exp..cogeners}}{The proportion of expected cogeners based on random sampling from the associated mainland pool of species, only reported for bird species.}
    \item{\code{Authority}}{Source of information for compilation.}
    \item{\code{Life.form}}{A factor with levels \code{Ants} \code{Land birds} \code{Passerine birds} \code{Vascular plants}.}
    \item{\code{Notes.1}}{Notes from Simberloff (1970)}
    \item{\code{Notes.2}}{Additional notes from Simberloff (1970)}
  }
}

\source{
Simberloff, D. (1970) Taxonomic diversity of island biotas. \emph{Evolution} 24, 23-47.
}

\keyword{datasets}

\name{K}
\alias{K}
\docType{data}
\title{
Soil potassium analyses from 8 laboratories
}
\description{
Jacobsen et al. (2002) sent nine "identical" soil samples to eight soil testing 
laboratories in the Great Plains region of the Central United States over a three year period of time. 
 Among other characteristics the labs were paid to measure soil potassium.  
A question of interest was whether the labs would produce identical analytical results.
}
\usage{data(K)}
\format{
  A data frame with 72 observations on the following 2 variables.
  \describe{
    \item{\code{K}}{Soil K in mg/kg}
    \item{\code{lab}}{Laboratories, a factor with levels \code{B} \code{D} \code{E} \code{F} \code{G} \code{H} \code{I} \code{J}}
  }
}
\source{
Jacobsen, J. S., Lorber, S. H., Schaff, B. E., and C. A. Jones (2002)  Variation in soil 
fertility test results from selected Northern Great Plains laboratories.  \emph{Commun. Soil Sci. plant Anal.}, 33(3&4): 303-319.
}

\keyword{datasets}

\name{fly.sex}
\alias{fly.sex}
\docType{data}
\title{
Fly sex and longevity
}
\description{
Partridge and Farqaur (1981) studied the effect of the number of mating partners on the longevity of fruit flies.  Five different mating treatments were applied to single male fruit flies.  As a concomitant variable thorax length was measured.
}
\usage{data(fly.sex)}


\format{
  A data frame with 125 observations on the following 3 variables.
  \describe{
    \item{\code{treatment}}{a factor with levels \code{1} = One virgin female per day, \code{2} = eight virgin females per day, \code{3} = a control group with one newly inseminated female per day, \code{4} = a control group with eight newly inseminated females per day, 
    and \code{5} a control group with no added females.}
    \item{\code{longevity}}{Age in days.}
    \item{\code{thorax}}{Thorax length in mm.}
  }
}

\source{
Quinn, G. P., and M. J. Keough.  2002.  \emph{Experimental Design and Data Analysis for 
Biologists}.  Cambridge University Press. 
}
\references{
Partridge, L., and Farquhar, M. (1981), Sexual activity and the lifespan of male fruit flies, \emph{Nature} 294, 580-581.
}
\keyword{datasets}

\name{BCI.plant}
\alias{BCI.plant}
\docType{data}
\title{
Tree presence/absence data from Barro Colorado island
}
\description{
The presence of the tropical trees \emph{Alchornea costaricensis} and \emph{Anacardium excelsum} with diameter at breast height equal or larger than 10 cm were recorded on along with environmental factors at Barro Colorado Island in Panama (Kindt and Coe 2005).  These data were originally from (Pyke et al. 2001). 
}
\usage{data(BCI.plant)}
\format{
  A data frame with 43 observations on the following 9 variables.
  \describe{
    \item{\code{site.no.}}{A factor with levels \code{C1} \code{C2} \code{C3} \code{C4} \code{p1} \code{p10} \code{p11} \code{p12} \code{p13} \code{p14} \code{p15} \code{p16} \code{p17} \code{p18} \code{p19} \code{p2} \code{p20} \code{p21} \code{p22} \code{p23} \code{p24} \code{p25} \code{p26} \code{p27} \code{p28} \code{p29} \code{p3} \code{p30} \code{p31} \code{p32} \code{p33} \code{p34} \code{p35} \code{p36} \code{p37} \code{p38} \code{p39} \code{p4} \code{p5} \code{p6} \code{p7} \code{p8} \code{p9}}
    \item{\code{UTM.E}}{UTM easting.}
    \item{\code{UTM.N}}{UTM northing.}
    \item{\code{precip}}{Precipitation in mm/year.}
    \item{\code{elev}}{Elevation in m above sea level.}
    \item{\code{age}}{A categorical vector describing age.}
    \item{\code{geology}}{A factor describing geology with levels \code{pT} \code{Tb} \code{Tbo} \code{Tc} \code{Tcm} \code{Tct} \code{Tgo} \code{Tl} \code{Tlc}.}
    \item{\code{Alchornea.costaricensis}}{Plant presence/absence.}
    \item{\code{Anacardium.excelsum}}{Plant presence/absence.}
  }
}

\source{
Condit et al. (2002), Kindt et al. (2005).
}
\references{
Condit, R, Pitman, N, Leigh, E.G., Chave, J., Terborgh, J., Foster, 
R.B., Nunez, P., Aguilar, S., Valencia, R., Villa, G., Muller-Landau,
H.C., Losos, E. & Hubbell, S.P. (2002). Beta-diversity in tropical
forest trees. \emph{Science} 295, 666--669.
  
Kindt, R. & Coe, R. (2005) Tree diversity analysis: A manual and software for common   statistical methods for ecological and biodiversity studies from the \pkg{BiodiversityR} package.

Pyke CR, Condit R, Aguilar S and Lao S. (2001). Floristic composition across a climatic gradient in a neotropical lowland forest. \emph{Journal of Vegetation Science} 12: 553-566.
}
\keyword{datasets}

\name{snore}
\alias{snore}
\docType{data}
\title{
Snoring and heart disease contingency data 
}
\description{
Norton and Dunn (1985) compiled data from four family practice clinics in Toronto to quantify the association between snoring and heart disease for 2484 subjects.  
}
\usage{data(snore)}
\format{
  A data frame with 2484 observations on the following 3 variables.
  \describe{
    \item{\code{snoring}}{A factor with levels \code{every.night} \code{nearly.ever.night} \code{never} \code{occasional}}
    \item{\code{ord.snoring}}{Agresti (21012) transformed the explanatory levels to ordinal values in his analysis of this data.}
    \item{\code{disease}}{Presence/absence of heart disease}
  }
}
\source{
Norton, P. G., and E. V. Dunn  (1985)  Snoring as a risk factor for disease: an 
	epidemiological survey.  \emph{British Medical Journal} 291: 630-632. 
}
\keyword{datasets}

\name{montane.island}
\alias{montane.island}
\docType{data}
\title{
Mountain island biogeographic data
}
\description{
Lomolino et al. (1989) investigated the relationship between the area of montane  forest patches (islands) and the richness of mammal fauna in the Southwestern United States.  This dataset contains richness and area information for 27 montane islands. 
}
\usage{data(montane.island)}
\format{
  A data frame with 27 observations on the following 3 variables.
  \describe{
    \item{\code{Island.name}}{a factor with levels \code{Abajos} \code{Animas} \code{Blacks} \code{Capitans} \code{Catalinas} \code{Chirucahuas} \code{Chuskas} \code{Guadalupes} \code{Huachucas} \code{Hualapais} \code{Lasals} \code{Magdalenas} \code{Manzanos} \code{Mogollon} \code{Mt. Taylor} \code{N. Rincon} \code{N. Uncompaghre} \code{Navajo} \code{Organs} \code{Pinalenos} \code{Prescotts} \code{S. Kabib} \code{Sacramentos} \code{San Mateos} \code{Sandias} \code{Santa Ritas} \code{Zunis}.}
    \item{\code{Richness}}{A numeric vector; the number of species.}
    \item{\code{Area}}{A numeric vector; area in km\eqn{^2}.}
  }
}
\source{
Lomolino, M. V., Brown, J. H., and R. Davis (1989)  Island biogeography of montane 
forest mammals in the American Southwest.  \emph{Ecology} 70: 180-194. 
}
\keyword{datasets}

\name{crab.weight}
\alias{crab.weight}
\docType{data}
\title{
crab gill and body weight data
}
\description{
Gill weight and body weight data for 12 striped shore crabs (\emph{Pachygrapsus crassipes}).
}
\usage{data(crab.weight)}
\format{
  A data frame with 12 observations on the following 2 variables.
  \describe{
    \item{\code{gill.wt}}{Gill weight in mg}
    \item{\code{body.wt}}{Body weight in grams}
  }
}
\source{
Sokal, R. R., and F. J. Rohlf  (2012)  \emph{Biometry, 4th edition}.  W. H. Freeman and Co., New York. 
}
\keyword{datasets}

\name{anm.loglik}
\alias{anm.loglik}
\alias{loglik.plot}
\alias{loglik.norm.plot}
\alias{loglik.pois.plot}
\alias{loglik.binom.plot}
\alias{loglik.exp.plot}
\alias{loglik.custom.plot}
\alias{anm.loglik.tck}
\title{Animated plots of log-likelihood functions}
\description{
Plots the normal, exponential, Poisson, binomial, and "custom" log-likelihood functions.  By definition, likelihoods for parameter estimates are calculated by holding data constant and varying estimates.  For the normal distribution a fixed value for the parameter which is not being estimated (\eqn{\mu} or \eqn{\sigma^2}) is established using MLEs.
}
\usage{
anm.loglik(X, dist = c("norm", "poi", "bin", "exp", "custom"),
plot.likfunc = TRUE, parameter = NULL, func = NULL, poss = NULL,
plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL,
conv = diff(range(X))/70, anim = TRUE, est.col = 2, density.leg = TRUE,
cex.leg = 0.9, interval = 0.01, ...)

loglik.norm.plot(X, parameter = c("mu", "sigma.sq"), poss = NULL,
plot.likfunc = TRUE, plot.density = TRUE, plot.calc = FALSE,
xlab = NULL, ylab = NULL, conv = 0.01, anim = TRUE, est.col = 2,
density.leg = TRUE, cex.leg = 0.9, interval = 0.01, ...)

loglik.pois.plot(X, poss = NULL, plot.likfunc = TRUE,
plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL,
conv = 0.01, anim = TRUE, interval = 0.01, ...)

loglik.binom.plot(X, poss = NULL, xlab = NULL, ylab = NULL,
plot.likfunc = TRUE, plot.density = TRUE, conv = 0.01, anim = TRUE,
interval = 0.01, ...)

loglik.exp.plot(X, poss = NULL, plot.likfunc = TRUE,
plot.density = TRUE, plot.calc = FALSE, xlab = NULL, ylab = NULL,
conv = 0.01, anim = TRUE, est.col = 2, density.leg = TRUE,
cex.leg = 0.9, interval = 0.01, ...)

loglik.custom.plot(X, func, poss, anim = TRUE, interval = 0.01,
xlab, ylab, ...)

anm.loglik.tck()
}

\arguments{

  \item{X}{A vector of quantitative data.  The function does not currently handle extremely large datasets, \emph{n} > 500. Data should be integers (counts) for the Poisson
log-likelihood function, and binary responses (0,1) for the binomial log likelihood function.  Data elements for the exponential log likelihood function must be greater than zero.}
  \item{parameter}{The parameter for which ML estimation is desired in \code{loglik.norm.plot}.  Specification of either \code{"mu"} or \code{"sigma.sq"} is required for the normal log-likelihood function.  No specification is required for exponential, Poisson, and binomial log-likelihood functions since these distributions are generally specified with a single parameter, i.e., \eqn{\theta} for the exponential, \eqn{\lambda} for the Poisson distribution, and \emph{p} (the probability of a success) for the binomial distribution.}
  \item{poss}{An optional vector containing a sequence of possible parameter estimates.  Elements in the vector must be distinct.  If \code{poss} is not specified a vector of appropriate possibilities is provided by the function.  This argument can be used to set \code{xlim} in the likelihood function and density plots.}
  \item{dist}{The type of assumed distribution there are currently five possibilities: \code{"norm"}, \code{"poi"}, \code{"binom"}, \code{"exp"}, and \code{"custom"}.  Use of custom distributions requires specification of a custom likelihood function in the argument \code{func}.}
  \item{plot.likfunc}{A logical command for indicating whether a graph of the log-likelihood function should be created.}
  \item{plot.density}{A logical command for indicating whether a second graph, in which densities are plotted on the pdf, should be created.}
  \item{plot.calc}{A logical command for indicating whether a third graph, in which log-densities are added to one another, should be created.}
  \item{xlab}{Optional \emph{X}-axis label.}
  \item{ylab}{Optional \emph{Y}-axis label.}
  \item{conv}{Precision of likelihood function.  Decreasing \code{conv} increases the smoothness and precision of the ML function.  Decreasing \code{conv} will also slow the animation.}
  \item{anim}{A logical command indicating whether animation should be used in plots.}
  \item{est.col}{Color used in depicting estimation.}
  \item{density.leg}{Logical.  Should the legend for density be shown?}
  \item{cex.leg}{Character expansion for legend.}
  \item{interval}{Speed of animation, in seconds per frame.  May not work in all systems; see \code{\link{Sys.sleep}}.}
  \item{func}{Custom likelihood function to be specified when using \code{loglik.custom.plot}.  The function should have two arguments.  An optional call to data, and the likelihood function parameter (see example below).}
  \item{\dots}{Additional arguments from \code{\link{plot}} can be specified for likelihood function plots.}
}

\details{These plots are helpful in explaining the workings of ML estimation for parameters.  Animation is included as an option to further clarify processes.
When specifying \code{poss} be sure to include the estimate that you "want" the log-likelihood function to maximize in the vector of possibilities, e.g. \code{mean(X)} for estimation of \eqn{\mu}.
}

\value{
Three animated plots can be created simultaneously.  The first plot shows the normal, Poisson, exponential, binomial, or custom log-likelihood functions.  The second plot shows the pdf with ML estimates for parameters.
On this graph densities of observations are plotted as pdf parameters are varied.  By default these two graphs will be created simultaneously on a single graphics device.
By specifying \code{plot.calc = TRUE} a third plot can also be created which shows that log-likelihood is the sum of the log-densities.
Animation in this third plot will be automatically sped up, using a primitive routine, for large datasets, and slowed for small datasets.
The third plot will not be created for the binomial pdf because there will only be a single outcome from the perspective of likelihood (e.g. 10 successes out of 22 trials).
The second and third plots will not be created for custom likelihood functions.
The function \code{anm.loglik.tck()} runs \code{anm.loglik()} from a \pkg{tcltk} GUI.
}

\author{Ken Aho}
\seealso{\code{\link{dnorm}}, \code{\link{dpois}}, \code{\link{dexp}}, \code{\link{dbinom}}}
\examples{

\dontrun{
##Normal log likelihood estimation of mu.
X<-c(11.2,10.8,9.0,12.4,12.1,10.3,10.4,10.6,9.3,11.8)
anm.loglik(X,dist="norm",parameter="mu")

##Add a plot describing log-likelihood calculation.
anm.loglik(X,dist="norm",parameter="mu",plot.calc=TRUE)

##Normal log likelihood estimation of sigma squared.
X<-c(11.2,10.8,9.0,12.4,12.1,10.3,10.4,10.6,9.3,11.8)
anm.loglik(X,dist="norm",parameter="sigma.sq")

##Exponential log likelihood estimation of theta
X<-c(0.82,0.32,0.14,0.41,0.09,0.32,0.74,4.17,0.36,1.80,0.74,0.07,0.45,2.33,0.21,
0.79,0.29,0.75,3.45)
anm.loglik(X,dist="exp")

##Poisson log likelihood estimation of lambda.
X<-c(1,3,4,0,2,3,4,3,5)
anm.loglik(X,dist="poi")

##Binomial log likelihood estimation of p.
X<-c(1,1,0,0,0,1,0,0,0,0)#where 1 = a success
anm.loglik(X,dist="bin",interval=.2)

##Custom log-likelihood function
func<-function(X=NULL,theta)theta^5*(1-theta)^10
anm.loglik(X=NULL,func=func,dist="custom",poss=seq(0,1,0.01),
xlab="Possibilities",ylab="Log-likelihood")

##Interactive GUI, requires package 'tcltk'
anm.loglik.tck()
}
}
\keyword{univar}
\keyword{graphs}

\name{Bayes.disc}
\alias{Bayes.disc}
\alias{Bayes.disc.tck}
\title{
Bayesian graphical summaries for discrete or categorical data.
}
\description{
An simple function for for summarizing a Bayesian analysis given discrete or categorical variables and priors.
}
\usage{

Bayes.disc(Likelihood, Prior, data.name = "data", plot = TRUE, 
c.data = seq(1, length(Prior)), ...)

Bayes.disc.tck()
}

\arguments{

  \item{Likelihood}{A vector of sample distribution probabilities.  This must be in the same order as \code{Prior}, i.e. if \eqn{\theta_1} is the first element in \code{Prior}, then \eqn{data|\theta_1} must be the first element in \code{Data}.
}
  \item{Prior}{
A vector of prior probabilities, or weights.
}
  \item{data.name}{A name for data in conditional statements.
}
  \item{plot}{
Logical, indicating whether a plot should be made.
}
  \item{c.data}{
A character string of names for discrete classes
}
  \item{\dots}{
Additional arguments to \code{\link{plot}}.
}
}

\author{
Ken Aho
}
\keyword{graphs}

\name{Rabino_CO2}
\alias{Rabino_del13C}
\alias{Rabino_CO2}
\docType{data}
\title{
CSIRO d13C-CO2 data from Rubino et al., A revised 1000 year atmospheric  13C-CO2 record from Law Dome and South Pole, Antarctica
}
\description{
Rabino et al. (2013) provided: CSIRO \eqn{\delta^{13}}C  and CO\eqn{_2} measures covering 1000 years.  
}
\usage{data("Rabino_CO2")}
\format{
    \describe{
    \item{\code{Sample.type}}{A factor with levels \code{firn} and \code{ice}.}
    \item{\code{depth}}{Depth of core (in meters).}
    \item{\code{effective.age}}{Age of CO\eqn{_2} (in years AD).}
    \item{\code{d13C.CO2}}{\eqn{\delta^{13}}C (per mille).}
    \item{\code{CO2}}{CO\eqn{_2} level (in ppm).}
    \item{\code{uncertainty}}{Uncertainty in measures (in ppm (CO\eqn{_2}) or per mille (\eqn{\delta^{13}}C)).}
  }
}

\source{
Rubino, M., Etheridge, D. M., Trudinger, C. M., Allison, C. E., Battle, M. O., Langenfelds, R. L., ... & Jenk, T. M. (2013). A revised 1000 year atmospheric \eqn{\delta^{13}}C-CO\eqn{_2} record from Law Dome and South Pole, Antarctica. \emph{Journal of Geophysical Research: Atmospheres}, 118(15), 8482-8499
}
\examples{
data(Rabino_CO2)
data(Rabino_del13C)

op <- par(mar=c(5,4.5,1,4.5))
with(Rabino_del13C, plot(effective.age, 
d13C.CO2, xlab = "Year", type='p', 
col = 1, pch = 21, bg = 'red', ylab = ''))
axis(2, col = 'red', col.axis = 'red')
mtext(side = 2, expression(paste(delta,' ','
'^13,'C  (per mille)')), col = 'red', 
line = 3, cex = 1.2)
par(new = TRUE)

with(Rabino_CO2, plot(effective.age, 
CO2, type='p', col=1,pch = 21, 
bg = 'blue', axes = FALSE, xlab = "", ylab = ""))
axis(4, col = 'blue', col.axis = 'blue')
mtext(side=4,expression(paste('Atmospheric ', 
CO[2], ' (ppm)')), 
line = 3, col = 'blue', cex = 1.2)
par(op)
}
\keyword{datasets}

\name{HL.mean}
\alias{HL.mean}
\title{Hodges-Lehman estimator of location}
\description{Calculates the Hodges-Lehman estimate of location --which is consistent for the true pseudomedian-- using Walsh averages (Hollander and Wolfe 1999, pgs. 51-55). If requested, the function also provides confidence intervals for the true pseudomedian.  In a symmetric distribution the mean, median, and pseudomedian will be identical.}
\usage{HL.mean(x, conf = NULL, method = "exact")}
\arguments{
  \item{x}{A vector of quantitative data.}
  \item{conf}{A proportion specifying 1 - \emph{P}(type I error).}
  \item{method}{method for confidence interval calculation.  One of \code{"approx"}, which uses a normal approximation, or \code{"exact"}, which uses the Wilcoxon sign-rank quantile function (see Hollander and Wolfe 1999).}
}
\author{Ken Aho}
\references{Hollander, M., and Wolfe, D. A  (1999) \emph{Nonparametric Statistical Methods}. New York: John Wiley & Sons.}
\seealso{\code{\link{H.mean}}, \code{\link{G.mean}}}
\examples{# Hamilton depression scale (Hollander and Wolfe 1999)
x<-c( -0.952, 0.147, -1.022, -0.430, -0.620, -0.590, -0.490,  0.080, -0.010)
HL.mean(x, conf = .96)
}

\name{bvn.plot}
\alias{bvn.plot}
\title{
Make plots of bivariate normal distributions
}
\description{
The function uses functions from \pkg{lattice} and \pkg{mvtnorm} to make wireframe plots of bivariate normal distributions.  Remember that the covariance
must be less than the product of the marginal standard deviations (square roots of the diagonal elements).
}
\usage{
bvn.plot(mu = c(0, 0), cv = 0, vr = c(1, 1), res = 0.3, xlab = expression(y[1]),
ylab = expression(y[2]), zlab = expression(paste("f(", y[1], ",", y[2], ")")), ...)
}

\arguments{
  \item{mu}{
A vector containing the joint distribution means.
}
  \item{cv}{
A number, indicating the covariance of the two variables.
}
  \item{vr}{
The diagonal elements in the variance covariance matrix.
}
  \item{res}{
Plot resolution.  Smaller values create a more detailed wireframe plot.
}
\item{xlab}{
\emph{X}-axis label.
}
\item{ylab}{
\emph{Y}-axis label.
}
\item{zlab}{
\emph{Z}-axis label.
}
\item{\dots}{
Additional arguments from \code{\link[lattice]{wireframe}}.
}
}
\author{
Ken Aho
}
\keyword{graphs}

\name{ci.prat}
\alias{ci.prat}

\title{
Confidence intervals for the ratio of binomial and multinomial proportions
}

\description{
A number of methods have been developed for obtaining confidence intervals for the ratio of two binomial proportions.  These include the Wald/Katz-log method (Katz et al. 1978), 
adjusted-log (Walter 1975, Pettigrew et al. 1986), Koopman asymptotic score (Koopman 1984), Inverse hyperbolic sine transformation (Newman 2001), the Bailey method (Bailey (1987), 
and the Noether (1957) procedure. Koopman results are found iteratively for most intervals using root finding.   
}

\usage{
ci.prat(y1, n1, y2, n2, conf = 0.95, method = "katz.log", 
bonf = FALSE, tol = .Machine$double.eps^0.25, R = 1000, r = length(y1))
}

\arguments{

  \item{y1}{
The ratio numerator number of successes.  A scalar or vector.
}
  \item{n1}{
The ratio numerator number of trials.  A scalar or vector of \code{length(y1)}
}
  \item{y2}{
The ratio denominator number of successes.  A scalar or vector of \code{length(y1)}
}
  \item{n2}{
The ratio denominator number of trials. A scalar or vector of \code{length(y1)}
}
  \item{conf}{
The level of confidence, i.e. 1 - \emph{P}(type I error). 
}
  \item{method}{
Confidence interval method.  One of \code{"adj.log"}, \code{"bailey"},  
\code{"boot"}, \code{"katz.log"}, \code{"koopman"}, \code{"sinh-1"} or 
\code{"noether"}.  Partial distinct names can be used.  
}
  \item{bonf}{
Logical, indicating whether or not Bonferroni corrections should be applied for simultaneous inference if \code{y1, y2, n1} and \code{n2} are vectors.
}  
  \item{tol}{The desired accuracy (convergence tolerance) for the iterative root finding procedure when finding Koopman intervals. The default is taken to be the smallest positive floating-point number of the workstation implementing the function, raised to the 0.25 power, and will normally be approximately 0.0001.
}
\item{R}{If method \code{"boot"} is chosen, the number of bootstrap iterations.
}
\item{r}{The number of ratios to which family-wise inferences are being made.  Assumed to be \code{length(y1)}. 
}
}
 
      
\details{
Let \eqn{Y_1} and \eqn{Y_2} be multinomial random variables with parameters \eqn{n_1, \pi_{1i}},  and  \eqn{n_2, \pi_{2i}}, respectively; where \eqn{i = \{1, 2, 3, \dots, r\}}.  This encompasses the binomial case in which \eqn{r = 1}. We define the true selection ratio for the \emph{i}th resource of \emph{r} total resources to be:
 \deqn{\theta_{i}=\frac{\pi _{1i}}{\pi _{2i}}}

where \eqn{\pi_{1i}} and \eqn{\pi_{2i}} represent the proportional use and availability of the \emph{i}th resource, respectively. Note that if \eqn{r = 1} the selection ratio becomes relative risk.  The maximum likelihood estimators for \eqn{\pi_{1i}} and \eqn{\pi_{2i}} are the sample proportions: 

\deqn{{{\hat{\pi }}_{1i}}=\frac{{{y}_{1i}}}{{{n}_{1}}},} and
\deqn{{{\hat{\pi }}_{2i}}=\frac{{{y}_{2i}}}{{{n}_{2}}}}

where \eqn{y_{1i}} and \eqn{y_{2i}} are the observed counts for use and availability for the \emph{i}th resource.  The estimator for \eqn{\theta_i} is:

\deqn{\hat{\theta}_{i}=\frac{\hat{\pi}_{1i}}{\hat{\pi }_{2i}}.}

\tabular{ll}{
Method \tab Algorithm \cr
\tab \cr 

% Katz-log	
Katz-log \tab \eqn{\hat\theta_i\times} exp\eqn{(\pm z_1-\alpha/2\hat{\sigma}_W)}, \cr
\tab where \eqn{\hat\sigma_W^2=\frac{(1-\hat{\pi} _{1i})}{\hat{\pi}_{1i}n_1}+\frac{(1-\hat{\pi}_{2i})}{\hat{\pi}_{2i}n_2}}.  \cr 
\tab \cr

% Adjusted log
Adjusted-log \tab \eqn{\hat{\theta}_{Ai}\times} exp\eqn{(\pm z_1-\alpha /2\hat{\sigma}_A)}, \cr 
\tab where \eqn{\hat{\theta}_{Ai}=\frac{y_{1i}+0.5/n_1+0.5}{y_{2i}+0.5/n_2+0.5}}, \cr 
\tab \eqn{\hat{\sigma}_A^2=\frac{1}{y_1+0.5}-\frac{1}{n_1+0.5}+\frac{1}{y_2+0.5}-\frac{1}{n_2+0.5}}. \cr
\tab \cr

% Bailey
Bailey \tab \eqn{\hat{\theta} _i\left[\frac{1\pm z_1-\left( \alpha /2 \right)\left( \hat{\pi}_{1i}'/y_{1i}+\hat{\pi}_{2i}'/y_{2i}-z_1-\left(\alpha/2 \right)^2\hat{\pi} _{1i}'\hat{\pi}_{2i}'/9y_{1i}y_{2i} \right)^{1/2}/3}{1-z_{1-\left(\alpha/2 \right)^2}\hat{\pi} _{2i}'/9y_{2i}} \right]^3},\cr 
\tab where \eqn{\hat{\pi}_{1i}'} = 1 - \eqn{\hat{\pi}_{1i}}, and \eqn{\hat{\pi}_{2i}'} = 1 - \eqn{\hat{\pi}_{2i}}.\cr
\tab \cr

% Inv sin
Inv. hyperbolic sine \tab \eqn{\ln({{\hat{\theta }}_{i}})\pm \left[ 2sin{{h}^{-1}}\left( \frac{{{z}_{(1-\alpha /2)}}}{2}\sqrt{\frac{1}{{{y}_{1i}}}-\frac{1}{{{n}_{1}}}+\frac{1}{{{y}_{2i}}}-\frac{1}{{{n}_{2}}}} \right) \right]}, \cr
\tab\cr 

% Koopman
Koopman \tab Find \eqn{X^2(\theta_0)} = \eqn{\chi _1^2(1 - \alpha)}, where \cr
\tab  \eqn{{{\tilde{\pi }}_{1i}}=\frac{{{\theta }_{0}}({{n}_{1}}+{{y}_{2i}})+{{y}_{1i}}+{{n}_{2}}-{{[{{\{{{\theta }_{0}}({{n}_{1}}+{{y}_{2i}})+{{y}_{1i}}+
{{n}_{2}}\}}^{2}}-4{{\theta }_{0}}({{n}_{1}}+{{n}_{2}})({{y}_{1i}}+{{y}_{2i}})]}^{0.5}}}{2({{n}_{1}}+{{n}_{2}})}}, \cr

\tab \eqn{\tilde{\pi}_{2i}=\frac{{{{\tilde{\pi }}}_{1i}}}{{{\theta }_{0}}}}, and \eqn{X^2(\theta_0)=\frac{\left(y_{1i}-n_1\tilde{\pi}_{1i}\right)^2}{n_1 \tilde{\pi }_{1i}(1-\tilde{\pi}_{1i})}\left\{1+\frac{n_1(\theta_0-\tilde{\pi}_{1i})}{n_2(1-\tilde{\pi}_{1i})} \right\}}. \cr 
\tab \cr
%% Noether
Noether \tab \eqn{\hat{\theta}_i\pm z_1-\alpha/2\hat{\sigma}_N},   \cr
\tab where \eqn{\hat{\sigma }_{N}^{2}=\hat{\theta }_{i}^{2}\left( \frac{1}{{{y}_{1i}}}-\frac{1}{{{n}_{1}}}+\frac{1}{{{y}_{2i}}}-\frac{1}{{{n}_{2}}} \right)}.  
}

Exception handling strategies are generally necessary in the cases \eqn{y_1} = 0, \eqn{n_1} = \eqn{y_1}, \eqn{y_2} = 0, and \eqn{n_2} = \eqn{y_2} (see Aho and Bowyer 2015).  

The bootstrap method currently employs percentile confidence intervals.

}

\value{Returns a list of \code{class = "ci"}.  Default output is a matrix with the point and interval estimate. 
}
\references{
Agresti, A., Min, Y. (2001) On small-sample confidence intervals for parameters in discrete distributions.  \emph{Biometrics} 57: 963-97.

Aho, K., and Bowyer, T. 2015. Confidence intervals for ratios of proportions: implications for selection ratios. \emph{Methods in Ecology and Evolution} 6: 121-132.

Bailey, B.J.R. (1987) Confidence limits to the risk ratio.  \emph{Biometrics} 43(1): 201-205.

Katz, D., Baptista, J., Azen, S. P., and Pike, M. C. (1978) Obtaining confidence intervals for the risk ratio in cohort studies. \emph{Biometrics} 34: 469-474

Koopman, P. A. R. (1984) Confidence intervals for the ratio of two binomial proportions. \emph{Biometrics} 40:513-517.

Manly, B. F., McDonald, L. L., Thomas, D. L., McDonald, T. L. and Erickson, W.P. (2002)  \emph{Resource Selection by Animals: Statistical Design and Analysis for Field Studies.  2nd  edn.}  Kluwer, New York, NY

Newcombe, R. G. (2001)  Logit confidence intervals and the inverse sinh transformation.  \emph{The American Statistician} 55: 200-202.

Pettigrew H. M., Gart, J. J., Thomas, D. G. (1986)  The bias and higher cumulants of the logarithm of a
binomial variate.  \emph{Biometrika} 73(2): 425-435.

Walter, S. D. (1975) The distribution of Levins measure of attributable risk. \emph{Biometrika} 62(2): 371-374.
}
\author{
Ken Aho
}
\seealso{
\code{\link{ci.p}, \link{ci.prat.ak}}
}
\examples{
# From Koopman (1984)
ci.prat(y1 = 36, n1 = 40, y2 = 16, n2 = 80, method = "katz")
ci.prat(y1 = 36, n1 = 40, y2 = 16, n2 = 80, method = "koop")
}

\name{plantTraits}
\alias{plantTraits}
\docType{data}
\title{Plant traits for 136 species}
\description{
This dataset, from the library \pkg{cluster}, describes 136 plant species
according to biological attributes (morphological or reproductive).
}
\usage{data(plantTraits)}
\format{
 A data frame with 136 observations on the following 31 variables.
   \describe{
     \item{\code{pdias}}{Diaspore mass (mg).}
     \item{\code{longindex}}{Seed bank longevity.}
     \item{\code{durflow}}{Flowering duration.}
     \item{height}{Plant height, an ordered factor with levels '1' < '2' <
          ... < '8'.}
     \item{\code{begflow}}{Time of first flowering, an ordered factor with levels
          '1' < '2' < '3' < '4' < '5' < '6' < '7' < '8' < '9'.}
     \item{\code{mycor}}{Mycorrhizae, an ordered factor with levels '0'never < '1'
          sometimes< '2'always.}
     \item{\code{vegaer}}{Aerial vegetative propagation, an ordered factor with
          levels '0'never < '1' present but limited< '2'important.}
     \item{\code{vegsout}}{Underground vegetative propagation, an ordered factor
          with 3 levels identical to 'vegaer' above.}
     \item{\code{autopoll}}{Selfing pollination, an ordered factor with levels
          '0'never < '1'rare < '2' often< the rule'3'.}
     \item{\code{insects}}{Insect pollination, an ordered factor with 5 levels '0'
          < ... < '4'.}
     \item{\code{wind}}{Wind pollination, an ordered factor with 5 levels '0' < ...
          < '4'.}
     \item{\code{lign}}{A binary factor with levels '0:1', indicating if plant is
          woody.}
     \item{\code{piq}}{A binary factor indicating if plant is thorny.}
     \item{\code{ros}}{A binary factor indicating if plant is rosette.}
     \item{\code{semiros}}{Semi-rosette plant, a binary factor ('0': no; '1': yes).}
     \item{\code{leafy}}{Leafy plant, a binary factor.}
     \item{\code{suman}}{Summer annual, a binary factor.}
     \item{\code{winan}}{Winter annual, a binary factor.}
     \item{\code{monocarp}}{Monocarpic perennial, a binary factor.}
     \item{\code{polycarp}}{Polycarpic perennial, a binary factor.}
     \item{\code{seasaes}}{Seasonal aestival leaves, a binary factor.}
     \item{\code{seashiv}}{Seasonal hibernal leaves, a binary factor.}
     \item{\code{seasver}}{Seasonal vernal leaves, a binary factor.}
     \item{\code{everalw}}{Leaves always evergreen, a binary factor.}
     \item{\code{everparti}}{Leaves partially evergreen, a binary factor.}
     \item{\code{elaio}}{Fruits with an elaiosome (dispersed by ants), a binary
          factor.}
     \item{\code{endozoo}}{Endozoochorous fruits, a binary factor.}
     \item{\code{epizoo}}{Epizoochorous fruits, a binary factor.}
     \item{\code{aquat}}{Aquatic dispersal fruits, a binary factor.}
     \item{\code{windgl}}{wind dispersed fruits,  a binary factor.}
     \item{\code{unsp}}{Unspecialized mechanism of seed dispersal, a binary factor.}
  }
}
\details{Most of factor attributes are not disjunctive. For example, a  plant can be 
usually pollinated by insects but sometimes self-pollination can occur.}
\note{The description here follows directly from that in \pkg{cluster}.}
\source{
     Vallet, Jeanne (2005) \emph{Structuration de communautes vegetales et
     analyse comparative de traits biologiques le long d'un gradient
     d'urbanisation}. Memoire de Master 2
     'Ecologie-Biodiversite-Evolution'; Universite Paris Sud XI, 30p.+
     annexes (in french).

     Maechler, M., Rousseeuw, P., Struyf, A., Hubert, M. (2005).  \emph{Cluster
     Analysis Basics and Extensions}; unpublished.
}

\keyword{datasets}

\name{stan.error}
\alias{stan.error}
\alias{stan.error.sq}
\title{Variance and standard error estimators for the sampling distribution of the sample mean}
\description{Estimator for the variance for the sampling distribution of the sample mean, i.e. \eqn{S^2/n}, and the standard deviation of the sampling distribution, i.e. \eqn{S/\sqrt(n)}.
}
\usage{
stan.error(x)
stan.error.sq(x)
}
\arguments{
\item{x}{A vector of quantitative data.}}
\author{Ken Aho}
\seealso{\code{\link{sd}}}
\keyword{univar}

\name{bootstrap}
\alias{bootstrap}
\alias{print.bootstrap}
\title{A simple function for bootstrapping}
\description{
The function serves as a simplified alternative to the function \code{\link[boot]{boot}} from the library \code{boot}. 
}
\usage{
bootstrap(data, statistic, R = 1000, prob = NULL, matrix = FALSE)
}
\arguments{
  \item{data}{Raw data to be bootstrapped.  A vector or quantitative data or a matrix if \code{matrix =TRUE}.}
  \item{statistic}{A function whose output is a statistic (e.g. a sample mean).  The function must have only one argument, a call to data.}
  \item{R}{The number of bootstrap iterations.}
  \item{prob}{A vector of probability weights for paramteric bootstrapping.}
  \item{matrix}{A logical statement.  If \code{matrix = TRUE} then rows in the matrix are sampled as multivariate observations.}
}
\details{With bootstrapping we sample with replacement from a dataset of size \emph{n} with n samples \code{R} times. At each of the \code{R} iterations a statistical summary can be created resulting in a bootstrap distribution of statistics.}   
\value{
  Returns a list.  The utility function \code{asbio:::print.bootstrap} returns summary output.  Invisible items include the resampling distribution of the statistic, the data, the statistic, and the bootstrap samples.  
}
\references{
Manly, B. F. J.  (1997)  \emph{Randomization and Monte Carlo Methods in Biology, 2nd edition}.  
Chapman and Hall, London.
}
\author{Ken Aho}
\seealso{\code{\link[boot]{boot}}, \code{\link{ci.boot}}}
\examples{


data(vs)
# A partial set of observations from a single plot for a Scandinavian 
# moss/vascular plant/lichen survey.
site18<-t(vs[1,])

#Shannon-Weiner diversity
SW<-function(data){
d<-data[data!=0]
p<-d/sum(d)
-1*sum(p*log(p))
}

bootstrap(site18[,1],SW,R=1000,matrix=FALSE)
}
\keyword{manip}

\name{bombus}
\Rdversion{1.1}
\alias{bombus}
\docType{data}
\title{Bombus pollen data.
}
\description{To investigate how pollen removal varied with reproductive caste in bemblebees (\emph{Bombus} sp.) Harder and Thompson (1989) recorded the proportion of pollen removed by thirty five bumblebee queens and twelve worker bees.
}
\usage{data(bombus)}
\format{
This data frame contains the following columns:
   \describe{
    \item{\code{pollen}}{
      A numeric vector indicating the proportion of pollen removed.
         }
    \item{\code{caste}}{
      A character string vector indicating whether a bee was a worker \code{"W"} or a queen \code{"Q"}.
         }
    }
  }
\source{
Harder, L. D. and Thompson, J. D.  1989.  Evolutionary options for maximizing pollen dispersal in animal pollinated plants.  \emph{American Naturalist} 133: 323-344.
}
\keyword{datasets}

\name{garments}
\alias{garments}
\docType{data}
\title{
Garment Latin square data from Littell et al. (2002)
}
\description{
Four materials (A, B, C, D) used in permanent press garments were subjected to a test for shrinkage.  The four materials were placed in a heat chamber with with four settings (pos).  The test was then conducted in four runs (run). 
}
\usage{data(garments)}
\format{
  A data frame with 16 observations on the following 4 variables.
  \describe{
    \item{\code{run}}{Test run, a factor with levels \code{1} \code{2} \code{3} \code{4}}
    \item{\code{pos}}{Heat position, a factor with levels \code{1} \code{2} \code{3} \code{4}}
    \item{\code{mat}}{Fabric materials, a factor with levels \code{A} \code{B} \code{C} \code{D}}
    \item{\code{shrink}}{Shrinkage measure, a numeric vector}
  }
}

\source{
Littell, R. C., Stroup, W. W., and R. J. Freund (2002)  \emph{SAS for Linear Models}.  John 
Wiley and Associates.
}
\keyword{datasets}

\name{see.regression.tck}
\alias{see.regression.tck}

\title{
Demonstration of regression mechanics
}
\description{
Population and sample regression lines are interactively depicted.  The same random observations generated by the true error distribution is used for both models. 
}
\usage{

see.regression.tck()
}
\author{
Ken Aho
}
\keyword{graphs}

\name{pairw.oneway}
\alias{pairw.oneway}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Welch tests controlled for simultaneous inference
}
\description{
Conducts all possible pairwise Welch tests with adjustments to \emph{P}-values using methods from \code{\link{p.adjust}}
}
\usage{
pairw.oneway(y, x, conf = 0.95, digits = 5, method = "holm")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{y}{
Response variable
}
  \item{x}{
Explanatory variable
}
  \item{conf}{
Confidence level
}
  \item{digits}{
Number of digits in results
}
  \item{method}{
Generalized method for controlling family wise type one error.  These must be methods from \code{\link{p.adjust}}, i.e., \code{"holm"}, \code{"hochberg"}, \code{"hommel"}, \code{"bonferroni"}, \code{"BH"}, \code{"BY"}, \code{"fdr"}, \code{"none"}.  Names can be abbreviated. 
}
}

\value{
The function \code{pairw.oneway} and the confidence interval functions it calls return a list of \code{class = "pairw"}. 

1) the type of contrast (names are taken from levels in x),

2) the mean difference,

3) the lower confidence bound of the true mean difference,

4) the upper confidence bound of the true mean difference,

5) the hypothesis decision, given the prescribed significance level, and

6) the adjusted \emph{P}-value.

Other \code{invisible} objects include:
  \item{cont}{a vector of contrasts.}
  \item{conf}{The confidence level.}
  \item{band}{A two column matrix containing the lower and upper confidence bounds.}
}

\note{
Note that while \emph{P}-values will be adjusted for simultaneous inference (unless \code{method = "none"}), confidence interval width are generally \emph{not adjusted}.  In particular, CI widths correspond to Welch SEs and Satterthwaite \emph{t} degrees of freedoms  Thus they control for heteroscedasticity, however they do not control for family-wise levels of \eqn{\alpha} unless \code{method = "bonferroni"}, under which the restrictive confidence level \eqn{1 - (\alpha/2r)} is used, where \emph{r} is the number of comparisons. 
}

\references{Kutner, M. H., Nachtsheim, C. J., Neter, J., and Li., W  (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.
}
\author{
Ken Aho and Peter Eckert
}

\seealso{
\code{\link{p.adjust}}, \code{\link{pairw.anova}} 
}
\examples{
y <- rnorm(30)
x <- as.factor(c(rep(1,10), rep(2,10), rep(3, 10)))
p <- pairw.oneway(y,x)
p
plot(p)
}
\keyword{univar}
\keyword{htest}

\name{ant.dew}
\alias{ant.dew}
\docType{data}
\title{
Ant honeydew data
}
\description{
Wright et al. (2000) examined behavior of red wood ants (\emph{Formica rufa}), a species that harvests honeydew in aphids.  
Worker ants traveled from their nests to nearby trees to forage honeydew from homopterans.  Ants descending trees were laden with food and weighed more, given a particular ant head width, then unladen, ascending ants.  
The authors were interested in comparing regression parameters of the ascending and descending ants to create a predictive model of honeydew foraging load for a given ant size.  
}
\usage{data(ant.dew)}
\format{
  A data frame with 72 observations on the following 3 variables.
  \describe{
    \item{\code{head.width}}{Ant head width in mm}
    \item{\code{ant.mass}}{Ant mass in mg}
    \item{\code{direction}}{Direction of travel \code{A} = ascending, \code{D} = descending}
  }
}
\details{
Data approximated from Fig. 1 in Wright et al. (2002)
}
\source{
Wright, P. J., Bonser, R., and U. O. Chukwu  (2000) The size-distance relationship in the 
wood ant \emph{Formica rufa}. \emph{Ecological Entomology} 25(2): 226-233.
}
\keyword{datasets}

\name{see.lmu.tck}
\alias{see.lmu.tck}
\alias{pm}
\title{
Unbalanced and balanced linear models
}
\description{The default design is balanced, as a result Type I = Type II = Type III SS.  A student can then delete one or more Y responses, and corresponding X responses to see create an unbalanced design.  Now the types of SS will no longer be equal.  Furthermore, the order that X1 and X2 are specified will now matter in the case of Type I SS, although it will not matter for type II and III SS. 
}
\usage{

see.lmu.tck()

pm(Y, X1, X2, X1X2, change.order = FALSE, delete = 0)
}

\arguments{
  \item{Y}{Response variable.}
  \item{X1}{
First column in design matrix with effect coding.
}
  \item{X2}{
Second column in design matrix.   
}
  \item{X1X2}{
An interaction column.  The product of design matrix columns one and two
}
  \item{change.order}{
A logical command specifying whether or not the order of \code{X1} and \code{X2} should changed in the model specification.
}
  \item{delete}{
when \code{delete != 0} an observation number to be deleted.
}
}

\author{Ken Aho}
\seealso{\code{\link{lm}}
}

\examples{
if(interactive()){
if(any(names(sessionInfo()$otherPkgs)=="asbio")) vignette(package = "asbio", "typeISS_key")
}
}



\keyword{graphs}

\name{huber.mu}
\alias{huber.mu}
\title{Huber M-estimator of location}
\description{The Huber \emph{M}-estimator is a robust high efficiency estimator of location that has probably been under-utilized by biologists. It is based on maximizing the likelihood of a weighting function.  This is accomplished using an iterative least squares process.  The Newton Raphson algorithm is used here.  The function usually converges fairly quickly (< 10 iterations).  The function uses the Median Absolute Deviation function, \code{\link{mad}}.  Note that if MAD = 0, then \code{NA} is returned.
}
\usage{
huber.mu(x, c = 1.28, iter = 20, conv = 1e-07)
}
\arguments{
  \item{x}{A vector of quantitative data.}
  \item{c}{Stop criterion.  The value \code{c = 1.28} gives 95\% efficiency of the mean given normality.}
  \item{iter}{Maximum number of iterations.}
  \item{conv}{Convergence criterion.}
}
\value{
Returns Huber's \emph{M}-estimator of location.}  
\seealso{\code{\link{huber.one.step}}, \code{\link{huber.NR}}, \code{\link{mad}}}
\references{ 
Huber, P. J. (2004)  \emph{Robust Statistics}. Wiley.

Wilcox, R. R. (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\examples{
x <- rnorm(100)
huber.mu(x)
}

\name{Mode}
\alias{Mode}
\title{Sample mode}
\description{Calculates the sample mode; i.e. the most frequent outcome in a dataset.  Non-existence of the mode will return a message.  Several errors in earlier versions were corrected in asbio 0.4.}
\usage{
Mode(x)
}
\arguments{
  \item{x}{A vector of quantitative data.}
}
\value{Returns the sample mode or an error message if the mode does not exist.
}
\references{Bain, L. J., and M. Engelhardt (1992)  \emph{Introduction to Probability and Mathematical 
Statistics}.  Duxbury press.  Belmont, CA, USA.
}
\author{Ken Aho}
\seealso{\code{\link{H.mean}}, \code{\link{HL.mean}}, \code{\link{mean}}, \code{\link{median}}, \code{\link{huber.mu}}}
\examples{
x<-round(rnorm(100000,mean=10,sd=2),0)
Mode(x)
}

\name{ML.k}
\alias{ML.k}
\title{
Maximum likelihood algorithm for determining the binomial dispersal coefficient
}
\description{
The function uses the maximum likelihood method described by Bliss and R. A. Fisher (1953) to determine maximum likelihood estimates for the binomial parameters \emph{m} (the mean) and \emph{k} (a parameter describing aggregation/dispersion). 
}
\usage{

ML.k(f, x, res = 1e-06)
}
\arguments{
  \item{f}{A vector of frequencies for objects in \code{x} (must be integers).

}
  \item{x}{
A vector of counts, must be sequential integers.
}
  \item{res}{
Resolution for the ML estimator.
}
}

\value{
Returns a list with two items
\item{k}{The negative binomial dispersion parameter, \emph{k}}

\item{m}{The negative binomial distribution mean, \emph{m}}

}
\references{
Bliss, C. I., and R. A. Fisher (1953)  Fitting the negative binomial distribution to biological data.  \emph{Biometrics} 9: 176-200.
}
\author{Ken Aho
}
\note{The program is slow at the current resolution.  Later iterations will use linear interpolation, or Fortran loops, or both.
}
\seealso{
\code{\link{dnbinom}}}
\examples{
mites <- seq(0, 8)
freq <- c(70, 38, 17, 10, 9, 3, 2, 1, 0)
ML.k(freq, mites) 
}

\name{win}
\alias{win}
\title{Winsorize data}
\description{
Winsorizes the proportion of ordered data given by \code{lambda} from each tail.
}
\usage{

win(x, lambda = 0.2)
}
\arguments{

  \item{x}{A vector of data.}
  \item{lambda}{A proportion from 0-1 giving the amount of data to be Winsorized in each tail of an ordered dataset.}
}
\details{
In Winsorization we  we replace responses that are not in the central \eqn{1 - 2\lambda} part of an ordered sample with the minimum and maximum responses of the central part of the sample.  
}
\value{
Returns Winsorized data.
}
\references{
Wilcox, R. R. (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}

\examples{
x<-c(2,1,4,5,6,2.4,7,2.2,.002,15,17,.001)
win(x)}

\name{press}
\alias{press}

\title{
prediction sum of squares
}
\description{
Calculates PREdiction Sum of Squares (\emph{PRESS}) for a linear model.
}
\usage{

press(lm, as.R2 = FALSE)
}
\arguments{
  \item{lm}{
An object of class \code{lm}.
}
  \item{as.R2}{ 
Logical.  Whether or not output should be expressed as predicted \eqn{R^2}, i.e., \eqn{PRESS/TSS}.   
}
}
\details{
The press statistic is calculated as:
\deqn{\sum_{i=1}^{n}d_i^2}
where 
\deqn{d_i = \frac{e_i}{1-h_{ii}}} 
where \eqn{h_{ii}} is the \emph{i}th diagonal element in the hat matrix.
}
\value{
Returns the \emph{PRESS} statistic.
}
\references{
Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li  (2005)  \emph{Applied Linear Statistical Models, 5th edition.}  McGraw-Hill, Boston.
}
\author{
Ken Aho
}
\seealso{\code{\link{cor}}}
\examples{
Y <- rnorm(100)
X <- rnorm(100)
press(lm(Y ~ X))
}
\keyword{univar}

\name{alpha.div}
\Rdversion{1.1}
\alias{alpha.div}
\alias{Simp.index}
\alias{SW.index}
\title{Functions for calculating alpha diversity.
}
\description{
Alpha diversity quantifies richness and evenness within a sampling unit (replicate).

The function \code{alpha.div} runs \code{Simp.index} or \code{SW.index} to calculate Simpson's, Inverse Simpson's or Shannon-Weiner diversities. 

Simpson's index has a straightforward interpretation. It is the probability of reaching into a plot and simultaneously pulling out two different species.  
Inverse Simpson's diversity is equivalent to one over the probability that two randomly chosen individuals will be the same species. 
These measures have been attributed to Simpson (1949).  While it does not allow straightforward interpretation of results, the Shannon-Weiner diversity (\emph{H}') 
is another commonly used alpha-diversity measure based on the Kullback-Leibler information criterion (Macarthur and Macarthur 1961). 
}
\usage{
alpha.div(x,index)
Simp.index(x,inv)
SW.index(x)
}
\arguments{
  \item{x}{
A vector or matrix of species abundances (e.g. counts).  The functions assume that species are in columns and sites are in rows.}
  \item{index}{
The type of alpha diversity to be computed.  The function currently has three choices. \code{simp} = Simpson's diversity, \code{inv.simp}=inverse Simpson's, \code{shan} = Shannon-Weiner diversity.}  
  \item{inv}{Logical, indicating whether or not Simpson's inverse diversity should be computed.} 	
}
\value{A single diversity value is returned if \code{x} is a vector.  A vector of diversities (one for each site) are returned if \code{x} is a matrix. 
}
\references{
Simpson, E. H.  (1949)  Measurement of diversity.  \emph{Nature}.  163: 688.

MacArthur, R. H., and MacArthur J. W.  (1961)  On bird species diversity.  \emph{Ecology}.  42: 594-598.
}
\author{
Ken Aho
}

\examples{
data(cliff.sp)
alpha.div(cliff.sp,"simp")
}

\name{bin2dec}
\alias{bin2dec}
\alias{dec2bin}
\alias{dec2bin.twos}

\title{
Conversion between binary digits and decimal numbers
}
\description{
Here are simple functions for converting binary expressions to digital numbers, and vice versa, under simple and (bit signed) two's complement formatting.
}

\usage{
bin2dec(digits, sign.bit = FALSE)

dec2bin(num, max.bits = 10, max.rep0 = 6)

dec2bin.twos(num, ...)
}

\arguments{
  \item{digits}{
A character string or sequence of binary digits.
}
  \item{sign.bit}{
Logical, indicating whether the leading bit a sign bit.
}
  \item{num}{
A decimal number greater than or equal to 0.
}
  \item{max.bits}{
The maximum number of bits to be used to approximate fractional numbers.
}
  \item{max.rep0}{
A handler for meaningless repeating zeroes at the end of some binary representations of decimal numbers, e.g., 0.25. Can be turned off by letting \code{max.rep0 = NULL}.
}
\item{...}{
Additional arguments from \code{dec2bin}.
}
}

\details{
The function \code{dec2bin} converts positive decimal representations to binary.
Use of a negative binary number (for instance, using \code{num = -10}) will produce the warning: "num must be >= 0. You can obtain binary expressions for negative decimal numbers with two's complement formatting using dec2bin.twos()."

The function \code{dec2bin.twos} converts positive decimal representations to binary under two's complement formatting. Thus (unlike \code{dec2bin}) it can handle positive and negative values for its \code{num} argument.

The function \code{bin2dec} converts binary representations of digital numbers (e.g., 10101011 = 171). Fractions, (e.g., \code{0.11101}) will be evaluated to the number of bits provided. Use of \code{sign.bit = TRUE} converts the first binary bit into a sign bit \code{0} = positive, \code{1} = negative, to allow binary formats like two's complement.
}

\author{
Ken Aho
}
\examples{
bin2dec(10110011.01) # = 179.25
dec2bin(179.25) # = 10110011.01

# Negative decimals
dec2bin.twos(-179.25) # = 101001101.1 (twos complement)
bin2dec(101001100.11, sign.bit = TRUE) # = -179.25
}

\name{trag}
\alias{trag}
\docType{data}
\title{
Salsify height dataset
}
\description{
Heights of salsify \emph{Tragapogon dubius} at the Barton Road long term experimental site in Pocatello Idaho. 
}

\usage{data(trag)}


\format{
  A data frame with 20 observations on the following variable.
  \describe{
    \item{\code{height}}{\emph{T. dubius} plant height in cm}
  }
}
\keyword{datasets}

\name{plot.pairw}
\alias{plot.pairw}

\title{
Plots confidence intervals and/or bars with letters indicating significant differences for objects from class pairw
}
\description{
Provides a utility confidence interval plotting function for objects of \code{class = "pairw"}, e.g., objects from \code{pairw.anova}, \code{pair.fried}, and \code{pairw.kw}.
}
\usage{
\method{plot}{pairw}(x, type = 1, lcol = 1, lty = NULL, lwd = NULL,
cap.length = 0.1, xlab = "", main = NULL, explanation = TRUE,...)
}
\arguments{

  \item{x}{
An object of class \code{pairw}.
}
  \item{type}{
Two types of plots can be made.  Type 1 is a barplot with identical letters over bars if the differences are not significant after adjustment for simultaneous inference.  Type 1 plots can be modified using \code{\link{bplot}} arguments.  A type 2 plot shows confidence intervals for true differences.
}
  \item{lcol}{
Confidence bar line color for a type 2 plot, see \code{\link{par}}.
}
  \item{lty}{
Confidence bar line type, see \code{\link{par}}.
}
  \item{lwd}{
Confidence bar line width, see \code{\link{par}}.
}
 \item{cap.length}{
Widths for caps on interval bars (in inches).
}
  \item{xlab}{
X-axis label.
}
  \item{main}{
Main caption.  Defaults to a descriptive head.
}
  \item{explanation}{
Logical.  If \code{TRUE} (default) provides plot explanation with text.
}
  \item{\dots}{
Additional arguments from \code{\link{bplot}} or \code{\link{barplot}} for type 1 and 2 graphs, respectively.
}
}

\author{
Ken Aho.  Letters for type 1 graphs obtained using the function \code{\link[multcompView]{multcompLetters}} which uses the algorithm of Peipho (2004).
}
\references{
Piepho, H-P (2004) An algorithm for a letter-based representation of all-pairwise comparisons. \emph{Journal of Computational and Graphical Statistics} 13(2): 456-466.
}
\seealso{
\code{\link{pairw.anova}}, \code{\link{pairw.fried}}, \code{\link{pairw.kw}}, \code{\link{barplot}}, \code{\link{bplot}}, \code{\link[multcompView]{multcompLetters}}
}
\examples{
eggs<-c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)
trt<-as.factor(c(1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,4,4,4))

# Type 1 plot
plot(pairw.anova(y = eggs, x = trt, method = "scheffe", conf = .8), int = "CI",
conf = .8)
# Type 2 plot
plot(pairw.anova(y = eggs, x = trt, method = "scheffe", conf = .8), type = 2)

# Data from Fox and Randall (1970)
tremors <- data.frame(freq = c(2.58, 2.63, 2.62, 2.85, 3.01, 2.7, 2.83, 3.15,
3.43, 3.47, 2.78, 2.71, 3.02, 3.14, 3.35, 2.36, 2.49, 2.58, 2.86, 3.1, 2.67,
2.96, 3.08, 3.32, 3.41, 2.43, 2.5, 2.85, 3.06, 3.07), weights =
factor(rep(c(7.5, 5, 2.5, 1.25, 0), 6)), block = factor(rep (1 : 6, each = 5)))

plot(with(tremors, pairw.fried(y = freq, x = weights, blocks = block, nblocks =
6, conf = .95)), loc.meas = median, int = "IQR", bar.col = "lightgreen",
lett.side = 4, density = 3, horiz = TRUE) # Note how blocking increases power

rye.data <- data.frame(rye = c(50, 49.8, 52.3, 44.5, 62.3, 74.8, 72.5, 80.2,
47.6, 39.5, 47.7,50.7), nutrient = factor(c(rep(1, 4), rep(2, 4), rep(3, 4))))

plot(with(rye.data, pairw.kw(y = rye, x = nutrient, conf = .95)), type = 2)
}

\keyword{graphs}
\keyword{htest}

\name{refinery}
\alias{refinery}
\docType{data}
\title{Refinery CO dataset}
\description{
In the early 1990s an oil refinery northeast of San Francisco agreed with local air quality regulators [the Bay Area Air Quality Management District (BAAQMD)] to reduce carbon monoxide emissions.  Baselines for reductions were to be based on measurements of CO made by refinery personnel, and by independent measurements from BAAQMD scientists for the roughly the same time period 
}
\usage{data(refinery)}
\format{
The dataframe contains three columns:
  \describe{
\item{\code{CO}}{Carbon monoxide.  Measured in ppm.}
\item{\code{Source}}{The source of measurements; either refinery or BAAQMD.}
\item{\code{Date}}{Month/Day/Year}
}
}
\keyword{datasets}

\name{rinvchisq}
\alias{rinvchisq}

\title{
Random draws from a scaled inverse chi-square distribution
}
\description{
The distribution is an important component of Bayesian normal hierarchical models with uniform priors.
}
\usage{

rinvchisq(n, df, scale = 1/df)
}
\arguments{
  \item{n}{
The number of random draws.
}
  \item{df}{
Degrees of freedom parameter.
}
  \item{scale}{
Scale non-centrality parameter.
}
}
\details{
Code based on a function with same name in package \pkg{goeR}.
}
\seealso{
The function is a wrapper for \code{\link{rchisq}}.}

\name{see.smooth.tck}
\alias{see.smooth.tck}
\title{
Interactive smoother demonstrations
}
\description{
LOWESS, kernel, and spline smoothers are depicted, using \pkg{tcltk} widgets.}
\usage{
see.smooth.tck()
}

\author{
Ken Aho, appropriated ideas from demo in library \pkg{tcltk}.
}
\seealso{
\code{\link{loess}}, \code{\link{ksmooth}}, \code{\link{smooth.spline}}
}
\keyword{graphs}

\name{lm.select}
\alias{lm.select}

\title{
AIC, AICc, BIC, Mallow's Cp, and PRESS evaluation of linear models
}
\description{
The function provide model selection summaries using \emph{AIC}, \emph{AICc}, \emph{BIC}, Mallow's \eqn{C_p}, and \emph{PRESS} for a list of objects of class \code{lm} 
}
\usage{

lm.select(lms, deltaAIC = FALSE)
}
\arguments{

 \item{lms}{
A list containing linear models.}
 \item{deltaAIC}{Logical; Should a \eqn{\Delta} \emph{AIC} summary be given with relative likelihoods and Akaike weights?}
}
\note{Mallow's \eqn{C_p} assumes that all models are nested within the first model in the argument \code{lms}.  Non-nesting will produce a warning message.}

\author{
Ken Aho
}

\seealso{
\code{\link{AIC}}, \code{\link{press}}
}
\examples{
Y <- rnorm(100)
X1 <- rnorm(100)
X2 <- rnorm(100)

lms <- list(lm(Y ~ X1), lm(Y ~ X1 + X2))
lm.select(lms)

}
\keyword{univar}

\name{rmvm}
\alias{rmvm}
\docType{data}
\title{
A multivariate normal dataset for data mining
}
\description{
Contains a \emph{Y} variable constrained to be a random function of fifteen \emph{X} variables, which, in turn, are generated from a multivariate normal distribution with no correlation between dimensions.   
}

\usage{data("rmvm")}
\format{
  A data frame with 500 observations on the following 16 variables.
  \describe{
    \item{\code{Y}}{A response vector defined to be: \eqn{Y =  X_1 + X_2 + X_3 + X_4 + X_5 + X_6 + X_7 +
X_8 + X_9 + X_{10} + X_{11} + X_{12} + X_{13} + X_{14} + X_{15} + \epsilon} where \eqn{\epsilon \sim N(0, 1)}.}
    \item{\code{X1}}{A random predictor}
    \item{\code{X2}}{A random predictor}
    \item{\code{X3}}{A random predictor}
    \item{\code{X4}}{A random predictor}
    \item{\code{X5}}{A random predictor}
    \item{\code{X6}}{A random predictor}
    \item{\code{X7}}{A random predictor}
    \item{\code{X8}}{A random predictor}
    \item{\code{X9}}{A random predictor}
    \item{\code{X10}}{A random predictor}
    \item{\code{X11}}{A random predictor}
    \item{\code{X12}}{A random predictor}
    \item{\code{X13}}{A random predictor}
    \item{\code{X14}}{A random predictor}
    \item{\code{X15}}{A random predictor}
  }
}
\details{
Data used by Derryberry et al. (in review) to consider high dimensional model selection applications.  
}

\references{
Derryberry, D., Aho, K., Peterson, T., Edwards, J.  (In review).  Finding the "best" second order regression model in a polynomial number of steps.  \emph{American Statistician}.
}
\examples{
## Code used to create data
\dontrun{
sigma <- matrix(nrow = 15, ncol = 15, 0)
diag(sigma) = 1
mvn <- rmvnorm(n=500, mean=rnorm(15), sigma=sigma)
Y <- mvn[,1] + mvn[,2] + mvn[,3] + mvn[,4] + mvn[,4] + mvn[,5] + mvn[,6] + mvn[,7] +
mvn[,8] + mvn[,9] + mvn[,10] + mvn[,11] + mvn[,12] + mvn[,13] + mvn[,14] + mvn[15] + rnorm(500)
rmvm <- data.frame(cbind(Y, mvn))
names(rmvm) <- c("Y", paste("X", 1:15, sep = ""))
}
}
\keyword{datasets}

\name{anm.LV}
\alias{anm.LVcomp}
\alias{anm.LVexp}
\alias{anm.LVc.tck}
\alias{anm.LVe.tck}
\title{Animated depictions of Lotka-Volterra competition and exploitation models
}
\description{
Creates animated plots of two famous abundance models from ecology; the Lotka-Volterra competition and exploitation models
}
\usage{
anm.LVcomp(n1, n2, r1, r2, K1, K2, a2.1, a1.2, time = seq(0, 200), ylab =
"Abundance", xlab = "Time", interval = 0.1, ...)

anm.LVexp(nh, np, rh, con, p, d.p, time = seq(0, 200), ylab = "Abundance",
xlab = "Time", interval = 0.1, circle = FALSE, ...)

anm.LVc.tck()

anm.LVe.tck()
}

\arguments{
\item{n1}{Initial abundance values for species one.  To be used in the competition function \code{anm.LVcomp}, i.e., \eqn{N_1} in the competition equations below.}
\item{n2}{Initial abundance values for species two in the competition function, i.e., \eqn{N_2} in the competition equations below.}
\item{r1}{Maximum intrinsic rate of increase for species one, i.e., \eqn{r_{max1}}.}
\item{r2}{Maximum intrinsic rate of increase for species two in the competition model \code{anm.LVcomp}, i.e., \eqn{r_{max2}}.}
\item{K1}{Carrying capacity for species one, i.e., \eqn{K_1}.}
\item{K2}{Carrying capacity for species two, i.e., \eqn{K_2}.}
\item{a2.1}{The interspecific effect of species one on species two, i.e., the term \eqn{\alpha_{21}}.}
\item{a1.2}{The interspecific effect of species two on species one, i.e., the term \eqn{\alpha_{12}}.}


\item{nh}{Initial abundance values for the host (prey) species.  To be used in the the exploitation model \code{anm.LVexp}, i.e., the term \eqn{N_h} at \eqn{t = 1}.}
\item{np}{Initial abundance values for the predator species in the the exploitation model, i.e., the term \eqn{N_p} at \eqn{t = 1}.}
\item{rh}{The intrinsic rate of increase for the host (prey) species, i.e., the term \eqn{r_h}.}
\item{con}{The conversion rate of prey to predator, i.e., the term \eqn{c}.}
\item{p}{The predation rate, i.e., the term \eqn{p}.}
\item{d.p}{The death rate of predators, i.e., the term \eqn{d_p}.}


\item{time}{A time sequence for which competition or exploitation is to be evaluated.}
\item{ylab}{\emph{Y}-axis label.}
\item{xlab}{\emph{X}-axis label.}
\item{interval}{Animation speed per frame (in seconds).}
\item{circle}{Logical, if \code{TRUE} a circular representation of the relation of prey and predator numbers is drawn.}
\item{\dots}{Additional arguments from \code{\link{plot}}.}
}

\details{
The Lotka-Volterra competition and exploitation models require simultaneous solutions for two differential equations.  These are solved using the function \code{rk4} from \code{odesolve}.

The interspecific competition model is based on:

\deqn{\frac{dN_1}{dt}=r_{max1}N_1\frac{K_1-N_1-\alpha_{12}}{K_1},}
\deqn{\frac{dN_2}{dt}=r_{max2}N_2\frac{K_2-N_2-\alpha_{21}}{K_2},}

where \eqn{N_1} is the number of individuals from species one, \eqn{K_1} is the carrying capacity for species one, \eqn{r_{max1}} is the maximum intrinsic rate of increase of species one, and \eqn{\alpha_{12}} is the interspecific competitive effect of species two on species one.

The exploitation model is based on:

\deqn{\frac{dN_h}{dt} = r_hN_h-pN_hN_p,}
\deqn{\frac{dN_p}{dt} = cpN_hN_p-d_pN_p,}

where \eqn{N_h} is the number of individuals from the host (prey) species, \eqn{N_p} is the number of individuals from the predator species, \eqn{r_h} is the intrinsic rate of increase for the host (prey) species, \eqn{p} is the rate of predation, \eqn{c} is a conversion factor which describes the rate at which prey are converted to new predators, and \eqn{d_p} is the death rate of the predators.

The term \eqn{r_hN_h} describes exponential growth for the host (prey) species.  This will be opposed by deaths due to predation, i.e. the term \eqn{pN_hN_p}.  The term \eqn{cpN_hN_p} is the rate at which predators destroy prey. This in turn will be opposed by \eqn{d_pN_p}, i.e. predator deaths.  . The functions \code{anm.LVe.tck()} and \code{anm.LVc.tck()} allow one to run \code{anm.LVe()} and \code{anm.LVc()}  with \pkg{tcltk} GUIs.
}

\value{The functions return descriptive animated plots}
\references{
Molles, M. C. (2010) \emph{Ecology, Concepts and Applications, 5th edition}.  McGraw Hill.

Crawley, M. J.  (2007) \emph{The R Book}.  Wiley
}

\author{Ken Aho, based on a concept elucidated by M. Crawley}
\examples{
\dontrun{

#---------------------- Competition ---------------------#
##Species 2 drives species 1 to extinction
anm.LVcomp(n1=150,n2=50,r1=.7,r2=.8,K1=200,K2=1000,a2.1=.5,a1.2=.7,time=seq(0,200))
##Species coexist with numbers below carrying capacities
anm.LVcomp(n1=150,n2=50,r1=.7,r2=.8,K1=750,K2=1000,a2.1=.5,a1.2=.7,time=seq(0,200))

#----------------------Exploitation----------------------#
#Fast cycles
anm.LVexp(nh=300,np=50,rh=.7,con=.4,p=.006,d.p=.2,time=seq(0,200))}
}

\keyword{graphs}

\name{anm.ls.reg}
\alias{anm.ls.reg}
\alias{anm.ls.reg.tck}
\title{
Animated plot of the least squares function.
}
\description{Depicts the process of least squares estimation of simple linear regression parameters by plotting the least squares function with respect to estimate possibilities for the intercept or slope.
}
\usage{

anm.ls.reg(X, Y, parameter="slope", nmax=50, interval = 0.1, col = "red",...)

anm.ls.reg.tck()
}
\arguments{

  \item{X}{
A numeric vector containing explanatory data.
}
  \item{Y}{
A numeric vector containing response data.
}
  \item{parameter}{
Parameter to be estimated.  Either \code{"slope"} or \code{"intercept"}.}
  \item{nmax}{The number of parameter estimates to be depicted.  The true LS estimate will always be in the center of this sequence.}
  \item{interval}{Speed of animation (in frames per second).  A smaller interval decreases speed.  May not work in all systems; see \code{\link{Sys.sleep}}.} 
  \item{col}{Line color.}
  \item{\dots}{
Additional arguments to \code{\link{plot}}
}
}

\value{
An animated plot of the plot possible regression lines is created along with an animated plot of the residual sum of squares. The function \code{anm.ls.reg.tck} provides a GUI to run the function.
}
\author{
Ken Aho
}
\seealso{
\code{\link{loglik.plot}}, \code{\link{anm.ls}}
}
\examples{
\dontrun{
X<-c(11.2,10.8,9.0,12.4,12.1,10.3,10.4,10.6,9.3,11.8)
Y<-log(X)
anm.ls.reg(X, Y, parameter = "slope")}
}
\keyword{graphs}

\name{goats}
\alias{goats}
\docType{data}
\title{Mountain goat data from Yellowstone National Park}
\description{
Mount goat (\emph{Oreomnos americanus}) feces data and soil nutrient data for eight different mountains in the Northern Absarokas in Yellowstone National Park.    
}
\usage{data(goats)}
\format{
  The dataframe has 3 columns:
  \describe{
    \item{\code{feces}}{feces concentration (Percent occurrence per 0.1, m^2 plot).}
    \item{\code{NO3}}{Nitrate concentration in ppm.} 
    \item{\code{organic.matter}}{Organic matter concentration (LOI) as a percentage.} 
        }
}
\source{
Aho, K. (2012)  \emph{Management of introduced mountain goats in Yellowstone National Park (vegetation analysis along a mountain goat gradient).  PMIS:  105289}.  Report prepared for USDA National Park Service. 150 pp.
}
\keyword{datasets}

\name{see.anova.tck}
\alias{see.anova.tck}

\title{
Interactive depiction of the ANOVA mechanism
}
\description{
Slider control of the means and (constant) variability of three factor level populations.  An ANOVA is run based on a random sample of these populations.
}
\usage{

see.anova.tck()
}


\author{
Ken Aho
}
\keyword{graphs}

\name{pairw.kw}
\alias{pairw.kw}
\alias{KW.multi.comp}
\title{Multiple pairwise comparison procedure to accompany a Kruskal-Wallis test}
\description{
Replaces the defunct \code{KW.multi.comp}. As with ANOVA we can examine multiple pairwise comparisons from a Kruskal-Wallis test after we have rejected our omnibus null hypothesis.  
However we will need to account for the fact that these comparisons will be non-orthogonal.  A conservative multiple comparison method used here is based on the Bonferroni inequality.
}
\usage{

pairw.kw(y, x, conf)
}
\arguments{

  \item{y}{The response variable.  A vector of quantitative responses.}
  \item{x}{An explanatory variable.  A vector of factor levels.}
  \item{conf}{The level of desired confidence, 1 - \emph{P}(type I error).}
}

\value{
Returns a list of \code{class = "pairw"}.  The utility print function returns a descriptive head and a six column summary dataframe containing: 

1) the type of contrast (names are taken from levels in \code{x}),

2) the mean rank difference, 

3) the lower confidence bound of the true mean rank difference, 

4) the upper confidence bound of the true mean rank difference, 

5) the hypothesis decision given the prescribed significance level, 

6) the adjusted \emph{P}-value.
}
\seealso{\code{\link{pairw.anova}}, \code{\link{pairw.fried}}, \code{\link{plot.pairw}}}
\references{Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.}
\author{Ken Aho and Richard Boyce.  Richard provided an adjustment for ties.  Thanks to Paule Bodson-Clermont for pointing out issues with the default behaviour of \code{\link{rank}}, leading to incorrect answers from \code{pair.kw} given missing vaues.
}
\examples{
rye.data <- data.frame(rye = c(50, 49.8, 52.3, 44.5, 62.3, 74.8, 72.5, 80.2, 
47.6, 39.5, 47.7,50.7), nutrient = factor(c(rep(1, 4), rep(2, 4), rep(3, 4))))
kw <- with(rye.data, pairw.kw(y = rye, x = nutrient, conf = .95))
kw
plot(kw, loc.meas = median, int = "IQR")
# you can also try: plot(kw, type = 2)
}
\keyword{univar}
\keyword{htest}

\name{see.norm.tck}
\alias{see.normcdf.tck}
\alias{see.beta.tck}
\alias{see.betacdf.tck}
\alias{see.bin.tck}
\alias{see.bincdf.tck}
\alias{see.chi.tck}
\alias{see.chicdf.tck}
\alias{see.disc.unif.tck}
\alias{see.disc.unifcdf.tck}
\alias{see.exp.tck}
\alias{see.expcdf.tck}
\alias{see.F.tck}
\alias{see.Fcdf.tck}
\alias{see.gam.tck}
\alias{see.gamcdf.tck}
\alias{see.geo.tck}
\alias{see.geocdf.tck}
\alias{see.hyper.tck}
\alias{see.hypercdf.tck}
\alias{see.logis.tck}
\alias{see.logiscdf.tck}
\alias{see.lnorm.tck}
\alias{see.lnormcdf.tck}
\alias{see.nbin.tck}
\alias{see.nbincdf.tck}
\alias{see.norm.tck}
\alias{see.pois.tck}
\alias{see.poiscdf.tck}
\alias{see.t.tck}
\alias{see.tcdf.tck}
\alias{see.unif.tck}
\alias{see.unifcdf.tck}
\alias{see.weib.tck}
\alias{see.weibcdf.tck}
\alias{see.pdfdriver.tck}
\alias{see.pdfdriver}
\title{Visualize pdfs}

\description{
Interactive GUIs for visualizing how distributions change with changing values of pdf parameters, e.g. \eqn{\mu} and \eqn{\sigma}.  The basic ideas here are lifted largely from a clever function from Greg Snow's package \pkg{TeachingDemos}. The functions \code{see.pdfdriver.tck} and \code{see.pdfdriver} are \pkg{tcltk} utility functions.
}

\usage{
see.norm.tck()
see.normcdf.tck()
see.beta.tck()
see.betacdf.tck()
see.bin.tck()
see.bincdf.tck()
see.chi.tck()
see.chicdf.tck()
see.disc.unif.tck()
see.disc.unifcdf.tck()
see.exp.tck()
see.expcdf.tck()
see.F.tck()
see.Fcdf.tck()
see.gam.tck()
see.gamcdf.tck()
see.geo.tck()
see.geocdf.tck()
see.hyper.tck()
see.hypercdf.tck()
see.logis.tck()
see.logiscdf.tck()
see.nbin.tck()
see.nbincdf.tck()
see.lnorm.tck()
see.lnormcdf.tck()
see.pois.tck()
see.poiscdf.tck()
see.t.tck()
see.tcdf.tck()
see.unif.tck()
see.unifcdf.tck()
see.weib.tck()
see.weibcdf.tck()
see.pdfdriver.tck()
see.pdfdriver(pdf, show.cdf = TRUE)
}                                               
\arguments{
\item{pdf}{Name of probability density function}
\item{show.cdf}{Logical, indicating whether or not the cumulative distribution function should be shown.}
}
\author{Ken Aho}
\examples{
\dontrun{
see.norm.tck()
}
}
\keyword{graphs}

\name{ci.mu.oneside}
\alias{ci.mu.oneside}
\title{
One sided confidence interval for mu.
}
\description{
In some situations we may wish to quantify confidence in the region above or below a mean estimate. For instance, a biologist working with an endangered species may be interested in saying: "I am 95 percent confident that the true mean number of offspring is above a particular threshold." In a one-sided situation, we essentially let our confidence be 1- 2\eqn{\alpha} (instead of 1 - \eqn{\alpha}).  
Thus, if our significance level for a two-tailed test is \eqn{\alpha}, our one-tailed significance level will be 2\eqn{\alpha}.
}
\usage{
ci.mu.oneside(data, conf = 0.95, n = NULL, Var = NULL, xbar = NULL, 
summarized = FALSE, N = NULL, fpc = FALSE, tail = "upper", na.rm = FALSE)
}
\arguments{

  \item{data}{
A vector of quantitative data.  Required if \code{summarized=TRUE}.}
  \item{conf}{
Level of confidence; 1 - \emph{P}(type I error).
}
  \item{n}{
Sample size.  Required if \code{summarized=TRUE}. 
}
  \item{Var}{
Sample variance.  Required if \code{summarized=TRUE}.
}
  \item{xbar}{
Sample mean.  Required if \code{summarized=TRUE}.
}
  \item{summarized}{
Logical.  Indicates whether summary statistics instead of raw data should be used.
}
  \item{N}{
Population size.  Required if \code{summarized=TRUE}.
}
  \item{fpc}{
Logical.  Indicating whether finite population corrections should be made.
}
  \item{tail}{
Indicates what side the one sided confidence limit should be calculated for.  Choices are \code{"upper"} or \code{"lower"}.
}
\item{na.rm}{Logical, indicate whether \code{NA} values should be stripped before the computation proceeds.}
}
\value{Returns a list of \code{class = "ci"}.  Default output is a matrix with the sample mean and either the upper or lower confidence limit.
}
\references{Bain, L. J., and Engelhardt, M. (1992) \emph{Introduction to Probability and Mathematical 
Statistics}.  Duxbury press, Belmont, CA, USA.
}
\author{
Ken Aho
}
\seealso{
\code{\link{ci.mu.t}}}
\examples{
ci.mu.oneside(rnorm(100))
}
\keyword{univar}
\keyword{htest}% __ONLY ONE__ keyword per line

\name{g.test}
\alias{g.test}

\title{
Likelihood ratio test for tabular data
}
\description{
Provides likelihood ratio tests for one way and multiway tables.
}
\usage{

g.test(y, correct = FALSE, pi.null = NULL)
}

\arguments{

  \item{y}{
A vector of at least 2 elements, or a matrix.  Must contain only non-negative integers.
}
  \item{correct}{
Logical.  Indicating whether Yates correction for continuity should be used.
}
  \item{pi.null}{
Optional vector or matrix of null proportions.  Must sum to one.
}
}
\author{
Ken Aho
}
\examples{
obs <- c(6022, 2001)
g.test(obs, pi.null = c(0.75, 0.25))
}
\keyword{htest}

\name{MC.test}
\Rdversion{1.1}
\alias{MC.test}
\title{
Monte Carlo hypothesis testing for two samples.
}
\description{\code{MC.test} calculates a permutation distribution of test statistics from a Welch\emph{t}-test.  It compares this distribution to an initial test statistic calculated using non-permuted data, to derive an empirical \emph{P}-value.}
\usage{
MC.test(Y,X, perm = 1000, alternative = "not.equal", paired = FALSE, print = TRUE)
}
\arguments{
  \item{Y}{
Response data.
}
  \item{X}{
Categorical explanatory variable.
}
  \item{perm}{
Number of iterations.
}

\item{paired}{Logical: Are sample paired?}

  \item{alternative}{
Alternative hypothesis.  One of three options: \code{"less","greater"}, or \code{"not.equal"}.  These provide lower-tail, upper-tail, and two-tailed tests.
}

\item{print}{Logical: automatically print a pretty summary of results (default).}
}
\details{
The method follows the description of Manly (1998) for a two-sample test.  Upper and lower tailed tests are performed by finding the portion of the distribution greater than or equal to the observed \emph{t} test statistic (upper-tailed) or less than or equal to the observed test statistic (lower-tailed). A two tailed test is performed by multiplying the portion of the null distribution greater than or equal to the absolute value of the observed test statistic and less than or equal to the absolute value of the observed test statistic times minus one.  Results from the test will be similar to \code{oneway_test} from the library \code{coin} because it is based on an equivalent test statistic.  As with \code{t.test}, pairing is assumed to occur within levels of \emph{X}.  That is, the responses \emph{Y = 11} and \emph{Y = 2} occur in the same pair (block) below.

\code{Y <- c(11,12,13,2,3,4)}

\code{X <- c(1,1,1,2,2,2)}


}
\value{
Returns a list with the following items:
\item{observed.test.statistic}{\emph{t}-statistic calculated from non-permuted (original)data.}
\item{no_of_permutations_exceeding_observed_value}{The number of times a Monte Carlo derived test statistic was more extreme than the initial observed test statistic.}
\item{p.value}{Empirical \emph{P}-value}
\item{alternative}{The alternative hypothesis}
}
\references{
Manly, B. F. J. (1997) \emph{Randomization and Monte Carlo Methods in Biology, 2nd edition}.  Chapman and Hall, London.
}
\author{Ken Aho, thanks to Vince Buonaccorsi who found an error under \code{paired = TRUE}.}
\seealso{\code{\link{t.test}}}
\examples{
Y<-c(runif(100,1,3),runif(100,1.2,3.2))
X<-factor(c(rep(1,100),rep(2,100)))
MC.test(Y,X,alternative="less")
}
\keyword{htest}
\keyword{univar}

\name{R.hat}
\alias{R.hat}
\title{
R hat MCMC convergence statistic
}
\description{
The degree of convergence of a random Markov Chain can be estimated using the Gelman-Rubin convergence statistic, \eqn{\hat{R}},
based on the stability of outcomes between and within \emph{m} chains of the same length, \emph{n}.       
Values close to one indicate convergence to the underlying distribution.  Values greater than 1.1 indicate inadequate convergence.
}
\usage{

R.hat(M, burn.in = 0.5)
}
\arguments{
  \item{M}{
An \emph{n} x \emph{m} numeric matrix of Markov Chains. 
}
  \item{burn.in}{
The proportion of each chains to be used as a burn in period.  The default value, 0.5, means that only the latter half of the chains will be used in computing \eqn{\hat{R}}. 
}
}
\details{Gelman et al. (2003, pg. 296) provides insufficient details to reproduce this function.  To get the real function see Gelman and Rubin (1992).  The authors list one other change in their Statlab version of this function.  They recommend multiplying \code{sqrt(postvar/W)} by \code{sqrt((df + 3)/t(df + 1))}. The original code and this function can produce estimates below 1.  
}

\references{
Gelman, A. and D. B. Rubin  (1992) \emph{Inference from iterative simulation using multiple 
sequences (with discussion)}. Statistical Science, 7:457-511.

Gelman, A., Carlin, J. B., Stern, H. S., and D. B. Rubin (2003)  \emph{Bayesian Data Analysis, 2nd edition}.  Chapman and Hall/CRC.
}
\author{
Ken Aho and unknown StatLib author
}
\keyword{graphs}

\name{bv.boxplot}
\alias{bv.boxplot}
\title{Bivariate boxplots}
\description{
Creates diagnostic bivariate quelplot ellipses (bivariate boxplots) using the method of Goldberg and Iglewicz (1992).  
The output can be used to check assumptions of bivariate normality and to identify multivariate outliers.  The default \code{robust=TRUE}
option relies on on a biweight correlation estimator function written by Everitt (2006).  Quelplots, 
are potentially asymmetric, although the method currently employed here uses a 
single "fence" definition and creates symmetric ellipses.  
}
\usage{
bv.boxplot(X, Y, robust = TRUE, D = 7, xlab = "X", ylab="Y", pch = 21, 
pch.out = NULL, bg = "gray", bg.out = NULL, hinge.col = 1, fence.col = 1, 
hinge.lty = 2, fence.lty = 3, xlim = NULL, ylim = NULL, names = 1:length(X), 
ID.out = FALSE, cex.ID.out = 0.7, uni.CI = FALSE, uni.conf = 0.95, 
uni.CI.col = 1, uni.CI.lty = 1, uni.CI.lwd = 2, show.points = TRUE, ...)
}
\arguments{
  \item{X}{First of two quantitative variables making up the bivariate distribution.}
  \item{Y}{Second of two quantitative variables making up the bivariate distribution.}
  \item{robust}{Logical.  Robust estimators, i.e. \code{robust = TRUE} are recommended.}
  \item{D}{The default \code{D = 7} lets the fence be equal to a 99 percent confidence interval for an individual observation.}
  \item{xlab}{Caption for \emph{X} axis.}
  \item{ylab}{Caption for \emph{Y} axis.}
  \item{pch}{Plotting character(s) for scatterplot.}
  \item{pch.out}{Plotting character for outliers.}
  \item{hinge.col}{Hinge color.}
  \item{fence.col}{Fence color.}
  \item{hinge.lty}{Hinge line type.}
  \item{fence.lty}{Fence line type.}
\item{xlim}{A two element vector defining the \emph{X}-limits of the plot.}
  \item{ylim}{The \emph{Y}-limits of the plot.}
  \item{bg}{Background color for points in scatterplot, defaults to black if \code{pch} is not in the range 21:26.}
  \item{bg.out}{Background color for outlying points in scatterplot, defaults to black if \code{pch} is not in the range 21:26.}
  \item{names}{An optional vector of names for \emph{X}, \emph{Y} coordinates.}  
  \item{ID.out}{Logical. Whether or not outlying points should be given labels (from argument \code{name} in plot.}
  \item{cex.ID.out}{Character expansion for outlying ID labels.}
  \item{uni.CI}{Logical. If true, univariate confidence intervals for the true median at confidence \code{uni.CI} are shown.}  
  \item{uni.conf}{Univariate confidence, only used if \code{CI.uni = TRUE}.}
  \item{uni.CI.col}{Univariate confidence bound line color, only used if \code{CI.uni = TRUE}.}
  \item{uni.CI.lty}{Univariate confidence bound line type, only used if \code{CI.uni = TRUE}.}
  \item{uni.CI.lwd}{Univariate confidence bound line width, only used if \code{CI.uni = TRUE}.}
  \item{show.points}{Logical. Whether points should be shown in graph.}
  \item{\dots}{Additional arguments from \code{\link{points}}.}
  }

\details{
Two ellipses are drawn.  The inner is the "hinge" which contains 50 percent of the data.  The outer is the "fence".  
Observations outside of the "fence" constitute possible troublesome outliers.  
The function \code{bivariate} from Everitt (2004) is used to calculate robust biweight measures of correlation, scale, and location if \code{robust = TRUE} (the default). 
We have the following form to the quelplot model:

\deqn{E_i =
\sqrt{\frac{X^2_{si} + Y^2_{si} - 2R^*X_{si}Y_{si}}{1-R^{*2}}}.}

where \eqn{X_{si} = (X_i - T^*_X)/S^*_X}, and \eqn{Y_{si} = (Y_i - T^*_X)/S^*_Y} are standardized values for \eqn{X_i} and \eqn{Y_i}, respectively,
\eqn{T^*_X} and \eqn{T^*_Y} are location estimators for \emph{X} and \emph{Y}, \eqn{S^*_X} and \eqn{S^*_Y} are scale estimators for 
\emph{X} and \emph{Y}, and \eqn{R^*} is a correlation estimator for \emph{X} and \emph{Y}.  We have:

\deqn{E_m = median\{E_i:i=1,2,...,n\},}  
and
\deqn{E_{max} = max\{E_i: E_i^2 < DE^2_m\}.} 
where \eqn{D} is a constant that regulates the distance of the "fence" and "hinge".

To draw the "hinge" we have:

\deqn{R_1 = E_m\sqrt{\frac{1 + R^*}{2}},}
\deqn{R_2 = E_m\sqrt{\frac{1 - R^*}{2}}.}

To draw the "fence" we have:

\deqn{R_1 = E_{max}\sqrt{\frac{1 + R^*}{2}},}
\deqn{R_2 = E_{max}\sqrt{\frac{1 - R^*}{2}}.}

For \eqn{\theta} = 0 to 360, let:

\deqn{\Theta_1 = R_1cos(\theta),}
\deqn{\Theta_2 = R_2sin(\theta).}

The Cartesian coordinates of the "hinge" and "fence" are:

\deqn{X=T^*_X=(\Theta_1+\Theta_2)S^*_X,}
\deqn{Y=T^*_Y=(\Theta_1-\Theta_2)S^*_Y.}

Quelplots, are potentially asymmetric, although the current (and only) method used here defines a single value for \eqn{E_{max}} 
and hence creates symmetric ellipses.  Under this implementation at least one point will define \eqn{E_{max}}, 
and lie on the "fence".        
}
\value{
A diagnostic plot is returned.  Invisible objects from the function include location, scale and correlation estimates for \eqn{X} and \eqn{Y}, 
estimates for \eqn{E_m} and \eqn{E_{max}}, and a list of outliers (that exceed \eqn{E_{max}}).
}
\references{
Everitt, B.  (2006) \emph{An R and S-plus Companion to Multivariate Analysis}.  Springer.

Goldberg, K. M., and B. Ingelwicz  (1992)  Bivariate extensions of the boxplot.  
\emph{Technometrics} 34: 307-320.
}
\author{Ken Aho, the function relies on an Everitt (2006) function for robust \emph{M}-estimation.}
\seealso{\code{\link{boxplot}}}
\examples{
Y1<-rnorm(100, 17, 3)
Y2<-rnorm(100, 13, 2)
bv.boxplot(Y1, Y2)

X <- c(-0.24, 2.53, -0.3, -0.26, 0.021, 0.81, -0.85, -0.95, 1.0, 0.89, 0.59, 
0.61, -1.79, 0.60, -0.05, 0.39, -0.94, -0.89, -0.37, 0.18)
Y <- c(-0.83, -1.44, 0.33, -0.41, -1.0, 0.53, -0.72, 0.33,  0.27, -0.99, 0.15, 
-1.17, -0.61, 0.37, -0.96, 0.21, -1.29, 1.40, -0.21, 0.39)
b <- bv.boxplot(X, Y, ID.out = TRUE, bg.out = "red")
b
}
\keyword{graphs}
\keyword{multivariate}

\name{ES.May}
\alias{ES.May}
\title{May's effective specialization index}
\description{
May and Beverton (1990) created the effective specialization index to quantify the degree of 
specialization of insects with potential host plants.
}
\usage{
ES.May(mat, digs = 3)
}
\arguments{
  \item{mat}{A symmetric matrix with potential specialist hosts in rows and 
  and the number species specializing on each of the host species in columns 
  (see details below).}
  \item{digs}{The number of significant digits in output.}
}
\details{
  The structure of the object \code{mat} is nonintuitive.  In the rows of the matrix are
  species which can be selected by potential specialists (i.e. hosts).  May and Beverton (1990) 
  used four oak species.  The columns indicate the degree of specialization of 
  potential specialists.  May and Beverton (1990) were interested in the specialization 
  of beetles.  The first element (row 1, column 1) in their 4 x 4 matrix contained 
  only beetle species found on host 1.  The second element (row 1, column 2) contained 
  the number of beetle species found on host 1 and one other host. The third element 
  (row 1, column 3) contained the number of beetle species found on host 1 and two 
  other hosts.  The fourth element (row 1, column 4) contained the number of beetle 
  species occurring on all four hosts.     
}
\value{
Output is a list 
  \item{E.S_coefficients}{}
  \item{Nk}{The number of distinct specialists.}
  \item{Pki.matrix}{The proportion of potential specialists on the \emph{k}th host}
  \item{N.matrix}{The raw data.}
  \item{fk.matrix}{}
  \item{fk.vector}{For the \emph{k}th host, the proportion of species which are effectively specialized.}
  \item{Nk.vector}{The number of species which are effectively specialized on the \emph{k}th host.}
}
\references{May, R. M. and Beverton, R. J. H. (1990)  How many species [and discussion].  
\emph{Philosophical Transactions: Biological Sciences}.  330 (1257) 293-304.}
\author{Ken Aho and Jessica Fultz}
\examples{
#data from May and Beverton (1990)
beetle<-matrix(ncol=4,nrow=4,data=c(5,8,7,8,20,10,9,8,14,15,11,8,15,15,12,8), 
byrow=TRUE)
ES.May(beetle)
}

\name{ci.boot}
\alias{ci.boot}
\alias{print.ciboot}

\title{
Bootstrap confidence intervals
}
\description{
Bootstrap confidence intervals for the output of function \code{bootstrap}.  Up to five different interval estimation methods can be called simultaneously: 
the normal approximation, the basic bootstrap, the percentile method, the bias corrected and accelerated method (BCa), and the studentized bootstrap method. 
}
\usage{

ci.boot(x, method = "all", sigma.t = NULL, conf = 0.95)

}

\arguments{

  \item{x}{
For \code{ci.boot} the list output from \code{bootstrap}. 
}
  \item{method}{
CI interval method to be used.  One of \code{"all"}, \code{"norm"}, \code{"basic"}, \code{"perc"}, \code{"BCa"}, or \code{"student"}.  Partial matches are allowed.
}
  \item{sigma.t}{
Vector of standard errors in association with studentized intervals.
}
  \item{conf}{
Confidence level; 1 - \emph{P}(Type I error).
}
}

\references{
Manly, B. F. J.  (1997)  \emph{Randomization and Monte Carlo Methods in Biology, 2nd edition}.  
Chapman and Hall, London.
}
\author{
Ken Aho
}
\seealso{
\code{\link[boot]{boot}}, \code{\link{bootstrap}},
}
\examples{


data(vs)
# A partial set of observations from a single plot for a Scandinavian 
# moss/vascular plant/lichen survey.
site18<-t(vs[1,])

#Shannon-Weiner diversity
SW<-function(data){
d<-data[data!=0]
p<-d/sum(d)
-1*sum(p*log(p))
}

b <- bootstrap(site18[,1],SW)
ci.boot(b)
}
\keyword{manip}

\name{webs}
\alias{webs}
\docType{data}
\title{Spider web length data}
\description{
Gosline et al. (1984) applied heat to strands of spider web to determine whether the structure underlying webs was rubber-like. Data are estimated from a scatterplot in Gosline et al.. 
}
\usage{data(webs)}
\format{
The dataframe contains 4 columns
\describe{
\item{obs}{Observation number.}   
\item{relative length}{Relative strand strand length after heat application.}         
\item{temp.C}{Temp in degrees Celsius.}        
\item{residuals}{Residuals from the linear model length~temp.C.}
  }
}
\source{Gosline, J. M., Denny, M. W. and Demont, M. E. (1984). Spider silk as rubber.
\emph{Nature} 309, 551-552.}
\keyword{datasets}

\name{drugs}
\alias{drugs}
\docType{data}
\title{
Contingency data for high school marijuana, alcohol, and cigarette use
}
\description{
Agresti (2012) included a three way contingency table describing cigarette, alcohol, and marijuana use of high school students in Dayton Ohio.
}
\usage{data(drugs)}
\format{
  A data frame with 8 observations on the following 4 variables.
  \describe{
    \item{\code{alc}}{Alcohol use. A factor with levels \code{N} \code{Y}.}
    \item{\code{cig}}{Cigarette use.  A factor with levels \code{N} \code{Y}.}
    \item{\code{mari}}{Marijuana use. A factor with levels \code{N} \code{Y}}
    \item{\code{count}}{Counts for the cross-classification.}
  }
}

\source{
Agresti, A.  2012.  \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley. 
}
\keyword{datasets}

\name{pairw.fried}
\alias{pairw.fried}
\alias{FR.multi.comp}
\title{Multiple pairwise comparison procedure to accompany a Friedman test.}
\description{Replaces now defunct \code{FR.multi.comp}.  As with ANOVA we can examine multiple pairwise comparisons from a Friedman test after we have rejected the overall null hypothesis.  
However we will need to account for family-wise type I error in these comparisons which will be non-orthogonal.  A conservative multiple comparison method used here is based on the Bonferroni procedure.
}
\usage{

pairw.fried(y, x, blocks, nblocks, conf = 0.95)
}
\arguments{

  \item{y}{A vector of responses, i.e. quantitative data.}
  \item{x}{A categorical vector of factor levels.}
  \item{blocks}{A categorical vector of blocks.}
  \item{nblocks}{The number of blocks.}
  \item{conf}{The level of confidence.  1 - \emph{P}(type I error).}
}

\value{
Returns a list of \code{class = "pairw"}.  The utility print function returns a descriptive head and a six column summary dataframe containing: 

1) the type of contrast (names are taken from levels in \code{x}),

2) the mean rank difference,
 
3) the lower confidence bound of the true mean rank difference,
 
4) the upper confidence bound of the true mean rank difference, 

5) the hypothesis decision given the prescribed significance level, and

6) the adjusted \emph{P}-value.
}
\references{
Fox, J. R., and Randall, J. E. (1970)  Relationship between forearm tremor and the biceps electromyogram.  \emph{Journal of Applied Physiology}  29: 103-108.

Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.}
\author{Ken Aho}
\seealso{\code{\link{friedman.test}}, \code{\link{plot.pairw}}}
\examples{
#Data from Fox and Randall (1970)
tremors <- data.frame(freq = c(2.58, 2.63, 2.62, 2.85, 3.01, 2.7, 2.83, 3.15, 
3.43, 3.47, 2.78, 2.71, 3.02, 3.14, 3.35, 2.36, 2.49, 2.58, 2.86, 3.1, 2.67, 
2.96, 3.08, 3.32, 3.41, 2.43, 2.5, 2.85, 3.06, 3.07), weights = 
factor(rep(c(7.5, 5, 2.5, 1.25, 0), 6)), block = factor(rep (1 : 6, each = 5)))

fr <- with(tremors, pairw.fried(y = freq, x = weights, blocks = block, nblocks = 6, conf = .95))
fr
plot(fr, loc.meas = median, int = "IQR")
# you can also try: plot(fr, type = 2, las = 2)
}
\keyword{htest}
\keyword{univar}

\name{portneuf}
\alias{portneuf}
\docType{data}
\title{
Portneuf River longitudinal N and P data
}
\description{
Portneuf River data from the Siphon Road site near Pocatello Idaho, downstream from an elemental P refinery.
}
\usage{data(portneuf)}
\format{
  A data frame with 176 observations on the following 3 variables.
  \describe{
    \item{\code{date}}{Dates from 1998-01-15 to 2011-08-16}
    \item{\code{TKN}}{Total Kjeldahl nitrogen (measured as a percentage)}
    \item{\code{total.P}}{Total phosphorous (mg/L)}
  }
}
\source{
Idaho State Department of Environmental Quality
}
\keyword{datasets}

\name{bear}
\alias{bear}
\docType{data}
\title{Grizzly bear litter sizes

}
\description{
Counts of grizzly bear (\emph{Ursus arctos}) litter sizes from the Greater Yellowstone Ecosystem from 1973-2010.  
}
\usage{data(bear)}
\format{
  A data frame with 38 observations on the following 5 variables.
  \describe{
    \item{\code{Year}}{Year.}
    \item{\code{X1.cub}}{The number of litters with one cub.}
    \item{\code{X2.cub}}{The number of litters with two cubs.}
    \item{\code{X3.cub}}{The number of litters with three cubs.}
    \item{\code{X4.cub}}{The number of litters with four cubs.}
  }
}

\source{
Haroldson, M. A (2010)  Assessing trend and estimating population size from counts of 
	unduplicated females. Pgs 10-15 in Schwartz, C. C., Haroldson, M. A., and K. West editors.  
  \emph{Yellowstone grizzly bear investigations: annual report of the Interagency grizzly bear study team, 2010}.  U. S. Geological Survey, Bozeman, MT. 

}
\keyword{datasets}

\name{anolis}
\alias{anolis}
\docType{data}
\title{
Anolis lizard contingency table data
}
\description{
Schoener (1968) examined the resource partitioning of anolis lizards on the Caribbean island of South Bimini.  
He cross-classified lizard counts in habitats (branches in trees) with respect to three variables: 
lizard species \emph{A. sargei} and \emph{A. distichus}, branch height (high and low), and branch size (small and large).
}
\usage{data(anolis)}
\format{
  A data frame with 8 observations on the following 4 variables.
  \describe{
    \item{\code{height}}{Brach height.  A factor with levels \code{H}, \code{L}.}
    \item{\code{size}}{Brach size.  A factor with levels \code{L}, \code{S}.}
    \item{\code{species}}{Anolis species. A factor with levels \code{distichus}, \code{sagrei}.}
    \item{\code{count}}{Count at the cross classification.}
  }
}

\source{
Schoener, T. W.  (1968)  The Anolis lizards of Bimini: resource partitioning in a complex fauna.  
\emph{Ecology} 49(4): 704-726.
}

\keyword{datasets}

\name{see.accPrec.tck}
\alias{see.accPrec.tck}

\title{
Interactive depiction of precision and accuracy
}
\description{
Slider GUI for examining the interaction of precision and accuracy.
}
\usage{

see.accPrec.tck()
}

\author{
Ken Aho
}
\keyword{graphs}

\name{r.dist}
\alias{r.dist}
\alias{see.r.dist.tck}

\title{
Visualize the sampling distribution of Pearson's product moment correlation
}
\description{
Stumbling points for many methods of inference for the true correlation \eqn{\rho} and for independence are: 1) asymmetry, 2) explicit bounds on \eqn{\rho},  and 3) dependence on sample size, of the sampling distribution of \emph{r}.

The functions here allow visualization of these characteristics.  The algorithm used for the sampling distribution of \emph{r} is based on the first two steps in an asymptotic series (see Kenney and Keeping 1951).
}
\usage{
r.dist(rho, r, n)
see.r.dist.tck()
}
\arguments{
  \item{rho}{
Population correlation
}
  \item{r}{
A numeric vector containing possible estimates of \eqn{rho}.
}
  \item{n}{
Sample size, an integer.
}

}
\details{
All distributions are standardized to have an area of one.
}
\references{
Kenney, J. F. and E. S. Keeping (1951) \emph{Mathematics of Statistics, Pt. 2, 2nd ed}. Van Nostrand, Princeton, NJ.

Weisstein, E. W. (2012) Correlation Coefficient--Bivariate Normal Distribution. From MathWorld--A Wolfram Web Resource. \url{https://mathworld.wolfram.com/CorrelationCoefficientBivariateNormalDistribution.html}
}
\author{
Ken Aho
}
\seealso{
\code{\link{cor}}
}
\examples{
# dev.new(height=3.5)
op <- par(mfrow=c(1,2),mar=c (0,0,1.5,3), oma = c(5, 4.2, 0, 0))
vals <- r.dist(0.9, seq(-1, 1, .001), 5)
plot(seq(-1, 1, .001), vals, type = "l",ylab = "", xlab = "")
vals <- r.dist(0.5, seq(-1, 1, .001), 5)
lines(seq(-1, 1, .001), vals, lty = 2)
vals <- r.dist(0.0, seq(-1, 1, .001), 5)
lines(seq(-1, 1, .001), vals, lty = 3)
legend("topleft", lty = c(1, 2, 3), title = expression(paste(italic(n)," = 5")),
legend = c(expression(paste(rho, " = 0.9")),expression(paste(rho, " = 0.5")),
expression(paste(rho, " = 0"))),bty = "n")

vals <- r.dist(0.9, seq(-1, 1, .001), 30)
plot(seq(-1, 1, .001), vals, type = "l",xlab= "", ylab= "")
vals <- r.dist(0.5, seq(-1, 1, .001), 30)
lines(seq(-1, 1, .001), vals, lty = 2)
vals <- r.dist(0.0, seq(-1, 1, .001), 30)
lines(seq(-1, 1, .001), vals, lty = 3)
legend("topleft", lty = c(1, 2, 3), title = expression(paste(italic(n)," = 30")),
legend = c(expression(paste(rho, " = 0.9")),expression(paste(rho, " = 0.5")),
expression(paste(rho, " = 0"))), bty = "n")
mtext(side = 2, expression(paste(italic(f),"(",italic(r),")")), outer = TRUE, line = 3)
mtext(side = 1, expression(italic(r)), outer = TRUE, line = 3, at = .45)
par(op)
}

\keyword{graphs}

\name{so2.us.cities}
\alias{so2.us.cities}
\docType{data}
\title{SO2 data for 32 US cities with respect to 6 explanatory variables}
\description{Of concern for public health officials and biologists are models of air 
pollution as a function of environmental characteristics.  Using a meta-analysis of 
government publications Sokal and Rolf (1995) compiled an interesting dataset which 
investigates air pollution (measured as annual mean SO\eqn{_2} concentration per m\eqn{^3}) 
as a function of six environmental variables for 32 cities in the United States.  
Whenever the data were available they are based on averages of three years 1969, 1970, 
and 1971.   
}
\usage{data(so2.us.cities)}
\format{
The dataset contains 8 variables:
  \describe{
\item{\code{City}}{US city.}
\item{\code{Y}}{Average annual SO\eqn{_2} concentration per m\eqn{^3}.}   
\item{\code{X1}}{Average annual temperature (degrees Celsius).}
\item{\code{X2}}{Number of industrial companies with more than 20 employees.}
\item{\code{X3}}{Population size (1970 census) in thousands.}
\item{\code{X4}}{Average Annual average wind speed.}
\item{\code{X5}}{Average Annual precipitation (cm).}
\item{\code{X6}}{Average number of days with precipitation.}
  }
}
\source{
Sokal, R. R., and F. J. Rohlf (2012) \emph{Biometry, 4th ed}.  Freeman.
}
\keyword{datasets}

\name{facebook}
\alias{facebook}
\docType{data}
\title{
Facebook performance metrics for data mining and machine learning
}
\description{
These data concern posts published during the year 2014 on the Facebook page of a popular cosmetics brand.
   The data here are 500 of the 790 rows and part of the features analyzed by Moro et al. (2016). The remaining data points were 
   omitted due to confidentiality issues.
}
\usage{data(facebook)}
\format{
  A data frame with 500 observations on the following 19 variables.
  \describe{
    \item{\code{X1}}{Total number of likes of the page containing a post.}
    \item{\code{X2}}{Type of content; a factor with levels \code{Link}, \code{Photo}, \code{Status}, and \code{Video}.}

    \item{\code{X3}}{Manual content category; a factor with levels: \code{action} (special offers and contests), \code{product} (direct advertisement, explicit brand content), and \code{inspiration} (non-explicit brand related content).}
    \item{\code{X4}}{Month the post was posted.}
    \item{\code{X5}}{Weekday the post was published.}
    \item{\code{X6}}{Hour the post was posted}
    \item{\code{X7}}{An binary variable indicating if the company paid to Facebook for advertising.}
    \item{\code{Y1}}{Lifetime post total reach: the number of people who saw a page post.}
    \item{\code{Y2}}{Lifetime number of total impressions: the number of times a post from a page is displayed, whether the post is clicked or not.}
    \item{\code{Y3}}{Lifetime engaged users: the total number of people who clicked anywhere in a post (unique users).}
    \item{\code{Y4}}{Lifetime number of post consumers: the number of people who clicked anywhere in a post after purchasing something on the page.}
    \item{\code{Y5}}{Lifetime number of post consumptions: the number of clicks anywhere in a post by people after purchasing something on the page.}
    \item{\code{Y6}}{Lifetime number of post impressions by people who have liked the page.}
    \item{\code{Y7}}{Lifetime post reach by people who like the page.}
    \item{\code{Y8}}{Lifetime number of people who have liked the page and engaged with the post.}
    \item{\code{Y9}}{Number of "comments"" on the post.}
    \item{\code{Y10}}{Number of "likes" on the post.}
    \item{\code{Y11}}{Number of times the post was "shared.""}
    \item{\code{Y12}}{Total interactions: the sum of "likes," "comments," and "shares" of the post.}
  }
}

\references{
%%  ~~ possibly secondary sources and usages ~~
   This dataset is publicly available for research. The details are described in (Moro et al., 2016).  Please include this citation if you plan to use this data: 

   S. Moro, P. Rita, Vala, B. (2016) Predicting social media performance metrics and evaluation of the impact on brand building: A data mining approach. Journal of Business Research 69(9): 3341-3351. 
 
}

\keyword{datasets}

\name{see.mnom.tck}
\alias{see.mnom.tck}

\title{
Interactive depiction of the multinomial distribution
}
\description{
tcltk GUI representation of the multinomial in a simple (binomial) context. 
}
\usage{
see.mnom.tck()
}

\author{
Ken Aho
}
\keyword{graphs}

\name{anm.coin}
\alias{anm.coin}
\alias{anm.coin.tck}
\title{
Animated demonstration of frequentist binomial convergence of probability using a coin flip.
}
\description{
Creates an animated plot showing the results from coin flips, and the resulting convergence in \emph{P}(Head) as the number of flips grows large.
}
\usage{
anm.coin(flips = 1000, p.head = 0.5, interval = 0.01, show.coin = TRUE, ...)
anm.coin.tck()
}

\arguments{
  \item{flips}{The number of desired coin flips.}
  \item{p.head}{User defined probability of a head; e.g., for a fair coin \code{p.head = 0.5}.}
  \item{interval}{The time between animation frames, in seconds.}
  \item{show.coin}{Logical if \code{show.coin=TRUE} shows a second plot with coin flip results (head or tail).}
  \item{\dots}{Additional arguments to \code{\link{plot}}.}
}
\value{
If \code{show.coin=TRUE}, returns two plots configured as a single graphical object.  The first plot shows convergence in estimated \emph{P}(Head), i.e., number of heads/number of trials, as the number of trials grows large.  The second plot shows individual outcomes of coin flips.  The second (smaller) plot is not returned if \code{show.coin=TRUE} is specified. The function \code{anm.coin()} can be run with the \pkg{tcltk} GUI function, \code{anm.coin.tck()}.
}
\author{Ken Aho
}
\seealso{\code{\link{rbinom}}
}
\examples{
\dontrun{anm.coin()}
}
\keyword{graphs}

\name{case1202}
\alias{case1202}
\docType{data}
\title{
Dataset of salary attributes for male and female workers from Ramsey and Schafer (1997)
}
\description{
Ramsey and Schafer (1997) used this dataset to illustrate considerations in model selection. The data describe attributes of 61 female and 32 male clerical employees hired between 1965 and 1975 by a bank sued for sexual harassment. 
}
\usage{data("case1202")}
\format{
  A data frame with 93 observations on the following 7 variables.
  \describe{
    \item{\code{Yhire}}{Annual salary upon hire (US dollars).}
    \item{\code{Y77}}{Annual salary in 1977 (US dollars).}
    \item{\code{Xsex}}{Sex; a factor with the levels \code{FEMALE} and \code{MALE}.}
    \item{\code{Xsen}}{Seniority (months since first hired).}
    \item{\code{Xage}}{Age (in months).}
    \item{\code{Xed}}{Education (in years).}
    \item{\code{Xexp}}{Experience previous to being hired by the bank (in months).}
  }
}

\source{
Ramsey, F., and Schafer, D. (1997). \emph{The statistical sleuth: a course in methods of data analysis}. Cengage Learning.
}
\examples{
data(case1202)
}
\keyword{datasets}

\name{paik}
\alias{paik}

\title{
Paik diagrams
}
\description{
Paik diagrams for the representation of Simpsons Paradox in three way tables.
}
\usage{

paik(formula, counts, resp.lvl = 2, data, circle.mult = 0.4, xlab = NULL, 
ylab = NULL, leg.title = NULL, leg.loc = NULL, show.mname = FALSE,...)
}

\arguments{

  \item{formula}{
A two sided formula, e.g. \code{Y ~ X1 + X2}, with cross-classified categorical variables. The second explanatory variable, i.e. \code{X2}, 
is used as the trace variable whose levels are distinguished in the graph with different colors.  Interactions and nested terms are not allowed. 
}
  \item{counts}{
A vector of counts for the associated categorical variables in \code{formula}. 
}
  \item{resp.lvl}{
The level in \emph{Y} of primary interest.  See example below.
}
  \item{data}{
Dataframe containing variables in \code{formula}.
}
  \item{circle.mult}{
Multiplier for circle radii in the diagram.
}
  \item{xlab}{
\emph{X}-axis label.  By default this is defined as the categories in the first explanatory variable, \code{X1}.
}
  \item{ylab}{
\emph{Y}-axis label.  By default these will be proportions with respect to the specified level of interest in the response. 
}
  \item{leg.title}{
Legend title.  By default the conditioning variable name.
}
  \item{leg.loc}{
Legend location.  A \code{legend} location keyword; \code{"bottomright"}, \code{"bottom"}, \code{"bottomleft"}, \code{"left"}, \code{"topleft"}, \code{"top"}, \code{"topright"}, \code{"right"} or \code{"center"}. 
}
  \item{show.mname}{ Logical, indicating whether or not the words "Marginal prop" should printed in the graph above the dotted line indicating marginal proportions. 
}
  \item{\dots}{
Additional arguments from \code{\link{plot}}.
}
}
\references{
Agresti, A. (2012) \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley. 

Paik M. (1985) A graphical representation of a three-way contingency table: Simpson's paradox and correlation.
\emph{American Statistician} 39:53-54.
}
\author{
Ken Aho
}
\examples{
require(tcltk)

data(death.penalty)# from Agresti 2012 

op <- par(mfrow=c(1,2), mar=c(4,4,0,0))
paik(verdict ~ d.race + v.race, counts = count, data = death.penalty, 
leg.title = "Victims race", xlab = "Defendants race", 
ylab = "Proportion receiving death penalty")
par(mar=c(4,2,0,2))
paik(verdict ~ v.race + d.race, counts = count, data = death.penalty, 
xlab = "Victims race", leg.title = "Defendants race",leg.loc="topleft", 
ylab = "", yaxt = "n")
par(op)

if(interactive()){
if(any(names(sessionInfo()$otherPkgs)=="asbio")) vignette(package = "asbio", "simpson")
}
}
\keyword{graphs}

\name{dO2}
\alias{dO2}
\docType{data}
\title{
Dissolved levels in locations above and below a town 
}
\description{
Dissolved O\eqn{_2} readings in ppm for 15 random locations above and below a riverside community. 
}
\usage{data(dO2)}
\format{
  A data frame with 30 observations on the following 2 variables.
  \describe{
    \item{\code{O2}}{Dissolved O\eqn{_2} levels in ppm.}
    \item{\code{location}}{River flow location with respect to town.  Levels are \code{Above} \code{Below}.}
  }
}

\source{
Ott, R. L., and M. T. Longnecker  (2004)  \emph{A First Course in Statistical Methods}.  Thompson. 
}
\keyword{datasets}

\name{chronic}
\alias{chronic}
\docType{data}
\title{Chronic ailment counts for urban and rural women in Australia 

}
\description{
Brown et al (1996) showed that Australian women who live in rural areas tended to have fewer visits with general practitioners.  
It was not clear from this data, however, whether this was because they were healthier or because of other factors 
(e.g. shortage of doctors, higher costs of visits, longer distances to travel for visits, etc.). 
To address this Dobson issue (2001) compiled data describing the number of chronic medical conditions 
for women visiting general practitioners in New South Wales.  Women were divided into two groups; those from rural areas, 
and those from urban areas.  All of the women were age 70-75, had the same socioeconomic status and reported to general practitioners three or fewer times in 1996.  
The question of central interest was: "do women who have the same level of general practitioner visits have the same medical need?"  
}

\usage{data(chronic)}
\format{
  A data frame with 49 observations on the following 4 variables.
  \describe{
    \item{\code{subject}}{The subject number.}
    \item{\code{count}}{The number of chronic conditions in a subject.}
    \item{\code{setting}}{a factor with levels \code{RURAL} \code{URBAN}.}
  }
}

\source{
Dobson, A. J. 2001. \emph{An Introduction to Generalized Linear Models, 2nd edition}. Chapman and Hall, London. 


}
\references{
Brown, W. J.  Bryon, L., Byles, J., et al.  (1996)  Women's health in Australia: establishment of the Australian longitudinal study on women's health.  \emph{Journal of Women's Health}.  5: 467-472.
}
\keyword{datasets}

\name{see.HW}
\alias{see.HW}
\alias{see.HW.tck}

\title{
Visualize the Hardy Weinberg equilibrium
}
\description{
Allows interactive depiction of the Hardy Weinberg equilibrium.
}
\usage{
see.HW(parg)
see.HW.tck()
}

\arguments{

  \item{parg}{Proportion of the allele \emph{p} in the population, i.e. a number between 0 and 1.

}

}
\details{
Solves and depicts the Hardy Weinberg equilibrium, i.e:
\deqn{pp + 2pq + qq = 1}
}
\author{Ken Aho
}
\keyword{graphs}

\name{ci.sigma}
\alias{ci.sigma}
\title{
Confidence interval for sigma squared.
}
\description{
The function calculates confidence intervals for \eqn{\sigma^2}.  We assume that the parent population is normal.}
\usage{
ci.sigma(data, conf = 0.95, S.sq = NULL, n = NULL, summarized = FALSE)
}
\arguments{
  \item{data}{A vector of quantitative data.  Required if \code{summarized=FALSE}.}
  \item{conf}{Level of confidence.  1 - \emph{P}(type I error).}
  \item{S.sq}{Sample variance, required if \code{summarized=TRUE}.}
  \item{n}{Sample size, required if \code{summarized=TRUE}.}
  \item{summarized}{Logical.  If \code{summarized=TRUE} then the user must supply \code{S.sq} and \code{n}
}
}
\value{Returns a list of \code{class = "ci"}.  Default printed results are the point estimate and confidence bounds.  Other objects are \code{invisible}.}
\references{Bain, L. J., and M. Engelhardt.  1992.  \emph{Introduction to Probability and Mathematical 
Statistics}.  Duxbury press.  Belmont, CA, USA.

}
\author{Ken Aho
}
\seealso{\code{\link{ci.mu.z}}}

\examples{
ci.sigma(rnorm(20))
}
\keyword{univar}
\keyword{htest}

\name{transM}
\alias{transM}
\alias{anm.transM}
\alias{anm.TM.tck}
\title{Transition matrix analysis}
\description{
Creates a plot showing expected numbers of individuals in specified age classes or life stages given survivorship probabilities from a transition matrix (cf. Caswell 2000).  The function \code{anm.transM} provides an animated view of the population growth curves.  The function \code{anm.TM.tck} provides a \pkg{tcltk} GUI to run \code{anm.TM.tck}. 
}
\usage{
transM(A, init, inter = 100, stage.names = c("All grps",1:(ncol(A))), 
leg.room = 1.5, ...)

anm.transM(A,init,inter=100,stage.names =c("All grps",1:(ncol(A))),
leg.room = 1.5, anim.interval=0.1,...)

anm.TM.tck()
}
\arguments{
  \item{A}{Transition matrix containing survivorship probabilities and fecundities see Caswell (2000).
}
  \item{init}{
A numeric vector containing initial numbers in each age class of interest. 
}
  \item{inter}{
Number of time intervals for which population numbers are to be calculated.  
}
  \item{stage.names}{
A character vector giving life stage names.
}
  \item{leg.room}{
A \emph{Y}-axis multiplier intended to create room for a legend.
}
  \item{anim.interval}{
Speed of animation in frames per second.
}
  \item{\dots}{
Additional arguments for \code{\link{plot}}
}
}

\value{
Returns a plot and proportions of the population in each age class for the number of time intervals in \code{inter}.
}
\references{
Caswell, H  (2000) \emph{Matrix Population Models: Construction, Analysis and Interpretation, 2nd Edition}. Sinauer Associates, Sunderland, Massachusetts.

Gurevitch, J., Scheiner, S. M., and G. A. Fox (2006)  \emph{The Ecology of Plants}.  Sinauer.
}
\author{
Ken Aho
}
\examples{
#Endangered cactus data data from Gurevitch et al. (2006)
A<-matrix(nrow=3,ncol=3,data=c(.672,0,.561,0.018,0.849,0,0,0.138,0.969),
byrow=TRUE)
init<-c(10,2,1)
transM(A,init,inter=100,stage.names=c("All","Sm. Juv.","Lg. Juv.","Adults"),
xlab="Years from present",ylab="n")
#animated version
\dontrun{
anm.transM(A,init,inter=100,stage.names=c("All","Sm. Juv.","Lg. Juv.","Adults"),
xlab="Years from present",ylab="n")
}
}
\keyword{graphs}

\name{asthma}
\alias{asthma}
\docType{data}
\title{Asthma repeated measures dataset from Littell et al. (2002)}
\description{
This dataset was used by Littell (2002) to demonstrate repeated measures analyses.  The effect of two asthma drugs and a placebo were measured on 24 asthmatic patients.  Each patient was randomly given each drug using an approach to minimize carry-over effects. Forced expiratory volume (FEV1), the volume of air that can be expired after taking a deep breath in one second, was measured.  FEV1 was measured hourly for eight hours following application of the drug.  A baseline measure of FEV1 was also taken 11 hours before application of the treatment.  
}
\usage{data(asthma)}
\format{
  The dataframe has 11 columns:
  \describe{
    \item{\code{PATIENT}}{The subjects (there were 24 patients).}
    \item{\code{BASEFEV1}}{A numerical variable; the baseline forced expiratory volume.} 
    \item{\code{FEV11H}}{Forced expiratory volume at 11 hours.}
    \item{\code{FEV12H}}{Forced expiratory volume at 12 hours.}
    \item{\code{FEV13H}}{Forced expiratory volume at 13 hours.}
    \item{\code{FEV14H}}{Forced expiratory volume at 14 hours.}
    \item{\code{FEV15H}}{Forced expiratory volume at 15 hours.}
    \item{\code{FEV16H}}{Forced expiratory volume at 16 hours.}
    \item{\code{FEV17H}}{Forced expiratory volume at 17 hours.}
    \item{\code{FEV18H}}{Forced expiratory volume at 18 hours.}
    \item{\code{DRUG}}{A factor with three levels \code{"a"} = a standard drug treatment, \code{"c"} = the drug under development, and \code{"p"} = a placebo.}   	
    }
}
\source{
Littell, R. C., Stroup, W. W., and R. J. Freund (2002)  \emph{SAS for Linear Models}.  John 
Wiley and Associates.
}
\keyword{datasets}

\name{power.z.test}
\alias{power.z.test}
\title{Power analysis for a one sample z-test}
\description{
A power analysis for a one sample \emph{z}-test. The function requires \eqn{\alpha}, \eqn{\sigma}, 
the effect size, the type of test (one tailed or two-tailed), and either power 
(1 - \eqn{\beta}) or \emph{n} (sample size).  If \emph{n} is provided, then power is calculated.  Conversely, 
if one provides power, but not \emph{n}, then the required \emph{n} is calculated.
}
\usage{

power.z.test(sigma = 1, n = NULL, power = NULL, alpha = 0.05, effect = NULL, 
test = c("two.tail", "one.tail"), strict = FALSE)
}
\arguments{
  \item{sigma}{The population standard deviation.}
  \item{n}{The sample size.  Not required if \code{power} is specified.}
  \item{power}{The desired power.  Not required if \code{n} is specified.}
  \item{alpha}{Probability of type I error.}
  \item{effect}{Effect size.}
  \item{test}{One of two choices: \code{"two.tail"} or \code{"one.tail"}.}
  \item{strict}{Causes the function to use a strict interpretation of power in a two-sided test.  
  If \code{strict = TRUE} then power for a two sided test will include the probability of rejection 
  in the opposite tail of the true effect. If \code{strict = FALSE} (the default) power will be half the value of \eqn{\alpha} if the true effect size is zero.}
}
\value{
  Returns a list
  \item{sigma}{The prescribed population variance.}
  \item{n}{The sample size.}
  \item{power}{The power.}
  \item{alpha}{The type I error probability.}
  \item{test}{The type of test prescribed.}
  \item{effect}{The effect size.}
}
\references{Bain, L. J., and M. Engelhardt (1992)  \emph{Introduction to Probability and Mathematical 
Statistics}.  Duxbury press.  Belmont, CA, USA.
}
\author{Ken Aho}
\seealso{\code{\link{pnorm}}}
\examples{
power.z.test(sigma=6,effect=5,power=.9,test="one.tail")
}

\name{agrostis}
\alias{agrostis}
\docType{data}
\title{
Agrostis variabilis cover measurements
}
\description{
Percent cover of the grass \emph{Agrostis variablis} at 25 alpine snowbank sites in the Absaroka-Beartooth Mountains.
}

\usage{data(agrostis)}
\format{
  A data frame with 25 observations on the following 2 variables.
  \describe{
    \item{site}{Site number}
    \item{cover}{Percent cover}
  }
}
\source{
Aho, K.  (2006)  \emph{Alpine and Cliff Ecosystems in the North-Central Rocky Mountains}.  PhD dissertation, Montana State University, Bozeman, MT.
}
\keyword{datasets}

\name{pika}
\alias{pika}
\docType{data}
\title{
Nitrogen content of soils under pika haypiles
}
\description{
Aho (1998) hypothesized that pikas worked as ecosystem engineers by building relatively rich soils (via decomposing haypiles and fecal accumulations) in otherwise barren scree.  
Soils from twenty one paired on-haypile and off-haypile sites were gathered from Rendezvous Peak Grand Teton National Park to determine if the habitats differed in total soil nitrogen.
}
\usage{data(pika)}
\format{
  A data frame with 22 observations on the following 2 variables.
  \describe{
    \item{\code{Haypile}}{a numeric vector}
    \item{\code{On.Off..N}}{a numeric vector}
  }
}
\references{
Aho, K., Huntly N., Moen J., and T. Oksanen (1998) Pikas (\emph{Ochotona princeps}: Lagomorpha) as allogenic engineers in an alpine ecosystem. \emph{Oecologia}.  114 (3): 405-409. 
}

\keyword{datasets}

\name{r.pb}
\alias{r.pb}
\title{Percentage bend correlation}
\description{
The percentage bend correlation is a robust alternative to Pearson's product moment correlation.
}
\usage{
r.pb(X, Y, beta = 0.2)
}
\arguments{
  \item{X}{A quantitative vector}
  \item{Y}{A second quantitative vector}
  \item{beta}{Bend criterion}
}
\details{The percentage bend correlation belongs to class of correlation measures which protect against marginal distribution (\emph{X} and \emph{Y}) outliers.  In this way it is similar to Kendall's \eqn{\tau}, Spearman's \eqn{\rho}, and biweight midcovariance.  A second class of robust correlation measures which take in to consideration the overall structure of the data (\emph{O} estimators) are discussed by Wilcox (2005, pg. 389).  A value for the bend criterion \code{beta} is required in the \code{R.pb} function; \code{beta} = 0.2 is recommended by Wilcox (2005).

}
\value{A dataframe with the correlation, test statistic and \emph{P}-value for the null hypothesis of independence are returned.

}
\references{Wilcox, R. R.  (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\seealso{\code{\link{cor}}, \code{\link{r.bw}}}
\examples{
x<-rnorm(100)
y<-rnorm(100)
r.pb(x,y)
}
\keyword{univar}
\keyword{htest}

\name{trim.test}
\alias{trim.test}
\title{Robust one way trimmed means test.}
\description{A robust heteroscedastic  procedure using trimmed means.
}
\usage{
trim.test(Y, X, tr = 0.2)
}
\arguments{
  \item{Y}{A vector of responses.  A quantitative vector}
  \item{X}{A vector of factor levels.}
  \item{tr}{The degree of trimming.  A value from 0-0.5.}
}
\details{The method utilized here is based on the simple idea of replacing means with trimmed means and standard error estimates, based on all the data, with the standard error of the trimmed mean (Wilcox 2005).  The method has the additional benefit of being resistant to heteroscedasticity due to the use of the Welch method for calculating degrees of freedom.  With no trimming the degrees of freedom reduce to those of the one way Welch procedure in \code{\link{oneway.test}}.
}
\value{Returns a dataframe with numerator and denominator degrees of freedom, a test statistic, and a \emph{p}-value based on the \emph{F}-distribution.
}
\references{
Wilcox, R. R.  (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\note{code based on Wilcox (2005) 
}
\seealso{\code{\link{oneway.test}}}
\examples{
rye<-c(50,49.8,52.3,44.5,62.3,74.8,72.5,80.2,47.6,39.5,47.7,50.7)
nutrient<-factor(c(rep(1,4),rep(2,4),rep(3,4)))
trim.test(rye,nutrient,tr=.2)
}
\keyword{htest}
\keyword{univar}

\name{wine}
\alias{wine}
\docType{data}
\title{
White wine quality data for data mining
}
\description{
%%  ~~ A concise (1-5 lines) description of the dataset. ~~
These data concern white variants of the Portuguese "Vinho Verde" wine.
Quality is an ordinal variable based on the median assessment of 
of at least 3 wine experts. Each expert graded wine quality between 0 (very bad) and 10 (excellent).
}
\usage{data("wine")}
\format{
  A data frame with 4898 observations on the following 12 variables.
  \describe{
    \item{\code{Y}}{Wine quality.}
    \item{\code{X1}}{Volatile acidity.}
    \item{\code{X2}}{Citric acid content.}
    \item{\code{X3}}{Residual Sugar content.}
    \item{\code{X4}}{Chloride content.}
    \item{\code{X5}}{Free sulfur dioxide content.}
    \item{\code{X6}}{Total sulfur dioxide content.}
    \item{\code{X7}}{Density.}
    \item{\code{X8}}{pH: \eqn{-\log_{10}} [H\eqn{^{+}}].}
    \item{\code{X9}}{Sulphate content.}
    \item{\code{X10}}{Alcohol content.}
    \item{\code{X11}}{Fixed acidity.}
  }
}

\source{
%%  ~~ reference to a publication or URL from which the data were obtained ~~
Paulo Cortez (Univ. Minho), Antonio Cerdeira, Fernando Almeida, Telmo Matos and Jose Reis (CVRVV) @ 2009
}
\references{
%%  ~~ possibly secondary sources and usages ~~
Past Usage:

  P. Cortez, A. Cerdeira, F. Almeida, T. Matos, Reis, J.(2009).  
  Modeling wine preferences by data mining from physicochemical properties.
  \emph{Decision Support Systems} 47(4):547-553. 
}

\keyword{datasets}

\name{plotCI.reg}
\alias{plotCI.reg}
\title{Plots a simple linear regression along with confidence and prediction intervals.

}
\description{Plots the fitted line from a simple linear regression (y ~ x) and (if requested) confidence and prediction intervals. 
}
\usage{

plotCI.reg(x, y, conf = 0.95, CI = TRUE, PI = TRUE, resid = FALSE, reg.col = 1, 
CI.col = 2, PI.col = 4, reg.lty = 1, CI.lty = 2, PI.lty = 3, reg.lwd = 1, 
CI.lwd = 1, resid.lty = 3, resid.col = 4,...)
}
\arguments{
  \item{x}{The explanatory variable, a numeric vector.}
  \item{y}{The response variable, a numeric vector}
  \item{conf}{The level of confidence; 1 - \emph{P}(type I error)}
  \item{CI}{Logical; should the confidence interval be plotted?}
  \item{PI}{Logical; should the prediction interval be plotted?}
  \item{resid}{Logical; should residuals be plotted?}
  \item{reg.col}{Color of the fitted regression line.}
  \item{CI.col}{Color of the confidence interval lines.}
  \item{PI.col}{Color of the prediction interval lines.}
  \item{reg.lty}{Line type for the fitted regression line.}
  \item{CI.lty}{Line type for the confidence interval.}
  \item{PI.lty}{Line type for the confidence interval.}
  \item{reg.lwd}{Line width for the regression line.}
  \item{CI.lwd}{Line widths for the confidence and prediction intervals.}
  \item{resid.lty}{Line width for the regression line.}
  \item{resid.col}{Line color for residual lines.}
  \item{\dots}{Additional arguments from \code{\link{plot}}}
  }

\value{
Returns a plot with a regression line and (if requested) confidence and prediction intervals} 

\author{Ken Aho
}
\seealso{\code{\link{plot}}, \code{\link{predict}}}

\examples{
y<-c(1,2,1,3,4,2,3,4,3,5,6)
x<-c(2,3,1,4,5,4,5,6,7,6,8)
plotCI.reg(x,y)
}
\keyword{graphs}
\keyword{htest}
\keyword{univar}

\name{whickham}
\alias{whickham}
\docType{data}
\title{
Whickham contingency table data for smokers and survivorship
}
\description{
Appleton et al. (1996) summarized a study from the Whickham district of England 
to quantify the association of smoking, age, and death.  1,314 women were interviewed 
in the early 1970s with respect to their smoking habits.  Twenty years later the women were relocated and 
classified with respect to survival at the time of the follow up (yes or no), 
whether they smoked at the time of the original interview (yes or no), 
and age at the time of the original study (1 = 18-24, 2 = 35-64, 3 = >65).   
}
\usage{data(whickham)}
\format{
  A data frame with 12 observations on the following 4 variables.
  \describe{
    \item{\code{age}}{A factor with levels \code{1} \code{2} \code{3}.}
    \item{\code{survival}}{A factor with levels \code{N} \code{Y}.}
    \item{\code{smoke}}{A factor with levels \code{N} \code{Y}.}
    \item{\code{count}}{Cross-classification count.}
  }
}
\source{
Appleton, D. R., French, J. M., Vanderpump, M. P. J.  (1996)  Ignoring a covariate: AN example of Simpson's paradox.  \emph{The American Statistician} 50(4): 340-341.
}
\keyword{datasets}

\name{DH.test}
\alias{DH.test}
\title{Doornik-Hansen test for multivariate normality.}
\description{
The Doornik-Hansen test for multivariate normality is a powerful alternative to the 
Shapiro-Wilk test.
}
\usage{

DH.test(Y, Y.names = NULL)
}
\arguments{

  \item{Y}{An \emph{n} x \emph{p} a dataframe of dependent variables.}
  \item{Y.names}{Names of \code{Y} variables; should be a 1 x \emph{p} character string.}
}
\details{
An assumption of multivariate normality is exceedingly difficult to verify.  Hypothesis 
tests tend to be too stringent, and multivariate diagnostic plots only allow viewing 
of two variables at a time.  Univariate normality of course can be verified using normal 
probability plots.  However while marginal non-normality indicates multivariate non-normality, 
marginal normality does not insure that \emph{Y} variables collectively follow a multivariate normal 
distribution.  

The Doornik-Hansen test for multivariate normality (Doornik and Hansen 2008) is based on the 
skewness and kurtosis of multivariate data that is transformed to insure independence.  
The DH test is more powerful than the Shapiro-Wilk test for most tested multivariate 
distributions (Doornik and Hansen 2008).  The function \code{DH.test} also runs the Doornik-Hansen 
test for both multivariate and univariate normality.  The later test follows 
directly from the work of Bowman and Shenton (1975), Shenton and Bowman (1977) and D'Agostino (1970).

}
\value{
Returns a list with two objects.
  \item{multi}{A dataframe containing multivariate results, i.e. the test statistic, \emph{E}, the 
  degrees of freedom and the \emph{p}-value.}
  \item{comp2 }{A dataframe with \emph{p} rows detailing univariate tests. Columns in the dataframe contain
  the test statistics, degrees of freedom and \emph{P}-values.}
}
\references{
D'Agostino, R. B. (1970). Transformation to normality of the null distribution of g1, \emph{Biometrika}
57: 679-681.

Doornik, J.A. and Hansen, H. (2008). An Omnibus test for univariate and multivariate 
normality. \emph{Oxford Bulletin of Economics and Statistics} 70, 927-939.

Shenton, L. R. and Bowman, K. O. (1977). A bivariate model for the distribution of b1 and b2,
\emph{Journal of the American Statistical Association} 72: 206.211.
}
\author{Ken Aho}
\note{As with all inferential normality tests our null hypothesis is that the underlying population 
is normal, in this case multivariate normal.
}
\seealso{\code{\link{shapiro.test}}, \code{\link{bv.boxplot}}}
\examples{
data(iris)#The ubiquitous multivariate iris data.
DH.test(iris[,1:4],Y.names=names(iris[,1:4]))
}
\keyword{htest}
\keyword{multivariate}

\name{huber.NR}
\alias{huber.NR}
\title{Huber M-estimator iterative least squares algorithm}
\description{
Algorithm for calculating fully iterated or one step Huber \emph{M}-estimators of location.
}                                                                                   
\usage{
huber.NR(x, c = 1.28, iter = 20)
}
\arguments{
  \item{x}{A vector of quantitative data}
  \item{c}{Bend criterion.  The value \code{c = 1.28} gives 95\% efficiency of the mean given normality.
  }
  \item{iter}{Maximum number of iterations}
}
\details{The Huber \emph{M}-estimator is a robust high efficiency estimator of location that has probably been under-utilized by biologists. It is based on maximizing the likelihood of a weighting function.  This is accomplished using an iterative least squares process.  The Newton Raphson algorithm is used here.  The function usually converges fairly quickly < 10 iterations.  The function uses the Median Absolute Deviation function, \code{\link{mad}}.  Note that if MAD = 0, then \code{NA} is returned.
}
\value{
Returns iterative least squares iterations which converge to Huber's \emph{M}-estimator.  The first element in the vector is the sample median.  The second element is the Huber one-step estimate. 
}
\seealso{\code{\link{huber.one.step}}, \code{\link{huber.mu}}, \code{\link{mad}}}
\references{ 
Huber, P. J.  (2004)  \emph{Robust Statistics}. Wiley.

Wilcox, R. R.   (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second Edition}.  Elsevier, Burlington, MA.
}
\author{Ken Aho}
\examples{
x<-rnorm(100)
huber.NR(x)
}

\name{bone}
\alias{bone}
\docType{data}
\title{
Bone development data
}
\description{
Neter et al. (1996) described an experiment in which researchers investigated the confounding effect of gender and bone development on growth hormone therapy for prepubescent children.  Gender had two levels: "M" and "F".  
The bone development factor had three levels indicating the severity of growth impediment before therapy: 1 = severely depressed, 2 = moderately depressed, and 3 = mildly depressed.  
At the start of the experiment 3 children were assigned to each of the six treatment combinations. However 4 of the children were unable to complete the experiment, resulting in an unbalanced design.  
}
\usage{data(bone)}
\format{
  A data frame with 14 observations on the following 3 variables.
  \describe{
    \item{\code{gender}}{A factor with levels \code{F} \code{M}}
    \item{\code{devel}}{A factor with levels \code{1} \code{2} \code{3}}
    \item{\code{growth}}{A numeric vector descibing the growth difference before and after hormone therapy}
  }
}
\source{
Neter, J., Kutner, M. H., Nachtsheim, C. J., and Wasserman, W  (1996)  \emph{Applied Linear Statistical Models}.  McGraw-Hill, Boston MA, USA. 
}
\keyword{datasets}

\name{starkey}
\alias{starkey}
\docType{data}
\title{DEM data from the Starkey experimental forest in NE Oregon}
\description{
UTM northing and easting data along with 18 other environmental variables describing the
Starkey experimental forest. 
}
\usage{data(starkey)}
%\source{
%\url{https://www.fs.fed.us/pnw/starkey/data/tables/Starkey_OR_Main_Habitat_1993-1996_Data.txt
%}}
\keyword{datasets}

\name{partial.resid.plot}
\alias{partial.resid.plot}
\title{Partial residual plots for interpretation of multiple regression.}
\description{The function creates partial residual plots which help a user graphically determine the effect of a single predictor with respect to all other predictors in a multiple regression model.
}
\usage{
partial.resid.plot(x, smooth.span = 0.8, lf.col = 2, sm.col = 4,...)
}
\arguments{

  \item{x}{A output object of class \code{lm} or class \code{glm}}
  \item{smooth.span}{Degree of smoothing for smoothing line.}
  \item{lf.col}{Color for linear fit.}
  \item{sm.col}{Color for smoother fit.}
  \item{\dots}{Additional arguments from \code{\link{plot}}.}
}
\details{
Creates partial residual plots (see Kutner et al. 2002).  Smoother lines from \code{\link{lowess}} and linear fits from \code{\link{lm}} are imposed over plots to help an investigator determine the effect of a particular \emph{X} variable on \emph{Y} with all other variables in the model.  The function automatically inserts explanatory variable names on axes.
}
\value{
Returns \emph{p} partial residual plots, where \emph{p} = the number of explanatory variables.
}
\references{Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li. (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.}
\author{Ken Aho}
\seealso{\code{\link{partial.R2}}}
\examples{
if(interactive()){
Soil.C<-c(13,20,10,11,2,25,30,25,23)
Soil.N<-c(1.2,2,1.5,1,0.3,2,3,2.7,2.5)
Slope<-c(15,14,16,12,10,18,25,24,20)
Aspect<-c(45,120,100,56,5,20,5,15,15)
Y<-c(20,30,10,15,5,45,60,55,45)
x <- lm(Y ~ Soil.N + Soil.C + Slope + Aspect)
op <- par(mfrow=c(2,2),mar=c(5,4,1,1.5))
partial.resid.plot(x)
par(op)
}
}
\keyword{univar}
\keyword{graphs}

\name{modlevene.test}
\alias{modlevene.test}
\alias{print.mltest}
\title{Modified Levene's test}
\description{
Conducts the modified Levene's test for homoscedastic populations.
}
\usage{

modlevene.test(y, x)
}
\arguments{

  \item{y}{Vector of quantitative ressponses, e.g., residuals from a linear model.}
  \item{x}{Vector of factor levels.}
}
\details{
The modified Levene's test is a test for homoscedasticity that (unlike the classic \emph{F}-test) is robust to violations of normality (Conover et al. 1981).  In a Modified Levene's test we calculate \eqn{d_{ij}=|e_{ij} - \tilde{e}_{i}|} where \eqn{\tilde{e}_i} is the \emph{i}th factor level residual median.  We then run an ANOVA on the \eqn{d_{ij}}'s.  If the \emph{p}-value is < \eqn{\alpha}, we reject the null and conclude that the population error variances are not equal.  
}
\value{
An ANOVA table is returned with the modified Levene's test results.
}
\references{
Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li. (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.}
\author{Ken Aho}

\seealso{\code{\link{fligner.test}}}
\examples{
eggs<-c(11,17,16,14,15,12,10,15,19,11,23,20,18,17,27,33,22,26,28)
trt<-as.factor(c(1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,4,4,4))
lm1<-lm(eggs~trt)
modlevene.test(residuals(lm1),trt)

}
\keyword{univar}
\keyword{htest}

\name{myeloma}
\alias{myeloma}
\docType{data}
\title{
Patient responses to myeloma drug treatments
}
\description{
Murakami et al. (1997) studied the effect of drugs treatments on levels of serum beta-2 microglobulin in patients with multiple myeloma.   
Serum beta-2 microglobulin is produced in the body as a result of myelomas, and thus can be used as an indicator of the severity of disease
}
\usage{data(myeloma)}
\format{
  A data frame with 20 observations on the following 2 variables.
  \describe{
    \item{\code{mglobulin}}{Levels of serum beta-2 microglobulin in mg/l}
    \item{\code{drug}}{Drug treatment strategy.  \code{Control} = sumerifon alone, \code{Trt} = malphalan and sumerifon.}
  }
}
\source{
Ott, R. L., and M. T. Longnecker  (2004)  \emph{A First Course in Statistical Methods}.  Thompson. 
}
\references{
Murakami, H., Ogawara, H., Morita, K.,  Saitoh, T., Matsushima, T., Tamura, J.,   Sawamura, M.,  Karasawa, M.,  Miyawaki, M.,, Schimano, S., Satoh, S., and  J Tsuchiy (1997)
Serum beta-2-microglobulin in patients with multiple myeloma treated with alpha interferon.  \emph{Journal of Medicine} 28(5-6):311-8. 
}
\keyword{datasets}

\name{deer}
\alias{deer}
\docType{data}
\title{Maternal deer data }
\description{
Monteith et al. (2009) examined the maternal life history characteristics of white-tailed deer (Odocoileus virginianus) originating from the Black Hills in southwestern South Dakota and from eastern South Dakota.  Because litter size and dam size affects offspring weight the investigators used proportional birth mass (dam mass/total litter mass) as a measure of reproductive investment by deer.  
}
\usage{data(deer)}
\format{
The dataframe contains 6 columns
\describe{
\item{\code{Birth.Yr}}{Year of birth.}   
\item{\code{Litter.size}}{Number of offspring.}         
\item{\code{Region}}{Categorical variable with two factor levels.  BH = Black Hills, ER = Eastern Region.}        
\item{\code{Dam.weight}}{Dam weight in kg.}
\item{\code{Total.birth.mass}}{Mass of litter in kg.}
\item{\code{Prop.mass}}{Total birth mass divided by dam weight.}
  }
}
\source{Monteith, K. L, Schmitz, L. E., Jenks, J. A., Delger, J. A., and R. T. Bowyer.  2009.  Growth of male white tailed deer: consequences of maternal effects.  \emph{Journal of Mammalogy} 90(3): 651-660.}
\keyword{datasets}

\name{potash}
\alias{potash}
\docType{data}
\title{
Potash/cotton strength data
}
\description{
An oft-cited RCBD example is an agricultural experiment which evaluates the effect of levels of of soil K\eqn{_2}O (potash) on 
the breaking strength of cotton fibers (Cochran and Cox 1957).  Five levels of K\eqn{_2}O were used in the soil subplots (
36, 54, 72, 108, and 144 lbs per acre) and a single sample of cotton was taken from each of five subplot.  
The experiment had three blocks, and each of the K\eqn{_2}O treatments was randomly assigned to the five subplots within each block.  
}
\usage{data(potash)}
\format{
  A data frame with 15 observations on the following 3 variables.
  \describe{
    \item{\code{treatment}}{a factor with levels \code{36} \code{54} \code{72} \code{108} \code{144}}
    \item{\code{block}}{a factor with levels \code{1} \code{2} \code{3}}
    \item{\code{strength}}{a numeric vector}
  }
}
\source{
Cochran, W. G. and G. M. Cox  (1957) \emph{Experimental Designs (Second Edition)}. New York: John Wiley & Sons.
}

\keyword{datasets}

\name{heart}
\alias{heart}
\docType{data}
\title{
Heart rate data from Milliken and Johnson (2009)
}
\description{
A repeated measures demonstration dataset from Milliken and Johnson (1999).  Heart rate was measured for twenty four subject at four time periods following administration of a treatment.  The treatment types were two active heart drugs and a control.  One treatment was assigned to each subject. 
Thus each drug was administered to eight subjects.
}
\usage{data(heart)}
\format{
  A data frame with 96 observations on the following 4 variables.
  \describe{
    \item{\code{rate}}{A numeric vector describing heart rate (bpm).}
    \item{\code{time}}{A factor with levels \code{t1} \code{t2} \code{t3} \code{t4}}
    \item{\code{drug}}{A factor with levels \code{AX23} \code{BWW9} \code{Ctrl}}
    \item{\code{subject}}{A factor describing which subject (in drug) that measurements were made on.}
  }
}

\source{
Milliken, G. A., and D. E. Johnson (2008) \emph{Analysis of Messy Data: Vol. I. Designed Experiments, 2nd edition}. CRC.
}
\examples{
\dontrun{
#data(heart)
#aov(rate ~ drug * time + Error(subject\%in\%drug), data = heart)
}
}
\keyword{datasets}
                   

\name{see.lmr.tck}
\alias{see.lmr.tck}
\alias{pm1}
\title{
Regression linear model derivation from linear algebra
}
\description{
Given Y and X matrices a regression linear model is demonstrated using matrix algebra.
}
\usage{
see.lmr.tck()
pm1(Y, X, sz=1, showXY = TRUE)
}

\arguments{

  \item{Y}{
Response variable
}
  \item{X}{
Explanatory variables
}
  \item{sz}{
Text expansion factor
}
  \item{showXY}{
Logical, indicating whether or not \emph{X} and \emph{Y} matrices should be shown.
}
}
\details{
\emph{X} requires a \emph{Y} intercept variable \eqn{X_0} and at least one other variable.
}
\author{Ken Aho
}
\seealso{\code{\link{lm}}}
\keyword{graphs}

\name{ci.prat.ak}
\alias{ci.prat.ak}

\title{
Confidence intervals for ratios of proportions when the denominator is known
}
\description{
It is increasingly possible that resource availabilities on a landscape will be known.  
For instance, in remotely sensed imagery with sub-meter resolution, the areal coverage of 
resources can be quantified to a high degree of precision, at even large spatial scales.  
Included in this function are six methods for computation of confidence intervals for 
a true ratio of proportions when the denominator proportion is known.  The first (adjusted-Wald) 
results from the variance of the estimator \eqn{\hat{\sigma}_{\hat{\pi}}} after multiplication by a constant.  
Similarly, the second method(Agresti-Coull-adjusted) adjusts the variance of the estimator \eqn{\hat{\sigma}_{\hat{\pi}_{AC}}}, 
where \eqn{\hat{\pi}_{AC}=(y+2)/(n+4)}.  The third method (fixed-log) is based on delta derivations of the logged ratio.
The fourth method is Bayesian and based on the beta posterior distribution derived from a binomial likelhood function and a beta prior distribution.  The fifth procedure is an older method based on Noether (1959).  Sixth, bootstrapping methods can also be implemented.  
}
\usage{
ci.prat.ak(y1, n1, pi2 = NULL, method = "ac", conf = 0.95, bonf = FALSE, 
bootCI.method = "perc", R = 1000, sigma.t = NULL, r = length(y1), gamma.hyper = 1, 
beta.hyper = 1)
}

\arguments{

  \item{y1}{
The ratio numerator number of successes.  A scalar or vector.
}
  \item{n1}{
The ratio numerator number of trials.  A scalar or vector of \code{length(y1)}
}
  \item{pi2}{
The denominator proportion.  A scalar or vector of \code{length(y1)}
}
  \item{method}{
One of \code{"ac", "wald", "noether-fixed", "boot", "fixed-log"} or \code{"bayes"} for the Agresti-Coull-adjusted, adjusted Wald, noether-fixed, bootstrapping, fixed-log and Bayes-beta, methods, respectively.  Partial distinct names can be used. 
}
  \item{conf}{
The level of confidence, i.e. 1 - \emph{P}(type I error). 
}
  \item{bonf}{Logical, indicating whether or not Bonferroni corrections should be applied for simultaneous inference if \code{y1, y2, n1} and \code{n2} are vectors.
} 
  \item{bootCI.method}{If \code{method = "boot"} the type of bootstrap confidence interval to calculate.  One of \code{"norm"}, \code{"basic"}, \code{"perc"}, \code{"BCa"}, or \code{"student"}.  See  
\code{\link{ci.boot}} for more information.
}
  \item{R}{If \code{method = "boot"} the number of bootstrap samples to take.  See \code{\link{ci.boot}} for more information.
} 
  \item{sigma.t}{If \code{method = "boot"} and \code{bootCI.methd = "student"} a vector of standard errors in association with studentized intervals.   See \code{\link{ci.boot}} for more information.
} 
  \item{r}{The number of ratios to which family-wise inferences are being made.  Assumed to be \code{length(y1)}. 
}
  \item{gamma.hyper}{If \code{method = "bayes"}.  A scalar or vector. Value(s) for the first hyperparameter for the beta prior distribution. 
}
  \item{beta.hyper}{If \code{method = "bayes"}.  A scalar or vector. Value(s) for the second hyperparameter for the beta prior distribution.
} 
}

\details{
Koopman et al. (1984) suggested methods for handling extreme cases of \eqn{y_1}, \eqn{n_1}, \eqn{y_2}, and \eqn{n_2} (see below).  These are applied through exception handling here (see Aho and Bowyer 2015). 

Let \eqn{Y_1} and \eqn{Y_2} be multinomial random variables with parameters \eqn{n_1, \pi_{1i}},  and  \eqn{n_2, \pi_{2i}}, respectively; where \eqn{i = \{1, 2, 3, \dots, r\}}.  This encompasses the binomial case in which \eqn{r = 1}. We define the true selection ratio for the \emph{i}th resource of \emph{r} total resources to be:
 \deqn{\theta_{i}=\frac{\pi _{1i}}{\pi _{2i}}}

where \eqn{\pi_{1i}} and \eqn{\pi_{2i}} represent the proportional use and availability of the \emph{i}th resource, respectively.  If \eqn{r = 1} the selection ratio becomes relative risk.  The maximum likelihood estimators for \eqn{\pi_{1i}} and \eqn{\pi_{2i}} are the sample proportions: 

\deqn{{{\hat{\pi }}_{1i}}=\frac{{{y}_{1i}}}{{{n}_{1}}},} and
\deqn{{{\hat{\pi }}_{2i}}=\frac{{{y}_{2i}}}{{{n}_{2}}}}

where \eqn{y_{1i}} and \eqn{y_{2i}} are the observed counts for use and availability for the \emph{i}th resource.  If \eqn{\pi_{2i}}s are known, the estimator for \eqn{\theta_i} is:

\deqn{\hat{\theta}_{i}=\frac{\hat{\pi}_{1i}}{\pi_{2i}}.}

The function \code{ci.prat.ak} assumes that selection ratios are being specified (although other applications are certainly possible).  Therefore it assume that \eqn{y_{1i}} must be greater than 0 if \eqn{\pi_{2i} = 1}, and assumes that \eqn{y_{1i}} must = 0 if \eqn{\pi_{2i} = 0}.  Violation of these conditions will produce a warning message.   


\tabular{ll}{
Method \tab Algorithm \cr
\tab \cr 

% AC	
Agresti Coull-Adjusted  \tab \eqn{{{\hat{\theta}}_{ACi}}\pm {{z}_{1-(\alpha /2)}}\sqrt{{{{\hat{\pi }}}_{AC1i}}(1-{{{\hat{\pi }}}_{AC1i}})/({{n}_{1}}+4){{{\hat{\pi }}}_{AC1i}}\pi _{2i}^{2}}}, \cr 
\tab where \eqn{{{\hat{\pi}}_{AC1i}}=\frac{{{y}_{1}}+z^2/2}{{{n}_{1}}+z^2}}, and \eqn{{{\hat{\theta }}_{ACi}}=\frac{{{\hat{\pi}}_{AC1i}}}{{{\pi }_{2i}}}}, \cr
\tab where \eqn{z} is the standard normal inverse cdf at probability \eqn{1 - \alpha/2} (\eqn{\approx 2} when \eqn{\alpha= 0.05}).  \cr 
\tab \cr
%Bayes
Bayes-beta \tab \eqn{(\frac{X_{\alpha/2}}{\pi_{2i}}} , \eqn{\frac{X_{1-(\alpha/2)}}{\pi_{2i}})}, \cr
\tab where \eqn{X \sim BETA(y_{1i} + \gamma_{i}, n_1 + \beta - y_{1i})}. \cr
\tab \cr
% fixed log
Fixed-log \tab \eqn{{{\hat{\theta }}_{i}}\times \exp \left( \pm {{z}_{1-\alpha /2}}{{{\hat{\sigma }}}_{F}} \right)}, \cr 
\tab where \eqn{\hat{\sigma}_{^{F}}^{2}=(1-{{\hat{\pi}}_{1i}})/{{\hat{\pi}}_{1i}}{{n}_{1}}.} \cr 
\tab \cr
% Noether-fixed	
Noether-fixed \tab \eqn{\frac{{{{\hat{\pi }}}_{1i}}/{{\pi }_{2}}}{1+z_{1-(\alpha /2)}^{2}}1+\frac{z_{1-(\alpha /2)}^{2}}{2{{y}_{1i}}}\pm z_{1-(\alpha /2)}^{2}\sqrt{\hat{\sigma}_{NF}^{2}+\frac{z_{1-(\alpha /2)}^{2}}{4y_{1i}^{2}}}}, \cr
\tab where \eqn{\hat{\sigma }_{NF}^{2}=\frac{1-{{{\hat{\pi }}}_{1i}}}{{{n}_{1}}{{{\hat{\pi }}}_{1i}}}}. \cr
\tab \cr
% Wald-adj
Wald-adjusted \tab \eqn{{{\hat{\theta }}_{i}}\pm {{z}_{1-(\alpha /2)}}\sqrt{{{{\hat{\pi }}}_{1i}}(1-{{{\hat{\pi }}}_{1i}})/{{n}_{1}}{{{\hat{\pi }}}_{1i}}\pi _{2i}^{2}}.}\cr
\tab \cr
}
}

\value{Returns a list of \code{class = "ci"}.  Default output is a matrix with the point and interval estimate. 
}
\references{
Aho, K., and Bowyer, T. 2015. Confidence intervals for ratios of proportions: implications for selection ratios. \emph{Methods in Ecology and Evolution} 6: 121-132.
}
\author{
Ken Aho
}
\seealso{
\code{\link{ci.prat}}, \code{\link{ci.p}}
}
\examples{
ci.prat.ak(3,4,.5)
}

\name{C.isotope}
\alias{C.isotope}
\docType{data}
\title{
Atmospheric carbon and D14C measurements
}
\description{
Atmospheric \eqn{\delta ^{14}}C (per mille) and CO\eqn{_2} (ppm) measurements for La Jolla Pier, California. Latitude: 32.9 Degrees N, Longitude: 117.3 Degrees W, Elevation: 10m; \eqn{\delta} \eqn{^{14}}C derived from flask air samples      
}
\usage{data(C.isotope)}
\format{
  A data frame with 280 observations on the following 5 variables.
  \describe{
    \item{\code{Date}}{a factor with levels \code{ 01-Apr-96} \code{ 01-Jul-92} \code{ 01-Jul-93} \code{ 02-Apr-01} \code{ 02-Feb-96} \code{ 02-Nov-94} \code{ 02-Oct-92} \code{ 03-Aug-06} \code{ 03-Aug-92} \code{ 03-Jan-95} \code{ 03-Jan-97} \code{ 03-Jul-95} \code{ 03-Mar-93} \code{ 03-May-05} \code{ 03-May-96} \code{ 03-Nov-05} \code{ 04-Apr-94} \code{ 04-Jun-01} \code{ 04-Jun-03} \code{ 04-Mar-03} \code{ 04-May-01} \code{ 04-May-07} \code{ 04-Sep-96} \code{ 05-Aug-96} \code{ 05-Jul-05} \code{ 05-Jun-00} \code{ 05-Sep-00} \code{ 06-Aug-02} \code{ 06-Oct-06} \code{ 06-Sep-01} \code{ 06-Sep-07} \code{ 07-Apr-05} \code{ 07-Apr-95} \code{ 07-Aug-07} \code{ 07-Dec-07} \code{ 07-Feb-01} \code{ 07-Feb-03} \code{ 07-Feb-05} \code{ 07-Jun-07} \code{ 07-Mar-01} \code{ 07-Sep-05} \code{ 08-Feb-94} \code{ 08-Feb-95} \code{ 08-Feb-99} \code{ 08-Jan-01} \code{ 08-Jun-95} \code{ 08-Sep-99} \code{ 09-Dec-01} \code{ 09-Feb-93} \code{ 09-Jan-02} \code{ 09-Jun-04} \code{ 09-Nov-00} \code{ 09-Nov-02} \code{ 09-Nov-06} \code{ 09-Sep-02} \code{ 09-Sep-03} \code{ 09-Sep-92} \code{ 10-Apr-03} \code{ 10-Aug-01} \code{ 10-Aug-97} \code{ 10-Aug-99} \code{ 10-Jan-98} \code{ 10-Jun-02} \code{ 10-Nov-95} \code{ 10-Oct-00} \code{ 10-Oct-04} \code{ 10-Oct-97} \code{ 11-Dec-92} \code{ 11-Feb-00} \code{ 11-Jan-07} \code{ 11-Jan-93} \code{ 11-Mar-94} \code{ 11-Mar-96} \code{ 11-Nov-93} \code{ 11-Oct-02} \code{ 12-Apr-93} \code{ 12-Apr-99} \code{ 12-Aug-93} \code{ 12-Jul-02} \code{ 12-Jun-06} \code{ 12-Oct-07} \code{ 13-Feb-98} \code{ 13-Jan-98} \code{ 13-Jun-01} \code{ 13-Mar-95} \code{ 13-May-02} \code{ 13-Sep-06} \code{ 14-Apr-00} \code{ 14-Aug-00} \code{ 14-Dec-98} \code{ 14-Feb-03} \code{ 14-Jul-00} \code{ 14-Sep-04} \code{ 15-Dec-93} \code{ 15-Feb-06} \code{ 15-Feb-95} \code{ 15-May-95} \code{ 15-Oct-99} \code{ 16-Apr-96} \code{ 16-Jul-01} \code{ 16-Jun-00} \code{ 16-Nov-03} \code{ 16-Nov-99} \code{ 16-Oct-95} \code{ 17-Dec-02} \code{ 17-Feb-02} \code{ 17-Feb-97} \code{ 17-Jul-06} \code{ 17-Jul-07} \code{ 17-Mar-06} \code{ 17-May-94} \code{ 17-Nov-99} \code{ 18-Aug-00} \code{ 18-Dec-92} \code{ 18-Jul-97} \code{ 18-Jun-05} \code{ 18-Mar-03} \code{ 18-May-93} \code{ 18-Nov-94} \code{ 19-Apr-05} \code{ 20-Apr-04} \code{ 20-Mar-00} \code{ 21-Apr-06} \code{ 21-Aug-95} \code{ 21-Dec-04} \code{ 21-Jan-00} \code{ 21-Jul-99} \code{ 21-Jun-02} \code{ 21-Jun-93} \code{ 22-Apr-97} \code{ 22-Feb-00} \code{ 22-Feb-96} \code{ 22-Jan-96} \code{ 22-Jun-94} \code{ 22-Mar-02} \code{ 22-May-06} \code{ 22-May-98} \code{ 23-Apr-98} \code{ 23-Feb-07} \code{ 23-Jul-92} \code{ 23-Jun-97} \code{ 23-Mar-01} \code{ 23-Mar-05} \code{ 24-Apr-03} \code{ 24-Aug-94} \code{ 24-Feb-93} \code{ 24-Jul-01} \code{ 24-Jul-02} \code{ 24-Jun-03} \code{ 24-Mar-04} \code{ 25-Apr-02} \code{ 25-Aug-98} \code{ 25-Jan-06} \code{ 25-Oct-96} \code{ 26-Aug-04} \code{ 26-Dec-03} \code{ 26-Feb-04} \code{ 26-Jan-05} \code{ 26-Jan-99} \code{ 26-Jun-96} \code{ 26-Mar-04} \code{ 26-May-00} \code{ 26-May-04} \code{ 26-Sep-95} \code{ 27-Jul-04} \code{ 27-Mar-07} \code{ 27-Nov-96} \code{ 27-Oct-05} \code{ 28-Jul-04} \code{ 28-Jul-05} \code{ 29-Aug-03} \code{ 29-Dec-02} \code{ 29-Jul-98} \code{ 29-Jun-98} \code{ 29-Oct-92} \code{ 29-Oct-98} \code{ 30-Jun-97} \code{ 30-Nov-93} \code{ 31-Dec-99} \code{ 31-Jan-04} \code{ 31-Oct-01} \code{ 31-Oct-03}}
    \item{\code{Decimal.date}}{A numeric vector}
    \item{\code{CO2}}{CO\eqn{_2} concentration (in ppm)}
    \item{\code{D14C}}{\eqn{\delta} \eqn{^{14}}C (in per mille)}
    \item{\code{D14C.uncertainty}}{measurement uncertainty for \code{D14C}(in per mille)}
  }
}

\source{
H. D. Graven, R. F. Keeling, A. F. Bollenbacher                                 
Scripps CO\eqn{_2} Program Scripps Institution of Oceanography (SIO) 
University of California, La Jolla, California USA 92093-0244                                                     
and
                                                                                   
T. P. Guilderson Center for Accelerator Mass Spectrometry (CAMS) 
Lawrence Livermore National Laboratory (LLNL)  
Livermore, California USA  94550
}
\references{
H. D. Graven, T. P. Guilderson and R. F. Keeling, Observations of radiocarbon 
in CO\eqn{_2} at La Jolla, California, USA 1992-2007: Analysis of the long-term trend. \emph{Journal of Geophysical Research}.}  
\keyword{datasets}

\name{bats}
\alias{bats}
\docType{data}
\title{Bat forearm length as a function of bat age}
\description{
Data from northern myotis bats (\emph{Myotis septentrionalis}) captured in the field in Vermillion County Indiana in 2000.   
}
\usage{data(bats)}
\format{
  The dataframe has 2 columns:
  \describe{
    \item{\code{days}}{The age of the bats in days.}
    \item{\code{forearm.length}}{The length of the forearm in millimeters.} 
        }
}
\source{
Krochmal, A. R., and D. W. Sparks (2007)  \emph{Journal of Mammalogy}. 88(3): 649-656.
}
\keyword{datasets}

\name{savage}
\alias{savage}
\docType{data}
\title{
Mammalian BMR and biomass data from Savage et al. (2004)
}
\description{
Compilation of mammalian BMR and biomass data from the large
data sets used in the studies of Hart (1971),
Heusner (1991), Lovegrove (2000, 2003) and White &
Seymour (2003).  Data compiled by Savage (2004).
}
\usage{data("savage")}
\format{
  A data frame with 1006 observations on the following 9 variables.
  \describe{
    \item{\code{Order}}{Mammal order.}
	\item{\code{Family}}{Mammal family.}
	\item{\code{Species}}{Mammal genus and species.}
    \item{\code{Mass}}{Biomass in grams.}
    \item{\code{BMR}}{Basal metabolic rate in watts}
    \item{\code{AvgMass}}{Average mass, given multiple reports for a particular species.}
    \item{\code{AvgBMR}}{Average BMR, given multiple reports for a particular species.}
    \item{\code{References}}{Authorities from whom data were obtained.}
    \item{\code{Notes}}{Note concerning a repeated species name.}
  }
}
\source{
Savage, 548 V.M., Gillooly, J.F., Woodruff, W.H., West, G.B., Allen, A.P., Enquist, B.J., 
Brown, J.H. (2004) The predominance of quarter-power scaling in biology. \emph{Functional 
Ecology}, 18, 257-282.
}
\references{
Hart, J.S. (1971) \emph{Rodents in Comparative Physiology of Thermoregulation}, Vol. II Mammals (ed. G.C. Whittow),
pp. 2-149. Academic Press, New York.

Heusner, A.A. (1991) Size and power in mammals. \emph{Journal of Experimental Biology} 160, 25-54.

Lovegrove, B.G. (2000) The zoogeography of mammalian basal metabolic rate. \emph{American Naturalist} 156, 201-219.

Lovegrove, B.G. (2003) The influence of climate on the metabolic rate of small mammals: a slow-fast metabolic continuum.  \emph{Journal of Comparative Physiology B} 173, 87-112.

White, C.R. and Seymour, R.S. (2003) Mammalian basal metabolic rate is proportional to
584 body mass 2/3. \emph{Proceedings of the National Academy of Sciences}, 100, 4046-4049.
}
\keyword{datasets}

\name{moose.sel}
\alias{mule.sel}
\alias{goat.sel}
\alias{quail.sel}
\alias{elk.sel}
\alias{bighorn.sel}
\alias{bighornAZ.sel}
\alias{moose.sel}
\alias{juniper.sel}
\docType{data}
\title{
Datasets for resource use and availability
}
\description{
A collection of datasets which can be used to calculate and compare selection ratios. Datasets are: \code{goat.sel, mule.sel, quail.sel, elk.sel, bighorn.sel, bighornAZ.sel, juniper.sel} and are described (briefly) in Manly et al. (2002) and Aho and Bowyer (2015).
}
\usage{data(moose.sel)
data(goat.sel)
data(quail.sel)
data(elk.sel)
data(bighorn.sel)
data(bighornAZ.sel)
data(juniper.sel)
}

\format{
  Dataframes with observations on the following variables.
  \describe{
    \item{\code{resources}}{A factor listing resource types.}
    \item{\code{avail}}{Proportional availability (for datasets without n2 and y2).}
    \item{\code{y1}}{A numeric vector: number of times the resource was used.}
    \item{\code{y2}}{A numeric vector: number of time the resource was observed.}
    \item{\code{n1}}{A numeric vector: number of times that all resources were used.}
    \item{\code{n2}}{A numeric vector: number of times that all resources were observed.}
  }
}
\source{
Manly BF, McDonald LL, Thomas DL, McDonald TL, Erickson WP (2002) \emph{Resource Selection by Animals: Statistical Design and Analysis for Field Studies.  2nd  edn}.  Kluwer, New York
}
\references{
Aho, K., and Bowyer, T. 2015. Confidence intervals for ratios of proportions: implications for selection ratios. \emph{Methods in Ecology and Evolution} 6: 121-132.  }
\keyword{datasets}

\name{trim.me}
\alias{trim.me}
\title{Trim data}
\description{
Trims observations above and below the central \eqn{(1 - 2\lambda}) part of an an ordered vector of data. 
}
\usage{
trim.me(Y, trim = 0.2)
}
\arguments{

  \item{Y}{A vector of quantitative data.}
  \item{trim}{Proportion (0-1) to be trimmed from each tail of an ordered version of \code{Y}.}
}
\value{Returns a trimmed data vector.}
\author{Ken Aho}
\examples{
x<-c(2,1,4,5,6,2.4,7,2.2,.002,15,17,.001)
trim.me(x)
}

\name{eff.rbd}
\alias{eff.rbd}

\title{
Efficiency of a randomized block design compared to a CRD
}
\description{
Calculates the RCBD efficiency ratio for a linear model with one main factor and one blocking factor.  Values greater than 1 indicate that the RCBD has greater efficiency compared to a CRD.
}
\usage{
eff.rbd(lm)
}

\arguments{

  \item{lm}{
An object of class \code{lm}.  The blocking factor must be called \code{"block"}.
}
}

\references{
Kutner, M. H., C. J. Nachtsheim, J. Neter, and W. Li  (2005) \emph{Applied Linear Statistical Models}. McGraw-Hill Irwin.
}
\author{
Ken Aho
}
\keyword{htest}

\name{cliff.env}
\alias{cliff.env}
\docType{data}
\title{Environmental data for the community dataset cliff.sp}
\description{
The data here are a subset of a dataset collected by Aho (2006) which describe the distribution of communities of lichens and vascular and avascular plant species on montane cliffs in Northeast Yellowstone National Park.  Of particular interest was whether substrate (limestone or andesitic conglomerate) or water supply influenced community composition.
}
\usage{data(cliff.env)}
\format{
This data frame contains the following columns:
  \describe{
    \item{\code{sub}}{
      a factor with 2 levels
      \code{"Andesite"} and \code{"Lime"} describing substrate type. 
    }
    \item{\code{water}}{
      a factor with 3 levels
      \code{"W"} 
      \code{"I"}
      \code{"D"}
      indicating wet, intermediate, or dry conditions. 
    }
  }
}
\details{
Two categorical environmental variables are described for 54 sites.  \code{sub} describes the substrate; there are two levels: \code{"Andesite"} and \code{"Lime"}.  \code{water} describes distance of samples from waterfalls which drain the cliff faces; there are three levels \code{"W"} indicating wet, \code{"I"} indicating intermediate, and \code{"D"} indicating dry.
}
\source{
Aho, K.(2006)  \emph{Alpine Ecology and Subalpine Cliff Ecology in the Northern Rocky 
Mountains}.  Doctoral dissertation, Montana State University, 458 pgs.
}
\keyword{datasets}

\name{see.mixedII}
\alias{see.mixedII}

\title{
Depiction of the effect of random level selection on inferences concerning fixed effects
}
\description{
The levels for a fixed factor are shown in rows, while the columns are levels for a random factor.  
Thus, the table depicts a mixed model.  Assume that the values in the table are population means.  
For instance, the true mean of random level R1 for the fixed level F1 is 1.  Using information from all random factor levels, 
the null hypothesis for the fixed factor is true.  That is, \eqn{\mu_{F1} = \mu_{F2} = \mu_{F3}}.  
However when we select a subset of random levels, this is obscured.  In fact, for any subset of random factor levels it appears as if there is evidence against H\eqn{_0}, 
i.e. there appears to be variability among the fixed factor level means.  
Thus, to avoid inflation of type I error (rejection of a true null hypothesis) 
we must consider the interaction of the random and fixed factors when considering inference for the fixed factor level populations.   
}
\usage{

see.mixedII()
}
\references{
Maxwell, S. E., and H. D. Delaney (2003) \emph{Designing Experiments and Analyzing Data: A Model Comparison Perspective, 2nd edition}. Routledge Academic.
}
\author{
Ken Aho, thanks to Ernest Keeley 
}
\keyword{graphs}

\name{shade.norm.tck}
\alias{shade.bin.tck}
\alias{shade.chi.tck}
\alias{shade.F.tck}
\alias{shade.norm.tck}
\alias{shade.poi.tck}
\alias{shade.t.tck}

\title{GUI display of probability 
}
\description{
Provides \pkg{tcltk} GUIs to manage \pkg{asbio} \code{\link{shade}} functions.
}
\usage{

shade.bin.tck()

shade.chi.tck()

shade.F.tck()

shade.norm.tck()

shade.poi.tck()

shade.t.tck()
}

\author{Ken Aho
}

\seealso{\code{\link{shade}}}
\keyword{graphs}

\name{pseudo.v}
\alias{pseudo.v}
\title{Jacknife pseudo-values}
\description{
The function returns jackknife pseudovalues which can then be used to create statistical summaries, e.g. the jackknife parameter estimate, and the jackknife standard error.  The function can be run on univariate data \code{(matrix = FALSE)} or multivariate data \code{(matrix =TRUE)}.  In the later case matrix rows are treated as multivariate observations.
}
\usage{
pseudo.v(data, statistic, order = 1, matrix = FALSE)
}
\arguments{
  \item{data}{A vector \code{(matrix =FALSE)} or matrix \code{(matrix=TRUE)} of quantitative data.}
  \item{statistic}{A function whose output is a statistic (e.g. a sample mean).  The function must have only one argument, a call to \code{data}.}
  \item{order}{The order of jackknifing to be used.}
  \item{matrix}{A logical statement.  If \code{matrix = TRUE} then rows in the matrix are sampled as multivariate observations.}
}
\details{
In the first order jackknife procedure a statistic \eqn{\hat{\theta}} is calculated using all \emph{n} samples, it is then calculated with the first observation removed \eqn{\hat{\theta}}\eqn{_{-1}}, with only the second observation removed, \eqn{\hat{\theta}}\eqn{_{-2}}, and so on.  This process is repeated for all \emph{n} samples.  The resulting vector of size \emph{n} contains pseudovalues for their respective observations.
}
\value{
A vector of first-order jackknife pseudovalues is returned.
}
\references{Manly, B. F. J.  (1997)  \emph{Randomization and Monte Carlo Methods in Biology, 2nd edition}.
Chapman and Hall, London.}
\author{Ken Aho}

\seealso{\code{\link[boot]{empinf}}, \code{\link[boot]{boot}}, \code{\link{bootstrap}}}


\examples{
data(cliff.sp)
siteCD1<-data.frame(t(cliff.sp[1,]))

#Shannon-Weiner diversity
SW<-function(data){
d<-data[data!=0]
p<-d/sum(d)
-1*sum(p*log(p))
}

pv<-pseudo.v(siteCD1,SW)
}
\keyword{manip}

\name{sedum.ts}
\alias{sedum.ts}
\docType{data}
\title{
CO2 exchange time series data 
}
\description{
Gurevitch et al. (1986) demonstrated time series analysis with data describing change in CO\eqn{_2} concentration of airstreams passing over a \emph{Sedum wrightii} test plant.  
}
\usage{data(sedum.ts)}
\format{
  A data frame with 24 observations on the following 3 variables.
  \describe{
    \item{\code{exchange}}{CO\eqn{_2} exchange, measured as: [change in CO\eqn{_2} concentration (g/mg)]/ plant fresh mass (g).  Thus units are 1/mg.  
    Positive values indicate net CO\eqn{_2} uptake while negative values indicate net CO2 output. }
    \item{\code{time}}{A numeric vector indicating two hour intervals}
    \item{\code{treatment}}{\code{Dry} = water withheld for several week, \code{Wet} = plant well watered.}
  }
}

\source{
Gurevitch, J. and S. T. Chester, Jr  (1986)  Analysis of repeated measures experiments.  \emph{Ecology} 67(1): 251-255.

}

\keyword{datasets}

\name{one.sample.z}
\alias{one.sample.z}
\alias{print.oneSamp}
\title{One sample z-test}
\description{
Provides a one-sample hypothesis test.  The test assumes that the underlying population is normal and furthermore that \eqn{\sigma} is known.}
\usage{
one.sample.z(data = NULL, null.mu = 0, xbar = NULL, sigma, n = NULL, 
alternative = "two.sided", conf = 0.95, na.rm = FALSE, fpc = FALSE, N = NULL)
}
\arguments{
  \item{data}{A vector of quantitative data.  Not required if \code{xbar} and \code{n} are supplied by the user.}
  \item{null.mu}{The expectation for the null distribution.}
  \item{xbar}{Sample mean.  Not required if \code{is.null(data)==FALSE}}
  \item{sigma}{The null distribution standard deviation}
  \item{n}{The sample size. Not required if \code{is.null(data)==FALSE}}
  \item{alternative}{Type of test.  One of three must be specified \code{"two.sided", "less"}, or \code{"greater"}}
  \item{conf}{Confidence level.}
   \item{na.rm}{Logical, indicate whether \code{NA} values should be stripped before the computation proceeds.}
   \item{fpc}{A logical statement specifying whether a finite population correction should be made.  If \code{fpc = TRUE} the population size \code{N} must be specified.}
  \item{N}{The population size.  Required if \code{fpc=TRUE}}
}
\details{The function can use either raw data \code{is.null(data)==FALSE} or summarized data if \code{is.null(data)==TRUE}.  With the later \code{xbar} and \code{n} must be specified by the user.
}
\value{Returns a test statistic and a \emph{p}-value.
}
\author{Ken Aho.  Thanks to Anderson Canteli for identifying a bug in the function for \pkg{asbio} versions < 1.9-6.}
\seealso{\code{\link{pnorm}}}
\examples{
one.sample.z(null.mu = 131, xbar = 126, sigma = 12, n = 85, alternative = "two.sided")
}
\keyword{htest}
\keyword{univar}

\name{see.move}
\alias{see.move}
\alias{see.adddel}
\title{
Interactive visualization of least squares regression.  
}
\description{
Scatterplot points can be moved with \code{see.move}, while points can be added and deleted with \code{see.adddel}. The function \code{see.move} is an appropriation from \pkg{tcltk} demos, with a few bells and whistles added.
}
\usage{
see.move()
see.adddel()
}
\author{the R Development Core Team for \code{see.move}, Ken Aho for \code{see.adddel}. 
}
\keyword{graphs}

\name{potato}
\alias{potato}
\docType{data}
\title{Fisher's Rothamsted potato data

}
\description{
In his "Statistical Methods for Research Workers" Fisher (1925) introduced the world to ANOVA using data from the  Rothamsted Agricultural Experimental Station.  In one example, Fisher compared potato yield (per plant) for twelve potato varieties and three fertilizer treatments (a basal manure application, along with sulfur and chloride addition).   
Three replicates were measured for each of the 12 x 3 = 36 treatment combinations. 
}
\usage{data(potato)}
\format{
  A data frame with 108 observations on the following 4 variables.
  \describe{
    \item{\code{Yield}}{Potato yield in lbs per plant}
    \item{\code{Variety}}{Potato variety: \code{Ajax} \code{Arran comrade} \code{British queen} \code{Duke of York} \code{Epicure} \code{Great Scot} \code{Iron duke} \code{K of K} \code{Kerrs pink} \code{Nithsdale} \code{Tinwald perfection} \code{Up-to-date}}
    \item{\code{Fert}}{Fertilizer type: \code{B} = basal manure, \code{Cl} = chloride addition, \code{S} = sulfur addition.}
    \item{\code{Patch}}{Feld patch number \code{1} \code{2} \code{3} \code{4} \code{5} \code{6} \code{7} \code{8} \code{9}}
  }
}
\source{
Fisher, R. A. (1925)  \emph{Statistical Methods for Research Workers, 1st edition}.  Oliver and Boyd,  Edinburgh

Thanks to Bob O'Hara for finding a data entry error for this dataset for versions of asbio <= 1.8-2.
}
\keyword{datasets}

\name{grass}
\alias{grass}
\docType{data}
\title{Agricultural factorial design}
\description{
Littell et al. (2006) describe an experiment to distinguish the effects of three seed growing methods 
on the yield of five turf grass varieties. The seed growing methods were applied to seed from each grass variety.  
Six pots were planted with each variety \eqn{\times} method combination.  The pots were placed in a growth chamber with 
uniform conditions and dry matter (in grams) was weighed from above ground clips after four weeks.  
}
\usage{data(grass)}
\format{
The dataframe has three columns:
  \describe{
\item{\code{yield}}{Refers to grass yield.}
\item{\code{method}}{Seed growing method.  A factor with three levels: \code{a,b,c}.}  
\item{\code{variety}}{Grass variety. A factor with five levels: \code{1,2,3,4,5}.}
  }
}
\source{
Littell, R. C., Milliken, G. A., Stroup, W. W., Wolfinger, R. D., and O. Schabenberger  
(2006)  \emph{SAS for mixed models 2nd ed}.  SAS press.
}
\keyword{datasets}

\name{wheat}
\alias{wheat}
\docType{data}
\title{Agricultural randomized block design}
\description{
Allard (1966) sought to quantify variation in the yield in wheat grasses.  
Five wheat crosses were selected from a breeding program and were grown at 
four randomly selected locations where the wheat would be grown commercially.  
At each location crosses (families) were randomly assigned to particular 
sections of fields, i.e. at each location a one way randomized block design 
was conducted.  
}
\usage{data(wheat)}
\format{
The dataframe has four columns:
  \describe{
\item{yield}{Refers to wheat yield.}
\item{loc}{Refers to randomly selected locations where wheat were grown commercially.  A factor with four levels: \code{1,2,3,4}.}
\item{block}{Refers to the replicate block within location.  A factor with four levels: \code{1,2,3,4}. Within each block five wheat crosses were randomly assigned and grown.}  
\item{cross}{Refers to wheat crosses.  A factor with five levels: \code{1,2,3,4,5}.}
  }
}
\source{
Littell, R. C., Milliken, G. A., Stroup, W. W., Wolfinger, R. D., and O. Schabenberger  
(2006)  \emph{SAS for Mixed Models 2nd ed}.  SAS press.
}
\keyword{datasets}

\name{aids}
\alias{aids}
\docType{data}
\title{Aids and veterans dataset

}
\description{
The veterans administration studied the effect of AZT on AIDS symptoms for 338 HIV-positive military veterans who were just beginning to express AIDS.  AZT treatment was withheld on a random component until helper T cells showed even greater depletion while the other group received the drug immediately.  The subjects were also classified by race.
}
\usage{data(aids)}
\format{
  A data frame with 338 observations on the following 3 variables.
  \describe{
    \item{\code{race}}{A factor with levels \code{black}, \code{white}.}
    \item{\code{AZT}}{A factor with levels \code{N}, \code{Y}.}
    \item{\code{symptoms}}{Presence/absence of AIDS symptoms.}
  }
}

\source{
Agresti, A. (2012)  \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley.
}

\keyword{datasets}

\name{SexDeterm}
\alias{SexDeterm}
\docType{data}
\title{
Fern environmental sex determination data
}
\description{
Sex determination (male and female) data at ecologically relevant glucose, N, and P concentrations and stoichiometries, at both ambient and elevated levels of CO\eqn{_2}. The term "ameristic" denotes gametophytes with only male gametangia, while the term "meristic" refers to gametophytes with female or female and male gametangia.
}

\usage{data("SexDeterm")}
\format{
  A data frame with 156 observations on the following 11 variables.
  \describe{
    \item{\code{CO2.Level}}{a factor with levels \code{Ambient} \code{Elevated} CO2 levels}
    \item{\code{Block}}{a numeric vector, the elevated CO2 experiment was completed in 2 blocks}
    \item{\code{Glucose.Level}}{the number of C atoms relative to the number of P atoms, with 5 indicating the presence of 6 micromolar glucose and 0 indicating the absence of glucose in the growth media}
    \item{\code{N.Level}}{the number of N atoms relative to the number of P atoms}
    \item{\code{P.Level}}{the number of P atoms relative to the number of N atoms}
    \item{\code{C.N.P}}{the ratio of C to N to P atoms, a factor with levels \code{1:1} \code{1:2} \code{1:3} \code{1:4} \code{16:1} \code{16:2} \code{16:3} \code{16:4} \code{32:1} \code{32:2} \code{32:3} \code{32:4} \code{48:1} \code{48:2} \code{48:3} \code{48:4} \code{5:1:1} \code{5:1:2} \code{5:1:3} \code{5:1:4} \code{5:16:1} \code{5:16:2} \code{5:16:3} \code{5:16:4} \code{5:32:1} \code{5:32:2} \code{5:32:3} \code{5:32:4} \code{5:48:1} \code{5:48:2} \code{5:48:3} \code{5:48:4}}
    \item{\code{Total.Gametophyte.No.}}{the total number of gametophytes in each population}
    \item{\code{No..of.Ameristic.Gametophytes}}{the number of ameristic (male) gametophytes in each gametophyte population}
    \item{\code{No..of.Meristic.Gametophytes}}{the number of meristic (female and hermaphrodite) gametophytes in each gametophyte population}
    \item{\code{Ameristic.Meristic.Ratio}}{the ratio of ameristic gametophytes to meristic gametophytes (sex ratio)}
    \item{\code{Pct..Ameristic.Gametophytes}}{the percentage of ameristic gametophytes per total gametophyte population}
  }
}
\references{
Goodnoe, T. T., Hill, J. P., Aho, K. (2016)  Effects of variation in carbon, nitrogen and phosphorous molarity and stoichiometry on sex determination in the fern \emph{Ceratopteris richardii}.  \emph{Botany} 94(4): 249-259.  
}
\examples{
data(SexDeterm)
}
\keyword{datasets}

\name{life.exp}
\alias{life.exp}
\docType{data}
\title{
Mouse life expectancy data
}
\description{
Weindruch et al. (1986) compared life expectancy of field mice given different diets.  To accomplish this, the authors randomly assigned 244 mice to one of four diet treatments.   
}
\usage{data(life.exp)}
\format{
  A data frame with 244 observations on the following 2 variables.
  \describe{
    \item{\code{lifespan}}{Lifespan in weeks}
    \item{\code{treatment}}{a factor with levels \code{N/N85}: Mice were fed normally both before and after weaning (the slash distinguishes pre and post weaning).  After weaning the diet consisted of 85kcal/week, a conventional total for mice rearing, 
    \code{N/R40}: Mice were fed normally before weaning, but were given a severely restricted diet of 40 kcal per week after feeding, \code{N/R50}: Mice were restricted to 50kcal per week before and after weaning,
    \code{R/R50}}: Mice were fed normally before weaning, but their diet was restricted to 50 kcal per week after weaning.
  }
}
\source{
Ramsey, F. L., and D. W. Schafer (1997)  \emph{The Statistical Sleuth: A Course in Methods of 
Data Analysis}.  Duxbury Press, Belmont, CA. 

}
\references{
Weindruch, R., Walford, R. L., Fligiel, S., and D. Guthrie  (1986)  The retardation of aging in mice by dietary restriction: 
longevity, cancer, immunity and lifetime energy intake.  \emph{The Journal of Nutrition} 116 (4): 641-54.

}
\examples{
data(life.exp)
## maybe str(life.exp) ; plot(life.exp) ...
}
\keyword{datasets}

\name{vs}
\alias{vs}
\alias{varespec}
\docType{data}
\title{
Scandinavian site by species community matrix
}
\description{
Scandinavian, lichen, bryophyte, and vascular plant data from Vare et al. (1995).
}
\usage{data(vs)}
\format{
  A data frame with 24 observations (sites) on 44 variables (species).
}
\details{
Lifted from dataframe \code{{varespec}} in package \pkg{vegan}.
}
\source{
The dataset \code{{varespec}} in package \pkg{vegan}
}
\references{
Vare, H., Ohtonen, R., and J. Oksanen (1995) Effects of reindeer grazing on understory vegetation in dry Pinus sylvestris forests. \emph{Journal of Vegetation Science} 6: 523-530.
}
\keyword{datasets}

\name{Preston.dist}
\Rdversion{1.1}
\alias{Preston.dist}
\title{
Preston diversity analysis
}
\description{
A diversity and richness analysis method based on the Preston (1948) log-normal distribution. 
}
\usage{

Preston.dist(counts, start = 0.2, cex.octave = 1, cex.legend = 1, cex.pt = 1, ...)
}
\arguments{
  \item{counts}{
	Vector of counts for species in a community dataset. 
}
  \item{start}{
	Starting value for non-linear least squares estimation of \emph{a} in \eqn{n = n_0 \times e^{-aR^2}}.
}
  \item{cex.octave}{
	Character expansion for octave labels.
}
  \item{cex.legend}{
	Character expansion for legend.}

  \item{cex.pt}{
	Character expansion for symbols.}

  \item{\dots}{
Additional arguments from \code{\link{plot}}.
}
}
\details{
Preston (1948) proposed that after a log\eqn{_2} transformation species abundances, grouped in bins representing 
a doubling of abundance (octaves), would be normally distributed.  Thus, after this transformation most 
species in a sample would have intermediate abundance, and there would be relatively few rare or ubiquitous species.  
The Preston model is based on the Gaussian function: \eqn{n = n_0 \times e^{-aR^2}}, where, \eqn{n_0} is the 
number of species contained in the modal octave, \emph{n} is the number of species contained in an octave \emph{R} 
octaves from the modal octave, and \emph{a} is an unknown parameter.  The parameter \emph{a} is estimated using the function 
\code{\link{nls}}, using a starting value, 0.2, recommended by Preston.  The area under Preston curve provides an 
extrapolated estimate of richness and thus an indication of the adequacy of a sampling effort.  Preston called a 
line placed at the 0th octave the veil line.  He argued that species with abundances below the veil line have not 
been detected due to inadequate sampling.  
 
}
\value{
Graph of the Preston log-normal distribution for a dataset given by "counts", and a summary of the analysis 
including the fitted Gaussian equation, the estimated number of species, and an estimate for the percentage 
of sampling that was completed i.e. \code{[length(counts)/Est.no.of.spp]*100}.
}
\references{
Preston, F.W.  (1948)  The commonness and rarity of species. \emph{Ecology} 29, 254-283. 
}
\author{
Ken Aho
}
\seealso{\code{\link{dnorm}}, \code{\link{nls}}}
\examples{

data(BCI.count)
BCI.ttl<-apply(BCI.count,2,sum)
Preston.dist(BCI.ttl)
}
\keyword{graphs}

\name{Semiconductor}
\alias{Semiconductor}
\docType{data}
\title{Split plot computer chip data from Littell et al. (2006)}
\description{
Littell et al. (2006) use the data here to introduce analysis of split plot 
designs using mixed models.  Twelve silicon wafers were randomly selected from 
a lot, and were randomly assigned to four different processing modes.  
Resistance on the chips was measured in four different positions (four different 
chips) on each wafer.  Mode of processing and position of chips were fixed 
factors, while wafer was a random effect.    The experimental units with respect 
to process are the wafers.  The experimental units with respect to position 
are individual chips.  Thus the wafer is the whole plot, whereas the positions 
(chips) are split plot units 
}
\usage{data(Semiconductor)}
\format{
The dataframe contains four columns:
  \describe{
\item{\code{Resistance}}{The response variable of interest.  Measured in ohms.}
\item{\code{Process}}{The explanatory variable of interest.  The type of process used to create the computer chips.  A factor with 4 levels.}
\item{\code{Wafer}}{The whole plot containing four chips.  There were four wafers tested, i.e. four levels, \code{1,2,3,4}.}
\item{\code{Chip}}{Position on the wafer.  These are split plots within the whole plots.  Four levels: \code{1,2,3,4}.}   
  }
}
\source{
Littell, R. C., Milliken, G. A., Stroup, W. W., Wolfinger, R. D., and O. Schabenberger  
(2006)  \emph{SAS for Mixed Models 2nd ed}.  SAS press.
}
\keyword{datasets}

\name{Fbird}
\alias{Fbird}
\docType{data}
\title{Frigatebird drumming frequency data}
\description{
Male magnificent frigatebirds (\emph{Fregata magnificens}) have an enlarged red throat pouch that has probably evolved as the result of sexual selection.  
During courtship displays males attract females by displaying this pouch and using it to make a drumming sound. Madsen et al. (2004) noted that conditions 
(e.g. oblique viewing angles) often limit females' ability to appraise pouch size exactly.  Since females choose mates based on pouch size, 
a question of interest is whether females could use the pitch of the pouch drumming as an indicator of pouch size. 
Madsen et al. (2004) estimated the pouch volume and fundamental drumming frequency for forty males at Isla Isabel in Nayarit Mexico.  
Eighteen of these observations are in this dataset.
}
\usage{data(Fbird)}
\format{
The dataframe contains two variables: 
  \describe{
    \item{\code{vol}}{
     Pouch volume (in cm\eqn{^3}). 
    }
    \item{\code{freq}}{
     Frequency of drumming (in Hz)
    }
    }
}
\source{Madsen, V., Balsby, T.J.S., Dabelsteen, T., and J.L. Osorno (2004) Bimodal signaling of 
a sexually selected trait: gular pouch drumming in the magnificent frigatebird. \emph{Condor} 106: 156-160.
} 
\keyword{datasets}

\name{ci.median}
\alias{ci.median}
\title{Confidence interval for the median
}
\description{
Calculates the upper and lower confidence bounds for the true median, and calculates true coverage of the interval.}
\usage{

ci.median(x, conf = 0.95)
}
\arguments{
  \item{x}{A vector of quantitative data.
}
  \item{conf}{
The desired level of confidence 1 - \emph{P}(type I error).
}
}
\value{Returns a list of \code{class = "ci"}.  Default printed results are the parameter estimate and confidence bounds.  Other \code{invisible} objects include:
  \item{coverage}{The true coverage of the interval.}
  }
\references{
Ott, R. L., and M. T. Longnecker (2004) \emph{A First Course in Statistical Methods}.  
Thompson.

}
\author{
Ken Aho
}
\seealso{\code{\link{median}}}
\examples{
x<-rnorm(20)
ci.median(x)}
\keyword{univar}

\name{anm.cont.pdf}
\alias{anm.cont.pdf}
\alias{see.pdf.conc.tck}
\title{Animated demonstration of density for a continuous pdf
}
\description{
A continuous pdf is conceptually a histogram whose bin area sums to one.  Infinite, infinitely small bins, however, are required to allow depiction of an infinite number of distinct continuous outcomes.
}
\usage{

anm.cont.pdf(part = "norm", interval = 0.3)

see.pdf.conc.tck()
}
\arguments{

  \item{part}{
Parent distribution, options are \code{"norm"} = \emph{N}(0, 1), \code{"t"} = \emph{t}(10),
\code{"exp"} = EXP(1), and \code{"unif"} = UNIF(0,1)
}
  \item{interval}{
Animation interval
}
}
\author{
Ken Aho}
\note{
May not work every time, because random values may exceed histogram range.
}
\keyword{graphs}

\name{sc.twin}
\alias{sc.twin}
\docType{data}
\title{Matched pairs schizophrenia data}
\description{
Scientists have long been concerned with identifying physiological characteristics which result in a disposition for schizophrenia.  Early studies suggested that the volume of particular brain regions of schizophrenic patients may differ from non-afflicted individuals.  However these studies often contained confounding variables (e.g. socioeconomic status, genetics) which obscured brain volume/ schizophrenia relationships (Ramsey and Schafer 1997).  To control for confounding variables Suddath et al. (1990) examined 15 pairs of monozygotic twins where one twin was schizophrenic and the other was not.  Twins were located from an intensive search throughout the United States and Canada.  The authors used magnetic resonance imaging to measure brain volume of particular regions in the twin's brains. 
}
\usage{data(sc.twin)}
\format{
  The dataframe has 2 columns:
  \describe{
    \item{\code{unaffected}}{Left hippocampus volumes for unaffected twins.}
    \item{\code{affected}}{Left hippocampus volumes for affected twins.}
    }
  } 
\keyword{datasets}

\name{wash.rich}
\alias{wash.rich}
\docType{data}
\title{
Species richness and environmental variables from Mt Washburn
}
\description{
Aho and Weaver (2010) examined the effect of environmental characteristics on alpine vascular plant species richness on Mount Washburn (3124m) a volcanic peak in north-central Yellowstone National Park.
}
\usage{data(wash.rich)}
\format{
  A data frame with 40 observations on the following 7 variables.
  \describe{
    \item{\code{site}}{Site identifier.}
    \item{\code{Y}}{Species richness.}
    \item{\code{X1}}{Percent Kjeldahl (total) soil N.}
    \item{\code{X2}}{Slope in degrees.}
    \item{\code{X3}}{Aspect in degrees from true north.}
    \item{\code{X4}}{Percent cover of surface rock.}
    \item{\code{X5}}{Soil pH.}
  }
}
\source{
Aho, K., and T. Weaver (2010)  Ecology of alpine nodes: environments, communities, 
and ecosystem evolution (Mount Washburn; Yellowstone Natl. Park).  \emph{Arctic, Antarctic, and Alpine Research}.  40(2): 139-151. 
}
\keyword{datasets}

\name{baby.walk}
\alias{baby.walk}
\docType{data}
\title{
Baby walking times experimental data
}
\description{
In general, mammals are able to walk within minutes or hours after birth.  
Human babies, however, generally don't begin to walk until they are between 10 and 18 months of age.  
This occurs because, although humans are born with rudimentary reflexes for walking, they are 
unused, and thus largely disappear by the age of eight weeks.  As a result 
these movements must be relearned by an infant following significant passage of time, 
through a process of trial and error.  Zelazo et al. (1972) performed a series of experiments 
to determine whether certain exercises could allow infants to maintain their walking reflexes, 
and allow them to walk at an earlier age.  Study subjects were 24 white male infants from middle class families, and were assigned to one of four exercise treatments.

Active exercise (AE): Parents were taught and were told to apply exercises that 
would strengthen the walking reflexes of their infant.   
Passive exercise (PE): Parents were taught and told to apply exercises unrelated to walking.
Test-only (TO):  The investigators did not specify any exercise, but visited and tested the walking reflexes of infants in weeks 1 through 8.  Passive and active exercise infants were also tested in this way.  
Control (C):  No exercises were specified, and infants were only tested at weeks one and eight.  This group was established to account for the potential effect of the walking reflex tests themselves.

}
\usage{data(baby.walk)}
\format{
  A data frame with 22 observations on the following 2 variables.
  \describe{
    \item{\code{date}}{Age when baby first started walking (in months)}
    \item{\code{treatment}}{A factor with levels \code{AE} \code{C} \code{PE} \code{TO}}
  }
}

\source{
Ott, R. L., and M. T. Longnecker {2004}  \emph{A First Course in Statistical Methods}.  
Thompson.

}
\references{
Zelazo, P. R., Zelazo, N. A., and S. Kolb.  1972.  Walking in the newborn.  \emph{Science} 176: 
314-315.

}
\keyword{datasets}

\name{bound.angle}
\alias{bound.angle}
\title{
Angle of azimuth to a boundary.
}
\description{
The function calculates the angle of azimuth from a Cartesian coordination given in \code{X} and \code{Y} to a nearest neighbor coordinate 
given by \code{nX} and \code{nY}.  The nearest neighbor coordinates can be obtained using the function \code{\link{near.bound}}.  
}
\usage{bound.angle(X, Y, nX, nY)}
\arguments{
  \item{X}{Cartesian \emph{X} coordinate of interest.  
}
  \item{Y}{Cartesian \emph{Y} coordinate of interest.
}
  \item{nX}{Cartesian \emph{X} coordinate of nearest neighbor point on a boundary.
}
  \item{nY}{Cartesian \emph{Y} coordinate of nearest neighbor point on a boundary. 
}
}
\details{The function returns the nearest neighbor angles (in degrees) with respect to a four coordinate system ala ARC-GIS Near(Analysis).  
Output angles range from \eqn{-180^{\circ}} to \eqn{180^{\circ}}: \eqn{0^{\circ}} to the East, \eqn{90^{\circ}} to the North, \eqn{180^{\circ}} (or \eqn{-180^{\circ}}) to the West,
and \eqn{-90^{\circ}} to the South.  
}
\value{Returns a vector of nearest neighbor angles.}

\author{Ken Aho}
\seealso{\code{\link{near.bound}}, \code{\link{prp}}}
\examples{
bX<-seq(0,49)/46
bY<-c(4.89000,4.88200,4.87400,4.87300,4.88000,4.87900,4.87900,4.90100,4.90800,
4.91000,4.93300,4.94000,4.91100,4.90000,4.91700,4.93000,4.93500,4.93700,
4.93300,4.94500,4.95900,4.95400,4.95100,4.95800,4.95810,4.95811,4.95810,
4.96100,4.96200,4.96300,4.96500,4.96500,4.96600,4.96700,4.96540,4.96400,
4.97600,4.97900,4.98000,4.98000,4.98100,4.97900,4.98000,4.97800,4.97600,
4.97700,4.97400,4.97300,4.97100,4.97000)

X<-c(0.004166667,0.108333333,0.316666667,0.525000000,0.483333333,0.608333333,
0.662500000,0.683333333,0.900000000,1.070833333)
Y<-c(4.67,4.25,4.26,4.50,4.90,4.10,4.70,4.40,4.20,4.30)
nn<-near.bound(X,Y,bX,bY)

bound.angle(X,Y,nn[,1],nn[,2])
}

\name{anm.geo.growth}
\alias{anm.geo.growth}
\alias{anm.exp.growth}
\alias{anm.log.growth}
\alias{anm.geo.growth.tck}
\alias{anm.exp.growth.tck}
\alias{anm.log.growth.tck}

\title{Animated depictions of population growth
}

\description{Animated depictions of geometric, exponential, and logistic growth.
}
\usage{

anm.geo.growth(n0, lambda, time = seq(0, 20), ylab = "Abundance",
xlab = "Time", interval = 0.1, ...)

anm.exp.growth(n, rmax, time = seq(0, 20), ylab = "Abundance",
xlab = "Time", interval = 0.1, ...)

anm.log.growth(n, rmax, K, time = seq(0, 60), ylab = "Abundance",
xlab = "Time", interval = 0.1, ...)

anm.geo.growth.tck()

anm.exp.growth.tck()

anm.log.growth.tck()
}

\arguments{

  \item{n0}{
Population size at time zero for geometric population growth.
}
  \item{lambda}{
Geometric growth rate.
}
  \item{time}{
A time sequence, i.e. a vector of integers which must include 0.
}
  \item{ylab}{
\emph{Y}-axis label.
}
  \item{xlab}{
\emph{X}-axis label
}
  \item{interval}{
Animation interval in seconds per frame.
}
  \item{\dots}{
Additional arguments to \code{\link{plot}}
}
  \item{n}{Initial population numbers for exponential and logistic growth
}
  \item{rmax}{
The maximum intrinsic rate of increase
}
  \item{K}{
The carrying capacity
}


}
\details{Presented here are three famous population growth models from ecology.  Geometric, exponential and logistic growth.  The first two model growth in the presence of unlimited resources.  Geometric growth is exponential growth assuming non-overlapping generations, and is computed as:

\deqn{N_t = N_{0}\lambda^t,}

where \eqn{N_t} is the number of individuals at time \emph{y}, \eqn{\lambda} is the geometric growth rate, and \emph{t} is time.

Exponential growth allows simultaneous existence of multiple generations, and is computed as:

\deqn{\frac{dN}{dt}=r_{max}N,}

where \eqn{r_{max}} is the maximum intrinsic rate of increase, i.e. max(birth rate - death rate), and \emph{N} is the population size.  With logistic growth, exponential growth is slowed as \emph{N} approaches the carrying capacity.  It is computed as:

\deqn{\frac{dN}{dt}=r_{max}N\frac{K-N}{K},}

where \eqn{r_{max}} is the maximum rate of intrinsic increase, \eqn{N} is the population size, and \eqn{K} is the carrying capacity

All three functions can be run from \pkg{tcltk} GUIs.
}

\author{
Ken Aho
}

\seealso{\code{\link{anm.LVexp}}, \code{\link{anm.LVcomp}}
}
\examples{
\dontrun{
anm.geo.growth(10,2.4)
}
}
\keyword{graphs}

\name{ci.impt}
\alias{ci.impt}
\title{Confidence interval for the product of two proportions
}
\description{
Provides one and two-tailed confidence intervals for the true product of two proportions.   
}
\usage{

ci.impt(y1, n1, y2 = NULL, n2 = NULL, avail.known = FALSE, pi.2 = NULL, 
conf = .95, x100 = TRUE, alternative = "two.sided", bonf = TRUE, wald = FALSE)
}

\arguments{

  \item{y1}{
The number of successes associated with the first proportion.
}
  \item{n1}{
The number of trials associated with the first proportion.
}
  \item{y2}{
The number of successes associated with the second proportion.  Not used if \code{avail.known = TRUE}.
}
  \item{n2}{
The number of trials associated with the first proportion.  Not used if \code{avail.known = TRUE}.
}
  \item{avail.known}{
Logical.  Are the proportions \eqn{\pi_{2i}} known?  If \code{avail.known = TRUE} these proportions should specified in the \code{pi.2} argument.  
}
  \item{pi.2}{
Proportions for \eqn{\pi_{2i}}.  Required if \code{avail.known = TRUE}.
  }
  \item{conf}{
Confidence level, i.e., 1 - \eqn{\alpha}.
}  
  \item{x100}{
Logical.  If true, estimate is multiplied by 100.
}
  \item{alternative}{
One of \code{"two.sided", "less", "greater"}.  Allows lower, upper, and two-tailed confidence intervals.  If \code{alternative = "two.sided"} (the default),  
then a conventional two-sided confidence interval is given.  The specifications \code{alternative = "less"} and \code{alternative = "greater"} provide lower and upper tailed CIs, respectively.
}

  \item{bonf}{
Logical.  If \code{bonf = TRUE}, and the number of requested intervals is greater than one, then Bonferroni-adjusted intervals are returned.
}
  \item{wald}{
Logical.  If \code{avail.known = TRUE} one can apply one of two standard error estimators.  The default is a delta-derived estimator.  If \code{wald = TRUE} is specified a modified Wald standard error estimator is used.  
}

}

\details{
Let \eqn{Y_1} and \eqn{Y_2} be multinomial random variables with parameters \eqn{n_1}, \eqn{\pi_{1i}} and \eqn{n_2}, \eqn{\pi_{2i}}, respectively; where \eqn{i = 1,2,\dots, r}.  
Under delta derivation, the log of the products of \eqn{\pi_{1i}} and \eqn{\pi_{2i}} (or the log of a product of \eqn{\pi_{1i}} and \eqn{\pi_{2i}} and a constant) is asymptotically normal with mean 
\eqn{log(\pi_{1i} \times \pi_{2i})} 
and variance \eqn{(1 - \pi_{1i})/\pi_{1i}n_1 + (1 - \pi_{2i})/ \pi_{2i}n_2}. Thus, an asymptotic \eqn{(1 - \alpha)100} percent confidence interval for \eqn{\pi_{1i} \times \pi_{2i}} is given by:

\deqn{
\hat{\pi}_{1i} \times \hat{\pi}_{2i} \times \exp(\pm z_{1-(\alpha/2)}\hat{\sigma}_i)
}
where: \eqn{\hat{\sigma}^2_i = \frac{(1 - \hat{\pi}_{1i})}{\hat{\pi}_{1i}n_1} + \frac{(1 - \hat{\pi}_{2i})}{\hat{\pi}_{2i}n_2}} and \eqn{z_{1-(\alpha/2)}} 
is the standard normal inverse CDF at probability \eqn{1 - \alpha}.
}


\value{Returns a list of \code{class = "ci"}.  Printed results are the parameter estimate and confidence bounds. }


\author{
Ken Aho
}
\note{
Method will perform poorly given unbalanced sample sizes.
}
\references{
Aho, K., and Bowyer, T. 2015. Confidence intervals for a product of proportions: Implications for importance values. \emph{Ecosphere} 6(11): 1-7.
}

\seealso{
\code{\link{ci.prat}}, \code{\link{ci.p}}
}
\examples{
ci.impt(30,40, 25,40)
}

\name{plotAncova}
\alias{plotAncova}

\title{
Creates plots for one way ANCOVAs 
}
\description{
ANCOVA plots are created, potentially with distinct line types and/or symbols and colors for treatments.  A legend relating ciphers to treatments is also included.
}
\usage{

plotAncova(model, pch = NULL, lty = NULL, col = NULL, leg.loc = "topright", 
leg.cex = 1, leg.bty = "o", leg.bg = par("bg"), legend.title = NULL,...)
}

\arguments{

  \item{model}{
Result from \code{\link{lm}}. An additive model results in a common slope plot.  An interaction model results in distinct slopes for treatments 
}
  \item{pch}{
A scalar, or a vector of length \emph{n} defining symbols for treatments. 
}
  \item{lty}{
A scalar, or a vector of length \emph{n} defining line types for treatments. 
}
  \item{col}{
A scalar, or a vector of length \emph{n} defining color for symbols and lines. 
}
  \item{leg.loc}{
Location of the legend. \code{"n"} suppresses the legend.
}
  \item{leg.cex}{
Character expansion from \code{\link{legend}}.
}
  \item{leg.bty}{
Box type from \code{\link{legend}}.
}
  \item{leg.bg}{
Background color from \code{\link{legend}}.
}
  \item{legend.title}{
Legend \code{title} from \code{\link{legend}}.
}
  \item{\dots}{
Additional arguments from \code{\link{plot}}
}
}

\value{
Returns an ANCOVA plot and model coefficients.  Slopes and intercepts for factor level lines are also stored as invisible output (see Examples).  
}

\author{
Ken Aho
}

\seealso{
\code{\link{lm}}
}
\examples{

x <- rnorm(20)
y <- 3 * x + rnorm(20)
cat <- c(rep("A",5),rep("B",5),rep("C",5),rep("D",5))
l <- lm(y ~ x * cat)
plotAncova(l, leg.loc = "bottomright")

# Access intercepts and slopes
pa <- plotAncova(l)
pa
}
\keyword{graphs}

\name{ipomopsis}
\alias{ipomopsis}
\docType{data}
\title{
Ipomopsis fruit yield data
}
\description{
The following question is based on data from Crawley (2007).  We are interested in the effect of grazing on seed production in the plant scarlet gilia \emph{Ipomopsis aggregata} .  Forty plants were allocated to two treatments, grazed and ungrazed.  Grazed plants were exposed to rabbits during the first two weeks of stem elongation.  They were then protected from subsequent grazing by the erection of a fence and allowed to continue growth. Because initial plant size may influence subsequent fruit production, the diameter of the top of the rootstock was measured before the experiment began.  At the end of the experiment, fruit production (dry weight in milligrams) was recorded for each of the forty plants.  
}
\usage{data(ipomopsis)}
\format{
  A data frame with 40 observations on the following 3 variables.
  \describe{
    \item{\code{root}}{Rootstock diameter in mm}
    \item{\code{fruit}}{Fruit dry weight in mg}
    \item{\code{grazing}}{a factor with levels \code{Grazed} \code{Ungrazed}}
  }
}

\source{
Website associated with --
Crawley, M. J.  2007.  \emph{The R book}.  Wiley. 
}
\keyword{datasets}

\name{larrea}
\alias{larrea}
\docType{data}
\title{
Creosote bush counts 
}
\description{
Phillips and MacMahon (1981) conducted an extensive study of \emph{Larrea tridentata} (creosote bush) distributions in the Mojave 
and Sonoran deserts from several life stage classes based areal coverage: Life stage 1 (102 -103 cm\eqn{^2})	Life stage 2 (103 -104 cm\eqn{^2}), and	Life stage 3
(104 -105 cm\eqn{^2}).  Data were generated (using variance and mean values, and the function \code{\link{rpois}} to approximate the results of the authors.
}
\usage{data(larrea)}
\format{
  A data frame with 25 observations on the following 3 variables.
  \describe{
    \item{\code{class1}}{Counts from life stage 1}
    \item{\code{class2}}{Counts from life stage 2}
    \item{\code{class3}}{Counts from life stage 3}
  }
}

\references{
Phillips, D. L., and J. A. MacMahon  (1981)  Competition and spacing patterns in desert 
shrubs.  \emph{Journal of Ecology} 69(1): 97-115. 

}
\keyword{datasets}

\name{anm.mc.bvn}
\alias{anm.mc.bvn}
\alias{anm.mc.norm}
\alias{anm.mc.bvn.tck}

\title{
Animation of Markov Chain Monte Carlo walks in bivariate normal space
}
\description{
The algorithm can use three different variants on MCMC random walks: Gibbs sampling, the Metropolis algorithm, and the Metropolis-Hastings algorithms to move through univariate \code{anm.mc.norm} and bivariate normal probability space.  The jumping distribution is also bivariate normal with a mean vector at the current bivariate coordinates.  The jumping kernel modifies the jumping distribution through multiplying the variance covariance of this distribution by the specified constant. 
}
\usage{
anm.mc.bvn(start = c(-4, -4), mu = c(0, 0), sigma = matrix(2, 2, data = c(1, 0,
 0, 1)), length = 1000, sim = "M", jump.kernel = 0.2, xlim = c(-4, 4),
 ylim = c(-4, 4), interval = 0.01, show.leg = TRUE, cex.leg = 1, ...)

anm.mc.norm(start = -4, mu = 0, sigma = 1, length = 2000, sim = "M",
 jump.kernel = 0.2, xlim = c(-4, 4), ylim = c(0, 0.4), interval = 0.01,
 show.leg = TRUE,...)

anm.mc.bvn.tck()
}



\arguments{

  \item{start}{
A two element vector specifying the bivariate starting coordinates.
}
  \item{mu}{
A two element vector specifying the mean vector for the proposal distribution.
}
  \item{sigma}{
A 2 x 2 matrix specifying the variance covariance matrix for the proposal distribution.    
}
  \item{length}{
The length of the MCMC chain.
}
  \item{sim}{
Simulation method used.  Must be one of \code{"G"} indicating Gibbs sampling, \code{"M"} indicating the Metropolis algorithm, or \code{"MH"} indicating the Metropolis-Hastings algorithm (Gibbs sampling is not implemented for \code{anm.mc.norm}).
}
  \item{jump.kernel}{
A number > 0 that will serve as a (squared) multiplier for the proposal variance covariance.  The result of this multiplication will be used as the variance covariance matrix for the jumping distribution.   
}
  \item{xlim}{
A two element vector describing the upper and lower limits of the \emph{x}-axis.
}
  \item{ylim}{
A two element vector describing the upper and lower limits of the \emph{y}-axis.
}
  \item{interval}{
Animation interval
}
  \item{show.leg}{
Logical.  Indicating whether or not the chain length should be shown.
}

 \item{cex.leg}{
Character expansion for legend.
}

  \item{\dots}{
Additional arguments from \code{\link{plot}}.
}
}


\value{
The function returns two plots.  These are: 1) the proposal bivariate normal distribution in which darker shading indicates higher density, and 2) an animated plot showing the MCMC algorithm walking through the probability space.
}
\references{
Gelman, A., Carlin, J. B., Stern, H. S., and D. B. Rubin (2003)  \emph{Bayesian Data Analysis, 2nd edition}.  Chapman and Hall/CRC. 
}
\author{
Ken Aho
}
\keyword{graphs}

\name{see.rEffect.tck}
\alias{see.rEffect.tck}
\alias{r.eff}
\title{
Visualize random effects model
}
\description{
An experiment to ascertain the effect of two randomly selected brands of soil fertilizer 
on wheat yield.  In the upper figure two brands of fertilizer (1 and 2) 
are randomly chosen from a population of potential choices.  The mean yields produced by the 
population of fertilizers \eqn{E(Y|A_i)} are normally distributed.  That is, it is possible to 
select a factor level that will result in very small average yields, or one that will 
result in large average yields, but it is more likely that a chosen factor level will 
produce some intermediate average effect.  We proceed with the experiment by assigning two 
experimental units (two wheat fields) to each fertilizer.  We assume that the yield of 
fields is normally distributed for each fertilizer, and furthermore that the factor 
levels are homoscedastic. We weigh our evidence against the H\eqn{_0} of a non-zero population variance by estimating the 
variability among factor levels.  The more that yield varies with respect to nutrient treatments the more evidence we will have against H\eqn{_0}.  
}
\usage{
see.rEffect.tck()
}

\author{Ken Aho
}
\keyword{graphs}

\name{mosquito}
\alias{mosquito}
\docType{data}
\title{
Mosquito wing length data
}
\description{
Sokal and Rohlf (2012) describe an experiment to gauge the variability in wing length in female mosquitos (\emph{Aedes intrudens}).  
Four females were randomly selected from three cages and two measurements were made on the left wing of each female.  
Both cage and female (in cage) can be seen as random effects.  
}
\usage{data(mosquito)}
\format{
  A data frame with 24 observations on the following 4 variables.
  \describe{
    \item{\code{length}}{Wing length in micrometers}
    \item{\code{cage}}{Cage number.}
    \item{\code{female}}{Female (in cage) number}
    \item{\code{measures}}{Measurement (in female in cage) number, i.e. pseudoreplicates in female.}
    
  }
}

\source{
Sokal, R. R., and F. J. Rohlf (2012)  \emph{Biometry, 4th edition}.  W. H. Freeman and Co., New York. 
}
\keyword{datasets}

\name{fire}
\alias{fire}
\docType{data}
\title{
Fire data from Yellowstone National Park
}
\description{
Fires from 1988 constituted the largest conflagration in the history of Yellowstone National Park.  This dataframe lists burned areas for ten Yellowstone stream catchments (Robinson et al. 1994).   
}
\usage{data(fire)}
\format{
  A data frame with 10 observations on the following 2 variables.
  \describe{
    \item{\code{fire}}{Burn area in, in hectares\eqn{^2}.}
    \item{\code{stream}}{A factor with levels \code{Blacktail} \code{Cache} \code{EF.Blacktail} \code{Fairy} \code{Hellroaring} \code{Iron.Springs} \code{Pebble} \code{Rose} \code{SF.Cache} \code{Twin}}
  }
}

\source{
Robinson, C. T., Minshall, G. W., and S. R. Rushforth  (1994)  The effects of the 1988 
wildfires on diatom assemblages in the streams of Yellowstone National Park.  Technical Report NPS/NRYELL/NRTR-93/XX. 
}

\keyword{datasets}

\name{crabs}
\alias{crabs}
\docType{data}
\title{
Agresti crabs dataset
}
\description{
Horseshoe crab satellite counts as a function of crab phenotype.
}
\usage{data(crabs)}
\format{
  A data frame with 173 observations on the following 5 variables.
  \describe{
    \item{\code{color}}{A factor with levels \code{1} = light medium, \code{2} = medium, \code{3} = dark medium, \code{4} = dark.}
    \item{\code{spine}}{A factor with levels \code{1} = both good, \code{2} = one worn or broken, \code{3} = both worn or broken.}
    \item{\code{width}}{Crab carapace width in cm.}
    \item{\code{satell}}{Number of satellites.}
    \item{\code{weight}}{Crab weight in in kg.}
  }
}
\source{
Agresti, A.  (2012)  \emph{An Introduction to Categorical Data Analysis, 3rd edition}.  Wiley, New Jersey.
}
\references{
Brockman, H. J.  (1996) Satellite male groups in horseshoe crabs, \emph{Limulus polyphemus}.  \emph{Ethology} 102(1) 1-21.
}
\keyword{datasets}

\name{beetle}
\alias{beetle}
\docType{data}
\title{
Wood boring beetle data
}
\description{
Saint Germain et al. (2007) modeled the presence absence of a saprophytic wood boring beetle (\emph{Anthophylax attenuatus}) as a function of the wood density of twenty-four decaying aspen trees (\emph{Populus tremuloides}) in Western Quebec Canada.  
}
\usage{data(beetle)}
\format{
  A data frame with 24 observations on the following 4 variables.
  \describe{
    \item{\code{Snag}}{Snag identifier}
    \item{\code{Yrs.since.death}}{The number of years since death, determined using dendrochronological methods.}
    \item{\code{Wood.density}}{The density of the decaying wood (dry weight/volume) in units of g cm\eqn{-3}.}
    \item{\code{ANAT}}{Beetle presence/absence (1/0)}
  }
}
\source{
Saint-Germain, M., Drapeau, P., and C. Buddle  (2007)  Occurrence patterns of aspen-
feeding wood-borers (Coleoptera: Cerambycidae) along the wood decay
gradient: active selection for specific host types or neutral mechanisms? \emph{Ecological Entomology}  32: 712-721.
}
\keyword{datasets}

\name{bromus}
\alias{bromus}
\docType{data}
\title{Bromus tectorum dataset}
\description{
Cheatgrass (\emph{Bromus tectorum}) is an introduced annual graminoid that has invaded vast areas of sagebrush steppe in the intermountain west. Because it completes its vegetative growth stage relatively early in the summer, it leaves behind senescent biomass that burns easily.  As a result areas with cheatgrass often experience a greater frequency of summer fires. A number of dominant shrub species in sagebrush steppe are poorly adapted to fire.   As a result, frequent fires can change a community formerly dominated by shrubs to one dominated by cheatgrass.  Nitrogen can also have a strong net positive effect on the cheatgrass biomass.  A study was conducted at the Barton Road Long Term Experimental Research site (LTER) in Pocatello Idaho to simultaneously examine the effect of shrub removal and nitrogen addition on graminoid productivity.   
}
\usage{data(bromus)}
\format{
  The dataframe has 3 columns:
  \describe{
    \item{\code{Plot}}{Plot number.}
    \item{\code{Biomass}}{Grass biomass in grams per meter squared.} 
    \item{\code{Trt}}{Treatment.  \code{C} = Control, \code{LN} = Low nitrogen, \code{HN} = High Nitrogen, \code{SR} = Shrub removal.}
    }
}
\keyword{datasets}

\name{mcmc.norm.hier}
\alias{mcmc.norm.hier}
\alias{norm.hier.summary}

\title{
Gibbs sampling of normal hierarchical models
}
\description{
These functions are designed for Gibbs sampling comparison of groups with normal hierarchical models (see Gelman 2003), and for providing appropriate summaries.    
}
\usage{

mcmc.norm.hier(data, length = 1000, n.chains = 5)

norm.hier.summary(M, burn.in = 0.5, cred = 0.95, conv.log = TRUE)
}

\arguments{
  \item{data}{
A numerical matrix with groups in columns and observations in rows.
}
  \item{length}{
An integer specifying the length of MCMC chains.
}
  \item{n.chains}{
The number of chains to be computed for each parameter
}

  \item{M}{
An output array from \code{mcmc.norm.hier}.
}
  \item{burn.in}{
The burn in period for the chains.  The default value, 0.5, indicates that only the latter half of chains should be used for calculating summaries. 
}

  \item{cred}{
Credibility interval width. 
}

  \item{conv.log}{
A logical argument indicating whether convergence for \eqn{\sigma} and \eqn{\tau} should be considered on a log scale.
}
}
\details{
An important Bayesian application is the comparison of groups within a normal hierarchical model.  
We assume that the data from each group are independent and from normal populations with means 
\eqn{\theta[j]}, \eqn{j = (1,...,J)}, and a common variance, \eqn{\sigma^2}. We also assume that group means, 
are normally distributed with an unknown mean, \eqn{\mu}, and an unknown variance , \eqn{\tau^2}.  
A uniform prior distribution is assumed for \eqn{\mu, log\sigma} and \eqn{\tau}; \eqn{\sigma} is 
logged to facilitate conjugacy.  The function \code{mcmc.norm.hier} provides posterior distributions 
of \eqn{\theta[j]}'s, \eqn{\mu, \sigma} and \eqn{\tau}.  The distributions are derived from univariate 
conditional distributions from the multivariate likelihood function.  These conditional distributions 
provide a situation conducive to MCMC Gibbs sampling. Gelman et al. (2003) provide excellent summaries of these sorts of models.  

The function \code{mcmc.summary} provides statistical summaries for the output array from \code{mcmc.norm.hier} including credible intervals (empirically derived directly from chains) and the Gelman/Rubin convergence criterion, \eqn{\hat{R}}.
}
\value{
The function \code{mcmc.norm.hier} returns a three dimensional (step x variable x chain) array.  The function \code{mcmc.summary} returns a summary table containing credible intervals and the Gelman/Rubin convergence criterion, \eqn{\hat{R}}.
}
\references{
Gelman, A., Carlin, J. B., Stern, H. S., and D. B. Rubin (2003) \emph{Bayesian Data Analysis, 2nd edition}.  Chapman and Hall/CRC.
}
\author{
Ken Aho
}
\seealso{
\code{\link{R.hat}}
}
\examples{
\dontrun{
data(cuckoo)
mcmc.norm.hier(cuckoo,10,2)
}
}

\name{see.power}
\alias{see.power}
\alias{see.power.tck}

\title{
Interactive depiction of type I and type II error and power
}
\description{
Provides an interactive pedagogical display of power.
}
\usage{

see.power(alpha = NULL, sigma = NULL, n = NULL, effect = NULL,
test = "lower", xlim = c(-3, 3), strict = FALSE)

see.power.tck()
}

\arguments{

  \item{alpha}{Type I error.
}
  \item{sigma}{Standard deviation of underlying population.
}
  \item{n}{
sample size
}
  \item{effect}{
Effect size
}
  \item{test}{
Type of test, one of \code{c("lower","upper","two")}.
}
  \item{xlim}{
\emph{X}-axis limits
}

  \item{strict}{Causes the function to use a strict interpretation of power in a two-sided test.  If \code{strict = TRUE}
   then power for a two sided test will include the probability of rejection in the opposite tail of the true effect. If \code{strict = FALSE}
   (the default) power will be half the value of \eqn{\alpha} if the true effect size is zero.}
}
\details{
The function \code{see.power} provides an interactive display of power.  The function \code{see.power.tck} provides a \pkg{tcltk} GUI to manipulate \code{see.power}.
}

\author{Ken Aho
}

\keyword{graphs}

\name{concrete}
\alias{concrete}
\docType{data}
\title{Concrete strength dataset for data mining
}
\description{
The actual concrete compressive strength (MPa) for a given mixture under a 
specific age (days) was determined from laboratory assays. Data are in raw form (not scaled). 
}
\usage{data("concrete")}
\format{
  A data frame with 1030 observations on the following 9 variables.
  \describe{
    \item{\code{X1}}{kg of cement in a m\eqn{^3} mixture.}
    \item{\code{X2}}{kg of blast furnace slag in a m\eqn{^3} mixture.}
    \item{\code{X3}}{kg of fly ash in a m\eqn{^3} mixture.}
    \item{\code{X4}}{kg of water in a m\eqn{^3} mixture.}
    \item{\code{X5}}{kg of superplasticizer in a m\eqn{^3} mixture.}
    \item{\code{X6}}{kg of coarse aggregate in a m\eqn{^3} mixture.}
    \item{\code{X7}}{kg of fine aggregate in a m\eqn{^3} mixture.}
    \item{\code{X8}}{Age: day(1-365), a numeric vector}
    \item{\code{Y}}{Concrete compressive strength in MPa, a numeric vector}
  }
}
\details{
The order of variables corresponds to the order in the original data. 
}
\source{
%%  ~~ reference to a publication or URL from which the data were obtained ~~
  Prof. I-Cheng Yeh
  Department of Information Management 
  Chung-Hua University, 
  Hsin Chu, Taiwan 30067, R.O.C.
  e-mail:icyeh@chu.edu.tw
  TEL:886-3-5186511
}
\references{
Past Usage: 

Primary

I-Cheng, Y. (1998) Modeling of strength of high performance concrete using artificial 
neural networks. \emph{Cement and Concrete Research}, 28(12): 1797-1808 .

Others

I-Cheng. Y. (1998) Modeling concrete strength with augment-neuron networks. \emph{J. of 
Materials in Civil Engineering, ASCE} 10(4): 263-268.

I-Cheng, Y.  (1999) Design of high performance concrete mixture using neural networks.  
\emph{J. of Computing in Civil Engineering, ASCE} 13 (1): 36-42.

I-Cheng, Y. (2003) Prediction of Strength of Fly Ash and Slag Concrete By The Use of 
Artificial Neural Networks.  \emph{Journal of the Chinese Institute of Civil and Hydraulic 
Engineering} Vol. 15, No. 4, pp. 659-663 (2003).

I-Cheng, Y. (2003) A mix Proportioning Methodology for Fly Ash and Slag Concrete Using 
artificial neural networks.  \emph{Chung Hua Journal of Science and Engineering} 1(1): 77-84.

I-Cheng, Y. (2006). Analysis of strength of concrete using design of experiments and 
neural networks. \emph{Journal of Materials in Civil Engineering, ASCE}  18(4): 597-604.

Acknowledgements, Copyright Information, and Availability:

NOTE: Reuse of this database is unlimited with retention of copyright notice for 
Prof. I-Cheng Yeh.
}

\keyword{datasets}

\name{panel.cor.res}
\alias{panel.cor.res}
\alias{panel.lm}
\title{Functions for customizing correlation matrices}
\description{
The functions here can be used to customize upper and lower triangles in 
correlation matrices.  In particular \code{panel.cor.res} provides correlation 
coefficients (any alternative from \code{\link{cor}} can be used) and \emph{p}-values for correlation 
tests.  The function \code{panel.lm} puts linear fitted lines from simple linear 
regression in scatterplots.  Note that the function \code{\link{panel.smooth}} provides a 
smoother fit.
}
\usage{
panel.cor.res(x, y, digits = 2, meth = "pearson", cex.cor=1)
panel.lm(x, y, col = par("col"), bg = NA, pch = par("pch"), cex = 1,
col.line = 2,lty = par("lty"))
}
\arguments{
  \item{x}{variable 1 in  correlation}
  \item{y}{variable 2 in correlation}
  \item{digits}{number of digits in text for \code{panel.cor.res}}
  \item{meth}{type of correlation coefficient from \code{panel.cor.res}, one of \code{"pearson"}, \code{"spearman"}, \code{"kendall"}}
  \item{cex.cor}{size of text in \code{panel.lm}}
  \item{col}{color of points in \code{panel.lm}}
  \item{bg}{background color of points in \code{panel.lm}}
  \item{pch}{type of symbols for points in \code{panel.lm}}
  \item{cex}{symbol size in \code{panel.lm}}
  \item{lty}{line type in \code{panel.lm}}
  \item{col.line}{color of lines in \code{panel.lm}}
}
\author{Ken Aho}
\seealso{\code{\link{cor}}, \code{\link{cor.test}}, \code{\link{panel.smooth}}}
\examples{
data(asthma)

pairs(asthma, cex.labels=1, cex=.95, gap=.1, lower.panel = panel.cor.res,
upper.panel = panel.lm)
}
\keyword{graphs}
\keyword{htest}

\name{magnets}
\alias{magnets}
\docType{data}
\title{Magnet pain relief data}
\description{
Magnets have long been used as an alternative medicine, particularly in the Far East, for speeding the recovery of broken bones and to aid in pain relief.  
Vallbona et al. (1997) tested whether chronic pain experienced by post-polio patients could be treated with magnetic fields applied directly to pain trigger points.  
The investigators identified fifty subjects who not only had post-polio syndrome, but who also experienced muscular or arthritic pain.  
Magnets were applied to pain trigger points in 29 randomly selected subjects, and in the other 21 a placebo was applied.  
The patients were asked to subjectively rate pain on a scale from one to ten before and after application of the magnet or placebo.

}
\usage{data(magnets)}
\format{
The dataframe contains 4 columns
\describe{
\item{\code{Score_1}}{Reported pain level before application of treatment.}   
\item{\code{Score_2}}{Reported pain level after application of treatment.}         
\item{\code{Active}}{Categorical variable indicating whether the device applied was active (magnet) or inactive (placebo).}        
  }
}
\source{Vallbona, C. et al  (1997)  Response of pain to static magnetic fields in post-polio patients, 
a double blind pilot study. \emph{Archives of Physical Medicine and Rehabilitation}.  78: 1200-1203.
}
\keyword{datasets}

\name{joint.ci.bonf}
\alias{joint.ci.bonf}
\title{Calculates joint confidence intervals for parameters in linear models using a Bonferroni procedure.}
\description{Creates widened confidence intervals to allow joint consideration of parameter confidence intervals.
}
\usage{

joint.ci.bonf(model, conf = 0.95)
}
\arguments{

  \item{model}{A linear model created by \code{\link{lm}}}
  \item{conf}{level of confidence 1 - \emph{P}(type I error)}
}
\details{
As with all Bonferroni-based methods for joint confidence the resulting intervals 
are exceedingly conservative and thus are prone to type II error.
}
\value{Returns a dataframe with the upper and lower confidence bounds for each parameter in a linear model.
}
\references{Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li. (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.}
\author{Ken Aho}
\seealso{\code{\link{confint}}, \code{\link{p.adjust}}}
\examples{
Soil.C<-c(13,20,10,11,2,25,30,25,23)
Soil.N<-c(1.2,2,1.5,1,0.3,2,3,2.7,2.5)
Slope<-c(15,14,16,12,10,18,25,24,20)
Aspect<-c(45,120,100,56,5,20,5,15,15)
Y<-as.vector(c(20,30,10,15,5,45,60,55,45))
model<-lm(Y~Soil.C+Soil.N+Slope+Aspect)
joint.ci.bonf(model)
}
\keyword{univar}
\keyword{htest}

\name{anm.samp.design}
\alias{anm.samp.design}
\alias{samp.design}
\alias{anm.samp.design.tck}
\title{Animated demonstration of randomized sampling designs}
\description{
Animated Comparisons of outcomes from simple random sampling, stratified random sampling and cluster sampling.
}
\usage{
anm.samp.design(n=20, interval = 0.5 ,iter = 30, main = "", lwd = 2, lcol = 2)

samp.design(n = 20, main = "", lwd = 2, lcol = 2)

anm.samp.design.tck()
}
\arguments{

  \item{n}{The number of samples to be randomly selected from a population of 400.}
  \item{interval}{Time length spent on each frame in animation (in seconds).}
  \item{iter}{Number of random iterations in animation.}
  \item{main}{Main heading.}
  \item{lwd}{Line width to distinguish strata in stratified and cluster designs.}
  \item{lcol}{Line width to distinguish strata in stratified and cluster designs.}
}
\details{
Returns a plot comparing outcomes of random sampling, stratified random sampling and cluster sampling from a population
of size 400.  For stratified random sampling the population is subdivided into four equally strata of size 100.
and \code{n}/4 samples are taken within each strata.  For cluster sampling the population is subdivided into four
equally sized clusters and a census is taken from two clusters (regardless of specification of \code{n}).   The function \code{anm.samp.design} depicts random sampling using animation}
\value{
A plot is returned with four subplots.  (a) shows the population before sampling, (b) shows simple random sampling, (c) shows stratified random sampling, (d) shows cluster sampling.  The function \code{anm.samp.design.tck} provides interactivity with a \pkg{tcltk} GUI.
}
\author{Ken Aho}
\examples{
samp.design(20)

#Animated demonstration
\dontrun{anm.samp.design(20)}
}
\keyword{design}
\keyword{graphs}

\name{cuckoo}
\alias{cuckoo}
\docType{data}
\title{
Tippett cuckoo egg data}
\description{
Part of a dataset detailing cuckoo egg lengths found in other birds nests.  Units are millimeters
}
\usage{data(cuckoo)}
\format{
  A data frame with 16 observations on the following 3 variables.
  \describe{
    \item{\code{TP}}{Tree pipit}
    \item{\code{HS}}{Hedge sparrow}
    \item{\code{RB}}{Robin}
  }
}
\source{
Tippett, L. H. C. (1952) \emph{The Methods of Statistics, 4th Edition}.  Wiley.
}
\keyword{datasets}

\name{veneer}
\alias{veneer}
\docType{data}
\title{
Veneer data from Littell et al. (2002)
}
\description{
Four examples of each of five brands of a synthetic wool veneer material were subjected to a friction test and a measure of wear was determined for each experimental unit. 
}
\usage{data(veneer)}
\format{
  A data frame with 20 observations on the following 2 variables.
  \describe{
    \item{\code{wear}}{a numeric vector}
    \item{\code{brand}}{a factor with levels \code{ACME} \code{AJAX} \code{CHAMP} \code{TUFFY} \code{XTRA}}
  }
}
\source{
Littell, R. C., Stroup, W. W., and R. J. Freund (2002)  \emph{SAS for Linear Models}.  John 
Wiley and Associates. }
\keyword{datasets}

\name{deer.296}
\alias{deer.296}
\title{
Mule deer telemetry data
}
\description{
Telemetry data for mule deer #296 from the Starkey Experimental Forest in Northeastern Oregon.  Data are high resolution (10 minute) radio collar readings from 8/20/2008 to 11/6/2008.  Also included are data for nearest neighbor locations of forest/grassland boundaries.
}
\usage{data(deer.296)}
\format{
  A data frame with 5423 observations on the following 7 variables.
  \describe{
    \item{\code{Time}}{Unit of time measurement used at the Starkey Experimental Forest}
    \item{\code{X}}{Mule Deer \emph{X}-coordinate, UTM Easting}
    \item{\code{Y}}{Mule Deer \emph{Y}-coordinate, UTM Northing}
    \item{\code{NEAR_X}}{Nearest boundary location \emph{X} coordinate}
    \item{\code{NEAR_Y}}{Nearest boundary location \emph{Y} coordinate}
    \item{\code{Hab_Type}}{Type of habitat}
    \item{\code{NEAR_ANGLE}}{A numeric vector containing the angle of azimuth to the nearest point on the boundary with respect to a four quadrant system.  NE = \eqn{0^{\circ}} to \eqn{90^{\circ}}, NW is > \eqn{90^{\circ}} and \eqn{\le 180^{\circ}}, SE is < \eqn{0^{\circ}} and \eqn{\le -90^{\circ}} is > \eqn{-90^{\circ}} and \eqn{\le -180^{\circ}}.}
  }
}
\keyword{datasets}

\name{best.agreement}
\alias{best.agreement}
\alias{print.max_agree}

\title{
Determine agreement of two classifications
}
\description{
Distinct classifications will have class labels that may prevent straightforward comparisons.  This algorithm considers all possible permutations of class labels to find a configuration that maximizes agreement on the diagonal of a contingency table comparing two classifications.  Classifications need not have the same number of classes.
}
\usage{

best.agreement(class1, class2, test = FALSE, rperm = 100)
}


\arguments{

  \item{class1}{A vector containing class assignments to observations, e.g., a result from \code{\link{cutree}}}
  \item{class2}{A vector containing class assignments for a second classification}
  \item{test}{Logical.  Indicates whether or not the null hypothesis, that agreement between \code{class1} and \code{class2} is no better than random, will be run. }
  \item{rperm}{If \code{test = TRUE}, the number of random permutations used in null hypothesis testing.}
}
\details{
Class assignments are fixed in \code{class1}, all possible permutations of class labels in \code{class2} are considered to find a configuration that maximizes agreement in the two classifications.  If \code{test=TRUE}, a permutation test is run for the null hypothesis that maximum agreement between classifications is no better than random.  This is done by sampling without replacement \code{rperm} times from \code{class2}, finding maximum agreement between \code{class1} and the randomly permuted classifications, and dividing one plus the number of times that maximum agreement between the random classifications and \code{class1} was greater than the maximum agreement observed for \code{class1} and \code{class2}.  Testing can be slow because it will be based on nested loops with \eqn{p x c!} steps, where \emph{p} is \code{nperm} and \emph{c!} is the number of combinatorial permutations possible for categories in \code{class2}. 
}
\value{A object of class \code{max_agree}.
\item{n.possible.perms}{Number of permutations considered}
\item{n.max.solutions}{Number of configurations in which classification agreement is maximized.  The first configuration identified is reported in \code{max.class.names1} and \code{max.class.names2}.}
\item{max.agree}{Proportion of observations assigned to the same cluster}
\item{max.class.names1}{Class labels in the first classification that allow maximum agreement.}
\item{max.class.names2}{Class labels in the second classification that allow maximum agreement.}
\item{test}{Whether or not test was run.}
\item{p.val}{If \code{test = TRUE}, the \emph{p}-value for the null hypothesis test described in Details above.}
}
\author{Ken Aho.  The internal \code{permutations} algorithm for obtaining all possible permutations was provided by Benjamin Christoffersen on \emph{stackoverflow}.}

\seealso{
 \code{\link{cutree}}, \code{\link{hclust}}
}
\examples{

# Example comparing a 4 cluster average-linkage solution 
# and a 5 cluster Ward-linakage solution 

avg <- hclust(dist(USArrests), "ave")
avg.4 <- as.matrix(cutree(avg, k = 4))
war <- hclust(dist(USArrests), "ward.D")
war.5 <- as.matrix(cutree(war, k = 5))

ba <- best.agreement(avg.4, war.5, test = TRUE)
ba
}

\name{suess}
\alias{suess}
\docType{data}
\title{
del14C in the atmosphere from 1700-1950
}
\description{
Six reservoir model prediction of the \eqn{\delta^14}C in the atmosphere from approximately 1700-1950 as provided by Bacastow and Keeling (1973).  
}
\usage{data("suess")}
\format{
  A data frame with 149 observations on the following 3 variables.
  \describe{
    \item{\code{Year}}{Year}
    \item{\code{del14C}}{Levels of \eqn{\delta^14}C}
    \item{\code{Source}}{Sources used by Bacastow et al. (1973). lermanN = Northern Hemisphere measures from Lerman (1970), lermanS = Southern Hemisphere measures from Lerman (1970), suess = Northern Hemisphere measures from Suess (1955, 1965), stuiver = Northern Hemisphere measures from Stuiver (1963).}
  }
}
\source{
Bacastow, R., Keeling, C. D., Woodwell, G. M., & Pecan, E. V. (1973). Atmospheric carbon dioxide and radiocarbon in the natural carbon cycle. II. Changes from AD 1700 to 2070 as deduced from a geochemical model (No. CONF-720510--). Univ. of California, San Diego, La Jolla; Brookhaven National Lab., Upton, NY (USA).
}
\references{
Secondary sources used by Bacastow et al. (1973):

Lerman, J. C., Mook, W. G., & Vogel, J. C. (1970). C14 in tree rings from different localities. In \emph{Radiocarbon Variations and Absolute Chronology}. Proceedings, XII Nobel Symposium. New York: Wiley. p (pp. 275-301).

Stuiver, M. (1963). Yale natural radiocarbon measurements IX. \emph{Radiocarbon}, 11, 545-658.

Suess, H. E. (1965). Secular variations of the cosmic-ray-produced carbon 14 in the atmosphere and their interpretations. \emph{Journal of Geophysical Research}, 70(23), 5937-5952.

Suess, H. E. (1955). Radiocarbon concentration in modern wood. \emph{Science}, 122(3166), 415-417.

}

\examples{
data(suess)
with(suess, plot(Year, del14C, col = Source, pch = as.numeric(Source)))
with(suess, legend("topright", legend = levels(Source), col = 1:4, pch = 1:4))
lines(lowess(suess$Year, suess$del14C, f = .25), lwd = 2)
}


\keyword{datasets}

\name{see.M}
\alias{see.M}
\title{Visualization of the M-estimation function
}
\description{
The function provides interactive visualization of robust \emph{M} estimation of location.  
}
\usage{
see.M()
}
\details{
The value \emph{c} = 1.28 gives 95 percent efficiency of the mean given normality.  The sample median and mean can be considered special cases of \emph{M}-estimators.  The value \emph{c} = 0 provides the sample median, while the value, \eqn{c = \infty} gives the sample mean.
}

\references{
Wilcox, R. R. (2005)  \emph{Introduction to Robust Estimation and Hypothesis Testing, Second 
Edition}.  Elsevier, Burlington, MA.
}
\author{
Ken Aho
}
\seealso{
\code{\link{huber.mu}}, \code{\link{huber.NR}}
}
\keyword{graphs}

\name{Kappa}
\alias{Kappa}
\title{Calculates kappa statistic and other classification error statistics}
\description{
The kappa statistic, along with user and producer error rates are conventionally 
used in the remote sensing to describe the effectiveness of ground cover 
classifications.  Since it simultaneously considers both errors of commission 
and omission, kappa can be considered a more conservative measure of 
classification accuracy than the percentage of correctly classified items.
 
}
\usage{
Kappa(class1, reference)
}
\arguments{
  \item{class1}{A vector describing a classification of experimental units.}
  \item{reference}{A vector describing the "correct" classification of the experimental units in \code{class1}}
}
\value{Returns a list with 4 items 
  \item{ttl_agreement}{The percentage of correctly classified items.}
  \item{user_accuracy}{The user accuracy for each category of the classification.}
  \item{producer_accuracy}{The producer accuracy for each category of the classification.}
  \item{kappa}{The kappa statistic.}
  \item{table}{A two way contingency table comparing the user supplied classification to the reference classification.}
}
\references{Jensen, J. R.  (1996)  \emph{Introductory digital imagery processing 2nd edition}.  Prentice-Hall.}
\author{Ken Aho}
\examples{
reference<-c("hi","low","low","hi","low","med","med")
class1<-c("hi","hi","low","hi","med","med","med")
Kappa(class1,reference)
}
\keyword{multivariate}

\name{chi.plot}
\alias{chi.plot}
\title{Chi plots for diagnosing multivariate independence.}
\description{
Chi-plots (Fisher and Switzer 1983, 2001) provide a method to diagnose multivariate 
non-independence among \emph{Y} variables.
}
\usage{chi.plot(Y1, Y2, ...)
}
\arguments{
  \item{Y1}{A \emph{Y} variable of interest.  Must be quantitative vector.}
  \item{Y2}{A second \emph{Y} variable of interest.  Must also be a quantitative vector.}
  \item{\dots}{Additional arguments from \code{\link{plot}}.} 
}
\details{The method relies on calculating all possible pairwise differences within \bold{y}\eqn{_1} and within \bold{y}\eqn{_2}. Let pairwise differences associated with the first observation in \bold{y}\eqn{_1} that are greater than zero be transformed to ones and all other differences be zeros.  Take the sum of the transformed values, and let this sum divided by (1 - \emph{n}) be be the first element in the 1 x \emph{n} vector \bold{z}.
Find the rest of the elements (2,..,\emph{n}) in \bold{z} using the same process. 

Perform the same transformation for the pairwise differences associated with the first observation in \bold{y}\eqn{_2}.  Let pairwise differences associated with the first observation in \bold{y}\eqn{_2} that are greater than zero be transformed to ones and all other differences be zeros.  Take the sum of the transformed values, and let this sum divided by (1 - \emph{n}) be be the first element in the 1 x \emph{n} vector \bold{g}.
Find the rest of the elements (2,..,\emph{n}) in \bold{g} using the same process. 

Let pairwise differences associated with the first observation in \bold{y}\eqn{_1} and the first observation in \eqn{\bold{y}_2} that are both greater than zero be transformed to ones and all other differences be zeros. Take the sum of the transformed values, and let this sum divided by (1 - \emph{n}) be be the first element in the 1 x \emph{n} vector \bold{h}.  Find the rest of the elements (2,..,\emph{n}) in \bold{h} using the same process.  We let:
      
\deqn{S = sign((\bold{z} - 0.5)(\bold{g} - 0.5))}{%
S = sign((z - 0.5)(g - 0.5))}
\deqn{\chi =(\bold{h} - \bold{z} \times \bold{g})/\sqrt{\bold{z} \times (1 - \bold{z}) \times \bold{g} \times (1 - \bold{g})}}{%
chi = (h - z x g)/sqrt(z) x (1 - z) x g x (1 - g)}
\deqn{\lambda = 4 \times S \times max[(\bold{z} - 0.5)^2,(\bold{g} - 0.5)^2]}{\lambda = 4 x S x max[(z - 0.5)^2,(g - 0.5)^2]}

We plot the resulting paired \eqn{\chi} and \eqn{\lambda} values for values of \eqn{\lambda} less than \eqn{4(1/(n - 1) - 0.5)^2}.  Values outside of \eqn{\frac{1.78}{\sqrt{n}}} can be considered non-independent. 
}

\value{
Returns a chi-plot.
}

\references{
Everitt, B.  (2006)  \emph{R and S-plus Companion to Multivariate Analysis}.  Springer.

Fisher, N. I, and Switzer, P. (1985)  Chi-plots for assessing dependence.  \emph{Biometrika}, 72: 
253-265.

Fisher, N. I., and Switzer, P.  (2001)  Graphical assessment of dependence: is a picture worth 100 tests?  
\emph{The American Statistician}, 55: 233-239.
}
\author{Ken Aho and Tom Taverner (Tom provided modified original code to eliminate looping)}
\seealso{\code{\link{bv.boxplot}}}
\examples{
Y1<-rnorm(100, 15, 2)
Y2<-rnorm(100, 18, 3.2)
chi.plot(Y1, Y2)
}
\keyword{graphs}
\keyword{multivariate}

\name{qq.Plot}
\alias{qq.Plot}

\title{
Normal quantile plots for single or multiple factor levels
}
\description{
Provides quantile plots for one or more factor levels overlaid on a single graph.  If \code{plot.CI = TRUE}, then
code for bootstrapped confidence provided in the documentation for \code{\link[boot]{boot}} is applied to create confidence envelopes. If \code{plot.CI = FALSE}, \code{\link{qqnorm}} and \code{\link{qqline}} are used to create overlaid normal probability plots given multiple categories in \code{x}.
}

\usage{

qq.Plot(y, x = NULL, col = NULL, pch = NULL, main = "", R = 5000, fit.lty = 1,
env.lty = 2, conf = 0.95, type = "point", ylim = NULL, xlim = NULL, xlab = NULL,
ylab = NULL, plot.CI = FALSE, standy = TRUE, ...)
}

\arguments{

\item{y}{
The response variable
}
  \item{x}{
A categorical variable to subset \emph{y}
}
  \item{col}{
A scalar or vector with length equivalent to the number of levels in \emph{x}, describing colors of points and lines for levels in \emph{x}.
}
  \item{pch}{
A scalar or vector with length equivalent to the number of levels in \emph{x}, describing symbols for levels in \emph{x}.
}
  \item{main}{
Main title.
}
  \item{R}{
Number of bootstrap samples for calculating confidence envelopes
}
  \item{fit.lty}{
Line type for fit line(s).
}
  \item{env.lty}{
Line type for fit line(s).
}
  \item{conf}{
Level of confidence in confidence envelopes.
}
  \item{type}{
Type of bootstrapped confidence envelope.  One of \code{"point"} or \code{"overall"}.
}
  \item{xlim}{
A two element vector defining the lower and upper \emph{x}-axis limits .
}
  \item{ylim}{
A two element vector defining the lower and upper \emph{y}-axis limits .
}
  \item{xlab}{
\emph{X}-axis label.
}
  \item{ylab}{
\emph{Y}-axis label.
}
  \item{plot.CI}{
Logical, specifying whether or not confidence ellipses should be plotted.
}
  \item{standy}{
Logical, specifying if observations should be standardized.
}
  \item{\dots}{
Other arguments from \code{\link{plot}}.
}
}

\author{
Ken Aho
}

\seealso{
\code{\link{qqnorm}}, \code{\link{qqline}},  \code{\link[boot]{envelope}}, \code{\link[boot]{boot}}
}
\examples{
y <- rnorm(50)
x <- c(rep(1, 25), rep(2, 25))
qq.Plot(y, x)
}

\name{MS.test}
\alias{MS.test}
\title{Mack-Skillings test}
\description{Runs a Mack-Skillings test for situations applicable to rank-based permutation procedures with blocking and more than one replicate for treatments in a block.
}
\usage{
MS.test(Y, X, reps)
}
\arguments{

  \item{Y}{A matrix of response data. The \code{MS.test} function requires that response data are organized in columns (see example below).}
  \item{X}{A vector of treatments.  The length of the vector should be equal to the number of rows in the response matrix.}
  \item{reps}{The number of replicates in each treatment (unbalanced designs cannot be analyzed).}
}
\details{
When we have more than one replication within a block, and the number of replications is equal for all treatments, we can use the Mack-Skillings test (Mack and Skillings 1980) as a rank based permutation procedure to test for main effect differences.  If ties occur the value of the significance level is only approximate.  Hollander and Wolfe (1996) provide a method for finding exact \emph{P}-values by deriving a test statistic distribution allowing ties.  
}
\value{Returns a dataframe summarizing the degrees of freedom, test statistic and \emph{p}-value.
}
\references{
Campbell, J. A., and O. Pelletier (1962)  Determination of niacin (niacinamide) in cereal 
products.  \emph{J. Assoc.  Offic. Anal.  Chem.}  45: 449-453. 


Hollander, M., and  D. A. Wolfe (1999) \emph{Nonparametric Statistical Methods}. New York: John Wiley & Sons. 


Mack, G. A., and J. H. Skillings (1980)  A Friedman-type rank test for main effects in a 
two-factor ANOVA.  \emph{Journal of the American Statistical Association}.  75: 947-951.
}
\author{Ken Aho}

\seealso{\code{\link{friedman.test}}}
\examples{
#data from Campbell and Pelletier (1962) 
Niacin0<-c(7.58,7.87,7.71,8.00,8.27,8,7.6,7.3,7.82,8.03,7.35,7.66)
Niacin4<-c(11.63,11.87,11.40,12.20,11.70,11.80,11.04,11.50,11.49,11.50,10.10,11.70)
Niacin8<-c(15.00,15.92,15.58,16.60,16.40,15.90,15.87,15.91,16.28,15.10,14.80,15.70)
Niacin<-cbind(Niacin0,Niacin4,Niacin8)
lab<-c(rep(1,3),rep(2,3),rep(3,3),rep(4,3))
MS.test(Niacin, lab, reps=3)
}

\keyword{htest}
\keyword{univar}

\name{frog}
\alias{frog}
\docType{data}
\title{Australian frog calls following fire
}
\description{
Driscoll and Roberts (1997) examined the impact of fire on the Walpole frog (\emph{Geocrinia lutea}) in catchments in Western Australia by counting the number of calling males in six paired burn and control sites for three years following spring burning in 1991. 
}
\usage{data(frog)}

\format{
  A data frame with 18 observations on the following 3 variables.
  \describe{
    \item{\code{catchment}}{A factor with levels \code{angove} \code{logging} \code{newpipe} \code{newquinE} \code{newquinW} \code{oldquinE}.}
    \item{\code{frogs}}{The difference in the number of male frog calls for control - burned sites.}
    \item{\code{year}}{Year.}
  }
}
\source{
Quinn, G. P., and M. J. Keough (2002) \emph{Experimental Design and Data Analysis for Biologists}. Cambridge University Press.
}
\references{
Driscoll, D. A., and J. D. Roberts. 1997. Impact of fuel-reduction burning on the frog Geocrinia lutea in southwest Western Australia. \emph{Australian Journal of Ecology} 22:334-339.
}
\keyword{datasets}

\name{ci.mu.z}
\alias{ci.mu.z}
\alias{ci.mu.t}
\alias{print.ci}
\title{Z and t confidence intervals for mu.}
\description{
These functions calculate \emph{t} and \emph{z} confidence intervals for \eqn{\mu}. \emph{Z} confidence intervals require specification (and thus knowledge) of \eqn{\sigma}. Both methods assume underlying normal distributions although this assumption becomes irrelevant for large sample sizes. Finite population corrections are provided if requested.
}
\usage{

ci.mu.z(data, conf = 0.95, sigma = 1, summarized = FALSE, xbar = NULL,
fpc = FALSE, N = NULL, n = NULL, na.rm = FALSE)

ci.mu.t(data, conf = 0.95, summarized = FALSE, xbar = NULL, sd = NULL, 
fpc = FALSE, N = NULL, n = NULL, na.rm = FALSE)
}
\arguments{
  \item{data}{A vector of quantitative data.  Required if \code{summarized = FALSE}}
  \item{conf}{Confidence level; 1 - \emph{P}(type I error).}
  \item{sigma}{The population standard deviation.}
  \item{summarized}{A logical statement specifying whether statistical summaries are to be used.  If \code{summarized = FALSE}, then the sample mean and the sample standard deviation (\code{t.conf} only) are calculated from the vector provided in \code{data}.  If \code{summarized = FALSE} then the sample mean \code{xbar}, the sample size \code{n}, and, in the case of \code{ci.mu.t},  the sample standard deviation \code{st.dev}, must be provided by the user.}
  \item{xbar}{The sample mean.  Required if \code{summarized = TRUE}.}
  \item{fpc}{A logical statement specifying whether a finite population correction should be made.  If \code{fpc = TRUE} the population size \code{N} must be specified.}
  \item{N}{The population size.  Required if \code{fpc=TRUE}}
  \item{sd}{The sample standard deviation.  Required if \code{summarized=TRUE}.}
  \item{n}{The sample size.  Required if \code{summarized = TRUE}.}
  \item{na.rm}{Logical, indicate whether \code{NA} values should be stripped before the computation proceeds.}
}
\details{\code{ci.mu.z} and \code{ci.mu.t} calculate confidence intervals for either summarized data or a 
dataset provided in \code{data}.  Finite population corrections are made if a user specifies \code{fpc=TRUE} and 
provides some value for \code{N}.} 

\value{Returns a list of \code{class = "ci"}.  Default printed results are the parameter estimate and confidence bounds.  Other \code{invisible} objects include:
  \item{Margin}{the confidence margin.}
}
\references{Lohr, S. L. (1999)  \emph{Sampling: Design and Analysis}.  Duxbury Press.  Pacific Grove, USA.}
\author{Ken Aho}
\seealso{\code{\link{pnorm}}, \code{\link{pt}}}
\examples{
#With summarized=FALSE 
x<-c(5,10,5,20,30,15,20,25,0,5,10,5,7,10,20,40,30,40,10,5,0,0,3,20,30)
ci.mu.z(x,conf=.95,sigma=4,summarized=FALSE)
ci.mu.t(x,conf=.95,summarized=FALSE)
#With summarized = TRUE
ci.mu.z(x,conf=.95,sigma=4,xbar=14.6,n=25,summarized=TRUE)
ci.mu.t(x,conf=.95,sd=4,xbar=14.6,n=25,summarized=TRUE)
#with finite population correction and summarized = TRUE
ci.mu.z(x,conf=.95,sigma=4,xbar=14.6,n=25,summarized=TRUE,fpc=TRUE,N=100)
ci.mu.t(x,conf=.95,sd=4,xbar=14.6,n=25,summarized=TRUE,fpc=TRUE,N=100)
}
\keyword{univar}
\keyword{htest}

\name{world.pop}
\alias{world.pop}
\docType{data}
\title{Population levels in various countries from 1980-2006}
\description{
Population levels of 13 countries from 1980-2006.  Population numbers are rounded to the nearest 100,000.  More up-to-date data can be found in this package at \code{\link{world.emissions}}
}
\usage{data(world.pop)}
\format{
The dataframe contains 14 columns
\describe{
\item{\code{Year}}{The year of population measurements (1980-2006)}   
\item{\code{Afghanistan}}{Population in Afghanistan from 1980-2006, rounded to the nearest 100,000.}         
\item{\code{Brazil}}{Population in Brazil...}
\item{\code{Canada}}{Population in Canada...}
\item{\code{China}}{Population in China...}
\item{\code{Finland}}{Population in Finland...}
\item{\code{Italy}}{Population in Italy...}        
\item{\code{Japan}}{Population in Japan...}
\item{\code{Kenya}}{Population in Kenya...}
\item{\code{Mexico}}{Population in Mexico...}        
\item{\code{Saudi.Arabia}}{Population in Saudi Arabia...}
\item{\code{United.Arab.Emirates}}{Population in the United Arab Emirates...}
\item{\code{United.States}}{Population in United States...}
\item{\code{World.Total}}{Population totals for the world...}
  }
}

\source{
US census bureau: \url{https://www.census.gov/programs-surveys/international-programs/about/idb.html}
}
\keyword{datasets}

\name{rat}
\alias{rat}
\docType{data}
\title{
Rat glycogen data from Sokal and Rohlf (2012)
}
\description{
This dataset from Sokal and Rohlf (2012) can be used to demonstrate pseudoreplication. Six rats were randomly given one of three treatments: "control", "compound 217", and "compound 217 + sugar".  After a short period of time the rats were euthanized and the glycogen content of their livers was measured.  Two glycogen measurements were made for three different preparations of each liver.  Clearly the liver preparations and measurements on those preparations are nested in each rat, and are not independent. 
}
\usage{data(rat)}
\format{
  A data frame with 36 observations on the following 4 variables.
  \describe{
    \item{\code{glycogen}}{A numeric vector describing glycogen levels.  Units are arbitrary.}
    \item{\code{diet}}{Nutritional compound: 1 = "control", 2 = "compound 217", 3 = "compound 217 + sugar".}
    \item{\code{rat}}{Rat animal number.}
    \item{\code{liver}}{Liver preparation.}
    \item{\code{measure}}{Measurement number.}
  }
}
\source{
Sokal, R. R., and Rohlf, F. J. (2012)  \emph{Biometry, 4th edition}.  W. H. Freeman and Co., New York. 
}
\keyword{datasets}

\name{partial.R2}
\alias{partial.R2}
\title{Partial correlations of determination in multiple regression}
\description{
Calculates the partial correlation of determination for a variable of interest in a multiple regression.  
}
\usage{

partial.R2(nested.lm, ref.lm)
}
\arguments{
  \item{nested.lm}{A linear model without the variable of interest.}
  \item{ref.lm}{A linear model with the variable of interest.}
  }
\details{
Coefficients of partial determination measure the proportional reduction in sums of squares after a variable of interest, \emph{X}, is introduced into a model.  We can see how this would be of interest in a multiple regression.  
}
\value{
The partial \eqn{R^2} is returned.
}
\references{
Kutner, M. H., Nachtsheim, C. J., Neter, J., and W. Li. (2005)  \emph{Applied Linear Statistical Models, 5th edition}.  McGraw-Hill, Boston.

}
\author{Ken Aho}
\seealso{\code{\link{cor}}, \code{\link{partial.resid.plot}}}
\examples{
Soil.C<-c(13,20,10,11,2,25,30,25,23)
Soil.N<-c(1.2,2,1.5,1,0.3,2,3,2.7,2.5)
Slope<-c(15,14,16,12,10,18,25,24,20)
Aspect<-c(45,120,100,56,5,20,5,15,15)
Y<-as.vector(c(20,30,10,15,5,45,60,55,45))

lm.with<-lm(Y~Soil.C+Soil.N+Slope+Aspect)
lm.without<-update(lm.with, ~. - Soil.N)

partial.R2(lm.without,lm.with)
}

\name{depression}
\alias{depression}
\docType{data}
\title{
Hamilton depression scores before and after drug treatment 
}
\description{
Hollander and Wolfe (1999) presented Hamilton depression scale factor measurements for 
9 patients with mixed anxiety and depression.  Measurements were taken at a time preceding administration of tranquilizer, and a time after tranquilizer administration. 
}
\usage{data(depression)}
\format{
  A data frame with 18 observations on the following 3 variables.
  \describe{
    \item{\code{subject}}{Experimental subject.}
    \item{\code{scale}}{Hamilton depression scale score.  0-7 is considered to be normal. Scores of 20 or higher indicate moderate to very severe depression}
    \item{\code{time}}{A factor with levels \code{post} \code{pre} indicating before and after tranquilizer treatment.}
  }
}
\source{
Hollander, M., and  D. A. Wolfe. 1999. \emph{Nonparametric Statistical Methods}. New York: John Wiley & Sons. 
}

\keyword{datasets}

\name{corn}
\alias{corn}
\docType{data}
\title{
Corn yield data
}
\description{
Hoshmand (2006) described a split plot design to test grain yield of corn with respect to corn hybrids (split plots) and nitrogen (in whole plots).  The experiment was replicated at two blocks.
}
\usage{data(corn)}
\format{
  A data frame with 40 observations on the following 4 variables.
  \describe{
    \item{\code{yield}}{Corn yield in bushels per acre.}
    \item{\code{hybrid}}{Type of hybrid, P = pioneer, levels were: \code{A632xLH38} \code{LH74xLH51} \code{Mo17xA634} \code{P3732} \code{P3747}.}
    \item{\code{N}}{Nitrogen addition in lbs/acre \code{0} \code{70} \code{140} \code{210}.}
    \item{\code{block}}{A blocking factor with levels \code{1} \code{2}.}
  }
}

\source{
Hoshmand, A. R.  (2006) \emph{Design of Experiments for Agriculture and the Natural Sciences 2nd Edition}.  Chapman and Hall.
}

\keyword{datasets}

\name{SM.temp.moist}
\alias{SM.temp.moist}
\docType{data}
\title{
Alpine soil temperature and moisture time series
}
\description{
Soil temperature and water availability from Mt. Washburn in Yellowstone National Park.  Data were taken at soil depth of 5cm from a late snowmelt site at UTM 4960736.977	544792.225 zone 12T NAD 83, elevation 3070m.   
}
\usage{data(SM.temp.moist)}
\format{
  A data frame with 30 observations on the following 4 variables.
  \describe{
    \item{\code{year}}{A numeric vector describing year.}
    \item{\code{day}}{The "day of year", whereby Jan 1 = day 1 and Dec 32 = day 365 (366 for leap years).}
    \item{\code{Temp_C}}{Temperature in degrees Celsius.}
    \item{\code{Moisture}}{Soil water availability sensor reading.  A reading of 35 is approximately equal to -1.5 MPa.}
  }
}
\source{
Aho, K. (2006)  \emph{Alpine Ecology and Subalpine Cliff Ecology in the Northern Rocky 
Mountains}.  Doctoral dissertation, Montana State University, 458 pgs.
}
\keyword{datasets}

\name{ci.p}
\alias{ci.p}
\title{
Confidence interval estimation for the binomial parameter pi using five popular methods.
}
\description{
Confidence interval formulae for \eqn{\mu} are not appropriate for variables describing binary outcomes.  The function \code{p.conf} calculates confidence intervals for the binomial parameter \eqn{\pi} (probability of success) using raw or summarized data.  By default Agresti-Coull
 point estimators are used to estimate \eqn{\pi} and \eqn{\sigma_{\hat{\pi}}}.  If raw data are to be used (the default) then successes should be indicated as ones and failures as zeros in the \code{data} vector.  Finite population corrections can also be specified. 
 }
\usage{

ci.p(data, conf = 0.95, summarized = FALSE, phat = NULL, 
fpc = FALSE, n = NULL, N = NULL, method="agresti.coull", plot = TRUE)
}
\arguments{

  \item{data}{
A vector of binary data.  Required if \code{summarized = FALSE}.
}
  \item{conf}{
Level of confidence 1 - \emph{P}(type I error).
}
  \item{summarized}{
Logical; indicate whether raw data or summary stats are to be used. 
}
  \item{phat}{
Estimate of \eqn{\pi}.  Required if \code{summarized = TRUE}.
}

  \item{fpc}{
Logical.  Indicates whether finite population corrections should be used.  If \code{fpc = TRUE} then \code{N} must be specified.  Finite population corrections are not possible for \code{method = "exact"} or \code{method = "score"}.
}
  \item{n}{
Sample size.  Required if \code{summarized = TRUE}.
}
  \item{N}{
Population size.  Required if \code{fpc = TRUE}.
}
  \item{method}{
Type of method to be used in confidence interval calculations, \code{method ="agresti.coull"} is the default.  Other procedures include \code{method="asymptotic"} which provides the conventional normal (Wald) approximation,    
\code{method = "score"}, \code{method = "LR"}, and \code{method="exact"} (see \bold{Details} below). Partial names can be used.  The \code{"exact"} method cannot be implemented if \code{summarized=TRUE}.
}
\item{plot}{
Logical.  Should likelihood ratio plot be created with estimate from \code{method = "LR"}.
}
}
\details{
For the binomial distribution, the parameter of interest is the probability of success, \eqn{\pi}.  ML estimators for the parameter, \eqn{\pi}, and its standard deviation, \eqn{\sigma_\pi} are: 
\deqn{\hat{\pi}=\frac{x}{n},}
\deqn{\hat{\sigma}_{\hat{\pi}}=\sqrt{\frac{\hat{\pi}(1-\hat{\pi})}{n}}}
where \emph{x} is the number of successes and \emph{n} is the number of observations.

Because the sampling distribution of any ML estimator is asymptotically normal, an "asymptotic" 100(1 - \eqn{\alpha})\% confidence interval for \eqn{\pi} is found using:

\deqn{\hat{\pi}\pm z_{1-(\alpha/2)}\hat{\sigma}_{\hat{\pi}}.}

This method has also been called the Wald confidence interval.

These estimators can create extremely inaccurate confidence intervals, particularly for small sample sizes or when \eqn{\pi} is near 0 or 1 (Agresti 2012).  A better method is to invert the Wald binomial test statistic and vary values for \eqn{\pi_0} in the test statistic numerator and standard error.  The interval consists of values of \eqn{\pi_0} 
in which result in a failure to reject null at \eqn{\alpha}. Bounds can be obtained by finding the roots of a quadratic expansion of the binomial likelihood function (See Agresti 2012).
This has been called a "score" confidence interval (Agresti 2012).  An simple approximation to this method can be obtained by adding \eqn{z_{1-(\alpha/2)} (\approx 2} for \eqn{\alpha = 0.05}) to the number of successes and failures (Agresti and Coull 1998).  The resulting Agresti-Coull estimators for \eqn{\pi} and \eqn{\sigma_{\hat{\pi}}} are:

\deqn{\hat{\pi}=\frac{x+z^2/2}{n+z^2},}
\deqn{\hat{\sigma}_{\hat{\pi}}=\sqrt{\frac{\hat{\pi}(1-\hat{\pi})}{n+z^2}}.}

where \eqn{z} is the standard normal inverse cdf at probability 1 - \eqn{\alpha/2}.

As above, the 100(1 - \eqn{\alpha})\% confidence interval for the binomial parameter \eqn{\pi} is found using:

\deqn{\hat{\pi}\pm z_{1-(\alpha/2)}\hat{\sigma}_{\hat{\pi}}.}


The likelihood ratio method \code{method = "LR"} finds points in the binomial log-likelihood function where the difference between the maximum likelihood and likelihood function is closest to \eqn{\chi_1^{2}(1 - \alpha)/2} 
for support given in \eqn{\pi_0}.  As support the function uses 
\code{seq(0.00001, 0.99999, by = 0.00001)}. 


The "exact" method of Clopper and Pearson (1934) is bounded at the nominal limits, but actual coverage may be well below this level, particularly when \emph{n} is small and \eqn{\pi} is near 0 or 1.  

Agresti (2012) recommends the Agresti-Coull method over the normal approximation, the score method over the Agresti-Coull method, and the likelihood ratio method over all others.  The Clopper Pearson has been repeatedly criticized as being too conservative (Agresti and Coull 2012).   
}

\value{Returns a list of \code{class = "ci"}.  
  \item{pi.hat}{Estimate for \eqn{\pi}.}
  \item{S.p.hat}{Estimate for \eqn{\sigma_{\hat{\pi}}}.}
  \item{margin}{Confidence margin.}
  \item{ci}{Confidence interval.}
}
\references{
Agresti, A.  (2012) \emph{Categorical Data Analysis, 3rd edition}.  New York.  Wiley. 

Agresti, A., and Coull, B . A. (1998) Approximate is better than 'exact' for interval 
estimation of binomial proportions. \emph{The American Statistician}. 52: 119-126.

Clopper, C. and Pearson, S. (1934) The use of confidence or fiducial limits illustrated in 
the case of the Binomial. \emph{Biometrika} 26: 404-413.

Ott, R. L., and Longnecker, M. T. (2004) \emph{A First Course in Statistical Methods}.  
Thompson.

Wilson, E. B.(1927) Probable inference, the law of succession, and statistical inference. 
\emph{Journal of the American Statistical Association} 22: 209-212.

}
\author{Ken Aho. thanks to Simon Thelwall for finding an error with summarized data under fpc.
}
\note{This function contains only a few of the many methods that have been proposed for confidence interval estimation for \eqn{\pi}.
}
\seealso{\code{\link{ci.mu.z}}}
\examples{
#In 2001, it was estimated that 56,200 Americans would be diagnosed with 
# non-Hodgkin's lymphoma and that 26,300 would die from it (Cernan et al. 2002).  
# Here we find the 95% confidence interval for the probability of diagnosis, pi. 

ci.p(c(rep(0, 56200-26300),rep(1,26300))) # Agresti-Coull
ci.p(c(rep(0, 56200-26300),rep(1,26300)), method = "LR") # Likelihood Ratio

# summarized = TRUE
n = 56200
x = 26300
phat = x/n

ci.p(summarized = TRUE, phat = phat, n = n) # Agresti-Coull

# Use 2001 US population size as N
N <- 285 * 10^6
ci.p(c(rep(0, 56200-26300),rep(1,26300)), fpc = TRUE, N = N) # Agresti-Coull
ci.p(summarized = TRUE, phat = phat, n = n, N = N, fpc = TRUE) # Agresti-Coull
} 
\keyword{univar}
\keyword{htest}

\name{see.cor.range.tck}
\alias{see.cor.range.tck}
\title{
Depict the effect of range on correlation
}
\description{
Function interactively depicts the effect of the data range on association measures.
}
\usage{
see.cor.range.tck(sd = 0.5)
}

\arguments{

  \item{sd}{
Amount of noise added to linear association.  Residuals around line pulled from a normal distribution centered at zero with this standard deviation.  
}
}
\references{
Based on a figure from \url{https://en.wikipedia.org/wiki/Correlation_and_dependence}
}
\author{
Ken Aho
}
\keyword{graphs}

\name{samp.dist.mech}
\alias{samp.dist.mech}
\alias{samp.dist.mech.tck}
\title{
Animated representation of sampling distribution basics
}
\description{
Mountain goats are randomly sampled 10 at a time and weighed [goat weights are normal \emph{N}(90.5, 225)], a mean weight is calculated from these measures and added to collection of mean weights in the form of a histogram. 
}
\usage{

samp.dist.mech(rep, int = 0.05)

samp.dist.mech.tck()

}
\arguments{

  \item{rep}{
Number of samples.  Should not greatly exceed 100.
}
  \item{int}{The time interval for animation (in seconds).  Smaller intervals speed up animation}
}

\author{
Ken Aho
}
\note{
Nice goat image from \url{https://all-free-download.com/} 
}

\keyword{graphs}

\name{skew}
\alias{skew}
\alias{kurt}
\title{Sample skewness and kurtosis}
\description{Functions for skewness and kurtosis.  
}
\usage{

skew(x,method="unbiased")

kurt(x,method="unbiased")
}

\arguments{

  \item{x}{A vector of quantitative data.}
  \item{method}{The type of method used for computation of skew and kurtosis.  Two choices are possible for skewness: \code{"moments"} and \code{"unbiased"}, and three choices are possible for kurtosis: \code{"unbiased", "moments"}, and \code{"excess"}.}
}
\details{Aside from centrality and variability we can describe distributions with respect to their shape.  Two important shape descriptors are skewness and kurtosis.  Skewness describes the relative density in the tails of a distribution while kurtosis describes the peakedness of a distribution. When quantified for a population skewness and kurtosis are denoted as \eqn{\gamma_1} and \eqn{\gamma_2} respectively.  For a symmetric distribution skewness will equal zero; i.e. \eqn{\gamma_1} = 0.  A distribution with more density in its right-hand tail will have  \eqn{\gamma_1} > 0, while one with more density in its left-hand tail will have  \eqn{\gamma_1} < 0.  These distributions are often referred to as positively-skewed and negatively-skewed respectively.  If a distribution is normally peaked (mesokurtic) then \eqn{\gamma_2} = 3.  As a result the number three is generally subtracted from kurtosis estimates so that a normal distribution will have \eqn{\gamma_2}  = 0 .  Thus strongly peaked (leptokurtic) distributions will have \eqn{\gamma_2} > 0, while flat-looking (platykurtic) distributions will have a kurtosis \eqn{\gamma_2} < 0. 

Several types of skewness and kurtosis estimation are possible. 

For method of moments estimation let: 
\deqn{m_j = (1/n)\sum_i({X_i-\bar{X}})^j,}{%
m_j = (1/n)sum(X_i-X.bar)^j,}

then the method of moments skewness is: \eqn{m_3/m_{2}^{3/2}}, the method of moments kurtosis is: \eqn{m_4/m_2^2}, and the excess method of moments kurtosis is \eqn{m_4/m_2^2 -3}. 

These estimators are biased low, particularly given small sample sizes.  A more complex estimator is required to account for this bias.  This is provided by \code{method = "unbiased"} in \code{skew} and \code{kurt}.
}

\value{
Output will be the sample skewness or kurtosis.
}
\author{Ken Aho}
\examples{
exp<-rexp(10000)
skew(exp)
kurt(exp)
}
\keyword{univar}

\name{D.sq}
\alias{D.sq}
\title{Mahalanobis distance for two sites using a pooled covariance matrix}
\description{Allows much easier multivariate comparisons of groups of sites then provided by the function \code{mahalanobis} in the \code{base} library.
}
\usage{
D.sq(g1, g2)
}
\arguments{

  \item{g1}{Community vector for site 1}
  \item{g2}{Community vector for site 2} 
}
\references{
Legendre, P, and L. Legendre  (1998)  \emph{Numerical Ecology, 2nd English Edition}.  Elsevier, 
Amsterdam, The Netherlands. 
}
\author{Ken Aho}
\seealso{\code{\link{mahalanobis}}}
\examples{
g1<-matrix(ncol=3,nrow=3,data=c(1,0,3,2,1,3,4,0,2))
g2<-matrix(ncol=3,nrow=3,data=c(1,2,4,5,2,3,4,3,1))
D.sq(g1,g2)$D.sq
 }
\keyword{multivariate}

\name{world.emissions}
\alias{world.emissions}
\docType{data}
\title{
Greenhouse gas emissions from Our World in Data
}
\description{
A subset of the complete CO\eqn{_2} and Greenhouse Gas Emissions dataset maintained by Our World in Data (\url{https://ourworldindata.org/}) through 2019. The data follow a format of 1 row per ``country'' per year.
}
\usage{data("world.emissions")}
\format{
  A data frame with 23708 observations on the following 15 variables.
  \describe{
    \item{\code{iso_code}}{Three-letter summary code for countries (ISO 3166-1 alpha-3). }
    \item{\code{country}}{A character vector identifying country.}
    \item{\code{year}}{Year data were collected, 1750-2019}
    \item{\code{co2}}{Annual production-based emissions of carbon dioxide (CO\eqn{_2}), measured in million tonnes. This is based on territorial emissions, which do not account for emissions from traded goods.}
    \item{\code{coal_co2}}{Annual production-based emissions of CO\eqn{_2} from coal, measured in million tonnes. }
    \item{\code{flaring_co2}}{Annual production-based emissions of CO\eqn{_2} from flaring, measured in million tonnes. }
    \item{\code{gas_co2}}{Annual production-based emissions of CO\eqn{_2} from gas, measured in million tonnes. }
    \item{\code{oil_co2}}{Annual production-based emissions of CO\eqn{_2} from oil, measured in million tonnes. }
    \item{\code{other_industry_co2}}{Annual production-based emissions of CO\eqn{_2} from other industry sources, measured in million tonnes. Based on territorial emissions,.}
    \item{\code{total_ghg}}{Total greenhouse gas emissions, including land use change and forestry, measured in million tonnes of CO\eqn{_2}-equivalents.}
    \item{\code{methane}}{Total methane emissions, measured in million tonnes of CO\eqn{_2}-equivalents.}
    \item{\code{nitrous_oxide}}{Total nitrous oxide emissions, measured in million tonnes of CO\eqn{_2}-equivalents.}
    \item{\code{primary_energy_consumption}}{Primary energy consumption, measured in terawatt-hours per year.}
    \item{\code{population}}{Population by country, available from 1800 to 2021 based on Gapminder data, HYDE, and UN Population Division (2019) estimates.}
    \item{\code{gdp}}{Gross domestic product measured in international-$ using 2011 prices to adjust for price changes over time (inflation) and price differences between countries. Calculated by multiplying GDP per capita with population.}
        \item{\code{continent}}{Continent.  Caribbean countries are distinguished from other North American countries.  Additionally a level called \code{"Redundant"} is included to parse redundant entries in the \code{country} column, e.g., the ``countries'' \code{Libya} and \code{Africa} contain redundant information.}
}
}
\details{
Thanks to BIOL 6651 students at ISU who annotated these data: Laurel Faurot, Sawyer Finley, Spencer Roop, Therese Balkenbush, Lauren Tucker, Jessica Call and Riley Lanfear.
}
\source{
\url{https://github.com/owid/co2-data}
}
\references{
According to Our World in Data (\url{https://ourworldindata.org/}), CO\eqn{_2} data are sourced from the Global Carbon Project (\url{https://www.globalcarbonproject.org}) which releases updates of CO\eqn{_2} emissions data annually. Greenhouse gas emissions (including methane, and nitrous oxide) are sourced from the CAIT Climate Data Explorer (\url{https://www.climatewatchdata.org:443/?source=cait}), and downloaded from the Climate Watch Portal (\url{https://www.climatewatchdata.org}. Energy consumption data this data are sourced from a combination of two sources The Statistical Review of World Energy https://www.bp.com/en/global/corporate/energy-economics.html and World Bank Development Indicators
\url{https://databank.worldbank.org/source/world-development-indicators}.  Although The Statistical Review of World Energy is published annually, it does not provide data for all countries. For countries absent from this dataset, we calculated primary energy by multiplying the World Bank, World Development Indicators metric Energy use per capita by total population figures. The World Bank sources its metric from the International Energy Agency (IEA). Other variables were collected from a variety of sources including the United Nations, Gapminder, and the Maddison Project Database.
}
\examples{
data(world.emissions)
}
\keyword{datasets}

\name{exercise.repeated}
\alias{exercise.repeated}
\docType{data}
\title{Repeated measures data for an exercise experiment.}
\description{
Freund et al. (1986) listed data for a longitudinal study of exercise therapies.  
The data were analyzed using AR1 covariance matrices in mixed models by Fitzmaurice 
et al. (2004).  In the study 37 patients were randomly assigned to one of two 
weightlifting programs. In the first program (TRT 1), repetitions with weights 
were increased as subjects became stronger. In the second program (TRT 2), 
the number of repetitions was fixed but weights were increased as subjects 
became stronger. An index measuring strength was created and recorded at day 
0, 2, 4, 6, 8, 10, and 12.  
}
\usage{data(exercise.repeated)}
\format{
The dataframe contains a repeated measures dataset describing the strength of 37 subjects with respect to two weightlifting programs.  There are four columns:
  \describe{
    \item{ID}{Subject ID.}
    \item{TRT}{The type of weightlifting treatment (a factor with two levels, \code{1} and \code{2}).}
    \item{strength}{A strength index.}
    \item{day}{The day that \code{strength} was measured on a subject, measured from the start of the experiment.}
    }  
}
\source{
Fitzmaurice, G. M., Laird, N. M, and Waird, J. H.  (2004) \emph{Applied Longitudinal Analysis}.  Wiley.
}
\keyword{datasets}

\name{see.roc.tck}
\alias{see.roc.tck}

\title{
Interactive depiction of ROC curves
}
\description{
Sliders allow users to change distinctness of dichotomous classes (success and failure).  
This will affect the ROC curve.  One can also change the criteria defining what constitutes a success.  
While this will not change the ROC curve (which compares true positive and false negative rates at all possible success cutoff), 
it The will change empirical rates of true positives, true negatives, false positives, and false negatives given the defined cutoff.  
}
\usage{
 see.roc.tck()
}

\author{
Ken Aho, inspired by a graphical demo at 
\url{http://www.anaesthetist.com/mnm/stats/roc/Findex.htm} 
}
\keyword{graphs}

\name{H.mean}
\alias{H.mean}
\title{Harmonic mean}
\description{Calculates the harmonic mean.}
\usage{H.mean(x)}
\arguments{
  \item{x}{Vector of quantitative data.}
}
\value{
Returns the harmonic mean.
}
\seealso{\code{\link{G.mean}}, \code{\link{HL.mean}}}
\author{Ken Aho}
\examples{
x<-c(2,1,4,5,6,2.4,7,2.2,.002,15,17,.001)
H.mean(x)
}

\name{see.ancova.tck}
\alias{see.ancova.tck}

\title{
Visualize ANCOVA mechanics
}
\description{
An interactive GUI to view ANCOVA meachnics.  Exp. power tries to simulate explanatory power in the concomitant variable.  It simply results in (1 - Exp. power) \eqn{\times} Residual SE.
}
\usage{

see.ancova.tck()
}
\author{
Ken Aho
}
\keyword{graphs}

\name{polyamine}
\alias{polyamine}
\docType{data}
\title{
Polyamine data from Hollander and  Wolfe (1999)
}
\description{
Polyamines are a class of organic compounds having two or more primary amino groups.  They appear to have a number of important functions including regulation of cell proliferation, cell differentiation, and cell death.  Polyamine plasma levels taken for healthy children of different ages were summarized by Hollander and Wolfe (1999).
}

\usage{data(polyamine)}
\format{
  A data frame with 25 observations on the following 2 variables.
  \describe{
    \item{\code{age}}{Child age in years (0 indicates newborn)}
    \item{\code{p.amine}}{Polyamine level in blood}
  }
}
\source{
Hollander, M., and  D. A. Wolfe  (1999) \emph{Nonparametric Statistical Methods}. New York: John Wiley & Sons. 
}
\keyword{datasets}

\name{prp}
\alias{prp}
\alias{print.prp.index}
\title{
Perpendicularity}
\description{
Calculates a perpendicularity index, \eqn{\eta}, for animal spatial movements.  The index has a [0, 1] range with 0 indicating a perfectly parallel movement with respect to boundary or edge and 1 indicating perfectly perpendicular movement.  Other summaries are also provided.
}
\usage{

prp(Time, S.X, S.Y, N.X, N.Y, habitat = NULL, near.angle = NULL, 
F.0.NA = TRUE)
}
\arguments{

  \item{Time}{
A numeric vector containing the times when spatial coordinates were recorded.
}
  \item{S.X}{
\emph{X}-coordinates of animal.
}
  \item{S.Y}{
\emph{Y}-coordinates of animal.
}
  \item{N.X}{
\emph{X}-coordinate of nearest point on boundary.  These data can be obtained from function \code{\link{near.bound}} or from ARCGIS Near output.
}
  \item{N.Y}{
\emph{Y}-coordinate of nearest point on boundary.  These data can be obtained from function \code{\link{near.bound}} or from ARCGIS Near output.
}
  \item{habitat}{
A character vector of habitat categories.
}
  \item{near.angle}{
A numeric vector containing the angle of azimuth to the nearest point on the boundary with respect to a four quadrant system.  NE = \eqn{0^{\circ}} to \eqn{90^{\circ}}, NW is > \eqn{90^{\circ}} and \eqn{\le 180^{\circ}}, SE is < \eqn{0^{\circ}} and \eqn{\le - 90^{\circ}} is > \eqn{-90^{\circ}} and \eqn{\le -180^{\circ}}.  This output can be obtained from function \code{\link{bound.angle}} or from ARCGIS Near output.
}
  \item{F.0.NA}{
A logical argument specifying whether or not a time interval in which F = 0 should be made \code{NA} (see Figure from examples)
}
}
\details{
This index for perpendicularity, \eqn{\eta} is based on the following rules:

if \eqn{\delta \le 90^o} then \eqn{\eta} = \eqn{\delta/90^o}; if \eqn{90^o < \delta \le 135^o} then \eqn{\eta} = \eqn{[90^o - (\delta - 90^o)]/90^o}; if \eqn{135^o < \delta \le 180^o} then \eqn{\eta} = \eqn{(\delta - 90^o)/90^o} 

For notation create Figures from examples.
}
\value{
Returns a list with four or five items.

\item{lines}{A matrix with \emph{n} - 1 rows containing line lengths for the lines \emph{A, B, C, D,} and \emph{F}.  See figure in examples below.}
\item{angles}{A matrix with \emph{n} - 1 rows containing line lengths for the angles \eqn{\kappa}, \eqn{\gamma} and \eqn{\delta}.  See Figure in examples below.}
\item{moment.by.moment}{This component provides a matrix with \emph{n} - 1 rows.  Included are the columns: \code{End.time}, \code{Eta.Index}, \code{Delta}, \code{Habitat}, and \code{Brdr chng}.  The columns \code{Habitat}, and \code{Brdr chng} are excluded if \code{habitat = NULL} or \code{near.angle = NULL}.}
\item{P.summary}{Contains averages and standard errors for \eqn{\eta}.}
\item{crossing.summary}{Crossing binomial summaries.  Provided if \code{habitat} and \code{near.angle} are specified.}
}
\references{
Kie, J.G., A.A. Ager, and R.T. Bowyer  (2005)  Landscape-level movements of North American 
elk (\emph{Cervus elaphus}): effects of habitat patch structure and topography. \emph{Landscape Ecology} 20:289-300.

McGarigal K., SA Cushman, M.C. Neel, and E. Ene  (2002) \emph{FRAGSTATS: Spatial Pattern
Analysis Program for Categorical Maps}. Computer software program produced by the
authors at the University of Massachusetts, Amherst.
}
\author{
Ken Aho
}
\seealso{\code{\link{near.bound}}, \code{\link{bound.angle}}}

\examples{
\dontrun{
###Diagram describing prp output.  
y<-rnorm(100,0,5)
plot(seq(1,100),sort(y),type="l",xaxt="n",yaxt="n",lwd=2,xlab="",ylab="")
op <- par(font=3)

segments(52,-12,46,sort(y)[46],lty=1,col=1,lwd=1)##A
segments(90,-8,85,sort(y)[85],lty=1,col=1,lwd=1)##B
segments(46,sort(y)[46],85,sort(y)[85],lty=1)##F
segments(90,-8,46,sort(y)[46],lty=2)##D
arrows(52,-12,90,-8,length=.1,lwd=3)##C
arrows(20,-12,20,8,lty=2,col="gray",length=.1)#North
arrows(20,sort(y)[46],95,sort(y)[46],length=.1,lty=2,col="gray")
arrows(20,-12,95,-12,length=.1,lty=2,col="gray")#East

text(20,9,"N",col="gray");text(97,-12, "E", col= "gray");text(97,sort(y)[46], "E",
col= "gray")
text(49.5,-12.5,"a");text(92.5,-8.5,"b")
text(45.5,-5.5,"A",font=4,col=1);text(70,-9,"C",font=4,col=1);text(91.5,-1.75,"B",
font=4,col=1)
text(44,sort(y)[46]+1,"c");text(67.5,-2.5,"D",font=4,col=1);text(65,3.9,"F",font=4,
col=1)
text(87,sort(y)[87]+1,"d");text(57,-10,expression(kappa),col=1);
text(81,sort(y)[87]-3,expression(gamma),col=1);text(57,1.3,expression(theta),col=1)
text(64,-11.5,expression(beta),col=1)

library(plotrix)
draw.arc(50,-12,6,1.35,col=1);draw.arc(50,-12,6,.3,col=1);draw.arc(50,-12,6,0.02,
col=1)
draw.arc(46,sort(y)[46],7,.01,col=1);draw.arc(46,sort(y)[46],7,.5,col="white")
draw.arc(85,sort(y)[85],6,-2.7,col=1);draw.arc(85,sort(y)[85],6,-1.4,col="white",
lwd=2)
legend("topleft",c(expression(paste(kappa, " = acos[(",C^2," + ",X^2," - ",D^2,")
/2CX]")),
expression(paste(gamma," = acos[(",Y^2," + ",F^2," - ",D^2,")/2YF]")),
expression(paste(theta," = atan[(",y[f]," - ",y[n],")/(",x[f]," - ",x[n],")]")),
expression(paste(beta, " = atan[(",y[epsilon]," - ",y[alpha],")/(",x[epsilon],
" - ",x[alpha],")]"))),
bty="n",cex=.9,inset=-.025)

###Figure for demo dataset.
bX<-seq(0,49)/46

bY<-c(4.89000,4.88200,4.87400,4.87300,4.88000,4.87900,4.87900,4.90100,4.90800,
4.91000,4.93300,4.94000,4.91100,4.90000,4.91700,4.93000,4.93500,4.93700,
4.93300,4.94500,4.95900,4.95400,4.95100,4.95800,4.95810,4.95811,4.95810,
4.96100,4.96200,4.96300,4.96500,4.96500,4.96600,4.96700,4.96540,4.96400,
4.97600,4.97900,4.98000,4.98000,4.98100,4.97900,4.98000,4.97800,4.97600,
4.97700,4.97400,4.97300,4.97100,4.97000)

X<-c(0.004166667,0.108333333,0.316666667,0.525000000,0.483333333,0.608333333,
0.662500000,0.683333333,0.900000000,1.070833333)
Y<-c(4.67,4.25,4.26,4.50,4.90,4.10,4.70,4.40,4.20,4.30)

plot(bX,bY,type="l",lwd=2,xlab="",ylab="",ylim=c(4,5.1))
lines(X,Y)

for(i in 1:9)arrows(X[i],Y[i],X[i+1],Y[i+1],length=.1,lwd=1,angle=20)
mx<-rep(1,9)
my<-rep(1,9)
for(i in 1:9)mx[i]<-mean(c(X[i],X[i+1]))
for(i in 1:9)my[i]<-mean(c(Y[i],Y[i+1]))
for(i in 1:9)text(mx[i],my[i],i,font=2,cex=1.3)

nn<-near.bound(X,Y,bX,bY)
prp(seq(1,10),X,Y,nn[,1],nn[,2])$moment.by.moment
par(op)
}
}

\name{samp.dist}
\alias{samp.dist}
\alias{samp.dist.snap}
\alias{samp.dist.method.tck}
\alias{samp.dist.tck}
\alias{samp.dist.snap.tck1}
\alias{samp.dist.snap.tck2}
\alias{dirty.dist}
\alias{samp.dist.n}

\title{Animated and/or snapshot representations of a statistic's sampling distribution}
\description{
This help page describes a series of \pkg{asbio} functions for depicting sampling distributions.  The function \code{samp.dist} samples from a parent distribution without replacement with sample size = \code{s.size}, 
\code{R} times.  At each iteration a statistic requested in \code{stat} is calculated. Thus a distribution of \code{R} statistic estimates is created.  
The function \code{samp.dist} shows this distribution as an animated \code{anim = TRUE} or non-animated \code{anim = FALSE} density histogram.   
Sampling distributions for up to four different statistics utilizing two different parent distributions are possible using \code{samp.dist}.  
Sampling distributions can be combined in various ways by specifying a function in \code{func} (see below). 
The function \code{samp.dist.n} was designed to show (with animation) how sampling distributions vary with sample size, and is still under development.  
The function \code{samp.dist.snap} creates snapshots, i.e. simultaneous views of a sampling distribution at particular sample sizes. 
The function \code{dirty.dist} can be used to create contaminated parent distributions.
}
\usage{

samp.dist(parent = NULL, parent2 = NULL, biv.parent = NULL, s.size = 1, s.size2
 = NULL, R = 1000, nbreaks = 50, stat = mean, stat2 = NULL, stat3 = NULL, stat4 
 = NULL, xlab = expression(bar(x)), func = NULL, show.n = TRUE, show.SE = FALSE, 
 anim = TRUE, interval = 0.01, col.anim = "rainbow", digits = 3, ...)

samp.dist.snap(parent = NULL, parent2 = NULL, biv.parent = NULL, stat = mean, 
stat2 = NULL, stat3 = NULL, stat4 = NULL, s.size = c(1, 3, 6, 10, 20, 50), 
s.size2 = NULL, R = 1000, func = NULL, xlab = expression(bar(x)), 
show.SE = TRUE, fits = NULL, show.fits = TRUE, xlim = NULL, ylim = NULL, ...)

samp.dist.method.tck()

samp.dist.tck(statc = "mean")

samp.dist.snap.tck1(statc = "mean")

samp.dist.snap.tck2(statc = "mean")

dirty.dist(s.size, parent = expression(rnorm(1)), 
cont = expression(rnorm(1, mean = 10)), prop.cont = 0.1)

samp.dist.n(parent, R = 500, n.seq = seq(1, 30), stat = mean, xlab = expression(bar(x)), 
    nbreaks = 50, func = NULL, show.n = TRUE, 
    show.SE = FALSE, est.density = TRUE, col.density = 4, lwd.density = 2, 
    est.ylim = TRUE, ylim = NULL, anim = TRUE, interval = 0.5, 
    col.anim = NULL, digits = 3, ...) 
}

\arguments{

  \item{parent}{A vector or vector generating function, describing the parental distribution.  
  Any collection of values can be used. When using random value generators for 
  parental distributions, for CPU efficiency (and accuracy) one should use 
  \code{parent = expression(rpdf(s.size, ...))}. Datasets exceeding 100000 observations are not recommended.}
  \item{parent2}{An optional second parental distribution (see \code{parent} above), 
  useful for the construction of sampling distributions of test statistics.  
  When using random value generators use \code{parent2 = expression(rpdf(s.size2, ...))}.}
  \item{biv.parent}{A bivariate (two column) distribution.}
  \item{s.size}{An integer defining sample size (or a vector of integers in the case of \code{samp.dist.snap}) to be taken at each of \code{R} iterations from the parental distribution.}
  \item{s.size2}{An optional integer defining a second sample size if a second statistic is to be calculated.  Again, this will be a vector of integers in the of \code{samp.dist.snap}.}
  \item{R}{The number of samples to be taken from parent distribution(s).}
  \item{nbreaks}{Number of breaks in the histogram.}
  \item{stat}{The statistic whose sampling distribution is to be represented.  Will work for any summary statistic that only requires a call to data; e.g. \code{\link{mean}}, \code{\link{var}}, \code{\link{median}}, etc.}
  \item{stat2}{An optional second statistic. Useful for conceptualizing sampling distributions of test statistics.  Calculated from sampling \code{parent2}.}
  \item{stat3}{An optional third statistic. The sampling distribution is created from the same sample data used for \code{stat}.}
  \item{stat4}{An optional fourth statistic. The sampling distribution is created from the same sample data used for \code{stat2}.}
  \item{xlab}{\emph{X}-axis label.}  
  \item{func}{An optional function used to manipulate a sampling distribution or to combine the sampling distributions of two or more statistics.  
  The function must contain the following arguments (although they needn't all be used in the function):  
  \code{s.dist}, \code{s.dist2}, \code{s.size}, and \code{s.size2}.  When sampling from a 
  single parent distribution use \code{s.dist3} in the place of \code{s.dist2}.  
  For an estimator involving two parent distributions and four statistics, six arguments will be required: 
  \code{s.dist}, \code{s.dist2}, \code{s.dist3}, \code{s.dist4}. 
  \code{s.size}, and \code{s.size2} , \code{s.dist3}, and  as non-fixed arguments (see example below).}
  \item{show.n}{A logical command, \code{TRUE} indicates that sample size for \code{parent} will be displayed.}
  \item{show.SE}{A logical command, \code{TRUE} indicates that bootstrap standard error for the statistic will be displayed.}
  \item{anim}{A logical command indicating whether or not animation should be used.}
  \item{interval}{Animation speed.  Decreasing \code{interval} increases speed.}
  \item{col.anim}{Color to be used in animation.  Three changing color palettes: \code{\link{rainbow}}, \code{\link{gray}}, \code{\link{heat.colors}}, or "fixed" color types can be used.}
  \item{digits}{The number of digits to be displayed in the bootstrap standard error.}
  \item{fits}{Fitted distributions for \code{samp.dist.snap}  A function with two argument: \code{s.size} and \code{s.size2}} 
  \item{show.fits}{Logical indicating whether or not fits should be shown (fits 
  will not be shown if no fitting function is specified regardless of whether this is \code{TRUE} or \code{FALSE}}
  \item{xlim}{A two element numeric vector defining the upper and lower limits of the \emph{X}-axis.}
  \item{ylim}{A two element numeric vector defining the upper and lower limits of the \emph{Y}-axis.} 
  \item{statc}{Presets for certain statistics.  Currently one of \code{"custom"}, \code{"mean"}, 
  \code{"median"}, \code{"trimmed mean"}, \code{"Winsorized mean"}, 
  \code{"Huber estimator"}, "H-L estimator", \code{"sd"}, \code{"var"}, \code{"IQR"},
  \code{"MAD"}, \code{"(n-1)S^2/sigma^2"}, \code{"F*"}, \code{"t* (1 sample)"},
  \code{"t* (2 sample)"}, \code{"Pearson correlation"} or \code{"covariance"}.
}
  \item{cont}{A distribution representing a source of contamination in the parent population.  Used by function \code{dirty.dist}.}
  \item{prop.cont}{The proportion of the parent distribution that is contaminated by \code{code}.}
  \item{n.seq}{A range of sample sizes for \code{samp.dist.n}}
  \item{est.density}{A logical command for \code{samp.dist.n}. if \code{TRUE} then a density line is plotted over the histogram.  Only used if \code{fix.n = true}.}
  \item{col.density}{The color of the density line for \code{samp.dist.n}.  See \code{est.density} above.}
  \item{lwd.density}{The width of the density line for \code{samp.dist.n}.  See \code{est.density} above.} 
  \item{est.ylim}{Logical.  If \code{TRUE} \emph{Y}-axis limits are estimated logically for the animation in \code{samp.dist.n}.  Consistent \emph{Y}-axis limits make animations easier to visualize.  Only used if \code{fix.n = TRUE}.} 
  \item{\dots}{Additional arguments from \code{\link{plot.histogram}}.}
}
\value{Returns a representation of a statistic's sampling distribution in the form of a histogram.
}

\details{Sampling distributions of individual statistics can be created with \code{samp.dist}, or the function can be used in more sophisticated ways, e.g. 
to create sampling distributions of ratios of statistics, i.e. \emph{t}*, \emph{F}* etc. (see examples below). To provide pedagogical clarity animation for figures is provided.    
To calculate bivariate statistics, specify the parent distribution with \code{biv.parent} and the statistic with \code{func} (see below). 


Two general uses of the function \code{samp.dist} are possible.
1) One can demonstrate the accumulation of statistics for a single sample size using animation.  
This is useful because as more and more statistics are acquired the frequentist paradigm associated with sampling distributions becomes better represented (i.e the number of estimates is closer to infinity).  This is elucidated by allowing the default \code{fix.n = TRUE}.  Animation will be provided with the default \code{anim = TRUE}.  Up two parent distributions, up to two sample sizes, and up to four distinct statistics (i.e. four distinct sampling distributions, representing four distinct estimators) can be used.  The arguments \code{stat} and \code{stat3} will be drawn from \code{parent}, while \code{stat3} and \code{stat4} will be drawn from \code{parent2}.  These distributions can be manipulated and combined in an infinite number of ways with an auxiliary function called in the argument \code{func} (see examples below).  This allows depiction of sampling distributions made up of multiple estimators, e.g. test statistics.  
2) One can provide simultaneous snapshots of a sampling distribution at a particular sample size with the function \code{samp.dist.snap}. 

Loading the package \pkg{tcltk} allows use of the functions \code{samp.dist.tck}, \code{samp.dist.method.tck}, \code{samp.dist.snap.tck1} and \code{samp.dist.snap.tck2}, 
which provide interactive GUIs that run \code{samp.dist}.

} 
\author{
Ken Aho
}
\examples{
\dontrun{
##Central limit theorem
#Snapshots of four sample sizes.
samp.dist.snap(parent=expression(rexp(s.size)), s.size = c(1,5,10,50), R = 1000)

##sample mean animation
samp.dist(parent=expression(rexp(s.size)), col.anim="heat.colors", interval=.3)

##Distribution of t-statistics from a pooled variance t-test under valid and invalid assumptions
#valid
t.star<-function(s.dist1, s.dist2, s.dist3, s.dist4, s.size = 6, s.size2 = 
s.size2){
MSE<-(((s.size - 1) * s.dist3) + ((s.size2 - 1) * s.dist4))/(s.size + s.size2-2)
func.res <- (s.dist1 - s.dist2)/(sqrt(MSE) * sqrt((1/s.size) + (1/s.size2)))
func.res}

samp.dist(parent = expression(rnorm(s.size)), parent2 = 
expression(rnorm(s.size2)), s.size=6, s.size2 = 6, R=1000, stat = mean, 
stat2 = mean, stat3 = var, stat4 = var, xlab = "t*", func = t.star)

curve(dt(x, 10), from = -6, to = 6, add = TRUE, lwd = 2)
legend("topleft", lwd = 2, col = 1, legend = "t(10)")

#invalid; same population means (null true) but different variances and other distributional 
#characteristics.
samp.dist(parent = expression(runif(s.size, min = 0, max = 2)), parent2 = 
expression(rexp(s.size2)), s.size=6, s.size2 = 6, R = 1000, stat = mean, 
stat2 = mean, stat3 = var, stat4 = var, xlab = "t*", func = t.star)

curve(dt(x, 10),from = -6, to = 6,add = TRUE, lwd = 2)
legend("topleft", lwd = 2, col = 1, legend = "t(10)")

## Pearson's R
require(mvtnorm)
BVN <- function(s.size) rmvnorm(s.size, c(0, 0), sigma = matrix(ncol = 2, 
nrow = 2, data = c(1, 0, 0, 1)))
samp.dist(biv.parent = expression(BVN(s.size)), s.size = 20, func = cor, xlab = "r")
                                                  
#Interactive GUI, require package 'tcltk'
samp.dist.tck("S^2")
samp.dist.snap.tck1("Huber estimator")
samp.dist.snap.tck2("F*")
}
}
\keyword{graphs}

\name{alfalfa.split.plot}
\alias{alfalfa.split.plot}
\docType{data}
\title{An agricultural split plot design}
\description{
An experiment was conducted in Iowa in 1944 to see how different varieties of alfalfa responded 
to the last cutting day of the previous year (Snedecor and Cochran 1967). We know that in the 
fall alfalfa can either continue to grow, or stop growing and store resources belowground in roots 
for growth during the following year. Thus, we might expect that later cutting dates inhibits 
growth for the following year. On the other hand, if plants are cut after they have gone into 
senescence, there should be little effect on productivity during the following year. There are 
two factors: 1) variety of alfalfa (three varieties were planted in each of three randomly chosen whole plots), 
and 2) the date of last cutting (Sept 1, Sept. 20, or Oct. 7).  The dates were randomly 
chosen split plots within the whole plots. Replication was accomplished using six blocks of fields. 
}
\usage{data(alfalfa.split.plot)}
\format{
The dataframe contains four variables: 
  \describe{
    \item{\code{yield}}{
     Alfalfa yield (tons per acre). 
    }
    \item{\code{variety}}{
      Alfalfa variety.  A factor with three levels "L"= Ladak, "C" = Cosack, and "R" = Ranger describing the variety of alfalfa seed used.
    }
    \item{\code{cut.time}}{Time of last cutting. A factor with three levels: "None" = field not cut, "S1" = Sept 1, "S20" = Sept. 20, or "O7" = Oct. 7.
          }
    \item{\code{block}}{The block (whole plot replicate).  A factor with six levels: "1", "2", "3", "4", "5", and "6".}
      }
}
\source{Snedecor, G. W. and Cochran, G. C.  (1967)  \emph{Statistical Methods, 6th edition}.  Iowa State University Press.} 
\keyword{datasets}

\name{km}
\alias{km}
\title{Kaplan-Meier survivorship.}
\description{
Calculates survivorship for individuals in a population over time based on the 
method of Kaplan-Meier; cf. Pollock et al. (1989).
}

\usage{
km(r, d, var = "O", conf = 0.95, age.seq=seq(1,length(r)),
ylab = "Survivorship", xlab = "Age class", type = "b", 
plot.km = TRUE, plot.CI = TRUE, ...)
}
\arguments{

  \item{r}{Numbers of individuals at risk in each age or time class.}
  \item{d}{Vector of the number of deaths in each age or time class.}
  \item{var}{Type of procedure used to calculate variance in confidence intervals \code{"O"} = Oakes, \code{"G"} = Greenwood.}
  \item{conf}{Level of confidence for confidence interval calculations; 1 - \emph{P}(type I error)}
  \item{age.seq}{A sequence of numbers indicating the age classes used.}
  \item{ylab}{\emph{Y}-axis label.}
  \item{xlab}{\emph{X}-axis label.}
  \item{type}{\code{type} argument from \code{\link{plot}}.}
  \item{plot.km}{Logical. Should plot be created?}
  \item{plot.CI}{Logical. Should confidence interval be overlaid on plot?}
  \item{\dots}{Additional arguments from \code{\link{plot}}.}
}
\details{
Details for this index are given in Pollock et al. (1989).
}
\value{
Returns a list with the following components
  \item{s.hat}{A vector of estimated survivorship probabilities from the 1st age class onward.}
  \item{Greenwood.Var}{The estimated Greenwood variance for each age class.}
  \item{Oakes.Var}{The estimated Oakes variance for each age class.}
  \item{CI}{Upper and lower confidence bound to the true survivorship.}     
}
\references{Pollock, K. H., Winterstein, S. R., and Curtis, P. D. (1989) Survival 
analysis in telemetry studies: the staggered entry design.  \emph{Journal of Wildlife 
Management}.  53(1):7-1.}
\author{Ken Aho}
\examples{
##Example from Pollock (1989)
r<-c(18,18,18,16,16,16,15,15,13,10,8,8,7)
d<-c(0,0,2,0,0,1,0,1,1,1,0,0,0)

km(r,d)
}
\keyword{univar}
\keyword{htest}
